# PrettyTables.jl

[![CI](https://img.shields.io/github/actions/workflow/status/ronisbr/PrettyTables.jl/ci.yml?style=flat-square&logo=githubactions&logoColor=white&labelColor=475569&label=CI)](https://github.com/ronisbr/PrettyTables.jl/actions/workflows/ci.yml)
[![Codecov](https://img.shields.io/codecov/c/github/ronisbr/PrettyTables.jl?style=flat-square&logo=codecov&logoColor=white&labelColor=475569)](https://codecov.io/gh/ronisbr/PrettyTables.jl)
[![docs-stable](https://img.shields.io/badge/docs-stable-16A34A?style=flat-square&logo=gitbook&logoColor=white&labelColor=475569)][docs-stable-url]
[![docs-dev](https://img.shields.io/badge/docs-dev-D97706?style=flat-square&logo=gitbook&logoColor=white&labelColor=475569)][docs-dev-url]
[![Code Style: Blue](https://img.shields.io/badge/code%20style-Blue-4495D1?style=flat-square&logo=julia&logoColor=white&labelColor=475569)](https://github.com/invenia/BlueStyle)
[![License](https://img.shields.io/github/license/ronisbr/PrettyTables.jl?style=flat-square&logo=readme&logoColor=white&labelColor=475569&color=0284C7)](https://github.com/ronisbr/PrettyTables.jl/blob/master/LICENSE.txt)
[![DOI](https://img.shields.io/badge/DOI-10.5281%2Fzenodo.10015722-DB2777?style=flat-square&logo=doi&logoColor=white&labelColor=475569)](https://zenodo.org/doi/10.5281/zenodo.10015722)

This package has the purpose to print data in matrices using different backends. It was
orizinally inspired in the functionality provided by
[ASCII Tables](https://ozh.github.io/ascii-tables/).

**PrettyTables.jl** allows to print the data together with some table sections. They can be
modified by the user to obtain the desired output. The sections currently available are:

![Table Design](./docs/src/assets/table_design.png)

This design is heavily inspired by the R's package [gt](https://github.com/rstudio/gt/) but
the API is highly different due to the differences between the R and Julia languages.

## Installation

```julia-repl
julia> using Pkg
julia> Pkg.add("PrettyTables")
```

## Example

We present in the following an example showing some of the features available in
**PrettyTables.jl**.

```julia
julia> using PrettyTables, StyledStrings

# == Creating the Table ====================================================================

julia> v1_t = 0:5:20

julia> v1_a = ones(length(v1_t)) * 1.0

julia> v1_v = @. 0 + v1_a * v1_t

julia> v1_d = @. 0 + v1_a * v1_t^2 / 2

julia> v2_t = 0:5:20

julia> v2_a = ones(length(v2_t)) * 0.75

julia> v2_v = @. 0 + v2_a * v2_t

julia> v2_d = @. 0 + v2_a * v2_t^2 / 2

julia> table = [
  v1_t v1_a v1_v v1_d
  v2_t v2_a v2_v v2_d
];

# == Configuring the Table =================================================================

julia> title = "Table 1. Data obtained from the test procedure."

julia> subtitle = "Comparison between two vehicles"

julia> column_labels = [
    [EmptyCells(2), MultiColumn(2, "Estimated Data")],
    ["Time (s)", "Acceleration", "Velocity", "Position"],
]

julia> units = [
  styled"{(foreground=gray):[s]}",
  styled"{(foreground=gray):[m / s²]}",
  styled"{(foreground=gray):[m / s]}",
  styled"{(foreground=gray):[m]}",
]

julia> push!(column_labels, units)

julia> merge_column_label_cells = :auto

julia> row_group_labels = [
    1 => "Vehicle #1",
    6 => "Vehicle #2"
]

julia> summary_rows = [
    (data, j) -> maximum(@views data[ 1:5, j]),
    (data, j) -> maximum(@views data[6:10, j]),
]

julia> summary_row_labels = [
    "Max. for Vehicle #1",
    "Max. for Vehicle #2",
]

julia> footnotes = [
    (:column_label, 1, 3) => "Estimated data based on the acceleration measurement."
]

julia> highlighters = [
    TextHighlighter((data, i, j) -> (j == 3) && (data[i, j] > 10), crayon"fg:red bold")
    TextHighlighter((data, i, j) -> (j == 4) && (data[i, j] > 10), crayon"fg:blue bold")
]

julia> table_format = TextTableFormat(;
    # Remove vertical lines.
    @text__no_vertical_lines
)

julia> style = TextTableStyle(
    column_label                   = crayon"bold",
    first_line_merged_column_label = crayon"fg:yellow bold underline",
    footnote                       = crayon"fg:cyan",
    row_group_label                = crayon"fg:magenta bold",
    subtitle                       = crayon"italics",
    title                          = crayon"fg:yellow bold",
)

# == Printing the Table ====================================================================

julia> pretty_table(
    table;
    column_labels,
    footnotes,
    highlighters,
    merge_column_label_cells,
    row_group_labels,
    style,
    subtitle,
    summary_row_labels,
    summary_rows,
    table_format,
    title,
)
```

![PrettyTables.jl example](./docs/src/assets/welcome_figure.svg)

## Usage

See the [documentation][docs-stable-url].

[docs-dev-url]: https://ronisbr.github.io/PrettyTables.jl/dev
[docs-stable-url]: https://ronisbr.github.io/PrettyTables.jl/stable

## Description #############################################################################
#
# HTML Back End: Tests related to divs.
#
############################################################################################

@testset "Divs" verbose = true begin
    matrix = [1 2]

    expected = """
<div style = "overflow-x: scroll;">
  <table class = "myClass">
    <thead>
      <tr class = "columnLabelRow">
        <th style = "font-weight: bold; text-align: right;">Col. 1</th>
        <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      </tr>
    </thead>
    <tbody>
      <tr class = "dataRow">
        <td style = "text-align: right;">1</td>
        <td style = "text-align: right;">2</td>
      </tr>
    </tbody>
  </table>
</div>
"""

    result = pretty_table(
        String, matrix; backend = :html, table_class = "myClass", wrap_table_in_div = true
    )

    @test result == expected

    expected = """
<div>
  <div style = "float: left;">
    <span>Top Left</span>
  </div>
  <div style = "clear: both;"></div>
</div>
<div style = "overflow-x: scroll;">
  <table class = "myClass">
    <thead>
      <tr class = "columnLabelRow">
        <th style = "font-weight: bold; text-align: right;">Col. 1</th>
        <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      </tr>
    </thead>
    <tbody>
      <tr class = "dataRow">
        <td style = "text-align: right;">1</td>
        <td style = "text-align: right;">2</td>
      </tr>
    </tbody>
  </table>
</div>
"""

    result = pretty_table(
        String,
        matrix;
        backend = :html,
        table_class = "myClass",
        top_left_string = "Top Left",
        wrap_table_in_div = true,
    )

    @test result == expected

    expected = """
<div>
  <div style = "float: left;">
    <span>Top Left</span>
  </div>
  <div style = "float: right; font-style: italic;">
    <span>Top Right</span>
  </div>
  <div style = "clear: both;"></div>
</div>
<div style = "overflow-x: scroll;">
  <table class = "myClass">
    <thead>
      <tr class = "columnLabelRow">
        <th style = "font-weight: bold; text-align: right;">Col. 1</th>
        <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      </tr>
    </thead>
    <tbody>
      <tr class = "dataRow">
        <td style = "text-align: right;">1</td>
        <td style = "text-align: right;">2</td>
      </tr>
    </tbody>
  </table>
</div>
"""

    result = pretty_table(
        String,
        matrix;
        backend = :html,
        table_class = "myClass",
        top_left_string = "Top Left",
        top_right_string = "Top Right",
        wrap_table_in_div = true,
    )

    @test result == expected
end

## Description #############################################################################
#
# Text back end for PrettyTables.jl.
#
############################################################################################

# Pre-allocate some default values for keywords to avoid allocations. Notice that we must do
# this only to the values that **are not** modified inside the algorithm. Otherwise, we will
# not be thread safe.
const _DEFAULT_ALIGNMENT_ANCHOR_REGEX = Regex[]
const _DEFAULT_TEXT_HIGHLIGHTER = TextHighlighter[]

function _text__print_table(
    pspec::PrintingSpec;
    alignment_anchor_fallback::Symbol = :l,
    alignment_anchor_regex::Union{Vector{Regex}, Vector{Pair{Int, Vector{Regex}}}} = _DEFAULT_ALIGNMENT_ANCHOR_REGEX,
    apply_alignment_regex_to_summary_rows::Bool = false,
    auto_wrap::Bool = false,
    column_label_width_based_on_first_line_only::Bool = false,
    display_size::NTuple{2, Int} = displaysize(pspec.context),
    equal_data_column_widths::Bool = false,
    fit_table_in_display_horizontally::Bool = true,
    fit_table_in_display_vertically::Bool = true,
    fixed_data_column_widths::Union{Int, Vector{Int}} = 0,
    highlighters::Vector{TextHighlighter} = _DEFAULT_TEXT_HIGHLIGHTER,
    line_breaks::Bool = false,
    minimum_data_column_widths::Union{Int, Vector{Int}} = 0,
    maximum_data_column_widths::Union{Int, Vector{Int}} = 0,
    overwrite_display::Bool = false,
    reserved_display_lines::Int = 0,
    shrinkable_data_column::Int = 0,
    shrinkable_column_minimum_width::Int = 0,
    style::TextTableStyle = TextTableStyle(),
    table_format::TextTableFormat = TextTableFormat(),
)
    context    = pspec.context
    table_data = pspec.table_data
    # NOTE: `Val(pspec.renderer)` infers to the abstract `Val` because
    # `pspec.renderer` is a `Symbol`. Branching here keeps the renderer concrete, so the
    # per-cell rendering calls are statically dispatched.
    renderer   = pspec.renderer === :show ? Val(:show) : Val(:print)
    tf         = table_format

    ps     = PrintingTableState()
    buf_io = IOBuffer()

    # Reusable render buffer: one allocation per table instead of three per cell.
    rctx = RenderContext(context)

    # == Process Input Variables ===========================================================

    # Auto wrap implies line breaks.
    if auto_wrap
        line_breaks = true
    end

    # If the user does not want to crop the table horizontally, we set the display width to
    # -1, meaning that we do not have a limit.
    if !fit_table_in_display_horizontally
        display_size = (display_size[1], -1)
    end

    # If the user does not want to crop the table vertically, we set the display length to
    # -1, meaning that we do not have a limit.
    if !fit_table_in_display_vertically
        display_size = (-1, display_size[2])
    end

    # If the user wants to reserve some display lines, remove them from the display size.
    if (reserved_display_lines > 0) && (display_size[1] > reserved_display_lines)
        display_size = (display_size[1] - reserved_display_lines, display_size[2])
    end

    # Create the structure that holds the display information.
    display = Display(display_size, 1, 0, get(context, :color, false), buf_io, IOBuffer())

    # Process the vertical lines at data columns.
    if tf.vertical_lines_at_data_columns isa Symbol
        vertical_lines_at_data_columns = if tf.vertical_lines_at_data_columns == :all
            1:(table_data.num_columns)
        else
            1:0
        end
    else
        vertical_lines_at_data_columns = tf.vertical_lines_at_data_columns::Vector{Int}
    end

    # The width keywords are indexed inside the per-cell loop. Hence, we must check their
    # length here to raise a meaningful error instead of a `BoundsError` deep in the back
    # end.
    for (name, v) in (
        ("fixed_data_column_widths", fixed_data_column_widths),
        ("minimum_data_column_widths", minimum_data_column_widths),
        ("maximum_data_column_widths", maximum_data_column_widths),
    )
        (v isa AbstractVector) && (length(v) != table_data.num_columns) && throw(
            ArgumentError(
                "The length of `$name` ($(length(v))) must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    # Normalize the width keywords into locals of a single concrete type. Notice that the
    # previous scalar-to-vector broadcast produced a `StepRangeLen`, not a `Vector{Int}`, so
    # these variables kept a `Union` for the rest of the function. Since they are indexed
    # inside the per-cell loop and passed to functions declaring `AbstractVector{Int}`, that
    # forced a runtime union resolution per access and a second specialization of those
    # functions.
    min_data_column_widths::Vector{Int} = if minimum_data_column_widths isa Number
        fill(minimum_data_column_widths, table_data.num_columns)
    else
        collect(Int, minimum_data_column_widths)
    end

    max_data_column_widths::Vector{Int} = if maximum_data_column_widths isa Number
        fill(maximum_data_column_widths, table_data.num_columns)
    else
        collect(Int, maximum_data_column_widths)
    end

    has_fixed_data_column_widths = false

    fix_data_column_widths::Vector{Int} = if fixed_data_column_widths isa Number
        has_fixed_data_column_widths = fixed_data_column_widths > 0
        fill(fixed_data_column_widths, table_data.num_columns)
    else
        has_fixed_data_column_widths = true
        collect(Int, fixed_data_column_widths)
    end

    if alignment_anchor_regex isa Vector{Pair{Int, Vector{Regex}}}
        for (j, _) in alignment_anchor_regex
            (j <= 0) && throw(
                ArgumentError(
                    "The column index in the alignment anchor regex must be greater than 0.",
                ),
            )

            (j > table_data.num_columns) && throw(
                ArgumentError(
                    "The column index in the alignment anchor regex must not be greater than the number of columns ($(table_data.num_columns)).",
                ),
            )
        end
    end

    # Check the style variables.
    if style.first_line_column_label isa Vector
        length(style.first_line_column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `first_line_column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    if style.column_label isa Vector
        length(style.column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    # == Table Fitting in the Display ======================================================

    # Process the horizontal lines at column labels.
    if tf.horizontal_lines_at_column_labels isa Symbol
        horizontal_lines_at_column_labels = if tf.horizontal_lines_at_column_labels == :all
            1:(length(table_data.column_labels) - 1)
        else
            1:0
        end
    else
        # Notice that a line after the last column label row is drawn by the option
        # `horizontal_line_after_column_labels`. Hence, we must neglect it here. Otherwise,
        # we would reserve a display line for a horizontal line that is never drawn.
        horizontal_lines_at_column_labels = filter(
            x -> 1 <= x <= length(table_data.column_labels) - 1,
            tf.horizontal_lines_at_column_labels::Vector{Int},
        )
    end

    # Process the horizontal lines at data rows.
    if tf.horizontal_lines_at_data_rows isa Symbol
        horizontal_lines_at_data_rows = if tf.horizontal_lines_at_data_rows == :all
            1:(table_data.num_rows)
        else
            1:0
        end
    else
        horizontal_lines_at_data_rows = tf.horizontal_lines_at_data_rows::Vector{Int}
    end

    # Limit the number of rendered columns given the display size if the user wants.
    if fit_table_in_display_horizontally && (display_size[2] > 0)
        mc = div(display.size[2], 5, RoundUp)

        # If the user provided a fixed data column width, we can use it to check how many
        # columns we can display.
        if has_fixed_data_column_widths
            aux = 0
            mc = 1

            for j in eachindex(fix_data_column_widths)
                aux += fix_data_column_widths[j] <= 0 ? 5 : fix_data_column_widths[j]
                aux > display.size[2] && break
                mc += 1
            end
        end

        if table_data.maximum_number_of_columns >= 0
            table_data.maximum_number_of_columns = min(
                table_data.maximum_number_of_columns, mc
            )
        else
            table_data.maximum_number_of_columns = mc
        end
    end

    # Limit the number of rendered rows given the display size if the user wants.
    vertically_limited_by_display          = false
    suppress_hline_before_continuation_row = false
    suppress_hline_after_continuation_row  = false

    if fit_table_in_display_vertically && (display_size[1] > 0)
        # We do not support middle cropping when using line breaks since it will require a
        # much more complex algorithm, decreasing the maintainability.
        if line_breaks
            table_data.vertical_crop_mode = :bottom
        end

        # NOTE: In case we have line breaks, this design is only preliminary. In this case,
        # we perform the following actions:
        #
        #   1. Design the number of rendered rows assuming one line per row.
        #   2. Render the table.
        #   3. Compute the number of rendered columns.
        #   4. Re-design the number of rendered rows considering the actual number of lines.

        mr, suppress_hline_before_continuation_row, suppress_hline_after_continuation_row = _text__design_vertical_cropping(
            table_data,
            tf,
            horizontal_lines_at_column_labels,
            horizontal_lines_at_data_rows,
            pspec.show_omitted_cell_summary,
            display.size[1],
            pspec.new_line_at_end,
        )

        if table_data.maximum_number_of_rows >= 0
            vertically_limited_by_display = mr < table_data.maximum_number_of_rows
            table_data.maximum_number_of_rows = min(table_data.maximum_number_of_rows, mr)
        else
            vertically_limited_by_display = mr < table_data.num_rows
            table_data.maximum_number_of_rows = mr
        end
    end

    # == Render the Table ==================================================================

    # For the text back end, we need to render the entire table before printing to take into
    # account the required column width.

    row_labels, column_labels, table_str, summary_rows, summary_row_labels, footnotes,
        custom_cells = _text__render_table(
            table_data,
            rctx,
            renderer,
            line_breaks,
            max_data_column_widths,
            vertical_lines_at_data_columns,
        )

    num_printed_data_rows, num_printed_data_columns = size(table_str)

    # == Column Alignment Regex ============================================================

    if !isempty(alignment_anchor_regex)
        # We will create a vector to copy each column string that will be aligned. This
        # procedure is necessary because if the user wants to also apply the alignment to
        # the summary rows, we need to copy those lines before the alignment process.

        if isnothing(summary_rows)
            # We should not apply the alignment regex to the summary rows if there is none.
            apply_alignment_regex_to_summary_rows = false
        end

        num_summary_rows = apply_alignment_regex_to_summary_rows ? size(summary_rows, 1) : 0

        column_str = Vector{String}(undef, num_printed_data_rows + num_summary_rows)

        # Check if we have one set of regexes to be applied to all the columns or if the
        # user specified regexes for some columns.
        if alignment_anchor_regex isa Vector{Regex}
            regex = alignment_anchor_regex

            @views for j in axes(table_str, 2)
                column_str[1:num_printed_data_rows] .= table_str[:, j]

                if apply_alignment_regex_to_summary_rows
                    column_str[(num_printed_data_rows + 1):end] .= summary_rows[:, j]
                end

                if !line_breaks
                    _align_column_with_regex!(column_str, regex, alignment_anchor_fallback)
                else
                    _align_multline_column_with_regex!(
                        column_str, regex, alignment_anchor_fallback
                    )
                end

                table_str[:, j] = column_str[1:num_printed_data_rows]

                if apply_alignment_regex_to_summary_rows
                    summary_rows[:, j] .= column_str[(num_printed_data_rows + 1):end]
                end
            end
        else
            @views for r in alignment_anchor_regex
                j, regex = r

                j > num_printed_data_columns && continue

                column_str[1:num_printed_data_rows] .= table_str[:, j]

                if apply_alignment_regex_to_summary_rows
                    column_str[(num_printed_data_rows + 1):end] .= summary_rows[:, j]
                end

                if !line_breaks
                    _align_column_with_regex!(column_str, regex, alignment_anchor_fallback)
                else
                    _align_multline_column_with_regex!(
                        column_str, regex, alignment_anchor_fallback
                    )
                end

                table_str[:, j] = column_str[1:num_printed_data_rows]

                if apply_alignment_regex_to_summary_rows
                    summary_rows[:, j] .= column_str[(num_printed_data_rows + 1):end]
                end
            end
        end

        # Since we modified the cell width to align the text, we must check if we need
        # additional cropping to comply with the maximum cell width specification.
        for j in 1:num_printed_data_columns
            for i in 1:num_printed_data_rows
                table_str[i, j] = _text__fit_cell_in_maximum_cell_width(
                    table_str[i, j], max_data_column_widths[j], line_breaks
                )
            end

            # Check if the summary rows were modified by the alignment regex.
            (isnothing(summary_rows) || !apply_alignment_regex_to_summary_rows) && continue

            for i in 1:size(summary_rows, 1)
                summary_rows[i, j] = _text__fit_cell_in_maximum_cell_width(
                    summary_rows[i, j], max_data_column_widths[j], line_breaks
                )
            end
        end
    end

    # == Compute the Column Width ==========================================================

    row_number_column_width, row_label_column_width, printed_data_column_widths = _text__printed_column_widths(
        table_data,
        row_labels,
        column_labels,
        summary_rows,
        summary_row_labels,
        table_str,
        vertical_lines_at_data_columns,
        column_label_width_based_on_first_line_only,
        line_breaks,
        min_data_column_widths,
    )

    # Now, we crop the additional column labels if the user wants to do so.
    # TODO: What should we do with the merged column labels?
    if column_label_width_based_on_first_line_only && !isnothing(column_labels)
        for j in eachindex(printed_data_column_widths)
            cw  = printed_data_column_widths[j]
            cls = @views column_labels[:, j]

            for i in eachindex(cls)
                str = cls[i]
                tw  = printable_textwidth(str)

                tw <= cw && continue

                str, _ = right_crop(str, tw - printed_data_column_widths[j] + 1)
                cls[i] = str * "…"
            end
        end
    end

    # If the user wants a fixed column width, we must reprocess all the data columns to crop
    # to the correct size if necessary.
    #
    # TODO: This can be integrated in the first column width computation!
    has_fixed_data_column_widths && _text__fix_data_column_widths!(
        printed_data_column_widths,
        table_data,
        column_labels,
        table_str,
        summary_rows,
        fix_data_column_widths,
        vertical_lines_at_data_columns,
        auto_wrap,
        line_breaks,
    )

    # If the user wants equal data column widths, make every column width equal to the
    # largest one.
    if equal_data_column_widths
        # `init` is required because the table can have no columns at all.
        printed_data_column_widths .= maximum(printed_data_column_widths; init = 0)
    end

    # == Horizontal Printing Limit =========================================================

    # In text back end, the printed column can be limited either by the user specification
    # or by the display limit. Now, we have access to the width of all candidate columns to
    # be printed. Hence, we can update the number of printed columns accordingly. Notice
    # that we also must analyze if the table continuation column is required since in text
    # back end we also have the continuation caused by the display end-of-line.

    # Compute the required width to display the table using the user specification without
    # the continuation column.
    table_width_wo_cont_col = _text__table_width_wo_cont_column(
        table_data,
        tf,
        vertical_lines_at_data_columns,
        row_number_column_width,
        row_label_column_width,
        printed_data_column_widths,
    )

    # We need to check if we are limiting the number of columns by the display or by the
    # user specification.
    horizontally_limited_by_display = _text__is_printing_horizontally_limited(
        table_data,
        fit_table_in_display_horizontally,
        display.size[2],
        num_printed_data_columns,
        table_width_wo_cont_col,
        tf.vertical_line_after_continuation_column,
    )

    # If we are limited by the display, we need to update the number of printed columns and
    # rows.
    if horizontally_limited_by_display
        # Check if the user selects one visible column to shrink to fit the table in the
        # display.
        if (1 <= shrinkable_data_column <= num_printed_data_columns)
            # Number of characters we should remove from the shrinkable data column to fit
            # the table in the display.
            Δc = table_width_wo_cont_col - display_size[2]

            # Compute the new column width.
            cw = max(
                1,
                shrinkable_column_minimum_width,
                printed_data_column_widths[shrinkable_data_column] - Δc,
            )

            printed_data_column_widths[shrinkable_data_column] = cw

            # Shrink the column labels.
            if !isnothing(column_labels)
                for i in 1:size(column_labels, 1)
                    # Compute the column limits of this column label.
                    j₀, j₁ = _column_label_limits(table_data, i, shrinkable_data_column)

                    # Compute the available width.
                    cell_width = 0

                    # Make sure we are not accessing a column out of the bounds.
                    j₁ = min(j₁, num_printed_data_columns)

                    for j in j₀:j₁
                        cell_width += printed_data_column_widths[j] + 2

                        # We must add a space if we have a vertical line in the merged
                        # cells.
                        if (j != j₁) && (j ∈ vertical_lines_at_data_columns)
                            cell_width += 1
                        end
                    end

                    # We already take into account 2 characters for the margin below.
                    cell_width -= 2

                    # We need to modify the first field of this column label to take into
                    # account merged labels.
                    column_labels[i, j₀] = _text__fit_cell_in_maximum_cell_width(
                        column_labels[i, j₀], cell_width, line_breaks
                    )
                end
            end

            # Shrink the data cells.
            for i in 1:num_printed_data_rows
                table_str[i, shrinkable_data_column] = _text__fit_cell_in_maximum_cell_width(
                    table_str[i, shrinkable_data_column],
                    printed_data_column_widths[shrinkable_data_column],
                    line_breaks,
                )
            end

            # Shrink the summary rows.
            if !isnothing(summary_rows)
                for i in 1:size(summary_rows, 1)
                    summary_rows[i, shrinkable_data_column] = _text__fit_cell_in_maximum_cell_width(
                        summary_rows[i, shrinkable_data_column],
                        printed_data_column_widths[shrinkable_data_column],
                        line_breaks,
                    )
                end
            end
        end

        # Since the table width has changed, we must recompute the following variables.
        num_printed_data_columns = _text__number_of_printed_data_columns(
            display.size[2],
            table_data,
            tf,
            vertical_lines_at_data_columns,
            row_number_column_width,
            row_label_column_width,
            printed_data_column_widths,
        )

        # `table_str` was rendered using an earlier, coarser estimate of the number of
        # columns. Hence, we must never claim to print more columns than were actually
        # rendered. Otherwise, the main loop would emit one `:data` action too many and index
        # past the end of `table_str` and `printed_data_column_widths`.
        table_data.maximum_number_of_columns = min(
            num_printed_data_columns + 1, table_data.num_columns, size(table_str, 2)
        )

        horizontally_limited_by_display = _text__is_printing_horizontally_limited(
            table_data,
            fit_table_in_display_horizontally,
            display.size[2],
            num_printed_data_columns,
            table_width_wo_cont_col,
            tf.vertical_line_after_continuation_column,
        )
    end

    # == Omitted Columns ===================================================================

    # If this is the very first row, we must check if a horizontal line must be printed.
    num_omitted_data_columns = table_data.num_columns - num_printed_data_columns
    num_omitted_data_rows    = table_data.num_rows - num_printed_data_rows

    # We must compute what will be the last printed column index to draw the correct
    # vertical lines. Notice that, at this point, we might be printing a column partially.
    last_printed_column_index = if horizontally_limited_by_display
        table_data.maximum_number_of_columns
    else
        num_printed_data_columns
    end

    # Never index past what was actually rendered.
    last_printed_column_index = min(last_printed_column_index, size(table_str, 2))

    # Finally, we can compute the printed table width.
    printed_table_width = table_width_wo_cont_col

    if _is_horizontally_cropped(table_data)
        printed_table_width += 3 + tf.vertical_line_after_continuation_column
    end

    if horizontally_limited_by_display
        printed_table_width = display_size[2]
    end

    # == Vertical Cropping Design with Line Breaks =========================================

    # Up to now, we consider that each table row has only one line. Now that we know how
    # many columns we must print, we can redesign the vertical cropping if the user wants
    # line breaks. In this case, we will analyze each line and check how many data rows we
    # can print considering the multiple lines.

    if fit_table_in_display_vertically && (display_size[1] > 0) && line_breaks
        # Notice that `mr` contains the number of fully printed data rows. Furthermore, if
        # `lrc` is `true`, the last row is cropped, meaning that we need to print `mr + 1`
        # rows from the rendered table.
        mr, lrc, suppress_hline_before_continuation_row = _text__design_vertical_cropping_with_line_breaks(
            table_data,
            table_str,
            tf,
            horizontal_lines_at_column_labels,
            horizontal_lines_at_data_rows,
            pspec.show_omitted_cell_summary,
            display.size[1],
            pspec.new_line_at_end,
            num_printed_data_columns,
        )

        if table_data.maximum_number_of_rows >= 0
            vertically_limited_by_display =
                vertically_limited_by_display || (mr < table_data.maximum_number_of_rows)

            table_data.maximum_number_of_rows = min(
                table_data.maximum_number_of_rows, mr + lrc
            )
        else
            vertically_limited_by_display =
                vertically_limited_by_display ||
                (num_printed_data_rows < table_data.num_rows)

            table_data.maximum_number_of_rows = mr + lrc
        end

        # Now that we have the number of fully printed data rows, we must update those
        # variables.
        num_printed_data_rows = table_data.maximum_number_of_rows
        num_omitted_data_rows = table_data.num_rows - mr
    end

    # == Print the Table ===================================================================

    ps     = PrintingTableState()
    action = :initialize

    # We must store the index related to the rendered tables. These indices differ from the
    # actual table indices due to cropping.
    ir = jr = 0

    # Variable to store how many data lines were printed.
    num_data_lines = 0

    top_line_printed = false

    # Those variables are used to process rows with multiple lines.
    #
    # Number of lines in the current row. It is computed by the maximum number of lines
    # inside a data cell in a specific row.
    num_lines_in_row = 0

    # Number of lines available in the display for the data section. Notice that it only
    # makes sense if the display is limiting the table.
    num_available_data_section_lines = if vertically_limited_by_display
        total_table_lines, num_lines_before_data, num_lines_after_data = _text__number_of_required_lines(
            table_data,
            tf,
            horizontal_lines_at_column_labels,
            horizontal_lines_at_data_rows,
            pspec.new_line_at_end,
        )

        (
            display.size[1] - num_lines_before_data - num_lines_after_data -
            pspec.show_omitted_cell_summary - 1 # ........................................................... Continuation row
        )
    else
        0
    end

    # Number of lines printed in data section, including horizontal lines and row group
    # labels.
    num_printed_data_section_lines = 0

    # Stored state at the beginning of the row with multiple lines. We use those values to
    # reiterate the printing state until we have no more new rows.
    saved_ps = PrintingTableState()
    saved_ir = 0

    # Current row line that is being printed. If it is 0, the current row does not have
    # multiple lines.
    current_row_line = 0

    tokens = if !line_breaks
        nothing
    else
        Vector{Vector{SubString{String}}}(undef, last_printed_column_index)
    end

    # The highlighters must receive the object the user passed to `pretty_table`, not the
    # internal table wrapper. Notice that this is loop invariant.
    orig_data = _get_data(table_data.data)

    while action != :end_printing
        if current_row_line == 0
            saved_ps = ps
            saved_ir = ir
        end

        action, rs, ps = _next(ps, table_data)

        ir, jr = _update_data_cell_indices(action, rs, ps, ir, jr)

        action == :end_printing && break

        # If we already printed the number of available lines in data section, skip
        # everything until we exit the data section.
        if line_breaks &&
            (rs == :data) &&
            (num_available_data_section_lines > 0) &&
            (num_printed_data_section_lines >= num_available_data_section_lines)
            current_row_line = 0
            continue
        end

        # == Table Header and Footer =======================================================

        if rs == :table_header
            if action ∈ (:title, :subtitle)
                alignment     = _current_cell_alignment(action, ps, table_data)
                cell          = _current_cell(action, ps, table_data)
                decoration    = action == :title ? style.title : style.subtitle
                rendered_cell = _text__render_cell(cell, rctx, renderer)

                _text__print_aligned(
                    display,
                    rendered_cell,
                    printed_table_width,
                    alignment,
                    decoration,
                    false,
                )
                _text__flush_line(display)
            end

            continue

        elseif rs == :table_footer
            if action == :footnote
                alignment  = _current_cell_alignment(action, ps, table_data)
                decoration = style.footnote

                _text__print_aligned(
                    display,
                    footnotes[ps.i],
                    printed_table_width,
                    alignment,
                    decoration,
                    false,
                )
                _text__flush_line(display)

            elseif action == :source_notes
                alignment     = _current_cell_alignment(action, ps, table_data)
                cell          = _current_cell(action, ps, table_data)
                decoration    = style.source_note
                rendered_cell = _text__render_cell(cell, rctx, renderer)

                _text__print_aligned(
                    display,
                    rendered_cell,
                    printed_table_width,
                    alignment,
                    decoration,
                    false,
                )
                _text__flush_line(display)
            end

            continue
        end

        # == New Row =======================================================================

        if action == :new_row

            # If this is the very first row, we must check if a horizontal line must be
            # printed.
            if tf.horizontal_line_at_beginning && !top_line_printed
                _text__print_column_label_horizontal_line(
                    display,
                    tf,
                    style.table_border,
                    table_data,
                    ir - 1,
                    vertical_lines_at_data_columns,
                    row_number_column_width,
                    row_label_column_width,
                    printed_data_column_widths,
                    true,
                )

                _text__flush_line(display, false)

                top_line_printed = true
            end

            if rs == :row_group_label
                # We must draw the horizontal line here if the user requested, if the last
                # row has a horizontal line due to the intersections, or if the last row was
                # a column label and the user wants a line after it.
                if tf.horizontal_line_before_row_group_label ||
                    (ir - 1 ∈ horizontal_lines_at_data_rows) ||
                    (ir == 1 && tf.horizontal_line_after_column_labels)
                    _text__print_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                        true,
                        false,
                        true,
                    )

                    _text__flush_line(display, false)
                    num_printed_data_section_lines += 1
                end
            end

            # Check if we need to start processing multiple row lines.
            if line_breaks && (rs == :data) && (current_row_line == 0)
                # NOTE: Only the columns that are actually printed may contribute to the
                # height of the row. Otherwise, a column cropped away horizontally could add
                # spurious blank lines. This also avoids allocating a `Vector` per row.
                num_lines_in_row = 1

                for jt in 1:last_printed_column_index
                    n = count(==('\n'), table_str[ir, jt]) + 1
                    n > num_lines_in_row && (num_lines_in_row = n)
                end
                current_row_line = 1

                # Obtain the tokens for each line.
                for jt in eachindex(tokens)
                    tokens[jt] = split(table_str[ir, jt], '\n')
                end
            end

            tf.vertical_line_at_beginning &&
                _text__styled_print(display, tf.borders.column, style.table_border)

            continue
        end

        # == Continuation Row ==============================================================

        if action == :diagonal_continuation_cell
            _text__print(display, " ⋱ ")
            tf.vertical_line_after_continuation_column &&
                _text__styled_print(display, tf.borders.column, style.table_border)
            continue

        elseif action == :horizontal_continuation_cell
            _text__print(display, " ⋯ ")
            tf.vertical_line_after_continuation_column &&
                _text__styled_print(display, tf.borders.column, style.table_border)
            continue

        elseif action ∈ _VERTICAL_CONTINUATION_CELL_ACTIONS
            alignment = _current_cell_alignment(action, ps, table_data)

            if action == :row_number_vertical_continuation_cell
                cell_width = row_number_column_width
                vline      = tf.vertical_line_after_row_number_column

            elseif action == :row_label_vertical_continuation_cell
                cell_width = row_label_column_width
                vline      = tf.vertical_line_after_row_label_column

            else
                cell_width = printed_data_column_widths[jr]
                vline = false

                if jr == last_printed_column_index
                    tf.vertical_line_after_data_columns && (vline = true)
                elseif ps.j ∈ vertical_lines_at_data_columns
                    vline = true
                end
            end

            _text__print(display, " ")
            _text__print_aligned(display, "⋮", cell_width, alignment)
            _text__print(display, " ")
            vline && _text__styled_print(display, tf.borders.column, style.table_border)

            continue
        end

        # == End Row =======================================================================

        if action == :end_row
            _, next_rs, _ = _next(ps, table_data)

            if rs == :data
                num_data_lines += 1
                num_printed_data_section_lines += 1
            elseif rs == :row_group_label
                num_printed_data_section_lines += 1
            end

            # == Flush the Line ============================================================

            if rs == :continuation_row
                _text__flush_line(display, true, '⋱')

            elseif rs == :data
                _text__flush_line(
                    display,
                    true,
                    (num_data_lines - 1) % (tf.ellipsis_line_skip + 1) == 0 ? '⋯' : ' ',
                )

            else
                _text__flush_line(display)
            end

            # Check if we must render another line for this row or if we should go to the
            # next row.
            if current_row_line > 0
                current_row_line += 1

                if current_row_line <= num_lines_in_row
                    # If we reached this point, we must render another line of the same row.
                    # Hence, we will restore that saved state at the beginning of the line,
                    # and render it again. Since we increased `current_row_line`, we will
                    # render the next line of the same row.
                    ps = saved_ps
                    ir = saved_ir
                    continue
                end

                # If we reached this point, we finished rendering the row.
                current_row_line = 0
            end

            # == Handle the Horizontal Lines ===============================================

            if (rs == :column_labels) && (next_rs == :column_labels)
                if (ps.i ∈ horizontal_lines_at_column_labels)
                    _text__print_column_label_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        ps.i,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                        false,
                        false,
                    )
                    _text__flush_line(display, false)

                elseif tf.horizontal_line_at_merged_column_labels &&
                    _has_merged_cells(table_data, ps.i)
                    _text__print_column_label_horizontal_line_only_at_merged_labels(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        ps.i,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                    )
                    _text__flush_line(display, false)
                end

                # Print the horizontal line after the column labels.
            elseif (rs == :column_labels) &&
                (next_rs != :column_labels) &&
                tf.horizontal_line_after_column_labels

                # We should skip this line if we have a row group label at the first column.
                if next_rs != :row_group_label
                    # We must handle that case where there are no data rows. In this case,
                    # the next section after the column labels will be the table footer or
                    # the end of printing.
                    bottom = next_rs ∈ (:table_footer, :end_printing)

                    _text__print_column_label_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        length(table_data.column_labels),
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                        false,
                        bottom,
                    )

                    _text__flush_line(display, false)
                end

                # Check if we must print a horizontal line after the current data row.
            elseif (rs == :data) && (ps.i ∈ horizontal_lines_at_data_rows)
                hline = true

                # We should only print this line if the next state is not the continuation
                # row or if we do not need to suppress the line before the continuation row.
                if (next_rs == :continuation_row) && suppress_hline_before_continuation_row
                    hline = false

                elseif _print_row_group_label(table_data, ir + 1)
                    hline = false
                end

                if hline
                    _text__print_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                    )

                    _text__flush_line(display, false)
                    num_printed_data_section_lines += 1
                end

            elseif (rs == :data) &&
                (next_rs ∈ (:summary_row, :table_footer, :end_printing)) &&
                tf.horizontal_line_after_data_rows
                bottom = next_rs ∈ (:table_footer, :end_printing)

                _text__print_horizontal_line(
                    display,
                    tf,
                    style.table_border,
                    table_data,
                    vertical_lines_at_data_columns,
                    row_number_column_width,
                    row_label_column_width,
                    printed_data_column_widths,
                    false,
                    bottom,
                )

                _text__flush_line(display, false)
                num_printed_data_section_lines += 1

            elseif (rs ∈ (:data, :continuation_row)) &&
                (next_rs == :summary_row) &&
                tf.horizontal_line_before_summary_rows
                _text__print_column_label_horizontal_line(
                    display,
                    tf,
                    style.table_border,
                    table_data,
                    length(table_data.column_labels),
                    vertical_lines_at_data_columns,
                    row_number_column_width,
                    row_label_column_width,
                    printed_data_column_widths,
                    false,
                    false,
                )

                _text__flush_line(display, false)

                # Check if we must print a horizontal line after the continuation row.
            elseif (rs == :continuation_row) && !suppress_hline_after_continuation_row
                hline = false
                bottom = next_rs ∈ (:table_footer, :end_printing)

                if ps.i ∈ horizontal_lines_at_data_rows
                    hline = true
                end

                if (next_rs !== :data) && tf.horizontal_line_after_data_rows
                    hline = true
                end

                if hline
                    _text__print_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                        false,
                        bottom,
                    )

                    _text__flush_line(display, false)
                end

            elseif (rs == :row_group_label)
                if tf.horizontal_line_after_row_group_label
                    _text__print_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                        false,
                        true,
                        true,
                    )

                    _text__flush_line(display, false)
                    num_printed_data_section_lines += 1
                end

                # Check if we must print the horizontal line at the end of the table.
            elseif (rs == :summary_row) && (next_rs != :summary_row)
                # If the next section is the table footer, we must draw the last table line.
                if tf.horizontal_line_after_summary_rows
                    _text__print_horizontal_line(
                        display,
                        tf,
                        style.table_border,
                        table_data,
                        vertical_lines_at_data_columns,
                        row_number_column_width,
                        row_label_column_width,
                        printed_data_column_widths,
                        false,
                        true,
                    )

                    _text__flush_line(display, false)
                end
            end

            # == Omitted Cell Summary ======================================================

            # We also must show the omitted cell summary if the user requested it.
            if (next_rs == :table_footer) && pspec.show_omitted_cell_summary
                ocs = _omitted_cell_summary(num_omitted_data_rows, num_omitted_data_columns)

                isempty(ocs) && continue

                _text__print_aligned(
                    display, ocs, printed_table_width, :r, style.omitted_cell_summary
                )

                _text__flush_line(display; crop_line = false)
            end

            continue
        end

        # == Table Cells ===================================================================

        # If we reach this point, we are processing table cells.

        # Notice that we only fetch the current cell in the branches that require the live
        # object. All the other sections were already rendered by `_text__render_table`,
        # and fetching the cell again would re-run the formatters and the summary row
        # functions, duplicating the work and the accesses to the user data.
        alignment     = _current_cell_alignment(action, ps, table_data)
        cell_printed  = false
        cell_width    = 1
        decoration    = _TEXT__DEFAULT
        # NOTE: The type assertion keeps the per-cell loop free of dynamic dispatches. The
        # generic `_text__render_cell` and the custom text cell API have no return type
        # annotation on their user-facing side, so inference would otherwise give `Any`
        # here. The union is concrete and small, and it avoids one string copy per line
        # when a cell line is a `SubString`.
        rendered_cell::Union{String, SubString{String}} = ""
        vline         = false
        vline_char    = tf.borders.column

        mc_last_index = 0
        merged_cell   = false

        # -- Width, Decoration, and Rendered String ----------------------------------------

        if action == :row_number_label
            cell          = _current_cell(action, ps, table_data)
            cell_width    = row_number_column_width
            decoration    = style.row_number_label
            rendered_cell = _text__render_cell(cell, rctx, renderer)

        elseif action == :stubhead_label
            cell          = _current_cell(action, ps, table_data)
            cell_width    = row_label_column_width
            decoration    = style.stubhead_label
            rendered_cell = _text__render_cell(cell, rctx, renderer)

        elseif action == :row_label
            cell_width    = row_label_column_width
            decoration    = style.row_label
            rendered_cell = row_labels[ir]

        elseif action == :summary_row_number
            cell_width    = row_number_column_width
            rendered_cell = ""

        elseif action == :summary_row_label
            cell_width    = row_label_column_width
            decoration    = style.summary_row_label
            rendered_cell = summary_row_labels[ir]

        elseif action == :column_label
            # The live cell is required here to check for merged cells.
            cell          = _current_cell(action, ps, table_data)
            cell_width    = printed_data_column_widths[jr]
            rendered_cell = column_labels[ir, jr]
            decoration    = if ir == 1
                if style.first_line_column_label isa Crayon
                    style.first_line_column_label
                else
                    style.first_line_column_label[jr]
                end
            else
                if style.column_label isa Crayon
                    style.column_label
                else
                    style.column_label[jr]
                end
            end

            cell === _IGNORE_CELL && continue

            if cell isa MergeCells
                alignment = cell.alignment

                j₀ = jr
                j₁ = min(jr + cell.column_span - 1, last_printed_column_index)

                cell_width = 0

                for j in j₀:j₁
                    cell_width += printed_data_column_widths[j] + 2

                    # We must add a space if we have a vertical line in the merged cells.
                    if (j != j₁) && (j ∈ vertical_lines_at_data_columns)
                        cell_width += 1
                    end
                end

                # We already take into account 2 characters for the margin below.
                cell_width -= 2

                # We must store that this is a merged cell and also what is the last column
                # index of it. It is necessary when drawing the vertical lines. The user
                # can ask to suppress all the vertical lines in the column labels. In
                # this case, we will draw only the very last one if necessary. Thus, we must
                # know if we are at the last cell when drawing a merged cell.
                merged_cell   = true
                mc_last_index = j₁

                # Apply the correct decoration.
                decoration = if ir == 1
                    style.first_line_merged_column_label
                else
                    style.merged_column_label
                end
            end

        elseif action == :row_number
            cell          = _current_cell(action, ps, table_data)
            cell_width    = row_number_column_width
            decoration    = style.row_number
            rendered_cell = _text__render_cell(cell, rctx, renderer)

        elseif action == :data
            # Custom text cells were recorded during the rendering pass, avoiding a new
            # fetch that would re-run the formatters.
            cell = isnothing(custom_cells) ? nothing : get(custom_cells, (ir, jr), nothing)

            if cell isa AbstractCustomTextCell
                cell_width = printed_data_column_widths[jr]

                # If the text on this cell must be cropped, we must regenerate the printable
                # cell text. It can happen if we have a fixed data column width or an upper
                # limit for the cell. Otherwise, we will have access to a cropped string and
                # we will not be able to call the API functions to actually reduce the
                # rendered string width.
                if (max_data_column_widths[jr] <= cell_width) ||
                    (has_fixed_data_column_widths && (fix_data_column_widths[jr] > 0))
                    if !line_breaks || (current_row_line == 1)
                        table_str[ir, jr] = CustomTextCell.printable_cell_text(cell)

                        # Here, we have line breaks and we are in the first line. Hence, we
                        # must regenerate the line tokens.
                        if line_breaks
                            tokens[jr] = split(table_str[ir, jr], '\n')
                        end
                    end
                end

                # We need to manually align the string by adding left and right padding.
                printable_cell = if !line_breaks
                    table_str[ir, jr]
                else
                    if current_row_line <= length(tokens[jr])
                        tokens[jr][current_row_line]
                    else
                        ""
                    end
                end

                tw = printable_textwidth(printable_cell)

                if tw > cell_width
                    CustomTextCell.crop!(cell, tw - cell_width + 1)
                    CustomTextCell.add_suffix!(cell, "…")
                    CustomTextCell.left_padding!(cell, 0)
                    CustomTextCell.right_padding!(cell, 0)

                elseif alignment == :r
                    Δ = cell_width - tw
                    CustomTextCell.left_padding!(cell, Δ)
                    CustomTextCell.right_padding!(cell, 0)

                elseif alignment == :c
                    # NOTE: `_text__print_aligned` rounds the left margin **down**. Hence, a
                    # custom text cell must do the same, or a plain string and a custom cell
                    # with the same content would be centered differently in the same column.
                    Δ = div(cell_width - tw, 2)
                    CustomTextCell.left_padding!(cell, Δ)
                    CustomTextCell.right_padding!(cell, cell_width - tw - Δ)

                else
                    # We must add a right padding because the custom cell must fill the
                    # entire space, leading to a correct cell decoration.
                    Δ = cell_width - tw
                    CustomTextCell.left_padding!(cell, 0)
                    CustomTextCell.right_padding!(cell, Δ)
                end

                rendered_cell = if !line_breaks
                    CustomTextCell.rendered_cell(cell)
                else
                    CustomTextCell.rendered_cell_line(cell, current_row_line)
                end
            else
                cell_width    = printed_data_column_widths[jr]
                rendered_cell = if line_breaks
                    tokens_jr = tokens[jr]

                    if current_row_line <= length(tokens_jr)
                        tokens_jr[current_row_line]
                    else
                        ""
                    end
                else
                    table_str[ir, jr]
                end
            end

            # Check if we must apply highlighters.
            if !isempty(highlighters)
                for h in highlighters
                    if h.f(orig_data, ps.i, ps.j)
                        decoration = h.fd(h, orig_data, ps.i, ps.j)::Crayon
                        break
                    end
                end
            end

        elseif action == :summary_row_cell
            cell_width    = printed_data_column_widths[jr]
            decoration    = style.summary_row_cell
            rendered_cell = summary_rows[ir, jr]

        elseif action == :row_group_label
            cell          = _current_cell(action, ps, table_data)
            cell_width    = printed_table_width - 4
            decoration    = style.row_group_label
            rendered_cell = _text__render_cell(cell, rctx, renderer)
        end

        # If we have multiple lines and we are not rendering a data cell, we must only
        # render it at the first line.
        if (current_row_line >= 2) && (action != :data)
            rendered_cell = ""
        end

        # -- Vertical Line After the Cell --------------------------------------------------

        if action ∈ (:row_number_label, :row_number, :summary_row_number)
            tf.vertical_line_after_row_number_column && (vline = true)

        elseif action ∈ (:stubhead_label, :row_label, :summary_row_label)
            tf.vertical_line_after_row_label_column && (vline = true)

        elseif action == :column_label
            if (!merged_cell && (jr == last_printed_column_index)) ||
                (merged_cell && (mc_last_index == last_printed_column_index))
                tf.vertical_line_after_data_columns && (vline = true)
            elseif ps.j ∈ vertical_lines_at_data_columns
                vline = true
                tf.suppress_vertical_lines_at_column_labels && (vline_char = ' ')
            end

        # NOTE: `:column_label` is fully consumed by the branch above, which is also the one
        # that honors `suppress_vertical_lines_at_column_labels`, and which uses the
        # merged-cell-aware last column index. Hence, it must not be listed here.
        elseif action ∈ (:data, :summary_row_cell)
            if jr == last_printed_column_index
                tf.vertical_line_after_data_columns && (vline = true)
            elseif ps.j ∈ vertical_lines_at_data_columns
                vline = true
            end

        elseif action == :row_group_label
            if tf.vertical_line_after_data_columns && !horizontally_limited_by_display
                vline = true
            end
        end

        _text__print_aligned(
            display,
            rendered_cell,
            cell_width,
            alignment,
            decoration,
            true;
            left_margin = 1,
            right_margin = 1,
        )

        vline && _text__styled_print(display, vline_char, style.table_border)
    end

    # == Print the Buffer Into the IO ======================================================

    output_str = String(take!(buf_io))

    if !pspec.new_line_at_end
        output_str = chomp(output_str)
    end

    if overwrite_display
        num_new_lines = count(==('\n'), output_str)
        print(context, "\e[1F\e[2K"^num_new_lines * output_str)
    else
        print(context, output_str)
    end

    return nothing
end

## Description #############################################################################
#
# Typst Back End: Test showing all the available fields.
#
############################################################################################

@testset "All Available Fields" verbose = true begin
    matrix  = [(i, j) for i in 1:4, j in 1:4]
    backend = :typst

    @testset "Without Cropping" begin
        expected = """
#{
  table(
    align: (right, right, right, right, right, right,),
    columns: (auto, auto, 25fr, 75fr, 5em, auto,),
    stroke: none,
    // == Horizontal Lines =======================
    table.hline(y: 2, stroke: 1.5pt,),
    table.hline(y: 3, start: 3, end: 5, stroke: 0.8pt,),
    table.hline(y: 4, stroke: 0.8pt,),
    table.hline(y: 5, stroke: 0.5pt,),
    table.hline(y: 6, stroke: 0.5pt,),
    table.hline(y: 9, stroke: 0.5pt,),
    table.hline(y: 11, stroke: 1.5pt,),
    // == Vertical Lines =========================
    table.vline(x: 0, start: 2, end: 11, stroke: 1.5pt),
    table.vline(x: 1, start: 2, end: 11, stroke: 0.8pt),
    table.vline(x: 2, start: 2, end: 11, stroke: 0.8pt),
    table.vline(x: 3, start: 2, end: 11, stroke: 0.8pt),
    table.vline(x: 4, start: 2, end: 11, stroke: 0.8pt),
    table.vline(x: 5, start: 2, end: 11, stroke: 0.8pt),
    table.vline(x: 6, start: 2, end: 11, stroke: 1.5pt),
    // == Table Header ===========================
    table.header(
      // -- Table Header: Title ------------------
      table.cell(align: center, colspan: 6,)[
        #text(size: 1.1em, weight: "bold",)[Table Title]
      ],
      // -- Table Header: Subtitle ---------------
      table.cell(align: center, colspan: 6,)[
        #text(size: 1.1em, style: "italic",)[Table Subtitle]
      ],
      // -- Column Labels: Row 1 -----------------
      [#text(weight: "bold",)[Row]],
      [#text(weight: "bold",)[Rows]],
      table.cell(fill: yellow,)[
        #text(fill: blue, weight: "extrabold",)[Col. 1]
      ],
      table.cell(colspan: 2, align: center, fill: blue,)[
        #text(fill: white, weight: "extrabold",)[Merged Column]#super[1]
      ],
      table.cell(fill: red,)[
        #text(fill: rgb(30, 30, 30),)[Col. 4]
      ],
      // -- Column Labels: Row 2 -----------------
      [],
      [],
      [#text(weight: "bold",)[1]],
      [#text(weight: "bold",)[2]],
      [#text(weight: "bold",)[3]],
      [#text(weight: "bold",)[4]],
    ),
    // == Table Body =============================
    // -- Data: Row 1 ----------------------------
    [#text(weight: "bold",)[1]],
    [#text(weight: "bold",)[Row 1]],
    [(1, 1)],
    [(1, 2)],
    [(1, 3)],
    [(1, 4)],
    // -- Row Group Label: Row 2 -----------------
    table.cell(align: left, colspan: 6,)[
      #text(weight: "bold",)[Row Group]
    ],
    // -- Data: Row 2 ----------------------------
    [#text(weight: "bold",)[2]],
    [#text(weight: "bold",)[Row 2]],
    [(2, 1)],
    [(2, 2)#super[2]],
    [(2, 3)],
    [(2, 4)],
    // -- Data: Row 3 ----------------------------
    [#text(weight: "bold",)[3]],
    [#text(weight: "bold",)[Row 3]],
    [(3, 1)],
    [(3, 2)],
    [(3, 3)],
    [(3, 4)],
    // -- Data: Row 4 ----------------------------
    [#text(weight: "bold",)[4]],
    [#text(weight: "bold",)[Row 4]],
    [(4, 1)],
    [(4, 2)],
    [(4, 3)],
    [(4, 4)],
    // -- Summary Row: Row 1 ---------------------
    [],
    [#text(weight: "bold",)[Summary 1]],
    [10],
    [20],
    [30],
    [40],
    // -- Summary Row: Row 2 ---------------------
    [],
    [#text(weight: "bold",)[Summary 2]],
    [20],
    [40],
    [60],
    [80],
    // -- Table Footer: Footnote 1 ---------------
    table.cell(align: left, colspan: 6, inset: (left: 0pt), stroke: none,)[
      #super[1]#text(size: 0.9em,)[Footnote in column label]
    ],
    // -- Table Footer: Footnote 2 ---------------
    table.cell(align: left, colspan: 6, inset: (left: 0pt), stroke: none,)[
      #super[2]#text(size: 0.9em,)[Footnote in data]
    ],
    // -- Table Footer: Source Notes -------------
    table.cell(align: left, colspan: 6, inset: (left: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[Source Notes]
    ],
  )
}
"""

        result = pretty_table(
            String,
            matrix;
            backend,
            style = TypstTableStyle(;
                first_line_column_label = [
                    [
                        "fill" => "yellow",
                        "text-fill" => "blue",
                        "text-weight" => "extrabold",
                    ],
                    [
                        "fill" => "blue",
                        "text-fill" => "white",
                        "text-weight" => "extrabold",
                    ],
                    ["fill" => "red", "text-fill" => "rgb(30, 30, 30)"],
                    ["fill" => "red", "text-fill" => "rgb(30, 30, 30)"],
                    ["fill" => "red", "text-fill" => "rgb(30, 30, 30)"],
                ],
            ),
            column_labels = [["Col. $i" for i in 1:4], ["$i" for i in 1:4]],
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            data_column_widths = ["25fr", "75fr", "5em", "auto"],
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
            subtitle = "Table Subtitle",
            wrap_column = 50,
        )

        @test result == expected
    end

    @testset "With Bottom Cropping" begin
        expected = """
#{
  table(
    align: (right, right, right, right, center,),
    columns: (auto, auto, auto, auto, auto,),
    stroke: none,
    // == Horizontal Lines =================================================================
    table.hline(y: 2, stroke: 1.5pt,),
    table.hline(y: 3, stroke: 0.8pt,),
    table.hline(y: 4, stroke: 0.5pt,),
    table.hline(y: 5, stroke: 0.5pt,),
    table.hline(y: 7, stroke: 0.5pt,),
    table.hline(y: 9, stroke: 1.5pt,),
    // == Vertical Lines ===================================================================
    table.vline(x: 0, start: 2, end: 9, stroke: 1.5pt),
    table.vline(x: 1, start: 2, end: 9, stroke: 0.8pt),
    table.vline(x: 2, start: 2, end: 9, stroke: 0.8pt),
    table.vline(x: 3, start: 2, end: 9, stroke: 0.8pt),
    table.vline(x: 4, start: 2, end: 9, stroke: 0.8pt),
    table.vline(x: 5, start: 2, end: 9, stroke: 1.5pt),
    // == Table Header =====================================================================
    table.header(
      // -- Table Header: Title ------------------------------------------------------------
      table.cell(align: center, colspan: 5,)[#text(size: 1.1em, weight: "bold",)[Table Title]],
      // -- Table Header: Subtitle ---------------------------------------------------------
      table.cell(align: center, colspan: 5,)[
        #text(size: 1.1em, style: "italic",)[Table Subtitle]
      ],
      // -- Column Labels: Row 1 -----------------------------------------------------------
      [#text(weight: "bold",)[Row]],
      [#text(weight: "bold",)[Rows]],
      [#text(weight: "bold",)[Col. 1]],
      table.cell(colspan: 1, align: center,)[#text(weight: "bold",)[Merged Column]#super[1]],
      [⋯],
    ),
    // == Table Body =======================================================================
    // -- Data: Row 1 ----------------------------------------------------------------------
    [#text(weight: "bold",)[1]],
    [#text(weight: "bold",)[Row 1]],
    [(1, 1)],
    [(1, 2)],
    [⋯],
    // -- Row Group Label: Row 2 -----------------------------------------------------------
    table.cell(align: left, colspan: 5,)[#text(weight: "bold",)[Row Group]],
    // -- Data: Row 2 ----------------------------------------------------------------------
    [#text(weight: "bold",)[2]],
    [#text(weight: "bold",)[Row 2]],
    [(2, 1)],
    [(2, 2)#super[2]],
    [⋯],
    // -- Continuation Row -----------------------------------------------------------------
    [⋮],
    [⋮],
    [⋮],
    [⋮],
    [⋱],
    // -- Summary Row: Row 1 ---------------------------------------------------------------
    [],
    [#text(weight: "bold",)[Summary 1]],
    [10],
    [20],
    [⋯],
    // -- Summary Row: Row 2 ---------------------------------------------------------------
    [],
    [#text(weight: "bold",)[Summary 2]],
    [20],
    [40],
    [⋯],
    // -- Omitted Cell Summary -------------------------------------------------------------
    table.cell(align: right, colspan: 5, inset: (right: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[2 columns and 2 rows omitted]
    ],
    // -- Table Footer: Footnote 1 ---------------------------------------------------------
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[1]#text(size: 0.9em,)[Footnote in column label]
    ],
    // -- Table Footer: Footnote 2 ---------------------------------------------------------
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[2]#text(size: 0.9em,)[Footnote in data]
    ],
    // -- Table Footer: Source Notes -------------------------------------------------------
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[Source Notes]
    ],
  )
}
"""

        result = pretty_table(
            String,
            matrix;
            backend,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
        )

        @test result == expected
    end

    @testset "With Middle Cropping" begin
        expected = """
#{
  table(
    align: (right, right, right, right, center,),
    columns: (auto, auto, auto, auto, auto,),
    stroke: none,
    // == Horizontal Lines =================================================================
    table.hline(y: 2, stroke: 1.5pt,),
    table.hline(y: 3, stroke: 0.8pt,),
    table.hline(y: 6, stroke: 0.5pt,),
    table.hline(y: 8, stroke: 1.5pt,),
    // == Vertical Lines ===================================================================
    table.vline(x: 0, start: 2, end: 8, stroke: 1.5pt),
    table.vline(x: 1, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 2, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 3, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 4, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 5, start: 2, end: 8, stroke: 1.5pt),
    // == Table Header =====================================================================
    table.header(
      // -- Table Header: Title ------------------------------------------------------------
      table.cell(align: center, colspan: 5,)[#text(size: 1.1em, weight: "bold",)[Table Title]],
      // -- Table Header: Subtitle ---------------------------------------------------------
      table.cell(align: center, colspan: 5,)[
        #text(size: 1.1em, style: "italic",)[Table Subtitle]
      ],
      // -- Column Labels: Row 1 -----------------------------------------------------------
      [#text(weight: "bold",)[Row]],
      [#text(weight: "bold",)[Rows]],
      [#text(weight: "bold",)[Col. 1]],
      table.cell(colspan: 1, align: center,)[#text(weight: "bold",)[Merged Column]#super[1]],
      [⋯],
    ),
    // == Table Body =======================================================================
    // -- Data: Row 1 ----------------------------------------------------------------------
    [#text(weight: "bold",)[1]],
    [#text(weight: "bold",)[Row 1]],
    [(1, 1)],
    [(1, 2)],
    [⋯],
    // -- Continuation Row -----------------------------------------------------------------
    [⋮],
    [⋮],
    [⋮],
    [⋮],
    [⋱],
    // -- Data: Row 4 ----------------------------------------------------------------------
    [#text(weight: "bold",)[4]],
    [#text(weight: "bold",)[Row 4]],
    [(4, 1)],
    [(4, 2)],
    [⋯],
    // -- Summary Row: Row 1 ---------------------------------------------------------------
    [],
    [#text(weight: "bold",)[Summary 1]],
    [10],
    [20],
    [⋯],
    // -- Summary Row: Row 2 ---------------------------------------------------------------
    [],
    [#text(weight: "bold",)[Summary 2]],
    [20],
    [40],
    [⋯],
    // -- Omitted Cell Summary -------------------------------------------------------------
    table.cell(align: right, colspan: 5, inset: (right: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[2 columns and 2 rows omitted]
    ],
    // -- Table Footer: Footnote 1 ---------------------------------------------------------
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[1]#text(size: 0.9em,)[Footnote in column label]
    ],
    // -- Table Footer: Footnote 2 ---------------------------------------------------------
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[2]#text(size: 0.9em,)[Footnote in data]
    ],
    // -- Table Footer: Source Notes -------------------------------------------------------
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[Source Notes]
    ],
  )
}
"""

        result = pretty_table(
            String,
            matrix;
            backend,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
            vertical_crop_mode = :middle,
        )

        @test result == expected
    end
    @testset "Without Annotation" begin
        expected = """
#{
  table(
    align: (right, right, right, right, center,),
    columns: (auto, auto, auto, auto, auto,),
    stroke: none,
    table.hline(y: 2, stroke: 1.5pt,),
    table.hline(y: 3, stroke: 0.8pt,),
    table.hline(y: 6, stroke: 0.5pt,),
    table.hline(y: 8, stroke: 1.5pt,),
    table.vline(x: 0, start: 2, end: 8, stroke: 1.5pt),
    table.vline(x: 1, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 2, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 3, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 4, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 5, start: 2, end: 8, stroke: 1.5pt),
    table.header(
      table.cell(align: center, colspan: 5,)[#text(size: 1.1em, weight: "bold",)[Table Title]],
      table.cell(align: center, colspan: 5,)[
        #text(size: 1.1em, style: "italic",)[Table Subtitle]
      ],
      [#text(weight: "bold",)[Row]],
      [#text(weight: "bold",)[Rows]],
      [#text(weight: "bold",)[Col. 1]],
      table.cell(colspan: 1, align: center,)[#text(weight: "bold",)[Merged Column]#super[1]],
      [⋯],
    ),
    [#text(weight: "bold",)[1]],
    [#text(weight: "bold",)[Row 1]],
    [(1, 1)],
    [(1, 2)],
    [⋯],
    [⋮],
    [⋮],
    [⋮],
    [⋮],
    [⋱],
    [#text(weight: "bold",)[4]],
    [#text(weight: "bold",)[Row 4]],
    [(4, 1)],
    [(4, 2)],
    [⋯],
    [],
    [#text(weight: "bold",)[Summary 1]],
    [10],
    [20],
    [⋯],
    [],
    [#text(weight: "bold",)[Summary 2]],
    [20],
    [40],
    [⋯],
    table.cell(align: right, colspan: 5, inset: (right: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[2 columns and 2 rows omitted]
    ],
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[1]#text(size: 0.9em,)[Footnote in column label]
    ],
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[2]#text(size: 0.9em,)[Footnote in data]
    ],
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[Source Notes]
    ],
  )
}
"""

        result = pretty_table(
            String,
            matrix;
            backend,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
            vertical_crop_mode = :middle,
            annotate = false,
        )

        @test result == expected
    end

    @testset "Wrap Column Tests" begin
        expected = """
#{
  table(
    align: (right, right, right, right, center,),
    columns: (auto, auto, auto, auto, auto,),
    stroke: none,
    table.hline(y: 2, stroke: 1.5pt,),
    table.hline(y: 3, stroke: 0.8pt,),
    table.hline(y: 6, stroke: 0.5pt,),
    table.hline(y: 8, stroke: 1.5pt,),
    table.vline(x: 0, start: 2, end: 8, stroke: 1.5pt),
    table.vline(x: 1, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 2, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 3, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 4, start: 2, end: 8, stroke: 0.8pt),
    table.vline(x: 5, start: 2, end: 8, stroke: 1.5pt),
    table.header(
      table.cell(align: center, colspan: 5,)[
        #text(size: 1.1em, weight: "bold",)[Table Title]
      ],
      table.cell(align: center, colspan: 5,)[
        #text(size: 1.1em, style: "italic",)[Table Subtitle]
      ],
      [
        #text(weight: "bold",)[Row]
      ],
      [
        #text(weight: "bold",)[Rows]
      ],
      [
        #text(weight: "bold",)[Col. 1]
      ],
      table.cell(colspan: 1, align: center,)[
        #text(weight: "bold",)[Merged Column]#super[1]
      ],
      [
        ⋯
      ],
    ),
    [
      #text(weight: "bold",)[1]
    ],
    [
      #text(weight: "bold",)[Row 1]
    ],
    [
      (1, 1)
    ],
    [
      (1, 2)
    ],
    [
      ⋯
    ],
    [
      ⋮
    ],
    [
      ⋮
    ],
    [
      ⋮
    ],
    [
      ⋮
    ],
    [
      ⋱
    ],
    [
      #text(weight: "bold",)[4]
    ],
    [
      #text(weight: "bold",)[Row 4]
    ],
    [
      (4, 1)
    ],
    [
      (4, 2)
    ],
    [
      ⋯
    ],
    [
      
    ],
    [
      #text(weight: "bold",)[Summary 1]
    ],
    [
      10
    ],
    [
      20
    ],
    [
      ⋯
    ],
    [
      
    ],
    [
      #text(weight: "bold",)[Summary 2]
    ],
    [
      20
    ],
    [
      40
    ],
    [
      ⋯
    ],
    table.cell(align: right, colspan: 5, inset: (right: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[2 columns and 2 rows omitted]
    ],
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[1]#text(size: 0.9em,)[Footnote in column label]
    ],
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #super[2]#text(size: 0.9em,)[Footnote in data]
    ],
    table.cell(align: left, colspan: 5, inset: (left: 0pt), stroke: none,)[
      #text(fill: gray, size: 0.9em, style: "italic",)[Source Notes]
    ],
  )
}
"""

        result = pretty_table(
            String,
            matrix;
            backend,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
            vertical_crop_mode = :middle,
            wrap_column = 1, # any attribute will need a new line
            annotate = false,
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# HTML Back End: Tests related with decorations.
#
############################################################################################

@testset "Decorations" verbose = true begin
    @testset "Decoration of Column Labels" begin
        matrix = ones(3, 3)

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "color: yellow; text-align: right;">Col. 1</th>
      <th style = "color: yellow; text-align: right;">Col. 2</th>
      <th style = "color: yellow; text-align: right;">Col. 3</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            color   = true,
            style   = HtmlTableStyle(; first_line_column_label = ["color" => "yellow"]),
        )

        @test result == expected

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "color: yellow; text-align: right;">Col. 1</th>
      <th style = "color: blue; text-align: right;">Col. 2</th>
      <th style = "color: red; text-align: right;">Col. 3</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1.0</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            color   = true,
            style   = HtmlTableStyle(; first_line_column_label = [["color" => "yellow"], ["color" => "blue"], ["color" => "red"]]),
        )

        @test result == expected
    end
    @testset "Per-Column Style for the Column Labels" begin
        # `column_label` may be a single style applied to every column, or a vector holding
        # one style per column. Only the scalar form was covered.
        result = pretty_table(
            String,
            [1 2];
            backend = :html,
            column_labels = [["A", "B"], ["a", "b"]],
            style = HtmlTableStyle(;
                column_label = [["color" => "red"], ["color" => "blue"]],
            ),
        )

        @test occursin("<th style = \"color: red; text-align: right;\">a</th>", result)
        @test occursin("<th style = \"color: blue; text-align: right;\">b</th>", result)
    end
end

## Description #############################################################################
#
# Markdown Back End: Test related with offset arrays.
#
############################################################################################

@testset "Offset Arrays" begin
    matrix = Matrix{Any}(undef, 3, 3)
    matrix[1, 1] = (1, 1)
    matrix[1, 2] = (1, 2)
    matrix[2, 1] = nothing
    matrix[2, 2] = missing
    matrix[3, 3] = (3, 3)

    omatrix = OffsetArray(matrix, -2:0, -3:-1)

    expected = """
| **Row** | **Col. -3** | **Col. -2** | **Col. -1** |
|--------:|------------:|------------:|------------:|
|  **-2** |      (1, 1) |      (1, 2) |      #undef |
|  **-1** |     nothing |     missing |      #undef |
|   **0** |      #undef |      #undef |      (3, 3) |
"""

    result = pretty_table(
        String, omatrix; backend = :markdown, show_row_number_column = true
    )

    @test result == expected
end

@testset "Empty Table With Row Numbers" begin
    # The row number column width used `floor(Int, log10(m) + 1)`, which throws an
    # `InexactError` for an empty table because `log10(0) == -Inf`.
    expected = """
| **Row** | **A** | **B** |
|--------:|------:|------:|
"""

    result = pretty_table(
        String,
        Matrix{Int}(undef, 0, 2);
        backend = :markdown,
        show_row_number_column = true,
        column_labels = [["A", "B"]],
    )

    @test result == expected
end

## Description #############################################################################
#
# LaTeX Back End: Test renderers.
#
############################################################################################

@testset "Renderers" verbose = true begin
    matrix = ['a' :a "a" missing nothing]

    @testset ":print" begin
        expected = """
\\begin{tabular}{|r|r|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} \\\\
  \\hline
  a & a & a & missing & nothing \\\\
  \\hline
\\end{tabular}
"""
        result = pretty_table(String, matrix; backend = :latex)

        @test result == expected
    end

    @testset ":show" begin
        expected = """
\\begin{tabular}{|r|r|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} \\\\
  \\hline
  'a' & :a & a & missing & nothing \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(String, matrix; backend = :latex, renderer = :show)

        @test result == expected
    end
end

## Description #############################################################################
#
# HTML back end of PrettyTables.jl
#
############################################################################################

function _html__print(
    pspec::PrintingSpec;
    allow_html_in_cells::Bool = false,
    column_label_titles::Union{Nothing, AbstractVector} = nothing,
    highlighters::Vector{HtmlHighlighter} = HtmlHighlighter[],
    is_stdout::Bool = false,
    line_breaks::Bool = false,
    maximum_column_width::String = "",
    minify::Bool = false,
    stand_alone::Bool = false,
    style::HtmlTableStyle = HtmlTableStyle(),
    table_class::String = "",
    table_div_class::String = "",
    table_format::HtmlTableFormat = HtmlTableFormat(),
    top_left_string::AbstractString = "",
    top_right_string::AbstractString = "",
    wrap_table_in_div::Bool = false,
)
    context    = pspec.context
    table_data = pspec.table_data
    # NOTE: `Val(pspec.renderer)` infers to the abstract `Val` because
    # `pspec.renderer` is a `Symbol`. Branching here keeps the renderer concrete, so the
    # per-cell rendering calls are statically dispatched.
    renderer   = pspec.renderer === :show ? Val(:show) : Val(:print)
    tf         = table_format

    ps     = PrintingTableState()
    buf_io = IOBuffer()
    buf    = IOContext(buf_io, context)

    # Create dictionaries to store properties and styles to decrease the number of
    # allocations.
    vproperties = Pair{String, String}[]
    vstyle      = Pair{String, String}[]

    # Check the dimensions of header cell titles.
    if !isnothing(column_label_titles)
        num_column_label_rows = length(table_data.column_labels)

        if length(column_label_titles) < num_column_label_rows
            error(
                "The number of vectors in `column_label_titles` must be equal to or greater than that in `column_labels`.",
            )
        end

        for k in eachindex(column_label_titles)
            if (
                !isnothing(column_label_titles[k]) &&
                (length(column_label_titles[k]) != table_data.num_columns)
            )
                error(
                    "The number of elements in each row of `column_label_titles` must match the number of columns in the table.",
                )
            end
        end
    end

    # Check the style variables.
    if style.first_line_column_label isa Vector{Vector{HtmlPair}}
        length(style.first_line_column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `first_line_column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    if style.column_label isa Vector{Vector{HtmlPair}}
        length(style.column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    # == Variables to Store Information About Indentation ==================================

    il = 0 # ..................................................... Current indentation level
    ns = 2 # .................................... Number of spaces in each indentation level

    # == Print HTML Header =================================================================

    if stand_alone
        _aprintln(
            buf,
            """
            <!DOCTYPE html>
            <html>
            <head>
            <meta charset="UTF-8">
            <style>""",
            il,
            ns;
            minify,
        )
        il += 1

        !isempty(tf.table_width) && _aprintln(
            buf,
            """
            table {
                width: $(tf.table_width);
            }
            """,
            il,
            ns;
            minify,
        )

        _aprintln(buf, tf.css, il, ns; minify)
        il -= 1

        _aprintln(
            buf,
            """
            </style>
            </head>
            <body>""",
            il,
            ns;
            minify,
        )
    end

    # == Top Bar ===========================================================================

    # Check if the user wants the omitted cell summary.
    ocs = _omitted_cell_summary(table_data, pspec)

    if !isempty(ocs)
        top_right_string = ocs
    end

    # Print the top bar if necessary.
    if !isempty(top_left_string) || !isempty(top_right_string)
        _aprintln(buf, _html__open_tag("div"), il, ns; minify)
        il += 1

        # Top left section.
        if !isempty(top_left_string)
            _html__print_top_bar_section(
                buf, "left", top_left_string, style.top_left_string, il, ns; minify
            )
        end

        # Top right section.
        if !isempty(top_right_string)
            _html__print_top_bar_section(
                buf, "right", top_right_string, style.top_right_string, il, ns; minify
            )
        end

        # We need to clear the floats so that the table is rendered below the top bar.
        empty!(vstyle)
        push!(vstyle, "clear" => "both")
        _aprintln(buf, _html__create_tag("div", ""; style = vstyle), il, ns; minify)

        il -= 1
        _aprintln(buf, _html__close_tag("div"), il, ns; minify)
    end

    # == Table =============================================================================

    if wrap_table_in_div
        empty!(vproperties)
        push!(vproperties, "class" => table_div_class)

        empty!(vstyle)
        push!(vstyle, "overflow-x" => "scroll")

        _aprintln(
            buf,
            _html__open_tag("div"; properties = vproperties, style = vstyle),
            il,
            ns;
            minify,
        )

        il += 1
    end

    empty!(vproperties)
    push!(vproperties, "class" => table_class)

    # NOTE: We must copy the style vector because the tag creation sorts it in place, and we
    # must not mutate a vector that belongs to the user.
    _aprintln(
        buf,
        _html__open_tag("table"; properties = vproperties, style = copy(style.table)),
        il,
        ns;
        minify,
    )

    il += 1

    action = :initialize

    # Some internal states to help printing.
    head_opened = false
    body_opened = false
    foot_opened = false

    # The highlighters must receive the object the user passed to `pretty_table`, not the
    # internal table wrapper. Notice that this is loop invariant.
    orig_data = _get_data(table_data.data)

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)

        action == :end_printing && break

        if action == :new_row
            if (ps.i == 1) && (rs ∈ (:table_header, :column_labels)) && !head_opened
                _aprintln(buf, "<thead>", il, ns; minify)
                il += 1
                head_opened = true

            elseif !body_opened && (
                ((ps.i == 1) && (rs ∈ (:data, :summary_row))) || (rs == :row_group_label)
            )
                if head_opened
                    il -= 1
                    _aprintln(buf, "</thead>", il, ns; minify)
                    head_opened = false
                end

                _aprintln(buf, "<tbody>", il, ns; minify)
                body_opened = true
                il += 1

            elseif (ps.i == 1) && (rs == :table_footer) && !foot_opened
                if head_opened
                    il -= 1
                    _aprintln(buf, "</thead>", il, ns; minify)
                    head_opened = false
                elseif body_opened
                    il -= 1
                    _aprintln(buf, "</tbody>", il, ns; minify)
                    body_opened = false
                end

                _aprintln(buf, "<tfoot>", il, ns; minify)
                foot_opened = true
                il += 1
            end

            empty!(vproperties)
            class = if rs == :table_header
                ps.state < _TITLE ? "title" : "subtitle"
            elseif rs == :column_labels
                "columnLabelRow"
            elseif rs == :row_group_label
                "rowGroupLabel"
            elseif rs == :data
                "dataRow"
            elseif rs == :summary_row
                "summaryRow"
            elseif rs == :table_footer
                # NOTE: This condition must mirror the one the printing state iterator uses
                # to decide whether it is emitting a footnote row or a source note row.
                # Otherwise, a table with source notes but without footnotes would tag its
                # source note rows with the `footnote` class.
                (ps.state < _FOOTNOTES) && !isnothing(table_data.footnotes) ?
                    "footnote" : "sourceNotes"
            else
                ""
            end
            push!(vproperties, "class" => class)

            _aprintln(buf, _html__open_tag("tr"; properties = vproperties), il, ns; minify)
            il += 1

        elseif action == :diagonal_continuation_cell
            # `vstyle` is a buffer reused across cells. Hence, it must be cleared here, just
            # like the vertical continuation cell branch below does. Otherwise, this cell
            # would inherit the style of whatever cell was rendered before it.
            empty!(vstyle)

            _aprintln(
                buf, _html__create_tag("td", "&dtdot;"; style = vstyle), il, ns; minify
            )

        elseif action == :horizontal_continuation_cell
            tag = rs == :column_labels ? "th" : "td"
            _aprintln(buf, _html__create_tag(tag, "&ctdot;"), il, ns; minify)

        elseif action ∈ _VERTICAL_CONTINUATION_CELL_ACTIONS
            # Obtain the cell style.
            empty!(vstyle)
            alignment = _current_cell_alignment(action, ps, table_data)
            _html__add_alignment_to_style!(vstyle, alignment)

            _aprintln(
                buf, _html__create_tag("td", "&vellip;"; style = vstyle), il, ns; minify
            )

        elseif action == :end_row
            il -= 1
            _aprintln(buf, "</tr>", il, ns; minify)

        else
            empty!(vproperties)
            empty!(vstyle)

            cell = _current_cell(action, ps, table_data)

            cell === _IGNORE_CELL && continue

            # If we are in a column label, check for cell titles.
            if !isnothing(column_label_titles) && (action == :column_label)
                title = column_label_titles[ps.i]
                !isnothing(title) && push!(vproperties, "title" => string(title[ps.j]))
            end

            # If we are in a column label, check if we must merge the cell.
            if (action == :column_label) && (cell isa MergeCells)
                # Check if we have enough data columns to merge the cell.
                num_data_columns = _number_of_printed_data_columns(table_data)

                cs = if (ps.j + cell.column_span - 1) > num_data_columns
                    num_data_columns - ps.j + 1
                else
                    cell.column_span
                end

                push!(vproperties, "colspan" => string(cs))
                rendered_cell = _html__render_cell(
                    cell.data, buf, renderer; allow_html_in_cells, line_breaks
                )

                alignment = cell.alignment

                append!(
                    vstyle,
                    if ps.i == 1
                        style.first_line_merged_column_label
                    else
                        style.merged_column_label
                    end,
                )

            else
                rendered_cell = _html__render_cell(
                    cell, buf, renderer; allow_html_in_cells, line_breaks
                )

                alignment = _current_cell_alignment(action, ps, table_data)
            end

            # Obtain the cell alignment.
            _html__add_alignment_to_style!(vstyle, alignment)

            # Check if the user wants to limit the column width.
            if !isempty(maximum_column_width)
                push!(
                    vstyle,
                    "max-width"     => maximum_column_width,
                    "overflow"      => "hidden",
                    "text-overflow" => "ellipsis",
                    "white-space"   => "nowrap",
                )
            end

            # Check for footnotes.
            footnotes = _current_cell_footnotes(table_data, action, ps.i, ps.j)

            if !isnothing(footnotes) && !isempty(footnotes)
                rendered_cell *= "<sup>"
                for i in eachindex(footnotes)
                    f = footnotes[i]
                    if i != last(eachindex(footnotes))
                        rendered_cell *= "$f,"
                    else
                        rendered_cell *= "$f</sup>"
                    end
                end
            end

            # If we are in a data cell, we must check for highlighters.
            if (action == :data) && !isempty(highlighters)
                for h in highlighters
                    if h.f(orig_data, ps.i, ps.j)
                        append!(vstyle, h.fd(h, orig_data, ps.i, ps.j))
                        break
                    end
                end
            end

            # Obtain the cell class and style.

            if action == :title
                push!(
                    vproperties, "colspan" => string(_number_of_printed_columns(table_data))
                )
                append!(vstyle, style.title)

            elseif action == :subtitle
                push!(
                    vproperties, "colspan" => string(_number_of_printed_columns(table_data))
                )
                append!(vstyle, style.subtitle)

            elseif action == :row_number_label
                push!(vproperties, "class" => "rowNumberLabel")
                append!(vstyle, style.row_number_label)

            elseif action == :row_number
                push!(vproperties, "class" => "rowNumber")
                append!(vstyle, style.row_number)

            elseif action == :summary_row_number
                push!(vproperties, "class" => "summaryRowNumber")
                append!(vstyle, style.row_number)

            elseif action == :stubhead_label
                push!(vproperties, "class" => "stubheadLabel")
                append!(vstyle, style.stubhead_label)

            elseif action == :row_group_label
                push!(
                    vproperties, "colspan" => string(_number_of_printed_columns(table_data))
                )
                append!(vstyle, style.row_group_label)

            elseif action == :row_label
                push!(vproperties, "class" => "rowLabel")
                append!(vstyle, style.row_label)

            elseif action == :summary_row_label
                push!(vproperties, "class" => "summaryRowLabel")
                append!(vstyle, style.summary_row_label)

            elseif action == :column_label
                if ps.i == 1
                    append!(
                        vstyle,
                        if style.first_line_column_label isa Vector{Vector{HtmlPair}}
                            style.first_line_column_label[ps.j]
                        else
                            style.first_line_column_label
                        end,
                    )
                else
                    append!(
                        vstyle,
                        if style.column_label isa Vector{Vector{HtmlPair}}
                            style.column_label[ps.j]
                        else
                            style.column_label
                        end,
                    )
                end

            elseif action == :summary_row_cell
                append!(vstyle, style.summary_row_cell)

            elseif action == :footnote
                # The footnote must be a cell that spans the entire printed table.
                push!(
                    vproperties, "colspan" => string(_number_of_printed_columns(table_data))
                )
                append!(vstyle, style.footnote)
                rendered_cell = "<sup>$(ps.i)</sup> " * rendered_cell

            elseif action == :source_notes
                # The source notes must be a cell that spans the entire printed table.
                push!(
                    vproperties, "colspan" => string(_number_of_printed_columns(table_data))
                )
                append!(vstyle, style.source_note)

            else
                push!(vproperties, "class" => "")
            end

            # Create the row tag with the content.
            row_tag = rs == :column_labels ? "th" : "td"
            _aprintln(
                buf,
                _html__create_tag(
                    row_tag, rendered_cell; properties = vproperties, style = vstyle
                ),
                il,
                ns;
                minify,
            )
        end
    end

    # Close the section that was left opened.
    if head_opened
        il -= 1
        _aprintln(buf, "</thead>", il, ns; minify)
    elseif body_opened
        il -= 1
        _aprintln(buf, "</tbody>", il, ns; minify)
    elseif foot_opened
        il -= 1
        _aprintln(buf, "</tfoot>", il, ns; minify)
    end

    il -= 1
    _aprintln(buf, _html__close_tag("table"), il, ns; minify)

    if wrap_table_in_div
        il -= 1
        _aprintln(buf, _html__close_tag("div"), il, ns; minify)
    end

    if stand_alone
        _aprintln(
            buf,
            """
            </body>
            </html>""",
            il,
            ns;
            minify,
        )
    end

    # == Print the Buffer Into the IO ======================================================

    output_str = String(take!(buf_io))

    if !pspec.new_line_at_end
        output_str = chomp(output_str)
    end

    # If we are printing to `stdout`, wrap the output in a `HTML` object.
    if is_stdout
        display(MIME("text/html"), HTML(output_str))
    else
        print(context, output_str)
    end

    return nothing
end

## Description #############################################################################
#
# Functions to render the table cells in the LaTeX back end.
#
############################################################################################

# NOTE: The functions to render the cell must receive the current `RenderContext` because
# its `IOContext` carries the information required to check for circular dependency. We
# store the objects being printed inside the key `__PRETTY_TABLES__DATA__` in the IO
# context. Hence, we must pass it forward when rendering the cells.

"""
    _latex__cell_to_str(
        cell::Any,
        context::RenderContext,
        renderer::Union{Val{:print}, Val{:show}}
    ) -> String

Convert the `cell` to a string using a specific `context` and `renderer`.
"""
function _latex__cell_to_str(cell::Any, context::RenderContext, ::Val{:print})
    return _sprint_with_context(print, context, cell)
end

function _latex__cell_to_str(cell::Any, context::RenderContext, ::Val{:show})
    if showable(MIME("text/latex"), cell)
        cell_str = _sprint_with_context(show, context, MIME("text/latex"), cell)
    else
        cell_str = _sprint_with_context(show, context, cell)
    end

    return cell_str
end

function _latex__cell_to_str(cell::AbstractString, context::RenderContext, ::Val{:print})
    # Notice that we must not use `string` here because it is the identity for any
    # `AbstractString`, whereas the callers require a `String`.
    return String(cell)
end

function _latex__cell_to_str(cell::AbstractString, context::RenderContext, ::Val{:show})
    return string(cell)
end

_latex__cell_to_str(cell::UndefinedCell, context::RenderContext, ::Val{:print}) = "#undef"
_latex__cell_to_str(cell::UndefinedCell, context::RenderContext, ::Val{:show}) = "#undef"

"""
    _latex__render_cell(
        cell::Any,
        context::RenderContext,
        renderer::Union{Val{:print}, Val{:show}};
        kwargs...
    ) -> String

Render the `cell` in latex back end using a specific `context` and `renderer`.
"""
function _latex__render_cell(
    cell::Any, context::RenderContext, renderer::Union{Val{:print}, Val{:show}}
)
    cell_str = _latex__cell_to_str(cell, context, renderer)

    # If the user wants latex code inside cell, we must not escape the latex characters.
    return _latex__escape_str(cell_str)
end

function _latex__render_cell(
    cell::LatexCell, context::RenderContext, renderer::Union{Val{:print}, Val{:show}}
)
    return _latex__cell_to_str(cell.data, context, renderer)
end

function _latex__render_cell(
    cell::LaTeXString, context::RenderContext, renderer::Union{Val{:print}, Val{:show}}
)
    return _latex__cell_to_str(cell, context, renderer)
end

# For Markdown cells, we must render always using `show` to obtain the correct decoration.
function _latex__render_cell(
    cell::Markdown.MD, context::RenderContext, renderer::Union{Val{:print}, Val{:show}}
)
    return replace(sprint(show, MIME("text/latex"), cell), "\n" => "")
end

## Description #############################################################################
#
# Excel Back End: Test style.
#
############################################################################################

@testset "ExcelTableStyle" verbose = true begin
    matrix = [
        1 2 3
        4 5 6
        7 8 9
    ]

    # == Styles with Vectors of Column Properties ==========================================

    @testset "Styles with Vectors of Column Properties" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            title = "This is a title.",
            subtitle = "This is a subtitle.",
            stubhead_label = "This is a stubhead label.",
            show_row_number_column = true,
            row_number_column_label = "Row Number",
            row_labels = ["Row 1", "Row 2", "Row 3"],
            row_group_labels = [3 => "Group 1"],
            summary_row_labels = ["Total"],
            summary_rows = [(data, i) -> sum(data[:, i])],
            footnotes = [
                (:subtitle, 1, 1) => "Subtitle footnote"
                (:column_label, 1, 3) => "Third column footnote."
                (:data, 2, 2) => "Midddle data footnote."
            ],
            source_notes = "This is a source note.",
            style = ExcelTableStyle(;
                title = [
                    "bold" => "true",
                    "color" => "orange",
                    "size" => "18",
                    "under" => "single",
                ],
                subtitle = ["italic" => "true", "name" => "Palatino"],
                row_number_label = ["under" => "double"],
                row_number = ["strike" => "true"],
                stubhead_label = ["bold" => "true", "color" => "red", "size" => "24"],
                row_label = ["color" => "orange"],
                row_group_label = ["bold" => "true", "color" => "magenta"],
                first_line_column_label = [
                    ["bold" => "true"], ["color" => "red"], ["size" => "24"]
                ],
                data_cell = ["bold" => "true"],
                summary_row_label = ["bold" => "true", "color" => "red", "size" => "24"],
                summary_row_cell = ["italic" => "true"],
                footnote = ["bold" => "true", "color" => "magenta"],
                source_note = ["italic" => "true", "color" => "cyan"],
            ),
        )

        r = result[1]

        f = XLSX.getFont(r, "A1").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFFA500")
        @test f["sz"] == Dict("val" => "18")
        @test haskey(f, "u") == true

        f = XLSX.getFont(r, "A2").font
        @test haskey(f, "i") == true
        @test f["name"] == Dict("val" => "Palatino")

        @test XLSX.getFont(r, "A3").font["u"] == Dict("val" => "double")
        @test haskey(XLSX.getFont(r, "A5").font, "strike") == true

        f = XLSX.getFont(r, "B3").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")

        @test XLSX.getFont(r, "B4").font["color"] == Dict("rgb" => "FFFFA500")

        f = XLSX.getFont(r, "A6").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF00FF")

        @test haskey(XLSX.getFont(r, "C3").font, "b") == true
        @test XLSX.getFont(r, "D3").font["color"] == Dict("rgb" => "FFFF0000")
        @test XLSX.getFont(r, "E3").font["sz"] == Dict("val" => "24")

        @test haskey(XLSX.getFont(r, "C4").font, "b") == true
        @test haskey(XLSX.getFont(r, "D4").font, "b") == true
        @test haskey(XLSX.getFont(r, "E4").font, "b") == true

        f = XLSX.getFont(r, "B8").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")

        @test haskey(XLSX.getFont(r, "C8").font, "i") == true
        @test haskey(XLSX.getFont(r, "D8").font, "i") == true
        @test haskey(XLSX.getFont(r, "E8").font, "i") == true

        f = XLSX.getFont(r, "A9").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF00FF")

        f = XLSX.getFont(r, "A12").font
        @test haskey(f, "i") == true
        @test f["color"] == Dict("rgb" => "FF00FFFF")
    end

    # == Styles with Constant Properties ===================================================

    @testset "Styles with Constant Properties for All Columns" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            title = "This is a title.",
            subtitle = "This is a subtitle.",
            stubhead_label = "This is a stubhead label.",
            show_row_number_column = true,
            row_number_column_label = "Row Number",
            row_labels = ["Row 1", "Row 2", "Row 3"],
            row_group_labels = [3 => "Group 1"],
            summary_row_labels = ["Total"],
            summary_rows = [(data, i) -> sum(data[:, i])],
            footnotes = [
                (:subtitle, 1, 1) => "Subtitle footnote"
                (:column_label, 1, 3) => "Third column footnote."
                (:data, 2, 2) => "Middle data footnote."
            ],
            source_notes = "This is a source note.",
            style = ExcelTableStyle(;
                title = [
                    "bold" => "true",
                    "color" => "orange",
                    "size" => "18",
                    "under" => "single",
                ],
                subtitle = ["italic" => "true", "name" => "Palatino"],
                row_number_label = ["under" => "double"],
                row_number = ["strike" => "true"],
                stubhead_label = ["bold" => "true", "color" => "red", "size" => "24"],
                row_label = ["color" => "orange"],
                row_group_label = ["bold" => "true", "color" => "magenta"],
                first_line_column_label = [
                    "bold" => "true", "color" => "red", "size" => "24"
                ],
                data_cell = ["bold" => "true", "color" => "red", "size" => "24"],
                summary_row_label = ["bold" => "true", "color" => "red", "size" => "24"],
                summary_row_cell = ["italic" => "true", "color" => "green", "size" => "14"],
                footnote = ["bold" => "true", "color" => "magenta"],
                source_note = ["italic" => "true", "color" => "cyan"],
            ),
        )

        r = result[1]

        f = XLSX.getFont(r, "A1").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFFA500")
        @test f["sz"] == Dict("val" => "18")
        @test haskey(f, "u") == true

        f = XLSX.getFont(r, "A2").font
        @test haskey(f, "i") == true
        @test f["name"] == Dict("val" => "Palatino")

        @test XLSX.getFont(r, "A3").font["u"] == Dict("val" => "double")
        @test haskey(XLSX.getFont(r, "A5").font, "strike") == true

        f = XLSX.getFont(r, "B3").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")

        @test XLSX.getFont(r, "B4").font["color"] == Dict("rgb" => "FFFFA500")

        f = XLSX.getFont(r, "A6").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF00FF")

        f = XLSX.getFont(r, "C3").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")
        f = XLSX.getFont(r, "D3").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")
        f = XLSX.getFont(r, "E3").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")

        f = XLSX.getFont(r, "C4").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")
        f = XLSX.getFont(r, "D4").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")
        f = XLSX.getFont(r, "E4").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")

        f = XLSX.getFont(r, "B8").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF0000")
        @test f["sz"] == Dict("val" => "24")

        f = XLSX.getFont(r, "C8").font
        @test haskey(f, "i") == true
        @test f["color"] == Dict("rgb" => "FF008000")
        @test f["sz"] == Dict("val" => "14")
        f = XLSX.getFont(r, "D8").font
        @test haskey(f, "i") == true
        @test f["color"] == Dict("rgb" => "FF008000")
        @test f["sz"] == Dict("val" => "14")
        f = XLSX.getFont(r, "E8").font
        @test haskey(f, "i") == true
        @test f["color"] == Dict("rgb" => "FF008000")
        @test f["sz"] == Dict("val" => "14")

        f = XLSX.getFont(r, "A9").font
        @test haskey(f, "b") == true
        @test f["color"] == Dict("rgb" => "FFFF00FF")

        f = XLSX.getFont(r, "A12").font
        @test haskey(f, "i") == true
        @test f["color"] == Dict("rgb" => "FF00FFFF")
    end
end

## Description #############################################################################
#
# Excel Back End: Test alignment of cells in the table.
#
############################################################################################

@testset "Alignment" verbose = true begin
    data = [1 2 3; 4 5 6; 7 8 9]

    # == With Headers, Footers and Summaries ===============================================

    @testset "With Headers, Footers and Summaries" verbose = true begin
        f = pretty_table(
            data;
            title_alignment = :l,
            title = "This is a title",
            subtitle_alignment = :c,
            subtitle = "This is a subtitle",
            stubhead_label = "stubhead label",
            column_labels = ["Column 1", "Column 2", "Column 3"],
            row_labels = ["Row 1", "Row 2", "Row 3"],
            row_label_column_alignment = :c,
            alignment = [:l, :r, :c],
            summary_rows = [
                (data, j) -> maximum(@views data[:, j]),
                (data, j) -> minimum(@views data[:, j]),
            ],
            summary_row_labels = ["Min Value", "Max Value"],
            footnotes = [
                (:subtitle, 1, 1) => "Vehicle 1: Ford Escort, Vehicle 2: VW Golf"
                (:column_label, 1, 3) => "Estimated data based on the acceleration measurement."
            ],
            footnote_alignment = :r,
            source_notes = "Source: Test procedure conducted on 2024-01-15.\nNote: Data is for demonstration purposes only.",
            source_note_alignment = :c,
            backend = :excel,
        )

        @test XLSX.getAlignment(f[1], "A3").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "B3").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "C3").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "D3").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "A4").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A5").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A6").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A7").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "B7").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "C7").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "D7").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A8").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "B8").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "C8").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "D8").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A9").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "1", "vertical" => "center")
        @test XLSX.getAlignment(f[1], "A10").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "1", "vertical" => "center")
        @test XLSX.getAlignment(f[1], "A11").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "center")
    end

    # == Column Label Alignment ============================================================

    @testset "Column Label Alignment" verbose = true begin
        f = pretty_table(
            data;
            title_alignment = :l,
            title = "This is a title",
            subtitle_alignment = :c,
            subtitle = "This is a subtitle",
            column_label_alignment = [:r, :c, :l],
            column_labels = ["Column 1", "Column 2", "Column 3"],
            row_label_column_alignment = :c,
            alignment = [:r, :c, :l],
            backend = :excel,
        )

        @test XLSX.getAlignment(f[1], "A1").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "A2").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "A3").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "B3").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "C3").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "1", "vertical" => "bottom")
        @test XLSX.getAlignment(f[1], "A4").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "B5").alignment["alignment"] ==
            Dict("horizontal" => "center", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "C6").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
    end

    # == Cell-Level Dynamic Alignment ========================================================

    @testset "Cell-Level Dynamic Alignment" verbose = true begin
        f = pretty_table(
            data;
            title_alignment = :l,
            title = "This is a title",
            subtitle_alignment = :c,
            subtitle = "This is a subtitle",
            column_label_alignment = [:r, :c, :l],
            column_labels = ["Column 1", "Column 2", "Column 3"],
            row_label_column_alignment = :c,
            alignment = :c,
            cell_alignment = [(data, i, j) -> isodd(j) ? :l : :r],
            backend = :excel,
        )

        @test XLSX.getAlignment(f[1], "A4").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "B4").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "C4").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A5").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "B5").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "C5").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "A6").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "B6").alignment["alignment"] ==
            Dict("horizontal" => "right", "wrapText" => "0", "vertical" => "top")
        @test XLSX.getAlignment(f[1], "C6").alignment["alignment"] ==
            Dict("horizontal" => "left", "wrapText" => "0", "vertical" => "top")
    end
end

## Description #############################################################################
#
# Functions to retrieve the current cell data.
#
############################################################################################

"""
    _get_data_cell(data, i::Int, j::Int) -> Any

Return the normalized data cell at `(i, j)`, or `_UNDEFINED_CELL` if it is unassigned.
"""
function _get_data_cell(data::AbstractVecOrMat, i::Int, j::Int)
    return isassigned(data, i, j) ? getindex(data, i, j) : _UNDEFINED_CELL
end

"""
    _get_data_cell(data::ColumnTable, i::Int, j::Int) -> Any

Return a column-table cell using only one column retrieval, mapping an undefined reference
to the undefined cell marker. This function is important for the performance since the
column lookup is dynamic and happens once per data cell.
"""
function _get_data_cell(data::ColumnTable, i::Int, j::Int)
    col = Tables.getcolumn(data.table, data.column_names[j])

    # If the column is a `Tuple`, all the elements are defined.
    (col isa Tuple) && return col[i]

    return isassigned(col, i) ? col[i] : _UNDEFINED_CELL
end

"""
    _get_data_cell(data::RowTable, i::Int, j::Int) -> Any

Return a row-table cell using one retrieval, mapping an undefined reference to the undefined
cell marker.
"""
function _get_data_cell(data::RowTable, i::Int, j::Int)
    try
        return getindex(data, i, j)
    catch e
        e isa UndefRefError && return _UNDEFINED_CELL
        rethrow()
    end
end

"""
    _current_cell(action::Symbol, state::PrintingTableState, table_data::TableData) -> Any

Return the current data specified by the `action` and the current printing table `state` of
`table_data`.
"""
function _current_cell(action::Symbol, state::PrintingTableState, table_data::TableData)
    if action == :title
        return table_data.title

    elseif action == :subtitle
        return table_data.subtitle

    elseif action == :row_number_label
        # We should not print anything if we are not at the first line of column labels.
        if state.i == 1
            return table_data.row_number_column_label
        else
            return ""
        end

    elseif action == :row_number
        return state.i - 1 + table_data.first_row_index

    elseif action == :summary_row_number
        return ""

    elseif action == :stubhead_label
        # We should not print anything if we are not at the first line of column labels.
        if state.i == 1
            return table_data.stubhead_label
        else
            return ""
        end

    elseif action == :row_group_label
        for g in table_data.row_group_labels
            g.first == state.i && return g.second
        end

        return ""

    elseif action == :row_label
        rl = table_data.row_labels
        return isnothing(rl) ? "" : rl[state.i - 1 + begin]

    elseif action == :summary_row_label
        return table_data.summary_row_labels[state.i - 1 + begin]

    elseif action == :column_label
        # Check if this cell must be merged or if it is part of a merged cell.
        if !isnothing(table_data.merge_column_label_cells)
            for mc in table_data.merge_column_label_cells
                if (mc.i == state.i)
                    if (mc.j == state.j)
                        return mc
                    elseif (mc.j <= state.j <= mc.j + mc.column_span - 1)
                        return _IGNORE_CELL
                    end
                end
            end
        end

        return table_data.column_labels[state.i - 1 + begin][state.j - 1 + begin]

    elseif action == :data
        i₀ = table_data.first_row_index
        j₀ = table_data.first_column_index

        cell_data = _get_data_cell(table_data.data, state.i - 1 + i₀, state.j - 1 + j₀)

        if !isnothing(table_data.formatters)
            for f in table_data.formatters
                cell_data = f(cell_data, state.i, state.j)
            end
        end

        return cell_data

    elseif action == :summary_row_cell
        f = table_data.summary_rows[state.i - 1 + begin]

        # The printing state column index is always 1-based, whereas the data can have an
        # arbitrary column axis. Hence, we must offset it exactly like the `:data` action
        # does. Otherwise, the summary would be computed from the wrong source column.
        j₀ = table_data.first_column_index

        col = @views table_data.data[:, state.j - 1 + j₀]

        applicable(f, col) && return f(col)

        return f(table_data.data, state.j - 1 + j₀)

    elseif action == :footnote
        return table_data.footnotes[state.i - 1 + begin].second

    elseif action == :source_notes
        return table_data.source_notes

    elseif action == :empty_cell
        return ""

    else
        throw(ArgumentError("Invalid action found: `$action`!"))
    end
end

"""
    _current_cell_footnotes(
        table_data::TableData,
        cell_type::Symbol,
        i::Int,
        j::Int
    ) -> Union{Nothing, Vector{Int}}

Return the ordered footnote indices for the `cell_type` at `(i, j)`, or `nothing` if there
are no matches.
"""
function _current_cell_footnotes(table_data::TableData, cell_type::Symbol, i::Int, j::Int)
    isnothing(table_data.footnotes) && return nothing

    current_footnotes = nothing

    for k in 1:length(table_data.footnotes)
        f, _ = table_data.footnotes[k - 1 + begin]
        ct, fi, fj = f

        if (ct == cell_type) && (fi == i)
            if (
                # Cell types that only require testing the row index.
                (ct ∈ (:title, :subtitle, :row_number, :row_label, :summary_row_label)) ||
                (fj == j)
            )
                if isnothing(current_footnotes)
                    current_footnotes = Int[k]
                else
                    push!(current_footnotes, k)
                end
            end
        end
    end

    return current_footnotes
end

## Description #############################################################################
#
# HTML Back End: Issues.
#
############################################################################################

@testset "Issues" verbose = true begin
    @testset "StyledStrings Support" begin
        A = [
            (1, 1)                          styled"({red:2}, {blue:3})"
            styled"({green:2}, {yellow:3})" "(2, 4)"
        ]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;"><Column 1></th>
      <th style = "font-weight: bold; text-align: right;"><Column 2></th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(2, 3)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">(2, 3)</td>
      <td style = "text-align: right;">(2, 4)</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            A;
            backend       = :html,
            column_labels = [styled"<{red:Column 1}>", "<Column 2>"],
        )

        @test result == expected

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">&lt;<span style="color: #a51c2c">Column 1</span>&gt;</th>
      <th style = "font-weight: bold; text-align: right;">&lt;Column 2&gt;</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(<span style="color: #a51c2c">2</span>, <span style="color: #195eb3">3</span>)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">(<span style="color: #25a268">2</span>, <span style="color: #e5a509">3</span>)</td>
      <td style = "text-align: right;">(2, 4)</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            A;
            backend       = :html,
            column_labels = [styled"<{red:Column 1}>", "<Column 2>"],
            renderer      = :show,
        )
    end
end

module PrettyTablesExcelExt

using PrettyTables
using XLSX

# Import the functions we're overriding.
import PrettyTables: _excel__print, _is_horizontally_cropped, pretty_table

# Import types we need.
using PrettyTables: PrintingSpec, RenderContext, TableData, PrintingTableState, MergeCells

# Import internal iterator and helpers.
import PrettyTables: _next, _current_cell, _current_cell_alignment, _current_cell_footnotes
import PrettyTables: _number_of_printed_columns, _number_of_printed_data_columns
import PrettyTables: _get_data, _has_summary_rows
import PrettyTables: _IGNORE_CELL, _EXCEL__NO_DECORATION, _sprint_with_context

# Also import Tables.jl for handling table data
using Tables

############################################################################################
#                                         Includes                                         #
############################################################################################

include("helpers.jl")
include("render_cell.jl")
include("write_table.jl")

############################################################################################
#                                        Functions                                         #
############################################################################################

"""
    _excel__print(pspec::PrintingSpec; kwargs...) -> Union{Nothing, String, XLSX.XLSXFile}

Write the table described by `pspec` to an Excel workbook. All other keyword arguments are
passed through to `_excel__write_table!`.

# Keywords

- `anchor_cell::String`: Top-left cell of the table in A1 notation, allowing placement
    anywhere on the sheet.
    (**Default**: `"A1"`)
- `filename::Union{Nothing, String}`: Path of the Excel file to write. When `nothing`, no
    file is created and an in-memory `XLSX.XLSXFile` is returned instead. When a string,
    behavior depends on `mode`.
    (**Default**: `nothing`)
- `sheet::Union{String, XLSX.Worksheet}`: When a `String`, the name of the worksheet tab.
    If no sheet with that name exists it will be created. When an `XLSX.Worksheet`, that
    worksheet is updated in place and `nothing` is returned.
    (**Default**: `"prettytable"`)
- `mode::String`: `"w"` to create a new file, `"rw"` to open and update an existing one,
    or `"wr"` as an alias for `"rw"`.
    (**Default**: `"w"`)
- `overwrite::Bool`: Allow overwriting an existing file when `mode = "w"`.
    (**Default**: `false`)

# Returns

- `nothing` when `sheet` is an `XLSX.Worksheet` (the worksheet is updated in place).
- `XLSX.XLSXFile` when `filename` is `nothing` and `sheet` is a `String`.
- `String` (the filename) when `filename` is a `String` and `mode = "w"`.
- `XLSX.XLSXFile` when `filename` is a `String` and `mode = "rw"` (or `"wr"`).

!!! note

    Save a returned `XLSX.XLSXFile` using `XLSX.writexlsx` or `XLSX.savexlsx`.
"""
function PrettyTables._excel__print(
    pspec::PrintingSpec;
    anchor_cell::String = "A1",
    filename::Union{Nothing, String} = nothing,
    mode::String = "w",
    overwrite::Bool = false,
    sheet::Union{String, XLSX.Worksheet} = "prettytable",
    kwargs...,
)
    if isnothing(filename)
        if sheet isa String
            # Return in-memory XLSX object.
            xf = XLSX.newxlsx()
            sh = xf[1]
            sheet == sh.name || XLSX.renamesheet!(sh, sheet)

            _excel__write_table!(sh, pspec; anchor_cell, kwargs...)

            return xf
        end

        _excel__write_table!(sheet, pspec; anchor_cell, kwargs...)
        return nothing
    end

    # Check arguments.
    mode ∉ ["w", "rw", "wr"] && throw(
        ArgumentError(
            "Invalid mode \"$mode\". Must be either \"w\" to create a new file, or \"rw\" (or its alias \"wr\") to add a PrettyTable to an existing spreadsheet.",
        ),
    )

    sheet isa XLSX.Worksheet && throw(
        ArgumentError(
            "Can't specify both `filename` and an `XLSX.worksheet`. Either the `sheet` argument must be a `String` name of the worksheet to write to, not an `XLSX.Worksheet` object or the filename must be `nothing`.",
        ),
    )

    if mode == "w"
        # Write the PrettyTable to a new `xlsx` file.
        (!overwrite && isfile(filename)) &&
            error("File \"$filename\" already exists and `overwrite = false`.")

        XLSX.openxlsx(filename; mode = "w") do xf
            sh = xf[1]
            sheet == sh.name || XLSX.renamesheet!(sh, sheet)

            _excel__write_table!(sh, pspec; anchor_cell, kwargs...)
        end

        return filename
    end

    # If we reach this point, we know that `mode` is "rw" and `filename` is not `nothing`,
    # so we can open the file and write to it.
    xf = XLSX.opentemplate(filename)
    XLSX.hassheet(xf, sheet) || XLSX.addsheet!(xf, sheet)
    sh = xf[sheet]

    _excel__write_table!(sh, pspec; anchor_cell, kwargs...)

    # Returning xf forces the user to save using XLSX.writexlsx, reducing the risk of
    # accidentally overwriting data.
    return xf
end

"""
    pretty_table(::Type{XLSX.XLSXFile}, data::Any; kwargs...) -> XLSX.XLSXFile

Render `data` as a PrettyTable and return an in-memory `XLSX.XLSXFile` object. All keyword
arguments are forwarded to `pretty_table`.

# Examples

```julia
julia> using PrettyTables, XLSX

julia> xf = pretty_table(XLSX.XLSXFile, [1 2 3; 4 5 6]; backend = :excel)

julia> XLSX.writexlsx("myfile.xlsx", xf)
```
"""
function pretty_table(::Type{XLSX.XLSXFile}, @nospecialize(data::Any); kwargs...)
    # Force `backend` to `:excel` and `filename` to `nothing`.
    #
    # NOTE: The overrides must be stripped from the user keywords first and then placed
    # **last**. When keywords are splatted, the rightmost binding wins, so a user-supplied
    # `filename` used to override the `nothing` here and write a file, contradicting both the
    # documentation and this comment.
    kw = Base.structdiff(NamedTuple(kwargs), NamedTuple{(:filename, :backend)})

    return pretty_table(data; kw..., backend = :excel, filename = nothing)
end

############################################################################################
#                                     Precompilation                                       #
############################################################################################

include("precompile.jl")

end # module

## Description #############################################################################
#
# Excel Back End: Test excel_formatters
#
############################################################################################

@testset "Excel Formatters" verbose = true begin

    # == Numeric and Date Formatters =======================================================

    @testset "Numeric Formatters" verbose = true begin
        matrix = [
            π π π π
            π π π π
        ]

        # The Excel rows are laid out as follows:
        #
        #   Row 1: column labels
        #   Row 2: data row 1     (data row index 1)
        #   Row 3: data row 2     (data row index 2)
        #   Row 4: summary row 1  (summary row index 1)
        #   Row 5: summary row 2  (summary row index 2)
        #
        # A `:data` formatter (the default) matches the data row index (`i ∈ {1, 2}`),
        # whereas a `:summary_row` formatter matches the summary row index (`i ∈ {1, 2}`),
        # NOT the Excel row index. Using two summary rows ensures we are indexing by the
        # summary row, not by the absolute Excel row (which would be 4 and 5).
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                # `:data` region matching a specific data row index.
                ExcelFormatter((v, i, j) -> (i == 2), ["format" => "0.00"])
                # `:summary_row` region matching the summary row index.
                ExcelFormatter(
                    (v, i, j) -> (i == 1), ["format" => "0.00000"]; region = :summary_row
                )
                ExcelFormatter(
                    (v, i, j) -> (i == 2), ["format" => "0.000"]; region = :summary_row
                )
                # `:data` region matching by column.
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "#,##0_0_0"])
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "#,##0.??_0_0"])
                ExcelFormatter((v, i, j) -> (j == 3), ["format" => "#,##0.???"])
                ExcelFormatter((v, i, j) -> (j == 4), ["format" => "0_0_0_0"])
            ],
            summary_row_labels = ["Maximum", "Minimum"],
            summary_rows = [
                (data, i) -> maximum(@views data[1:2, i]),
                (data, i) -> minimum(@views data[1:2, i]),
            ],
        )

        # Data row 1 (Excel row 2): matched by the column formatters.
        @test XLSX.getFormat(result[1], "B2").format["numFmt"]["formatCode"] == "#,##0_0_0"
        @test XLSX.getFormat(result[1], "C2").format["numFmt"]["formatCode"] ==
            "#,##0.??_0_0"
        @test XLSX.getFormat(result[1], "D2").format["numFmt"]["formatCode"] == "#,##0.???"
        @test XLSX.getFormat(result[1], "E2").format["numFmt"]["formatCode"] == "0_0_0_0"

        # Data row 2 (Excel row 3): matched by the `:data` formatter `i == 2`, which takes
        # precedence over the column formatters because it appears first.
        @test XLSX.getFormat(result[1], "B3").format["numFmt"]["formatCode"] == "0.00"
        @test XLSX.getFormat(result[1], "E3").format["numFmt"]["formatCode"] == "0.00"

        # Summary row 1 (Excel row 4): matched by the `:summary_row` formatter `i == 1`. The
        # `:data` column formatters must NOT leak into the summary rows.
        @test XLSX.getFormat(result[1], "B4").format["numFmt"]["formatCode"] == "0.00000"
        @test XLSX.getFormat(result[1], "D4").format["numFmt"]["formatCode"] == "0.00000"

        # Summary row 2 (Excel row 5): matched by the `:summary_row` formatter `i == 2`,
        # confirming the index is the summary row index and not the Excel row index.
        @test XLSX.getFormat(result[1], "B5").format["numFmt"]["formatCode"] == "0.000"
        @test XLSX.getFormat(result[1], "D5").format["numFmt"]["formatCode"] == "0.000"
    end

    # == Predicate receives the entire data matrix =======================================

    @testset "Predicate receives the data matrix" verbose = true begin
        # The `ExcelFormatter` predicate signature is `f(data, i, j)`, where the first
        # argument is the entire data matrix passed to `pretty_table`. The predicate can
        # therefore index into `data` to express conditions on the cell value.
        matrix = [
            1 2 3
            4 5 6
            7 8 9
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                ExcelFormatter((data, i, j) -> (data[i, j] > 5), ["format" => "0.00"])
            ],
        )

        # Cells whose value exceeds 5 are: (2,3) = 6 and (3,*) = {7,8,9}. Excel rows are
        # one header row plus the data rows, so the matched cells sit at C3, A4, B4, C4.
        @test XLSX.getFormat(result[1], "C3").format["numFmt"]["formatCode"] == "0.00"
        @test XLSX.getFormat(result[1], "A4").format["numFmt"]["formatCode"] == "0.00"
        @test XLSX.getFormat(result[1], "B4").format["numFmt"]["formatCode"] == "0.00"
        @test XLSX.getFormat(result[1], "C4").format["numFmt"]["formatCode"] == "0.00"
        # Cells whose value does not exceed 5 must keep the default "General" format.
        @test XLSX.getFormat(result[1], "A2").format["numFmt"]["formatCode"] == "General"
        @test XLSX.getFormat(result[1], "B2").format["numFmt"]["formatCode"] == "General"
        @test XLSX.getFormat(result[1], "C2").format["numFmt"]["formatCode"] == "General"
    end

    # == Formats Must Survive the Cell Value Assignment ====================================

    @testset "Formats Survive the Value Assignment" verbose = true begin
        # Assigning an `Int64` or `Float64` value to a cell resets its number format to
        # "General" unless XLSX.jl considers the current format float-like (e.g. "0.00").
        # Hence, the formatters must be applied only after the rendered cell is assigned to
        # the sheet (see issue #318). This regression requires numeric data cells together
        # with integer-like formats because string cells never reset the format and
        # float-like formats survive the assignment.
        matrix = Any[
            1000000.3 5
            2000000.5 10
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                # Integer-like format on a `Float64` column.
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "#,##0"])
                # Integer-like format on an `Int64` column.
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "#,##0_0"])
                # Integer-like format on the summary row, whose cells are also numeric.
                ExcelFormatter(
                    (v, i, j) -> true, ["format" => "#,##0"]; region = :summary_row
                )
            ],
            summary_row_labels = ["Total"],
            summary_rows = [(data, i) -> sum(@views data[:, i])],
        )

        # Data rows (Excel rows 2 and 3).
        @test XLSX.getFormat(result[1], "B2").format["numFmt"]["formatCode"] == "#,##0"
        @test XLSX.getFormat(result[1], "B3").format["numFmt"]["formatCode"] == "#,##0"
        @test XLSX.getFormat(result[1], "C2").format["numFmt"]["formatCode"] == "#,##0_0"
        @test XLSX.getFormat(result[1], "C3").format["numFmt"]["formatCode"] == "#,##0_0"

        # Summary row (Excel row 4).
        @test XLSX.getFormat(result[1], "B4").format["numFmt"]["formatCode"] == "#,##0"
        @test XLSX.getFormat(result[1], "C4").format["numFmt"]["formatCode"] == "#,##0"
    end

    @testset "Issue 318 Reproduction" verbose = true begin
        # Mirror the reproduction in issue #318, which uses a column table with `Float64`
        # columns and both integer-like and float-like formats.
        table = (
            CMA                   = ["CMA1", "CMA2", "CMA3", "CMA4"],
            Constituents          = [5, 10, 15, 20],
            Total_amount          = [1000000.3, 2000000.5, 3000000.7, 4000001.9],
            Total_Population      = [50000.7, 100000.5, 150000.3, 200000.1],
            Per_Capita            = [20.2, 20.3, 20.5, 20.6],
            Multiple_UK_PerCapita = [1.0, 1.2, 1.4, 1.6],
        )

        result = pretty_table(
            XLSX.XLSXFile,
            table;
            excel_formatters = [
                ExcelFormatter((v, i, j) -> (j == 3), ["format" => "#,##0"])
                ExcelFormatter((v, i, j) -> (j == 4), ["format" => "#,##0.0"])
                ExcelFormatter((v, i, j) -> (j == 5), ["format" => "#,##0"])
                ExcelFormatter((v, i, j) -> (j == 6), ["format" => "#,##0.00"])
            ],
        )

        # Column tables render two column label rows (the column names and the column
        # types), so the data cells start at the third Excel row.
        for row in 3:6
            @test XLSX.getFormat(result[1], "C$row").format["numFmt"]["formatCode"] ==
                "#,##0"
            @test XLSX.getFormat(result[1], "D$row").format["numFmt"]["formatCode"] ==
                "#,##0.0"
            @test XLSX.getFormat(result[1], "E$row").format["numFmt"]["formatCode"] ==
                "#,##0"
            @test XLSX.getFormat(result[1], "F$row").format["numFmt"]["formatCode"] ==
                "#,##0.00"
        end

        # Columns without a matching formatter must keep the default "General" format.
        @test XLSX.getFormat(result[1], "A3").format["numFmt"]["formatCode"] == "General"
        @test XLSX.getFormat(result[1], "B3").format["numFmt"]["formatCode"] == "General"
    end

    # == Numeric Format Codes ==============================================================

    @testset "Numeric Format Codes" verbose = true begin
        # Purely numeric format strings must reach `XLSX.setFormat` as strings, where they
        # select a format code like "0" or a built-in format ID like "39". Parsing them to
        # `Int`, as done with the other attributes, makes `XLSX.setFormat` throw.
        matrix = [
            1234.5 1234.5
            1234.5 1234.5
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                # The format code "0" must be applied verbatim.
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "0"])
                # The format "39" selects the built-in format ID 39.
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "39"])
            ],
        )

        @test XLSX.getFormat(result[1], "A2").format["numFmt"]["formatCode"] == "0"
        @test XLSX.getFormat(result[1], "A3").format["numFmt"]["formatCode"] == "0"
        @test XLSX.getFormat(result[1], "B2").format["numFmt"]["formatCode"] ==
            "#,##0.00_);(#,##0.00)"
        @test XLSX.getFormat(result[1], "B3").format["numFmt"]["formatCode"] ==
            "#,##0.00_);(#,##0.00)"
    end

    # == Region Field and Constructors =====================================================
    @testset "Region Field and Constructors" verbose = true begin
        # The default region must be `:data`.
        f = ExcelFormatter((v, i, j) -> true, ["format" => "0.00"])
        @test f.region === :data

        # The region can be set explicitly.
        f = ExcelFormatter((v, i, j) -> true, ["format" => "0.00"]; region = :summary_row)
        @test f.region === :summary_row

        # An invalid region must throw.
        @test_throws ArgumentError ExcelFormatter(
            (v, i, j) -> true, ["format" => "0.00"]; region = :invalid
        )
    end

    # == Date Formatters ===================================================================

    @testset "Date Formatters" verbose = true begin
        now = Dates.now()
        matrix = [
            now now now now
            now now now now
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
                ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
                ExcelFormatter(
                    (v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"]
                )
            ],
            data_column_widths = [12.0, 16.0, 8.0, 20.0],
        )

        @test XLSX.getFormat(result[1], "A2").format["numFmt"]["formatCode"] == "m/d/yyyy"
        @test XLSX.getFormat(result[1], "B2").format["numFmt"]["formatCode"] ==
            "d mmmm yyyy"
        @test XLSX.getFormat(result[1], "C2").format["numFmt"]["formatCode"] == "hh:mm"
        @test XLSX.getFormat(result[1], "D2").format["numFmt"]["formatCode"] ==
            "yyyy-mm-dd\"T\"hh:mm:ss"
    end
end

## Description #############################################################################
#
# Private functions for the LaTeX back end.
#
############################################################################################

# == Strings ===============================================================================

"""
    _latex__alignment_to_str(a::Symbol) -> String

Convert the alignment `a` to the corresponding string for LaTeX.
"""
function _latex__alignment_to_str(a::Symbol)
    return if a ∈ (:l, :L)
        "l"
    elseif a ∈ (:c, :C)
        "c"
    else
        "r"
    end
end

"""
    _latex__add_environments(str::String, envs::Union{Nothing, Vector{String}}) -> String

Apply the latex environments in `envs` to the string `str`. If `envs` is `nothing`, it
returns `str` unchanged.
"""
function _latex__add_environments(str::String, envs::Vector{String})
    # Do not apply any environment if the string is empty.
    isempty(str) && return str

    for env in envs
        str = "\\$env{$str}"
    end

    return str
end

_latex__add_environments(s::String, ::Nothing) = s

raw"""
    _latex__escape_str(io::IO, s::AbstractString, esc::String = "") -> Nothing
    _latex__escape_str(s::AbstractString, esc::String = "") -> String

Print the string `s` in `io` escaping the characters for the LaTeX back end. If `io` is
omitted, the escaped string is returned.

Every character in `esc` is escaped by prefixing it with a backslash. On top of that, the
LaTeX metacharacters `%`, `#`, `$`, `&`, `_`, `{`, and `}` are escaped, `^` and `~` are
replaced by `\textasciicircum{}` and `\textasciitilde{}`, and the backslash itself is
replaced by `\textbackslash{}`. Control and non-printable characters are emitted using a
`\textbackslash{}x`, `\textbackslash{}u`, or `\textbackslash{}U` sequence.

Notice that `<`, `>`, `"`, and `'` are **not** escaped. Under the OT1 font encoding, `<` and
`>` are typeset as `¡` and `¿`.
"""
function _latex__escape_str(io::IO, s::AbstractString, esc::String = "")
    a = Iterators.Stateful(s)
    for c in a
        if c in esc
            print(io, '\\', c)
        elseif isascii(c)
            c == '\0'         ? print(io, "\\textbackslash{}0") :
            c == '\e'         ? print(io, "\\textbackslash{}e") :
            c == '\\'         ? print(io, "\\textbackslash{}") :
            '\a' <= c <= '\r' ? print(io, "\\textbackslash{}", "abtnvfr"[Int(c) - 6]) :
            c == '%'          ? print(io, "\\%") :
            c == '#'          ? print(io, "\\#") :
            c == '\$'         ? print(io, "\\\$") :
            c == '&'          ? print(io, "\\&") :
            c == '_'          ? print(io, "\\_") :
            c == '^'          ? print(io, "\\textasciicircum{}") :
            c == '{'          ? print(io, "\\{") :
            c == '}'          ? print(io, "\\}") :
            c == '~'          ? print(io, "\\textasciitilde{}") :
            isprint(c)        ? print(io, c) :
            print(io, "\\textbackslash{}x", string(UInt32(c); base = 16, pad = 2))
        elseif !Base.isoverlong(c) && !Base.ismalformed(c)
            isprint(c)    ? print(io, c) :
            c <= '\x7f'   ? print(io, "\\textbackslash{}x", string(UInt32(c); base = 16, pad = 2)) :
            c <= '\uffff' ? print(io, "\\textbackslash{}u", string(UInt32(c); base = 16, pad = Base.need_full_hex(peek(a)) ? 4 : 2)) :
            print(io, "\\textbackslash{}U", string(UInt32(c); base = 16, pad = Base.need_full_hex(peek(a)) ? 8 : 4))
        else # malformed or overlong
            u = bswap(reinterpret(UInt32, c))
            while true
                print(io, "\\textbackslash{}x", string(u % UInt8; base = 16, pad = 2))
                (u >>= 8) == 0 && break
            end
        end
    end
end

function _latex__escape_str(s::AbstractString, esc::String = "")
    return sprint(_latex__escape_str, s, esc; sizehint = lastindex(s))
end

# == Table =================================================================================

"""
    _latex__table_header_description(td::TableData, tf::LatexTableFormat, vertical_lines_at_data_columns::AbstractVector{Int}) -> String

Create the LaTeX table header description with the column alignments and vertical lines
considering the table data `td`, table format `tf`, and the processed information about
vertical lines at data columns `vertical_lines_at_data_columns`.
"""
function _latex__table_header_description(
    td::TableData, tf::LatexTableFormat, vertical_lines_at_data_columns::AbstractVector{Int}
)
    num_columns = td.num_columns

    desc = IOBuffer(; sizehint = 2num_columns + 3)

    # == Table Beginning ===================================================================

    tf.vertical_line_at_beginning && print(desc, '|')

    # == Row Number Column =================================================================

    if td.show_row_number_column
        print(desc, _row_number_column_alignment(td) |> _latex__alignment_to_str)

        if tf.vertical_line_after_row_number_column
            print(desc, '|')
        end
    end

    # == Row Labels ========================================================================

    if _has_row_labels(td)
        print(desc, _row_label_column_alignment(td) |> _latex__alignment_to_str)
        tf.vertical_line_after_row_label_column && print(desc, '|')
    end

    # == Data Columns ======================================================================

    nc = _number_of_printed_data_columns(td)

    for i in 1:nc
        print(desc, _data_column_alignment(td, i) |> _latex__alignment_to_str)

        vline = i in vertical_lines_at_data_columns

        if (i == nc) && tf.vertical_line_after_data_columns
            vline = true
        end

        vline && print(desc, '|')
    end

    # == Continuation Column ===============================================================

    if nc < num_columns
        print(desc, 'c')
        tf.vertical_line_after_continuation_column && print(desc, '|')
    end

    return String(take!(desc))
end

## Description #############################################################################
#
# Excel Back End: Documentation for the Excel backend.
#
############################################################################################

"""
# Excel Backend

The Excel backend can be selected by passing the keyword `backend = :excel` to the function
[`pretty_table`](@ref). This will allow you to create a pretty table in a newly created
Excel file or to add a pretty table to a new or existing sheet in an existing Excel file.

The Excel backend's return value depends on the following combination of keywords:

- `nothing` when `sheet` is an `XLSX.Worksheet` (the worksheet is updated in place).
- `XLSX.XLSXFile` when `filename` is `nothing` and `sheet` is a `String`.
- `String` (the filename) when `filename` is a `String` and `mode = "w"`.
- `XLSX.XLSXFile` when `filename` is a `String` and `mode = "rw"`.

!!! note

    This backend uses the functions of [XLSX.jl](https://github.com/felipenoris/XLSX.jl),
    particularly the functions `setFont`, `setFill`, `setBorder` and `setFormat`. For more
    information, refer to the documentation of this package.

## Keywords

- `anchor_cell::String`: Top-left cell of the table in A1 notation (e.g. `"B3"`).
    (**Default**: `"A1"`)
- `data_column_widths::Union{Float64, Vector{Float64}}`: Explicit width for each data column
    in Excel units, overriding auto-calculated widths. A scalar applies to all columns; a
    vector sets per-column widths. When set (> 0), `minimum_data_column_widths` and
    `maximum_data_column_widths` are ignored for that column.
    (**Default**: `0.0`)
- `excel_formatters::Vector{ExcelFormatter}`: Number-format rules applied to data and
    summary cells.
    (**Default**: `ExcelFormatter[]`)
- `filename::Union{Nothing, String}`: Path of the Excel file to write. When `nothing`, no
    file is created and an in-memory `XLSX.XLSXFile` is returned instead. When a string,
    behaviour depends on `mode`.
    (**Default**: `nothing`)
- `highlighters::Vector{ExcelHighlighter}`: Highlighters to apply to the table. For more
    information, see the section **Excel Highlighters** in the **Extended Help**.
- `maximum_data_column_widths::Union{Float64, Vector{Float64}}`: Maximum width for each
    data column in Excel units. A scalar applies to all columns; a vector sets per-column
    maximums.
    (**Default**: `0.0`)
- `minimum_data_column_widths::Union{Float64, Vector{Float64}}`: Minimum width for each
    data column in Excel units. A scalar applies to all columns; a vector sets per-column
    minimums.
    (**Default**: `0.0`)
- `mode::String`: `"w"` to create a new file or `"rw"` (or its alias `"wr"`) to open and
    update an existing one.
    (**Default**: `"w"`)
- `overwrite::Bool`: Allow overwriting an existing file when `mode = "w"`.
    (**Default**: `false`)
- `sheet::Union{String, XLSX.Worksheet}`: When a `String`, the name of the worksheet tab.
    If no sheet with that name exists it will be created. When an `XLSX.Worksheet`, that
    worksheet is updated in place and `nothing` is returned.
    (**Default**: `"prettytable"`)
- `style::ExcelTableStyle`: Style of the table. For more information, see the section
    **Excel Table Style** in the **Extended Help**.
- `table_format::ExcelTableFormat`: Excel table format used to render the table. For more
    information, see the section **Excel Table Format** in the **Extended Help**.

# Extended Help

## Excel Highlighters

A set of highlighters can be passed as a `Vector{ExcelHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`ExcelHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)`, which should return `true`
  if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
  highlighter. This function must return a `Vector{ExcelPair}` with the styling attributes
  to apply to the highlighted cell.

An Excel highlighter can be constructed using the following helpers:

```julia
ExcelHighlighter(f::Function, decoration::ExcelPair)
ExcelHighlighter(f::Function, decoration::Vector{ExcelPair})
ExcelHighlighter(f::Function, fd::Function)
```

The decoration uses the same `Vector{ExcelPair}` format as `ExcelTableStyle` fields.
Font attributes are specified directly; fill attributes use the `"cell_fill_"` key prefix
(stripped before calling `XLSX.setFill`). Border attributes are not supported.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells in the third data column with a value greater
than 10 in red with a grey fill, and those in the fourth column in blue:

```julia
highlighters = [
    ExcelHighlighter((data, i, j) -> (j == 3) && (data[i, j] > 10), [
        "color" => "red", "bold" => "true",
        "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "grey90",
    ]),
    ExcelHighlighter((data, i, j) -> (j == 4) && (data[i, j] > 10),
        ["color" => "blue", "bold" => "true"],
    ),
]
```

## Excel Formatters

It is possible to apply a set of native Excel formats by passing a `Vector{ExcelFormatter}`
to the `excel_formatters` keyword. Each Excel formatter is an instance of the structure
[`ExcelFormatter`](@ref).

The first formatter (in the order they are specified) that satisfies the specified condition
in the given table cell is applied, and the remainder of the formatters in the list are
skipped. If none matches, no `ExcelFormatter` is applied.

By default, an `ExcelFormatter` matches the **data cells** and the value of `i` passed to
its function is the data row index. An `ExcelFormatter` can be applied in the summary row,
too, by setting the keyword `region = :summary_row`. In this case, the value of `i` relates
to the summary row index (`1` for the first summary row, `2` for the second, and so on),
rather than the data table row. The value of `j` has the same meaning/values (column
specifier) as in the data table itself.

Excel formatters may be applied in addition to the standard formatters. The standard
formatters control the literal values written to Excel while the Excel formatters control
how Excel displays the literal cell values.

For example, to apply Excel-native formatting to different columns of a table:

```julia
excel_formatters = [
    ExcelFormatter((v, i, j) -> (j==1), ["format" => "#,##0_0_0"])
    ExcelFormatter((v, i, j) -> (j==2), ["format" => "#,##0.??_0_0"])
    ExcelFormatter((v, i, j) -> (j==3), ["format" => "#,##0.???"])
    ExcelFormatter((v, i, j) -> (j==4), ["format" => "0_0_0_0"])
]
```

Excel formatters apply native Excel formatting to native Excel values. However,
`PrettyTables.jl` can handle Julia types that can't be represented natively in Excel. If
these are passed natively, then XLSX.jl will fail. To circumvent this, a predefined
formatter has been provided which converts any unhandled types to strings (using
`string()`). For more information, see [`fmt__excel_stringify`](@ref).

## Excel Table Format

The Excel table format is defined using an object of type [`ExcelTableFormat`](@ref) that
contains the following fields:

- `borders::ExcelTableBorders`: Border style configuration (see below).
- `horizontal_line_at_beginning::Bool`: Draw a horizontal line at the first table row after
    the title/subtitle section (i.e., the top of the column labels or the first data row).
    Title and subtitle rows are never bordered.
- `horizontal_line_after_column_labels::Bool`: Draw a line under the column header section.
- `horizontal_line_between_column_labels::Bool`: Draw a line between column header rows.
- `horizontal_line_at_merged_column_labels::Bool`: Draw a line under merged column headers.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: Draw underlines after data
    rows. `:all` draws after every row, `:none` draws none, a `Vector{Int}` draws only after
    the specified row indices (e.g., `[1, 3]` draws after rows 1 and 3).
- `horizontal_line_after_data_rows::Bool`: Draw a line under the data table section.
- `horizontal_line_before_row_group_label::Bool`: Draw a line above each row group divider.
- `horizontal_line_after_row_group_label::Bool`: Draw a line below each row group divider.
- `horizontal_line_before_summary_rows::Bool`: Draw a line between the data rows and the
    summary rows.
- `horizontal_line_after_summary_rows::Bool`: Draw a line under the last summary row.
- `vertical_line_at_beginning::Bool`: Draw a vertical line on the left side of the content
    area (excludes title/subtitle and footnotes).
- `vertical_line_after_row_number_column::Bool`: Draw a vertical line after the row number
    column.
- `vertical_line_after_row_label_column::Bool`: Draw a vertical line after the row label
    column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: Draw dividers between data
    columns. `:all` draws after every column, `:none` draws none, a `Vector{Int}` draws only
    after the specified column indices (e.g., `[1, 3]` draws after columns 1 and 3).
- `vertical_line_after_data_columns::Bool`: Draw a vertical line on the right side of the
    content area (excludes title/subtitle and footnotes).
- `vertical_line_after_continuation_column::Bool`: Draw a vertical line after the
    continuation column when the table is horizontally cropped.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@excel__all_horizontal_lines`](@ref).
- [`@excel__all_vertical_lines`](@ref).
- [`@excel__no_horizontal_lines`](@ref).
- [`@excel__no_vertical_lines`](@ref).

Border styles are specified using an [`ExcelTableBorders`](@ref) object with these fields:

**Horizontal lines:**

- `top_line`: Top of the outside border.
    (**Default**: thick black).
- `header_line`: Line drawn under the column label section.
    (**Default**: medium black).
- `merged_header_cell_line`: Line below merged header cells
    (**Default**: thin black).
- `middle_line`: All other internal horizontal lines — data row underlines, lines around
    row groups, lines around summary rows, between-header lines — and vertical lines
    between data columns.
    (**Default**: thin black).
- `bottom_line`: Bottom of the outside border
    (**Default**: thick black).

**Vertical lines:**

- `left_line`: Left of the outside border.
    (**Default**: thick black).
- `center_line`: Structural vertical lines — after row numbers and after row labels.
    (**Default**: thin black).
- `right_line`: Right of the outside border.
    (**Default**: thick black).

### Examples

Apply a preset:

```julia
table_format = ExcelTableFormat(; @excel__no_vertical_lines)
```

Apply a preset and override one of its fields. Notice that the keyword must come **after**
the macro, since the last binding wins:

```julia
table_format = ExcelTableFormat(;
    @excel__no_vertical_lines,
    vertical_line_at_beginning = true,
)
```

Draw section-separator lines in red:

```julia
table_format = ExcelTableFormat(;
    borders = ExcelTableBorders(; header_line = ["style" => "thin", "color" => "red"]),
)
```

To combine a preset with customized border styles:

```julia
table_format = ExcelTableFormat(;
    @excel__no_vertical_lines,
    borders = ExcelTableBorders(;
        header_line = ["style" => "thick", "color" => "red"],
        middle_line = ["style" => "thick", "color" => "red"],
    ),
)
```

When more than one preset is applied, they take effect in order, with the later ones taking
precedence. Any keyword argument provided after them takes precedence over all of them.

## Excel Table Style

The Excel table style is defined using an object of type [`ExcelTableStyle`](@ref) that
contains the following fields:

- `title::Vector{ExcelPair}`: Style for the title.
- `subtitle::Vector{ExcelPair}`: Style for the subtitle.
- `row_number_label::Vector{ExcelPair}`: Style for the row number label.
- `row_number::Vector{ExcelPair}`: Style for the row number.
- `stubhead_label::Vector{ExcelPair}`: Style for the stubhead label.
- `row_label::Vector{ExcelPair}`: Style for the row label.
- `row_group_label::Vector{ExcelPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}}`: Style for
    the first line of the column labels. If a vector of `Vector{ExcelPair}` is provided,
    each column label in the first line will use the corresponding style.
- `column_label::Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}}`: Style for the rest of
    the column labels. If a vector of `Vector{ExcelPair}` is provided, each column label
    will use the corresponding style.
- `first_line_merged_column_label::Vector{ExcelPair}`: Style for the merged cells at the
    first column label line.
- `merged_column_label::Vector{ExcelPair}`: Style for the merged cells at the rest of the
    column labels.
- `data_cell::Vector{ExcelPair}`: Style for the table cells.
- `summary_row_label::Vector{ExcelPair}`: Style for the summary row label.
- `summary_row_cell::Vector{ExcelPair}`: Style for the summary row cell.
- `footnote::Vector{ExcelPair}`: Style for the footnotes.
- `source_note::Vector{ExcelPair}`: Style for the source notes.

Each field corresponds to a table element and should be a vector of `ExcelPair`,
*i.e.* `Pair{String, String}`, describing properties and values compatible with the
`XLSX.setFont` function.

Fill (background color) attributes for a cell can also be included in the same field by
prefixing their keys with `"cell_fill_"`. Any pair whose key starts with `"cell_fill_"` is
routed to `XLSX.setFill` (with the prefix stripped) instead of `XLSX.setFont`. Font and
fill pairs may be mixed freely within a single field.

It is only necessary to define those fields for which the default style needs to be
overwritten. For example:

```julia
style = ExcelTableStyle(
    column_label                   = [["bold" => "true"], ["color" => "red"]], # assuming two columns
    summary_row_label              = ["size" => "8"],
    first_line_merged_column_label = ["bold" => "true", "color" => "orange"],
    footnote                       = ["italic" => "true", "color" => "cyan"],
    row_group_label                = ["bold" => "true", "color" => "magenta"],
    subtitle                       = ["italic" => "true"],
    title                          = ["bold" => "true", "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "black"],
)
```

"""
pretty_table_excel_backend

## Description #############################################################################
#
# HTML Back End: Tests related with the cell titles.
#
############################################################################################

@testset "Cell Titles" verbose = true begin
    @testset "Column Label Titles" begin
        matrix              = [(i, j) for i in 1:2, j in 1:4]
        column_labels       = [[(i, j) for j in 1:4] for i in 1:3]
        column_label_titles = [[1, 2, 3, 4], nothing, ["5", "6", "7", "8"]]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th title = "1" style = "font-weight: bold; text-align: right;">(1, 1)</th>
      <th title = "2" style = "font-weight: bold; text-align: right;">(1, 2)</th>
      <th title = "3" style = "font-weight: bold; text-align: right;">(1, 3)</th>
      <th title = "4" style = "font-weight: bold; text-align: right;">(1, 4)</th>
    </tr>
    <tr class = "columnLabelRow">
      <th style = "text-align: right;">(2, 1)</th>
      <th style = "text-align: right;">(2, 2)</th>
      <th style = "text-align: right;">(2, 3)</th>
      <th style = "text-align: right;">(2, 4)</th>
    </tr>
    <tr class = "columnLabelRow">
      <th title = "5" style = "text-align: right;">(3, 1)</th>
      <th title = "6" style = "text-align: right;">(3, 2)</th>
      <th title = "7" style = "text-align: right;">(3, 3)</th>
      <th title = "8" style = "text-align: right;">(3, 4)</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td style = "text-align: right;">(1, 4)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">(2, 1)</td>
      <td style = "text-align: right;">(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td style = "text-align: right;">(2, 4)</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend             = :html,
            column_labels       = column_labels,
            column_label_titles = column_label_titles,
        )

        @test result == expected
    end

    @testset "Errors" verbose = true begin
        matrix        = [(i, j) for i in 1:2, j in 1:4]
        column_labels = [[(i, j) for j in 1:4] for i in 1:3]

        column_label_titles = [[1, 2, 3, 4], ["5", "6", "7", "8"]]
        @test_throws Exception pretty_table(
            matrix;
            backend             = :html,
            column_labels       = column_labels,
            column_label_titles = column_label_titles,
        )

        column_label_titles = [[1, 2, 3, 4], nothing, ["5", "6", "7", "8", "9"]]
        @test_throws Exception pretty_table(
            matrix;
            backend             = :html,
            column_labels       = column_labels,
            column_label_titles = column_label_titles,
        )

        column_label_titles = [[1, 2, 3], nothing, ["5", "6", "7", "8"]]
        @test_throws Exception pretty_table(
            matrix;
            backend             = :html,
            column_labels       = column_labels,
            column_label_titles = column_label_titles,
        )
    end
end

## Description #############################################################################
#
# Functions related to display manipulation.
#
############################################################################################

"""
    _text__check_eol(display::Display) -> Bool

Check if the current column of the `display` is past the end of line.
"""
function _text__check_eol(display::Display)
    w = display.size[2]
    return (w > 0) && (display.column > display.size[2])
end

"""
    _text__print(display::Display, char::Char) -> Nothing

Print a single character `char` to the `display`.

Notice that this method must write the character directly instead of forwarding to the
`AbstractString` one. Otherwise, printing a table border would allocate one `String` per
vertical line per row.
"""
function _text__print(display::Display, char::Char)
    _text__check_eol(display) && return nothing
    print(display.buf_line, char)
    display.column += textwidth(char)
    return nothing
end

"""
    _text__print(display::Display, char::Char, n::Int) -> Nothing

Print the character `char` repeated `n` times to the `display`.

Notice that this method must write the characters directly instead of using `char^n`.
Otherwise, printing a horizontal line would allocate one `String` per table column.
"""
function _text__print(display::Display, char::Char, n::Int)
    _text__check_eol(display) && return nothing

    for _ in 1:n
        print(display.buf_line, char)
    end

    display.column += textwidth(char) * n
    return nothing
end

"""
    _text__print(display::Display, str::AbstractString, str_width::Int = -1) -> Nothing

Print a string `str` to the `display`, updating the column position. If `str_width` is
positive, it is used as the width of the printed string, reducing the computational burden.
Otherwise, the printable width of `str` is computed using `printable_textwidth`.
"""
function _text__print(display::Display, str::AbstractString, str_width::Int = -1)
    _text__check_eol(display) && return nothing
    print(display.buf_line, str)
    display.column += str_width < 0 ? printable_textwidth(str) : str_width
    return nothing
end

"""
    _text__styled_print(display::Display, char::Char, crayon::Crayon) -> Nothing

Print a single character `char` to the `display` with style given by the `crayon`.
"""
function _text__styled_print(display::Display, char::Char, crayon::Crayon)
    (!display.has_color || crayon == _TEXT__DEFAULT || crayon == _TEXT__EMPTY_CRAYON) &&
        return _text__print(display, char)

    _text__check_eol(display) && return nothing
    print(display.buf_line, string(crayon), char, _TEXT__STRING_RESET)
    display.column += textwidth(char)
    return nothing
end

"""
    _text__styled_print(display::Display, str::AbstractString, crayon::Crayon) -> Nothing

Print a string `str` to the `display` with the style given by the `crayon`.
"""
function _text__styled_print(display::Display, str::AbstractString, crayon::Crayon)
    (!display.has_color || crayon == _TEXT__DEFAULT || crayon == _TEXT__EMPTY_CRAYON) &&
        return _text__print(display, str)

    _text__check_eol(display) && return nothing
    print(display.buf_line, string(crayon), str, _TEXT__STRING_RESET)
    display.column += printable_textwidth(str)
    return nothing
end

"""
    _text__flush_line(
        display::Display,
        add_continuation_char::Bool = true,
        continuation_char::Char = '⋯';
        crop_line::Bool = true
    ) -> Nothing

Flush the current line buffer to the `display`, cropping and adding continuation characters
if needed.
"""
function _text__flush_line(
    display::Display,
    add_continuation_char::Bool = true,
    continuation_char::Char = '⋯';
    crop_line::Bool = true,
)
    dw   = display.size[2]
    line = String(take!(display.buf_line))

    if crop_line && (dw > 0) && (display.column > dw)
        str_width = printable_textwidth(line)

        crop = crop_width_to_fit_string_in_field(
            line,
            dw;
            add_continuation_char,
            add_space_in_continuation_char = add_continuation_char,
            continuation_char,
            printable_string_width = str_width,
        )

        if crop > 0
            cont_str = add_continuation_char ? (" " * string(continuation_char)) : ""

            cropped_str, ansi = right_crop(
                line, crop; keep_escape_seq = true, printable_string_width = str_width
            )

            line = cropped_str * String(parse_decoration(ansi)) * cont_str
        end
    end

    println(display.buf, rstrip(line))
    display.column = 0
    display.row += 1

    return nothing
end

"""
    _text__print_aligned(
        display::Display,
        str::AbstractString,
        cell_width::Int,
        alignment::Symbol,
        crayon::Crayon = _TEXT__DEFAULT,
        fill::Bool = true;
        kwargs...
    ) -> Nothing

Print a string `str` to the `display`, aligned according to `alignment` in a cell of width
`cell_width`. The string is printed with the style given by `crayon`. The `alignment` can be
`:l` (left), `:r` (right), or `:c` (center). If `fill` is `true`, the string is filled with
spaces to fit the cell width.

# Keywords

- `left_margin::Int`: Number of spaces to print before the aligned cell.
    (**Default**: 0)
- `right_margin::Int`: Number of spaces to print after the aligned cell.
    (**Default**: 0)

Notice that the margins are **not** part of `cell_width`. They exist so that the caller does
not need to build a new string just to pad the cell, which would allocate once per cell and
would also force the padding to be measured again by `printable_textwidth`.
"""
function _text__print_aligned(
    display::Display,
    str::AbstractString,
    cell_width::Int,
    alignment::Symbol,
    crayon::Crayon = _TEXT__DEFAULT,
    fill::Bool = true;
    left_margin::Int = 0,
    right_margin::Int = 0,
)
    str_width = printable_textwidth(str)
    _text__check_eol(display) && return nothing

    if cell_width > str_width
        remaining = cell_width - str_width

        if alignment === :l
            right_margin += fill ? remaining : 0
        elseif alignment === :c
            Δ = div(remaining, 2)
            left_margin += Δ
            right_margin += fill ? remaining - Δ : 0
        elseif alignment === :r
            left_margin += remaining
        end
    end

    styled = display.has_color && crayon != _TEXT__DEFAULT && crayon != _TEXT__EMPTY_CRAYON

    styled && print(display.buf_line, string(crayon))

    for _ in 1:left_margin
        write(display.buf_line, ' ')
    end

    print(display.buf_line, str)

    for _ in 1:right_margin
        write(display.buf_line, ' ')
    end

    styled && print(display.buf_line, _TEXT__STRING_RESET)
    display.column += left_margin + str_width + right_margin

    return nothing
end

"""
    _text__print_horizontal_line(
        display::Display,
        tf::TextTableFormat,
        crayon::Crayon,
        table_data::TableData,
        vertical_lines_at_data_columns::AbstractVector{Int},
        row_number_column_width::Int,
        row_label_column_width::Int,
        printed_data_column_widths::Vector{Int},
        top::Bool = false,
        bottom::Bool = false,
        row_group_label::Bool = false
    ) -> Nothing

Print a horizontal line to `display`.

# Arguments

- `display::Display`: Display where the horizontal line will be printed.
- `tf::TextTableFormat`: Table format.
- `crayon::Crayon`: Crayon used to print the horizontal line.
- `table_data::TableData`: Table data.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Printed data column widths.
- `top::Bool`: If `true`, a top horizontal line will be drawn.
    (**Default**: false)
- `bottom::Bool`: If `true`, a bottom horizontal line will be drawn.
    (**Default**: false)
- `row_group_label::Bool`: If `true`, a row group label horizontal line will be drawn. In
    this case, the horizontal line type is also modified by the keyword `top`, whereas the
    keyword `bottom` is neglected. To draw the bottom row label horizontal line, set `top`
    to `false`.
    (**Default**: false)
"""
function _text__print_horizontal_line(
    display::Display,
    tf::TextTableFormat,
    crayon::Crayon,
    table_data::TableData,
    vertical_lines_at_data_columns::AbstractVector{Int},
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
    top::Bool = false,
    bottom::Bool = false,
    row_group_label::Bool = false,
)
    # == Auxiliary Variables ===============================================================

    tb = tf.borders

    # Here, we obtain the characters for the left, middle, and right intersections.

    local li, mi, ri

    if !row_group_label
        li = if top
            tb.up_left_corner
        elseif bottom
            tb.bottom_left_corner
        else
            tb.left_intersection
        end

        mi = if top
            tb.up_intersection
        elseif bottom
            tb.bottom_intersection
        else
            tb.middle_intersection
        end

        ri = if top
            tb.up_right_corner
        elseif bottom
            tb.bottom_right_corner
        else
            tb.right_intersection
        end
    else
        li = tb.left_intersection
        mi = top ? tb.bottom_intersection : tb.up_intersection
        ri = tb.right_intersection
    end

    row = tb.row

    table_continuation_column = _is_horizontally_cropped(table_data)

    # == Print the Horizontal Line =========================================================

    (display.has_color && crayon != _TEXT__DEFAULT) && _text__print(display, string(crayon))

    # -- Left Intersection -----------------------------------------------------------------

    tf.vertical_line_at_beginning && _text__print(display, li)

    # -- Row Number Column -----------------------------------------------------------------

    if table_data.show_row_number_column
        _text__print(display, row, row_number_column_width + 2)
        tf.vertical_line_after_row_number_column &&
            _text__horizontal_line_intersection(display, mi, row, false)
    end

    # -- Row Label Column ------------------------------------------------------------------

    if _has_row_labels(table_data)
        _text__print(display, row, row_label_column_width + 2)
        tf.vertical_line_after_row_label_column &&
            _text__horizontal_line_intersection(display, mi, row, false)
    end

    # -- Data ------------------------------------------------------------------------------

    for j in eachindex(printed_data_column_widths)
        cw = printed_data_column_widths[j]
        _text__print(display, row, cw + 2)

        if (j == last(eachindex(printed_data_column_widths)))
            tf.vertical_line_after_data_columns && _text__horizontal_line_intersection(
                display,
                table_continuation_column ? mi : ri,
                row,
                !table_continuation_column,
            )
        elseif j ∈ vertical_lines_at_data_columns
            _text__horizontal_line_intersection(display, mi, row, false)
        end
    end

    # -- Table Continuation Column ---------------------------------------------------------

    if table_continuation_column
        _text__print(display, row, 3)
        tf.vertical_line_after_continuation_column &&
            _text__horizontal_line_intersection(display, ri, row, true)
    end

    # NOTE: The reset must be guarded by `has_color` exactly like the opening escape
    # sequence is. Otherwise, a table styled with a non-default crayon would leak a bare
    # `\e[0m` into an output where color is disabled.
    (display.has_color && crayon != _TEXT__DEFAULT) &&
        _text__print(display, _TEXT__STRING_RESET)

    return nothing
end

"""
    _text__print_column_label_horizontal_line(
        display::Display,
        tf::TextTableFormat,
        crayon::Crayon,
        table_data::TableData,
        row_number::Int,
        vertical_lines_at_data_columns::AbstractVector{Int},
        row_number_column_width::Int,
        row_label_column_width::Int,
        printed_data_column_widths::Vector{Int},
        top::Bool = false,
        bottom::Bool = false
    )

Print a column label horizontal line to `display`.

# Arguments

- `display::Display`: Display where the horizontal line will be printed.
- `tf::TextTableFormat`: Table format.
- `crayon::Crayon`: Crayon used to print the horizontal line.
- `table_data::TableData`: Table data.
- `row_number::Int`: Column label row number before the horizontal line.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Printed data column widths.
- `top::Bool`: If `true`, a top horizontal line will be drawn.
    (**Default**: false)
- `bottom::Bool`: If `true`, a bottom horizontal line will be drawn.
    (**Default**: false)
"""
function _text__print_column_label_horizontal_line(
    display::Display,
    tf::TextTableFormat,
    crayon::Crayon,
    table_data::TableData,
    row_number::Int,
    vertical_lines_at_data_columns::AbstractVector{Int},
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
    top::Bool = false,
    bottom::Bool = false,
)
    # == Auxiliary Variables ===============================================================

    tb = tf.borders
    num_column_labels = length(table_data.column_labels)

    # Here, we obtain the characters for the left, middle, and right intersections.

    local li, mi, ri

    ti = tb.up_intersection
    bi = tb.bottom_intersection

    li = if top
        tb.up_left_corner
    elseif bottom
        tb.bottom_left_corner
    else
        tb.left_intersection
    end

    mi = if top
        ti
    elseif bottom
        bi
    else
        tb.middle_intersection
    end

    ri = if top
        tb.up_right_corner
    elseif bottom
        tb.bottom_right_corner
    else
        tb.right_intersection
    end

    row = tb.row

    table_continuation_column = _is_horizontally_cropped(table_data)

    # == Print the Horizontal Line =========================================================

    (display.has_color && crayon != _TEXT__DEFAULT) && _text__print(display, string(crayon))

    # -- Left Intersection -----------------------------------------------------------------

    tf.vertical_line_at_beginning && _text__print(display, li)

    # -- Row Number Column -----------------------------------------------------------------

    if table_data.show_row_number_column
        _text__print(display, row, row_number_column_width + 2)
        tf.vertical_line_after_row_number_column &&
            _text__horizontal_line_intersection(display, mi, row, false)
    end

    # -- Row Label Column ------------------------------------------------------------------

    if _has_row_labels(table_data)
        _text__print(display, row, row_label_column_width + 2)
        tf.vertical_line_after_row_label_column &&
            _text__horizontal_line_intersection(display, mi, row, false)
    end

    # -- Data ------------------------------------------------------------------------------

    for j in eachindex(printed_data_column_widths)
        cw = printed_data_column_widths[j]
        _text__print(display, row, cw + 2)

        if (j == last(eachindex(printed_data_column_widths)))
            tf.vertical_line_after_data_columns && _text__horizontal_line_intersection(
                display,
                table_continuation_column ? mi : ri,
                row,
                !table_continuation_column,
            )
        elseif j ∈ vertical_lines_at_data_columns
            # We must compute if the cell at the top or at the bottom from the current
            # horizontal line is merged. Notice that if we are at the top of the table, the
            # effect is equal to have a merged cell above it.
            top_j₀, top_j₁       = _column_label_limits(table_data, row_number, j + 1)
            bottom_j₀, bottom_j₁ = _column_label_limits(table_data, row_number + 1, j + 1)

            tcm = (top_j₀ != top_j₁) && (j + 1 != top_j₀) || top
            bcm = (bottom_j₀ != bottom_j₁) && (j + 1 != bottom_j₀)

            if tf.suppress_vertical_lines_at_column_labels
                bcm = tcm = true

                # We must have a special treatment if this is the last column label since we
                # must connect the vertical lines with those at the table.
                row_number == num_column_labels && (bcm = false)
            end

            aux = if tcm && bcm
                row
            elseif tcm && !bcm
                ti
            elseif !tcm && bcm
                bi
            else
                mi
            end

            _text__horizontal_line_intersection(display, aux, row, false)
        end
    end

    # -- Table Continuation Column ---------------------------------------------------------

    if table_continuation_column
        _text__print(display, row, 3)
        tf.vertical_line_after_continuation_column &&
            _text__horizontal_line_intersection(display, ri, row, true)
    end

    # NOTE: The reset must be guarded by `has_color` exactly like the opening escape
    # sequence is. Otherwise, a table styled with a non-default crayon would leak a bare
    # `\e[0m` into an output where color is disabled.
    (display.has_color && crayon != _TEXT__DEFAULT) &&
        _text__print(display, _TEXT__STRING_RESET)

    return nothing
end

"""
    _text__print_column_label_horizontal_line_only_at_merged_labels(
        display::Display,
        tf::TextTableFormat,
        crayon::Crayon,
        table_data::TableData,
        row_number::Int,
        vertical_lines_at_data_columns::AbstractVector{Int},
        row_number_column_width::Int,
        row_label_column_width::Int,
        printed_data_column_widths::Vector{Int}
    )

Print a column label line to `display` where a horizontal line is drawn only after merged
column labels.

# Arguments

- `display::Display`: Display where the horizontal line will be printed.
- `tf::TextTableFormat`: Table format.
- `crayon::Crayon`: Crayon used to print the horizontal line.
- `table_data::TableData`: Table data.
- `row_number::Int`: Column label row number before the horizontal line.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Printed data column widths.
"""
function _text__print_column_label_horizontal_line_only_at_merged_labels(
    display::Display,
    tf::TextTableFormat,
    crayon::Crayon,
    table_data::TableData,
    row_number::Int,
    vertical_lines_at_data_columns::AbstractVector{Int},
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
)
    # == Auxiliary Variables ===============================================================

    tb  = tf.borders
    ti  = tb.up_intersection
    ri  = tb.right_intersection
    col = tb.column
    row = tb.row

    table_continuation_column = _is_horizontally_cropped(table_data)

    # == Print the Horizontal Line =========================================================

    (display.has_color && crayon != _TEXT__DEFAULT) && _text__print(display, string(crayon))

    # -- Left Intersection -----------------------------------------------------------------

    tf.vertical_line_at_beginning && _text__print(display, col)

    # -- Row Number Column -----------------------------------------------------------------

    if table_data.show_row_number_column
        _text__print(display, ' ', row_number_column_width + 2)
        tf.vertical_line_after_row_number_column && _text__print(display, col)
    end

    # -- Row Label Column ------------------------------------------------------------------

    if _has_row_labels(table_data)
        _text__print(display, ' ', row_label_column_width + 2)
        tf.vertical_line_after_row_label_column && _text__print(display, col)
    end

    # -- Data ------------------------------------------------------------------------------

    for j in eachindex(printed_data_column_widths)
        j₀, j₁ = _column_label_limits(table_data, row_number, j)
        is_merged = j₀ != j₁

        cw = printed_data_column_widths[j]

        if !is_merged
            _text__print(display, ' ', cw + 2)
        else
            _text__print(display, j == j₀ ? " " : row)
            _text__print(display, row, cw)
            _text__print(display, j == j₁ ? " " : row)
        end

        if (j == last(eachindex(printed_data_column_widths)))
            tf.vertical_line_after_data_columns && _text__print(display, col)

        elseif j ∈ vertical_lines_at_data_columns
            # Check if we are in the middle of a merged column label.
            if (j₀ != j₁) && (j₁ != j)
                # Check if the next column label is merged so that we can print the correct
                # intersection.
                bottom_j₀, bottom_j₁ = _column_label_limits(table_data, row_number + 1, j)
                ci = (bottom_j₀ != bottom_j₁) && (j != bottom_j₁) ? row : ti

                _text__print(
                    display, tf.suppress_vertical_lines_at_column_labels ? row : ci
                )

                continue
            end

            _text__print(display, tf.suppress_vertical_lines_at_column_labels ? " " : col)
        end
    end

    # -- Table Continuation Column ---------------------------------------------------------

    if table_continuation_column
        _text__print(display, row, 3)
        tf.vertical_line_after_continuation_column &&
            _text__horizontal_line_intersection(display, ri, row, true)
    end

    # NOTE: The reset must be guarded by `has_color` exactly like the opening escape
    # sequence is. Otherwise, a table styled with a non-default crayon would leak a bare
    # `\e[0m` into an output where color is disabled.
    (display.has_color && crayon != _TEXT__DEFAULT) &&
        _text__print(display, _TEXT__STRING_RESET)

    return nothing
end

"""
    _text__horizontal_line_intersection(
        display::Display,
        intersection::Char,
        row::Char,
        final_intersection::Bool
    ) -> Nothing

Print to `display` the horizontal line `intersection` if we have enough space. Otherwise,
print `row`. The argument `final_intersection` indicates that we are printing the final
intersection of the table. In that case, we print `intersection` if we have at least two
remaining spaces.
"""
function _text__horizontal_line_intersection(
    display::Display, intersection::Char, row::Char, final_intersection::Bool
)
    # If the display size is negative, it means we do not have a limit. Hence, just print
    # the intersection.
    if display.size[2] < 0
        _text__print(display, intersection)
        return nothing
    end

    # If the display has only two characters and we are not at the final intersection, we
    # should use the row character because the other lines will be cropped.
    num_remaining_chars = display.size[2] - display.column

    if num_remaining_chars > 2
        _text__print(display, intersection)
    elseif (num_remaining_chars >= 1) && final_intersection
        _text__print(display, intersection)
    else
        _text__print(display, row)
    end

    return nothing
end

## Description #############################################################################
#
# Excel Back End: Test row height and column width determination.
#
############################################################################################

@testset "Heights and Widths" verbose = true begin

    # == Style and Highlighter Size Effects ================================================

    @testset "Style and Highlighter Size Effects" verbose = true begin
        data = [1 2 3]

        result = pretty_table(
            XLSX.XLSXFile,
            data;
            title = "Test Table",
            subtitle = "Subtitle_test",
            highlighters = [
                ExcelHighlighter(
                    (data, i, j) -> (i == 1),
                    ["color" => "red", "bold" => "true", "size" => "32"],
                ),
            ],
            style = ExcelTableStyle(;
                title = ["size" => "48", "bold" => "true"],
                subtitle = ["size" => "8", "italic" => "true"],
            ),
        )

        @test XLSX.getRowHeight(result[1], 1, 1) ≈ 60.810937499999994
        @test XLSX.getRowHeight(result[1], 2, 1) ≈ 12.8109375
        @test XLSX.getRowHeight(result[1], 4, 1) ≈ 41.6109375
    end

    # == Text vs Numbers Affecting Width/Height ============================================

    @testset "Text vs Numbers Affecting Width/Height" verbose = true begin
        data = [
            "Quite long, long text" "S" "Hytsgt"
            1 1.12345623456789 1.0
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            data;
            style = ExcelTableStyle(; data_cell = ["size" => "48", "bold" => "true"]),
        )

        @test XLSX.getColumnWidth(result[1], 2, 1) ≈ 81.91093750000002
        @test XLSX.getColumnWidth(result[1], 2, 2) ≈ 8.368080357142858
        @test XLSX.getRowHeight(result[1], 3, 1) ≈ 60.810937499999994
    end

    # == Formatted Dates Column Widths =====================================================

    @testset "Formatted Dates Column Widths" verbose = true begin
        now = Dates.now()
        matrix = [
            now now now now
            now now now now
            now now now now
            now now now now
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
                ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
                ExcelFormatter(
                    (v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"]
                )
            ],
        )

        for j in 1:4
            @test XLSX.getColumnWidth(result[1], 1, j) ≈ 8.368080357142858
            @test XLSX.getRowHeight(result[1], j, 1) ≈ 17.6109375
        end
    end

    # == Fixed Column Widths ===============================================================

    @testset "Fixed Column Widths" verbose = true begin
        now = Dates.now()
        matrix = [
            now now now now
            now now now now
            now now now now
            now now now now
        ]

        @testset "Single Fixed Width" verbose = true begin
            result = pretty_table(
                XLSX.XLSXFile,
                matrix;
                excel_formatters = [
                    ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
                    ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
                    ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
                    ExcelFormatter(
                        (v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"]
                    )
                ],
                data_column_widths = 10.5,
            )

            for j in 1:4
                @test XLSX.getColumnWidth(result[1], 1, j) ≈ 11.2109375
                @test XLSX.getRowHeight(result[1], j, 1) ≈ 17.6109375
            end
        end

        @testset "Vector of Fixed Widths" verbose = true begin
            result = pretty_table(
                XLSX.XLSXFile,
                matrix;
                excel_formatters = [
                    ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
                    ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
                    ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
                    ExcelFormatter(
                        (v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"]
                    )
                ],
                data_column_widths = [12.0, 16.0, 8.0, 20.0],
            )

            w = [12.7109375, 16.7109375, 8.7109375, 20.7109375]
            for j in 1:4
                @test XLSX.getColumnWidth(result[1], 1, j) ≈ w[j]
                @test XLSX.getRowHeight(result[1], j, 1) ≈ 17.6109375
            end
        end
    end

    # == Maximum Column Widths =============================================================

    @testset "Maximum Column Widths" verbose = true begin
        now = Dates.now()
        matrix = [
            now now now now
            now now now now
            now now now now
            now now now now
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
                ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
                ExcelFormatter(
                    (v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"]
                )
            ],
            maximum_data_column_widths = [6.0, 100.0, 40.0, 5.0],
        )

        w = [6.7109375, 8.368080357142858, 8.368080357142858, 5.7109375]
        for j in 1:4
            @test XLSX.getColumnWidth(result[1], 1, j) ≈ w[j]
            @test XLSX.getRowHeight(result[1], j, 1) ≈ 17.6109375
        end
    end

    # == Minimum Column Widths =============================================================

    @testset "Minimum Column Widths" verbose = true begin
        now = Dates.now()
        matrix = [
            now now now now
            now now now now
            now now now now
            now now now now
        ]

        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            excel_formatters = [
                ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
                ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
                ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
                ExcelFormatter(
                    (v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"]
                )
            ],
            minimum_data_column_widths = [1.0, 12.0, 16.0, 1.0],
        )

        w = [8.368080357142858, 12.7109375, 16.7109375, 8.368080357142858]
        for j in 1:4
            @test XLSX.getColumnWidth(result[1], 1, j) ≈ w[j]
            @test XLSX.getRowHeight(result[1], j, 1) ≈ 17.6109375
        end
    end
end

## Description #############################################################################
#
# Documentation for the LaTeX backend.
#
############################################################################################

"""
# PrettyTables.jl LaTeX Backend

The LaTeX backend can be selected by passing the keyword `backend = :latex` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output.

# Keywords

- `highlighters::Vector{LatexHighlighter}`: Highlighters to apply to the table. For more
    information, see the section **LaTeX Highlighters** in the **Extended Help**.
- `style::LatexTableStyle`: Style of the table. For more information, see the section
    **LaTeX Table Style** in the **Extended Help**.
- `table_format::LatexTableFormat`: LaTeX table format used to render the table. For more
    information, see the section **LaTeX Table Format** in the **Extended Help**.

# Extended Help

## LaTeX Highlighters


A set of highlighters can be passed as a `Vector{LatexHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`LatexHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
    highlighter. This function must return a `Vector{String}` with the LaTeX environments to
    be applied to the cell.

A LaTeX highlighter can be constructed using two helpers:

```julia
LatexHighlighter(f::Function, envs::Vector{String})
```

where it will apply recursively all the LaTeX environments in `envs` to the highlighted
text, and

```julia
LatexHighlighter(f::Function, fd::Function)
```

where the user selects the desired decoration by specifying the function `fd`.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to make the cells with value greater than 5 bold, and all the cells
with value less than 5 small, we can define:

```julia
hl_gt5 = LatexHighlighter(
    (data, i, j) -> data[i, j] > 5,
    ["textbf"]
)

hl_lt5 = LatexHighlighter(
    (data, i, j) -> data[i, j] < 5,
    ["small"]
)

highlighters = [hl_gt5, hl_lt5]
```

## LaTeX Table Format

The LaTeX table format is defined using an object of type [`LatexTableFormat`](@ref) that
contains the following fields:

- `borders::LatexTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn on bottom of the merged column labels using `\\cline`.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data row. If the symbol `:none` is passed,
    no horizontal lines will be drawn after the data rows.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will
    be drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data row. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@latex__all_horizontal_lines`](@ref).
- [`@latex__all_vertical_lines`](@ref).
- [`@latex__no_horizontal_lines`](@ref).
- [`@latex__no_vertical_lines`](@ref).

## LaTeX Table Style

The LaTeX table style is defined using an object of type [`LatexTableStyle`](@ref) that
contains the following fields:

- `title::LatexEnvironments`: Latex environments with the style for the title.
- `subtitle::LatexEnvironments`: Latex environments with the style for the subtitle.
- `row_number_label::LatexEnvironments`: Latex environments with the style for the row
    number label.
- `row_number::LatexEnvironments`: Latex environments with the style for the row numbers.
- `stubhead_label::LatexEnvironments`:  Latex environments with the style for the stubhead
    label.
- `row_label::LatexEnvironments`: Latex environments with the style for the row labels.
- `row_group_label::LatexEnvironments`: Latex environments with the style for the row group
    label.
- `first_line_column_label::Union{LatexEnvironments, Vector{LatexEnvironments}}`: Latex
    environments with the style for the first line of the column labels. If a vector of
    `LatexEnvironments` is provided, each column label in the first line will use the
    corresponding style.
- `column_label::Union{LatexEnvironments, Vector{LatexEnvironments}}`: Latex environments
    with the style for the rest of the column labels. If a vector of `LatexEnvironments` is
    provided, each column label will use the corresponding style.
- `first_line_merged_column_label::LatexEnvironments`: Latex environments with the style for
    the merged cells at the first column label line.
- `merged_column_label::LatexEnvironments`: Latex environments with the style for the merged
    cells at the rest of the column labels.
- `summary_row_cell::LatexEnvironments`: Latex environments with the style for the summary
    row cell.
- `summary_row_label::LatexEnvironments`: Latex environments with the style for the summary
    row label.
- `footnote::LatexEnvironments`: Latex environments with the style for the footnotes.
- `source_note::LatexEnvironments`: Latex environments with the style for the source notes.
- `omitted_cell_summary::LatexEnvironments`: Latex environments with the style for the
    omitted cell summary.

Each field is a `LatexEnvironments` object, which is a vector of strings with the LaTeX
environments to be applied to the corresponding element.

For example, if we want to make the stubhead label bold and red, we must define:

```julia
style = LatexTableStyle(
    stubhead_label = ["textbf", "color{red}"]
)
```
"""
pretty_table_latex_backend

## Description #############################################################################
#
# HTML Back End: Test highlighters.
# 
############################################################################################

@testset "Highlighters" begin
    matrix = [
        1 2 3
        4 5 6
    ]

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "color: green; font-weight: bold; text-align: right;">1</td>
      <td style = "color: red; text-align: right;">2</td>
      <td style = "color: green; font-weight: bold; text-align: right;">3</td>
    </tr>
    <tr class = "dataRow">
      <td style = "color: red; text-align: right;">4</td>
      <td style = "color: green; font-weight: bold; text-align: right;">5</td>
      <td style = "color: red; text-align: right;">6</td>
    </tr>
  </tbody>
</table>
"""

    result = pretty_table(
        String,
        matrix;
        backend = :html,
        highlighters = [
            HtmlHighlighter((data, i, j) -> data[i, j] % 2 == 0, "color" => "red"),
            HtmlHighlighter((data, i, j) -> data[i, j] % 2 == 0, ["color" => "blue"]),
            HtmlHighlighter(
                (data, i, j) -> data[i, j] % 2 != 0,
                ["font-weight" => "bold"],
                "color" => "green",
            ),
        ],
    )

    @test result == expected

    result = pretty_table(
        String,
        matrix;
        backend = :html,
        highlighters = [
            HtmlHighlighter(
                (data, i, j) -> data[i, j] % 2 == 0, (_, _, _, _) -> ["color" => "red"]
            ),
            HtmlHighlighter((data, i, j) -> data[i, j] % 2 == 0, ["color" => "blue"]),
            HtmlHighlighter(
                (data, i, j) -> data[i, j] % 2 != 0,
                ["font-weight" => "bold"],
                "color" => "green",
            ),
        ],
    )

    @test result == expected

    @testset "First Match Wins" begin
        # The applied style must be the one of the **first** matching highlighter.
        h1 = HtmlHighlighter((d, i, j) -> true, ["color" => "red"])
        h2 = HtmlHighlighter((d, i, j) -> true, ["color" => "blue"])

        result = pretty_table(String, [1]; backend = :html, highlighters = [h1, h2])

        @test occursin("color: red", result)
        @test !occursin("color: blue", result)
    end

    @testset "Highlighter Receives the Original Data" begin
        # The highlighter callbacks must see the object the user passed to `pretty_table`,
        # not the internal table wrapper, so that they are portable across back ends.
        data = (a = [1, 2],)
        seen = []

        h = HtmlHighlighter(
            (d, i, j) -> (push!(seen, typeof(d)); false),
            ["color" => "red"],
        )

        pretty_table(String, data; backend = :html, highlighters = [h])

        @test !isempty(seen)
        @test all(==(typeof(data)), seen)
    end
end

## Description #############################################################################
#
# Markdown Back End: Test with default options.
#
############################################################################################

@testset "Default Options" begin
    matrix = [
        1 1.0 0x01 'a' "abc" missing
        2 2.0 0x02 'b' "def" nothing
        3 3.0 0x03 'c' "ghi" :symbol
    ]

    expected = """
| **Col. 1** | **Col. 2** | **Col. 3** | **Col. 4** | **Col. 5** | **Col. 6** |
|-----------:|-----------:|-----------:|-----------:|-----------:|-----------:|
|          1 |        1.0 |          1 |          a |        abc |    missing |
|          2 |        2.0 |          2 |          b |        def |    nothing |
|          3 |        3.0 |          3 |          c |        ghi |     symbol |
"""

    result = pretty_table(String, matrix; backend = :markdown)
    @test result == expected

    result = pretty_table(String, matrix; table_format = MarkdownTableFormat())
    @test result == expected

    result = pretty_table_markdown_backend(String, matrix)
    @test result == expected
end

@testset "Title and Subtitle" begin
    # The title and subtitle must be escaped, and a heading level lower than 1 must print
    # them as plain text.
    expected = """
# My \\*Title\\*

Subtitle

| **Col. 1** | **Col. 2** |
|-----------:|-----------:|
|          1 |          2 |
"""

    result = pretty_table(
        String,
        [1 2];
        backend = :markdown,
        subtitle = "Subtitle",
        table_format = MarkdownTableFormat(; subtitle_heading_level = 0),
        title = "My *Title*",
    )

    @test result == expected
end

@testset "Summary Rows in Tables Without Columns" begin
    # A table with rows but no columns has no printed cells. Hence, requesting summary rows
    # must keep printing nothing instead of accessing undefined label references.
    result = pretty_table(
        String,
        Matrix{Float64}(undef, 4, 0);
        backend = :markdown,
        summary_rows = [sum],
    )

    @test result == ""
end

## Description #############################################################################
#
# Excel Back End: Helpers for building tables.
#
############################################################################################

# Used when otherwise unspecified
const DEFAULT_FONT_SIZE = 12

# Unicode superscript digits for footnote references
const SUPERSCRIPT_DIGITS = ['⁰', '¹', '²', '³', '⁴', '⁵', '⁶', '⁷', '⁸', '⁹']

"""
    _excel__alignment_string(s::Symbol) -> String

Convert the alignment symbol `s` to a string for use in `XLSX.setAlignment`.
"""
function _excel__alignment_string(s::Symbol)
    s == :r && return "right"
    s == :c && return "center"

    # Return "left" for `:l` or any other value.
    return "left"
end

"""
    _excel__unempty_row!(sheet::XLSX.Worksheet, row::Number, cols::UnitRange) -> Nothing

Ensure all cells of `sheet` inside the column range `cols` in `row` are not `XLSX.EmptyCell`
so that formatting applies correctly.
"""
function _excel__unempty_row!(sheet::XLSX.Worksheet, row::Number, cols::UnitRange)
    sheet[row, cols] = ""
    return nothing
end

"""
    _excel__to_superscript(n::Int) -> String

Convert the integer `n` to a superscript string using Unicode characters.
"""
function _excel__to_superscript(n::Int)
    return join(SUPERSCRIPT_DIGITS[parse(Int, c) + 1] for c in string(n))
end

"""
    _excel__column_width_for_text(text_length::Number, font_size::Number) -> Number

Estimate the Excel column width needed to display text of `text_length` characters rendered
at `font_size`.
"""
function _excel__column_width_for_text(text_length::Number, font_size::Number)
    # Empirical approximation of Excel's column-width units for ASCII characters in the
    # default font, derived from a pixel-to-character ratio of 0.55/7 with a constant
    # padding of 2 for margins.
    return (0.55 * text_length * font_size) / 7 + 2
end

"""
    _excel__row_height_for_text(line_count::Number, font_size::Number) -> Number

Estimate the Excel row height needed to accommodate `line_count` lines of text rendered at
`font_size`.
"""
function _excel__row_height_for_text(line_count::Number, font_size::Number)
    # Standard Excel row height in points: line_count × (1.2 × font_size), plus a 3-point
    # padding that approximates the row margins Excel uses by default.
    return line_count * (font_size * 1.2) + 3
end

"""
    _excel__text_lines(text::Any) -> Number

Determine the number of lines in `text` by counting newline occurrences. If `text` is not a
string, returns 1.
"""
_excel__text_lines(text::AbstractString) = count('\n', text) + 1
_excel__text_lines(::Any) = 1

"""
    _excel__multilength(text::AbstractString) -> Number

Return the length of the longest line in the multi-line string `text`. If `text` is not a
string, returns 0.
"""
function _excel__multilength(text::AbstractString)
    return maximum(length, split(text, '\n'); init = 0)
end

_excel__multilength(::Any) = 0

"""
    fmt__excel_stringify(
        columns::Union{Nothing, Int, AbstractVector{Int}} = nothing
    ) -> Function

Create a formatter function that converts values XLSX.jl cannot handle directly into their
string representation. When `columns` is `nothing`, all values are stringified; otherwise
only the columns listed in `columns` are converted.
"""
function PrettyTables.fmt__excel_stringify(
    columns::Union{Nothing, Int, AbstractVector{Int}} = nothing
)
    return (v, _, j) -> begin
        (v isa XLSX.CellConcreteType) && return v

        isnothing(columns) && return string(v)

        j ∈ columns && return string(v)

        return v
    end
end

"""
    _excel__cell_length_and_height(text::Any, fontsize::Number) -> Tuple{Float64, Float64}

Notice that the returned tuple is `(row_height, col_length)`, in that order.

Compute the estimated Excel row height and column width for a cell containing `text`
rendered at `fontsize`.

# Returns

- `Tuple{Float64, Float64}`: `(row_height, col_length)` in Excel units. `col_length` is
    zero for non-string values.
"""
function _excel__cell_length_and_height(text::AbstractString, fontsize::Number)
    lines      = _excel__text_lines(text)
    col_length = _excel__column_width_for_text(_excel__multilength(text), fontsize)
    row_height = _excel__row_height_for_text(lines, fontsize)

    return row_height, col_length
end

function _excel__cell_length_and_height(_::Any, fontsize::Number)
    lines      = 1
    col_length = 0.0
    row_height = _excel__row_height_for_text(lines, fontsize)

    return row_height, col_length
end

"""
    _excel__get_col_width(
        col::Int,
        max_col_length::Vector{Float64},
        col_offset::Int,
        data_column_widths::AbstractVector{Float64},
        min_data_column_widths::AbstractVector{Float64},
        max_data_column_widths::AbstractVector{Float64}
    ) -> Float64

Resolve the Excel column width for column `col`. Columns at or before `col_offset`
(row-number and row-label columns) are returned as-is from `max_col_length`. For data
columns, a positive entry in `data_column_widths` takes precedence; otherwise the
auto-calculated width is clamped between the corresponding entries of
`min_data_column_widths` and `max_data_column_widths` (values ≤ 0 are ignored).
"""
function _excel__get_col_width(
    col::Int,
    max_col_length::Vector{Float64},
    col_offset::Int,
    data_column_widths::AbstractVector{Float64},
    min_data_column_widths::AbstractVector{Float64},
    max_data_column_widths::AbstractVector{Float64},
)
    # Don't limit non-data cells.
    col <= col_offset && return max_col_length[col]

    j = col - col_offset

    # A positive explicit width overrides everything.
    dw = data_column_widths[j]
    dw > 0.0 && return dw

    # Clamp auto-calculated width between min and max.
    col_width = max_col_length[col]

    min_w = min_data_column_widths[j]
    min_w > 0.0 && (col_width = max(col_width, min_w))

    max_w = max_data_column_widths[j]
    max_w > 0.0 && (col_width = min(col_width, max_w))

    return col_width
end

function _excel__split_attributes(attributes::Vector{ExcelPair})
    font_attributes = Pair{Symbol, Any}[]
    fill_attributes = Pair{Symbol, Any}[]

    for (k, v) in attributes
        if startswith(k, "cell_fill_")
            pv = fill_attributes
            sym = Symbol(@view k[(ncodeunits("cell_fill_") + 1):end])
        else
            pv = font_attributes
            sym = Symbol(k)
        end

        processed_attribute = tryparse(Int, v)

        if isnothing(processed_attribute)
            processed_attribute = if v == "true"
                true
            elseif v == "false"
                false
            else
                v
            end
        end

        push!(pv, sym => processed_attribute)
    end

    return font_attributes, fill_attributes
end

"""
    _excel__apply_cell_style!(
        sheet::XLSX.Worksheet,
        row::Int,
        col::Int,
        style::Vector{ExcelPair},
        alignment::Union{Nothing, Symbol},
        valign::String,
        wrap::Bool,
    ) -> Number

Apply font and fill styling to the cell at (`row`, `col`) in `sheet` and return the
resolved font size.

The font size is taken from the `:size` entry of `style` when present, and from
`DEFAULT_FONT_SIZE` otherwise. When `style` carries no font attributes, no font is written
and a highlighter's prior font settings are preserved. The `:cell_fill_*` entries of
`style` are routed to `XLSX.setFill` and the remaining entries to `XLSX.setFont`.
`alignment`, when not `nothing`, is applied via `XLSX.setAlignment` together with `valign`
and `wrap`.
"""
function _excel__apply_cell_style!(
    sheet::XLSX.Worksheet,
    row::Int,
    col::Int,
    style::Vector{ExcelPair},
    alignment::Union{Nothing, Symbol},
    valign::String,
    wrap::Bool,
)
    font_attributes, fill_attributes = _excel__split_attributes(style)

    if !isempty(font_attributes)
        id = findfirst(p -> first(p) == :size, font_attributes)
        fontsize = isnothing(id) ? DEFAULT_FONT_SIZE : last(font_attributes[id])

        XLSX.setFont(sheet, row, col; font_attributes...)
    else
        # Preserve any font previously applied (e.g., by a highlighter) by not calling
        # `setFont`. The default size is used only as a fallback for cell sizing.
        fontsize = DEFAULT_FONT_SIZE
    end

    !isnothing(alignment) && XLSX.setAlignment(
        sheet,
        row,
        col;
        vertical = valign,
        horizontal = _excel__alignment_string(alignment),
        wrapText = wrap,
    )

    isempty(fill_attributes) || XLSX.setFill(sheet, row, col; fill_attributes...)

    return fontsize
end

"""
    _excel__format_attributes(
        @nospecialize(data::Any),
        excelFormatter::ExcelFormatter,
        current_row::Int,
        j::Int
    ) -> Union{Nothing, Vector{Pair{Symbol, Any}}}

Compute the format attributes `excelFormatter` yields for the cell at row `current_row` and
column `j` of `data`, or return `nothing` when the formatter condition is not met. Notice
that `data` must be the object the user passed to `pretty_table`, so that the formatter
condition sees the same object in every back end.
"""
function _excel__format_attributes(
    @nospecialize(data::Any),
    excelFormatter::ExcelFormatter,
    current_row::Int,
    j::Int,
)
    attributes = excelFormatter.f(data, current_row, j) ? excelFormatter.numFmt : nothing

    isnothing(attributes) && return nothing

    font_attributes, _ = _excel__split_attributes(attributes)

    return font_attributes
end

## Description #############################################################################
#
# Sub-module that defines a custom text cell for the text back end.
#
############################################################################################

module CustomTextCell

export AbstractCustomTextCell

############################################################################################
#                                          Types                                           #
############################################################################################

abstract type AbstractCustomTextCell end

############################################################################################
#                                        Functions                                         #
############################################################################################

"""
    add_suffix!(cell::AbstractCustomTextCell, suffix::String) -> Nothing

Add `suffix` to the custom `cell` rendered text.
"""
function add_suffix!(cell::AbstractCustomTextCell, suffix::String)
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `add_suffix!`.",
    )
end

"""
    crop!(cell::AbstractCustomTextCell, field_width::Int) -> Nothing

Right-crop a field with display width `field_width` from `cell`. This cropping must be
applied to either the entire cell or to a specific line.
"""
function crop!(cell::AbstractCustomTextCell, field_width::Int)
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `crop!`.",
    )
end

"""
    init!(
        cell::AbstractCustomTextCell,
        context::IOContext,
        renderer::Union{Val{:print}, Val{:show}}
    ) -> Nothing

Initialize the custom text `cell` using the `context` and `renderer`.

# Keywords

- `line_breaks`: If `true`, the cell will be rendered into multiple lines.
"""
function init!(
    cell::AbstractCustomTextCell,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    line_breaks::Bool = false,
)
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `init!`.",
    )
end

"""
    left_padding!(cell::AbstractCustomTextCell, pad::Int) -> Nothing

Apply a left padding of `pad` display characters to `cell`.
"""
function left_padding!(cell::AbstractCustomTextCell, pad::Int)
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `left_padding!`.",
    )
end

"""
    right_padding!(cell::AbstractCustomTextCell, pad::Int) -> Nothing

Apply a right padding of `pad` display characters to `cell`.
"""
function right_padding!(cell::AbstractCustomTextCell, pad::Int)
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `right_padding!`.",
    )
end

"""
    rendered_cell(cell::AbstractCustomTextCell) -> String

Render all the lines in the `cell`, applying the specifications for right and left padding
and cropping.
"""
function rendered_cell(cell::AbstractCustomTextCell)::String
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `rendered_cell`.",
    )
end

"""
    rendered_cell_line(cell::AbstractCustomTextCell, line::Int) -> String

Render the `line` in the `cell`, applying the specifications for right and left padding
and cropping.
"""
function rendered_cell_line(cell::AbstractCustomTextCell, line::Int)::String
    line > 1 && return ""
    return rendered_cell(cell)
end

raw"""
    printable_cell_text(cell::AbstractCustomTextCell) -> String

Render only the printable characters in `cell`. Here, we must not consider the
specifications for right and left padding or cropping.

!!! note

    If line breaks are not supported, `\n` must be escaped.
"""
function printable_cell_text(cell::AbstractCustomTextCell)::String
    return error(
        "The custom text cell of type `$(typeof(cell))` does not implement the API function `printable_cell_text`.",
    )
end

end

## Description #############################################################################
#
# Markdown back end for PrettyTables.jl.
#
############################################################################################

function _markdown__print(
    pspec::PrintingSpec;
    allow_markdown_in_cells::Bool = false,
    highlighters::Vector{MarkdownHighlighter} = MarkdownHighlighter[],
    line_breaks::Bool = false,
    style::MarkdownTableStyle = MarkdownTableStyle(),
    table_format::MarkdownTableFormat = MarkdownTableFormat(),
)
    context    = pspec.context
    table_data = pspec.table_data
    # NOTE: `Val(pspec.renderer)` infers to the abstract `Val` because
    # `pspec.renderer` is a `Symbol`. Branching here keeps the renderer concrete, so the
    # per-cell rendering calls are statically dispatched.
    renderer   = pspec.renderer === :show ? Val(:show) : Val(:print)
    tf         = table_format

    ps     = PrintingTableState()
    buf_io = IOBuffer()
    buf    = IOContext(buf_io, context)

    # Obtain general information about the table.
    num_column_label_lines   = length(table_data.column_labels)
    num_printed_data_columns = _number_of_printed_data_columns(table_data)
    num_printed_data_rows    = _number_of_printed_data_rows(table_data)
    num_summary_rows         = _has_summary_rows(table_data) ? length(table_data.summary_rows) : 0

    # Check the style variables.
    if style.first_line_column_label isa Vector{MarkdownStyle}
        length(style.first_line_column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `first_line_column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    if style.column_label isa Vector{MarkdownStyle}
        length(style.column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    # == Render the Table ==================================================================

    # For Markdown, we need to render the entire table before printing to take into account
    # the required column width.

    # Let's allocate all the sections.
    column_labels = if table_data.show_column_labels
        Matrix{String}(undef, num_column_label_lines, num_printed_data_columns)
    else
        nothing
    end

    row_labels = if _has_row_labels(table_data)
        Vector{String}(undef, num_printed_data_rows)
    else
        nothing
    end

    table_str = Matrix{String}(undef, num_printed_data_rows, num_printed_data_columns)

    summary_rows = if _has_summary_rows(table_data)
        Matrix{String}(undef, num_summary_rows, num_printed_data_columns)
    else
        nothing
    end

    summary_row_labels = if _has_summary_rows(table_data)
        Vector{String}(undef, num_summary_rows)
    else
        nothing
    end

    action = :initialize

    # We must store the index related to the rendered tables. These indices differ from the
    # actual table indices due to cropping.
    ir = jr = 0

    # The highlighters must receive the object the user passed to `pretty_table`, not the
    # internal table wrapper. Notice that this is loop invariant.
    orig_data = _get_data(table_data.data)

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)

        action == :end_printing && break

        ir, jr = _update_data_cell_indices(action, rs, ps, ir, jr)

        # Here, we only want actions related to table cells.
        action ∉ (:column_label, :data, :summary_row_cell, :row_label, :summary_row_label) &&
            continue

        cell = _current_cell(action, ps, table_data)

        rendered_cell = if cell !== _IGNORE_CELL
            _markdown__render_cell(cell, buf, renderer; allow_markdown_in_cells, line_breaks)
        else
            ""
        end

        # Check for footnotes.
        footnotes = _current_cell_footnotes(table_data, action, ps.i, ps.j)

        if !isnothing(footnotes) && !isempty(footnotes)
            for i in eachindex(footnotes)
                f = footnotes[i]
                rendered_cell *= "[^$f]"
            end
        end

        if table_data.show_column_labels && (action == :column_label)
            # Apply the style to the column label.
            rendered_cell = _markdown__apply_style(
                if ir == 1
                    if style.first_line_column_label isa Vector{MarkdownStyle}
                        style.first_line_column_label[jr]
                    else
                        style.first_line_column_label
                    end
                else
                    if style.column_label isa Vector{MarkdownStyle}
                        style.column_label[jr]
                    else
                        style.column_label
                    end
                end,
                rendered_cell,
            )

            column_labels[ir, jr] = rendered_cell

        elseif action == :data
            # Check if we must apply highlighters.
            if !isempty(highlighters)
                for h in highlighters
                    if h.f(orig_data, ps.i, ps.j)
                        d = h.fd(h, orig_data, ps.i, ps.j)
                        rendered_cell = _markdown__apply_style(d, rendered_cell)
                        break
                    end
                end
            end

            table_str[ir, jr] = rendered_cell

        elseif !isnothing(summary_rows) && (action == :summary_row_cell)
            rendered_cell = _markdown__apply_style(style.summary_row_cell, rendered_cell)

            summary_rows[ir, jr] = rendered_cell

        elseif !isnothing(row_labels) && (action == :row_label)
            rendered_cell = _markdown__apply_style(style.row_label, rendered_cell)

            row_labels[ir] = rendered_cell

        elseif !isnothing(summary_row_labels) && (action == :summary_row_label)
            rendered_cell = _markdown__apply_style(style.summary_row_label, rendered_cell)

            summary_row_labels[ir] = rendered_cell
        end
    end

    # We now must unify the column labels into one cell because Markdown does not support
    # headers with multiple lines.
    if !isnothing(column_labels)
        for j in last(axes(column_labels))
            for i in first(axes(column_labels))
                i == first(first(axes(column_labels))) && continue
                column_labels[1, j] *= "<br>" * column_labels[i, j]
            end
        end
    end

    # Finally, we must apply the style to the other fields in the header.
    decorated_row_number_column_label = _markdown__apply_style(
        style.row_number_label, table_data.row_number_column_label
    )

    decorated_stubhead_label = _markdown__apply_style(
        style.stubhead_label, table_data.stubhead_label
    )

    # == Compute the Column Width ==========================================================

    row_number_column_width    = 1
    row_label_column_width     = 1
    printed_data_column_widths = ones(Int, num_printed_data_columns)

    # When we are printing in compact mode, we do not need to compute the column widths.
    if !tf.compact_table
        if table_data.show_row_number_column
            m =
                if (
                    _is_vertically_cropped(table_data) &&
                    (table_data.vertical_crop_mode == :bottom)
                )
                    table_data.maximum_number_of_rows
                else
                    table_data.num_rows
                end

            # The printed row numbers run from `first_row_index` to `first_row_index + m - 1`,
            # which can be negative when the data has a non 1-based row axis. Notice that
            # `ndigits` must be used instead of `floor(Int, log10(m) + 1)` because the latter
            # throws an `InexactError` for an empty table, where `log10(0) == -Inf`.
            f = table_data.first_row_index
            l = f + max(m, 1) - 1

            # The row numbers are decorated with the style `row_number`. Hence, we must take
            # the decoration width into account when computing the column width.
            rnsw = _markdown__style_textwidth(style.row_number)

            row_number_column_width = max(
                textwidth(decorated_row_number_column_label),
                ndigits(f) + (f < 0) + rnsw,
                ndigits(l) + (l < 0) + rnsw,
            )
        end

        if _has_row_labels(table_data)
            row_label_column_width = max(
                textwidth(decorated_stubhead_label),
                num_printed_data_rows > 0 ? maximum(textwidth, row_labels) : 0,
                if !isnothing(summary_row_labels)
                    maximum(textwidth, summary_row_labels)
                else
                    0
                end,
            )
        end

        @views for j in last(axes(table_str))
            m = if !isnothing(column_labels)
                maximum(textwidth, column_labels[:, j])
            else
                0
            end

            if num_printed_data_rows > 0
                m = max(maximum(textwidth, table_str[:, j]), m)

                if _has_summary_rows(table_data)
                    m = max(maximum(textwidth, summary_rows[:, j]), m)
                end
            end

            printed_data_column_widths[j] = m
        end

        # Markdown does not support merging rows. Hence, if we have a row group label, we must
        # add the information in the first column. Thus, we need to possibly increase this cell
        # accordingly.
        if _has_row_group_labels(table_data)
            m =
                maximum(x -> textwidth(last(x)), table_data.row_group_labels) +
                _markdown__style_textwidth(style.row_group_label)

            if table_data.show_row_number_column
                row_number_column_width = max(row_number_column_width, m)

            elseif _has_row_labels(table_data)
                row_label_column_width = max(row_label_column_width, m)

            else
                printed_data_column_widths[1] = max(printed_data_column_widths[1], m)
            end
        end
    end

    # == Print the Table ===================================================================

    ps     = PrintingTableState()
    action = :initialize

    # We must store the index related to the rendered tables. These indices differ from the
    # actual table indices due to cropping.
    ir = jr = 0

    # Variable to store if the header was already printed.
    header_printed = false

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)
        ir, jr = _update_data_cell_indices(action, rs, ps, ir, jr)

        action == :end_printing && break

        # We must skip if we are at the column label section but not in the first line.
        (rs == :column_labels && header_printed) && continue

        # Special treatment for table header and footer.
        if rs == :table_header
            if action ∈ (:title, :subtitle)
                l = action == :title ? tf.title_heading_level : tf.subtitle_heading_level

                # If the heading level is not positive, the title or subtitle is printed as
                # plain text.
                if l > 0
                    print(buf, "#"^l)
                    print(buf, " ")
                end

                rendered_cell = _markdown__escape_str(
                    _current_cell(action, ps, table_data), line_breaks, true
                )

                println(buf, rendered_cell)
                println(buf)
            end

            continue

        elseif rs == :table_footer
            if action == :footnote
                rendered_cell = _markdown__escape_str(
                    _current_cell(action, ps, table_data), line_breaks, true
                )

                ps.i == 1 && println(buf)
                print(buf, "[^$(ps.i)]: ")
                println(buf, _markdown__apply_style(style.footnote, rendered_cell))

            elseif action == :source_notes
                rendered_cell = _markdown__escape_str(
                    _current_cell(action, ps, table_data), line_breaks, true
                )

                println(buf)
                println(buf, _markdown__apply_style(style.source_note, rendered_cell))
            end

            continue
        end

        if action == :new_row
            # In case we do not have column labels, we must at least print the header line.
            if !header_printed && (rs == :data)
                _markdown__print_header_separator(
                    buf,
                    table_data,
                    row_number_column_width,
                    row_label_column_width,
                    printed_data_column_widths,
                )
                header_printed = true
            end

            print(buf, "|")

        elseif action == :diagonal_continuation_cell
            print(buf, " ⋱ |")

        elseif action == :horizontal_continuation_cell
            print(buf, " ⋯ |")

        elseif action ∈ _VERTICAL_CONTINUATION_CELL_ACTIONS
            alignment = _current_cell_alignment(action, ps, table_data)

            cell_width = if action == :row_number_vertical_continuation_cell
                row_number_column_width
            elseif action == :row_label_vertical_continuation_cell
                row_label_column_width
            else
                printed_data_column_widths[jr]
            end

            print(buf, " ")

            if !tf.compact_table
                _markdown__print_aligned(buf, "⋮", cell_width, alignment)
            else
                print(buf, "⋮")
            end

            print(buf, " |")

        elseif action == :end_row
            # Obtain the next row section since some actions depend on it.
            _, next_rs, _ = _next(ps, table_data)

            println(buf)

            if (rs == :column_labels)
                header_printed = true

                # We only reach this point at the first line.
                _markdown__print_header_separator(
                    buf,
                    table_data,
                    row_number_column_width,
                    row_label_column_width,
                    printed_data_column_widths,
                )

            elseif tf.line_before_summary_rows &&
                (rs != :summary_row) &&
                (next_rs == :summary_row)
                _markdown__print_separation_line(
                    buf,
                    table_data,
                    tf.horizontal_line_char,
                    row_number_column_width,
                    row_label_column_width,
                    printed_data_column_widths,
                )

            elseif next_rs ∈ (:table_footer, :end_printing)
                # We reach this point only once because the Markdown table ends here. Thus,
                # we need to check if we must print the omitted cell summary.
                if pspec.show_omitted_cell_summary
                    ocs = _omitted_cell_summary(table_data, pspec)

                    if !isempty(ocs)
                        println(buf)
                        println(
                            buf, _markdown__apply_style(style.omitted_cell_summary, ocs)
                        )
                    end
                end
            end

        elseif action == :row_group_label
            row_group_label = _markdown__apply_style(
                style.row_group_label, _current_cell(action, ps, table_data)
            )

            # In this case, we write the row group to the first cell and fill the entire
            # table with empty data.
            _markdown__print_row_group_line(
                buf,
                row_group_label,
                table_data,
                tf.horizontal_line_char,
                row_number_column_width,
                row_label_column_width,
                printed_data_column_widths,
            )

        else
            alignment     = _current_cell_alignment(action, ps, table_data)
            cell_width    = 1
            rendered_cell = ""

            print(buf, " ")

            if action == :row_number_label
                cell_width    = row_number_column_width
                rendered_cell = decorated_row_number_column_label

            elseif action == :stubhead_label
                cell_width    = row_label_column_width
                rendered_cell = decorated_stubhead_label

            elseif action == :row_label
                cell_width    = row_label_column_width
                rendered_cell = row_labels[ir]

            elseif action == :summary_row_number
                cell_width    = row_number_column_width
                rendered_cell = ""

            elseif action == :summary_row_label
                cell_width    = row_label_column_width
                rendered_cell = summary_row_labels[ir]

            elseif action == :column_label
                cell_width = printed_data_column_widths[jr]

                # We need to check if we are in a cell that should be merged. Since Markdown
                # does not support such an operation, we only fill the field with `-`.
                rendered_cell = if _current_cell(action, ps, table_data) === _IGNORE_CELL
                    string(tf.horizontal_line_char)^cell_width
                else
                    column_labels[ir, jr]
                end

            elseif action == :row_number
                cell          = _current_cell(action, ps, table_data)
                cell_width    = row_number_column_width
                rendered_cell = _markdown__apply_style(
                    style.row_number, _markdown__render_cell(cell, buf, renderer)
                )

            elseif action == :data
                cell_width    = printed_data_column_widths[jr]
                rendered_cell = table_str[ir, jr]

            elseif action == :summary_row_cell
                cell_width    = printed_data_column_widths[jr]
                rendered_cell = summary_rows[ir, jr]
            end

            if !tf.compact_table
                _markdown__print_aligned(buf, rendered_cell, cell_width, alignment)
            else
                print(buf, rendered_cell)
            end

            print(buf, " |")
        end
    end

    # == Print the Buffer Into the IO ======================================================

    output_str = String(take!(buf_io))

    if !pspec.new_line_at_end
        output_str = chomp(output_str)
    end

    print(context, output_str)

    return nothing
end

## Description #############################################################################
#
# Tests related to the internal functions that return the cell data.
#
############################################################################################

@testset "Cell Data" verbose = true begin
    @testset "Without Merged Column Labels" begin
        # == Create the Table Data =============================================================

        data = [
            1  2  3  4
            5  6  7  8
            9 10 11 12
        ]

        summary_rows = [(data, j) -> 20j, (data, j) -> 30j, sum]

        td = PrettyTables.TableData(;
            data,
            title                       = "Table Title",
            subtitle                    = "Table Subtitle",
            column_labels               = [["1-1", "1-2", "1-3", "1-4"], ["2-1", "2-2", "2-3", "2-4"]],
            stubhead_label              = "Stubhead Label",
            show_row_number_column      = true,
            row_number_column_label     = "Row Number",
            row_labels                  = ["Row 1", "Row 2", "Row 3"],
            row_group_labels            = [2 => "Row Group"],
            summary_rows                = summary_rows,
            summary_row_labels          = PrettyTables.SummaryLabelIterator(summary_rows),
            footnotes                   = [(:data, 1, 1) => "Footnote 1", (:data, 2, 2) => "Footnote 2"],
            source_notes                = "Source Notes",
            data_alignment              = [:l, :c, :r, :l],
            column_label_alignment      = [:r, :r, :l, :c],
            row_label_column_alignment  = :r,
            row_number_column_alignment = :c,
            num_rows                    = 3,
            num_columns                 = 4,
            first_row_index             = 1,
            first_column_index          = 1,
            formatters                  = [(v, i, j) -> i == 2 ? v + 10 : v],
        )

        # == Iterate the Printing Table ps =================================================

        ps = PrettyTables.PrintingTableState()

        # -- Table Header ------------------------------------------------------------------

        # .. Table Title ...................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        cell = PrettyTables._current_cell(action, ps, td)
        @test cell == "Table Title"

        action, rs, ps = PrettyTables._next(ps, td)

        # .. Table Subtitle ................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        cell = PrettyTables._current_cell(action, ps, td)
        @test cell == "Table Subtitle"

        action, rs, ps = PrettyTables._next(ps, td)

        # -- Column Labels -----------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == (i == 1 ? "Row Number" : "")

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == (i == 1 ? "Stubhead Label" : "")

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)
                @test cell == "$i-$j"
            end

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Table Data --------------------------------------------------------------------

        for i in 1:3
            if i == 2
                action, rs, ps = PrettyTables._next(ps, td)

                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)
                @test cell == "Row Group"

                action, rs, ps = PrettyTables._next(ps, td)
            end

            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == i

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == "Row $i"

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)
                # Notice that we have a formatter that changes the second line.
                @test cell == (i - 1) * 4 + j + ((i == 2) ? 10 : 0)
            end

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Table Summary -----------------------------------------------------------------

        for i in 1:3
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == ""

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == (i == 3 ? "sum" : "Summary $i")

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)

                if i ∈ (1, 2)
                    @test cell == (10i + 10) * j
                else
                    @test cell == sum(data[:, j])
                end
            end

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Footnotes ---------------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == "Footnote $i"

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Source Notes ------------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        cell = PrettyTables._current_cell(action, ps, td)
        @test cell == "Source Notes"

        action, rs, ps = PrettyTables._next(ps, td)
    end

    @testset "With Merged Column Labels" begin
        # == Create the Table Data =========================================================

        data = [
            1  2  3  4
            5  6  7  8
            9 10 11 12
        ]
        summary_rows = [(data, j) -> 20j, (data, j) -> 30j, sum]

        td = PrettyTables.TableData(;
            data,
            title                       = "Table Title",
            subtitle                    = "Table Subtitle",
            column_labels               = [["1-1", "1-2", "1-3", "1-4"], ["2-1", "2-2", "2-3", "2-4"]],
            stubhead_label              = "Stubhead Label",
            show_row_number_column      = true,
            row_number_column_label     = "Row Number",
            row_labels                  = ["Row 1", "Row 2", "Row 3"],
            row_group_labels            = [2 => "Row Group"],
            summary_rows                = summary_rows,
            summary_row_labels          = PrettyTables.SummaryLabelIterator(summary_rows),
            footnotes                   = [(:data, 1, 1) => "Footnote 1", (:data, 2, 2) => "Footnote 2"],
            source_notes                = "Source Notes",
            merge_column_label_cells    = [MergeCells(1, 2, 2, "Merged #1"), MergeCells(2, 1, 2, "Merged #2")],
            data_alignment              = [:l, :c, :r, :l],
            column_label_alignment      = [:r, :r, :l, :c],
            row_label_column_alignment  = :r,
            row_number_column_alignment = :c,
            num_rows                    = 3,
            num_columns                 = 4,
            first_row_index             = 1,
            first_column_index          = 1,
            formatters                  = [(v, i, j) -> i == 2 ? v + 10 : v],
        )

        # == Iterate the Printing Table ps =================================================

        ps = PrettyTables.PrintingTableState()

        # -- Table Header ------------------------------------------------------------------

        # .. Table Title ...................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        cell = PrettyTables._current_cell(action, ps, td)
        @test cell == "Table Title"

        action, rs, ps = PrettyTables._next(ps, td)

        # .. Table Subtitle ................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        cell = PrettyTables._current_cell(action, ps, td)
        @test cell == "Table Subtitle"

        action, rs, ps = PrettyTables._next(ps, td)

        # -- Column Labels -----------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == (i == 1 ? "Row Number" : "")

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == (i == 1 ? "Stubhead Label" : "")

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)

                expected = if (i == 1) && (j == 2)
                    MergeCells(1, 2, 2, "Merged #1")
                elseif (i == 1) && (j == 3)
                    PrettyTables._IGNORE_CELL
                elseif (i == 2) && (j == 1)
                    MergeCells(2, 1, 2, "Merged #2")
                elseif (i == 2) && (j == 2)
                    PrettyTables._IGNORE_CELL
                else
                    "$i-$j"
                end

                @test cell == expected
            end

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Table Data --------------------------------------------------------------------

        for i in 1:3
            if i == 2
                action, rs, ps = PrettyTables._next(ps, td)

                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)
                @test cell == "Row Group"

                action, rs, ps = PrettyTables._next(ps, td)
            end

            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == i

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == "Row $i"

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)
                # Notice that we have a formatter that changes the second line.
                @test cell == (i - 1) * 4 + j + ((i == 2) ? 10 : 0)
            end

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Table Summary -----------------------------------------------------------------

        for i in 1:3
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == ""

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == (i == 3 ? "sum" : "Summary $i")

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                cell = PrettyTables._current_cell(action, ps, td)

                if i ∈ (1, 2)
                    @test cell == (10i + 10) * j
                else
                    @test cell == sum(data[:, j])
                end
            end

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Footnotes ---------------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            cell = PrettyTables._current_cell(action, ps, td)
            @test cell == "Footnote $i"

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Source Notes ------------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        cell = PrettyTables._current_cell(action, ps, td)
        @test cell == "Source Notes"

        action, rs, ps = PrettyTables._next(ps, td)
    end

    @testset "Current Cell Footnotes" begin
        """Create table data with the specified footnotes for testing."""
        function table_data_with_footnotes(footnotes)
            return PrettyTables.TableData(;
                data          = reshape([1], 1, 1),
                column_labels = [Any["Column"]],
                footnotes,
                num_rows           = 1,
                num_columns        = 1,
                first_row_index    = 1,
                first_column_index = 1,
            )
        end

        td = table_data_with_footnotes(nothing)
        @test isnothing(PrettyTables._current_cell_footnotes(td, :data, 1, 1))

        td = table_data_with_footnotes([(:data, 2, 1) => "No match"])
        @test isnothing(PrettyTables._current_cell_footnotes(td, :data, 1, 1))

        td = table_data_with_footnotes([(:data, 1, 1) => "Match"])
        @test PrettyTables._current_cell_footnotes(td, :data, 1, 1) == [1]

        td = table_data_with_footnotes([
            (:data, 1, 1) => "First match",
            (:data, 2, 1) => "No match",
            (:data, 1, 1) => "Second match",
        ])
        @test PrettyTables._current_cell_footnotes(td, :data, 1, 1) == [1, 3]
    end
end

## Description #############################################################################
#
# Function to render the table in the text back end.
#
############################################################################################

"""
    _text__render_table(
        table_data::TableData,
        rctx::RenderContext,
        renderer::Union{Val{:print}, Val{:show}},
        line_breaks::Bool,
        maximum_data_column_widths::AbstractVector{Int},
        vertical_lines_at_data_columns::AbstractVector{Int}
    )

Render the table using the specification in `table_data`. When the cells are converted to
`String`, we use the render context `rctx`, and the `renderer`.

If `line_breaks` is `true`, we split each cell into multiple lines at every occurrence of
`\\n`.

`maximum_data_column_widths` must contain the user specification for the maximum data column
widths, whereas `vertical_lines_at_data_columns` must contain the list of columns where a
vertical line is drawn after the cell. The latter is required to compute the available width
of merged column labels.

# Returns

- `Union{Nothing, Vector{String}}`: Rendered row labels.
- `Union{Nothing, Matrix{String}}`: Rendered column labels.
- `Matrix{String}`: Rendered data cells.
- `Union{Nothing, Matrix{String}}`: Rendered summary rows.
- `Union{Nothing, Vector{String}}`: Rendered summary row labels.
- `Union{Nothing, Vector{String}}`: Rendered footnotes.
- `Union{Nothing, Dict{NTuple{2, Int}, AbstractCustomTextCell}}`: Custom text cells found
    during the rendering, keyed by the rendered data cell indices, or `nothing` if the
    table has none.
"""
function _text__render_table(
    table_data::TableData,
    rctx::RenderContext,
    renderer::Union{Val{:print}, Val{:show}},
    line_breaks::Bool,
    maximum_data_column_widths::AbstractVector{Int},
    vertical_lines_at_data_columns::AbstractVector{Int},
)
    num_column_label_lines   = length(table_data.column_labels)
    num_printed_data_columns = _number_of_printed_data_columns(table_data)
    num_printed_data_rows    = _number_of_printed_data_rows(table_data)
    num_summary_rows         = _has_summary_rows(table_data) ? length(table_data.summary_rows) : 0
    num_footnotes            = _has_footnotes(table_data) ? length(table_data.footnotes) : 0

    # Let's allocate all the sections.
    column_labels = if table_data.show_column_labels
        Matrix{String}(undef, num_column_label_lines, num_printed_data_columns)
    else
        nothing
    end

    # Notice that we must not allocate the label vectors with `undef` because the printing
    # iterator does not fill them if the table has no printed columns, leading to undefined
    # references when computing the column widths.
    row_labels =
        _has_row_labels(table_data) ? fill("", num_printed_data_rows) : nothing

    table_str = Matrix{String}(undef, num_printed_data_rows, num_printed_data_columns)

    summary_rows =
        _has_summary_rows(table_data) ?
        Matrix{String}(undef, num_summary_rows, num_printed_data_columns) : nothing

    summary_row_labels =
        _has_summary_rows(table_data) ? fill("", num_summary_rows) : nothing

    footnotes = _has_footnotes(table_data) ? Vector{String}(undef, num_footnotes) : nothing

    # Custom text cells must be accessed as live objects when printing. We record them here
    # so the printing pass does not need to fetch the data cells again, which would re-run
    # the formatters. Most tables have no custom cells, meaning that this variable stays
    # `nothing` and the common path allocates nothing.
    custom_cells = nothing

    action = :initialize

    # We must store the index related to the rendered tables. These indices differ from the
    # actual table indices due to cropping.
    ir = jr = 0

    ps = PrintingTableState()

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)

        action == :end_printing && break

        ir, jr = _update_data_cell_indices(action, rs, ps, ir, jr)

        action ∉ (
            :column_label,
            :data,
            :summary_row_cell,
            :row_label,
            :summary_row_label,
            :footnote,
        ) && continue

        # We should only break lines if we are in a data cell.
        lb = (action == :data) && line_breaks

        cell = _current_cell(action, ps, table_data)

        if (action == :data) && (cell isa AbstractCustomTextCell)
            if isnothing(custom_cells)
                custom_cells = Dict{NTuple{2, Int}, AbstractCustomTextCell}()
            end

            custom_cells[(ir, jr)] = cell
        end

        mw =
            (action ∈ (:column_label, :data, :summary_row_cell)) ?
            maximum_data_column_widths[ps.j] : -1

        # A merged column label spans multiple columns. Hence, its maximum width must be
        # computed from all the spanned columns.
        if (action == :column_label) && (cell isa MergeCells)
            j₀ = ps.j
            j₁ = min(ps.j + cell.column_span - 1, num_printed_data_columns)

            mw = 0

            for j in j₀:j₁
                mwj = maximum_data_column_widths[j]

                # If any spanned column has no maximum width, the merged cell width is
                # unlimited.
                if mwj <= 0
                    mw = -1
                    break
                end

                mw += mwj

                # We must also take into account the margins and vertical lines between the
                # merged columns.
                if j != j₁
                    mw += 2 + (j ∈ vertical_lines_at_data_columns)
                end
            end
        end

        rendered_cell = if cell !== _IGNORE_CELL
            _text__render_cell(cell, rctx, renderer, lb, mw)
        else
            ""
        end

        # Check for footnotes.
        cell_footnotes = _current_cell_footnotes(table_data, action, ps.i, ps.j)

        if !isnothing(cell_footnotes) && !isempty(cell_footnotes)
            for i in eachindex(cell_footnotes)
                f = cell_footnotes[i]
                rendered_cell *= _text__render_footnote_superscript(f)
                (i != last(eachindex(cell_footnotes))) && (rendered_cell *= "ʼ")
            end
        end

        if !isnothing(column_labels) && (action == :column_label)
            column_labels[ir, jr] = rendered_cell

        elseif (action == :data)
            table_str[ir, jr] = rendered_cell

        elseif !isnothing(summary_rows) && (action == :summary_row_cell)
            summary_rows[ir, jr] = rendered_cell

        elseif !isnothing(row_labels) && (action == :row_label)
            row_labels[ir] = rendered_cell

        elseif !isnothing(summary_row_labels) && (action == :summary_row_label)
            summary_row_labels[ir] = rendered_cell

        elseif !isnothing(footnotes) && (action == :footnote)
            id = ps.i
            footnotes[id] = _text__render_footnote_superscript(id) * ": " * rendered_cell
        end

        # If the user requested a maximum data column width, check the current size and crop
        # accordingly.
        if action == :column_label
            column_labels[ir, jr] = _text__fit_cell_in_maximum_cell_width(
                column_labels[ir, jr], mw, false
            )
        elseif action == :data
            table_str[ir, jr] = _text__fit_cell_in_maximum_cell_width(
                table_str[ir, jr], mw, line_breaks
            )
        elseif action == :summary_row_cell
            summary_rows[ir, jr] = _text__fit_cell_in_maximum_cell_width(
                summary_rows[ir, jr], mw, false
            )
        end
    end

    return row_labels, column_labels, table_str, summary_rows, summary_row_labels,
        footnotes, custom_cells
end

## Description #############################################################################
#
# HTML Back End: Test related with the column  widths.
#
############################################################################################

@testset "Maximum Column Width" begin
    matrix = [(i, j) for i in 1:3, j in 1:3]

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">Col. 1</th>
      <th style = "font-weight: bold; max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">Col. 2</th>
      <th style = "font-weight: bold; max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">Col. 3</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(1, 1)</td>
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(1, 2)</td>
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(1, 3)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(2, 1)</td>
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(2, 2)</td>
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(2, 3)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(3, 1)</td>
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(3, 2)</td>
      <td style = "max-width: 30px; overflow: hidden; text-align: right; text-overflow: ellipsis; white-space: nowrap;">(3, 3)</td>
    </tr>
  </tbody>
</table>
"""

    result = pretty_table(String, matrix; backend = :html, maximum_column_width = "30px")

    @test result == expected
end

## Description #############################################################################
#
# Markdown Back End: Test the compact option.
#
############################################################################################

@testset "Compact Table" verbose = true begin
    matrix = [(i, j) for i in 1:4, j in 1:4]

    @testset "Without Cropping" begin
        expected = """
# Table Title

## Table Subtitle

| **Row** | **Rows** | **Col. 1**<br>`1` | **Merged Column[^1]**<br>`2` | ─ | **Col. 4**<br>`4` |
|--:|--:|--:|--:|--:|--:|
| **1** | **Row 1** | (1, 1) | (1, 2) | (1, 3) | (1, 4) |
| **Row Group** | ─ | ─ | ─ | ─ | ─ |
| **2** | **Row 2** | (2, 1) | (2, 2)[^2] | (2, 3) | (2, 4) |
| **3** | **Row 3** | (3, 1) | (3, 2) | (3, 3) | (3, 4) |
| **4** | **Row 4** | (4, 1) | (4, 2) | (4, 3) | (4, 4) |
| ─ | ─ | ─ | ─ | ─ | ─ |
|  | **Summary 1** | 10 | 20 | 30 | 40 |
|  | **Summary 2** | 20 | 40 | 60 | 80 |

[^1]: Footnote in column label
[^2]: Footnote in data

Source Notes
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            column_labels = [["Col. $i" for i in 1:4], ["$i" for i in 1:4]],
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            table_format = MarkdownTableFormat(; compact_table = true),
            title = "Table Title",
        )

        @test result == expected

        expected = """
# Table Title

## Table Subtitle

| **Rows** | **Col. 1**<br>`1` | **Merged Column[^1]**<br>`2` | ─ | **Col. 4**<br>`4` |
|--:|--:|--:|--:|--:|
| **Row 1** | (1, 1) | (1, 2) | (1, 3) | (1, 4) |
| **Row Group** | ─ | ─ | ─ | ─ |
| **Row 2** | (2, 1) | (2, 2)[^2] | (2, 3) | (2, 4) |
| **Row 3** | (3, 1) | (3, 2) | (3, 3) | (3, 4) |
| **Row 4** | (4, 1) | (4, 2) | (4, 3) | (4, 4) |
| ─ | ─ | ─ | ─ | ─ |
| **Summary 1** | 10 | 20 | 30 | 40 |
| **Summary 2** | 20 | 40 | 60 | 80 |

[^1]: Footnote in column label
[^2]: Footnote in data

Source Notes
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            column_labels = [["Col. $i" for i in 1:4], ["$i" for i in 1:4]],
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = false,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            table_format = MarkdownTableFormat(; compact_table = true),
            title = "Table Title",
        )

        @test result == expected
    end

    @testset "With Bottom Cropping" begin
        expected = """
# Table Title

## Table Subtitle

| **Row** | **Rows** | **Col. 1** | **Merged Column[^1]** | ⋯ |
|--:|--:|--:|--:|---|
| **1** | **Row 1** | (1, 1) | (1, 2) | ⋯ |
| **Row Group** | ─ | ─ | ─ | ⋯ |
| **2** | **Row 2** | (2, 1) | (2, 2)[^2] | ⋯ |
| ⋮ | ⋮ | ⋮ | ⋮ | ⋱ |
| ─ | ─ | ─ | ─ | ─ |
|  | **Summary 1** | 10 | 20 | ⋯ |
|  | **Summary 2** | 20 | 40 | ⋯ |

*2 columns and 2 rows omitted*

[^1]: Footnote in column label
[^2]: Footnote in data

Source Notes
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            table_format = MarkdownTableFormat(; compact_table = true),
            title = "Table Title",
        )

        @test result == expected
    end

    @testset "With Middle Cropping" begin
        expected = """
# Table Title

## Table Subtitle

| **Row** | **Rows** | **Col. 1** | **Merged Column[^1]** | ⋯ |
|--:|--:|--:|--:|---|
| **1** | **Row 1** | (1, 1) | (1, 2) | ⋯ |
| ⋮ | ⋮ | ⋮ | ⋮ | ⋱ |
| **4** | **Row 4** | (4, 1) | (4, 2) | ⋯ |
| ─ | ─ | ─ | ─ | ─ |
|  | **Summary 1** | 10 | 20 | ⋯ |
|  | **Summary 2** | 20 | 40 | ⋯ |

*2 columns and 2 rows omitted*

[^1]: Footnote in column label
[^2]: Footnote in data

Source Notes
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            table_format = MarkdownTableFormat(; compact_table = true),
            title = "Table Title",
            vertical_crop_mode = :middle,
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# LaTeX Back End: Test showing all the available fields.
#
############################################################################################

@testset "All Available Fields" verbose = true begin
    matrix = [(i, j) for i in 1:3, j in 1:3]

    expected = """
\\begin{tabular}{|r|r|r|r|r|}
  \\multicolumn{5}{@{}c@{}}{\\textbf{\\large{Table Title}}} \\\\
  \\multicolumn{5}{@{}c@{}}{\\textit{Table Subtitle}} \\\\
  \\hline
  \\textbf{Row} & \\textbf{Rows} & \\textbf{Col. 1} & \\multicolumn{2}{@{}c|@{}}{\\textbf{Merged Column}\$^{1}\$} \\\\
  \\cline{4-5}
   &  & \\textit{1} & \\textit{2} & \\textit{3} \\\\
  \\hline
  1 & \\textbf{Row 1} & (1, 1) & (1, 2) & (1, 3) \\\\
  \\hline
  \\multicolumn{5}{|l|}{\\textbf{Row Group}} \\\\
  \\hline
  2 & \\textbf{Row 2} & (2, 1) & (2, 2)\$^{2}\$ & (2, 3) \\\\
  3 & \\textbf{Row 3} & (3, 1) & (3, 2) & (3, 3) \\\\
  \\hline
   & \\textbf{Summary 1} & 10 & 20 & 30 \\\\
   & \\textbf{Summary 2} & 20 & 40 & 60 \\\\
  \\hline
  \\multicolumn{5}{@{}l@{}}{\\small{\$^{1}\$Footnote in column label}} \\\\
  \\multicolumn{5}{@{}l@{}}{\\small{\$^{2}\$Footnote in data}} \\\\
  \\multicolumn{5}{@{}l@{}}{\\textit{\\small{Source Notes}}} \\\\
\\end{tabular}
"""

    result = pretty_table(
        String,
        matrix;
        backend = :latex,
        column_labels = [["Col. $i" for i in 1:3], ["$i" for i in 1:3]],
        footnotes = [
            (:column_label, 1, 2) => "Footnote in column label",
            (:data, 2, 2) => "Footnote in data",
        ],
        merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
        row_group_labels = [2 => "Row Group"],
        row_labels = ["Row $i" for i in 1:5],
        show_row_number_column = true,
        source_notes = "Source Notes",
        stubhead_label = "Rows",
        subtitle = "Table Subtitle",
        summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
        title = "Table Title",
    )

    @test result == expected
end

## Description #############################################################################
#
# LaTeX Back End: Tests related to table cropping.
#
############################################################################################

@testset "Table Cropping" verbose = true begin
    matrix = [(i, j) for i in 1:100, j in 1:100]

    @testset "Bottom Cropping" begin
        expected = """
\\begin{tabular}{|r|r|r|c|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \$\\cdots\$ \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & \$\\cdots\$ \\\\
  (2, 1) & (2, 2) & (2, 3) & \$\\cdots\$ \\\\
  \$\\vdots\$ & \$\\vdots\$ & \$\\vdots\$ & \$\\ddots\$ \\\\
  \\hline
  \\multicolumn{4}{r@{}}{\\textit{\\small{97 columns and 98 rows omitted}}}
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
        )

        @test result == expected
    end

    @testset "Middle Cropping" begin
        expected = """
\\begin{tabular}{|r|r|r|c|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \$\\cdots\$ \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & \$\\cdots\$ \\\\
  \$\\vdots\$ & \$\\vdots\$ & \$\\vdots\$ & \$\\ddots\$ \\\\
  (100, 1) & (100, 2) & (100, 3) & \$\\cdots\$ \\\\
  \\hline
  \\multicolumn{4}{r@{}}{\\textit{\\small{97 columns and 98 rows omitted}}}
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
            vertical_crop_mode = :middle,
        )

        @test result == expected
    end

    @testset "Omitted Cell Summary" begin
        expected = """
\\begin{tabular}{|r|r|r|c|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \$\\cdots\$ \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & \$\\cdots\$ \\\\
  (2, 1) & (2, 2) & (2, 3) & \$\\cdots\$ \\\\
  \$\\vdots\$ & \$\\vdots\$ & \$\\vdots\$ & \$\\ddots\$ \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
            show_omitted_cell_summary = false,
        )

        @test result == expected
    end

    @testset "Omitted Cell Summary With Table Footer" begin
        # The omitted cell summary row must be terminated with `\\\\` when the table footer
        # is printed afterward. Otherwise, the footer cells would be rendered in the same
        # tabular row, leading to an invalid LaTeX document.
        expected = """
\\begin{tabular}{|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} \\\\
  \\hline
  1\$^{1}\$ & 2 \\\\
  \$\\vdots\$ & \$\\vdots\$ \\\\
  \\hline
  \\multicolumn{2}{r@{}}{\\textit{\\small{2 rows omitted}}} \\\\
  \\multicolumn{2}{@{}l@{}}{\\small{\$^{1}\$Note}} \\\\
\\end{tabular}
"""

        result = pretty_table(
            String,
            [1 2; 3 4; 5 6];
            backend = :latex,
            footnotes = [(:data, 1, 1) => "Note"],
            maximum_number_of_rows = 1,
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# Excel Back End: Types, structures and constructors.
#
############################################################################################

export ExcelPair, ExcelHighlighter, ExcelTableBorders, ExcelTableFormat, ExcelTableStyle
export ExcelFormatter

############################################################################################
#                                       Constants                                          #
############################################################################################

# Pair that defines Excel properties.
const ExcelPair = Pair{String, String}

# Create some default table style definitions to reduce allocations.
const _EXCEL__NO_DECORATION     = ExcelPair[]
const _EXCEL__BOLD              = ["bold" => "true"]
const _EXCEL__ITALIC            = ["italic" => "true"]
const _EXCEL__XLARGE_BOLD       = ["size" => "18", "bold" => "true"]
const _EXCEL__LARGE_ITALIC      = ["size" => "14", "italic" => "true"]
const _EXCEL__SMALL             = ["size" => "10"]
const _EXCEL__SMALL_ITALIC      = ["size" => "10", "italic" => "true"]
const _EXCEL__SMALL_ITALIC_GRAY = ["color" => "gray", "size" => "10", "italic" => "true"]

const _EXCEL__MEDIUM_BORDER = ["style" => "medium", "color" => "Black"]
const _EXCEL__THICK_BORDER  = ["style" => "thick", "color" => "Black"]
const _EXCEL__THIN_BORDER   = ["style" => "thin", "color" => "Black"]

############################################################################################
#                                       Highlighters                                       #
############################################################################################

"""
    struct ExcelHighlighter

Define the default highlighter of a table when using the Excel back end.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
    highlighter. This function must return a `Vector{ExcelPair}` with the styling attributes
    to apply to the highlighted cell.
- `_decoration::Vector{ExcelPair}`: The decoration applied when the default `fd` is used.

# Remarks

An Excel highlighter can be constructed using the following helpers:

```julia
ExcelHighlighter(f::Function, decoration::ExcelPair)
ExcelHighlighter(f::Function, decoration::Vector{ExcelPair})
ExcelHighlighter(f::Function, fd::Function)
```

The decoration is a flat `Vector{ExcelPair}` (same format as `ExcelTableStyle` fields).
Font attributes are passed directly; fill attributes use the `"cell_fill_"` key prefix
(the prefix is stripped before calling `XLSX.setFill`). Border attributes are not
supported in highlighters.

For example, to highlight cells in column 3 with a value greater than 10 in red bold, cells
with value 0 in green with a solid fill, and cells in column 4 greater than 10 in blue:

```julia
highlighters = [
    ExcelHighlighter((data, i, j) -> (j == 3) && (data[i, j] > 10), [
        "color" => "red", "bold" => "true",
        "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "grey90",
    ]),
    ExcelHighlighter((data, i, j) -> (data[i, j] ≈ 0.0),
        ["color" => "green", "bold" => "true"],
    ),
    ExcelHighlighter((data, i, j) -> (j == 4) && (data[i, j] > 10),
        ["color" => "blue", "bold" => "true"],
    ),
]
```
"""
struct ExcelHighlighter
    f::Function
    fd::Function

    # == Private Fields ====================================================================

    _decoration::Vector{ExcelPair}

    # == Constructors ======================================================================

    function ExcelHighlighter(f::Function, fd::Function)
        return new(f, fd, ExcelPair[])
    end

    function ExcelHighlighter(f::Function, decoration::ExcelPair)
        return new(f, _excel__default_highlighter_fd, [decoration])
    end

    function ExcelHighlighter(f::Function, decoration::Vector{ExcelPair})
        return new(f, _excel__default_highlighter_fd, decoration)
    end
end

_excel__default_highlighter_fd(h::ExcelHighlighter, ::Any, ::Int, ::Int) = h._decoration

############################################################################################
#                                       Formatters                                         #
############################################################################################

"""
    struct ExcelFormatter

Define the Excel format to apply to a cell.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
  if the element `(i, j)` in `data` must be formatted, or `false` otherwise. The first
  argument is the entire data matrix passed to `pretty_table`, allowing `data[i, j]` to be
  inspected inside the predicate.
- `numFmt::Vector{ExcelPair}`: Specifies the format to apply to the cell. The format should be
  specified with an `ExcelPair` (*i.e.* `Pair{String, String}`) using the `XLSX.jl`
  formatting definitions used by the `XLSX.setFormat` function.
- `region::Symbol`: Region of the table in which the formatter is applied. It can be
  `:data` or `:summary_row`. If it is `:data`, the formatter is applied to the data cells
  and the value of `i` passed to `f` is the **data row** index. If it is `:summary_row`,
  the formatter is applied to the summary row cells and the value of `i` passed to `f` is
  the **summary row** index (*i.e.* `1` for the first summary row, `2` for the second, and
  so on).

# Constructors

```julia
ExcelFormatter(f::Function, numFmt::Vector{ExcelPair}; region::Symbol = :data)
```

The keyword `region` defaults to `:data`, so the formatter matches data cells based on the
data row index unless `:summary_row` is explicitly requested.

# Remarks

It is possible to apply a set of native Excel formats by passing a `Vector{ExcelFormatter}`
to the `excel_formatters` keyword. Each Excel formatter is an instance of the structure
[`ExcelFormatter`](@ref).

The first formatter (in the order they are specified) that satisfies the specified condition
in the given table cell is applied, and the remainder of the formatters in the list are
skipped. If none matches, no `ExcelFormatter` is applied.

An `ExcelFormatter` can be applied in the summary row, too. In this case, set `region` to
`:summary_row`. The value of `i` passed to `f` then relates to the summary row index (`1`
for the first summary row, `2` for the second, and so on), rather than the data table row.
The value of `j` has the same meaning/values (column specifier) as in the data table
itself.

Excel formatters may be applied in addition to the standard formatters. The standard
formatters control the literal values written to Excel while the Excel formatters control
how Excel displays the literal cell values.

For example, to apply Excel-native formatting to different columns of a table:

```julia
excel_formatters = [
    ExcelFormatter((data, i, j) -> (j==1), ["format" => "#,##0_0_0"])
    ExcelFormatter((data, i, j) -> (j==2), ["format" => "#,##0.??_0_0"])
    ExcelFormatter((data, i, j) -> (j==3), ["format" => "#,##0.???"])
    ExcelFormatter((data, i, j) -> (j==4), ["format" => "0_0_0_0"])
]
```

Excel formatters apply native Excel formatting to native Excel values. However,
`PrettyTables.jl` can handle Julia types that can't be represented natively in Excel. If
these are passed natively, then XLSX.jl will fail. To circumvent this, a predefined
formatter has been provided which converts any unhandled types to strings (using
`string()`). For more information, see [`fmt__excel_stringify`](@ref).
"""
struct ExcelFormatter
    f::Function
    numFmt::Vector{ExcelPair}
    region::Symbol

    # == Constructors ======================================================================

    function ExcelFormatter(f::Function, numFmt::Vector{ExcelPair}; region::Symbol = :data)
        region ∈ (:data, :summary_row) || throw(
            ArgumentError(
                "The `region` of an `ExcelFormatter` must be `:data` or `:summary_row`."
            ),
        )

        return new(f, numFmt, region)
    end
end

############################################################################################
#                                      Table Borders                                       #
############################################################################################

"""
    struct ExcelTableBorders

Define the border styles for each line type used when printing a table with the Excel back
end. All fields are `Vector{ExcelPair}` compatible with the `XLSX.setBorder` function.

# Fields

## Horizontal Lines

- `top_line::Vector{ExcelPair}`: Style for the top border of the table.
    (**Default**: `["style" => "thick", "color" => "Black"]`)
- `header_line::Vector{ExcelPair}`: Style for the line drawn under the column label
    section.
    (**Default**: `["style" => "medium", "color" => "Black"]`)
- `merged_header_cell_line::Vector{ExcelPair}`: Style for the line below merged header
    cells.
    (**Default**: `["style" => "thin", "color" => "Black"]`)
- `middle_line::Vector{ExcelPair}`: Style for all other internal horizontal lines (data
    row underlines, lines around row groups, lines around summary rows) and for vertical
    lines between data columns.
    (**Default**: `["style" => "thin", "color" => "Black"]`)
- `bottom_line::Vector{ExcelPair}`: Style for the bottom border of the table.
    (**Default**: `["style" => "thick", "color" => "Black"]`)

## Vertical Lines

- `left_line::Vector{ExcelPair}`: Style for the left border of the table.
    (**Default**: `["style" => "thick", "color" => "Black"]`)
- `center_line::Vector{ExcelPair}`: Style for structural vertical lines (after the row
    number column and after the row label column).
    (**Default**: `["style" => "thin", "color" => "Black"]`)
- `right_line::Vector{ExcelPair}`: Style for the right border of the table.
    (**Default**: `["style" => "thick", "color" => "Black"]`)
"""
@kwdef struct ExcelTableBorders
    # == Horizontal Lines ==================================================================

    top_line::Vector{ExcelPair}                = _EXCEL__THICK_BORDER
    header_line::Vector{ExcelPair}             = _EXCEL__MEDIUM_BORDER
    merged_header_cell_line::Vector{ExcelPair} = _EXCEL__THIN_BORDER
    middle_line::Vector{ExcelPair}             = _EXCEL__THIN_BORDER
    bottom_line::Vector{ExcelPair}             = _EXCEL__THICK_BORDER

    # == Vertical Lines ====================================================================

    left_line::Vector{ExcelPair}   = _EXCEL__THICK_BORDER
    center_line::Vector{ExcelPair} = _EXCEL__THIN_BORDER
    right_line::Vector{ExcelPair}  = _EXCEL__THICK_BORDER
end

############################################################################################
#                                       Table Format                                       #
############################################################################################

"""
    struct ExcelTableFormat

Define the table borders that will be used to form the Excel table.

# Fields

- `borders::ExcelTableBorders`: Border style configuration for all line types.
- `horizontal_line_at_beginning::Bool`: Whether to draw a horizontal line at the first
    table row after the title/subtitle section (i.e., the top of the column labels or
    the first data row if there are no column labels). Title and subtitle rows are never
    bordered.
- `horizontal_line_after_column_labels::Bool`: Whether to draw a line under the column
    header section.
- `horizontal_line_between_column_labels::Bool`: Whether to draw a line between (unmerged)
    column header rows.
- `horizontal_line_at_merged_column_labels::Bool`: Whether to draw a line under merged
    column headers.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: Controls which data rows get
    an underline. `:all` draws a line after every data row; `:none` draws none; a
    `Vector{Int}` draws a line only after the listed row indices.
- `horizontal_line_after_data_rows::Bool`: Whether to draw a line under the data table
    section.
- `horizontal_line_before_row_group_label::Bool`: Whether to draw a line above each row
    group divider.
- `horizontal_line_after_row_group_label::Bool`: Whether to draw a line below each row
    group divider.
- `horizontal_line_before_summary_rows::Bool`: Whether to draw a line between the data
    rows and the summary rows.
- `horizontal_line_after_summary_rows::Bool`: Whether to draw a line under the last
    summary row.
- `vertical_line_at_beginning::Bool`: Whether to draw a vertical line at the left side of
    the table (spanning only the content rows, not title/subtitle or footnotes).
- `vertical_line_after_row_number_column::Bool`: Whether to draw a vertical line to the
    right of the row number column.
- `vertical_line_after_row_label_column::Bool`: Whether to draw a vertical line to the
    right of the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: Controls which data columns
    get a right-side divider. `:all` draws after every data column; `:none` draws none; a
    `Vector{Int}` draws only after the listed column indices.
- `vertical_line_after_data_columns::Bool`: Whether to draw a vertical line after the last
    data column (spanning only the content rows, not title/subtitle or footnotes).
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.
"""
@kwdef struct ExcelTableFormat
    borders::ExcelTableBorders = ExcelTableBorders()

    # == Configuration for the Horizontal and Vertical Lines ===============================

    horizontal_line_at_beginning::Bool = true
    horizontal_line_after_column_labels::Bool = true
    horizontal_line_between_column_labels::Bool = false
    horizontal_line_at_merged_column_labels::Bool = true
    horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}} = :none
    horizontal_line_after_data_rows::Bool = true
    horizontal_line_before_row_group_label::Bool = true
    horizontal_line_after_row_group_label::Bool = true
    horizontal_line_before_summary_rows::Bool = true
    horizontal_line_after_summary_rows::Bool = true

    vertical_line_at_beginning::Bool = true
    vertical_line_after_row_number_column::Bool = true
    vertical_line_after_row_label_column::Bool = true
    vertical_lines_at_data_columns::Union{Symbol, Vector{Int}} = :all
    vertical_line_after_data_columns::Bool = true
    vertical_line_after_continuation_column::Bool = true
end

############################################################################################
#                                       Table Style                                        #
############################################################################################

"""
    struct ExcelTableStyle

Define the style (font and cell attributes) of each of the table elements used with the
Excel back end.

# Fields

- `title::Vector{ExcelPair}`: Style for the title.
- `subtitle::Vector{ExcelPair}`: Style for the subtitle.
- `row_number_label::Vector{ExcelPair}`: Style for the row number label.
- `row_number::Vector{ExcelPair}`: Style for the row number.
- `stubhead_label::Vector{ExcelPair}`: Style for the stubhead label.
- `row_label::Vector{ExcelPair}`: Style for the row label.
- `row_group_label::Vector{ExcelPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}}`: Style for
    the first line of the column labels. If a vector of `Vector{ExcelPair}` is provided,
    each column label in the first line will use the corresponding style.
- `column_label::Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}}`: Style for the rest of
    the column labels. If a vector of `Vector{ExcelPair}` is provided, each column label
    will use the corresponding style.
- `first_line_merged_column_label::Vector{ExcelPair}`: Style for the merged cells at the
    first column label line.
- `merged_column_label::Vector{ExcelPair}`: Style for the merged cells at the rest of the
    column labels.
- `data_cell::Vector{ExcelPair}`: Style for the table cells.
- `summary_row_label::Vector{ExcelPair}`: Style for the summary row label.
- `summary_row_cell::Vector{ExcelPair}`: Style for the summary row cell.
- `footnote::Vector{ExcelPair}`: Style for the footnotes.
- `source_note::Vector{ExcelPair}`: Style for the source notes.

# Remarks

Each field corresponds to a table element and should be a vector of `ExcelPair`, *i.e.*
`Pair{String, String}`, describing properties and values compatible with the `XLSX.setFont`
function. We can also define properties to be applied to the cell itself with the function
`XLSX.setFill`. In this case, prefix the parameter name with `"cell_fill_"` (e.g.,
`"cell_fill_pattern" => "solid"`).

It is only necessary to define those fields for which the default style needs to be
overwritten. For example:

# Examples

```julia
style = ExcelTableStyle(
    column_label                   = [["bold" => "true"], ["color" => "red"]], # assuming two columns
    summary_row_label              = ["size" => "8"],
    first_line_merged_column_label = ["bold" => "true", "color" => "orange"],
    footnote                       = ["italic" => "true", "color" => "cyan"],
    row_group_label                = ["bold" => "true", "color" => "magenta"],
    subtitle                       = ["italic" => "true"],
    title                          = ["bold" => "true", "color" => "orange", "size" => "18", "under" => "single"],
)
```
"""
@kwdef struct ExcelTableStyle{
    TFCL <: Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}},
    TCL <: Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}},
}
    title::Vector{ExcelPair}                          = _EXCEL__XLARGE_BOLD
    subtitle::Vector{ExcelPair}                       = _EXCEL__LARGE_ITALIC
    row_number_label::Vector{ExcelPair}               = _EXCEL__BOLD
    row_number::Vector{ExcelPair}                     = _EXCEL__BOLD
    stubhead_label::Vector{ExcelPair}                 = _EXCEL__BOLD
    row_label::Vector{ExcelPair}                      = _EXCEL__BOLD
    row_group_label::Vector{ExcelPair}                = _EXCEL__BOLD
    first_line_column_label::TFCL                     = _EXCEL__BOLD
    column_label::TCL                                 = _EXCEL__NO_DECORATION
    first_line_merged_column_label::Vector{ExcelPair} = _EXCEL__BOLD
    merged_column_label::Vector{ExcelPair}            = _EXCEL__NO_DECORATION
    data_cell::Vector{ExcelPair}                      = _EXCEL__NO_DECORATION
    summary_row_label::Vector{ExcelPair}              = _EXCEL__BOLD
    summary_row_cell::Vector{ExcelPair}               = _EXCEL__NO_DECORATION
    footnote::Vector{ExcelPair}                       = _EXCEL__SMALL
    source_note::Vector{ExcelPair}                    = _EXCEL__SMALL_ITALIC_GRAY
end

## Description #############################################################################
#
# Excel Back End: Test fills.
#
############################################################################################

@testset "ExcelTableStyle Fill" verbose = true begin
    matrix = [
        "Data" "Data" "Data"
        "Data" "Data" "Data"
        "Data" "Data" "Data"
        "Data" "Data" "Data"
        "Data" "Data" "Data"
        "Data" "Data" "Data"
    ]

    # == Vector of Attributes for Fill in Each Column ======================================

    @testset "Vector of Attributes for Fill in Each Column" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            anchor_cell = "B2",
            title = "Title",
            subtitle = "Subtitle",
            stubhead_label = "Stubhead Label",
            column_labels = [
                ["Column Label", "Column Label", "Column Label"],
                ["Column Label", MultiColumn(2, "Merged Column Label")],
                [MultiColumn(2, "Merged Column Label"), "Column Label"],
            ],
            merge_column_label_cells = :auto,
            show_row_number_column = true,
            row_number_column_label = "Row Number",
            row_labels = fill("Row Label", 6),
            row_group_labels = [3 => "Row Group Label", 5 => "Row Group Label"],
            summary_row_labels = ["Row Summary Label", "Row Summary Label"],
            summary_rows = [(data, i) -> "Summary Cell", (data, i) -> "Summary Cell"],
            footnotes = [(:title, 1, 1) => "Footnotes"],
            source_notes = "Source Notes",
            alignment = :c,
            row_label_column_alignment = :c,
            row_number_column_alignment = :c,
            table_format = ExcelTableFormat(;
                horizontal_line_at_beginning = false,
                vertical_line_at_beginning = false,
                vertical_line_after_data_columns = false,
                borders = ExcelTableBorders(;
                    top_line = ["style" => "thick", "color" => "white"],
                    header_line = ["style" => "thick", "color" => "white"],
                    merged_header_cell_line = ["style" => "thin", "color" => "white"],
                    middle_line = ["style" => "thin", "color" => "white"],
                    bottom_line = ["style" => "thick", "color" => "white"],
                    left_line = ["style" => "thick", "color" => "white"],
                    center_line = ["style" => "thin", "color" => "white"],
                    right_line = ["style" => "thick", "color" => "white"],
                ),
            ),
            style = ExcelTableStyle(;
                title = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "black",
                ],
                subtitle = [
                    "color" => "white",
                    "italic" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "grey50",
                ],
                row_number_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                row_number = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "steelblue4",
                ],
                stubhead_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                row_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "steelblue4",
                ],
                row_group_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "goldenrod1",
                ],
                first_line_column_label = [
                    [
                        "color" => "white",
                        "bold" => "true",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "seagreen",
                    ],
                    [
                        "color" => "white",
                        "bold" => "true",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "blue",
                    ],
                    [
                        "color" => "white",
                        "bold" => "true",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "red",
                    ],
                ],
                column_label = [
                    [
                        "color" => "white",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "red",
                    ],
                    [
                        "color" => "white",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "seagreen",
                    ],
                    [
                        "color" => "white",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "blue",
                    ],
                ],
                merged_column_label = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                data_cell = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "steelblue4",
                ],
                summary_row_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "violetred3",
                ],
                summary_row_cell = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "violetred3",
                ],
                footnote = [
                    "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "grey80"
                ],
                source_note = [
                    "color" => "black",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "grey80",
                ],
            ),
        )

        r = result[1]

        # Title and subtitle
        @test XLSX.getFill(r, "B2").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF000000")
        @test XLSX.getFill(r, "B3").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF7F7F7F")

        # Headings
        @test XLSX.getFill(r, "B4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "C4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "D4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "E4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF0000FF")
        @test XLSX.getFill(r, "F4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFFF0000")
        @test XLSX.getFill(r, "D5").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFFF0000")
        @test XLSX.getFill(r, "E5").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "D6").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "F6").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF0000FF")

        # Row groups
        @test XLSX.getFill(r, "B9").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFFFC125")
        @test XLSX.getFill(r, "B12").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFFFC125")

        # Data rows
        @test XLSX.getFill(r, "B7").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "B10").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "B14").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "C8").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "C11").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "C13").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "D7").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "E11").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "F14").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")

        # Summary rows
        @test XLSX.getFill(r, "C15").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")
        @test XLSX.getFill(r, "D15").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")
        @test XLSX.getFill(r, "E16").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")
        @test XLSX.getFill(r, "F15").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")

        # Footnote and sourcenotes
        @test XLSX.getFill(r, "B17").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCCCCCC")
        @test XLSX.getFill(r, "B18").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCCCCCC")
    end

    # == Single Attributes for Fill in All Columns =========================================

    @testset "Single Attributes for Fill in All Columns" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            anchor_cell = "B2",
            title = "Title",
            subtitle = "Subtitle",
            stubhead_label = "Stubhead Label",
            column_labels = [
                ["Column Label", "Column Label", "Column Label"],
                ["Column Label", MultiColumn(2, "Merged Column Label")],
                [MultiColumn(2, "Merged Column Label"), "Column Label"],
            ],
            merge_column_label_cells = :auto,
            show_row_number_column = true,
            row_number_column_label = "Row Number",
            row_labels = fill("Row Label", 6),
            row_group_labels = [3 => "Row Group Label", 5 => "Row Group Label"],
            summary_row_labels = ["Row Summary Label", "Row Summary Label"],
            summary_rows = [(data, i) -> "Summary Cell", (data, i) -> "Summary Cell"],
            footnotes = [(:title, 1, 1) => "Footnotes"],
            source_notes = "Source Notes",
            alignment = :c,
            row_label_column_alignment = :c,
            row_number_column_alignment = :c,
            table_format = ExcelTableFormat(;
                horizontal_line_at_beginning = false,
                vertical_line_at_beginning = false,
                vertical_line_after_data_columns = false,
                borders = ExcelTableBorders(;
                    top_line = ["style" => "thick", "color" => "white"],
                    header_line = ["style" => "thick", "color" => "white"],
                    merged_header_cell_line = ["style" => "thin", "color" => "white"],
                    middle_line = ["style" => "thin", "color" => "white"],
                    bottom_line = ["style" => "thick", "color" => "white"],
                    left_line = ["style" => "thick", "color" => "white"],
                    center_line = ["style" => "thin", "color" => "white"],
                    right_line = ["style" => "thick", "color" => "white"],
                ),
            ),
            style = ExcelTableStyle(;
                title = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "black",
                ],
                subtitle = [
                    "color" => "white",
                    "italic" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "grey50",
                ],
                row_number_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                row_number = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "steelblue4",
                ],
                stubhead_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                row_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "steelblue4",
                ],
                row_group_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "goldenrod1",
                ],
                first_line_column_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                column_label = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                first_line_merged_column_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                merged_column_label = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "seagreen",
                ],
                data_cell = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "steelblue4",
                ],
                summary_row_label = [
                    "color" => "white",
                    "bold" => "true",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "violetred3",
                ],
                summary_row_cell = [
                    "color" => "white",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "violetred3",
                ],
                footnote = [
                    "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "grey80"
                ],
                source_note = [
                    "color" => "black",
                    "cell_fill_pattern" => "solid",
                    "cell_fill_fgColor" => "grey80",
                ],
            ),
        )

        r = result[1]

        # Title and subtitle
        @test XLSX.getFill(r, "B2").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF000000")
        @test XLSX.getFill(r, "B3").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF7F7F7F")

        # Headings
        @test XLSX.getFill(r, "B4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "C4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "D4").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "E5").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")
        @test XLSX.getFill(r, "F6").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF2E8B57")

        # Row groups
        @test XLSX.getFill(r, "B9").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFFFC125")
        @test XLSX.getFill(r, "B12").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFFFC125")

        # Data rows
        @test XLSX.getFill(r, "B7").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "B10").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "B14").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "C8").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "C11").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "C13").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "D7").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "E11").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")
        @test XLSX.getFill(r, "F14").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FF36648B")

        # Summary rows
        @test XLSX.getFill(r, "C15").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")
        @test XLSX.getFill(r, "D15").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")
        @test XLSX.getFill(r, "E16").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")
        @test XLSX.getFill(r, "F15").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCD3278")

        # Footnote and sourcenotes
        @test XLSX.getFill(r, "B17").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCCCCCC")
        @test XLSX.getFill(r, "B18").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFCCCCCC")
    end
end

## Description #############################################################################
#
# HTML Back End: Test related with offset arrays.
#
############################################################################################

@testset "Offset Arrays" begin
    matrix = Matrix{Any}(undef, 3, 3)
    matrix[1, 1] = (1, 1)
    matrix[1, 2] = (1, 2)
    matrix[2, 1] = nothing
    matrix[2, 2] = missing
    matrix[3, 3] = (3, 3)

    omatrix = OffsetArray(matrix, -2:0, -3:-1)

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th class = "rowNumberLabel" style = "font-weight: bold; text-align: right;">Row</th>
      <th style = "font-weight: bold; text-align: right;">Col. -3</th>
      <th style = "font-weight: bold; text-align: right;">Col. -2</th>
      <th style = "font-weight: bold; text-align: right;">Col. -1</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">-2</td>
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td style = "text-align: right;">#undef</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">-1</td>
      <td style = "text-align: right;">nothing</td>
      <td style = "text-align: right;">missing</td>
      <td style = "text-align: right;">#undef</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">0</td>
      <td style = "text-align: right;">#undef</td>
      <td style = "text-align: right;">#undef</td>
      <td style = "text-align: right;">(3, 3)</td>
    </tr>
  </tbody>
</table>
"""

    result = pretty_table(String, omatrix; backend = :html, show_row_number_column = true)

    @test result == expected
end

## Description #############################################################################
#
# Private functions for the text back end.
#
############################################################################################

# == Footnotes =============================================================================

const _TEXT__EXPONENTS = ("⁰", "¹", "²", "³", "⁴", "⁵", "⁶", "⁷", "⁸", "⁹")

"""
    _text__render_footnote_superscript(number::Int) -> String

Render the superscript of a footnote.
"""
function _text__render_footnote_superscript(number::Int)
    # NOTE: `divrem` keeps the arithmetic in `Int`. The previous `floor(aux / 10)` promoted
    # `aux` to `Float64`, which made both `aux` and the digit a `Union{Int, Float64}` and
    # indexed the tuple with a float.
    aux = abs(number)
    str = ""

    while aux ≥ 1
        aux, r = divrem(aux, 10)
        str = _TEXT__EXPONENTS[r + 1] * str
    end

    # The minus sign must not be silently dropped.
    number < 0 && (str = "⁻" * str)

    return str
end

# == Horizontal Cropping ===================================================================

"""
    _text__is_printing_horizontally_limited(table_data::TableData, fit_table_in_display_horizontally::Bool, display_width::Int, num_printed_data_columns::Int, table_width_wo_cont_col::Int, vertical_line_after_continuation_column::Bool) -> Bool

Return `true` if the table printing is horizontally limited by the display, meaning that it
will be cropped.

# Arguments

- `table_data::TableData`: Table data.
- `fit_table_in_display_horizontally::Bool`: If `true`, the table must fit in the display
    horizontally.
- `display_width::Int`: Display width.
- `num_printed_data_columns::Int`: Number of printed data columns.
- `table_width_wo_cont_col::Int`: Width of the table without the continuation column.
- `vertical_line_after_continuation_column::Bool`: If `true`, there is a vertical line
    after the continuation column.
"""
function _text__is_printing_horizontally_limited(
    table_data::TableData,
    fit_table_in_display_horizontally::Bool,
    display_width::Int,
    num_printed_data_columns::Int,
    table_width_wo_cont_col::Int,
    vertical_line_after_continuation_column::Bool,
)
    horizontally_limited_by_display = false

    if fit_table_in_display_horizontally && (display_width > 0)
        # Here we have four possibilities:
        #
        #   1. We can show the entire table. If not, we will have a continuation column.
        #   2. We cannot show the table continuation column, meaning that the table is
        #      horizontally limited by the display.
        #   3. We can partially show the continuation column, meaning that the table is
        #      horizontally limited by the display but there is a continuation column.
        #   4. We can show the continuation column, meaning that the table is horizontally
        #      cropped by the user specification.

        num_remaining_columns = display_width - table_width_wo_cont_col

        horizontally_limited_by_display =
            if (
                (num_remaining_columns > 0) || (
                    (num_remaining_columns == 0) &&
                    (num_printed_data_columns == table_data.num_columns)
                )
            )
                false
            else
                num_remaining_columns < (3 + vertical_line_after_continuation_column)
            end
    end

    return horizontally_limited_by_display
end

"""
    _text__number_of_printed_data_columns(display_width::Int, table_data::TableData, tf::TextTableFormat, vertical_lines_at_data_columns::AbstractVector{Int}, row_number_column_width::Int, row_label_column_width::Int, printed_data_column_widths::Vector{Int}) -> Int

Compute the number of printed data columns.

# Arguments

- `display_width::Int`: Display width.
- `table_data::TableData`: Table data.
- `tf::TextTableFormat`: Table format.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Printed data column widths.
"""
function _text__number_of_printed_data_columns(
    display_width::Int,
    table_data::TableData,
    tf::TextTableFormat,
    vertical_lines_at_data_columns::AbstractVector{Int},
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
)
    display_width <= 0 && return table_data.num_columns

    current_column = 0
    current_column +=
        tf.vertical_line_at_beginning +
        (
            if table_data.show_row_number_column
                row_number_column_width + tf.vertical_line_after_row_number_column + 2
            else
                0
            end
        ) +
        (
            if _has_row_labels(table_data)
                row_label_column_width + tf.vertical_line_after_row_label_column + 2
            else
                0
            end
        )

    num_printed_data_columns = 0

    for j in eachindex(printed_data_column_widths)
        current_column += 1 + printed_data_column_widths[j]
        num_remaining_columns = display_width - current_column

        num_remaining_columns <= 1 && break

        num_printed_data_columns += 1
        current_column += (j ∈ vertical_lines_at_data_columns) + 1
    end

    return num_printed_data_columns
end

# == Vertical Cropping =====================================================================

"""
    _text__count_horizontal_lines(horizontal_lines::AbstractVector{Int}, last_row::Int) -> Int

Return how many of the rows in `1:last_row` have a horizontal line drawn after them
according to `horizontal_lines`. Notice that a row is counted only once, even if it appears
more than once in `horizontal_lines`.

This function must be `O(length(horizontal_lines))`, never `O(last_row)`, because `last_row`
can be the number of rows of a very large table that is only shown cropped.
"""
function _text__count_horizontal_lines(
    horizontal_lines::AbstractUnitRange{Int}, last_row::Int
)
    (last_row < 1) && return 0

    # A range is sorted and has no duplicates. Hence, we only need the size of the
    # intersection with `1:last_row`.
    l = max(first(horizontal_lines), 1)
    u = min(last(horizontal_lines), last_row)

    return max(0, u - l + 1)
end

function _text__count_horizontal_lines(horizontal_lines::AbstractVector{Int}, last_row::Int)
    (last_row < 1) && return 0

    n = 0

    for (k, i) in enumerate(horizontal_lines)
        (1 <= i <= last_row) || continue

        # Skip a row we have already counted.
        (i ∈ view(horizontal_lines, 1:(k - 1))) && continue

        n += 1
    end

    return n
end

"""
    _text__number_of_required_lines(table_data::TableData, tf::TextTableFormat, horizontal_lines_at_column_labels::AbstractVector{Int}, horizontal_lines_at_data_rows::AbstractVector{Int}, new_line_at_end::Bool) -> NTuple{3, Int}

Compute the total number of lines required to print the table.

# Arguments

- `table_data::TableData`: Table data.
- `tf::TextTableFormat`: Table format.
- `horizontal_lines_at_column_labels::AbstractVector{Int}`: Horizontal lines at column
    labels.
- `horizontal_lines_at_data_rows::AbstractVector{Int}`: Horizontal lines at data rows.
- `new_line_at_end::Bool`: If `true`, we must add a new line at the end of the table.

# Returns

- `Int`: Total number of lines required to print the table.
- `Int`: Number of lines required before printing the data.
- `Int`: Number of lines required after printing the data.
"""
function _text__number_of_required_lines(
    table_data::TableData,
    tf::TextTableFormat,
    horizontal_lines_at_column_labels::AbstractVector{Int},
    horizontal_lines_at_data_rows::AbstractVector{Int},
    new_line_at_end::Bool,
)
    # Compute the number of lines we must have before printing the data.
    num_lines_before_data =
        !isempty(table_data.title) +
        !isempty(table_data.subtitle) +
        tf.horizontal_line_at_beginning

    if table_data.show_column_labels
        num_lines_before_data +=
            length(table_data.column_labels) +
            length(horizontal_lines_at_column_labels) +
            tf.horizontal_line_after_column_labels
    end

    # Compute the number of lines we must have after printing the data.
    num_lines_after_data =
        tf.horizontal_line_after_data_rows +
        (
            if _has_summary_rows(table_data)
                # The horizontal line after data rows is already counted.
                (
                    !tf.horizontal_line_after_data_rows &&
                    tf.horizontal_line_before_summary_rows
                ) +
                length(table_data.summary_rows) +
                tf.horizontal_line_after_summary_rows
            else
                0
            end
        ) +
        (_has_footnotes(table_data) ? length(table_data.footnotes) : 0) +
        !isempty(table_data.source_notes) +
        new_line_at_end +
        1 # ............................................................... Margin at bottom

    # Count how many non-data lines we must print in data row section. This number includes
    # the horizontal lines and the row group labels.
    #
    # NOTE: This computation must never iterate over the rows of the source table. Otherwise,
    # printing a cropped view of a table with millions of rows would be `O(num_rows)` even
    # though only a screenful is ever shown.
    num_rows = table_data.num_rows

    # The horizontal line after the last data row is not counted here.
    num_non_data_lines =
        _text__count_horizontal_lines(horizontal_lines_at_data_rows, num_rows - 1)

    if _has_row_group_labels(table_data)
        row_group_labels = table_data.row_group_labels

        lines_per_row_group_label =
            1 +
            tf.horizontal_line_before_row_group_label +
            tf.horizontal_line_after_row_group_label

        for (k, rg) in enumerate(row_group_labels)
            i = first(rg)

            (1 <= i <= num_rows) || continue

            # If two groups start at the same row, only one label is printed. Hence, we must
            # count that row only once, exactly like the previous per-row scan did.
            any(m -> first(row_group_labels[m]) == i, 1:(k - 1)) && continue

            num_non_data_lines += lines_per_row_group_label
        end
    end

    # Obtain the total number of lines required to print the table.
    total_table_lines =
        num_lines_before_data +
        table_data.num_rows +
        num_non_data_lines +
        num_lines_after_data

    return (total_table_lines, num_lines_before_data, num_lines_after_data)
end

"""
    _text__design_vertical_cropping(table_data::TableData, tf::TextTableFormat, horizontal_lines_at_column_labels::AbstractVector{Int}, horizontal_lines_at_data_rows::AbstractVector{Int}, show_omitted_row_summary::Bool, display_number_of_rows::Int, new_line_at_end::Bool = true) -> Int, Bool, Bool

Design the vertical cropping of the table by computing how many data lines we can print and
if we must suppress the horizontal line before or after the continuation line.

# Arguments

- `table_data::TableData`: Table data.
- `tf::TextTableFormat`: Table format.
- `horizontal_lines_at_column_labels::AbstractVector{Int}`: Horizontal lines at column
    labels.
- `horizontal_lines_at_data_rows::AbstractVector{Int}`: Horizontal lines at data rows.
- `show_omitted_row_summary::Bool`: If `true`, we must show the omitted row summary.
- `display_number_of_rows::Int`: Number of rows in the display.
- `new_line_at_end::Bool`: If `true`, we must add a new line at the end of the table.

# Returns

- `Int`: Number of data rows we can print.
- `Bool`: If `true`, we must suppress the horizontal line before the continuation line.
- `Bool`: If `true`, we must suppress the horizontal line after the continuation line.
"""
function _text__design_vertical_cropping(
    table_data::TableData,
    tf::TextTableFormat,
    horizontal_lines_at_column_labels::AbstractVector{Int},
    horizontal_lines_at_data_rows::AbstractVector{Int},
    show_omitted_row_summary::Bool,
    display_number_of_rows::Int,
    new_line_at_end::Bool,
)
    num_data_rows = 0

    # This variable indicates if we must suppress the horizontal line before the
    # continuation row if it exists.
    suppress_hline_before_continuation_row = false

    # This variable indicates if we must suppress the horizontal line after the
    # continuation row if it exists.
    suppress_hline_after_continuation_row = false

    # Compute the number of required lines to print the table.
    total_table_lines, num_lines_before_data, num_lines_after_data = _text__number_of_required_lines(
        table_data,
        tf,
        horizontal_lines_at_column_labels,
        horizontal_lines_at_data_rows,
        new_line_at_end,
    )

    # Check if we can draw the entire table, meaning that a continuation line is not
    # necessary.
    (total_table_lines <= display_number_of_rows) &&
        return table_data.num_rows, false, false

    # We need one additional line to show the omitted row summary, if required, since we
    # must crop the table here.
    num_lines_after_data += show_omitted_row_summary

    required_lines_for_row_group_label =
        1 +
        tf.horizontal_line_before_row_group_label +
        tf.horizontal_line_after_row_group_label

    if table_data.vertical_crop_mode == :bottom

        # In bottom mode, the continuation line will be at the end.
        available_lines =
            display_number_of_rows - num_lines_before_data - num_lines_after_data - 1 # ........................................................... Continuation row

        num_printed_lines = 0

        for i in 1:(table_data.num_rows)
            hline               = i ∈ horizontal_lines_at_data_rows
            row_group_label     = _print_row_group_label(table_data, i)
            num_remaining_lines = available_lines - num_printed_lines

            # Compute the number of lines required for the current row.
            Δ = 1 + hline + (row_group_label ? required_lines_for_row_group_label : 0)

            # If the next line is a row group label and we must draw the horizontal line
            # here, we will need to remove this horizontal line.
            if _print_row_group_label(table_data, i + 1) &&
                tf.horizontal_line_before_row_group_label &&
                hline
                Δ -= 1
            end

            # Check if we have enough vertical space to display the line. If not, try to
            # remove horizontal line before the continuation line to make it fit.
            if num_remaining_lines < Δ
                if hline && (Δ - num_remaining_lines == 1)
                    suppress_hline_before_continuation_row = true
                    num_data_rows += 1
                end

                break
            end

            # If we reach this point, we can print the data row.
            num_data_rows     += 1
            num_printed_lines += Δ
        end

    else
        # To design the number of data rows we can print, we will process one line at the
        # beginning of the table and one line at the end of table counting the number of
        # printed lines. When it reaches the maximum number of lines we have, we stop the
        # algorithm. Notice that sometimes we might have a blank space because we have
        # non-data rows to print that consumes display lines, such as row group labels and
        # horizontal lines.
        #
        # NOTE: If we reach this point, we know that a continuation row must be printed.

        available_lines =
            display_number_of_rows - num_lines_before_data - num_lines_after_data - 1 # ........................................................... Continuation row

        num_printed_lines = 0

        for row in 1:div(table_data.num_rows, 2, RoundDown)

            # == Line at the Beginning of the Table ========================================

            i = row

            hline               = i ∈ horizontal_lines_at_data_rows
            row_group_label     = _print_row_group_label(table_data, i)
            num_remaining_lines = available_lines - num_printed_lines

            # Compute the number of lines required for the current row.
            Δ = 1 + hline + (row_group_label ? required_lines_for_row_group_label : 0)

            # If the next line is a row group label and we must draw the horizontal line
            # here, we will need to remove this horizontal line.
            if _print_row_group_label(table_data, i + 1) &&
                tf.horizontal_line_before_row_group_label &&
                hline
                Δ -= 1
            end

            # Check if we have enough vertical space to display the line. If not, try to
            # remove horizontal line before the continuation line to make it fit.
            if num_remaining_lines < Δ
                if hline && (Δ - num_remaining_lines == 1)
                    suppress_hline_before_continuation_row = true
                    num_data_rows += 1
                end

                break
            end

            # If we reach this point, we can print the data row.
            num_data_rows     += 1
            num_printed_lines += Δ

            # == Line at the End of the Table ==============================================

            i = table_data.num_rows - row + 1

            hline               = i ∈ horizontal_lines_at_data_rows
            row_group_label     = _print_row_group_label(table_data, i)
            num_remaining_lines = available_lines - num_printed_lines

            # Compute the number of lines required for the current row.
            Δ = 1 + hline + (row_group_label ? required_lines_for_row_group_label : 0)

            # Check if we have enough vertical space to display the line. If not, try to
            # remove horizontal line before the continuation line to make it fit.
            if num_remaining_lines < Δ
                if hline && (Δ - num_remaining_lines == 1)
                    suppress_hline_after_continuation_row = true
                    num_data_rows += 1
                end

                break
            end

            # If we reach this point, we can print the data row.
            num_data_rows     += 1
            num_printed_lines += Δ
        end
    end

    return (
        num_data_rows,
        suppress_hline_before_continuation_row,
        suppress_hline_after_continuation_row,
    )
end

"""
    _text__design_vertical_cropping_with_line_breaks(table_data::TableData, table_str::Matrix{String}, tf::TextTableFormat, horizontal_lines_at_column_labels::AbstractVector{Int}, horizontal_lines_at_data_rows::AbstractVector{Int}, show_omitted_row_summary::Bool, display_number_of_rows::Int, new_line_at_end::Bool, num_printed_data_columns::Int) -> Tuple{Int, Bool, Bool}

Design the vertical cropping of the table when the user wants line breaks by computing how
many data lines we can print and if we must suppress the horizontal line before the
continuation line. Notice that middle vertical cropping is not supported when we have line
breaks.

# Arguments

- `table_data::TableData`: Table data.
- `table_str::Matrix{String}`: Rendered table cells.
- `tf::TextTableFormat`: Table format.
- `horizontal_lines_at_column_labels::AbstractVector{Int}`: Horizontal lines at column
    labels.
- `horizontal_lines_at_data_rows::AbstractVector{Int}`: Horizontal lines at data rows.
- `show_omitted_row_summary::Bool`: If `true`, we must show the omitted row summary.
- `display_number_of_rows::Int`: Number of rows in the display.
- `new_line_at_end::Bool`: If `true`, we must add a new line at the end of the table.
- `num_printed_data_columns::Int`: Number of printed data columns.

# Returns

- `Int`: Number of data rows we can fully print.
- `Bool`: If `true`, the printing process will crop the last row.
- `Bool`: If `true`, we must suppress the horizontal line before the continuation line.
"""
function _text__design_vertical_cropping_with_line_breaks(
    table_data::TableData,
    table_str::Matrix{String},
    tf::TextTableFormat,
    horizontal_lines_at_column_labels::AbstractVector{Int},
    horizontal_lines_at_data_rows::AbstractVector{Int},
    show_omitted_row_summary::Bool,
    display_number_of_rows::Int,
    new_line_at_end::Bool,
    num_printed_data_columns::Int,
)
    num_data_rows = 0

    # This variable indicates if we must suppress the horizontal line before the
    # continuation row if it exists.
    suppress_hline_before_continuation_row = false

    # Compute the number of required lines to print the table.
    total_table_lines, num_lines_before_data, num_lines_after_data = _text__number_of_required_lines(
        table_data,
        tf,
        horizontal_lines_at_column_labels,
        horizontal_lines_at_data_rows,
        new_line_at_end,
    )

    # We need one additional line to show the omitted row summary, if required, since we
    # must crop the table here.
    num_lines_after_data += show_omitted_row_summary

    required_lines_for_row_group_label =
        1 +
        tf.horizontal_line_before_row_group_label +
        tf.horizontal_line_after_row_group_label

    # In bottom mode, the continuation line will be at the end.
    available_lines =
        display_number_of_rows - num_lines_before_data - num_lines_after_data - 1 # ............................................................... Continuation row

    num_printed_lines = 0
    last_row_cropped  = false

    # We need this verification if we are not printing one entire column to avoid problems
    # in the algorithm. Notice that the upper clamp is required because the table can have no
    # columns at all, in which case there is nothing to measure.
    num_printed_data_columns = clamp(num_printed_data_columns, 1, size(table_str, 2))

    # If the table has no columns, no data row can be cropped.
    size(table_str, 2) == 0 && return table_data.num_rows, false, false

    @views for i in 1:min(size(table_str, 1), table_data.num_rows)
        hline               = i ∈ horizontal_lines_at_data_rows
        row_group_label     = _print_row_group_label(table_data, i)
        num_remaining_lines = available_lines - num_printed_lines

        # Compute the number of lines in this row.
        num_lines = maximum(count.(==('\n'), table_str[i, 1:num_printed_data_columns])) + 1

        # Compute the number of lines required for the current row.
        Δ = num_lines + hline + (row_group_label ? required_lines_for_row_group_label : 0)

        # If the next line is a row group label and we must draw the horizontal line
        # here, we will need to remove this horizontal line.
        if _print_row_group_label(table_data, i + 1) &&
            tf.horizontal_line_before_row_group_label &&
            hline
            Δ -= 1
        end

        # Check if we have enough vertical space to display the line. If not, try to
        # remove horizontal line before the continuation line to make it fit.
        if num_remaining_lines == Δ
            num_data_rows += 1
            break

        elseif num_remaining_lines < Δ
            if hline && (Δ - num_remaining_lines == 1)
                suppress_hline_before_continuation_row = true
                num_data_rows += 1
                break
            end

            last_row_cropped = true
            break
        end

        # If we reach this point, we can print the data row.
        num_data_rows     += 1
        num_printed_lines += Δ
    end

    return num_data_rows, last_row_cropped, suppress_hline_before_continuation_row
end

# == Table Dimensions ======================================================================

"""
    _text__table_width_wo_cont_column(table_data::TableData, tf::TextTableFormat, vertical_lines_at_data_columns::AbstractVector{Int}, row_number_column_width::Int, row_label_column_width::Int, printed_data_column_widths::Vector{Int}) -> Int

Compute the width of the table without the continuation column.

# Arguments

- `table_data::TableData`: Table data.
- `tf::TextTableFormat`: Table format.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Printed data column widths.
"""
function _text__table_width_wo_cont_column(
    table_data::TableData,
    tf::TextTableFormat,
    vertical_lines_at_data_columns::AbstractVector{Int},
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
)
    current_column = 0
    current_column +=
        tf.vertical_line_at_beginning +
        (
            if table_data.show_row_number_column
                row_number_column_width + tf.vertical_line_after_row_number_column + 2
            else
                0
            end
        ) +
        (
            if _has_row_labels(table_data)
                row_label_column_width + tf.vertical_line_after_row_label_column + 2
            else
                0
            end
        )

    for j in eachindex(printed_data_column_widths)
        current_column += 2 + printed_data_column_widths[j]

        # We should not add the last printed column vertical line because it is taken into
        # account afterwards.
        if (j != last(eachindex(printed_data_column_widths))) &&
            (j ∈ vertical_lines_at_data_columns)
            current_column += 1
        end
    end

    current_column += tf.vertical_line_after_data_columns

    return current_column
end

## Description #############################################################################
#
# Types and structures for the markdown back end
#
############################################################################################

export MarkdownStyle, MarkdownHighlighter, MarkdownTableFormat, MarkdownTableStyle

"""
    struct MarkdownStyle

Structure that defines styling parameters to a table cell in the markdown back end.

# Fields

- `bold::Bool`: Bold text.
- `italic::Bool`: Italic text.
- `strikethrough::Bool`: Strikethrough.
- `code::Bool`: Code.
"""
@kwdef struct MarkdownStyle
    bold::Bool = false
    italic::Bool = false
    strikethrough::Bool = false
    code::Bool = false
end

############################################################################################
#                                       Highlighters                                       #
############################################################################################

"""
    struct MarkdownHighlighter

Defines the default highlighter of a table when using the markdown backend.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `fd(h, data, i, j)` in which `h` is the
    highlighter. This function must return the `MarkdownStyle` to be applied to the
    cell that must be highlighted.
- `_decoration::MarkdownStyle`: The decoration to be applied to the highlighted cell if
    the default `fd` is used.

# Remarks

This structure can be constructed using two helpers:

    MarkdownHighlighter(f::Function, decoration::MarkdownStyle)

    MarkdownHighlighter(f::Function, fd::Function)

The first will apply a fixed decoration to the highlighted cell specified in `decoration`
whereas the second lets the user select the desired decoration by specifying the function
`fd`.
"""
struct MarkdownHighlighter
    f::Function
    fd::Function

    # == Private Fields ====================================================================

    _decoration::MarkdownStyle

    # == Constructors ======================================================================

    function MarkdownHighlighter(f::Function, fd::Function)
        return new(f, fd, MarkdownStyle())
    end

    function MarkdownHighlighter(f::Function, decoration::MarkdownStyle)
        return new(f, _markdown__default_highlighter_fd, decoration)
    end
end

_markdown__default_highlighter_fd(h::MarkdownHighlighter, ::Any, ::Int, ::Int) =
    h._decoration

############################################################################################
#                                       Table Format                                       #
############################################################################################

# Create some default decorations to reduce allocations.
const _MARKDOWN__NO_DECORATION = MarkdownStyle()
const _MARKDOWN__BOLD          = MarkdownStyle(; bold = true)
const _MARKDOWN__ITALIC        = MarkdownStyle(; italic = true)
const _MARKDOWN__CODE          = MarkdownStyle(; code = true)

"""
    struct MarkdownTableFormat

Define the format of the tables printed with the markdown back end.

# Fields

- `title_heading_level::Int`: Title heading level.
- `subtitle_heading_level::Int`: Subtitle heading level.
- `horizontal_line_char::Char`: Character used to draw the horizontal line.
- `line_before_summary_rows::Bool`: Whether to draw a line before the summary rows.
- `compact_table::Bool`: If `true`, the table is printed in a compact format without extra
    spaces between columns.
"""
@kwdef struct MarkdownTableFormat
    title_heading_level::Int       = 1
    subtitle_heading_level::Int    = 2
    horizontal_line_char::Char     = '─'
    line_before_summary_rows::Bool = true
    compact_table::Bool            = false
end

"""
    struct MarkdownTableStyle

Define the style of the tables printed with the markdown back end.

# Fields

- `row_number_label::MarkdownStyle`: Style for the row number label.
- `row_number::MarkdownStyle`: Style for the row number.
- `stubhead_label::MarkdownStyle`: Style for the stubhead label.
- `row_label::MarkdownStyle`: Style for the row label.
- `row_group_label::MarkdownStyle`: Style for the row group label.
- `first_line_column_label::Union{MarkdownStyle, Vector{MarkdownStyle}}`: Style for the
    first line of the column label. If a vector of `MarkdownStyle` is provided, each column
    label in the first line will use the corresponding style.
- `column_label::Union{MarkdownStyle, Vector{MarkdownStyle}}`: Style for the column label.
    If a vector of `MarkdownStyle` is provided, each column label will use the corresponding
    style.
- `summary_row_label::MarkdownStyle`: Style for the summary row label.
- `summary_row_cell::MarkdownStyle`: Style for the summary row cell.
- `footnote::MarkdownStyle`: Style for the footnote.
- `source_note::MarkdownStyle`: Style for the source note.
- `omitted_cell_summary::MarkdownStyle`: Style for the omitted cell summary.
"""
@kwdef struct MarkdownTableStyle{
    TFCL <: Union{MarkdownStyle, Vector{MarkdownStyle}},
    TCL <: Union{MarkdownStyle, Vector{MarkdownStyle}},
}
    row_number_label::MarkdownStyle     = _MARKDOWN__BOLD
    row_number::MarkdownStyle           = _MARKDOWN__BOLD
    stubhead_label::MarkdownStyle       = _MARKDOWN__BOLD
    row_label::MarkdownStyle            = _MARKDOWN__BOLD
    row_group_label::MarkdownStyle      = _MARKDOWN__BOLD
    first_line_column_label::TFCL       = _MARKDOWN__BOLD
    column_label::TCL                   = _MARKDOWN__CODE
    summary_row_label::MarkdownStyle    = _MARKDOWN__BOLD
    summary_row_cell::MarkdownStyle     = _MARKDOWN__NO_DECORATION
    footnote::MarkdownStyle             = _MARKDOWN__NO_DECORATION
    source_note::MarkdownStyle          = _MARKDOWN__NO_DECORATION
    omitted_cell_summary::MarkdownStyle = _MARKDOWN__ITALIC
end

## Description #############################################################################
#
# Excel Back End: Test continuation cells (⋮, ⋯, ⋱).
#
############################################################################################

@testset "Continuation Cells" verbose = true begin
    # == Vertical Cropping Yields ⋮ Cells ==================================================

    @testset "Vertical cropping yields ⋮ cells with default style" verbose = true begin
        # With more rows than `maximum_number_of_rows`, a continuation row is appended.
        # The placeholder characters (\"⋮\") live in the continuation row at every column.
        # Under the default `ExcelTableStyle`, the continuation cells must inherit the
        # `data_cell` decoration (an empty `ExcelPair` vector), so the rendered font must
        # not contain the `b` (bold) key that `style.row_number_label` would introduce.
        data = reshape(1:9, 3, 3)  # 3 rows, 3 columns
        result = pretty_table(
            XLSX.XLSXFile, data; backend = :excel, maximum_number_of_rows = 1
        )

        # Find the continuation row (the row containing \"⋮\") in column A.
        sheet_range = result[1].dimension
        last_row = sheet_range.stop.row_number
        cont_row = nothing
        for r in 1:last_row
            v = result[1]["A$(r)"]
            if !ismissing(v) && v == "⋮"
                cont_row = r
                break
            end
        end
        @test cont_row !== nothing

        # The continuation cell's font must not carry the bold attribute that the
        # `row_number_label` style (default `[\"bold\" => \"true\"]`) would apply.
        for col in ("A", "B", "C")
            font = XLSX.getFont(result[1], "$(col)$(cont_row)").font
            @test !haskey(font, "b")
        end
    end
end

## Description #############################################################################
#
# Documentation for the HTML backend.
#
############################################################################################

"""
# PrettyTables.jl HTML Backend

The HTML backend can be selected by passing the keyword `backend = :html` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output.

# Keywords

- `allow_html_in_cells::Bool`: If `true`, the content of the cells can contain HTML code.
    This can be useful to render tables with more complex content, but it can also be a
    security risk if the content is not sanitized.
    (**Default**: `false`)
- `column_label_titles::Union{Nothing, AbstractVector}`: Titles for the column labels. If
    `nothing`, no titles are added. If a vector is passed, it must have the same length as
    the number of column label rows. Each element in the vector can be `nothing` (no title
    for that row) or an element with the title for that row. Notice that this element will
    be converted to string using the function `string`.
    (**Default**: `nothing`)
- `highlighters::Vector{HtmlHighlighter}`: Highlighters to apply to the table. For more
    information, see the section **HTML Highlighters** in the **Extended Help**.
- `line_breaks::Bool`: If `true`, line breaks in the content of the cells (`\\n`) are
    replaced by the HTML tag `<br>`.
    (**Default**: `false`)
- `maximum_column_width::String`: CSS width string for the maximum column width.
    (**Default**: "")
- `minify::Bool`: If `true`, the output HTML code is minified.
    (**Default**: `false`)
- `stand_alone::Bool`: If `true`, the output HTML code is a complete HTML document.
    (**Default**: `false`)
- `style::HtmlTableStyle`: Style of the table. For more information, see the section
    **HTML Table Style** in the **Extended Help**.
- `table_class::String`: Class for the table.
    (**Default**: "")
- `table_div_class::String`: Class for the div containing the table. It is only used if
    `wrap_table_in_div` is `true`.
    (**Default**: "")
- `table_format::HtmlTableFormat`: HTML table format used to render the table. For more
    information, see the section **HTML Table Format** in the **Extended Help**.
- `top_left_string::String`: String to put in the top left corner div.
    (**Default**: "")
- `top_right_string::String`: String to put in the top right corner div. Notice that this
    information is replaced if we are printing the omitted cell summary.
    (**Default**: "")
- `wrap_table_in_div::Bool`: If `true`, the table is wrapped in a div.
    (**Default**: `false`)

# Extended Help

## HTML Highlighters

A set of highlighters can be passed as a `Vector{HtmlHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`HtmlHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
    highlighter. This function must return a `Vector{Pair{String, String}}` with properties
    compatible with the `style` field that will be applied to the highlighted cell.

An HTML highlighter can be constructed using three helpers:

```julia
HtmlHighlighter(f::Function, decoration::Vector{Pair{String, String}})

HtmlHighlighter(f::Function, decoration::HtmlPair)

HtmlHighlighter(f::Function, fd::Function)
```

The first two apply a fixed decoration to the highlighted cell, whereas the third lets the
user select the desired decoration by specifying the function `fd`.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells with value greater than 5 in red, and all
cells with values less than 5 in blue, we can define:

```julia
hl_gt5 = HtmlHighlighter(
    (data, i, j) -> data[i, j] > 5,
    ["color" => "red"]
)

hl_lt5 = HtmlHighlighter(
    (data, i, j) -> data[i, j] < 5,
    ["color" => "blue"]
)

highlighters = [hl_gt5, hl_lt5]
```

## HTML Table Format

The HTML table format is defined using an object of type [`HtmlTableFormat`](@ref) that
contains the following fields:

- `css::String`: CSS to be injected at the end of the `<style>` section.
- `table_width::String`: Table width.

Notice that this format is only applied if `stand_alone = true`.

## HTML Table Style

The HTML table style is defined using an object of type [`HtmlTableStyle`](@ref) that
contains the following fields:

- `top_left_string::Vector{HtmlPair}`: Style for the top left string.
- `top_right_string::Vector{HtmlPair}`: Style for the top right string.
- `table::Vector{HtmlPair}`: Style for the table.
- `title::Vector{HtmlPair}`: Style for the title.
- `subtitle::Vector{HtmlPair}`: Style for the subtitle.
- `row_number_label::Vector{HtmlPair}`: Style for the row number label.
- `row_number::Vector{HtmlPair}`: Style for the row number.
- `stubhead_label::Vector{HtmlPair}`: Style for the stubhead label.
- `row_label::Vector{HtmlPair}`: Style for the row label.
- `row_group_label::Vector{HtmlPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}}`: Style for
    the first line of the column labels. If a vector of `Vector{HtmlPair}` is provided,
    each column label in the first line will use the corresponding style.
- `column_label::Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}}`: Style for the rest of
    the column labels. If a vector of `Vector{HtmlPair}` is provided, each column label
    will use the corresponding style.
- `first_line_merged_column_label::Vector{HtmlPair}`: Style for the merged cells at the
    first column label line.
- `merged_column_label::Vector{HtmlPair}`: Style for the merged cells at the rest of the
    column labels.
- `summary_row_cell::Vector{HtmlPair}`: Style for the summary row cell.
- `summary_row_label::Vector{HtmlPair}`: Style for the summary row label.
- `footnote::Vector{HtmlPair}`: Style for the footnote.
- `source_note::Vector{HtmlPair}`: Style for the source notes.

Each field is a vector of [`HtmlPair`](@ref), *i.e.* `Pair{String, String}`, describing
properties and values compatible with the HTML style attribute.

For example, if we want the stubhead label to be bold and red, we must define:

```julia
style = HtmlTableStyle(
    stubhead_label = ["font-weight" => "bold", "color" => "red"]
)
```
"""
pretty_table_html_backend

## Description #############################################################################
#
# Precompilation.
#
############################################################################################

import PrecompileTools

PrecompileTools.@setup_workload begin
    types = [
        Int8(1),
        Int16(1),
        Int32(1),
        Int64(1),
        UInt8(1),
        UInt16(1),
        UInt32(1),
        UInt64(1),
        Float16(1),
        Float32(1),
        Float64(1),
        Bool(1),
        "S",
        'C',
        Int8[1, 2, 3],
        Int16[1, 2, 3],
        Int32[1, 2, 3],
        Int64[1, 2, 3],
        UInt8[1, 2, 3],
        UInt16[1, 2, 3],
        UInt32[1, 2, 3],
        UInt64[1, 2, 3],
        Float16[1, 2, 3],
        Float32[1, 2, 3],
        Float64[1, 2, 3],
        Bool[0, 1],
        ["S", "S"],
        ['C', 'C'],
        Int8[1 2; 3 4],
        Int16[1 2; 3 4],
        Int32[1 2; 3 4],
        Int64[1 2; 3 4],
        UInt8[1 2; 3 4],
        UInt16[1 2; 3 4],
        UInt32[1 2; 3 4],
        UInt64[1 2; 3 4],
        Float16[1 2; 3 4],
        Float32[1 2; 3 4],
        Float64[1 2; 3 4],
        Bool[0 1; 0 1],
        ["S" "S"; "S" "S"],
        ['C' 'C'; 'C' 'C'],
    ]

    # A named tuple is compliant with Table.jl.
    table = (a = 1:1:10, b = ["S" for i in 1:10], c = ['C' for i in 1:10])

    dict = Dict(:a => (1, 1), :b => (2, 2), :c => (3, 3))

    # We will redirect the `stdout` so that the workload does not produce visible output.
    old_stdout = Base.stdout
    redirect_stdout(devnull)

    # In HTML, we use `display` if we are rendering to `stdout`. However, even if we are
    # redirecting it, the text is still being shown in the display. Thus, we create a buffer
    # for those cases.
    html_buf = IOBuffer()

    # NOTE: Redirecting `stdout` to `devnull` means the workload above compiles the rendering
    # path for `io::Base.DevNull`. Real users print to an `IOContext` wrapping a `TTY` or an
    # `IOBuffer`, which is a different type. Hence, we must also exercise an explicit
    # `IOContext{IOBuffer}` so that the first real print is not fully cold.
    io_buf = IOContext(
        IOBuffer(),
        :color        => true,
        :compact      => true,
        :limit        => true,
        :displaysize  => (25, 80),
    )

    try
        PrecompileTools.@compile_workload begin
            # == Input: Arrays =============================================================

            matrix = ones(10, 10)

            # -- General API ---------------------------------------------------------------

            pretty_table(matrix; column_labels = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
            pretty_table(matrix; column_labels = [MultiColumn(5, "A"), EmptyCells(5)])

            # -- Text ----------------------------------------------------------------------

            pretty_table(matrix)
            pretty_table(matrix; summary_rows = [sum, sum, sum])

            pretty_table(
                types;
                alignment = :l,
                fit_table_in_display_horizontally = false,
                fit_table_in_display_vertically = false,
            )

            pretty_table(
                matrix;
                highlighters = [TextHighlighter((data, i, j) -> i == 1, crayon"bold")]
            )

            pretty_table(types)

            # .. Text Table Styles .........................................................

            pretty_table(
                matrix;
                style = TextTableStyle(;
                    first_line_column_label = [crayon"bold yellow" for i in 1:10]
                ),
            )

            pretty_table(
                matrix;
                style = TextTableStyle(;
                    column_label = [crayon"bold yellow" for i in 1:10]
                ),
            )

            pretty_table(
                matrix;
                style = TextTableStyle(;
                    first_line_column_label = [crayon"bold yellow" for i in 1:10],
                    column_label            = [crayon"bold yellow" for i in 1:10],
                ),
            )

            # -- Options Used in DataFrames.jl ---------------------------------------------

            style = TextTableStyle(; row_label = Crayon())

            table_format = TextTableFormat(;
                @text__no_horizontal_lines,
                @text__no_vertical_lines,
                ellipsis_line_skip                    = 3,
                horizontal_line_after_column_labels   = true,
                horizontal_line_before_summary_rows   = true,
                vertical_line_after_row_label_column  = true,
                vertical_line_after_row_number_column = true,
            )

            hl = TextHighlighter((data, i, j) -> false, Crayon(; foreground = :dark_gray))

            pretty_table(
                table;
                alignment                         = [:l, :c, :r],
                alignment_anchor_fallback         = :r,
                alignment_anchor_regex            = [r"\."],
                column_label_alignment            = :l,
                column_labels                     = [["A", "B", "C"], ["A", "B", "C"]],
                continuation_row_alignment        = :c,
                display_size                      = (15, 33),
                fit_table_in_display_horizontally = true,
                fit_table_in_display_vertically   = true,
                formatters                        = [
                    (v, i, j) -> ismissing(v) ? "missing" : v
                ],
                highlighters                      = [hl],
                maximum_data_column_widths        = [20, 20, 20],
                new_line_at_end                   = false,
                reserved_display_lines            = 2,
                row_label_column_alignment        = :r,
                row_labels                        = ["$i" for i in 1:10],
                row_number_column_alignment       = :r,
                row_number_column_label           = "Row",
                show_first_column_label_only      = false,
                show_row_number_column            = false,
                stubhead_label                    = "Row",
                style                             = style,
                table_format                      = table_format,
                title                             = "Test table",
                title_alignment                   = :l,
                vertical_crop_mode                = :middle,
            )

            # -- HTML ----------------------------------------------------------------------

            pretty_table(html_buf, matrix; backend = :html)

            pretty_table(
                html_buf,
                matrix;
                backend = :html,
                highlighters = [
                    HtmlHighlighter((data, i, j) -> i == 1, ["font-weight" => "bold"])
                ],
            )

            pretty_table(html_buf, types; backend = :html)

            # .. HTML Table Styles .........................................................

            pretty_table(
                html_buf,
                matrix;
                backend = :html,
                style = HtmlTableStyle(;
                    first_line_column_label = [["color" => "red"] for i in 1:10]
                ),
            )

            pretty_table(
                html_buf,
                matrix;
                backend = :html,
                style = HtmlTableStyle(; column_label = [["color" => "red"] for i in 1:10]),
            )

            pretty_table(
                html_buf,
                matrix;
                backend = :html,
                style = HtmlTableStyle(;
                    first_line_column_label = [["color" => "red"] for i in 1:10],
                    column_label            = [["color" => "red"] for i in 1:10],
                ),
            )

            # -- LaTeX ---------------------------------------------------------------------

            pretty_table(matrix; backend = :latex)

            pretty_table(
                matrix;
                backend = :latex,
                highlighters = [LatexHighlighter((data, i, j) -> i == 1, ["textbf"])],
            )

            pretty_table(types; backend = :latex)

            # .. LaTeX Table Styles ........................................................

            pretty_table(
                matrix;
                backend = :latex,
                style = LatexTableStyle(;
                    first_line_column_label = [["textbf"] for i in 1:10]
                ),
            )

            pretty_table(
                matrix;
                backend = :latex,
                style = LatexTableStyle(; column_label = [["textbf"] for i in 1:10]),
            )

            pretty_table(
                matrix;
                backend = :latex,
                style = LatexTableStyle(;
                    first_line_column_label = [["textbf"] for i in 1:10],
                    column_label            = [["textbf"] for i in 1:10],
                ),
            )

            # -- Markdown ------------------------------------------------------------------

            pretty_table(matrix; backend = :markdown)

            pretty_table(
                matrix;
                backend = :markdown,
                highlighters = [
                    MarkdownHighlighter(
                        (data, i, j) -> i == 1, MarkdownStyle(; bold = true)
                    )
                ],
            )

            pretty_table(types; backend = :markdown)

            # .. Markdown Table Styles .....................................................

            pretty_table(
                matrix;
                backend = :markdown,
                style = MarkdownTableStyle(;
                    first_line_column_label = [MarkdownStyle(; bold = true) for i in 1:10]
                ),
            )

            pretty_table(
                matrix;
                backend = :markdown,
                style = MarkdownTableStyle(;
                    column_label = [MarkdownStyle(; italic = true) for i in 1:10]
                ),
            )

            pretty_table(
                matrix;
                backend = :markdown,
                style = MarkdownTableStyle(;
                    first_line_column_label = [MarkdownStyle(; bold = true) for i in 1:10],
                    column_label            = [
                        MarkdownStyle(; italic = true) for i in 1:10
                    ],
                ),
            )

            # == Typst =====================================================================

            pretty_table(matrix; backend = :typst)

            pretty_table(
                matrix;
                backend = :typst,
                highlighters = [
                    TypstHighlighter((data, i, j) -> i == 1, ["text-fill" => "red"])
                ],
            )

            pretty_table(types; backend = :typst)

            #=        # == Excel ===========================================================

                    pretty_table(matrix; backend = :excel)

                    pretty_table(
                        matrix;
                        backend = :excel,
                        highlighters = [
                            ExcelHighlighter((data, i, j) -> i == 1, ["text-fill" => "red"])
                        ]
                    )

                    pretty_table(types; backend = :excel)
            =#
            # == Input: Tables.jl ==========================================================

            pretty_table(table)
            pretty_table(table; backend = :markdown)
            pretty_table(table; backend = :latex)
            pretty_table(html_buf, table; backend = :html)

            # == Entry Points Used Outside a Redirected `stdout` ===========================

            # Printing to an explicit `IOContext` is what happens in the REPL and in every
            # `pretty_table(String, ...)` call. Without these, the first real print pays
            # for the code generation of the whole rendering path.
            pretty_table(io_buf, matrix)
            take!(io_buf.io)

            pretty_table(io_buf, table)
            take!(io_buf.io)

            pretty_table(String, matrix)
            pretty_table(String, table)

            # `show(::IO, ::PrettyTable)` is a completely separate entry point.
            show(io_buf, PrettyTable(matrix))
            take!(io_buf.io)

            show(io_buf, PrettyTable(table))
            take!(io_buf.io)
        end
    finally
        # Restore stdout.
        redirect_stdout(old_stdout)
    end
end

## Description #############################################################################
#
# HTML Back End: Test with minification.
#
############################################################################################

@testset "Minify" begin
    matrix = [1 2]

    expected = """
<table><thead><tr class = "columnLabelRow"><th style = "font-weight: bold; text-align: right;">Col. 1</th><th style = "font-weight: bold; text-align: right;">Col. 2</th></tr></thead><tbody><tr class = "dataRow"><td style = "text-align: right;">1</td><td style = "text-align: right;">2</td></tr></tbody></table>"""

    result = pretty_table(String, matrix; backend = :html, minify = true)

    @test result == expected
end

## Description #############################################################################
#
# General tests.
#
############################################################################################

@testset "Automatic Column Label Merge" begin
    matrix = [1 2 3 4 5; 6 7 8 9 10]
    column_labels = [
        MultiColumn(2, "Merged Col. 1"), MultiColumn(2, "Merged Col. 2", :l), EmptyCells(1)
    ]

    expected = """
┌───────────────────────────────────┬───────────────────────────────────┬─────────────────┐
│           Merged Col. 1           │ Merged Col. 2                     │                 │
├─────────────────┬─────────────────┼─────────────────┬─────────────────┼─────────────────┤
│               1 │               2 │               3 │               4 │               5 │
│               6 │               7 │               8 │               9 │              10 │
└─────────────────┴─────────────────┴─────────────────┴─────────────────┴─────────────────┘
"""

    result = pretty_table(String, matrix; column_labels, fixed_data_column_widths = 15)
    @test result == expected
end

@testset "Merge Column Label Cells" begin
    matrix = [1 2 3; 4 5 6]
    column_labels = [MultiColumn(2, "Test"), "B", "C"]

    expected = """
┌────────────────────────────┬───┬───┐
│ MultiColumn(2, "Test", :c) │ B │ C │
├────────────────────────────┼───┼───┤
│                          1 │ 2 │ 3 │
│                          4 │ 5 │ 6 │
└────────────────────────────┴───┴───┘
"""

    result = pretty_table(
        String, matrix; column_labels, merge_column_label_cells = :something
    )
    @test result == expected

    @test_throws ArgumentError pretty_table(String, matrix; column_labels)
end

@testset "Show Only First Column Label" begin
    matrix = [1 2 3; 4 5 6]
    column_labels = [["A", "B", "C"], ["D", "E", "F"]]

    expected = """
┌───┬───┬───┐
│ A │ B │ C │
├───┼───┼───┤
│ 1 │ 2 │ 3 │
│ 4 │ 5 │ 6 │
└───┴───┴───┘
"""

    result = pretty_table(
        String, matrix; column_labels, show_first_column_label_only = true
    )
    @test result == expected
end

@testset "Show Only First Column Label With Merged Cells" begin
    matrix = ones(Int, 2, 4)

    # Merged cells in the dropped column label rows must be neglected.
    expected = """
┌───┬───┬───┬───┐
│ A │ B │ C │ D │
├───┼───┼───┼───┤
│ 1 │ 1 │ 1 │ 1 │
│ 1 │ 1 │ 1 │ 1 │
└───┴───┴───┴───┘
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = [["A", "B", "C", "D"], [MultiColumn(2, "G"), EmptyCells(2)]],
        show_first_column_label_only = true,
    )
    @test result == expected

    # Merged cells in the first column label row must be kept.
    expected = """
┌───────┬───┬───┐
│   G   │   │   │
├───┬───┼───┼───┤
│ 1 │ 1 │ 1 │ 1 │
│ 1 │ 1 │ 1 │ 1 │
└───┴───┴───┴───┘
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = [[MultiColumn(2, "G"), EmptyCells(2)], ["A", "B", "C", "D"]],
        show_first_column_label_only = true,
    )
    @test result == expected
end

@testset "Zero-Column Tables" verbose = true begin
    # A table without columns must be rendered exactly the same whether or not the column
    # labels are shown, and it must never throw.
    matrix = Matrix{Int}(undef, 3, 0)

    @testset "Column Labels Do Not Change the Output" begin
        for backend in (:text, :latex, :markdown, :typst, :html)
            shown  = pretty_table(String, matrix; backend, show_column_labels = true)
            hidden = pretty_table(String, matrix; backend, show_column_labels = false)

            @test shown == hidden
        end
    end

    @testset "Text Back End Keywords" begin
        # `line_breaks` used to index a 3×0 matrix at `[1, 1:1]`, and
        # `equal_data_column_widths` used to reduce over an empty collection.
        @test pretty_table(String, matrix; line_breaks = true) == ""
        @test pretty_table(String, matrix; equal_data_column_widths = true) == ""
    end
end

@testset "Cropping to Zero Rows" verbose = true begin
    matrix = [10i + j for i in 1:6, j in 1:2]

    @testset "Column Labels Hidden" begin
        # The `show_column_labels` shortcut in the printing state iterator used to jump over
        # the rule that sends a table cropped to zero rows to the continuation row. Hence,
        # the text back end indexed a 0×2 matrix and the HTML back end silently printed every
        # data row.
        expected = """
┌───┬───┐
│ ⋮ │ ⋮ │
└───┴───┘
6 rows omitted
"""

        result = pretty_table(
            String,
            matrix;
            maximum_number_of_rows = 0,
            show_column_labels = false,
        )

        @test result == expected

        # No back end may leak a data row.
        for backend in (:text, :latex, :markdown, :typst, :html)
            result = pretty_table(
                String,
                matrix;
                backend,
                maximum_number_of_rows = 0,
                show_column_labels = false,
            )

            @test !occursin("11", result)
        end
    end
end

@testset "Maximum Number of Columns Equal to Zero" begin
    # `maximum_number_of_columns == 0` means "no limit", exactly like a negative value. Some
    # back ends used to treat it as "crop to a single column", laying out one column while
    # the iterator fed them all of them, which produced uncompilable LaTeX and Typst.
    matrix = [1 2 3; 4 5 6]

    for backend in (:text, :latex, :markdown, :typst, :html)
        limited   = pretty_table(String, matrix; backend, maximum_number_of_columns = 0)
        unlimited = pretty_table(String, matrix; backend)

        @test limited == unlimited
    end

    @test occursin("{|r|r|r|}", pretty_table(
        String,
        matrix;
        backend = :latex,
        maximum_number_of_columns = 0,
    ))
end

@testset "Width Keyword Validation" verbose = true begin
    matrix = [1 2 3; 4 5 6]

    @testset "Text Back End" begin
        for name in (
            :fixed_data_column_widths,
            :minimum_data_column_widths,
            :maximum_data_column_widths,
        )
            @test_throws ArgumentError pretty_table(
                String,
                matrix;
                NamedTuple{(name,)}(([5],))...,
            )
        end
    end
end

@testset "Multiple Footnotes in the Same Cell" verbose = true begin
    # A cell may carry more than one footnote. The loop that appends the second and further
    # references was never executed, since every existing test attaches at most one footnote
    # per cell.
    matrix = [1 2]

    footnotes = [
        (:data, 1, 1) => "one",
        (:data, 1, 1) => "two",
    ]

    @testset "Text" begin
        result = pretty_table(String, matrix; footnotes)
        @test occursin("1¹ʼ²", result)
    end

    @testset "LaTeX" begin
        result = pretty_table(String, matrix; backend = :latex, footnotes)
        @test occursin("1\$^{1,2}\$", result)
    end

    @testset "HTML" begin
        result = pretty_table(String, matrix; backend = :html, footnotes)
        @test occursin("1<sup>1,2</sup>", result)
    end

    @testset "Markdown" begin
        result = pretty_table(String, matrix; backend = :markdown, footnotes)
        @test occursin("1[^1][^2]", result)
    end

    @testset "Typst" begin
        result = pretty_table(String, matrix; backend = :typst, footnotes)
        @test occursin("[1#super[1,2]],", result)
    end
end

@testset "Malformed UTF-8 in a Cell" verbose = true begin
    # Each escaper has a final branch that emits the raw bytes of a malformed or overlong
    # UTF-8 sequence. It is only reachable with an invalid string, which no test provided.
    invalid = String(UInt8[0x61, 0xff, 0xfe, 0x62])

    @test !isvalid(invalid)

    matrix = [invalid]

    @testset "Text" begin
        @test occursin("a\\xff\\xfeb", pretty_table(String, matrix))
    end

    @testset "LaTeX" begin
        result = pretty_table(String, matrix; backend = :latex)
        @test occursin("a\\textbackslash{}xff\\textbackslash{}xfeb", result)
    end

    @testset "HTML" begin
        @test occursin("a\\xff\\xfeb", pretty_table(String, matrix; backend = :html))
    end

    @testset "Markdown" begin
        @test occursin("a\\xff\\xfeb", pretty_table(String, matrix; backend = :markdown))
    end

    @testset "Typst" begin
        # Typst has no `\xNN` escape sequence. Hence, the malformed bytes are replaced by
        # the Unicode replacement character.
        @test occursin("a��b", pretty_table(String, matrix; backend = :typst))
    end
end

@testset "Column Labels Without Any Row" verbose = true begin
    # A table with column labels but no data and no summary rows closes its header section
    # immediately. In the text back end the column label line doubles as the bottom border,
    # and in the HTML back end `</thead>` must be emitted without ever opening a `<tbody>`.
    empty_matrix  = Matrix{Int}(undef, 0, 3)
    column_labels = [["A", "B", "C"]]

    @testset "Text" begin
        expected = """
┌───┬───┬───┐
│ A │ B │ C │
└───┴───┴───┘
"""

        @test pretty_table(String, empty_matrix; column_labels) == expected
    end

    @testset "HTML" begin
        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">A</th>
      <th style = "font-weight: bold; text-align: right;">B</th>
      <th style = "font-weight: bold; text-align: right;">C</th>
    </tr>
  </thead>
</table>
"""

        result = pretty_table(String, empty_matrix; backend = :html, column_labels)

        @test result == expected
    end

    @testset "HTML With Source Notes" begin
        # Here the header must be closed by the transition into the table footer.
        result = pretty_table(
            String, empty_matrix; backend = :html, column_labels, source_notes = "s"
        )

        @test occursin("</thead>\n  <tfoot>", result)
        @test occursin("<tr class = \"sourceNotes\">", result)
        @test !occursin("<tbody>", result)
    end

    @testset "LaTeX" begin
        expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{A} & \\textbf{B} & \\textbf{C} \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(String, empty_matrix; backend = :latex, column_labels)

        @test result == expected
    end

    @testset "Typst" begin
        result = pretty_table(String, empty_matrix; backend = :typst, column_labels)

        @test occursin("table.header(", result)
        @test occursin("[#text(weight: \"bold\",)[A]],", result)
    end

    @testset "Markdown" begin
        expected = """
| **A** | **B** | **C** |
|------:|------:|------:|
"""

        result = pretty_table(String, empty_matrix; backend = :markdown, column_labels)

        @test result == expected
    end
end

@testset "Default Column Labels Without Any Row" verbose = true begin
    # The number of columns of a matrix does not depend on its number of rows. Hence, a
    # matrix with no rows but a positive number of columns must still get one automatic
    # label per column.
    #
    # The guard that handles empty data used `isempty`, which is length-based and thus also
    # true here, so the automatic labels came out as an empty row and the table failed the
    # "one label per column" validation.
    empty_matrix = Matrix{Int}(undef, 0, 3)

    @testset "Text" begin
        expected = """
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
└────────┴────────┴────────┘
"""

        @test pretty_table(String, empty_matrix) == expected
    end

    @testset "Row Number Column" begin
        expected = """
┌─────┬────────┬────────┬────────┐
│ Row │ Col. 1 │ Col. 2 │ Col. 3 │
└─────┴────────┴────────┴────────┘
"""

        @test pretty_table(String, empty_matrix; show_row_number_column = true) == expected
    end

    @testset "Markdown" begin
        expected = """
| **Col. 1** | **Col. 2** | **Col. 3** |
|-----------:|-----------:|-----------:|
"""

        @test pretty_table(String, empty_matrix; backend = :markdown) == expected
    end

    @testset "Other Empty Shapes Are Unchanged" begin
        # A vector without elements is defined to have no columns, and so is a matrix
        # without columns. Both must keep printing nothing.
        @test pretty_table(String, Int[]) == ""
        @test pretty_table(String, Matrix{Int}(undef, 0, 0)) == ""
        @test pretty_table(String, Matrix{Int}(undef, 3, 0)) == ""
    end

    @testset "Offset Columns" begin
        # The labels follow the column axis, exactly like they do for a non-empty table.
        data = OffsetArray(Matrix{Int}(undef, 0, 3), 1:0, 0:2)

        expected = """
┌────────┬────────┬────────┐
│ Col. 0 │ Col. 1 │ Col. 2 │
└────────┴────────┴────────┘
"""

        @test pretty_table(String, data) == expected
    end
end

## Description #############################################################################
#
# Excel Back End: Helpers for designing table formats.
#
############################################################################################

export @excel__all_horizontal_lines, @excel__all_vertical_lines
export @excel__no_horizontal_lines, @excel__no_vertical_lines

"""
    @excel__all_horizontal_lines

Return the keyword arguments to be splatted into [`ExcelTableFormat`](@ref) to enable all
horizontal lines.

# Examples

```julia
# Enable all horizontal lines.
table_format = ExcelTableFormat(; @excel__all_horizontal_lines)

# Enable all horizontal lines but suppress data-row underlines.
table_format = ExcelTableFormat(; @excel__all_horizontal_lines, horizontal_lines_at_data_rows = :none)
```
"""
macro excel__all_horizontal_lines()
    return :(
        (
            horizontal_line_at_beginning            = true,
            horizontal_line_after_column_labels     = true,
            horizontal_line_between_column_labels   = true,
            horizontal_line_at_merged_column_labels = true,
            horizontal_lines_at_data_rows           = :all,
            horizontal_line_after_data_rows         = true,
            horizontal_line_before_row_group_label  = true,
            horizontal_line_after_row_group_label   = true,
            horizontal_line_before_summary_rows     = true,
            horizontal_line_after_summary_rows      = true,
        )...
    )
end

"""
    @excel__all_vertical_lines

Return the keyword arguments to be splatted into [`ExcelTableFormat`](@ref) to enable all
vertical lines.

# Examples

```julia
# Enable all vertical lines.
table_format = ExcelTableFormat(; @excel__all_vertical_lines)

# Enable all vertical lines but suppress the row-number column divider.
table_format = ExcelTableFormat(; @excel__all_vertical_lines, vertical_line_after_row_number_column = false)
```
"""
macro excel__all_vertical_lines()
    return :(
        (
            vertical_line_at_beginning            = true,
            vertical_line_after_row_number_column = true,
            vertical_line_after_row_label_column  = true,
            vertical_lines_at_data_columns        = :all,
            vertical_line_after_data_columns      = true,
            vertical_line_after_continuation_column = true,
        )...
    )
end

"""
    @excel__no_horizontal_lines

Return the keyword arguments to be splatted into [`ExcelTableFormat`](@ref) to suppress all
horizontal lines.

# Examples

```julia
# Suppress all horizontal lines.
table_format = ExcelTableFormat(; @excel__no_horizontal_lines)

# Suppress all horizontal lines except the one after the column labels.
table_format = ExcelTableFormat(; @excel__no_horizontal_lines, horizontal_line_after_column_labels = true)
```
"""
macro excel__no_horizontal_lines()
    return :(
        (
            horizontal_line_at_beginning            = false,
            horizontal_line_after_column_labels     = false,
            horizontal_line_between_column_labels   = false,
            horizontal_line_at_merged_column_labels = false,
            horizontal_lines_at_data_rows           = :none,
            horizontal_line_after_data_rows         = false,
            horizontal_line_before_row_group_label  = false,
            horizontal_line_after_row_group_label   = false,
            horizontal_line_before_summary_rows     = false,
            horizontal_line_after_summary_rows      = false,
        )...
    )
end

"""
    @excel__no_vertical_lines

Return the keyword arguments to be splatted into [`ExcelTableFormat`](@ref) to suppress all
vertical lines.

# Examples

```julia
# Suppress all vertical lines.
table_format = ExcelTableFormat(; @excel__no_vertical_lines)

# Suppress all vertical lines except the one at the beginning.
table_format = ExcelTableFormat(; @excel__no_vertical_lines, vertical_line_at_beginning = true)
```
"""
macro excel__no_vertical_lines()
    return :(
        (
            vertical_line_at_beginning            = false,
            vertical_line_after_row_number_column = false,
            vertical_line_after_row_label_column  = false,
            vertical_lines_at_data_columns        = :none,
            vertical_line_after_data_columns      = false,
            vertical_line_after_continuation_column = false,
        )...
    )
end

## Description #############################################################################
#
# Types and structures for the LaTeX back end.
#
############################################################################################

export LatexTableBorders, LatexTableFormat, LatexTableStyle
export LatexHighlighter

############################################################################################
#                                       Table Format                                       #
############################################################################################

# Pair that defines LaTeX properties.
const LatexEnvironments = Vector{String}

# Create some default decorations to reduce allocations.
const _LATEX__DEFAULT      = String[]
const _LATEX__BOLD         = ["textbf"]
const _LATEX__ITALIC       = ["textit"]
const _LATEX__LARGE_BOLD   = ["large", "textbf"]
const _LATEX__SMALL        = ["small"]
const _LATEX__SMALL_ITALIC = ["small", "textit"]

@kwdef struct LatexTableBorders
    top_line::String                = "\\hline"
    header_line::String             = "\\hline"
    merged_header_cell_line::String = "\\cline"
    middle_line::String             = "\\hline"
    bottom_line::String             = "\\hline"
end

"""
    struct LatexTableFormat

Define the format of the tables printed with the LaTeX back end.

# Fields

- `borders::LatexTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn at the bottom of the merged column labels using `\\cline`.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data row. If the symbol `:none` is passed,
    no horizontal lines will be drawn after the data rows.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data row. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.
"""
@kwdef struct LatexTableFormat
    # == Border and Lines ==================================================================

    borders::LatexTableBorders = LatexTableBorders()

    # == Configuration for the Horizontal and Vertical Lines ===============================

    horizontal_line_at_beginning::Bool = true
    horizontal_line_after_column_labels::Bool = true
    horizontal_line_at_merged_column_labels::Bool = true
    horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}} = :none
    horizontal_line_before_row_group_label::Bool = true
    horizontal_line_after_row_group_label::Bool = true
    horizontal_line_after_data_rows::Bool = true
    horizontal_line_before_summary_rows::Bool = true
    horizontal_line_after_summary_rows::Bool = true

    vertical_line_at_beginning::Bool = true
    vertical_line_after_row_number_column::Bool = true
    vertical_line_after_row_label_column::Bool = true
    vertical_lines_at_data_columns::Union{Symbol, Vector{Int}} = :all
    vertical_line_after_data_columns::Bool = true
    vertical_line_after_continuation_column::Bool = true
end

"""
    struct LatexTableStyle

Define the style of the tables printed with the latex back end.

# Fields

- `title::LatexEnvironments`: Latex environments with the style for the title.
- `subtitle::LatexEnvironments`: Latex environments with the style for the subtitle.
- `row_number_label::LatexEnvironments`: Latex environments with the style for the row
    number label.
- `row_number::LatexEnvironments`: Latex environments with the style for the row numbers.
- `stubhead_label::LatexEnvironments`:  Latex environments with the style for the stubhead
    label.
- `row_label::LatexEnvironments`: Latex environments with the style for the row labels.
- `row_group_label::LatexEnvironments`: Latex environments with the style for the row group
    label.
- `first_line_column_label::Union{LatexEnvironments, Vector{LatexEnvironments}}`: Latex
    environments with the style for the first line of the column labels. If a vector of
    `LatexEnvironments` is provided, each column label in the first line will use the
    corresponding style.
- `column_label::Union{LatexEnvironments, Vector{LatexEnvironments}}`: Latex environments
    with the style for the rest of the column labels. If a vector of `LatexEnvironments` is
    provided, each column label will use the corresponding style.
- `first_line_merged_column_label::LatexEnvironments`: Latex environments with the style for
    the merged cells at the first column label line.
- `merged_column_label::LatexEnvironments`: Latex environments with the style for the merged
    cells at the rest of the column labels.
- `summary_row_cell::LatexEnvironments`: Latex environments with the style for the summary
    row cell.
- `summary_row_label::LatexEnvironments`: Latex environments with the style for the summary
    row label.
- `footnote::LatexEnvironments`: Latex environments with the style for the footnotes.
- `source_note::LatexEnvironments`: Latex environments with the style for the source notes.
- `omitted_cell_summary::LatexEnvironments`: Latex environments with the style for the
    omitted cell summary.
"""
@kwdef struct LatexTableStyle{
    TFCL <: Union{LatexEnvironments, Vector{LatexEnvironments}},
    TCL <: Union{LatexEnvironments, Vector{LatexEnvironments}},
}
    title::LatexEnvironments                          = _LATEX__LARGE_BOLD
    subtitle::LatexEnvironments                       = _LATEX__ITALIC
    row_number_label::LatexEnvironments               = _LATEX__BOLD
    row_number::LatexEnvironments                     = _LATEX__DEFAULT
    stubhead_label::LatexEnvironments                 = _LATEX__BOLD
    row_label::LatexEnvironments                      = _LATEX__BOLD
    row_group_label::LatexEnvironments                = _LATEX__BOLD
    first_line_column_label::TFCL                     = _LATEX__BOLD
    column_label::TCL                                 = _LATEX__ITALIC
    first_line_merged_column_label::LatexEnvironments = _LATEX__BOLD
    merged_column_label::LatexEnvironments            = _LATEX__BOLD
    summary_row_cell::LatexEnvironments               = _LATEX__DEFAULT
    summary_row_label::LatexEnvironments              = _LATEX__BOLD
    footnote::LatexEnvironments                       = _LATEX__SMALL
    source_note::LatexEnvironments                    = _LATEX__SMALL_ITALIC
    omitted_cell_summary::LatexEnvironments           = _LATEX__SMALL_ITALIC
end

############################################################################################
#                                     LatexHighlighter                                     #
############################################################################################

"""
    LatexHighlighter

Defines the default highlighter of a table when using the LaTeX backend.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd`: A function with the signature `fd(h, data, i, j)::Vector{String}` in which `h` is the
    highlighter object, `data` is the matrix, and `(i, j)` is the element position in the
    table. This function should return a vector with the LaTeX environments to be applied to
    the cell.

# Remarks

This structure can be constructed using two helpers:

```julia
LatexHighlighter(f::Function, envs::Vector{String})
```

where it will apply recursively all the LaTeX environments in `envs` to the highlighted
text, and

```julia
LatexHighlighter(f::Function, fd::Function)
```

where the user selects the desired decoration by specifying the function `fd`.

Thus, for example:

```julia
LatexHighlighter((data, i, j) -> true, ["textbf", "small"])
```

will wrap all the cells in the table in the following environment:

```latex
\\small{\\textbf{<Cell text>}}
```

Notice that the environments are applied in order, meaning that the **last** one in the
vector ends up being the outermost.
"""
struct LatexHighlighter
    f::Function
    fd::Function

    # == Private Fields ====================================================================

    _environments::LatexEnvironments

    # == Constructors ======================================================================

    function LatexHighlighter(f::Function, fd::Function)
        return new(f, fd, _LATEX__DEFAULT)
    end

    function LatexHighlighter(f::Function, envs::Vector{String})
        return new(f, _latex__default_highlighter_fd, envs)
    end
end

_latex__default_highlighter_fd(h::LatexHighlighter, ::Any, ::Int, ::Int) = h._environments

############################################################################################
#                                        LaTeX Cell                                        #
############################################################################################

export LatexCell
export @latex_cell_str

"""
    struct LatexCell

Defines a table cell that contains LaTeX code. It can be created using the macro
[`@latex_cell_str`](@ref).
"""
struct LatexCell{T}
    data::T
end

raw"""
    @latex_cell_str(str)

Create a table cell with LaTeX code.

# Examples

```julia
julia> latex_cell"\textbf{Bold text}"
LatexCell{String}("\textbf{Bold text}")
```
"""
macro latex_cell_str(str)
    return :(LatexCell($str))
end

## Description #############################################################################
#
# LaTeX Back End: Tests related with decorations.
#
############################################################################################

@testset "Decorations" verbose = true begin
    @testset "Decoration of Column Labels" begin
        matrix = ones(3, 3)

        expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            style = LatexTableStyle(; first_line_column_label = ["textbf"]),
        )

        @test result == expected

        expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{\\color{red}{Col. 1}} & \\textbf{\\color{blue}{Col. 2}} & \\textbf{\\color{green}{Col. 3}} \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            style = LatexTableStyle(;
                first_line_column_label = [
                    ["color{red}", "textbf"],
                    ["color{blue}", "textbf"],
                    ["color{green}", "textbf"],
                ],
            ),
        )

        @test result == expected
    end
    @testset "Per-Column Style for the Column Labels" begin
        # `column_label` may be a single style applied to every column, or a vector holding
        # one style per column. Only the scalar form was covered.
        expected = """
\\begin{tabular}{|r|r|}
  \\hline
  \\textbf{A} & \\textbf{B} \\\\
  \\textbf{a} & \\textit{b} \\\\
  \\hline
  1 & 2 \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            [1 2];
            backend = :latex,
            column_labels = [["A", "B"], ["a", "b"]],
            style = LatexTableStyle(; column_label = [["textbf"], ["textit"]]),
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# Pre-defined formatters.
#
############################################################################################

export fmt__printf, fmt__round, fmt__latex_sn, fmt__excel_stringify

"""
    fmt__excel_stringify(columns::Union{Nothing, Int, AbstractVector{Int}} = nothing) -> Function

Create a formatter function that converts values XLSX.jl cannot handle directly into their
string representation. When `columns` is `nothing`, all values are stringified; otherwise
only the columns listed in `columns` are converted.

!!! note

    This function is only available when the package XLSX.jl is loaded.
"""
function fmt__excel_stringify end

"""
    fmt__printf(fmt_str::String[, columns::AbstractVector{Int}]) -> Function

Apply the format `fmt_str` (see the `Printf` standard library) to the elements in the
columns specified in the vector `columns`. If `columns` is not specified, the format will be
applied to the entire table.

!!! info

    This formatter will be applied only to the cells that are of type `Number`.

# Extended Help

## Examples

```julia-repl
julia> data = [f(a) for a = 0:30:90, f in (sind, cosd, tand)]
4×3 Matrix{Float64}:
 0.0       1.0        0.0
 0.5       0.866025   0.57735
 0.866025  0.5        1.73205
 1.0       0.0       Inf

julia> pretty_table(data; formatters = [fmt__printf("%5.3f")])
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│  0.000 │  1.000 │  0.000 │
│  0.500 │  0.866 │  0.577 │
│  0.866 │  0.500 │  1.732 │
│  1.000 │  0.000 │    Inf │
└────────┴────────┴────────┘

julia> pretty_table(data; formatters = [fmt__printf("%5.3f", [1, 3])])
┌────────┬──────────┬────────┐
│ Col. 1 │   Col. 2 │ Col. 3 │
├────────┼──────────┼────────┤
│  0.000 │      1.0 │  0.000 │
│  0.500 │ 0.866025 │  0.577 │
│  0.866 │      0.5 │  1.732 │
│  1.000 │      0.0 │    Inf │
└────────┴──────────┴────────┘
```
"""
function fmt__printf(fmt_str::String)
    # For efficiency, compute the `Format` object outside.
    fmt = Printf.Format(fmt_str)

    return (v, _, _) -> begin
        !(v isa Number) && return v

        return Printf.format(fmt, v)
    end
end

function fmt__printf(fmt_str::String, columns::AbstractVector{Int})
    # For efficiency, compute the `Format` object outside.
    fmt = Printf.Format(fmt_str)

    return (v, _, j) -> begin
        !(v isa Number) && return v

        for c in columns
            j == c && return Printf.format(fmt, v)
        end

        return v
    end
end

"""
    fmt__round(digits::Int[, columns::AbstractVector{Int}]) -> Function

Round the elements in the columns specified in the vector `columns` to the number of
`digits`. If `columns` is not specified, the rounding will be applied to the entire table.

!!! info

    This formatter will be applied only to the cells that are of type `Number`.

# Extended Help

## Examples

```julia-repl
julia> data = [f(a) for a = 0:30:90, f in (sind, cosd, tand)]
4×3 Matrix{Float64}:
 0.0       1.0        0.0
 0.5       0.866025   0.57735
 0.866025  0.5        1.73205
 1.0       0.0       Inf

julia> pretty_table(data; formatters = [fmt__round(1)])
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│    0.0 │    1.0 │    0.0 │
│    0.5 │    0.9 │    0.6 │
│    0.9 │    0.5 │    1.7 │
│    1.0 │    0.0 │    Inf │
└────────┴────────┴────────┘

julia> pretty_table(data; formatters = [fmt__round(1, [1, 3])])
┌────────┬──────────┬────────┐
│ Col. 1 │   Col. 2 │ Col. 3 │
├────────┼──────────┼────────┤
│    0.0 │      1.0 │    0.0 │
│    0.5 │ 0.866025 │    0.6 │
│    0.9 │      0.5 │    1.7 │
│    1.0 │      0.0 │    Inf │
└────────┴──────────┴────────┘
```
"""
function fmt__round(digits::Int)
    return (v, _, _) -> begin
        # Bail out before the `try` for anything that is not a number. Otherwise, every
        # non-numeric cell would pay for a thrown and caught `MethodError`, which is orders
        # of magnitude more expensive than rendering the cell. The `try` is kept as a
        # secondary guard for exotic `Number` subtypes that do not support `round`.
        !(v isa Number) && return v

        try
            return round(v; digits)
        catch
            return v
        end
    end
end

function fmt__round(digits::Int, columns::AbstractVector{Int})
    return (v, _, j) -> begin
        !(v isa Number) && return v

        for c in columns
            if j == c
                try
                    return round(v; digits)
                catch
                    return v
                end
            end
        end

        return v
    end
end

"""
    fmt__latex_sn(m_digits::Int[, columns::AbstractVector{Int}]) -> Function

Format the numbers of the elements in the `columns` to a scientific notation using LaTeX.
If `columns` is not present, the formatting will be applied to the entire table.

The number is first printed using `Printf` functions with the `g` modifier and then
converted to the LaTeX format. The number of digits in the mantissa can be selected by the
argument `m_digits`.

The formatted number will be wrapped in the object `LatexCell`. Hence, this formatter only
makes sense if the selected backend is `:latex`.

!!! info

    This formatter will be applied only to the cells that are of type `Number`.

# Extended Help

## Examples

```julia-repl
julia> data = [10.0^(-i + j) for i in 1:6, j in 1:6]
6×6 Matrix{Float64}:
 1.0     10.0     100.0    1000.0   10000.0  100000.0
 0.1      1.0      10.0     100.0    1000.0   10000.0
 0.01     0.1       1.0      10.0     100.0    1000.0
 0.001    0.01      0.1       1.0      10.0     100.0
 0.0001   0.001     0.01      0.1       1.0      10.0
 1.0e-5   0.0001    0.001     0.01      0.1       1.0

julia> pretty_table(data; formatters = [fmt__latex_sn(1)], backend = :latex)
\\begin{tabular}{|r|r|r|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} & \\textbf{Col. 6} \\\\
  \\hline
  1 & \$1 \\cdot 10^{1}\$ & \$1 \\cdot 10^{2}\$ & \$1 \\cdot 10^{3}\$ & \$1 \\cdot 10^{4}\$ & \$1 \\cdot 10^{5}\$ \\\\
  0.1 & 1 & \$1 \\cdot 10^{1}\$ & \$1 \\cdot 10^{2}\$ & \$1 \\cdot 10^{3}\$ & \$1 \\cdot 10^{4}\$ \\\\
  0.01 & 0.1 & 1 & \$1 \\cdot 10^{1}\$ & \$1 \\cdot 10^{2}\$ & \$1 \\cdot 10^{3}\$ \\\\
  0.001 & 0.01 & 0.1 & 1 & \$1 \\cdot 10^{1}\$ & \$1 \\cdot 10^{2}\$ \\\\
  0.0001 & 0.001 & 0.01 & 0.1 & 1 & \$1 \\cdot 10^{1}\$ \\\\
  \$1 \\cdot 10^{-5}\$ & 0.0001 & 0.001 & 0.01 & 0.1 & 1 \\\\
  \\hline
\\end{tabular}
```
"""
function fmt__latex_sn(m_digits::Int)
    # Precompute Format objects.
    fmts = Printf.Format("%." * string(m_digits) * "g")

    return (v, _, _) -> begin
        !(v isa Number) && return v

        str = Printf.format(fmts, v)

        # Check if we have scientific notation.
        aux = match(r"e[+-][0-9]+", str)

        if !isnothing(aux)
            exp_str = " \\cdot 10^{" * string(parse(Int, aux.match[2:end])) * "}"
            str = replace(str, r"e.*" => exp_str)
            str = "\$" * str * "\$"
        end

        return LatexCell(str)
    end
end

function fmt__latex_sn(m_digits::Int, columns::AbstractVector{Int})
    # Precompute Format objects.
    fmts = Printf.Format("%." * string(m_digits) * "g")

    return (v, _, j) -> begin
        !(v isa Number) && return v

        for c in columns
            j != c && continue

            str = Printf.format(fmts, v)

            # Check if we have scientific notation.
            aux = match(r"e[+-][0-9]+", str)

            if !isnothing(aux)
                exp_str = " \\cdot 10^{" * string(parse(Int, aux.match[2:end])) * "}"
                str = replace(str, r"e.*" => exp_str)
                str = "\$" * str * "\$"
            end

            return LatexCell(str)
        end

        return v
    end
end

## Description #############################################################################
#
# Text Back End: Tests related with decorations.
#
############################################################################################

@testset "Decorations" verbose = true begin
    @testset "Styled Print" begin
        crayon = crayon"bold red"
        display = PrettyTables.Display(; has_color = true)

        @test PrettyTables._text__styled_print(display, "abc", crayon) === nothing
        @test take!(display.buf_line) == collect(codeunits("\e[31;1mabc\e[0m"))
        @test display.column == 3

        display = PrettyTables.Display(; size = (-1, 2), column = 2, has_color = true)

        @test PrettyTables._text__styled_print(display, "ab", crayon) === nothing
        @test take!(display.buf_line) == collect(codeunits("\e[31;1mab\e[0m"))
        @test display.column == 4

        display = PrettyTables.Display(; size = (-1, 2), column = 3, has_color = true)

        @test PrettyTables._text__styled_print(display, "ab", crayon) === nothing
        @test isempty(take!(display.buf_line))
        @test display.column == 3
    end

    @testset "Aligned Print" begin
        render = function (
            str,
            cell_width,
            alignment;
            fill = true,
            crayon = crayon"default",
            has_color = false,
            column = 0,
            size = (-1, -1),
        )
            display = PrettyTables.Display(; has_color, column, size)
            result = PrettyTables._text__print_aligned(
                display, str, cell_width, alignment, crayon, fill
            )
            return result, String(take!(display.buf_line)), display.column
        end

        @test render("x", 4, :l) == (nothing, "x   ", 4)
        @test render("x", 4, :c) == (nothing, " x  ", 4)
        @test render("x", 4, :r) == (nothing, "   x", 4)
        @test render("x", 4, :c; fill = false) == (nothing, " x", 2)
        @test render("x", 4, :r; fill = false) == (nothing, "   x", 4)

        @test render("", 4, :c) == (nothing, "    ", 4)
        @test render("abcd", 4, :r) == (nothing, "abcd", 4)
        @test render("abcde", 4, :r) == (nothing, "abcde", 5)
        @test render("界", 4, :c) == (nothing, " 界 ", 4)

        ansi_str = "\e[31mx\e[0m"
        @test render(ansi_str, 3, :l) == (nothing, ansi_str * "  ", 3)
        @test render("x", 4, :unknown) == (nothing, "x", 1)

        @test render("x", 4, :c; has_color = true) == (nothing, " x  ", 4)
        @test render("x", 4, :c; crayon = crayon"", has_color = true) ==
            (nothing, " x  ", 4)

        colored = "\e[31;1m x  \e[0m"
        @test render("x", 4, :c; crayon = crayon"bold red", has_color = true) ==
            (nothing, colored, 4)
        @test count("\e[31;1m", colored) == 1
        @test count("\e[0m", colored) == 1

        @test render("x", 4, :c; column = 7) == (nothing, " x  ", 11)
        @test render("x", 4, :c; column = 3, size = (-1, 2)) == (nothing, "", 3)
    end

    @testset "Decoration of Column Labels" begin
        matrix = ones(3, 3)

        expected = """
┌────────┬────────┬────────┐
│\e[33;1m Col. 1 \e[0m│\e[33;1m Col. 2 \e[0m│\e[33;1m Col. 3 \e[0m│
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
└────────┴────────┴────────┘
"""

        result = pretty_table(
            String,
            matrix;
            color = true,
            style = TextTableStyle(; first_line_column_label = crayon"bold yellow"),
        )

        @test result == expected

        expected = """
┌────────┬────────┬────────┐
│\e[33;1m Col. 1 \e[0m│\e[34;1m Col. 2 \e[0m│\e[31;1m Col. 3 \e[0m│
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
└────────┴────────┴────────┘
"""

        result = pretty_table(
            String,
            matrix;
            color = true,
            style = TextTableStyle(;
                first_line_column_label = [
                    crayon"bold yellow"
                    crayon"bold blue"
                    crayon"bold red"
                ],
            ),
        )

        @test result == expected
    end
end

@testset "Colored Vertical Lines" begin
    # The vertical line separators are printed as a `Char`. The styled branch of the `Char`
    # method is only taken when color is enabled *and* the border crayon is not the default,
    # a combination no test exercised. Notice that the counterpart, which asserts that no
    # escape sequence leaks when color is disabled, lives in "Table Border Without Color".
    io = IOContext(IOBuffer(), :color => true)

    pretty_table(io, [1 2]; style = TextTableStyle(; table_border = crayon"blue"))

    result = String(take!(io.io))

    expected =
        "\e[34m┌────────┬────────┐\e[0m\n" *
        "\e[34m│\e[0m\e[1m Col. 1 \e[0m\e[34m│\e[0m\e[1m Col. 2 \e[0m\e[34m│\e[0m\n" *
        "\e[34m├────────┼────────┤\e[0m\n" *
        "\e[34m│\e[0m      1 \e[34m│\e[0m      2 \e[34m│\e[0m\n" *
        "\e[34m└────────┴────────┘\e[0m\n"

    @test result == expected
end

@testset "Table Border Without Color" begin
    # A non-default border crayon must not leak any escape sequence when color is disabled.
    result = pretty_table(
        String, [1 2]; style = TextTableStyle(; table_border = crayon"blue")
    )

    @test !occursin("\e", result)
end

## Description #############################################################################
#
# Markdown Back End: Tests related with table cropping.
#
############################################################################################

@testset "Table Cropping" verbose = true begin
    matrix = [(i, j) for i in 1:100, j in 1:100]

    @testset "Bottom Cropping" begin
        expected = """
| **Col. 1** | **Col. 2** | **Col. 3** | ⋯ |
|-----------:|-----------:|-----------:|---|
|     (1, 1) |     (1, 2) |     (1, 3) | ⋯ |
|     (2, 1) |     (2, 2) |     (2, 3) | ⋯ |
|          ⋮ |          ⋮ |          ⋮ | ⋱ |

*97 columns and 98 rows omitted*
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
        )

        @test result == expected
    end

    @testset "Middle Cropping" begin
        expected = """
| **Col. 1** | **Col. 2** | **Col. 3** | ⋯ |
|-----------:|-----------:|-----------:|---|
|     (1, 1) |     (1, 2) |     (1, 3) | ⋯ |
|          ⋮ |          ⋮ |          ⋮ | ⋱ |
|   (100, 1) |   (100, 2) |   (100, 3) | ⋯ |

*97 columns and 98 rows omitted*
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
            vertical_crop_mode = :middle,
        )

        @test result == expected
    end

    @testset "Omitted Cell Summary" begin
        expected = """
| **Col. 1** | **Col. 2** | **Col. 3** | ⋯ |
|-----------:|-----------:|-----------:|---|
|     (1, 1) |     (1, 2) |     (1, 3) | ⋯ |
|     (2, 1) |     (2, 2) |     (2, 3) | ⋯ |
|          ⋮ |          ⋮ |          ⋮ | ⋱ |
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
            show_omitted_cell_summary = false,
        )

        @test result == expected
    end

    @testset "Omitted Cell Summary With Zero Maximum Number of Rows" begin
        expected = """
| **Col. 1** | **Col. 2** |
|-----------:|-----------:|
|          ⋮ |          ⋮ |

*2 rows omitted*
"""

        result = pretty_table(
            String,
            [1 2; 3 4];
            backend = :markdown,
            maximum_number_of_rows = 0,
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# Functions to render the table cells in the Typst back end.
#
############################################################################################

"""
    _typst__cell_to_str(cell::Any, context::IOContext, renderer::Union{Val{:print}, Val{:show}}) -> String

Convert the `cell` to a string using a specific `context` and `renderer`.
"""
function _typst__cell_to_str(cell::Any, context::IOContext, ::Val{:print})
    return _sprint_with_context(print, context, cell)
end

function _typst__cell_to_str(cell::Any, context::IOContext, ::Val{:show})
    if showable(MIME("text/typst"), cell)
        cell_str = _sprint_with_context(show, context, MIME("text/typst"), cell)
    else
        cell_str = _sprint_with_context(show, context, cell)
    end

    return cell_str
end

function _typst__cell_to_str(cell::AbstractString, context::IOContext, ::Val{:show})
    if showable(MIME("text/typst"), cell)
        cell_str = _sprint_with_context(show, context, MIME("text/typst"), cell)
    else
        cell_str = string(cell)
    end

    return cell_str
end

_typst__cell_to_str(cell::UndefinedCell, context::IOContext, ::Val{:print}) = "#undef"

_typst__cell_to_str(cell::UndefinedCell, context::IOContext, ::Val{:show}) = "#undef"

"""
    _typst__render_cell(cell::Any, context::IOContext, renderer::Union{Val{:print}, Val{:show}}) -> String

Render the `cell` in Typst back end using a specific `context` and `renderer`.
"""
function _typst__render_cell(
    cell::Any, context::IOContext, renderer::Union{Val{:print}, Val{:show}}
)
    cell_str = _typst__cell_to_str(cell, context, renderer)

    # Notice that the cell content is always escaped, since it is emitted inside a Typst content block.
    return _typst__escape_str(cell_str)
end

function PrettyTables._typst__render_cell(
    cell::Markdown.MD, context::IOContext, renderer::Union{Val{:print}, Val{:show}}
)
    # We will always render Markdown cells using `#raw` until we can obtain a good way to
    # convert Markdown to Typst.
    str = "\"" * replace(chomp(string(cell)), "\n" => "\\n\" + \n  \"") * "\""

    return """
        #raw(
          $str,
          block: false,
          lang: "markdown",
        )"""
end

## Description #############################################################################
#
# Documentation for the Typst backend.
#
############################################################################################

"""
# PrettyTables.jl Typst Backend

The Typst backend can be selected by passing the keyword `backend = :typst` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output:

# Keywords

- `annotate::Bool`: Boolean indicating whether Typst code should be annotated.
- `caption::Union{Nothing, String, TypstCaption}`: Table caption to be used by the
    Typst `#figure` function. The user can provide additional configuration to the caption
    by using the `TypstCaption` structure.
- `data_column_widths::Union{Nothing, String, Vector{String}, Vector{Pair{Int, String}}}`:
    Column widths for the data columns. The information must be a valid length information
    in Typst, such as "10fr" or "30pt". If a single string is provided, it will be repeated
    for all columns. If a vector of strings is provided, its length must be equal to or
    larger than the number of printed columns. Alternatively, a vector of pairs can be
    provided, where the first element of the pair is the column index and the second element
    is the width for that column. In this case, columns that are not specified will have
    width `auto`.
    (**Default** = `nothing`)
- `highlighters::Vector{TypstHighlighter}`: Highlighters to apply to the table. For more
    information, see the section **Typst Highlighters** in the **Extended Help**.
    (**Default** = `TypstHighlighter[]`)
- `minify::Bool`: If `true`, the generated Typst code will be minified by ignoring
    `wrap_column` and printing the table columns in the same line.
    (**Default** = `false`)
- `style::TypstTableStyle`: Style of the table. For more information, see the section
    **Typst Table Style** in the **Extended Help**.
    (**Default** = `TypstTableStyle()`)
- `table_format::TypstTableFormat`: Typst table format used to render the table. For more
    information, see the section **Typst Table Format** in the **Extended Help**.
- `wrap_column::Integer`: Indicates the column where the output will be wrapped.
    (**Default** = `92`)

!!! note

    The content in the cells is always escaped. If you want to use a raw Typst component as
    cell, load the package Typstry.jl and pass the cell content as a `TypstString`. In this
    case, the content will not be escaped and will be treated as a raw Typst component.

# Extended Help

## Typst Highlighters

A set of highlighters can be passed as a `Vector{TypstHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`TypstHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)`, which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)`, where `h` is the
    highlighter. This function must return a `Vector{Pair{String, String}}` with properties
    compatible with the `style` field that will be applied to the highlighted cell.

A Typst highlighter can be constructed using three helpers:

```julia
TypstHighlighter(f::Function, decoration::Vector{Pair{String, String}})

TypstHighlighter(f::Function, decoration::TypstPair)

TypstHighlighter(f::Function, fd::Function)
```

The first two apply a fixed decoration to the highlighted cell specified in `decoration`,
whereas the third lets the user select the desired decoration by specifying the function
`fd`.

!!! note

    If multiple highlighters are valid for element `(i, j)`, the applied style is the first
    match according to the order in the vector `highlighters`.

!!! note

    If highlighters are used together with [Formatters](@ref), formatting changes
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells with value greater than 5 in red, and all
cells with values less than 5 in blue, we can define:

```julia
hl_gt5 = TypstHighlighter(
    (data, i, j) -> data[i, j] > 5,
    ["text-fill" => "red"]
)

hl_lt5 = TypstHighlighter(
    (data, i, j) -> data[i, j] < 5,
    ["text-fill" => "blue"]
)

highlighters = [hl_gt5, hl_lt5]
```

Each cell with properties is rendered with one call to `#text` inside a `table.cell`
function, as shown below:

```typst
table.cell()[#text()[Cell Content]]
```

!!! note

    Since `table.cell` and `#text()` share some attribute names, attributes used by the
    `#text` function must be defined with the `text-` prefix. For example, to create a table
    style (or highlighter) that sets a blue background and white font color:

    ```julia
    ["fill" => "blue", "text-fill" => "white"]
    ```

## Typst Table Format

The Typst table format is defined using an object of type [`TypstTableFormat`](@ref) that
contains the following fields:

- `borders::TypstTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn at the bottom of the merged column labels using `table.hline`.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data row. If the symbol `:none` is passed,
    no horizontal lines will be drawn after the data rows.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data column. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@typst__all_horizontal_lines`](@ref).
- [`@typst__all_vertical_lines`](@ref).
- [`@typst__no_horizontal_lines`](@ref).
- [`@typst__no_vertical_lines`](@ref).

## Typst Table Style

The Typst table style is defined using an object of type [`TypstTableStyle`](@ref) that
contains the following fields:

- `table::Vector{TypstPair}`: Style for the table.
- `title::Vector{TypstPair}`: Style for the title.
- `subtitle::Vector{TypstPair}`: Style for the subtitle.
- `row_number_label::Vector{TypstPair}`: Style for the row number label.
- `row_number::Vector{TypstPair}`: Style for the row number.
- `stubhead_label::Vector{TypstPair}`: Style for the stubhead label.
- `row_label::Vector{TypstPair}`: Style for the row label.
- `row_group_label::Vector{TypstPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{TypstPair}, Vector{Vector{TypstPair}}}`: Style for
  the first line of the column labels. If a vector of `Vector{TypstPair}` is provided, each
  column label in the first line will use the corresponding style.
- `column_label::Union{Vector{TypstPair}, Vector{Vector{TypstPair}}}`: Style for the rest of
  the column labels. If a vector of `Vector{TypstPair}` is provided, each column label will
  use the corresponding style.
- `first_line_merged_column_label::Vector{TypstPair}`: Style for the merged cells at the
  first column label line.
- `merged_column_label::Vector{TypstPair}`: Style for the merged cells at the rest of the
  column labels.
- `summary_row_cell::Vector{TypstPair}`: Style for the summary row cell.
- `summary_row_label::Vector{TypstPair}`: Style for the summary row label.
- `footnote::Vector{TypstPair}`: Style for the footnote.
- `omitted_cell_summary::Vector{TypstPair}`: Style for the omitted cell summary.
- `source_note::Vector{TypstPair}`: Style for the source notes.

Each field is a vector of [`TypstPair`](@ref), *i.e.* `Pair{String, String}`, describing
properties and values compatible with the Typst style attribute.

For example, if we want the stubhead label to be bold and red, we must define:

```julia
style = TypstTableStyle(
    stubhead_label = ["text-weight" => "bold", "text-fill" => "red"]
)
```

The user can pass any property compatible with the Typst style attribute. If the prefix
`text-` is used, the property will be applied to the text of the cell. Otherwise, it will be
applied to the cell itself.
"""
pretty_table_typst_backend

## Description #############################################################################
#
# Helpers for designing tables in the text backend.
#
############################################################################################

export @text__all_horizontal_lines, @text__all_vertical_lines
export @text__no_horizontal_lines, @text__no_vertical_lines

"""
    @text__all_horizontal_lines() -> Keywords for `TextTableFormat`

Return the keyword arguments to be passed to [`TextTableFormat`](@ref) to show all
horizontal lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a text table format with all horizontal lines:

```julia
tf = TextTableFormat(; @text__all_horizontal_lines())
```

Any option can be overridden by merging the keyword arguments. For example, the following
code shows all the horizontal lines but the first one:

```julia
tf = TextTableFormat(; @text__all_horizontal_lines, horizontal_line_at_beginning = false)
```

# Extended Help

## Example

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = TextTableFormat(; @text__all_horizontal_lines))
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
└────────┴────────┴────────┘

julia> pretty_table(
    A;
    table_format = TextTableFormat(
        ;
        @text__all_horizontal_lines,
        horizontal_line_after_column_labels = false
    )
)
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
│    1.0 │    1.0 │    1.0 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
└────────┴────────┴────────┘
```
"""
macro text__all_horizontal_lines()
    return :(
        (
            horizontal_line_at_beginning           = true,
            horizontal_line_after_column_labels    = true,
            horizontal_lines_at_data_rows          = :all,
            horizontal_line_before_row_group_label = true,
            horizontal_line_after_row_group_label  = true,
            horizontal_line_after_data_rows        = true,
            horizontal_line_before_summary_rows    = true,
            horizontal_line_after_summary_rows     = true,
        )...
    )
end

"""
    @text__all_vertical_lines() -> Keywords for `TextTableFormat`

Return the keyword arguments to be passed to [`TextTableFormat`](@ref) to show all vertical
lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a text table format with all vertical lines:

```julia
tf = TextTableFormat(; @text__all_vertical_lines)
```

Any option can be overridden by merging the keyword arguments. For example, the following
code shows all the vertical lines but the first one:

```julia
tf = TextTableFormat(; @text__all_vertical_lines, vertical_line_at_beginning = false)
```

# Extended Help

## Examples

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = TextTableFormat(; @text__all_vertical_lines))
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
└────────┴────────┴────────┘

julia> pretty_table(
    A;
    show_row_number_column = true,
    table_format = TextTableFormat(
        ;
        @text__all_vertical_lines,
        vertical_line_after_row_number_column = false
    )
)
┌─────────────┬────────┬────────┐
│ Row  Col. 1 │ Col. 2 │ Col. 3 │
├─────────────┼────────┼────────┤
│   1     1.0 │    1.0 │    1.0 │
│   2     1.0 │    1.0 │    1.0 │
│   3     1.0 │    1.0 │    1.0 │
└─────────────┴────────┴────────┘
```
"""
macro text__all_vertical_lines()
    return :(
        (
            suppress_vertical_lines_at_column_labels = false,
            vertical_line_after_continuation_column  = true,
            vertical_lines_at_data_columns           = :all,
            vertical_line_after_data_columns         = true,
            vertical_line_after_row_label_column     = true,
            vertical_line_after_row_number_column    = true,
            vertical_line_at_beginning               = true,
        )...
    )
end

"""
    @text__no_horizontal_lines() -> Keywords for `TextTableFormat`

Return the keyword arguments to be passed to [`TextTableFormat`](@ref) to suppress all
horizontal lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a text table format without horizontal lines:

```julia
tf = TextTableFormat(; @text__no_horizontal_lines)
```

Any option can be overridden by merging the keyword arguments. For example, the following
code draws only the horizontal line at the beginning of the table:

```julia
tf = TextTableFormat(; @text__no_horizontal_lines, horizontal_line_at_beginning = true)
```

# Extended Help

## Example

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = TextTableFormat(; @text__no_horizontal_lines))
│ Col. 1 │ Col. 2 │ Col. 3 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │

julia> pretty_table(
    A;
    table_format = TextTableFormat(
        ;
        @text__no_horizontal_lines,
        horizontal_line_after_column_labels = true
    )
)
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
```
"""
macro text__no_horizontal_lines()
    return :(
        (
            horizontal_line_at_beginning           = false,
            horizontal_line_after_column_labels    = false,
            horizontal_lines_at_data_rows          = :none,
            horizontal_line_before_row_group_label = false,
            horizontal_line_after_row_group_label  = false,
            horizontal_line_after_data_rows        = false,
            horizontal_line_before_summary_rows    = false,
            horizontal_line_after_summary_rows     = false,
        )...
    )
end

"""
    @text__no_vertical_lines() -> Keywords for `TextTableFormat`

Return the keyword arguments to be passed to [`TextTableFormat`](@ref) to suppress all
vertical lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a text table format without vertical lines:

```julia
tf = TextTableFormat(; @text__no_vertical_lines)
```

Any option can be overridden by merging the keyword arguments. For example, the following
code draws only the vertical line at the beginning of the table:

```julia
tf = TextTableFormat(; @text__no_vertical_lines, vertical_line_at_beginning = true)
```

# Extended Help

## Examples

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = TextTableFormat(; @text__no_vertical_lines))
────────────────────────
 Col. 1  Col. 2  Col. 3
────────────────────────
    1.0     1.0     1.0
    1.0     1.0     1.0
    1.0     1.0     1.0
────────────────────────

julia> pretty_table(
    A;
    show_row_number_column = true,
    table_format = TextTableFormat(
        ;
        @text__no_vertical_lines,
        vertical_line_after_row_number_column = true
    )
)
─────┬────────────────────────
 Row │ Col. 1  Col. 2  Col. 3
─────┼────────────────────────
   1 │    1.0     1.0     1.0
   2 │    1.0     1.0     1.0
   3 │    1.0     1.0     1.0
─────┴────────────────────────
```
"""
macro text__no_vertical_lines()
    return :(
        (
            suppress_vertical_lines_at_column_labels = true,
            vertical_line_after_continuation_column  = false,
            vertical_lines_at_data_columns           = :none,
            vertical_line_after_data_columns         = false,
            vertical_line_after_row_label_column     = false,
            vertical_line_after_row_number_column    = false,
            vertical_line_at_beginning               = false,
        )...
    )
end

## Description #############################################################################
#
# Markdown Back End: Tests related to special cells.
#
############################################################################################

@testset "Special Cells" verbose = true begin
    @testset "Markdown Code Espaping" begin
        matrix = ["**Bold**", "~~Strike~~", "`Code`"]

        expected = """
|     **Col. 1** |
|---------------:|
|   \\*\\*Bold\\*\\* |
| \\~\\~Strike\\~\\~ |
|       \\`Code\\` |
"""

        result = pretty_table(String, matrix; backend = :markdown)

        @test result == expected

        result = pretty_table(String, matrix; backend = :markdown, renderer = :show)

        @test result == expected
    end

    @testset "Markdown Cells" begin
        matrix = ["**Bold**", "~~Strike~~", md"`Code`"]

        expected = """
|     **Col. 1** |
|---------------:|
|   \\*\\*Bold\\*\\* |
| \\~\\~Strike\\~\\~ |
|         `Code` |
"""

        result = pretty_table(String, matrix; backend = :markdown)

        @test result == expected

        result = pretty_table(String, matrix; backend = :markdown, renderer = :show)

        @test result == expected
    end

    @testset "Allow Markdown in Cells" begin
        matrix = ["**Bold**", "~~Strike~~", md"`Code`"]

        expected = """
| **Col. 1** |
|-----------:|
|   **Bold** |
| ~~Strike~~ |
|     `Code` |
"""

        result = pretty_table(
            String, matrix; backend = :markdown, allow_markdown_in_cells = true
        )

        @test result == expected

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            allow_markdown_in_cells = true,
            renderer = :show,
        )

        @test result == expected
    end

    @testset "Line Breaks" begin
        matrix = ["First Line\nSecond Line" "Third Line\nFourth Line"]

        expected = """
|              **Col. 1** |              **Col. 2** |
|------------------------:|------------------------:|
| First Line\\nSecond Line | Third Line\\nFourth Line |
"""

        result = pretty_table(String, matrix; backend = :markdown)

        @test result == expected

        result = pretty_table(String, matrix; backend = :markdown, renderer = :show)

        @test result == expected

        expected = """
|                **Col. 1** |                **Col. 2** |
|--------------------------:|--------------------------:|
| First Line<br>Second Line | Third Line<br>Fourth Line |
"""

        result = pretty_table(String, matrix; backend = :markdown, line_breaks = true)

        @test result == expected

        result = pretty_table(
            String, matrix; backend = :markdown, line_breaks = true, renderer = :show
        )

        @test result == expected
    end

    @testset "Undefined Cells" begin
        v    = Vector{Any}(undef, 5)
        v[1] = undef
        v[2] = "String"
        v[5] = π

        expected = """
|         **Col. 1** |
|-------------------:|
| UndefInitializer() |
|             String |
|             #undef |
|             #undef |
|                  π |
"""

        result = pretty_table(String, v; backend = :markdown)

        @test result == expected

        result = pretty_table(String, v; backend = :markdown, renderer = :show)

        @test result == expected
    end

    @testset "Escaping of Markdown Metacharacters" begin
        # `\` must be escaped first. Otherwise, the backslash this function inserts for, say,
        # `*` would sit next to a user backslash, `\\` would render as a literal backslash,
        # and the `*` would start an emphasis span.
        #
        # `[` and `]` are critical because the back end itself emits `[^N]` footnote
        # references, so unescaped user data could collide with the generated markup. `<` and
        # `>` would otherwise be interpreted as raw HTML or as an autolink.
        matrix = ["a\\*b" "c[^1]d" "e<b>f" "g|h" "i*j" "k_l" "m~n" "o`p"]

        result = pretty_table(String, matrix; backend = :markdown)

        @test occursin("a\\\\\\*b", result)
        @test occursin("c\\[^1\\]d", result)
        @test occursin("e\\<b\\>f", result)
        @test occursin("g\\|h", result)
        @test occursin("i\\*j", result)
        @test occursin("k\\_l", result)
        @test occursin("m\\~n", result)
        @test occursin("o\\`p", result)
    end

    @testset "Sentinels Are Not Escaped" begin
        # `#` must not be escaped, otherwise the sentinels this package emits would be
        # corrupted.
        v    = Vector{Any}(undef, 1)
        result = pretty_table(String, v; backend = :markdown)

        @test occursin("#undef", result)
        @test !occursin("\\#undef", result)
    end

    @testset "Line Breaks Still Emit <br>" begin
        # The `<br>` the back end emits for line breaks is produced *after* the escaping,
        # hence escaping `<` and `>` at the source level must not affect it.
        result = pretty_table(String, ["a\nb"]; backend = :markdown, line_breaks = true)

        @test occursin("a<br>b", result)

        # Without `line_breaks`, the newline must be escaped instead.
        result = pretty_table(String, ["a\nb"]; backend = :markdown, line_breaks = false)

        @test occursin("a\\nb", result)
    end
end

## Description #############################################################################
#
# Test line breaks.
#
############################################################################################

@testset "Line Breaks Inside Cells" begin
    data = [
        "This line contains\nthe velocity [m/s]" 10.0
        "This line contains\nthe acceleration [m/s^2]" 1.0
        "This line contains\nthe time from the\nbeginning of the simulation" 10
    ]

    column_labels = ["Information", "Value"]

    expected = """
┌─────────────────────────────┬───────┐
│                 Information │ Value │
├─────────────────────────────┼───────┤
│          This line contains │  10.0 │
│          the velocity [m/s] │       │
│          This line contains │   1.0 │
│    the acceleration [m/s^2] │       │
│          This line contains │    10 │
│           the time from the │       │
│ beginning of the simulation │       │
└─────────────────────────────┴───────┘
"""

    result = pretty_table(String, data; column_labels, line_breaks = true)
    @test result == expected

    expected = """
┌─────────────────────────────┬───────┐
│         Information         │ Value │
├─────────────────────────────┼───────┤
│     This line contains      │ 10.0  │
│     the velocity [m/s]      │       │
│     This line contains      │  1.0  │
│  the acceleration [m/s^2]   │       │
│     This line contains      │  10   │
│      the time from the      │       │
│ beginning of the simulation │       │
└─────────────────────────────┴───────┘
"""

    result = pretty_table(String, data; alignment = :c, column_labels, line_breaks = true)
    @test result == expected

    expected = """
┌─────────────────────────────┬───────┐
│ Information                 │ Value │
├─────────────────────────────┼───────┤
│ This line contains          │ 10.0  │
│ the velocity [m/s]          │       │
│ This line contains          │ 1.0   │
│ the acceleration [m/s^2]    │       │
│ This line contains          │ 10    │
│ the time from the           │       │
│ beginning of the simulation │       │
└─────────────────────────────┴───────┘
"""

    result = pretty_table(String, data; alignment = :l, column_labels, line_breaks = true)
    @test result == expected

    expected = """
┌────────────────────────────────────────────────────────────────────┬───────┐
│                                                        Information │ Value │
├────────────────────────────────────────────────────────────────────┼───────┤
│                             This line contains\\nthe velocity [m/s] │  10.0 │
│                       This line contains\\nthe acceleration [m/s^2] │   1.0 │
│ This line contains\\nthe time from the\\nbeginning of the simulation │    10 │
└────────────────────────────────────────────────────────────────────┴───────┘
"""

    result = pretty_table(String, data; column_labels)
    @test result == expected
end

@testset "Auto wrapping" begin
    table = [
        1 """Ouviram do Ipiranga as margens plácidas
             De um povo heróico o brado retumbante,
             E o sol da Liberdade, em raios fúlgidos,
             Brilhou no céu da Pátria nesse instante."""
        2 """Se o penhor dessa igualdade
             Conseguimos conquistar com braço forte,
             Em teu seio, ó Liberdade,
             Desafia o nosso peito a própria morte!"""
        3 """Ó Pátria amada, Idolatrada, Salve! Salve!
             Brasil, um sonho intenso, um raio vívido
             De amor e de esperança à terra desce,
             Se em teu formoso céu, risonho e límpido,"""
    ]

    column_labels = ["Verse Number", "Verse"]

    expected = """
┌──────────────┬────────────────────────────────┐
│ Verse Number │                          Verse │
├──────────────┼────────────────────────────────┤
│            1 │ Ouviram do Ipiranga as margens │
│              │                       plácidas │
│              │     De um povo heróico o brado │
│              │                    retumbante, │
│              │ E o sol da Liberdade, em raios │
│              │                      fúlgidos, │
│              │ Brilhou no céu da Pátria nesse │
│              │                      instante. │
├──────────────┼────────────────────────────────┤
│            2 │    Se o penhor dessa igualdade │
│              │     Conseguimos conquistar com │
│              │                   braço forte, │
│              │      Em teu seio, ó Liberdade, │
│              │        Desafia o nosso peito a │
│              │                 própria morte! │
├──────────────┼────────────────────────────────┤
│            3 │    Ó Pátria amada, Idolatrada, │
│              │                  Salve! Salve! │
│              │   Brasil, um sonho intenso, um │
│              │                    raio vívido │
│              │ De amor e de esperança à terra │
│              │                         desce, │
│              │ Se em teu formoso céu, risonho │
│              │                     e límpido, │
└──────────────┴────────────────────────────────┘
"""

    result = pretty_table(
        String,
        table;
        auto_wrap                = true,
        column_labels            = column_labels,
        fixed_data_column_widths = [0, 30],
        line_breaks              = true,
        table_format             = TextTableFormat(; @text__all_horizontal_lines),
    )

    @test result == expected

    expected = """
┌──────────────┬────────────────────────────────┐
│ Verse Number │             Verse              │
├──────────────┼────────────────────────────────┤
│      1       │ Ouviram do Ipiranga as margens │
│              │            plácidas            │
│              │   De um povo heróico o brado   │
│              │          retumbante,           │
│              │ E o sol da Liberdade, em raios │
│              │           fúlgidos,            │
│              │ Brilhou no céu da Pátria nesse │
│              │           instante.            │
├──────────────┼────────────────────────────────┤
│      2       │  Se o penhor dessa igualdade   │
│              │   Conseguimos conquistar com   │
│              │          braço forte,          │
│              │   Em teu seio, ó Liberdade,    │
│              │    Desafia o nosso peito a     │
│              │         própria morte!         │
├──────────────┼────────────────────────────────┤
│      3       │  Ó Pátria amada, Idolatrada,   │
│              │         Salve! Salve!          │
│              │  Brasil, um sonho intenso, um  │
│              │          raio vívido           │
│              │ De amor e de esperança à terra │
│              │             desce,             │
│              │ Se em teu formoso céu, risonho │
│              │           e límpido,           │
└──────────────┴────────────────────────────────┘
"""

    result = pretty_table(
        String,
        table;
        alignment                = :c,
        auto_wrap                = true,
        column_labels            = column_labels,
        fixed_data_column_widths = [-1, 30],
        line_breaks              = true,
        table_format             = TextTableFormat(; @text__all_horizontal_lines),
    )

    @test result == expected

    expected = """
┌──────────────┬────────────────────────────────┐
│ Verse Number │                          Verse │
├──────────────┼────────────────────────────────┤
│            1 │ Ouviram do Ipiranga as margens │
│              │                       plácidas │
│              │     De um povo heróico o brado │
│              │                    retumbante, │
│              │ E o sol da Liberdade, em raios │
│              │                      fúlgidos, │
│              │ Brilhou no céu da Pátria nesse │
│              │                      instante. │
├──────────────┼────────────────────────────────┤
│            2 │    Se o penhor dessa igualdade │
│              │     Conseguimos conquistar com │
│              │                   braço forte, │
│              │      Em teu seio, ó Liberdade, │
│              │        Desafia o nosso peito a │
│              │                 própria morte! │
├──────────────┼────────────────────────────────┤
│            3 │    Ó Pátria amada, Idolatrada, │
│              │                  Salve! Salve! │
│              │   Brasil, um sonho intenso, um │
│              │                    raio vívido │
│              │ De amor e de esperança à terra │
│              │                         desce, │
│              │ Se em teu formoso céu, risonho │
│              │                     e límpido, │
└──────────────┴────────────────────────────────┘
"""

    result = pretty_table(
        String,
        table;
        alignment                = :r,
        auto_wrap                = true,
        column_labels            = column_labels,
        fixed_data_column_widths = [-1, 30],
        line_breaks              = true,
        table_format             = TextTableFormat(; @text__all_horizontal_lines),
    )

    @test result == expected

    # -- Test with additional rows ---------------------------------------------------------

    expected = """
┌─────┬──────────┬──────────────┬────────────────────────────────┐
│ Row │    Verso │ Verse Number │ Verse                          │
├─────┼──────────┼──────────────┼────────────────────────────────┤
│   1 │ Primeiro │ 1            │ Ouviram do Ipiranga as margens │
│     │          │              │ plácidas                       │
│     │          │              │ De um povo heróico o brado     │
│     │          │              │ retumbante,                    │
│     │          │              │ E o sol da Liberdade, em raios │
│     │          │              │ fúlgidos,                      │
│     │          │              │ Brilhou no céu da Pátria nesse │
│     │          │              │ instante.                      │
├─────┼──────────┼──────────────┼────────────────────────────────┤
│   2 │  Segundo │ 2            │ Se o penhor dessa igualdade    │
│     │          │              │ Conseguimos conquistar com     │
│     │          │              │ braço forte,                   │
│     │          │              │ Em teu seio, ó Liberdade,      │
│     │          │              │ Desafia o nosso peito a        │
│     │          │              │ própria morte!                 │
├─────┼──────────┼──────────────┼────────────────────────────────┤
│   3 │ Terceiro │ 3            │ Ó Pátria amada, Idolatrada,    │
│     │          │              │ Salve! Salve!                  │
│     │          │              │ Brasil, um sonho intenso, um   │
│     │          │              │ raio vívido                    │
│     │          │              │ De amor e de esperança à terra │
│     │          │              │ desce,                         │
│     │          │              │ Se em teu formoso céu, risonho │
│     │          │              │ e límpido,                     │
└─────┴──────────┴──────────────┴────────────────────────────────┘
"""

    result = pretty_table(
        String,
        table;
        alignment                = :l,
        auto_wrap                = true,
        column_labels            = column_labels,
        fixed_data_column_widths = [-1, 30],
        line_breaks              = true,
        row_labels               = ["Primeiro", "Segundo", "Terceiro"],
        show_row_number_column   = true,
        stubhead_label           = "Verso",
        table_format             = TextTableFormat(; @text__all_horizontal_lines),
    )

    @test result == expected
end

## Description #############################################################################
#
# Types and structures for the Typst back end.
#
############################################################################################

export TypstHighlighter, TypstTableBorders, TypstTableFormat, TypstTableStyle, TypstCaption


############################################################################################
#                                        Constants                                         #
############################################################################################

# == Public ================================================================================

const TypstPair  = Pair{String, String}
const TypstAttrs = String

# == Private ===============================================================================

const _TYPST__ALIGNMENT_MAP = Dict(
    :l => "left", :L => "left", :c => "center", :C => "center", :r => "right", :R => "right"
)

const _TYPST__CELL_ATTRIBUTES = [
    "align", "breakable", "colspan", "fill", "inset", "rowspan", "stroke"
]

const _TYPST__TABLE_ATTRIBUTES = [
    "rows", "gutter", "column-gutter", "row-gutter", "inset", "fill", "stroke"
]

const _TYPST__STRING_ATTRIBUTES = [
    "bottom-edge",
    "font",
    "lang",
    "number-type",
    "number-width",
    "region",
    "script",
    "style",
    "top-edge",
    "weight",
]

const _TYPST__TEXT_ATTRIBUTES = [
    "alternates",
    "baseline",
    "bottom-edge",
    "cjk-latin-spacing",
    "costs",
    "dir",
    "discretionary-ligatures",
    "fallback",
    "features",
    "fill",
    "font",
    "fractions",
    "historical-ligatures",
    "hyphenate",
    "kerning",
    "lang",
    "ligatures",
    "number-type",
    "number-width",
    "overhang",
    "region",
    "script",
    "size",
    "slashed-zero",
    "spacing",
    "stretch",
    "style",
    "stylistic-set",
    "top-edge",
    "tracking",
    "weight",
]

# -- Decorations ---------------------------------------------------------------------------

const _TYPST__NO_DECORATION     = TypstPair[]

# Shared empty vector returned when a cell has no properties. It must never be mutated.
const _TYPST__EMPTY_PROPERTIES  = TypstPair[]
const _TYPST__BOLD              = ["text-weight" => "bold"]
const _TYPST__ITALIC            = ["text-style" => "italic"]
const _TYPST__XLARGE_BOLD       = ["text-size" => "1.1em", "text-weight" => "bold"]
const _TYPST__LARGE_ITALIC      = ["text-size" => "1.1em", "text-style" => "italic"]
const _TYPST__SMALL             = ["text-size" => "0.9em"]
const _TYPST__SMALL_ITALIC      = ["text-size" => "0.9em", "text-style" => "italic"]
const _TYPST__SMALL_ITALIC_GRAY = ["text-fill" => "gray", "text-size" => "0.9em", "text-style" => "italic"]
const _TYPST__MERGED_CELL       = TypstPair[]

############################################################################################
#                                          Types                                           #
############################################################################################

"""
    struct TypstHighlighter

Define the default highlighter of a table when using the Typst back end.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
    highlighter. This function must return a `Vector{Pair{String, String}}` with properties
    compatible with the `style` field that will be applied to the highlighted cell.
- `_decoration::Vector{TypstPair}`: The decoration to be applied to the highlighted cell
    if the default `fd` is used.

# Remarks

This structure can be constructed using the following helpers:

    TypstHighlighter(f::Function, decoration::TypstPair)

    TypstHighlighter(f::Function, decoration::Vector{TypstPair})

    TypstHighlighter(f::Function, fd::Function)

The first two apply a fixed decoration to the highlighted cell, whereas the third lets the
user select the desired decoration by specifying the function `fd`.
"""
struct TypstHighlighter
    f::Function
    fd::Function

    # == Private Fields ====================================================================

    _decoration::Vector{TypstPair}

    # == Constructors ======================================================================

    function TypstHighlighter(f::Function, fd::Function)
        return new(f, fd, TypstPair[])
    end

    function TypstHighlighter(f::Function, decoration::TypstPair)
        return new(f, _typst__default_highlighter_fd, [decoration])
    end

    function TypstHighlighter(f::Function, decoration::Vector{TypstPair})
        return new(f, _typst__default_highlighter_fd, decoration)
    end

    function TypstHighlighter(f::Function, decoration::Vector{TypstPair}, args::TypstPair...)
        return new(f, _typst__default_highlighter_fd, [decoration..., args...])
    end
end

_typst__default_highlighter_fd(h::TypstHighlighter, ::Any, ::Int, ::Int) = h._decoration

"""
    struct TypstTableBorders

Define the stroke widths for the borders of a table printed with the Typst back end. All
fields are strings with the properties that can be passed to a `stroke` object (e.g.,
`"(paint: blue, thickness: 4pt, cap: \"round\")"`). For more information, refer to:
https://typst.app/docs/reference/visualize/stroke/

# Fields

## Horizontal Lines

- `top_line::String`: Stroke for the top border of the table.
    (**Default**: `"1.5pt"`)
- `header_line::String`: Stroke for the line below the table header.
    (**Default**: `"0.8pt"`)
- `merged_header_cell_line::String`: Stroke for the line below merged header cells.
    (**Default**: `"0.8pt"`)
- `middle_line::String`: Stroke for horizontal lines inside the table body.
    (**Default**: `"0.5pt"`)
- `bottom_line::String`: Stroke for the bottom border of the table.
    (**Default**: `"1.5pt"`)

## Vertical Lines

- `left_line::String`: Stroke for the left border of the table.
    (**Default**: `"1.5pt"`)
- `center_line::String`: Stroke for vertical lines inside the table body.
    (**Default**: `"0.8pt"`)
- `right_line::String`: Stroke for the right border of the table.
    (**Default**: `"1.5pt"`)
"""
@kwdef struct TypstTableBorders
    # == Horizontal Lines ==================================================================

    top_line::String                = "1.5pt"
    header_line::String             = "0.8pt"
    merged_header_cell_line::String = "0.8pt"
    middle_line::String             = "0.5pt"
    bottom_line::String             = "1.5pt"

    # == Vertical Lines ====================================================================

    left_line::String   = "1.5pt"
    center_line::String = "0.8pt"
    right_line::String  = "1.5pt"
end

"""
    struct TypstTableFormat

Define the format of the tables printed with the Typst back end.

# Fields

- `borders::TypstTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn at the bottom of the merged column labels using `table.hline`.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data row. If the symbol `:none` is passed,
    no horizontal lines will be drawn after the data rows.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data column. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.
"""
@kwdef struct TypstTableFormat
    borders::TypstTableBorders = TypstTableBorders()

    # == Configuration for the Horizontal and Vertical Lines ===============================

    horizontal_line_at_beginning::Bool = true
    horizontal_line_after_column_labels::Bool = true
    horizontal_line_at_merged_column_labels::Bool = true
    horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}} = :none
    horizontal_line_before_row_group_label::Bool = true
    horizontal_line_after_row_group_label::Bool = true
    horizontal_line_after_data_rows::Bool = true
    horizontal_line_before_summary_rows::Bool = true
    horizontal_line_after_summary_rows::Bool = true

    vertical_line_at_beginning::Bool = true
    vertical_line_after_row_number_column::Bool = true
    vertical_line_after_row_label_column::Bool = true
    vertical_lines_at_data_columns::Union{Symbol, Vector{Int}} = :all
    vertical_line_after_data_columns::Bool = true
    vertical_line_after_continuation_column::Bool = true
end

"""
    struct TypstTableStyle

Define the style of the tables printed with the Typst back end.

# Fields

- `table::Vector{TypstPair}`: Style for the table.
- `title::Vector{TypstPair}`: Style for the title.
- `subtitle::Vector{TypstPair}`: Style for the subtitle.
- `row_number_label::Vector{TypstPair}`: Style for the row number label.
- `row_number::Vector{TypstPair}`: Style for the row number.
- `stubhead_label::Vector{TypstPair}`: Style for the stubhead label.
- `row_label::Vector{TypstPair}`: Style for the row label.
- `row_group_label::Vector{TypstPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{TypstPair}, Vector{Vector{TypstPair}}}`: Style for
    the first line of the column labels. If a vector of `Vector{TypstPair}` is provided,
    each column label in the first line will use the corresponding style.
- `column_label::Union{Vector{TypstPair}, Vector{Vector{TypstPair}}}`: Style for the rest of
    the column labels. If a vector of `Vector{TypstPair}` is provided, each column label
    will use the corresponding style.
- `first_line_merged_column_label::Vector{TypstPair}`: Style for the merged cells at the
    first column label line.
- `merged_column_label::Vector{TypstPair}`: Style for the merged cells at the rest of the
    column labels.
- `omitted_cell_summary::Vector{TypstPair}`: Style for the omitted cell summary.
- `summary_row_cell::Vector{TypstPair}`: Style for the summary row cell.
- `summary_row_label::Vector{TypstPair}`: Style for the summary row label.
- `footnote::Vector{TypstPair}`: Style for the footnote.
- `source_note::Vector{TypstPair}`: Style for the source notes.
"""
@kwdef struct TypstTableStyle{
    TFCL <: Union{Vector{TypstPair}, Vector{Vector{TypstPair}}},
    TCL <: Union{Vector{TypstPair}, Vector{Vector{TypstPair}}},
}
    table::Vector{TypstPair}                          = _TYPST__NO_DECORATION
    title::Vector{TypstPair}                          = _TYPST__XLARGE_BOLD
    subtitle::Vector{TypstPair}                       = _TYPST__LARGE_ITALIC
    row_number_label::Vector{TypstPair}               = _TYPST__BOLD
    row_number::Vector{TypstPair}                     = _TYPST__BOLD
    stubhead_label::Vector{TypstPair}                 = _TYPST__BOLD
    row_label::Vector{TypstPair}                      = _TYPST__BOLD
    row_group_label::Vector{TypstPair}                = _TYPST__BOLD
    first_line_column_label::TFCL                     = _TYPST__BOLD
    column_label::TCL                                 = _TYPST__BOLD
    first_line_merged_column_label::Vector{TypstPair} = _TYPST__MERGED_CELL
    merged_column_label::Vector{TypstPair}            = _TYPST__MERGED_CELL
    omitted_cell_summary::Vector{TypstPair}           = _TYPST__SMALL_ITALIC_GRAY
    summary_row_cell::Vector{TypstPair}               = _TYPST__NO_DECORATION
    summary_row_label::Vector{TypstPair}              = _TYPST__BOLD
    footnote::Vector{TypstPair}                       = _TYPST__SMALL
    source_note::Vector{TypstPair}                    = _TYPST__SMALL_ITALIC_GRAY
end

"""
    struct TypstCaption

Define a Typst caption configuration to be used by the Typst backend.

# Fields

- `caption::String`: Caption text.
- `kind::String`: Caption kind forwarded to Typst (for example, `auto` or a
    custom kind).
- `supplement::Union{Nothing, String}`: Optional caption supplement.
- `gap::String`: Gap between figure content and caption.
- `position::Union{Nothing, String}`: Optional caption position.
"""
@kwdef struct TypstCaption
    caption::String
    kind::String = "auto"
    supplement::Union{Nothing, String} = nothing
    gap::String = "auto"
    position::Union{Nothing, String} = nothing
end

TypstCaption(caption::String; kwargs...) = TypstCaption(; caption, kwargs...)

## Description #############################################################################
#
# Functions to render the table cells in text back end.
#
############################################################################################

# NOTE: The functions to render the cell must receive the current `IOContext` because we
# need to check for circular dependency. We store the information about the objects being
# printed inside the key `__PRETTY_TABLES__DATA__` in the IO context. Hence, we must pass it
# forward when rendering the cells.

"""
    _text__cell_to_str(cell::Any, context::IOContext, renderer::Union{Val{:print}, Val{:show}}) -> String

Convert the `cell` to a string using a specific `context` and `renderer`.
"""
function _text__cell_to_str(cell::Any, @nospecialize(context::IOContext), ::Val{:print})
    cell isa String && return cell
    return _sprint_with_context(print, context, cell)
end

function _text__cell_to_str(cell::Any, @nospecialize(context::IOContext), ::Val{:show})
    return _sprint_with_context(show, context, MIME("text/plain"), cell)
end

function _text__cell_to_str(
    cell::AbstractString, @nospecialize(context::IOContext), ::Val{:show}
)
    cell isa String && return cell
    return _sprint_with_context(print, context, cell)
end

function _text__cell_to_str(::UndefinedCell, @nospecialize(::IOContext), ::Val{:print})
    return "#undef"
end

function _text__cell_to_str(::UndefinedCell, @nospecialize(::IOContext), ::Val{:show})
    return "#undef"
end

function _text__cell_to_str(
    cell::MergeCells, @nospecialize(context::IOContext), renderer::Val{:print}
)
    return _text__cell_to_str(cell.data, context, renderer)
end

function _text__cell_to_str(
    cell::MergeCells, @nospecialize(context::IOContext), renderer::Val{:show}
)
    return _text__cell_to_str(cell.data, context, renderer)
end

"""
    _text__render_cell(cell::Any, @nospecialize(context::IOContext), renderer::Union{Val{:print}, Val{:show}}, line_breaks::Bool = false, column_width::Int = -1) -> String

Render the `cell` in text back end using a specific `context` and `renderer`.

If `line_breaks` is `true`, the user wants to see line breaks in the output. The parameter
`column_width` contains the maximum column width of the current cell. Currently, it is only
used when rendering `Markdown.MD` cells.
"""
function _text__render_cell(
    cell::Any,
    @nospecialize(context::IOContext),
    renderer::Union{Val{:print}, Val{:show}},
    line_breaks::Bool = false,
    column_width::Int = -1,
)::String
    cell_str = _text__cell_to_str(cell, context, renderer)

    # `escape_string` always goes through `sprint`, allocating a fresh `IOBuffer`, its backing
    # array, and a `String` even when the input needs no escaping at all. Since that is by far
    # the most common case (numbers, plain identifiers, ordinary words), we scan the string
    # first and return it untouched when there is nothing to do.
    _text__needs_escaping(cell_str, line_breaks) || return cell_str

    # If the user wants line breaks, we should not escape the character `\n`.
    keep = line_breaks ? '\n' : ()

    return escape_string(cell_str, (); keep)
end

"""
    _text__needs_escaping(str::AbstractString, line_breaks::Bool) -> Bool

Return whether `escape_string` would change `str`. If `line_breaks` is `true`, the character
`\\n` is not considered, since it is kept verbatim.

Notice that this function is allowed to be conservative, that is, to return `true` for a
string that would in fact be left unchanged. It must never return `false` for a string that
would be modified.
"""
function _text__needs_escaping(str::AbstractString, line_breaks::Bool)
    for c in str
        (c == '\\') && return true

        isprint(c) && continue

        # A kept newline is emitted verbatim.
        (line_breaks && (c == '\n')) && continue

        return true
    end

    return false
end

function _text__render_cell(
    cell::AbstractCustomTextCell,
    @nospecialize(context::IOContext),
    renderer::Union{Val{:print}, Val{:show}},
    line_breaks::Bool = false,
    column_width::Int = -1,
)::String
    # Here, we are rendering the cell for the first time. Hence, we need to initialize it.
    CustomTextCell.init!(cell, context, renderer; line_breaks)

    return CustomTextCell.printable_cell_text(cell)
end

function _text__render_cell(
    cell::Markdown.MD,
    @nospecialize(context::IOContext),
    renderer::Union{Val{:print}, Val{:show}},
    line_breaks::Bool = false,
    column_width::Int = -1,
)::String
    # If the user does not want to break lines, we will set the column with equal to
    # `typemax(Int)`, which means that the text will never be broken into multiple
    # lines.
    if !line_breaks
        column_width = typemax(Int)
    elseif column_width <= 0
        column_width = 80
    end

    cell_str = _sprint_with_context(Markdown.term, context, cell, column_width)

    if !line_breaks
        cell_str = replace(cell_str, '\n' => "\\n")
    end

    return cell_str
end

@static if VERSION >= v"1.11"
    function _text__render_cell(
        cell::Base.AnnotatedString,
        @nospecialize(context::IOContext),
        renderer::Union{Val{:print}, Val{:show}},
        line_breaks::Bool = false,
        column_width::Int = -1,
    )::String
        cell_str = _text__cell_to_str(cell, context, renderer)

        if !line_breaks
            cell_str = replace(cell_str, '\n' => "\\n")
        end

        return cell_str
    end
end

## Description #############################################################################
#
# Text cell to render a URL.
#
############################################################################################

export UrlTextCell

mutable struct UrlTextCell <: AbstractCustomTextCell
    text::String
    url::String

    # == API Configurations ================================================================

    crop::Int
    left_padding::Int
    right_padding::Int
    suffix::String

    # == Constructor =======================================================================

    function UrlTextCell(text::String, url::String)
        return new(text, url, 0, 0, 0, "")
    end
end

############################################################################################
#                                           API                                            #
############################################################################################

function CustomTextCell.add_suffix!(cell::UrlTextCell, suffix::String)
    cell.suffix = suffix
    return nothing
end

function CustomTextCell.crop!(cell::UrlTextCell, field_width::Int)
    cell.crop = field_width
    return nothing
end

function CustomTextCell.init!(
    cell::UrlTextCell,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    line_breaks::Bool = false,
)
    cell.crop          = 0
    cell.left_padding  = 0
    cell.right_padding = 0
    cell.suffix        = ""

    return nothing
end

function CustomTextCell.left_padding!(cell::UrlTextCell, pad::Int)
    cell.left_padding = pad
    return nothing
end

function CustomTextCell.right_padding!(cell::UrlTextCell, pad::Int)
    cell.right_padding = pad
    return nothing
end

function CustomTextCell.rendered_cell(cell::UrlTextCell)
    text = CustomTextCell.printable_cell_text(cell)
    rendered_cell = "\e]8;;$(cell.url)\e\\$(text)\e]8;;\e\\"
    return rendered_cell
end

function CustomTextCell.printable_cell_text(cell::UrlTextCell)
    left_padding_str  = " "^max(cell.left_padding, 0)
    right_padding_str = " "^max(cell.right_padding, 0)
    full_str          = left_padding_str * cell.text * right_padding_str
    cropped_str       = first(right_crop(full_str, cell.crop)) * cell.suffix

    return cropped_str
end

## Description #############################################################################
#
# Text cell with ANSI escape sequences.
#
############################################################################################

export AnsiTextCell

mutable struct AnsiTextCell <: AbstractCustomTextCell
    content::String

    # == API Configurations ================================================================

    crop::Int
    left_padding::Int
    right_padding::Int
    suffix::String

    # == Line Breaks =======================================================================

    line_breaks::Bool
    lines::Union{Nothing, Vector{String}}
    decorations::Union{Nothing, Vector{Decoration}}

    # == Constructor =======================================================================

    function AnsiTextCell(content::String)
        return new(content, 0, 0, 0, "", false, nothing, nothing)
    end

    function AnsiTextCell(renderfn::Function; context::Tuple = ())
        # Render the text and create the text cell.
        io = IOBuffer()
        renderfn(IOContext(io, context...))
        rendered = String(take!(io))
        return AnsiTextCell(rendered)
    end
end

############################################################################################
#                                           API                                            #
############################################################################################

function CustomTextCell.add_suffix!(cell::AnsiTextCell, suffix::String)
    cell.suffix = suffix
    return nothing
end

function CustomTextCell.crop!(cell::AnsiTextCell, field_width::Int)
    cell.crop = field_width
    return nothing
end

function CustomTextCell.init!(
    cell::AnsiTextCell,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    line_breaks::Bool = false,
)
    cell.crop          = 0
    cell.left_padding  = 0
    cell.right_padding = 0
    cell.line_breaks   = line_breaks
    cell.suffix        = ""
    cell.lines         = nothing
    cell.decorations   = nothing

    if line_breaks
        lines     = String.(split(cell.content, '\n'))
        num_lines = length(lines)

        current_decoration = Decoration()
        decorations        = Decoration[]
        sizehint!(decorations, num_lines)

        for line in lines
            push!(decorations, current_decoration)
            current_decoration = drop_inactive_properties(
                update_decoration(current_decoration, line)
            )
        end

        cell.decorations = decorations
        cell.lines       = lines
    end

    return nothing
end

function CustomTextCell.left_padding!(cell::AnsiTextCell, pad::Int)
    cell.left_padding = pad
    return nothing
end

function CustomTextCell.right_padding!(cell::AnsiTextCell, pad::Int)
    cell.right_padding = pad
    return nothing
end

function CustomTextCell.rendered_cell(cell::AnsiTextCell)
    left_padding_str  = " "^max(cell.left_padding, 0)
    right_padding_str = " "^max(cell.right_padding, 0)
    line_str          = if !cell.line_breaks
        replace(cell.content, '\n' => "\\n")
    else
        cell.content
    end

    cropped_str, remaining_ansi = right_crop(line_str, cell.crop)

    return left_padding_str *
           cropped_str *
           remaining_ansi *
           _TEXT__STRING_RESET *
           right_padding_str *
           cell.suffix
end

function CustomTextCell.rendered_cell_line(cell::AnsiTextCell, line::Int)
    if isnothing(cell.lines)
        line == 1 && return CustomTextCell.rendered_cell(cell)
        return ""
    end

    (line > length(cell.lines)) && return ""

    left_padding_str  = " "^max(cell.left_padding, 0)
    right_padding_str = " "^max(cell.right_padding, 0)
    line_str          = cell.lines[line]
    decoration_str    = convert(String, cell.decorations[line])

    cropped_str, remaining_ansi = right_crop(line_str, cell.crop)

    return decoration_str *
           left_padding_str *
           cropped_str *
           remaining_ansi *
           _TEXT__STRING_RESET *
           right_padding_str *
           cell.suffix
end

function CustomTextCell.printable_cell_text(cell::AnsiTextCell)
    line = cell.line_breaks ? cell.content : replace(cell.content, '\n' => "\\n")
    return remove_decorations(line)
end

## Description #############################################################################
#
# Excel Back End: Test highlighters.
#
############################################################################################

@testset "Highlighters" verbose = true begin
    matrix = [
        1 2 3
        4 5 6
        7 8 9
    ]

    # == Three Constructor Types ===========================================================

    @testset "Three Constructor Types" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            row_group_labels = [3 => "Group 1"],
            highlighters = [
                ExcelHighlighter(
                    (data, i, j) -> (j == 1) && (data[i, j] > 3),
                    [
                        "color" => "red",
                        "bold" => "true",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "grey90",
                    ],
                ),
                ExcelHighlighter(
                    (data, i, j) -> (data[i, j] == 2),
                    ["color" => "green", "bold" => "true"],
                ),
                ExcelHighlighter(
                    (data, i, j) -> (j == 3) && (data[i, j] > 3),
                    ["color" => "blue", "bold" => "true"],
                ),
                ExcelHighlighter((data, i, j) -> (data[i, j] == 3), "color" => "red"),
            ],
        )

        @test XLSX.getFont(result[1], "B2").font["color"] == Dict("rgb" => "FF008000")
        @test XLSX.getFont(result[1], "C2").font["color"] == Dict("rgb" => "FFFF0000")
        @test XLSX.getFill(result[1], "A3").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFE5E5E5")
        @test XLSX.getFont(result[1], "C5").font["color"] == Dict("rgb" => "FF0000FF")
    end

    # == With Source Note Row ==============================================================

    @testset "With Source Note Row" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            row_group_labels = [3 => "Group 1"],
            source_notes = "This is a source note.",
            highlighters = [
                ExcelHighlighter(
                    (data, i, j) -> (j == 1) && (data[i, j] > 3),
                    [
                        "color" => "red",
                        "bold" => "true",
                        "cell_fill_pattern" => "solid",
                        "cell_fill_fgColor" => "grey90",
                    ],
                ),
                ExcelHighlighter(
                    (data, i, j) -> (data[i, j] == 2),
                    ["color" => "green", "bold" => "true", "size" => "18"],
                ),
                ExcelHighlighter(
                    (data, i, j) -> (j == 3) && (data[i, j] > 3),
                    ["color" => "blue", "bold" => "true"],
                ),
                ExcelHighlighter((data, i, j) -> (data[i, j] == 3), "color" => "red"),
            ],
        )

        @test XLSX.getFont(result[1], "B2").font["color"] == Dict("rgb" => "FF008000")
        @test XLSX.getFont(result[1], "B2").font["sz"] == Dict("val" => "18")
        @test XLSX.getFont(result[1], "C2").font["color"] == Dict("rgb" => "FFFF0000")
        @test XLSX.getFill(result[1], "A3").fill["patternFill"] ==
            Dict("patternType" => "solid", "fgrgb" => "FFE5E5E5")
        @test XLSX.getFont(result[1], "C5").font["color"] == Dict("rgb" => "FF0000FF")
    end
end

@testset "Highlighters Take Precedence Over the Data Cell Style" begin
    # The highlighter decoration must be applied after the section style. Otherwise, the
    # font attributes of `data_cell` would overwrite the highlighter.
    result = pretty_table(
        XLSX.XLSXFile,
        [1 2; 3 4];
        highlighters = [
            ExcelHighlighter((data, i, j) -> data[i, j] > 2, ["color" => "red"]),
        ],
        style = ExcelTableStyle(; data_cell = ["italic" => "true"]),
    )

    font = XLSX.getFont(result[1], "A3").font

    @test font["color"] == Dict("rgb" => "FFFF0000")
    @test haskey(font, "i")
    @test haskey(XLSX.getFont(result[1], "A2").font, "i")
end

## Description #############################################################################
#
# Excel Back End: Test formats (table borders).
#
############################################################################################

@testset "ExcelTableFormat" verbose = true begin
    matrix = [
        1 2 3
        4 5 6
        7 8 9
    ]

    # == Default Formats ===================================================================

    @testset "Default Formats" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            title = "This is a title.",
            subtitle = "This is a subtitle.",
            stubhead_label = "This is a stubhead label.",
            show_row_number_column = true,
            row_number_column_label = "Row Number",
            row_labels = ["Row 1", "Row 2", "Row 3"],
            row_group_labels = [3 => "Group 1"],
            summary_row_labels = ["Total"],
            summary_rows = [(data, i) -> sum(data[:, i])],
            footnotes = [
                (:subtitle, 1, 1) => "Subtitle footnote"
                (:column_label, 1, 3) => "Third column footnote."
                (:data, 2, 2) => "Middle data footnote."
            ],
            source_notes = "This is a source note.",
        )

        r = result[1]

        f = XLSX.getBorder(r, "A1").border

        @test f["top"] === nothing
        @test f["left"] === nothing
        @test f["right"] === nothing
        @test f["bottom"] === nothing

        @test XLSX.getBorder(r, "A2").border["bottom"] === nothing
        @test XLSX.getBorder(r, "A3").border["top"] ==
            Dict("style" => "thick", "rgb" => "FF000000")
        @test XLSX.getBorder(r, "A3").border["bottom"] ==
            Dict("style" => "medium", "rgb" => "FF000000")

        f = XLSX.getBorder(r, "A4").border
        @test f["bottom"] === nothing
        @test f["right"] == Dict("rgb" => "FF000000", "style" => "thin")

        f = XLSX.getBorder(r, "B4").border
        @test f["bottom"] === nothing
        @test f["right"] == Dict("rgb" => "FF000000", "style" => "thin")

        f = XLSX.getBorder(r, "D4").border
        @test f["bottom"] === nothing
        @test f["right"] == Dict("rgb" => "FF000000", "style" => "thin")

        f = XLSX.getBorder(r, "A5").border
        @test f["bottom"] == Dict("rgb" => "FF000000", "style" => "thin")

        f = XLSX.getBorder(r, "A6").border
        @test f["top"] == Dict("style" => "thin", "rgb" => "FF000000")
        @test f["bottom"] == Dict("style" => "thin", "rgb" => "FF000000")

        @test XLSX.getBorder(r, "A7").border["bottom"] ==
            Dict("style" => "thin", "rgb" => "FF000000")
        @test XLSX.getBorder(r, "A8").border["bottom"] ==
            Dict("style" => "thick", "rgb" => "FF000000")
        @test XLSX.getBorder(r, "A9").border["bottom"] === nothing
        @test XLSX.getBorder(r, "A10").border["bottom"] === nothing
        @test XLSX.getBorder(r, "A11").border["bottom"] === nothing
    end

    # == No Vertical Lines with Row Group Borders =============================================

    @testset "No Vertical Lines with Row Group Borders" verbose = true begin
        result = pretty_table(
            XLSX.XLSXFile,
            matrix;
            title = "This is a title.",
            subtitle = "This is a subtitle.",
            stubhead_label = "This is a stubhead label.",
            show_row_number_column = true,
            row_number_column_label = "Row Number",
            row_labels = ["Row 1", "Row 2", "Row 3"],
            row_group_labels = [3 => "Group 1"],
            summary_row_labels = ["Total"],
            summary_rows = [(data, i) -> sum(data[:, i])],
            footnotes = [
                (:subtitle, 1, 1) => "Subtitle footnote"
                (:column_label, 1, 3) => "Third column footnote."
                (:data, 2, 2) => "Middle data footnote."
            ],
            source_notes = "This is a source note.",
            table_format = ExcelTableFormat(;
                horizontal_line_before_row_group_label = true,
                horizontal_line_after_row_group_label = true,
                vertical_line_after_row_number_column = false,
                vertical_line_after_row_label_column = false,
                vertical_lines_at_data_columns = :none,
                borders = ExcelTableBorders(;
                    header_line = ["style" => "double", "color" => "red"]
                ),
            ),
        )

        r = result[1]

        f = XLSX.getBorder(r, "A1").border
        f["top"] == Dict("style" => "thick", "rgb" => "FF000000")
        f["left"] == Dict("style" => "thick", "rgb" => "FF000000")
        f["right"] == Dict("style" => "thick", "rgb" => "FF000000")
        f["bottom"] === nothing

        @test XLSX.getBorder(r, "A2").border["bottom"] === nothing
        @test XLSX.getBorder(r, "A3").border["top"] ==
            Dict("style" => "thick", "rgb" => "FF000000")
        @test XLSX.getBorder(r, "A3").border["bottom"] ==
            Dict("rgb" => "FFFF0000", "style" => "double")

        f = XLSX.getBorder(r, "A4").border
        @test f["bottom"] === nothing
        @test f["right"] === nothing

        f = XLSX.getBorder(r, "B4").border
        @test f["bottom"] === nothing
        @test f["right"] === nothing

        f = XLSX.getBorder(r, "D4").border
        @test f["bottom"] === nothing
        @test f["right"] === nothing

        f = XLSX.getBorder(r, "A5").border
        @test f["bottom"] == Dict("rgb" => "FF000000", "style" => "thin")

        f = XLSX.getBorder(r, "A6").border
        @test f["top"] == Dict("rgb" => "FF000000", "style" => "thin")
        @test f["bottom"] == Dict("rgb" => "FF000000", "style" => "thin")

        @test XLSX.getBorder(r, "D6").border["top"] ==
            Dict("style" => "thin", "rgb" => "FF000000")
        @test XLSX.getBorder(r, "A7").border["bottom"] ==
            Dict("rgb" => "FF000000", "style" => "thin")
        @test XLSX.getBorder(r, "A8").border["bottom"] ==
            Dict("style" => "thick", "rgb" => "FF000000")
        @test XLSX.getBorder(r, "A9").border["bottom"] === nothing
        @test XLSX.getBorder(r, "A10").border["bottom"] === nothing
        @test XLSX.getBorder(r, "A11").border["bottom"] === nothing
    end

    # == Horizontal Lines at Data Rows ========================================================

    @testset "Horizontal Lines at Data Rows" verbose = true begin
        @testset "Vector of Rows" verbose = true begin
            result = pretty_table(
                XLSX.XLSXFile,
                [1 2 3; 4 5 6; 7 8 9; 10 11 12];
                table_format = ExcelTableFormat(; horizontal_lines_at_data_rows = [1, 3]),
            )

            r = result[1]

            @test XLSX.getBorder(r, "A1").border["top"] ==
                Dict("style" => "thick", "rgb" => "FF000000")
            @test XLSX.getBorder(r, "A1").border["bottom"] ==
                Dict("style" => "medium", "rgb" => "FF000000")
            @test XLSX.getBorder(r, "A2").border["bottom"] ==
                Dict("style" => "thin", "rgb" => "FF000000")
            @test XLSX.getBorder(r, "A3").border["bottom"] === nothing
            @test XLSX.getBorder(r, "A4").border["bottom"] ==
                Dict("style" => "thin", "rgb" => "FF000000")
            @test XLSX.getBorder(r, "A5").border["bottom"] ==
                Dict("style" => "thick", "rgb" => "FF000000")
        end

        @testset "None" verbose = true begin
            result = pretty_table(
                XLSX.XLSXFile,
                [1 2 3; 4 5 6; 7 8 9];
                table_format = ExcelTableFormat(; horizontal_lines_at_data_rows = :none),
            )

            r = result[1]

            @test XLSX.getBorder(r, "A2").border["bottom"] === nothing
            @test XLSX.getBorder(r, "A3").border["bottom"] === nothing
            @test XLSX.getBorder(r, "A4").border["bottom"] ==
                Dict("style" => "thick", "rgb" => "FF000000")
        end
    end

    # == Vertical Lines at Data Columns ====================================================

    @testset "Vertical Lines at Data Columns" verbose = true begin
        @testset "Vector of Columns" verbose = true begin
            result = pretty_table(
                XLSX.XLSXFile,
                [1 2 3 4; 5 6 7 8];
                table_format = ExcelTableFormat(; vertical_lines_at_data_columns = [1, 3]),
            )

            r = result[1]

            @test XLSX.getBorder(r, "A1").border["right"] ==
                Dict("style" => "thin", "rgb" => "FF000000")
            @test XLSX.getBorder(r, "B1").border["right"] === nothing
            @test XLSX.getBorder(r, "C1").border["right"] ==
                Dict("style" => "thin", "rgb" => "FF000000")
            @test XLSX.getBorder(r, "D1").border["right"] ==
                Dict("style" => "thick", "rgb" => "FF000000")
        end

        @testset "None" verbose = true begin
            result = pretty_table(
                XLSX.XLSXFile,
                [1 2 3; 4 5 6];
                table_format = ExcelTableFormat(; vertical_lines_at_data_columns = :none),
            )

            r = result[1]

            @test XLSX.getBorder(r, "A1").border["right"] === nothing
            @test XLSX.getBorder(r, "B1").border["right"] === nothing
        end
    end
end

## Description #############################################################################
#
# HTML Back End: Tests related with the cell alignment.
#
############################################################################################

@testset "Alignment" verbose = true begin
    matrix = [(i, j) for i in 1:5, j in 1:5]

    @testset "Alignment as a Symbol" verbose = true begin
        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: center;">Col. 1</th>
      <th style = "font-weight: bold; text-align: center;">Col. 2</th>
      <th style = "font-weight: bold; text-align: center;">Col. 3</th>
      <th style = "font-weight: bold; text-align: center;">Col. 4</th>
      <th style = "font-weight: bold; text-align: center;">Col. 5</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: center;">(1, 1)</td>
      <td style = "text-align: center;">(1, 2)</td>
      <td style = "text-align: center;">(1, 3)</td>
      <td style = "text-align: center;">(1, 4)</td>
      <td style = "text-align: center;">(1, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: center;">(2, 1)</td>
      <td style = "text-align: center;">(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td style = "text-align: center;">(2, 4)</td>
      <td style = "text-align: center;">(2, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: center;">(3, 1)</td>
      <td style = "text-align: center;">(3, 2)</td>
      <td style = "text-align: center;">(3, 3)</td>
      <td style = "text-align: center;">(3, 4)</td>
      <td style = "text-align: center;">(3, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: center;">(4, 1)</td>
      <td style = "text-align: center;">(4, 2)</td>
      <td style = "text-align: center;">(4, 3)</td>
      <td style = "text-align: center;">(4, 4)</td>
      <td style = "text-align: left;">(4, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: center;">(5, 1)</td>
      <td style = "text-align: center;">(5, 2)</td>
      <td style = "text-align: center;">(5, 3)</td>
      <td style = "text-align: center;">(5, 4)</td>
      <td style = "text-align: center;">(5, 5)</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            alignment = :c,
            backend = :html,
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
        )

        @test result == expected

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold;">Col. 1</th>
      <th style = "font-weight: bold;">Col. 2</th>
      <th style = "font-weight: bold;">Col. 3</th>
      <th style = "font-weight: bold;">Col. 4</th>
      <th style = "font-weight: bold;">Col. 5</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td>(1, 1)</td>
      <td>(1, 2)</td>
      <td>(1, 3)</td>
      <td>(1, 4)</td>
      <td>(1, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td>(2, 1)</td>
      <td>(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td>(2, 4)</td>
      <td>(2, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td>(3, 1)</td>
      <td>(3, 2)</td>
      <td>(3, 3)</td>
      <td>(3, 4)</td>
      <td>(3, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td>(4, 1)</td>
      <td>(4, 2)</td>
      <td>(4, 3)</td>
      <td>(4, 4)</td>
      <td style = "text-align: left;">(4, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td>(5, 1)</td>
      <td>(5, 2)</td>
      <td>(5, 3)</td>
      <td>(5, 4)</td>
      <td>(5, 5)</td>
    </tr>
  </tbody>
</table>
"""
        result = pretty_table(
            String,
            matrix;
            alignment = :n,
            backend = :html,
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
        )

        @test result == expected
    end

    @testset "Alignment as a Vector" verbose = true begin
        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: left;">Col. 1</th>
      <th style = "font-weight: bold; text-align: center;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th style = "font-weight: bold; text-align: left;">Col. 4</th>
      <th style = "font-weight: bold; text-align: center;">Col. 5</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: left;">(1, 1)</td>
      <td style = "text-align: center;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td style = "text-align: left;">(1, 4)</td>
      <td style = "text-align: center;">(1, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(2, 1)</td>
      <td style = "text-align: center;">(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td style = "text-align: left;">(2, 4)</td>
      <td style = "text-align: center;">(2, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(3, 1)</td>
      <td style = "text-align: center;">(3, 2)</td>
      <td style = "text-align: right;">(3, 3)</td>
      <td style = "text-align: left;">(3, 4)</td>
      <td style = "text-align: center;">(3, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(4, 1)</td>
      <td style = "text-align: center;">(4, 2)</td>
      <td style = "text-align: right;">(4, 3)</td>
      <td style = "text-align: left;">(4, 4)</td>
      <td style = "text-align: left;">(4, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(5, 1)</td>
      <td style = "text-align: center;">(5, 2)</td>
      <td style = "text-align: right;">(5, 3)</td>
      <td style = "text-align: left;">(5, 4)</td>
      <td style = "text-align: center;">(5, 5)</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            alignment = [:l, :c, :r, :l, :c],
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
        )

        @test result == expected

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: left;">Col. 1</th>
      <th style = "font-weight: bold; text-align: center;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th style = "font-weight: bold;">Col. 4</th>
      <th style = "font-weight: bold; text-align: right;">Col. 5</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: left;">(1, 1)</td>
      <td style = "text-align: center;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td>(1, 4)</td>
      <td style = "text-align: right;">(1, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(2, 1)</td>
      <td style = "text-align: center;">(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td>(2, 4)</td>
      <td style = "text-align: right;">(2, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(3, 1)</td>
      <td style = "text-align: center;">(3, 2)</td>
      <td style = "text-align: right;">(3, 3)</td>
      <td>(3, 4)</td>
      <td style = "text-align: right;">(3, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(4, 1)</td>
      <td style = "text-align: center;">(4, 2)</td>
      <td style = "text-align: right;">(4, 3)</td>
      <td>(4, 4)</td>
      <td style = "text-align: left;">(4, 5)</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: left;">(5, 1)</td>
      <td style = "text-align: center;">(5, 2)</td>
      <td style = "text-align: right;">(5, 3)</td>
      <td>(5, 4)</td>
      <td style = "text-align: right;">(5, 5)</td>
    </tr>
  </tbody>
</table>
"""
        result = pretty_table(
            String,
            matrix;
            backend = :html,
            alignment = [:l, :c, :r, :n, :X],
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# Types and structures for the text back end.
#
############################################################################################

export CustomTextCell, TextTableBorders, TextTableFormat, TextTableStyle, TextHighlighter

############################################################################################
#                                     Custom Text Cell                                     #
############################################################################################

include("./CustomTextCell/CustomTextCell.jl")
using .CustomTextCell
export AbstractCustomTextCell

include("./CustomTextCell/AnsiTextCell.jl")
include("./CustomTextCell/UrlTextCell.jl")

############################################################################################
#                                         Display                                          #
############################################################################################

"""
    struct Display

Store the information of the display and the current cursor position.

!!! note

    This is not the real cursor position with respect to the display, but with respect to
    the point in which the table is printed.

# Fields

- `size::Tuple{Int, Int}`: Display size.
- `row::Int`: Current row.
- `column::Int`: Current column.
- `has_color::Bool`: Indicates if the display has color support.
- `buf_line::IOBuffer`:  Buffer that stores the current line.
- `buf::IOBuffer`: Buffer that stores the entire output.
"""
@kwdef mutable struct Display
    size::NTuple{2, Int} = (-1, -1)
    row::Int             = 1
    column::Int          = 0
    has_color::Bool      = false

    # Buffer that stores the entire output.
    buf::IOBuffer = IOBuffer()
    # Buffer that stores the current line.
    buf_line::IOBuffer = IOBuffer()
end

############################################################################################
#                                       Table Format                                       #
############################################################################################

"""
    struct TextTableBorders

Define the format of the borders in the tables printed with the text back end.

# Fields

- `up_right_corner::Char`: Character in the up right corner.
- `up_left_corner::Char`: Character in the up left corner.
- `bottom_left_corner::Char`: Character in the bottom left corner.
- `bottom_right_corner::Char`: Character in the bottom right corner.
- `up_intersection::Char`: Character in the intersection of lines in the up part.
- `left_intersection::Char`: Character in the intersection of lines in the left part.
- `right_intersection::Char`: Character in the intersection of lines in the right part.
- `middle_intersection::Char`: Character in the intersection of lines in the middle of the
    table.
- `bottom_intersection::Char`: Character in the intersection of the lines in the bottom
    part.
- `column::Char`: Character in a vertical line inside the table.
- `row::Char`: Character in a horizontal line inside the table.
"""
@kwdef struct TextTableBorders
    up_right_corner::Char     = '┐'
    up_left_corner::Char      = '┌'
    bottom_left_corner::Char  = '└'
    bottom_right_corner::Char = '┘'
    up_intersection::Char     = '┬'
    left_intersection::Char   = '├'
    right_intersection::Char  = '┤'
    middle_intersection::Char = '┼'
    bottom_intersection::Char = '┴'
    column::Char              = '│'
    row::Char                 = '─'
end

# Create some default decorations to reduce allocations.
const _TEXT__BOLD                = crayon"bold"
const _TEXT__BOLD_UNDERLINE      = crayon"bold underline"
const _TEXT__CYAN                = crayon"fg:cyan"
const _TEXT__DARK_GRAY           = crayon"fg:dark_gray"
const _TEXT__DARK_GRAY_UNDERLINE = crayon"fg:dark_gray underline"
const _TEXT__DEFAULT             = crayon"default"
const _TEXT__EMPTY_CRAYON        = crayon""
const _TEXT__RESET               = crayon"reset"

# The reset escape sequence. We use the literal string instead of `string(_TEXT__RESET)`
# because Crayons may produce an empty string when colors are disabled at precompilation time.
const _TEXT__STRING_RESET = "\e[0m"

"""
    struct TextTableFormat

Define the format of the tables printed with the text back end.

# Fields

- `borders::TextTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_lines_at_column_labels::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each column label row index listed in this vector. If the symbol `:all` is
    passed, a horizontal line will be drawn after every column label. If the symbol `:none`
    is passed, no horizontal lines will be drawn.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn at the merged column labels. Notice that the horizontal line drawn using the
    option `horizontal_lines_at_column_labels` has precedence over this one.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data row. If the symbol `:none` is passed,
    no horizontal lines will be drawn.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data column. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.
- `suppress_vertical_lines_at_column_labels::Bool`: If `true`, the vertical lines inside
    the column label rows will be suppressed.
- `ellipsis_line_skip::Int`: Number of lines to skip when printing an ellipsis.
"""
@kwdef struct TextTableFormat
    # == Border and Lines ==================================================================

    borders::TextTableBorders = TextTableBorders()

    # == Configuration for the Horizontal and Vertical Lines ===============================

    horizontal_line_at_beginning::Bool = true
    horizontal_lines_at_column_labels::Union{Symbol, Vector{Int}} = :none
    horizontal_line_at_merged_column_labels::Bool = false
    horizontal_line_after_column_labels::Bool = true
    horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}} = :none
    horizontal_line_before_row_group_label::Bool = true
    horizontal_line_after_row_group_label::Bool = true
    horizontal_line_after_data_rows::Bool = true
    horizontal_line_before_summary_rows::Bool = true
    horizontal_line_after_summary_rows::Bool = true

    vertical_line_at_beginning::Bool = true
    vertical_line_after_row_number_column::Bool = true
    vertical_line_after_row_label_column::Bool = true
    vertical_lines_at_data_columns::Union{Symbol, Vector{Int}} = :all
    vertical_line_after_data_columns::Bool = true
    vertical_line_after_continuation_column::Bool = true

    suppress_vertical_lines_at_column_labels::Bool = false

    # == Other Configurations ==============================================================

    ellipsis_line_skip::Int = 0
end

"""
    struct TextTableStyle

Define the style of the tables printed with the text back end.

# Fields

- `title::Crayon`: Crayon with the style for the title.
- `subtitle::Crayon`: Crayon with the style for the subtitle.
- `row_number_label::Crayon`: Crayon with the style for the row number label.
- `row_number::Crayon`: Crayon with the style for the row numbers.
- `stubhead_label::Crayon`:  Crayon with the style for the stubhead label.
- `row_label::Crayon`: Crayon with the style for the row labels.
- `row_group_label::Crayon`: Crayon with the style for the row group label.
- `first_line_column_label::Union{Crayon, Vector{Crayon}}`: Crayon or crayons with the style
    for the first column label lines. If a vector of crayons is passed, it must have the
    same length as the number of columns in the table.
- `column_label::Union{Crayon, Vector{Crayon}}`: Crayon or crayons with the style for the
    rest of the column labels. If a vector of crayons is passed, it must have the same
    length as the number of columns in the table.
- `first_line_merged_column_label::Crayon`: Crayon with the style for the merged cells at
    the first column label line.
- `merged_column_label::Crayon`: Crayon with the style for the merged cells at the rest of
    the column labels.
- `summary_row_cell::Crayon`: Crayon with the style for the summary row cell.
- `summary_row_label::Crayon`: Crayon with the style for the summary row label.
- `footnote::Crayon`: Crayon with the style for the footnotes.
- `source_note::Crayon`: Crayon with the style for the source notes.
- `omitted_cell_summary::Crayon`: Crayon with the style for the omitted cell summary.
- `table_border::Crayon`: Crayon with the style for the table border.
"""
@kwdef struct TextTableStyle{
    TFCL <: Union{Crayon, Vector{Crayon}}, TCL <: Union{Crayon, Vector{Crayon}}
}
    title::Crayon                          = _TEXT__BOLD
    subtitle::Crayon                       = _TEXT__DEFAULT
    row_number_label::Crayon               = _TEXT__BOLD
    row_number::Crayon                     = _TEXT__DEFAULT
    stubhead_label::Crayon                 = _TEXT__BOLD
    row_label::Crayon                      = _TEXT__BOLD
    row_group_label::Crayon                = _TEXT__BOLD
    first_line_column_label::TFCL          = _TEXT__BOLD
    column_label::TCL                      = _TEXT__DARK_GRAY
    first_line_merged_column_label::Crayon = _TEXT__BOLD_UNDERLINE
    merged_column_label::Crayon            = _TEXT__DARK_GRAY_UNDERLINE
    summary_row_cell::Crayon               = _TEXT__DEFAULT
    summary_row_label::Crayon              = _TEXT__BOLD
    footnote::Crayon                       = _TEXT__DEFAULT
    source_note::Crayon                    = _TEXT__DARK_GRAY
    omitted_cell_summary::Crayon           = _TEXT__CYAN
    table_border::Crayon                   = _TEXT__DEFAULT
end

############################################################################################
#                                     TextHighlighter                                      #
############################################################################################

"""
    struct TextHighlighter

Defines the default highlighter of a table when using the text backend.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `fd(h, data, i, j)` in which `h` is the
    highlighter. This function must return the `Crayon` to be applied to the cell that must
    be highlighted.
- `_decoration::Crayon`: The `Crayon` to be applied to the highlighted cell if the default
    `fd` is used.

# Remarks

This structure can be constructed using three helpers:

```julia
TextHighlighter(f::Function; kwargs...)
```

where it will construct a `Crayon` using the keywords in `kwargs` and apply it to the
highlighted cell,

```julia
TextHighlighter(f::Function, crayon::Crayon)
```

where it will apply the `crayon` to the highlighted cell, and

```julia
TextHighlighter(f::Function, fd::Function)
```

where it will apply the `Crayon` returned by the function `fd` to the highlighted cell.
"""
struct TextHighlighter
    f::Function
    fd::Function

    # == Private Fields ====================================================================

    _decoration::Crayon

    # == Constructors ======================================================================

    function TextHighlighter(f::Function, fd::Function)
        return new(f, fd, _TEXT__DEFAULT)
    end

    function TextHighlighter(f::Function, decoration::Crayon)
        return new(f, _text__default_highlighter_fd, decoration)
    end

    function TextHighlighter(f::Function; kwargs...)
        return new(f, _text__default_highlighter_fd, Crayon(; kwargs...))
    end
end

_text__default_highlighter_fd(h::TextHighlighter, ::Any, ::Int, ::Int) = h._decoration

## Description #############################################################################
#
# Functions related to the printing state iterations.
#
############################################################################################

"""
    _next(state::PrintingTableState, table_data::TableData) -> Tuple{Symbol, Symbol, PrintingTableState}

Return the action the back end must perform, the current table row section, and the new
print table state, given the current `state` and the `table_data`.
"""
function _next(state::PrintingTableState, table_data::TableData)
    ps = state.state
    rs = state.row_section

    i     = state.i
    j     = state.j
    max_i = table_data.num_rows
    max_j = table_data.num_columns

    # == Table Header ======================================================================

    if ps < _TITLE
        isempty(table_data.title) &&
            return _next(PrintingTableState(_TITLE, 0, 0, rs), table_data)

        if j == 0
            return :new_row, :table_header, PrintingTableState(ps, 1, j + 1, rs)
        elseif j == 1
            return :title, :table_header, PrintingTableState(ps, 1, j + 1, rs)
        else
            return :end_row, :table_header, PrintingTableState(_TITLE, 0, 0, rs)
        end
    end

    if ps < _SUBTITLE
        isempty(table_data.subtitle) &&
            return _next(PrintingTableState(_SUBTITLE, 0, 0, :column_labels), table_data)

        if j == 0
            return :new_row, :table_header, PrintingTableState(ps, 1, j + 1, rs)
        elseif j == 1
            return :subtitle, :table_header, PrintingTableState(ps, 1, j + 1, rs)
        else
            return :end_row,
            :table_header,
            PrintingTableState(_SUBTITLE, 0, 0, :column_labels)
        end
    end

    # == Column Labels and Table Body ======================================================

    if ps < _NEW_ROW
        new_i = i + 1

        # If we do not have any column, jump to the table footer. Notice that this check must
        # come before the `show_column_labels` shortcut below. Otherwise, the shortcut would
        # already have moved the row section away from `:column_labels`, and a table without
        # columns would be rendered with empty rows.
        (max_j == 0) && return _next(
            PrintingTableState(_FOOTNOTES - 1, 0, 0, :table_footer), table_data
        )

        # If we started the column labels but the user does not want to show them, skip to
        # the first section that has rows.
        if (rs == :column_labels) && !table_data.show_column_labels
            # If the maximum number of rows is 0, we must go to the continuation row. Notice
            # that this rule also exists in the `:end_row` branch of the column labels, which
            # this shortcut jumps over.
            mr = table_data.maximum_number_of_rows

            next_row_section = if (mr == 0) && (max_i > 0)
                :continuation_row
            elseif max_i > 0
                :data
            elseif !isnothing(table_data.summary_rows)
                :summary_row
            else
                :table_footer
            end

            next_printing_state = if next_row_section == :table_footer
                _END_ROW
            else
                _NEW_ROW - 1
            end

            return _next(
                PrintingTableState(next_printing_state, 0, 0, next_row_section), table_data
            )
        end

        # Check if we are starting a row group label.
        if (rs == :data) && !isnothing(table_data.row_group_labels)
            for g in table_data.row_group_labels
                g.first == new_i && return :new_row,
                :row_group_label,
                PrintingTableState(_NEW_ROW, new_i, 0, :row_group_label)
            end
        end

        return :new_row, rs, PrintingTableState(_NEW_ROW, new_i, 0, rs)
    end

    if ps < _ROW_GROUP && (rs == :row_group_label)
        return :row_group_label, rs, PrintingTableState(_END_ROW_AFTER_GROUP - 1, i, 0, rs)
    end

    if ps < _ROW_NUMBER_COLUMN && table_data.show_row_number_column
        action = if rs == :column_labels
            :row_number_label
        elseif rs == :data
            :row_number
        elseif rs == :continuation_row
            :row_number_vertical_continuation_cell
        else
            :summary_row_number
        end

        return action, rs, PrintingTableState(_ROW_NUMBER_COLUMN, i, 0, rs)
    end

    if (ps < _ROW_LABEL_COLUMN) &&
        (!isnothing(table_data.row_labels) || !isnothing(table_data.summary_row_labels))
        action = if rs == :column_labels
            :stubhead_label
        elseif rs == :data
            :row_label
        elseif rs == :continuation_row
            :row_label_vertical_continuation_cell
        else
            :summary_row_label
        end

        return action, rs, PrintingTableState(_ROW_LABEL_COLUMN, i, 0, rs)
    end

    if ps < _DATA
        mc = table_data.maximum_number_of_columns

        # Check if we reached the maximum number of columns or the end of line.
        if ((mc > 0) && (j >= mc)) || (j >= max_j)
            return _next(PrintingTableState(_DATA, i, j, rs), table_data)
        end

        action = if rs == :column_labels
            :column_label
        elseif rs == :data
            :data
        elseif rs == :continuation_row
            :vertical_continuation_cell
        else
            :summary_row_cell
        end

        return action, rs, PrintingTableState(ps, i, j + 1, rs)
    end

    if ps < _CONTINUATION_COLUMN
        # Check if a continuation cell is necessary.
        if j >= max_j
            return _next(PrintingTableState(_CONTINUATION_COLUMN, i, 0, rs), table_data)
        else
            action =
                rs == :continuation_row ? :diagonal_continuation_cell :
                :horizontal_continuation_cell

            return action, rs, PrintingTableState(_CONTINUATION_COLUMN, i, 0, rs)
        end
    end

    if ps < _END_ROW
        if rs == :column_labels
            num_column_labels = length(table_data.column_labels)

            if i >= num_column_labels
                # If the maximum number of row is 0, we must go to the continuation row.
                mr = table_data.maximum_number_of_rows

                ((mr == 0) && (max_i > 0)) && return :end_row,
                rs,
                PrintingTableState(_NEW_ROW - 1, i, 0, :continuation_row)

                # If we have no data rows, we can go to the summary rows.
                if (table_data.num_rows == 0) && !isnothing(table_data.summary_rows)
                    return :end_row,
                    rs,
                    PrintingTableState(_NEW_ROW - 1, 0, 0, :summary_row)
                end

                # If we have no data or summary rows, we can go to the table footer.
                (max_i == 0) &&
                    return :end_row, rs, PrintingTableState(_END_ROW, 0, 0, :table_footer)

                # If we reached the number of column labels, we must go to the data.
                return :end_row, rs, PrintingTableState(_NEW_ROW - 1, 0, 0, :data)
            else
                # Otherwise, print the next line with column labels.
                return :end_row, rs, PrintingTableState(_NEW_ROW - 1, i, 0, rs)
            end

        elseif rs == :data
            mr = table_data.maximum_number_of_rows

            cont_row = if (mr > 0) && (mr < max_i)
                if table_data.vertical_crop_mode == :bottom
                    i >= mr
                else
                    i == div(mr, 2, RoundUp)
                end
            else
                false
            end

            if cont_row
                # The user limited the number of rows and we printed the requested number.
                return :end_row,
                rs,
                PrintingTableState(_NEW_ROW - 1, i, 0, :continuation_row)

            elseif i >= max_i
                # If we reached the number of data lines, we must go to the summary row if
                # the user wants it.
                if !isnothing(table_data.summary_rows)
                    return :end_row,
                    rs,
                    PrintingTableState(_NEW_ROW - 1, 0, 0, :summary_row)
                else
                    return :end_row, rs, PrintingTableState(_END_ROW, 0, 0, :table_footer)
                end
            else
                # Otherwise, print the next data line.
                return :end_row, rs, PrintingTableState(_NEW_ROW - 1, i, 0, rs)
            end

        elseif rs == :continuation_row
            # Treat the case where we must perform a middle cropping.
            if table_data.vertical_crop_mode == :middle
                mr = table_data.maximum_number_of_rows
                next_i = max_i - (mr - div(mr, 2, RoundUp)) + 1

                # Check if we have more rows to be printed.
                next_i <= max_i && return :end_row,
                rs,
                PrintingTableState(_NEW_ROW - 1, next_i - 1, 0, :data)

                # If there is no more rows to be printed, we can treat as we are in a bottom
                # cropping.
            end

            # After the continuation row, we must check if we need to print the summary
            # cell.
            if !isnothing(table_data.summary_rows)
                return :end_row, rs, PrintingTableState(_NEW_ROW - 1, 0, 0, :summary_row)
            else
                return :end_row, rs, PrintingTableState(_END_ROW, 0, 0, :table_footer)
            end

        else
            i >= length(table_data.summary_rows) &&
                return :end_row, rs, PrintingTableState(_END_ROW, 0, 0, :table_footer)

            return :end_row, rs, PrintingTableState(_NEW_ROW - 1, i, 0, rs)
        end
    end

    # ==  Table Footer =====================================================================

    if ps < _FOOTNOTES && !isnothing(table_data.footnotes)
        if j == 0
            i >= length(table_data.footnotes) &&
                return _next(PrintingTableState(_FOOTNOTES, 0, 0, rs), table_data)

            return :new_row, :table_footer, PrintingTableState(ps, i + 1, j + 1, rs)
        elseif j == 1
            return :footnote, :table_footer, PrintingTableState(ps, i, j + 1, rs)
        else
            return :end_row, :table_footer, PrintingTableState(ps, i, 0, rs)
        end
    end

    if ps < _SOURCENOTES && !isempty(table_data.source_notes)
        if j == 0
            return :new_row, :table_footer, PrintingTableState(ps, i + 1, j + 1, rs)
        elseif j == 1
            return :source_notes, :table_footer, PrintingTableState(ps, i, j + 1, rs)
        else
            return :end_row,
            :table_footer,
            PrintingTableState(_SOURCENOTES, i, 0, :end_printing)
        end
    end

    # == End Printing ======================================================================

    ps < _END_PRINTING &&
        return :end_printing, rs, PrintingTableState(_END_PRINTING - 1, 0, 0, :end_printing)

    # == Row Groups ========================================================================

    # We must have special states for new and end line actions after row groups since they
    # will provide different row numbering increase and state compared to the default ones.
    ps < _END_ROW_AFTER_GROUP &&
        return :end_row, rs, PrintingTableState(_END_ROW_AFTER_GROUP, i, 0, rs)

    # After the row group label, we must change the row section to `:data`. Notice that
    # there is no possibility to have a row group label outside the data rows.
    ps < _NEW_ROW_AFTER_GROUP &&
        return :new_row, :data, PrintingTableState(_ROW_GROUP, i, 0, :data)

    # We must never reach this point.
    return :internal_error, rs, state
end

function _update_data_cell_indices(
    action::Symbol, row_section::Symbol, state::PrintingTableState, i::Int, j::Int
)
    if (action == :new_row) && (row_section ∉ (:table_header, :continuation_row))
        i += 1
        j = 0

    elseif (
        action ∈ (
            :row_number_vertical_continuation_cell,
            :row_label_vertical_continuation_cell,
            :row_label,
            :row_number,
        )
    )
        j = 0

    elseif action == :row_group_label
        i -= 1

    elseif (action == :column_label) ||
        (action == :data) ||
        (action == :summary_row_cell) ||
        (action == :vertical_continuation_cell)
        j += 1

    elseif (action == :end_row) && (row_section != state.row_section)
        if (
            (row_section != :continuation_row) && (state.row_section != :continuation_row)
        ) || (state.row_section == :summary_row)
            i = j = 0
        elseif state.row_section == :continuation_row
            j = 0
        end
    end

    return i, j
end

## Description #############################################################################
#
# Documentation for the Markdown backend.
#
############################################################################################

"""
# PrettyTables.jl Markdown Backend

The markdown backend can be selected by passing the keyword `backend = :markdown` to the
function [`pretty_table`](@ref). In this case, we have the following additional keywords to
configure the output.

# Keywords

- `allow_markdown_in_cells::Bool`: If `true`, the content of the cells can contain markdown
    code.
    (**Default**: `false`)
- `highlighters::Vector{MarkdownHighlighter}`: Highlighters to apply to the table. For more
    information, see the section **Markdown Highlighters** in the **Extended Help**.
- `line_breaks::Bool`: If `true`, line breaks in the content of the cells (`\\n`) are
    replaced by `<br>`.
    (**Default**: `false`)
- `style::MarkdownTableStyle`: Style of the table. For more information, see the section
    **Markdown Table Style** in the **Extended Help**.
- `table_format::MarkdownTableFormat`: Markdown table format used to render the table. For
    more information, see the section **Markdown Table Format** in the **Extended Help**.

# Extended Help

## Markdown Highlighters

A set of highlighters can be passed as a `Vector{MarkdownHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`MarkdownHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `fd(h, data, i, j)` in which `h` is the
    highlighter. This function must return the [`MarkdownStyle`](@ref) to be applied to the
cell that must be highlighted.

The function `f` has the following signature:

```julia
f(data, i, j)
```

in which `data` is a reference to the data that is being printed, and `i` and `j` are the
element coordinates that are being tested. If this function returns `true`, the highlight
style will be applied to the `(i, j)` element. Otherwise, the default style will be used.

If the function `f` returns true, the function `fd(h, data, i, j)` will be called and must
return an element of type [`MarkdownStyle`](@ref) that contains the decoration to be
applied to the cell.

A markdown highlighter can be constructed using two helpers:

```julia
MarkdownHighlighter(f::Function, decoration::MarkdownStyle)

MarkdownHighlighter(f::Function, fd::Function)
```

The first will apply a fixed decoration to the highlighted cell specified in `decoration`,
whereas the second lets the user select the desired decoration by specifying the function
`fd`.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

## Markdown Table Format

The markdown table format is defined using an object of type [`MarkdownTableFormat`](@ref)
that contains the following fields:

- `title_heading_level::Int`: Title heading level.
- `subtitle_heading_level::Int`: Subtitle heading level.
- `horizontal_line_char::Char`: Character used to draw the horizontal line.
- `line_before_summary_rows::Bool`: Whether to draw a line before the summary rows.
- `compact_table::Bool`: If `true`, the table is printed in a compact format without extra
    spaces between columns.

## Markdown Table Style

The markdown table style is defined using an object of type [`MarkdownTableStyle`](@ref)
that contains the following fields:

- `row_number_label::MarkdownStyle`: Style for the row number label.
- `row_number::MarkdownStyle`: Style for the row number.
- `stubhead_label::MarkdownStyle`: Style for the stubhead label.
- `row_label::MarkdownStyle`: Style for the row label.
- `row_group_label::MarkdownStyle`: Style for the row group label.
- `first_line_column_label::Union{MarkdownStyle, Vector{MarkdownStyle}}`: Style for the
    first line of the column label. If a vector of `MarkdownStyle` is provided, each column
    label in the first line will use the corresponding style.
- `column_label::Union{MarkdownStyle, Vector{MarkdownStyle}}`: Style for the column label.
    If a vector of `MarkdownStyle` is provided, each column label will use the corresponding
    style.
- `summary_row_label::MarkdownStyle`: Style for the summary row label.
- `summary_row_cell::MarkdownStyle`: Style for the summary row cell.
- `footnote::MarkdownStyle`: Style for the footnote.
- `source_note::MarkdownStyle`: Style for the source note.
- `omitted_cell_summary::MarkdownStyle`: Style for the omitted cell summary.

Each field is an instance of the structure [`MarkdownStyle`](@ref) describing the style to
be applied to the corresponding element.

For example, if we want the stubhead label to be bold and italic, we must define:

```julia
style = MarkdownTableStyle(
    stubhead_label = MarkdownStyle(bold = true, italic = true)
)
```
"""
pretty_table_markdown_backend

## Description #############################################################################
#
# HTML Back End: Test renderers.
#
############################################################################################

@testset "Renderers" verbose = true begin
    matrix = ['a' :a "a" missing nothing]

    @testset ":print" begin
        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th style = "font-weight: bold; text-align: right;">Col. 4</th>
      <th style = "font-weight: bold; text-align: right;">Col. 5</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">missing</td>
      <td style = "text-align: right;">nothing</td>
    </tr>
  </tbody>
</table>
"""
        result = pretty_table(String, matrix; backend = :html)

        @test result == expected
    end

    @testset ":show" begin
        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th style = "font-weight: bold; text-align: right;">Col. 4</th>
      <th style = "font-weight: bold; text-align: right;">Col. 5</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">&apos;a&apos;</td>
      <td style = "text-align: right;">:a</td>
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">missing</td>
      <td style = "text-align: right;">nothing</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html, renderer = :show)

        @test result == expected
    end
end

## Description #############################################################################
#
# Tests related to the internal functions that return the cell alignment.
#
############################################################################################

@testset "Cell Alignment" verbose = true begin
    @testset "Default" begin
        # == Create the Table Data =========================================================

        td = PrettyTables.TableData(;
            data                        = rand(6, 4),
            title                       = "Table Title",
            subtitle                    = "Table Subtitle",
            column_labels               = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
            stubhead_label              = "Stubhead Label",
            show_row_number_column      = true,
            row_number_column_label     = "Row Number",
            row_labels                  = ["Row 1", "Row 2", "Row 3"],
            row_group_labels            = [2 => "Row Group"],
            summary_rows                = [(data, i) -> i, (data, i) -> 2i],
            footnotes                   = [(:data, 1, 1) => "Footnote", (:data, 2, 2) => "Footnote"],
            source_notes                = "Source Notes",
            title_alignment             = :r,
            subtitle_alignment          = :l,
            cell_alignment              = [(data, i, j) -> (i == 2 && j == 3) ? :c : nothing],
            data_alignment              = [:l, :c, :r, :l],
            column_label_alignment      = [:r, :r, :l, :c],
            row_label_column_alignment  = :r,
            row_group_label_alignment   = :r,
            row_number_column_alignment = :c,
            footnote_alignment          = :c,
            source_note_alignment       = :r,
            num_rows                    = 6,
            num_columns                 = 4,
            first_row_index             = 1,
            first_column_index          = 1,
            maximum_number_of_rows      = 3,
            vertical_crop_mode          = :bottom,
        )

        # == Iterate the Printing Table State ==============================================

        ps = PrettyTables.PrintingTableState()

        # -- Table Header ------------------------------------------------------------------

        # .. Table Title ...................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :r

        action, rs, ps = PrettyTables._next(ps, td)

        # .. Table Subtitle ................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :l

        action, rs, ps = PrettyTables._next(ps, td)

        # -- Column Labels -----------------------------------------------------------------

        for _ in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Table Data --------------------------------------------------------------------

        for i in 1:3
            if i == 2
                action, rs, ps = PrettyTables._next(ps, td)

                action, rs, ps = PrettyTables._next(ps, td)
                alignment = PrettyTables._current_cell_alignment(action, ps, td)
                @test alignment == :r

                action, rs, ps = PrettyTables._next(ps, td)
            end

            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == ((i != 2) ? :r : :c)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Continuation Row --------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :r

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :l

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :r

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :l

        action, rs, ps = PrettyTables._next(ps, td)

        # -- Table Summary -----------------------------------------------------------------

        for _ in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Footnotes ---------------------------------------------------------------------

        for _ in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Source Notes ------------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :r

        action, rs, ps = PrettyTables._next(ps, td)
    end

    @testset "Continuation Row Override" begin
        # == Create the Table Data =========================================================

        td = PrettyTables.TableData(;
            data                        = rand(6, 4),
            title                       = "Table Title",
            subtitle                    = "Table Subtitle",
            column_labels               = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
            stubhead_label              = "Stubhead Label",
            show_row_number_column      = true,
            row_number_column_label     = "Row Number",
            row_labels                  = ["Row 1", "Row 2", "Row 3"],
            summary_rows                = [(data, i) -> i, (data, i) -> 2i],
            summary_row_labels          = ["Summary 1", "Summary 2"],
            footnotes                   = [(:data, 1, 1) => "Footnote", (:data, 2, 2) => "Footnote"],
            source_notes                = "Source Notes",
            title_alignment             = :r,
            subtitle_alignment          = :l,
            cell_alignment              = [(data, i, j) -> (i == 2 && j == 3) ? :c : nothing],
            data_alignment              = [:l, :c, :r, :l],
            column_label_alignment      = [:r, :r, :l, :c],
            continuation_row_alignment  = :c,
            row_label_column_alignment  = :r,
            row_number_column_alignment = :c,
            footnote_alignment          = :c,
            source_note_alignment       = :r,
            num_rows                    = 6,
            num_columns                 = 4,
            first_row_index             = 1,
            first_column_index          = 1,
            maximum_number_of_rows      = 3,
            vertical_crop_mode          = :bottom,
        )

        # == Iterate the Printing Table State ==============================================

        ps = PrettyTables.PrintingTableState()

        # -- Table Header ------------------------------------------------------------------

        # .. Table Title ...................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :r

        action, rs, ps = PrettyTables._next(ps, td)

        # .. Table Subtitle ................................................................

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :l

        action, rs, ps = PrettyTables._next(ps, td)

        # -- Column Labels -----------------------------------------------------------------

        for _ in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Table Data --------------------------------------------------------------------

        for i in 1:3
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == ((i != 2) ? :r : :c)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Continuation Row --------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :c

        action, rs, ps = PrettyTables._next(ps, td)

        # -- Table Summary -----------------------------------------------------------------

        for _ in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :r

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :l

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Footnotes ---------------------------------------------------------------------

        for _ in 1:2
            action, rs, ps = PrettyTables._next(ps, td)

            action, rs, ps = PrettyTables._next(ps, td)
            alignment = PrettyTables._current_cell_alignment(action, ps, td)
            @test alignment == :c

            action, rs, ps = PrettyTables._next(ps, td)
        end

        # -- Source Notes ------------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)

        action, rs, ps = PrettyTables._next(ps, td)
        alignment = PrettyTables._current_cell_alignment(action, ps, td)
        @test alignment == :r

        action, rs, ps = PrettyTables._next(ps, td)
    end
end

## Description #############################################################################
#
# Private functions for the HTML back end.
#
############################################################################################

# == Strings ===============================================================================

raw"""
    _html__escape_str(@nospecialize(io::IO), s::AbstractString, replace_newline::Bool = false, escape_html_chars::Bool = true) -> Nothing
    _html__escape_str(s::AbstractString, replace_newline::Bool = false, escape_html_chars::Bool = true) -> String

Print the string `s` in `io` escaping the characters for the HTML back end. If `io` is
omitted, the escaped string is returned.

If `replace_newline` is `true`, `\n` is replaced with `<br>`. Otherwise, it is escaped when
`escape_html_chars` is `true`, leading to `\\n`, and kept unchanged otherwise.

If `escape_html_chars` is `true`, `&`, `<`, `>`, `"`, and `'` will be replaced by HTML
sequences.
"""
function _html__escape_str(
    io::IO, s::AbstractString, replace_newline::Bool = false, escape_html_chars::Bool = true
)
    a = Iterators.Stateful(s)
    for c in a
        if Base.isascii(c)
            # When `escape_html_chars` is `false`, the user asked for the cell content to be
            # emitted as raw HTML. Hence, we must keep the line breaks. Otherwise, we would
            # corrupt the HTML code with a literal `\n`.
            c == '\n'         ? (
                replace_newline ? print(io, "<br>") :
                escape_html_chars ? print(io, "\\n") : print(io, c)
            ) :
            c == '&'          ? (escape_html_chars ? print(io, "&amp;") : print(io, c))  :
            c == '<'          ? (escape_html_chars ? print(io, "&lt;") : print(io, c))   :
            c == '>'          ? (escape_html_chars ? print(io, "&gt;") : print(io, c))   :
            c == '"'          ? (escape_html_chars ? print(io, "&quot;") : print(io, c)) :
            c == '\''         ? (escape_html_chars ? print(io, "&apos;") : print(io, c)) :
            c == '\0'         ? print(io, Base.escape_nul(peek(a)))                      :
            c == '\e'         ? print(io, "\\e")                                         :
            # When `escape_html_chars` is `false`, the user asked for the cell content to be
            # emitted as raw HTML. Escaping the backslash would corrupt any inline CSS or
            # JavaScript in it.
            c == '\\'         ? (escape_html_chars ? print(io, "\\\\") : print(io, c))     :
            '\a' <= c <= '\r' ? print(io, '\\', "abtnvfr"[Int(c) - 6])                   :
            isprint(c)        ? print(io, c)                                             :
            print(io, "\\x", string(UInt32(c); base = 16, pad = 2))
        elseif !Base.isoverlong(c) && !Base.ismalformed(c)
            isprint(c)    ? print(io, c) :
            c <= '\x7f'   ? print(io, "\\x", string(UInt32(c); base = 16, pad = 2)) :
            c <= '\uffff' ? print(io, "\\u", string(UInt32(c); base = 16, pad = Base.need_full_hex(peek(a)) ? 4 : 2)) :
            print(io, "\\U", string(UInt32(c); base = 16, pad = Base.need_full_hex(peek(a)) ? 8 : 4))
        else # malformed or overlong
            u = bswap(reinterpret(UInt32, c))
            while true
                print(io, "\\x", string(u % UInt8; base = 16, pad = 2))
                (u >>= 8) == 0 && break
            end
        end
    end
end

function _html__escape_str(
    s::AbstractString, replace_newline::Bool = false, escape_html_chars::Bool = true
)
    return sprint(
        _html__escape_str, s, replace_newline, escape_html_chars; sizehint = lastindex(s)
    )
end

# == Styles ================================================================================

const _HTML__ALIGNMENT_MAP = Dict(
    :l => "left", :L => "left", :c => "center", :C => "center", :r => "right", :R => "right"
)

"""
    _html__add_alignment_to_style!(style::Vector{HtmlPair}, alignment::Symbol) -> Nothing

Add the HTML alignment property to `style` according to the `alignment` symbol.
"""
function _html__add_alignment_to_style!(style::Vector{HtmlPair}, alignment::Symbol)
    if (alignment == :n) || (alignment == :N)
        return nothing
    elseif haskey(_HTML__ALIGNMENT_MAP, alignment)
        return push!(style, "text-align" => _HTML__ALIGNMENT_MAP[alignment])
    else
        return push!(style, "text-align" => _HTML__ALIGNMENT_MAP[:r])
    end
end

"""
    _html__write_style(buf::IO, style::Union{Nothing, Vector{HtmlPair}}) -> Nothing

Write the HTML style attribute to `buf` using the information in the vector `style`.

Notice that this function writes directly to `buf` instead of building intermediate strings.
Otherwise, we would allocate multiple strings per printed cell.
"""
function _html__write_style(buf::IO, style::Vector{HtmlPair})
    # If there are no keys in the style vector, we have nothing to do.
    isempty(style) && return nothing

    # Make sure the style is sorted by key.
    sort!(style)

    # Every value can be empty, in which case there is no style to emit. Hence, we must
    # check it before writing the attribute opening.
    first_pair = true

    # NOTE: The separator is *prepended* to every entry but the first. Appending it and
    # skipping the last index left a trailing space whenever the last pair had an empty
    # value, as in `["a" => "1", "z" => ""]`.
    @inbounds for (key, value) in style
        # If the value is empty, then just continue.
        isempty(value) && continue

        if first_pair
            print(buf, " style = \"")
        else
            print(buf, ' ')
        end

        print(buf, key)
        print(buf, ": ")
        print(buf, value)
        print(buf, ';')

        first_pair = false
    end

    !first_pair && print(buf, '"')

    return nothing
end

_html__write_style(::IO, ::Nothing) = nothing

"""
    _html__create_style(style::Union{Nothing, Vector{HtmlPair}}) -> String

Create the HTML style string using the information in the vector `style`.
"""
function _html__create_style(style::Vector{HtmlPair})
    buf = IOBuffer()
    _html__write_style(buf, style)
    return String(take!(buf))
end

_html__create_style(::Nothing) = ""

# == Tags ==================================================================================

"""
    _html__open_tag(tag::String; kwargs...) -> String

Create the string that opens the HTML `tag`.

# Keywords

- `properties::Union{Nothing, Vector{HtmlPair}}`: Tag properties.
    (**Default**: `nothing`)
- `style::Union{Nothing, Vector{HtmlPair}}`: Tag style.
    (**Default**: `nothing`)
"""
function _html__open_tag(
    tag::String;
    properties::Union{Nothing, Vector{HtmlPair}} = nothing,
    style::Union{Nothing, Vector{HtmlPair}} = nothing,
)
    buf = IOBuffer()
    _html__write_open_tag(buf, tag, properties, style)
    return String(take!(buf))
end

"""
    _html__write_open_tag(buf::IO, tag::String, properties::Union{Nothing, Vector{HtmlPair}}, style::Union{Nothing, Vector{HtmlPair}}) -> Nothing

Write the string that opens the HTML `tag` to `buf`.

Notice that this function writes directly to `buf` instead of building intermediate strings.
Otherwise, we would allocate multiple strings per printed cell.
"""
function _html__write_open_tag(
    buf::IO,
    tag::String,
    properties::Union{Nothing, Vector{HtmlPair}},
    style::Union{Nothing, Vector{HtmlPair}},
)
    print(buf, '<')
    print(buf, tag)

    if !isnothing(properties)
        # Make sure the properties are sorted by key.
        sort!(properties)

        for (k, v) in properties
            if !isempty(v)
                print(buf, ' ')
                print(buf, k)
                print(buf, " = \"")
                _html__escape_str(buf, v)
                print(buf, '"')
            end
        end
    end

    _html__write_style(buf, style)

    print(buf, '>')

    return nothing
end

"""
    _html__close_tag(tag::String) -> String

Create the string that closes the HTML `tag`.
"""
_html__close_tag(tag::String) = "</$tag>"

"""
    _html__create_tag(tag::String, content::String; kwargs...) -> String

Create an HTML `tag` with the `content`.

# Keywords

- `properties::Union{Nothing, Vector{HtmlPair}}`: Tag properties.
    (**Default**: `nothing`)
- `style::Union{Nothing, Vector{HtmlPair}}`: Tag style.
    (**Default**: `nothing`)
"""
function _html__create_tag(
    tag::String,
    content::String;
    properties::Union{Nothing, Vector{HtmlPair}} = nothing,
    style::Union{Nothing, Vector{HtmlPair}} = nothing,
)
    buf = IOBuffer(; sizehint = 32 + ncodeunits(tag) * 2 + ncodeunits(content))
    _html__write_open_tag(buf, tag, properties, style)
    print(buf, content)
    print(buf, "</")
    print(buf, tag)
    print(buf, '>')
    return String(take!(buf))
end

# == Top Bar ===============================================================================

"""
    _html__print_top_bar_section(buf::IOContext, position::String, text::String, decoration::Union{Nothing, Vector{HtmlPair}}, il::Int, ns::Int; kwargs...)

Print the HTML top bar section.

# Arguments

- `buf::IOContext`: Buffer to which the top bar will be printed.
- `position::String`: Buffer position. It can be "left" or "right".
- `text::String`: Text to be printed in the selected position.
- `decoration::Union{Nothing, Vector{HtmlPair}}`: Text decoration.
- `il::Int`: Indentation level.
- `ns::Int`: Number of space per indentation level.

# Keywords

- `minify::Bool`: If `true`, the output will be minified.
    (**Default**: `false`)
"""
function _html__print_top_bar_section(
    buf::IOContext,
    position::String,
    text::String,
    decoration::Union{Nothing, Vector{HtmlPair}},
    il::Int,
    ns::Int;
    minify::Bool = false,
)
    style = isnothing(decoration) ? HtmlPair[] : copy(decoration)
    push!(style, "float" => position)

    _aprintln(buf, _html__open_tag("div"; style), il, ns; minify)
    il += 1

    _aprintln(buf, _html__create_tag("span", _html__escape_str(text)), il, ns; minify)

    il -= 1
    return _aprintln(buf, _html__close_tag("div"), il, ns; minify)
end

## Description #############################################################################
#
# Test errors and exceptions.
#
############################################################################################

@testset "Alignment Vector Length" begin
    data = [1 2 3 4]
    @test_throws ArgumentError pretty_table(data; alignment = [:c])
    @test_throws ArgumentError pretty_table(data; alignment = [:c, :c, :c])
    @test_throws ArgumentError pretty_table(data; alignment = [:c, :c, :c, :c, :c])
end

@testset "Merge Cell Specifications" begin
    data = [1 2 3 4]
    merge_column_label_cells = [MergeCells(1, 1, 2, :c), MergeCells(1, 2, 2, :c)]
    @test_throws ArgumentError pretty_table(data; merge_column_label_cells)

    # Both indices are 1-based, meaning 0 must be rejected by the validator instead of
    # blowing up later inside a back end with a `BoundsError`.
    @test_throws ArgumentError pretty_table(
        data; merge_column_label_cells = [MergeCells(1, 0, 2, "X")]
    )

    @test_throws ArgumentError pretty_table(
        data; merge_column_label_cells = [MergeCells(0, 1, 2, "X")]
    )
end

@testset "Renderer Selection" begin
    data = [1 2 3 4]
    @test_throws ArgumentError pretty_table(data; renderer = :something)
end

@testset "Summary Row and Summary Row Label Lengths" begin
    data = [
        1 2 3
        4 5 6
    ]

    @test_throws ArgumentError pretty_table(
        data, summary_rows = [(data, i) -> i], summary_row_labels = ["First", "Second"]
    )

    # The error message used to interpolate the `length` *function* instead of calling it.
    msg = try
        pretty_table(
            String,
            data;
            summary_rows = [sum],
            summary_row_labels = ["a", "b"],
        )
        ""
    catch e
        sprint(showerror, e)
    end

    @test occursin("`summary_rows` (1)", msg)
    @test occursin("`summary_row_labels` (2)", msg)
    @test !occursin("length(summary_rows)", msg)
end

@testset "Column Label Style Vector Length" begin
    # When `first_line_column_label` or `column_label` is given as a vector, it must hold
    # exactly one style per column. Only the `first_line_column_label` check was covered.
    data = [1 2 3]

    @test_throws ArgumentError pretty_table(
        String, data; style = TextTableStyle(; column_label = [crayon"bold"])
    )

    @test_throws ArgumentError pretty_table(
        String, data; style = TextTableStyle(; first_line_column_label = [crayon"bold"])
    )

    @test_throws ArgumentError pretty_table(
        String, data; backend = :latex, style = LatexTableStyle(; column_label = [["textbf"]])
    )

    @test_throws ArgumentError pretty_table(
        String,
        data;
        backend = :html,
        style = HtmlTableStyle(; column_label = [["color" => "red"]]),
    )

    @test_throws ArgumentError pretty_table(
        String,
        data;
        backend = :markdown,
        style = MarkdownTableStyle(; column_label = [MarkdownStyle(; bold = true)]),
    )
end

## Description #############################################################################
#
# Text Back End: Test related with offset arrays.
#
############################################################################################

@testset "Offset Arrays" begin
    matrix = Matrix{Any}(undef, 3, 3)
    matrix[1, 1] = (1, 1)
    matrix[1, 2] = (1, 2)
    matrix[2, 1] = nothing
    matrix[2, 2] = missing
    matrix[3, 3] = (3, 3)

    omatrix = OffsetArray(matrix, -2:0, -3:-1)

    expected = """
┌─────┬─────────┬─────────┬─────────┐
│ Row │ Col. -3 │ Col. -2 │ Col. -1 │
├─────┼─────────┼─────────┼─────────┤
│  -2 │  (1, 1) │  (1, 2) │  #undef │
│  -1 │ nothing │ missing │  #undef │
│   0 │  #undef │  #undef │  (3, 3) │
└─────┴─────────┴─────────┴─────────┘
"""

    result = pretty_table(String, omatrix; show_row_number_column = true)

    @test result == expected
end

@testset "Summary Rows With Offset Columns" begin
    # The summary row path used the raw 1-based print index instead of offsetting it by
    # `first_column_index`. Hence, the summaries of the first columns were silently computed
    # from the wrong source column before the last one threw a `BoundsError`.
    data = OffsetArray([1 2 3; 4 5 6; 7 8 9], -1:1, 0:2)

    expected = """
┌─────┬────────┬────────┬────────┐
│     │ Col. 0 │ Col. 1 │ Col. 2 │
├─────┼────────┼────────┼────────┤
│     │      1 │      2 │      3 │
│     │      4 │      5 │      6 │
│     │      7 │      8 │      9 │
├─────┼────────┼────────┼────────┤
│ Sum │     12 │     15 │     18 │
└─────┴────────┴────────┴────────┘
"""

    result = pretty_table(String, data; summary_rows = [sum], summary_row_labels = ["Sum"])

    @test result == expected
end

@testset "Row Number Column Width With Offset Rows" begin
    # The row number column width was computed from the row *count* instead of from the
    # actual row indices, so a non 1-based row axis overflowed the column and broke the
    # borders.
    data = OffsetArray(reshape(collect(1:6), 2, 3), -1000:-999, 1:3)

    expected = """
┌───────┬────────┬────────┬────────┐
│   Row │ Col. 1 │ Col. 2 │ Col. 3 │
├───────┼────────┼────────┼────────┤
│ -1000 │      1 │      3 │      5 │
│  -999 │      2 │      4 │      6 │
└───────┴────────┴────────┴────────┘
"""

    result = pretty_table(String, data; show_row_number_column = true)

    @test result == expected
end

## Description #############################################################################
#
# Functions to render the table cells in the Excel back end.
#
############################################################################################

# Renderers supported by the Excel back end. Notice that every `_excel__render_cell` method
# must annotate its renderer argument with this exact type so that the dispatch is decided
# solely by the cell type. Otherwise, we would introduce method ambiguities.
const _EXCEL__RENDERER = Union{Val{:print}, Val{:show}}

"""
    _excel__render_cell(
        cell::Any,
        context::RenderContext,
        renderer::Union{Val{:print}, Val{:show}}
    ) -> Union{
        Missing,
        Bool,
        Int64,
        Float64,
        Dates.Date,
        Dates.DateTime,
        Dates.Time,
        AbstractString,
        XLSX.CellValue
    }

Render the `cell` in the Excel back end. If the cell type is supported natively by Excel, we
return a value that Excel can store as such, that is, a value of type `Missing`, `Bool`,
`Int64`, `Float64`, `Dates.Date`, `Dates.DateTime`, `Dates.Time`, `AbstractString`, or
`XLSX.CellValue`. Integers and floating point numbers of any width are converted to `Int64`
and `Float64`, respectively, so that they remain numeric values in the spreadsheet.
Otherwise, we convert the cell to a `String` using the `renderer` and the IO `context`.
"""
function _excel__render_cell(
    cell::Union{
        Missing,
        XLSX.Dates.Date,
        XLSX.Dates.DateTime,
        XLSX.Dates.Time,
        AbstractString,
        XLSX.CellValue,
    },
    ::RenderContext,
    ::_EXCEL__RENDERER,
)
    return cell
end

function _excel__render_cell(cell::Bool, ::RenderContext, ::_EXCEL__RENDERER)
    return cell
end

# Any integer or floating point number must be widened to the types Excel supports natively.
# Otherwise, for example, an `Int32` would be written as text, losing the right alignment and
# becoming unusable in formulas. Notice that this is critical on 32-bit platforms, where
# `Int === Int32`.
function _excel__render_cell(cell::Integer, ::RenderContext, ::_EXCEL__RENDERER)
    return Int64(cell)
end

function _excel__render_cell(cell::AbstractFloat, ::RenderContext, ::_EXCEL__RENDERER)
    return Float64(cell)
end

# `nothing` must lead to a blank cell, exactly like `missing`.
function _excel__render_cell(::Nothing, ::RenderContext, ::_EXCEL__RENDERER)
    return missing
end

function _excel__render_cell(
    cell::MergeCells,
    context::RenderContext,
    renderer::_EXCEL__RENDERER,
)
    return _excel__render_cell(cell.data, context, renderer)
end

function _excel__render_cell(cell::Any, context::RenderContext, renderer::_EXCEL__RENDERER)
    return _excel__cell_to_str(cell, context, renderer)
end

"""
    _excel__cell_to_str(
        cell::Any,
        context::RenderContext,
        renderer::Union{Val{:print}, Val{:show}}
    ) -> String

Convert `cell` to a `String` using `renderer` and the IO `context`. Notice that this function
must not be called directly; use [`_excel__render_cell`](@ref) instead.
"""
function _excel__cell_to_str(cell::Any, context::RenderContext, ::Val{:print})
    return _sprint_with_context(print, context, cell)
end

function _excel__cell_to_str(cell::Any, context::RenderContext, ::Val{:show})
    return _sprint_with_context(show, context, MIME("text/plain"), cell)
end

## Description #############################################################################
#
# Functions to define interfaces with Tables.jl.
#
# This file contains some overloads related to the structures `ColumnTable` and `RowTable`
# so that an element can be accessed by `table[i,j]`. This is required for the low-level
# interface of PrettyTables.jl when printing.
#
############################################################################################

import Base: getindex, isassigned, length, size

############################################################################################
#                             Functions Related to ColumnTable                             #
############################################################################################

Base.@nospecializeinfer function ColumnTable(@nospecialize(data::Any))
    # Access the table using the columns.
    table = Tables.columns(data)

    # Get the column names.
    names = collect(Symbol, Tables.columnnames(table))

    # Compute the table size and get the column types.
    size_j = length(names)::Int
    size_i = Tables.rowcount(table)::Int

    return ColumnTable(data, table, names, (size_i, size_j))
end

function getindex(ctable::ColumnTable, i, j)
    # Get the column name.
    column_name = ctable.column_names[j]

    # Get the element.
    element = Tables.getcolumn(ctable.table, column_name)[i]

    return element
end

function getindex(ctable::ColumnTable, inds...)
    if length(inds) != 2
        error("An element of type `ColumnTable` must be accessed using 2 indices.")
    end

    return getindex(ctable, inds[1], inds[2])
end

function isassigned(ctable::ColumnTable, i, j)
    # Get the column name.
    column_name = ctable.column_names[j]

    # Get the column.
    col = Tables.getcolumn(ctable.table, column_name)

    # If the column is a `Tuple`, then all the elements must be defined.
    if col isa Tuple
        return true
    else
        return isassigned(col, i)
    end
end

function isassigned(ctable::ColumnTable, inds...)
    if length(inds) != 2
        error("An element of type `ColumnTable` must be accessed using 2 indices.")
    end

    return isassigned(ctable, inds[1], inds[2])
end

axes(ctable::ColumnTable) = (Base.OneTo(ctable.size[1]), Base.OneTo(ctable.size[2]))

function axes(ctable::ColumnTable, dim::Int)
    dim == 1 && return Base.OneTo(ctable.size[1])
    return Base.OneTo(ctable.size[2])
end

length(ctable::ColumnTable) = ctable.size[1] * ctable.size[2]

size(ctable::ColumnTable) = ctable.size

# A whole-column query must be answered by the wrapper itself. Otherwise, it would be
# forwarded to the user's object, which usually does not support `[:, j]` indexing. This is
# the access pattern the summary rows use to obtain the column they must reduce.
Base.maybeview(ctable::ColumnTable, ::Colon, j::Integer) =
    Tables.getcolumn(ctable.table, ctable.column_names[j])

Base.maybeview(ctable::ColumnTable, inds...) = Base.maybeview(ctable.data, inds...)

_get_data(ctable::ColumnTable) = ctable.data

############################################################################################
#                              Functions Related to RowTable                               #
############################################################################################

Base.@nospecializeinfer function RowTable(@nospecialize(data::Any))
    # Access the table using the rows.
    table = Tables.rows(data)

    # Compute the number of rows.
    size_i = length(table)::Int

    # If we have at least one row, we can obtain the number of columns by fetching the row.
    # Otherwise, we try to use the schema.
    if size_i > 0
        row₁ = first(table)

        # Get the column names.
        names = collect(Symbol, Tables.columnnames(row₁))
    else
        sch = Tables.schema(data)

        if sch === nothing
            # In this case, we do not have a row and we do not have a schema.  Thus, we can
            # do nothing. Hence, we assume there is no row or column.
            names = Symbol[]
        else
            names = [sch.names...]
        end
    end

    size_j = length(names)::Int

    return RowTable(data, table, names, (size_i, size_j), RowTableAccessState())
end

"""
    _row_table_subset(rtable::RowTable, i::Integer) -> Tuple{Bool, Any}

Acquire and cache the subset row for row `i`, including acquisition failures.
"""
function _row_table_subset(rtable::RowTable, i::Integer)
    access_state = rtable.access_state

    # If this table does not implement `Tables.subset` at all, never try again. Otherwise,
    # we would pay for a thrown and caught exception once per row because the cache below is
    # row-local.
    access_state.subset_supported || return false, nothing

    # Reset the row-local subset cache for a new requested row.
    if access_state.requested_row != i
        access_state.requested_row = i
        access_state.subset_attempted = false
        access_state.subset_succeeded = false
        access_state.subset_row = nothing
    end

    # Return a previously cached subset acquisition result.
    access_state.subset_attempted &&
        return access_state.subset_succeeded, access_state.subset_row

    # Mark the attempt before invoking user-provided table code.
    access_state.subset_attempted = true
    try
        access_state.subset_row = Tables.subset(rtable.data, i; viewhint = true)

        # Record a successful subset acquisition.
        access_state.subset_succeeded = true
    catch
        # Record a failed subset acquisition and never attempt it again for this table.
        access_state.subset_row = nothing
        access_state.subset_succeeded = false
        access_state.subset_supported = false
    end

    # Return the cached subset acquisition status and row.
    return access_state.subset_succeeded, access_state.subset_row
end

"""
    _row_table_iterator_row(rtable::RowTable, i::Integer) -> Any

Acquire row `i` from the iterator, advancing forward or restarting for backward requests.
"""
function _row_table_iterator_row(rtable::RowTable, i::Integer)
    access_state = rtable.access_state

    if !access_state.iterator_started || i < access_state.iterator_row_index
        step = iterate(rtable.table)
        step === nothing && error("The row `i` does not exist.")

        access_state.iterator_row, access_state.iterator_state = step
        access_state.iterator_row_index = 1
        access_state.iterator_started = true
    end

    while access_state.iterator_row_index < i
        step = iterate(rtable.table, access_state.iterator_state)
        step === nothing && error("The row `i` does not exist.")

        access_state.iterator_row, access_state.iterator_state = step
        access_state.iterator_row_index += 1
    end

    return access_state.iterator_row
end

function getindex(rtable::RowTable, i, j)
    column_name = rtable.column_names[j]
    access_state = rtable.access_state
    subset_succeeded, subset_row = _row_table_subset(rtable, i)

    if subset_succeeded && access_state.subset_getcolumn_supported
        try
            return Tables.getcolumn(subset_row, column_name)
        catch e
            # A real undefined cell is not a capability failure of the subset path. Hence,
            # we must rethrow it so the caller can convert it into an undefined cell marker
            # instead of permanently downgrading every access to the iterator path.
            e isa UndefRefError && rethrow()

            # Preserve the broad subset-to-iterator fallback semantics. As above, latch the
            # capability so that the failure is paid for only once.
            access_state.subset_getcolumn_supported = false
        end
    end

    row = _row_table_iterator_row(rtable, i)
    return Tables.getcolumn(row, column_name)
end

function getindex(rtable::RowTable, inds...)
    if length(inds) != 2
        error("An element of type `RowTable` must be accessed using 2 indices.")
    end

    return getindex(rtable, inds[1], inds[2])
end

function isassigned(rtable::RowTable, i, j)
    try
        getindex(rtable, i, j)
        return true
    catch e
        if isa(e, UndefRefError)
            return false
        else
            throw(e)
        end
    end
end

function isassigned(rtable::RowTable, inds...)
    if length(inds) != 2
        error("An element of type `RowTable` must be accessed using 2 indices.")
    end

    return isassigned(rtable, inds[1], inds[2])
end

axes(rtable::RowTable) = (Base.OneTo(rtable.size[1]), Base.OneTo(rtable.size[2]))

function axes(rtable::RowTable, dim::Int)
    dim == 1 && return Base.OneTo(rtable.size[1])
    return Base.OneTo(rtable.size[2])
end

length(rtable::RowTable) = rtable.size[1] * rtable.size[2]

size(rtable::RowTable) = rtable.size

# A whole-column query must be answered by the wrapper itself. Otherwise, it would be
# forwarded to the user's object, which usually does not support `[:, j]` indexing. Since a
# row table has no columns, we must materialize one. Notice that the rows are walked
# forward, meaning this is `O(num_rows)`, and that it is only paid once per summary row per
# column.
Base.maybeview(rtable::RowTable, ::Colon, j::Integer) =
    [rtable[i, j] for i in 1:rtable.size[1]]

Base.maybeview(rtable::RowTable, inds...) = Base.maybeview(rtable.data, inds...)

_get_data(rtable::RowTable) = rtable.data

############################################################################################
#                                     Other Overloads                                      #
############################################################################################

# `_get_data` is a function that returns the original matrix passed to `pretty_table`
# function. This is required because when printing something compliant with Tables.jl, we
# modify its type to be `ColumnTable` or `RowTable`. In this case, functions like
# highlighters must receive the original data, not the transformed one.
_get_data(data) = data

## Description #############################################################################
#
# HTML Back End: Test with default options.
#
############################################################################################

@testset "Default Options" begin
    matrix = [
        1 1.0 0x01 'a' "abc" missing
        2 2.0 0x02 'b' "def" nothing
        3 3.0 0x03 'c' "ghi" :symbol
    ]

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th style = "font-weight: bold; text-align: right;">Col. 4</th>
      <th style = "font-weight: bold; text-align: right;">Col. 5</th>
      <th style = "font-weight: bold; text-align: right;">Col. 6</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">abc</td>
      <td style = "text-align: right;">missing</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">2</td>
      <td style = "text-align: right;">2.0</td>
      <td style = "text-align: right;">2</td>
      <td style = "text-align: right;">b</td>
      <td style = "text-align: right;">def</td>
      <td style = "text-align: right;">nothing</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">3.0</td>
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">c</td>
      <td style = "text-align: right;">ghi</td>
      <td style = "text-align: right;">symbol</td>
    </tr>
  </tbody>
</table>
"""

    result = pretty_table(String, matrix; backend = :html)
    @test result == expected

    result = pretty_table(String, matrix; table_format = HtmlTableFormat())
    @test result == expected

    result = pretty_table_html_backend(String, matrix)
    @test result == expected

    result = pretty_table(HTML, matrix)
    @test typeof(result) == HTML{String}
    @test result.content == expected

    result = pretty_table(HTML, matrix; backend = :html)
    @test typeof(result) == HTML{String}
    @test result.content == expected
end

module PrettyTablesTypstryExt

using PrettyTables

using Markdown
using Typstry

function PrettyTables.pretty_table(::Type{Typst}, @nospecialize(data::Any); kwargs...)
    # If the keywords do not set the back end or the table format, use the Typst back end
    # by default.
    str = if !haskey(kwargs, :backend)
        pretty_table(String, data; backend = :typst, kwargs...)
    else
        pretty_table(String, data; kwargs...)
    end

    return Typst(TypstText(str))
end

# Render cells with Typst commands.
function PrettyTables._typst__render_cell(
    cell::TypstString,
    context::PrettyTables.RenderContext,
    renderer::Union{Val{:print}, Val{:show}},
)
    return sprint(show, MIME("text/typst"), cell)
end

# A `TypstString` cell must be treated as a raw Typst component.
PrettyTables._typst__is_raw_typst_cell(::TypstString) = true

# Try to render the table as an image if the current display supports it. This function
# returns whether the table was displayed. Notice that it is called by
# `PrettyTables._typst__display` through `Base.get_extension`.
function _typst__display(output_str::String)
    displayable(MIME("image/png")) || return false

    try
        display(MIME("image/png"), Typst(TypstText(output_str)))
        return true
    catch
        return false
    end
end

end

## Description #############################################################################
#
# HTML Back End: Tests related to special cells.
#
############################################################################################

@testset "Special Cells" verbose = true begin
    @testset "HTML Code Espaping" begin
        matrix = ["<BR>", "<p>Test<p>", "<p>&vellip;</p>"]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">&lt;BR&gt;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">&lt;p&gt;Test&lt;p&gt;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">&lt;p&gt;&amp;vellip;&lt;/p&gt;</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html)

        @test result == expected

        result = pretty_table(String, matrix; backend = :html, renderer = :show)

        @test result == expected
    end

    @testset "HTML Cells" begin
        matrix = ["<BR>", "<p>Test<p>", html"<p>&vellip;</p>"]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">&lt;BR&gt;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">&lt;p&gt;Test&lt;p&gt;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;"><p>&vellip;</p></td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html)

        @test result == expected

        result = pretty_table(String, matrix; backend = :html, renderer = :show)

        @test result == expected
    end

    @testset "Allow HTML in Cells" begin
        matrix = ["<BR>", "<p>Test<p>", "<p>&vellip;</p>"]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;"><BR></td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;"><p>Test<p></td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;"><p>&vellip;</p></td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html, allow_html_in_cells = true)

        @test result == expected

        result = pretty_table(
            String, matrix; backend = :html, allow_html_in_cells = true, renderer = :show
        )

        @test result == expected
    end

    @testset "Allow HTML in Cells With Line Breaks" begin
        # The line breaks must be kept in raw HTML cells. Otherwise, we would corrupt the
        # HTML code with a literal `\\n`.
        matrix = ["<div>\na\n</div>";;]

        result = pretty_table(String, matrix; backend = :html, allow_html_in_cells = true)

        @test !occursin("\\n", result)
        @test occursin("<div>", result)
    end

    @testset "Line Breaks" begin
        matrix = ["First Line\nSecond Line" "Third Line\nFourth Line"]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">First Line\\nSecond Line</td>
      <td style = "text-align: right;">Third Line\\nFourth Line</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html)

        @test result == expected

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">First Line<br>Second Line</td>
      <td style = "text-align: right;">Third Line<br>Fourth Line</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html, line_breaks = true)

        @test result == expected
    end

    @testset "Undefined Cells" begin
        v    = Vector{Any}(undef, 5)
        v[1] = undef
        v[2] = "String"
        v[5] = π

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">UndefInitializer()</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">String</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">#undef</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">#undef</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">π</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, v; backend = :html)

        @test result == expected

        result = pretty_table(String, v; backend = :html, renderer = :show)

        @test result == expected
    end

    @testset "Markdown" begin
        matrix = [md"**Bold**" md"*Italic*" md"_**Bold and Italic**_"]

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;"><div class="markdown"><p><strong>Bold</strong></p></div></td>
      <td style = "text-align: right;"><div class="markdown"><p><em>Italic</em></p></div></td>
      <td style = "text-align: right;"><div class="markdown"><p><em><strong>Bold and Italic</strong></em></p></div></td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(String, matrix; backend = :html)
        @test result == expected

        result = pretty_table(String, matrix; backend = :html, renderer = :show)
        @test result == expected
    end
end

## Description #############################################################################
#
# LaTeX Back End: Test highlighters.
#
############################################################################################

@testset "Highlighters" begin
    matrix = [
        1 2 3
        4 5 6
    ]

    # NOTE: The even cells match both the 1st and the 2nd highlighters. Since the applied
    # style must be the one of the **first** match, they are decorated with `textbf` only.
    expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  \\textit{\\textbf{1}} & \\textbf{2} & \\textit{\\textbf{3}} \\\\
  \\textbf{4} & \\textit{\\textbf{5}} & \\textbf{6} \\\\
  \\hline
\\end{tabular}
"""

    result = pretty_table(
        String,
        matrix;
        backend = :latex,
        color = true,
        highlighters = [
            LatexHighlighter(
                (data, i, j) -> data[i, j] % 2 == 0, (_, _, _, _) -> ["textbf"]
            )
            LatexHighlighter((data, i, j) -> data[i, j] % 2 == 0, ["textit"])
            LatexHighlighter((data, i, j) -> data[i, j] % 2 != 0, ["textbf", "textit"])
        ],
    )

    @test result == expected

    @testset "First Match Wins" begin
        # The applied style must be the one of the **first** matching highlighter.
        h1 = LatexHighlighter((d, i, j) -> true, ["textbf"])
        h2 = LatexHighlighter((d, i, j) -> true, ["small"])

        result = pretty_table(String, [1]; backend = :latex, highlighters = [h1, h2])

        @test occursin("\\textbf{1}", result)
        @test !occursin("\\small", result)
    end

    @testset "Highlighter Receives the Original Data" begin
        # The highlighter callbacks must see the object the user passed to `pretty_table`,
        # not the internal table wrapper, so that they are portable across back ends.
        data = (a = [1, 2],)
        seen = []

        h = LatexHighlighter((d, i, j) -> (push!(seen, typeof(d)); false), ["textbf"])

        pretty_table(String, data; backend = :latex, highlighters = [h])

        @test !isempty(seen)
        @test all(==(typeof(data)), seen)
    end
end

## Description #############################################################################
#
# LaTeX Back End: Tests related with the cell alignment.
#
############################################################################################

@testset "Alignment" verbose = true begin
    matrix = [(i, j) for i in 1:5, j in 1:5]

    @testset "Alignment as a Symbol" verbose = true begin
        expected = """
\\begin{tabular}{|c|c|c|c|c|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & (1, 4) & (1, 5) \\\\
  (2, 1) & (2, 2) & \\multicolumn{1}{r|}{(2, 3)} & (2, 4) & (2, 5) \\\\
  (3, 1) & (3, 2) & (3, 3) & (3, 4) & (3, 5) \\\\
  (4, 1) & (4, 2) & (4, 3) & (4, 4) & \\multicolumn{1}{l|}{(4, 5)} \\\\
  (5, 1) & (5, 2) & (5, 3) & (5, 4) & (5, 5) \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            alignment = :c,
            backend = :latex,
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
        )

        @test result == expected

        expected = """
\\begin{tabular}{|c|cc|c|c}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & (1, 4) & (1, 5) \\\\
  (2, 1) & (2, 2) & \\multicolumn{1}{r|}{(2, 3)} & (2, 4) & (2, 5) \\\\
  (3, 1) & (3, 2) & (3, 3) & (3, 4) & (3, 5) \\\\
  (4, 1) & (4, 2) & (4, 3) & (4, 4) & \\multicolumn{1}{l}{(4, 5)} \\\\
  (5, 1) & (5, 2) & (5, 3) & (5, 4) & (5, 5) \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            alignment = :c,
            backend = :latex,
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
            table_format = LatexTableFormat(;
                vertical_lines_at_data_columns = [1, 3, 4],
                vertical_line_after_data_columns = false,
            ),
        )

        @test result == expected
    end

    @testset "Alignment as a Vector" verbose = true begin
        expected = """
\\begin{tabular}{|l|c|r|l|c|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & (1, 4) & (1, 5) \\\\
  (2, 1) & (2, 2) & (2, 3) & (2, 4) & (2, 5) \\\\
  (3, 1) & (3, 2) & (3, 3) & (3, 4) & (3, 5) \\\\
  (4, 1) & (4, 2) & (4, 3) & (4, 4) & \\multicolumn{1}{l|}{(4, 5)} \\\\
  (5, 1) & (5, 2) & (5, 3) & (5, 4) & (5, 5) \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            alignment = [:l, :c, :r, :l, :c],
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
        )

        @test result == expected

        expected = """
\\begin{tabular}{|l|cr|l|c}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} \\\\
  \\hline
  (1, 1) & (1, 2) & (1, 3) & (1, 4) & (1, 5) \\\\
  (2, 1) & (2, 2) & (2, 3) & (2, 4) & (2, 5) \\\\
  (3, 1) & (3, 2) & (3, 3) & (3, 4) & (3, 5) \\\\
  (4, 1) & (4, 2) & (4, 3) & (4, 4) & \\multicolumn{1}{l}{(4, 5)} \\\\
  (5, 1) & (5, 2) & (5, 3) & (5, 4) & (5, 5) \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            alignment = [:l, :c, :r, :l, :c],
            cell_alignment = [(2, 3) => :r, (4, 5) => :l],
            table_format = LatexTableFormat(;
                vertical_lines_at_data_columns = [1, 3, 4],
                vertical_line_after_data_columns = false,
            ),
        )

        @test result == expected
    end

    @testset "Uppercase Alignment Symbols" begin
        # The uppercase alignment symbols must be normalized to a valid LaTeX column
        # descriptor. We also check here that a merged column label at the table beginning
        # keeps the vertical line at its left.
        expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\multicolumn{2}{@{}|c|@{}}{\\textbf{AB}} & \\textbf{C} \\\\
  \\hline
  1 & \\multicolumn{1}{c|}{2} & 3 \\\\
  \\hline
  \\multicolumn{3}{|l|}{\\textbf{Group}} \\\\
  \\hline
  4 & 5 & 6 \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            [1 2 3; 4 5 6];
            backend = :latex,
            cell_alignment = [(1, 2) => :C],
            column_labels = [[MultiColumn(2, "AB", :c), "C"]],
            row_group_labels = [2 => "Group"],
            row_group_label_alignment = :L,
        )

        @test result == expected
    end
end

## Description ############################################################################
#
# Excel Back End: Write the table to an XLSX.Worksheet object.
#
############################################################################################

"""
    _excel__write_table!(
        sheet::XLSX.Worksheet,
        pspec::PrintingSpec;
        kwargs...
    ) -> Nothing

Write the complete table described by `pspec` to `sheet` using the PrettyTables.jl
printing iterator. Cell styling, borders, column widths, and row heights are all applied
during the single pass over the iterator.

# Keywords

- `anchor_cell::String`: Top-left cell of the table in A1 notation (e.g. `"B3"`).
    (**Default**: `"A1"`)
- `data_column_widths::Union{Float64, Vector{Float64}}`: Explicit width for each data column
    in Excel units, overriding auto-calculated widths. A scalar applies to all columns; a
    vector sets per-column widths. When set (> 0), `minimum_data_column_widths` and
    `maximum_data_column_widths` are ignored for that column.
    (**Default**: `0.0`)
- `excel_formatters::Vector{ExcelFormatter}`: Number-format rules applied to data and
    summary cells.
    (**Default**: `ExcelFormatter[]`)
- `highlighters::Vector{ExcelHighlighter}`: Highlighters to apply to the table.
- `minimum_data_column_widths::Union{Float64, Vector{Float64}}`: Minimum width for each
    data column in Excel units. A scalar applies to all columns; a vector sets per-column
    minimums.
    (**Default**: `0.0`)
- `maximum_data_column_widths::Union{Float64, Vector{Float64}}`: Maximum width for each
    data column in Excel units. A scalar applies to all columns; a vector sets per-column
    maximums.
    (**Default**: `0.0`)
- `style::ExcelTableStyle`: Font and fill style for each table section.
    (**Default**: `ExcelTableStyle()`)
- `table_format::ExcelTableFormat`: Border and column-width configuration.
    (**Default**: `ExcelTableFormat()`)
"""
function _excel__write_table!(
    sheet::XLSX.Worksheet,
    pspec::PrintingSpec;
    anchor_cell::String = "A1",
    data_column_widths::Union{Float64, Vector{Float64}} = 0.0,
    excel_formatters::Vector{ExcelFormatter} = ExcelFormatter[],
    highlighters::Vector{ExcelHighlighter} = ExcelHighlighter[],
    maximum_data_column_widths::Union{Float64, Vector{Float64}} = 0.0,
    minimum_data_column_widths::Union{Float64, Vector{Float64}} = 0.0,
    style::ExcelTableStyle = ExcelTableStyle(),
    table_format::ExcelTableFormat = ExcelTableFormat(),
)
    table_data = pspec.table_data

    c = XLSX.CellRef(anchor_cell)
    anchor_row_offset = Int(c.row_number - 1)
    anchor_col_offset = Int(c.column_number - 1)

    num_cols = table_data.num_columns
    num_rows = table_data.num_rows
    num_printed_cols = _number_of_printed_columns(table_data)
    num_printed_data_cols = _number_of_printed_data_columns(table_data)

    num_leading_columns =
        num_printed_cols - num_printed_data_cols - _is_horizontally_cropped(table_data)

    context  = pspec.context
    renderer = pspec.renderer === :show ? Val(:show) : Val(:print)

    # Reusable render buffer: one allocation per table instead of three per cell.
    rctx = RenderContext(context)

    # The width keywords are indexed per data column. Hence, we must check their length here
    # to raise a meaningful error instead of a `BoundsError` deep in the back end.
    for (name, v) in (
        ("data_column_widths", data_column_widths),
        ("minimum_data_column_widths", minimum_data_column_widths),
        ("maximum_data_column_widths", maximum_data_column_widths),
    )
        (v isa AbstractVector) && (length(v) != num_cols) && throw(
            ArgumentError(
                "The length of `$name` ($(length(v))) must be equal to the number of columns ($num_cols).",
            ),
        )
    end

    if data_column_widths isa Number
        data_column_widths = fill(Float64(data_column_widths), num_cols)
    end

    if minimum_data_column_widths isa Number
        minimum_data_column_widths = fill(Float64(minimum_data_column_widths), num_cols)
    end

    if maximum_data_column_widths isa Number
        maximum_data_column_widths = fill(Float64(maximum_data_column_widths), num_cols)
    end

    max_row_height = Dict{Int, Float64}()
    max_col_length = zeros(Float64, num_printed_cols)

    # == Iterator Setup ====================================================================

    # Preprocess Union{Symbol,Vector{Int}} fields into concrete index iterables,
    # mirroring the Typst backend's handling.
    horizontal_lines_at_data_rows = if table_format.horizontal_lines_at_data_rows isa Symbol
        table_format.horizontal_lines_at_data_rows == :all ? (1:typemax(Int)) : (1:0)
    else
        table_format.horizontal_lines_at_data_rows::Vector{Int}
    end

    vertical_lines_at_data_columns =
        if table_format.vertical_lines_at_data_columns isa Symbol
            table_format.vertical_lines_at_data_columns == :all ? (1:typemax(Int)) : (1:0)
        else
            table_format.vertical_lines_at_data_columns::Vector{Int}
        end

    ps     = PrintingTableState()
    action = :initialize

    has_cont_column = _is_horizontally_cropped(table_data)

    # Tracking variables used for post-loop operations and section transitions.
    first_content_row = 0 # .. Absolute sheet row of 1st row outside the title/subtitle sec.
    last_written_row  = 0 # .................... Absolute sheet row of last data/summary row

    all_cols = (1 + anchor_col_offset):(num_printed_cols + anchor_col_offset)

    ir = jr = 0

    # The highlighters and the formatters must receive the object the user passed to
    # `pretty_table`, not the internal table wrapper. Notice that this is loop invariant.
    orig_data = _get_data(table_data.data)

    # == Main Loop =========================================================================

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)

        action == :end_printing && break

        jr += 1

        sheet_row = ir + anchor_row_offset
        sheet_col = jr + anchor_col_offset

        if action == :new_row
            ir += 1
            jr = 0

            max_row_height[ir] = 0.0

            # Ensure all cells in the row are non-empty before any merges.
            _excel__unempty_row!(sheet, ir + anchor_row_offset, all_cols)

            # Track the first row outside the title/subtitle section so the post-loop
            # outer-border logic can clamp the top of the content area accordingly.
            if first_content_row == 0 && rs != :table_header
                first_content_row = ir + anchor_row_offset
            end

        elseif action ∈ (
            :horizontal_continuation_cell,
            :diagonal_continuation_cell,
            :vertical_continuation_cell,
            :row_number_vertical_continuation_cell,
            :row_label_vertical_continuation_cell,
        )
            alignment = :c

            rendered_cell = if action == :horizontal_continuation_cell
                "⋯"
            elseif action == :diagonal_continuation_cell
                "⋱"
            else
                "⋮"
            end

            sheet[sheet_row, sheet_col] = rendered_cell

            fontsize = _excel__apply_cell_style!(
                sheet, sheet_row, sheet_col, style.data_cell, alignment, "bottom", false
            )

            row_height, col_length = _excel__cell_length_and_height(rendered_cell, fontsize)

            max_row_height[ir] = max(max_row_height[ir], row_height)
            max_col_length[jr] = max(max_col_length[jr], col_length)

        elseif action == :end_row
            # Obtain the next row section since some decisions below depend on it. Notice
            # that this must be done here, and not once per action, because the lookahead is
            # a full run of the printing state iterator and only this branch consumes it.
            _, next_rs, _ = _next(ps, table_data)

            # Track the last row inside the content area so the post-loop outer-border
            # logic works even when the table has no data rows at all.
            if rs != :table_header
                last_written_row = ir + anchor_row_offset
            end

            # NOTE: The row height is set once for every row in the post-loop block, which
            # already has the final value. Setting it here as well doubled the work.

            if rs == :column_labels && next_rs != :column_labels
                if table_format.horizontal_line_after_column_labels
                    XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        bottom = table_format.borders.header_line,
                    )
                end

            elseif rs ∈ (:data, :continuation_row)
                if next_rs ∉ (:data, :continuation_row)
                    table_format.horizontal_line_after_data_rows && XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        bottom = table_format.borders.middle_line,
                    )

                    (
                        (next_rs == :summary_row) &&
                        table_format.horizontal_line_before_summary_rows
                    ) && XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        bottom = table_format.borders.middle_line,
                    )

                elseif (ps.i ∈ horizontal_lines_at_data_rows)
                    XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        bottom = table_format.borders.middle_line,
                    )
                end

            elseif rs == :summary_row
                if next_rs != :summary_row
                    table_format.horizontal_line_after_summary_rows && XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        bottom = table_format.borders.bottom_line,
                    )
                end

            elseif rs == :row_group_label
                if table_format.horizontal_line_before_row_group_label
                    XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        top = table_format.borders.middle_line,
                    )
                end

                if table_format.horizontal_line_after_row_group_label
                    XLSX.setBorder(
                        sheet,
                        ir + anchor_row_offset,
                        all_cols;
                        bottom = table_format.borders.middle_line,
                    )
                end
            end

        else
            # == Cell Actions ==============================================================

            cell = _current_cell(action, ps, table_data)
            cell === _IGNORE_CELL && continue

            rendered_cell = _excel__render_cell(cell, rctx, renderer)

            alignment = _current_cell_alignment(action, ps, table_data)

            # Footnote superscripts to append to this cell.
            fn_indices = _current_cell_footnotes(table_data, action, ps.i, ps.j)

            if !isnothing(fn_indices) && !isempty(fn_indices)
                fn_str = join(_excel__to_superscript.(fn_indices))
                rendered_cell = string(rendered_cell) * fn_str
            end

            # -- Full-span Cells -----------------------------------------------------------

            if action ∈ (:title, :subtitle, :row_group_label, :footnote, :source_notes)
                if action == :footnote
                    # Footnote cells are prefixed with their index superscript.
                    rendered_cell = _excel__to_superscript(ps.i) * rendered_cell
                end

                style_key  = action == :source_notes ? "source_note" : string(action)
                cell_style = getproperty(style, Symbol(style_key))

                valign = if action ∈ (:title, :subtitle)
                    "bottom"
                else
                    "center"
                end

                col_start = 1 + anchor_col_offset
                col_end   = num_printed_cols + anchor_col_offset

                sheet[sheet_row, col_start] = rendered_cell

                XLSX.mergeCells(
                    sheet,
                    XLSX.CellRange(
                        XLSX.CellRef(sheet_row, col_start), XLSX.CellRef(sheet_row, col_end)
                    ),
                )

                fontsize = _excel__apply_cell_style!(
                    sheet, sheet_row, col_start, cell_style, alignment, valign, true
                )

                text_lines = _excel__text_lines(rendered_cell)
                row_height = _excel__row_height_for_text(text_lines, fontsize)

                max_row_height[ir] = max(max_row_height[ir], row_height)

            elseif (action == :column_label) && (cell isa MergeCells)
                # -- Column labels (Merged Cell) -------------------------------------------

                num_data_cols = _number_of_printed_data_columns(table_data)
                span          = min(cell.column_span, num_data_cols - ps.j + 1)

                sheet[sheet_row, sheet_col] = rendered_cell

                XLSX.mergeCells(
                    sheet,
                    XLSX.CellRange(
                        XLSX.CellRef(sheet_row, sheet_col),
                        XLSX.CellRef(sheet_row, sheet_col + span - 1),
                    ),
                )

                cell_style =
                    ps.i == 1 ? style.first_line_merged_column_label :
                    style.merged_column_label

                fontsize = _excel__apply_cell_style!(
                    sheet, sheet_row, sheet_col, cell_style, cell.alignment, "bottom", true
                )

                row_height, _ = _excel__cell_length_and_height(rendered_cell, fontsize)

                max_row_height[ir] = max(max_row_height[ir], row_height)

                if table_format.horizontal_line_at_merged_column_labels
                    XLSX.setBorder(
                        sheet,
                        sheet_row,
                        sheet_col:(sheet_col + span - 1);
                        bottom = table_format.borders.merged_header_cell_line,
                    )
                end

                # We draw the vertical line here because we have access to the actual span
                # of the merged cell.
                last_merged_col = ps.j + span - 1
                if (last_merged_col == num_printed_data_cols)
                    # If we do not have a continuation column, we are in the last column.
                    # The right border in this case is drawn at the end.
                    table_format.vertical_line_after_data_columns &&
                        has_cont_column &&
                        XLSX.setBorder(
                            sheet,
                            sheet_row,
                            sheet_col + span - 1;
                            right = table_format.borders.middle_line,
                        )

                elseif (last_merged_col ∈ vertical_lines_at_data_columns)
                    XLSX.setBorder(
                        sheet,
                        sheet_row,
                        sheet_col + span - 1;
                        right = table_format.borders.middle_line,
                    )
                end

            else
                # -- Other Cells -----------------------------------------------------------

                vertical_alignment = "bottom"
                cell_style         = _EXCEL__NO_DECORATION
                wrap               = false

                # .. Unmerged Column labels ................................................

                if (action == :column_label)
                    style_var =
                        ps.i == 1 ? style.first_line_column_label : style.column_label

                    cell_style = if style_var isa Vector{Vector{ExcelPair}}
                        style_var[ps.j]
                    else
                        style_var
                    end

                    vertical_alignment = "bottom"
                    wrap = true

                    if ps.i < length(table_data.column_labels) &&
                        table_format.horizontal_line_between_column_labels
                        XLSX.setBorder(
                            sheet,
                            sheet_row,
                            sheet_col;
                            bottom = table_format.borders.middle_line,
                        )
                    end

                elseif action == :row_number_label
                    cell_style = ps.i == 1 ? style.row_number_label : _EXCEL__NO_DECORATION
                    vertical_alignment = "bottom"
                    wrap = true

                    if (ps.i < length(table_data.column_labels)) &&
                        table_format.horizontal_line_between_column_labels
                        XLSX.setBorder(
                            sheet,
                            sheet_row,
                            sheet_col;
                            bottom = table_format.borders.middle_line,
                        )
                    end


                elseif action ∈ (:row_number, :summary_row_number)
                    cell_style = style.row_number
                    vertical_alignment = "top"
                    wrap = true

                elseif action == :stubhead_label
                    cell_style = ps.i == 1 ? style.stubhead_label : _EXCEL__NO_DECORATION
                    vertical_alignment = "bottom"
                    wrap = true

                    if (ps.i < length(table_data.column_labels)) &&
                        table_format.horizontal_line_between_column_labels
                        XLSX.setBorder(
                            sheet,
                            sheet_row,
                            sheet_col;
                            bottom = table_format.borders.middle_line,
                        )
                    end

                elseif action == :row_label
                    cell_style = style.row_label
                    vertical_alignment = "top"
                    wrap = true

                elseif action == :summary_row_label
                    cell_style = style.summary_row_label
                    vertical_alignment = "top"
                    wrap = true

                elseif action == :data
                    cell_style = style.data_cell
                    lines = _excel__text_lines(rendered_cell)
                    vertical_alignment = "top"
                    wrap = lines > 1

                    for formatter in excel_formatters
                        # `:data` formatters match the data row index.
                        formatter.region === :data || continue

                        fmt_attributes = _excel__format_attributes(
                            orig_data, formatter, ps.i, ps.j
                        )
                        if !isnothing(fmt_attributes)
                            XLSX.setFormat(sheet, sheet_row, sheet_col; fmt_attributes...)
                            break
                        end
                    end

                elseif action == :summary_row_cell
                    cell_style = style.summary_row_cell
                    vertical_alignment = "top"
                    wrap = false

                    for formatter in excel_formatters
                        # `:summary_row` formatters match the summary row index.
                        formatter.region === :summary_row || continue

                        fmt_attributes = _excel__format_attributes(
                            orig_data, formatter, ps.i, ps.j
                        )

                        if !isnothing(fmt_attributes)
                            XLSX.setFormat(sheet, sheet_row, sheet_col; fmt_attributes...)
                            break
                        end
                    end
                end

                sheet[sheet_row, sheet_col] = rendered_cell

                fontsize = _excel__apply_cell_style!(
                    sheet,
                    sheet_row,
                    sheet_col,
                    cell_style,
                    alignment,
                    vertical_alignment,
                    wrap,
                )

                row_height, col_length = _excel__cell_length_and_height(
                    rendered_cell, fontsize
                )

                max_row_height[ir] = max(max_row_height[ir], row_height)
                max_col_length[jr] = max(max_col_length[jr], col_length)

                # Apply highlighters in order, breaking after the first match. Notice that
                # this must be performed after applying the section style. Otherwise, the
                # highlighter decoration would be overwritten.
                if action == :data
                    for highlighter in highlighters
                        highlighter.f(orig_data, ps.i, ps.j) || continue

                        decoration = highlighter.fd(highlighter, orig_data, ps.i, ps.j)

                        hl_font_size = _excel__apply_cell_style!(
                            sheet, sheet_row, sheet_col, decoration, nothing, "", false
                        )

                        hl_row_height, hl_col_length = _excel__cell_length_and_height(
                            rendered_cell, hl_font_size
                        )

                        max_row_height[ir] = max(max_row_height[ir], hl_row_height)
                        max_col_length[jr] = max(max_col_length[jr], hl_col_length)

                        break
                    end
                end
            end
        end

        # == Vertical Lines ================================================================

        if action ∈ (
            :row_number_label,
            :row_number,
            :row_number_vertical_continuation_cell,
            :summary_row_number,
        )
            table_format.vertical_line_after_row_number_column && XLSX.setBorder(
                sheet, sheet_row, sheet_col; right = table_format.borders.center_line
            )

        elseif action ∈ (
            :stubhead_label,
            :row_label,
            :row_label_vertical_continuation_cell,
            :summary_row_label,
        )
            table_format.vertical_line_after_row_label_column && XLSX.setBorder(
                sheet, sheet_row, sheet_col; right = table_format.borders.center_line
            )

        elseif action ∈
            (:column_label, :data, :summary_row_cell, :vertical_continuation_cell)
            if !(action == :column_label && cell isa MergeCells)
                if (ps.j == num_printed_data_cols)
                    # If we do not have a continuation column, we are in the last column.
                    # The right border in this case is drawn at the end.
                    table_format.vertical_line_after_data_columns &&
                        has_cont_column &&
                        XLSX.setBorder(
                            sheet,
                            sheet_row,
                            sheet_col;
                            right = table_format.borders.middle_line,
                        )

                elseif (ps.j ∈ vertical_lines_at_data_columns)
                    XLSX.setBorder(
                        sheet,
                        sheet_row,
                        sheet_col;
                        right = table_format.borders.middle_line,
                    )
                end
            end
        end
    end

    # == Post-Loop Operations ==============================================================

    # Outer borders span only the content area (excludes title/subtitle and footnotes).
    content_start = first_content_row > 0 ? first_content_row : 1 + anchor_row_offset
    content_end = last_written_row > 0 ? last_written_row : ir + anchor_row_offset - 1
    all_rows = content_start:content_end

    # If the table has no content rows at all, we must not draw the outer borders.
    has_content = content_end >= content_start

    b = table_format.borders

    if has_content && table_format.horizontal_line_at_beginning
        XLSX.setBorder(sheet, content_start, all_cols; top = b.top_line)
    end

    # NOTE: The bottom rule must be an independent decision. It used to sit inside the block
    # above, so turning off the line at the *beginning* of the table silently removed the
    # line at its *end*. It follows the flag of the last section that is actually printed.
    draw_bottom_line = if _has_summary_rows(table_data)
        table_format.horizontal_line_after_summary_rows
    else
        table_format.horizontal_line_after_data_rows
    end

    if has_content && draw_bottom_line
        XLSX.setBorder(sheet, content_end, all_cols; bottom = b.bottom_line)
    end

    if has_content && table_format.vertical_line_at_beginning
        XLSX.setBorder(sheet, all_rows, first(all_cols); left = b.left_line)
    end

    if has_content
        if _is_horizontally_cropped(table_data)
            table_format.vertical_line_after_continuation_column &&
                XLSX.setBorder(sheet, all_rows, last(all_cols); right = b.right_line)
        else
            table_format.vertical_line_after_data_columns &&
                XLSX.setBorder(sheet, all_rows, last(all_cols); right = b.right_line)
        end
    end

    # Set column widths based on accumulated content lengths.
    for i in 1:num_printed_cols
        col_width = _excel__get_col_width(
            i,
            max_col_length,
            num_leading_columns,
            data_column_widths,
            minimum_data_column_widths,
            maximum_data_column_widths,
        )

        col_width > 0 &&
            XLSX.setColumnWidth(sheet, i + anchor_col_offset; width = col_width)
    end

    # Set final row heights.
    for (row, height) in max_row_height
        XLSX.setRowHeight(sheet, row + anchor_row_offset; height = height)
    end

    return nothing
end

## Description #############################################################################
#
# Test PrettyTable structure.
#
############################################################################################

@testset "Construction and Printing" begin
    matrix = [
        1 1.0 0x01 'a' "abc" missing
        2 2.0 0x02 'b' "def" nothing
        3 3.0 0x03 'c' "ghi" :symbol
    ]

    pt = PrettyTable(matrix; backend = :text)

    expected = """
┌────────┬────────┬────────┬────────┬────────┬─────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │ Col. 4 │ Col. 5 │  Col. 6 │
├────────┼────────┼────────┼────────┼────────┼─────────┤
│      1 │    1.0 │      1 │      a │    abc │ missing │
│      2 │    2.0 │      2 │      b │    def │ nothing │
│      3 │    3.0 │      3 │      c │    ghi │  symbol │
└────────┴────────┴────────┴────────┴────────┴─────────┘
"""

    result = pretty_table(String, pt)

    @test result == expected

    pt = PrettyTable(matrix)
    pt.column_labels = ["#1", "#2", "#3", "#4", "#5", "#6"]

    expected = """
┌────┬─────┬────┬────┬─────┬─────────┐
│ #1 │  #2 │ #3 │ #4 │  #5 │      #6 │
├────┼─────┼────┼────┼─────┼─────────┤
│  1 │ 1.0 │  1 │  a │ abc │ missing │
│  2 │ 2.0 │  2 │  b │ def │ nothing │
│  3 │ 3.0 │  3 │  c │ ghi │  symbol │
└────┴─────┴────┴────┴─────┴─────────┘
"""

    result = pretty_table(String, pt)

    @test result == expected

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">#1</th>
      <th style = "font-weight: bold; text-align: right;">#2</th>
      <th style = "font-weight: bold; text-align: right;">#3</th>
      <th style = "font-weight: bold; text-align: right;">#4</th>
      <th style = "font-weight: bold; text-align: right;">#5</th>
      <th style = "font-weight: bold; text-align: right;">#6</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">abc</td>
      <td style = "text-align: right;">missing</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">2</td>
      <td style = "text-align: right;">2.0</td>
      <td style = "text-align: right;">2</td>
      <td style = "text-align: right;">b</td>
      <td style = "text-align: right;">def</td>
      <td style = "text-align: right;">nothing</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">3.0</td>
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">c</td>
      <td style = "text-align: right;">ghi</td>
      <td style = "text-align: right;">symbol</td>
    </tr>
  </tbody>
</table>
"""

    pt.backend = :html

    result = pretty_table(String, pt)
    @test result == expected

    pt = PrettyTable(matrix)
    pt.column_labels = ["#1", "#2", "#3", "#4", "#5", "#6"]
    result = pretty_table(HTML, pt)

    @test result isa HTML
    @test result.content == expected
end

@testset "Parameter Overload when Printing" begin
    matrix = [
        1 1.0 0x01 'a' "abc" missing
        2 2.0 0x02 'b' "def" nothing
        3 3.0 0x03 'c' "ghi" :symbol
    ]

    pt = PrettyTable(matrix; backend = :text)

    expected = """
┌────┬─────┬────┬────┬─────┬─────────┐
│ #1 │  #2 │ #3 │ #4 │  #5 │      #6 │
├────┼─────┼────┼────┼─────┼─────────┤
│  1 │ 1.0 │  1 │  a │ abc │ missing │
│  2 │ 2.0 │  2 │  b │ def │ nothing │
│  3 │ 3.0 │  3 │  c │ ghi │  symbol │
└────┴─────┴────┴────┴─────┴─────────┘
"""

    result = pretty_table(String, pt; column_labels = ["#1", "#2", "#3", "#4", "#5", "#6"])

    @test result == expected

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">#1</th>
      <th style = "font-weight: bold; text-align: right;">#2</th>
      <th style = "font-weight: bold; text-align: right;">#3</th>
      <th style = "font-weight: bold; text-align: right;">#4</th>
      <th style = "font-weight: bold; text-align: right;">#5</th>
      <th style = "font-weight: bold; text-align: right;">#6</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">1.0</td>
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">a</td>
      <td style = "text-align: right;">abc</td>
      <td style = "text-align: right;">missing</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">2</td>
      <td style = "text-align: right;">2.0</td>
      <td style = "text-align: right;">2</td>
      <td style = "text-align: right;">b</td>
      <td style = "text-align: right;">def</td>
      <td style = "text-align: right;">nothing</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">3.0</td>
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">c</td>
      <td style = "text-align: right;">ghi</td>
      <td style = "text-align: right;">symbol</td>
    </tr>
  </tbody>
</table>
"""

    pt.backend = :html

    result = pretty_table(String, pt; column_labels = ["#1", "#2", "#3", "#4", "#5", "#6"])
    @test result == expected

    result = pretty_table(HTML, pt; column_labels = ["#1", "#2", "#3", "#4", "#5", "#6"])

    @test result isa HTML
    @test result.content == expected
end

@testset "Show" begin
    io = IOBuffer()

    matrix = [
        1 1.0 0x01 'a' "abc" missing
        2 2.0 0x02 'b' "def" nothing
        3 3.0 0x03 'c' "ghi" :symbol
    ]

    pt = PrettyTable(
        matrix; backend = :text, column_labels = ["#1", "#2", "#3", "#4", "#5", "#6"]
    )

    expected = """
┌────┬─────┬────┬────┬─────┬─────────┐
│ #1 │  #2 │ #3 │ #4 │  #5 │      #6 │
├────┼─────┼────┼────┼─────┼─────────┤
│  1 │ 1.0 │  1 │  a │ abc │ missing │
│  2 │ 2.0 │  2 │  b │ def │ nothing │
│  3 │ 3.0 │  3 │  c │ ghi │  symbol │
└────┴─────┴────┴────┴─────┴─────────┘"""

    show(io, pt)

    result = String(take!(io))

    @test result == expected
end

## Description #############################################################################
#
# Excel Back End: Test column headers.
#
############################################################################################

@testset "Column Headers" verbose = true begin
    data = [1 2 3 4]
    merge_column_label_cells = :auto

    # == Merged Columns in Top Row =========================================================

    @testset "Merged Columns in Top Row" verbose = true begin
        column_labels = [
            [EmptyCells(2), MultiColumn(2, "Estimated Data")],
            [
                styled"{(foreground=gray):[s]}",
                styled"{(foreground=gray):[m / s²]}",
                styled"{(foreground=gray):[m / s]}",
                styled"{(foreground=gray):[m]}",
            ],
            ["Time (s)", "Acceleration", "Velocity", "Position"],
        ]

        f = pretty_table(data; column_labels, merge_column_label_cells, backend = :excel)

        @test XLSX.getBorder(f[1], "C1").border["bottom"] ==
            Dict("style" => "thin", "rgb" => "FF000000")
        @test XLSX.isMergedCell(f[1], "D1") == true
    end

    # == Merged Columns in Middle Row ======================================================

    @testset "Merged Columns in Middle Row" verbose = true begin
        column_labels = [
            [
                styled"{(foreground=gray):[s]}",
                styled"{(foreground=gray):[m / s²]}",
                styled"{(foreground=gray):[m / s]}",
                styled"{(foreground=gray):[m]}",
            ],
            [EmptyCells(2), MultiColumn(2, "Estimated Data")],
            ["Time (s)", "Acceleration", "Velocity", "Position"],
        ]

        f = pretty_table(data; column_labels, merge_column_label_cells, backend = :excel)

        @test XLSX.getBorder(f[1], "C2").border["bottom"] ==
            Dict("style" => "thin", "rgb" => "FF000000")
        @test XLSX.isMergedCell(f[1], "D2") == true
    end

    # == Merged Columns in Bottom Row ======================================================

    @testset "Merged Columns in Bottom Row" verbose = true begin
        column_labels = [
            [
                styled"{(foreground=gray):[s]}",
                styled"{(foreground=gray):[m / s²]}",
                styled"{(foreground=gray):[m / s]}",
                styled"{(foreground=gray):[m]}",
            ],
            ["Time (s)", "Acceleration", "Velocity", "Position"],
            [EmptyCells(2), MultiColumn(2, "Estimated Data")],
        ]

        f = pretty_table(data; column_labels, merge_column_label_cells, backend = :excel)

        @test XLSX.getBorder(f[1], "C3").border["bottom"] ==
            Dict("style" => "medium", "rgb" => "FF000000")
        @test XLSX.isMergedCell(f[1], "D3") == true
    end

    # == Merged Columns in Middle Two Columns ==============================================

    @testset "Merged Columns in Middle Two Columns" verbose = true begin
        column_labels = [
            [
                styled"{(foreground=gray):[s]}",
                styled"{(foreground=gray):[m / s²]}",
                styled"{(foreground=gray):[m / s]}",
                styled"{(foreground=gray):[m]}",
            ],
            [EmptyCells(1), MultiColumn(2, "Estimated Data"), EmptyCells(1)],
            ["Time (s)", "Acceleration", "Velocity", "Position"],
        ]

        f = pretty_table(data; column_labels, merge_column_label_cells, backend = :excel)

        @test XLSX.getBorder(f[1], "B2").border["bottom"] ==
            Dict("style" => "thin", "rgb" => "FF000000")
        @test XLSX.isMergedCell(f[1], "C2") == true
    end

    # == Default Height and Width ==========================================================

    @testset "Default Height and Width" verbose = true begin
        column_labels = [
            [
                styled"{(foreground=gray):[s]}",
                styled"{(foreground=gray):[m / s²]}",
                styled"{(foreground=gray):[m / s]}",
                styled"{(foreground=gray):[m]}",
            ],
            [EmptyCells(1), MultiColumn(2, "Estimated Data"), EmptyCells(1)],
            ["Time (s)", "Acceleration", "Velocity", "Position"],
        ]

        f = pretty_table(data; column_labels, merge_column_label_cells, backend = :excel)

        @test XLSX.getRowHeight(f[1], "C3") ≈ 17.6109375
        @test XLSX.getColumnWidth(f[1], "C3") ≈ 10.253794642857144
    end

    # == Between-Header Borders on Row-Number and Stubhead Columns ========================

    @testset "Between-header borders on row-number and stubhead columns" verbose = true begin
        # When `horizontal_line_between_column_labels` is enabled and the header spans
        # three or more rows, the row-number column (shown here) and the row-label column
        # (a stubhead when row labels are also requested) must each receive a \"thin\" bottom
        # border on every row except the last header row, mirroring the behaviour of the
        # column-label cells.
        column_labels = [["A", "B", "C", "D"], ["a", "b", "c", "d"], ["x", "y", "z", "w"]]

        # With `show_row_number_column = true`, column A holds the row-number-label cells.

        f = pretty_table(
            data;
            column_labels,
            backend = :excel,
            show_row_number_column = true,
            table_format = ExcelTableFormat(; horizontal_line_between_column_labels = true),
        )

        # A1 (first header row) and A2 (middle header row) must both carry a thin border
        # underneath; A3 (last header row) gets the medium header-line border instead.
        for cell in ("A1", "A2")
            border = XLSX.getBorder(f[1], cell).border
            @test get(border, "bottom", nothing) ==
                Dict("style" => "thin", "rgb" => "FF000000")
        end
        @test XLSX.getBorder(f[1], "A3").border["bottom"] ==
            Dict("style" => "medium", "rgb" => "FF000000")
        # Sanity check: the column-label cells on A2's row are bordered too, so we are
        # not silently drawing the divider for the row-number column only.
        for cell in ("B2", "C2")
            @test XLSX.getBorder(f[1], cell).border["bottom"] ==
                Dict("style" => "thin", "rgb" => "FF000000")
        end

        # With row labels, column A holds the stubhead-label cells instead. Same expectation.
        g = pretty_table(
            data;
            column_labels,
            backend = :excel,
            row_labels = ["r1", "r2", "r3", "r4"],
            table_format = ExcelTableFormat(; horizontal_line_between_column_labels = true),
        )
        for cell in ("A1", "A2")
            border = XLSX.getBorder(g[1], cell).border
            @test get(border, "bottom", nothing) ==
                Dict("style" => "thin", "rgb" => "FF000000")
        end
        @test XLSX.getBorder(g[1], "A3").border["bottom"] ==
            Dict("style" => "medium", "rgb" => "FF000000")
    end

    # == Formatted Merged Column Labels ====================================================

    @testset "Formatted Merged Column Labels" verbose = true begin
        column_labels = [
            [
                styled"{(foreground=gray):[s]}",
                styled"{(foreground=gray):[m / s²]}",
                styled"{(foreground=gray):[m / s]}",
                styled"{(foreground=gray):[m]}",
            ],
            [EmptyCells(1), MultiColumn(2, "Estimated Data"), EmptyCells(1)],
            ["Time (s)", "Acceleration", "Velocity", "Position"],
        ]

        f = pretty_table(
            data;
            column_labels,
            merge_column_label_cells,
            table_format = ExcelTableFormat(;
                borders = ExcelTableBorders(;
                    merged_header_cell_line = ["style" => "thick", "color" => "red"]
                ),
            ),
            style = ExcelTableStyle(;
                merged_column_label = ["color" => "red", "size" => "32"]
            ),
            backend = :excel,
        )

        @test XLSX.getRowHeight(f[1], "C2") ≈ 41.6109375
        @test XLSX.getColumnWidth(f[1], "C3") ≈ 10.253794642857144
        @test XLSX.getColumnWidth(f[1], "D3") ≈ 10.253794642857144
        @test XLSX.getBorder(f[1], "C2").border["bottom"] ==
            Dict("style" => "thick", "rgb" => "FFFF0000")
    end
end

## Description #############################################################################
#
# Markdown Back End: Tests related with decorations.
#
############################################################################################

@testset "Decorations" verbose = true begin
    @testset "Decoration of Column Labels" begin
        matrix = ones(3, 3)

        expected = """
| *Col. 1* | *Col. 2* | *Col. 3* |
|---------:|---------:|---------:|
|      1.0 |      1.0 |      1.0 |
|      1.0 |      1.0 |      1.0 |
|      1.0 |      1.0 |      1.0 |
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            style = MarkdownTableStyle(;
                first_line_column_label = MarkdownStyle(; italic = true)
            ),
        )

        @test result == expected

        expected = """
| *Col. 1* | **Col. 2** | `Col. 3` |
|---------:|-----------:|---------:|
|      1.0 |        1.0 |      1.0 |
|      1.0 |        1.0 |      1.0 |
|      1.0 |        1.0 |      1.0 |
"""

        result = pretty_table(
            String,
            matrix;
            backend = :markdown,
            style = MarkdownTableStyle(;
                first_line_column_label = [
                    MarkdownStyle(; italic = true),
                    MarkdownStyle(; bold = true),
                    MarkdownStyle(; code = true),
                ],
            ),
        )

        @test result == expected
    end
    @testset "Code Style Is Applied Innermost" begin
        # A Markdown code span renders its content verbatim. Hence, if `code` were applied
        # outermost, the `bold` / `italic` / `strikethrough` markers would show up literally.
        result = pretty_table(
            String,
            [1 2];
            backend = :markdown,
            style = MarkdownTableStyle(;
                first_line_column_label = MarkdownStyle(; bold = true, code = true),
            ),
        )

        @test occursin("**`Col. 1`**", result)
        @test !occursin("`**Col. 1**`", result)
    end
end

## Description #############################################################################
#
# LaTeX Back End: Test with default options.
#
############################################################################################

@testset "Default Option" verbose = true begin
    matrix = [
        1 1.0 0x01 'a' "abc" missing
        2 2.0 0x02 'b' "def" nothing
        3 3.0 0x03 'c' "ghi" :symbol
    ]

    expected = """
\\begin{tabular}{|r|r|r|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} & \\textbf{Col. 4} & \\textbf{Col. 5} & \\textbf{Col. 6} \\\\
  \\hline
  1 & 1.0 & 1 & a & abc & missing \\\\
  2 & 2.0 & 2 & b & def & nothing \\\\
  3 & 3.0 & 3 & c & ghi & symbol \\\\
  \\hline
\\end{tabular}
"""

    result = pretty_table(String, matrix; backend = :latex)
    @test result == expected

    result = pretty_table(String, matrix; table_format = LatexTableFormat())
    @test result == expected

    result = pretty_table_latex_backend(String, matrix)
    @test result == expected
end

## Description #############################################################################
#
# Tests related to the internal functions that manage the printing state.
#
############################################################################################

@testset "Print State" verbose = true begin
    @testset "Default" begin
        # == Create the Table Data =========================================================

        td = PrettyTables.TableData(;
            data                    = rand(3, 4),
            title                   = "Table Title",
            subtitle                = "Table Subtitle",
            column_labels           = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
            stubhead_label          = "Stubhead Label",
            show_row_number_column  = true,
            row_number_column_label = "Row Number",
            row_labels              = ["Row 1", "Row 2", "Row 3"],
            row_group_labels        = [2 => "Row Group"],
            summary_rows            = [(data, j) -> j, (data, j) -> 2j],
            summary_row_labels      = ["Summary 1", "Summary 2"],
            footnotes               = [(:data, 1, 1) => "Footnote", (:data, 2, 2) => "Footnote"],
            source_notes            = "Source Notes",
            num_rows                = 3,
            num_columns             = 4,
            first_row_index         = 1,
            first_column_index      = 1,
        )

        # == Iterate the Printing Table State ==============================================

        ps = PrettyTables.PrintingTableState()

        # -- Table Header ------------------------------------------------------------------

        for a in (:title, :subtitle)
            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :table_header

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == a
            @test rs == :table_header

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :table_header
        end

        # -- Column Labels -----------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :column_labels

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_number_label
            @test rs == :column_labels
            @test ps.i == i

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :stubhead_label
            @test rs == :column_labels
            @test ps.i == i

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :column_label
                @test rs == :column_labels
                @test ps.i == i
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :column_labels
        end

        # -- Table Data --------------------------------------------------------------------

        for i in 1:3
            if i == 2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :row_group_label
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_group_label
                @test rs == :row_group_label
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :row_group_label
                @test ps.i == i
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :data
            @test ps.i == i

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_number
            @test rs == :data
            @test ps.i == i

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_label
            @test rs == :data
            @test ps.i == i

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :data
                @test rs == :data
                @test ps.i == i
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :data
        end

        # -- Table Summary -----------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :summary_row
            @test ps.i == i

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :summary_row_number
            @test rs == :summary_row
            @test ps.i == i

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :summary_row_label
            @test rs == :summary_row
            @test ps.i == i

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_cell
                @test rs == :summary_row
                @test ps.i == i
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :summary_row
        end

        # -- Table Footer ------------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :footnote
            @test ps.i == i
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :table_footer
        end

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :new_row
        @test rs == :table_footer

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :source_notes
        @test rs == :table_footer

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :end_row
        @test rs == :table_footer

        # -- End Printing ------------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :end_printing

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :end_printing
    end

    @testset "Without Optional Fields" begin
        # == Create the Table Data =========================================================

        td = PrettyTables.TableData(;
            data               = rand(3, 4),
            column_labels      = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
            num_rows           = 3,
            num_columns        = 4,
            first_row_index    = 1,
            first_column_index = 1,
        )

        # == Iterate the Printing Table State ==============================================

        ps = PrettyTables.PrintingTableState()

        # -- Column Labels -----------------------------------------------------------------

        for i in 1:2
            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :column_labels

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :column_label
                @test rs == :column_labels
                @test ps.i == i
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :column_labels
        end

        # -- Table Data --------------------------------------------------------------------

        for i in 1:3
            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :data
            @test ps.i == i

            for j in 1:4
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :data
                @test rs == :data
                @test ps.i == i
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :data
        end

        # -- End Printing ------------------------------------------------------------------

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :end_printing

        action, rs, ps = PrettyTables._next(ps, td)
        @test action == :end_printing
    end

    @testset "Zero Rows With Hidden Column Labels" begin
        @testset "With Summary Rows" begin
            summary_rows = [(data, j) -> j]
            td = PrettyTables.TableData(;
                data               = Matrix{Int}(undef, 0, 2),
                column_labels      = [["1", "2"]],
                show_column_labels = false,
                summary_rows       = summary_rows,
                summary_row_labels = PrettyTables.SummaryLabelIterator(summary_rows),
                num_rows           = 0,
                num_columns        = 2,
                first_row_index    = 1,
                first_column_index = 1,
            )

            ps = PrettyTables.PrintingTableState()
            actions = Symbol[]
            row_sections = Symbol[]

            while true
                action, row_section, ps = PrettyTables._next(ps, td)
                push!(actions, action)
                push!(row_sections, row_section)
                action == :end_printing && break
            end

            @test actions == [
                :new_row,
                :summary_row_label,
                :summary_row_cell,
                :summary_row_cell,
                :end_row,
                :end_printing,
            ]
            @test row_sections == [
                :summary_row,
                :summary_row,
                :summary_row,
                :summary_row,
                :summary_row,
                :table_footer,
            ]
            @test :data ∉ actions
        end

        @testset "Without Summary Rows" begin
            td = PrettyTables.TableData(;
                data               = Matrix{Int}(undef, 0, 2),
                column_labels      = [["1", "2"]],
                show_column_labels = false,
                num_rows           = 0,
                num_columns        = 2,
                first_row_index    = 1,
                first_column_index = 1,
            )

            action, row_section, ps = PrettyTables._next(
                PrettyTables.PrintingTableState(), td
            )

            @test action == :end_printing
            @test row_section == :table_footer
            @test ps.i == 0
            @test :data != action
            @test :new_row != action
        end
    end

    @testset "With Cropping" verbose = true begin
        @testset "Bottom Vertical Cropping" begin
            # == Create the Table Data =====================================================

            summary_rows = [(data, i) -> i, (data, i) -> 2i]

            td = PrettyTables.TableData(;
                data                      = rand(6, 4),
                title                     = "Table Title",
                subtitle                  = "Table Subtitle",
                column_labels             = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
                stubhead_label            = "Stubhead Label",
                show_row_number_column    = true,
                row_number_column_label   = "Row Number",
                row_labels                = ["Row 1", "Row 2", "Row 3"],
                row_group_labels          = [2 => "Row Group 1", 4 => "Row Group 1"],
                summary_rows              = summary_rows,
                summary_row_labels        = PrettyTables.SummaryLabelIterator(summary_rows),
                footnotes                 = [(:data, 1, 1) => "Footnote", (:data, 2, 2) => "Footnote"],
                source_notes              = "Source Notes",
                num_rows                  = 6,
                num_columns               = 4,
                first_row_index           = 1,
                first_column_index        = 1,
                maximum_number_of_columns = 2,
                maximum_number_of_rows    = 3,
                vertical_crop_mode        = :bottom,
            )

            # == Iterate the Printing Table State ==========================================

            ps = PrettyTables.PrintingTableState()

            # -- Table Header --------------------------------------------------------------

            for a in (:title, :subtitle)
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :table_header

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == a
                @test rs == :table_header

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :table_header
            end

            # -- Column Labels -------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :column_labels

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number_label
                @test rs == :column_labels
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :stubhead_label
                @test rs == :column_labels
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :column_label
                    @test rs == :column_labels
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :column_labels

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :column_labels
            end

            # -- Table Data ----------------------------------------------------------------

            for i in 1:3
                if i == 2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :new_row
                    @test rs == :row_group_label
                    @test ps.i == i

                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :row_group_label
                    @test rs == :row_group_label
                    @test ps.i == i

                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :end_row
                    @test rs == :row_group_label
                    @test ps.i == i
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_label
                @test rs == :data
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :data
                    @test rs == :data
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :data

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :data
            end

            # -- Continuation Row ----------------------------------------------------------

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :continuation_row

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_number_vertical_continuation_cell
            @test rs == :continuation_row

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_label_vertical_continuation_cell
            @test rs == :continuation_row

            for j in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :vertical_continuation_cell
                @test rs == :continuation_row
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :diagonal_continuation_cell
            @test rs == :continuation_row

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :continuation_row

            # -- Table Summary -------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :summary_row
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_number
                @test rs == :summary_row
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_label
                @test rs == :summary_row
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :summary_row_cell
                    @test rs == :summary_row
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :summary_row

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :summary_row
            end

            # -- Table Footer --------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :table_footer

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :footnote
                @test ps.i == i
                @test rs == :table_footer

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :table_footer
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :source_notes
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :table_footer

            # -- End Printing --------------------------------------------------------------

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_printing

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_printing
        end

        @testset "Middle Vertical Cropping" begin
            # == Create the Table Data =====================================================

            summary_rows = [(data, i) -> i, (data, i) -> 2i]

            td = PrettyTables.TableData(;
                data                      = rand(6, 4),
                title                     = "Table Title",
                subtitle                  = "Table Subtitle",
                column_labels             = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
                stubhead_label            = "Stubhead Label",
                show_row_number_column    = true,
                row_number_column_label   = "Row Number",
                row_labels                = ["Row 1", "Row 2", "Row 3"],
                row_group_labels          = [2 => "Row Group 1", 6 => "Row Group 2"],
                summary_rows              = summary_rows,
                summary_row_labels        = PrettyTables.SummaryLabelIterator(summary_rows),
                footnotes                 = [(:data, 1, 1) => "Footnote", (:data, 2, 2) => "Footnote"],
                source_notes              = "Source Notes",
                num_rows                  = 6,
                num_columns               = 4,
                first_row_index           = 1,
                first_column_index        = 1,
                maximum_number_of_columns = 2,
                maximum_number_of_rows    = 3,
                vertical_crop_mode        = :middle,
            )

            # == Iterate the Printing Table State ==========================================

            ps = PrettyTables.PrintingTableState()

            # -- Table Header --------------------------------------------------------------

            for a in (:title, :subtitle)
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :table_header

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == a
                @test rs == :table_header

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :table_header
            end

            # -- Column Labels -------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :column_labels

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number_label
                @test rs == :column_labels
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :stubhead_label
                @test rs == :column_labels
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :column_label
                    @test rs == :column_labels
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :column_labels

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :column_labels
            end

            # -- Table Data ----------------------------------------------------------------

            for i in 1:2
                if i == 2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :new_row
                    @test rs == :row_group_label
                    @test ps.i == i

                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :row_group_label
                    @test rs == :row_group_label
                    @test ps.i == i

                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :end_row
                    @test rs == :row_group_label
                    @test ps.i == i
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_label
                @test rs == :data
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :data
                    @test rs == :data
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :data

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :data
            end

            # -- Continuation Row ----------------------------------------------------------

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :continuation_row

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_number_vertical_continuation_cell
            @test rs == :continuation_row

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :row_label_vertical_continuation_cell
            @test rs == :continuation_row

            for j in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :vertical_continuation_cell
                @test rs == :continuation_row
                @test ps.j == j
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :diagonal_continuation_cell
            @test rs == :continuation_row

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :continuation_row

            # -- Table Data (Remaining Rows) -----------------------------------------------

            let i = 6
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :row_group_label
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_group_label
                @test rs == :row_group_label
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :row_group_label
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_label
                @test rs == :data
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :data
                    @test rs == :data
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :data

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :data
            end

            # -- Table Summary -------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :summary_row
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_number
                @test rs == :summary_row
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_label
                @test rs == :summary_row
                @test ps.i == i

                for j in 1:2
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :summary_row_cell
                    @test rs == :summary_row
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :horizontal_continuation_cell
                @test rs == :summary_row

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :summary_row
            end

            # -- Table Footer --------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :table_footer

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :footnote
                @test ps.i == i
                @test rs == :table_footer

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :table_footer
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :source_notes
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :table_footer

            # -- End Printing --------------------------------------------------------------

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_printing

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_printing
        end

        @testset "Corner Cases of Vertical Cropping" begin
            # If the maximum number of rows / columns is equal to the number of rows /
            # columns, we should not print the continuation row.

            # == Create the Table Data =====================================================

            summary_rows = [(data, i) -> i, (data, i) -> 2i]

            td = PrettyTables.TableData(;
                data                      = rand(3, 4),
                title                     = "Table Title",
                subtitle                  = "Table Subtitle",
                column_labels             = [["1", "2", "3", "4"], ["1", "2", "3", "4"]],
                stubhead_label            = "Stubhead Label",
                show_row_number_column    = true,
                row_number_column_label   = "Row Number",
                row_labels                = ["Row 1", "Row 2", "Row 3"],
                summary_rows              = summary_rows,
                summary_row_labels        = PrettyTables.SummaryLabelIterator(summary_rows),
                footnotes                 = [(:data, 1, 1) => "Footnote", (:data, 2, 2) => "Footnote"],
                source_notes              = "Source Notes",
                num_rows                  = 3,
                num_columns               = 4,
                first_row_index           = 1,
                first_column_index        = 1,
                maximum_number_of_rows    = 3,
                maximum_number_of_columns = 4,
            )

            # == Iterate the Printing Table State ==========================================

            ps = PrettyTables.PrintingTableState()

            # -- Table Header --------------------------------------------------------------

            for a in (:title, :subtitle)
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :table_header

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == a
                @test rs == :table_header

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :table_header
            end

            # -- Column Labels -------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :column_labels

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number_label
                @test rs == :column_labels
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :stubhead_label
                @test rs == :column_labels
                @test ps.i == i

                for j in 1:4
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :column_label
                    @test rs == :column_labels
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :column_labels
            end

            # -- Table Data ----------------------------------------------------------------

            for i in 1:3
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_number
                @test rs == :data
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :row_label
                @test rs == :data
                @test ps.i == i

                for j in 1:4
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :data
                    @test rs == :data
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :data
            end

            # -- Table Summary -------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :summary_row
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_number
                @test rs == :summary_row
                @test ps.i == i

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :summary_row_label
                @test rs == :summary_row
                @test ps.i == i

                for j in 1:4
                    action, rs, ps = PrettyTables._next(ps, td)
                    @test action == :summary_row_cell
                    @test rs == :summary_row
                    @test ps.i == i
                    @test ps.j == j
                end

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :summary_row
            end

            # -- Table Footer --------------------------------------------------------------

            for i in 1:2
                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :new_row
                @test rs == :table_footer

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :footnote
                @test ps.i == i
                @test rs == :table_footer

                action, rs, ps = PrettyTables._next(ps, td)
                @test action == :end_row
                @test rs == :table_footer
            end

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :new_row
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :source_notes
            @test rs == :table_footer

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_row
            @test rs == :table_footer

            # -- End Printing --------------------------------------------------------------

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_printing

            action, rs, ps = PrettyTables._next(ps, td)
            @test action == :end_printing
        end
    end
end

## Description #############################################################################
#
# Private functions.
#
############################################################################################

"""
    _guess_column_labels(data) -> Vector{Vector{String}}

Guess the column label associated with `data` in case the user did not pass a default value.
"""
function _guess_column_labels(data::Union{ColumnTable, RowTable})
    column_labels = [string.(data.column_names)]
    sch           = Tables.schema(_get_data(data))

    if !isnothing(sch)
        types::Vector{String} = _compact_type_str.([sch.types...])
        push!(column_labels, types)
    end

    return column_labels
end

function _guess_column_labels(data::AbstractVecOrMat)
    # A vector without elements is treated as having no columns, exactly like in
    # `_pretty_table`. A matrix, on the other hand, always has `size(data, 2)` columns, even
    # when it has no rows at all.
    #
    # NOTE: This check must not be `isempty(data)`. Since `isempty` is length-based, it is
    # also true for a matrix with zero rows and a positive number of columns, which used to
    # produce an empty column label row that then failed the "one label per column"
    # validation.
    (data isa AbstractVector) && isempty(data) && return [String[]]

    return [parent(["Col. $i" for i in axes(data, 2)])]
end

function _guess_column_labels(::AbstractDict{K, V}) where {K, V}
    return [["Keys", "Values"], [_compact_type_str(K), _compact_type_str(V)]]
end

"""
    _preprocess_data(data::Any) -> Any

Preprocess the `data` for printing. This function throws an error if `data` is not supported
by PrettyTables.jl.
"""
Base.@nospecializeinfer function _preprocess_data(@nospecialize(data::AbstractVecOrMat))
    # If the data vector or matrix follows the Tables.jl API, we must use it directly.
    Tables.istable(data) &&
        return Tables.columnaccess(data) ? ColumnTable(data) : RowTable(data)

    return data
end

function _preprocess_data(dict::AbstractDict)
    return hcat(collect(keys(dict)), collect(values(dict)))
end

Base.@nospecializeinfer function _preprocess_data(@nospecialize(data::Any))
    # This is the fallback action to guess the column label. Hence, if data does not support
    # Tables.jl API, we must throw an error.
    !Tables.istable(data) &&
        error("`pretty_table` does not support objects of type `$(typeof(data))`.")
    return Tables.columnaccess(data) ? ColumnTable(data) : RowTable(data)
end

"""
    _process_merge_column_label_specification(column_labels::Vector{T}, num_columns::Int) where T <: AbstractVector -> Vector{Vector{Any}}, Vector{MergeCells}

Process the column label specification by replacing `MultiColumn` objects in `column_labels`
and adding the correct specification to `merge_column_label_cells`. This function returns
the new objects that must replace the old `column_labels` and the
`merge_column_label_cells`.

The number of columns in the table must be passed in `num_columns` so the function can verify
the correctness of the specification.
"""
function _process_merge_column_label_specification(
    column_labels::Vector{T}, num_columns::Int
) where {T <: AbstractVector}
    # We only need to process the column labels if we have elements of type `MultiColumn`
    # or `EmptyCells` in the column labels. Otherwise, we can return the current column
    # label, reducing the allocations.
    need_processing = false

    for line in column_labels
        for column in line
            if (column isa MultiColumn) || (column isa EmptyCells)
                need_processing = true
                break
            end
        end

        need_processing && break
    end

    !need_processing && return column_labels, nothing

    processed_column_labels = Vector{Vector{Any}}(undef, length(column_labels))

    merge_column_label_cells = MergeCells[]

    for l in eachindex(column_labels)
        column_label_line = Any[]
        line = column_labels[l]

        for c in eachindex(line)
            column = line[c]

            if column isa MultiColumn
                push!(
                    merge_column_label_cells,
                    MergeCells(
                        l,
                        length(column_label_line) + 1,
                        column.column_span,
                        column.data,
                        column.alignment,
                    ),
                )

                for _ in 1:(column.column_span)
                    push!(column_label_line, "")
                end

                continue

            elseif column isa EmptyCells
                for _ in 1:(column.number_of_cells)
                    push!(column_label_line, "")
                end

                continue
            end

            push!(column_label_line, column)
        end

        # Check if the number of processed columns is correct.
        npc = length(column_label_line)
        npc != num_columns && throw(
            ArgumentError(
                "The number of columns ($npc) obtained from the specifications in the line #$(l) of `column_labels` does not match the number of columns in the table ($num_columns).",
            ),
        )

        processed_column_labels[l] = column_label_line
    end

    return processed_column_labels, merge_column_label_cells
end

"""
    _validate_merge_cell_specification(table_data::TableData) -> Nothing

Validate the merge cell specification in `table_data`. If something is wrong, this function
throws an error.
"""
function _validate_merge_cell_specification(table_data::TableData)
    isnothing(table_data.merge_column_label_cells) && return nothing

    num_column_label_rows = length(table_data.column_labels)
    mc = table_data.merge_column_label_cells

    for i in eachindex(mc)
        mi = mc[i]

        mi_beg = mi.j
        mi_end = mi.j + mi.column_span - 1

        mi.column_span < 2 &&
            throw(ArgumentError("The specification #$i has a column span lower than 2."))

        mi.i < 1 && throw(
            ArgumentError(
                "The row index must be greater than 0 in the specification #$i for merging cells.",
            ),
        )

        mi.i > num_column_label_rows && throw(
            ArgumentError(
                "The row index is larger than the number of column label rows in the specification #$i for merging cells.",
            ),
        )

        mi.j < 1 && throw(
            ArgumentError(
                "The column index must be greater than 0 in the specification #$i for merging cells.",
            ),
        )

        mi.j > table_data.num_columns && throw(
            ArgumentError(
                "The column index is larger than the number of table columns in the specification #$i for merging cells.",
            ),
        )

        mi_end > table_data.num_columns && throw(
            ArgumentError(
                "The specification #$i for merging cells references a cell outside the table column range.",
            ),
        )

        for j in (i + 1):lastindex(mc)
            mj = mc[j]

            mi.i != mj.i && continue

            mj_beg = mj.j
            mj_end = mj.j + mj.column_span - 1

            ((mi_end >= mj_beg) && (mj_end >= mi_beg)) && throw(
                ArgumentError("The specifications #$i and #$j for merging cells overlap."),
            )
        end
    end

    return nothing
end

using Test
using PrettyTables

using Crayons
using LaTeXStrings
using Markdown
using OffsetArrays
using StyledStrings
using Tables
using XLSX
using Dates

# Force color output for tests to ensure ANSI escape codes are generated.
# This is needed because Crayons.jl may disable colors during precompilation or
# in non-TTY environments like CI.
Crayons.force_color(true)

############################################################################################
#                                   Types and Structures                                   #
############################################################################################

include("./types.jl")

############################################################################################
#                                          Tests                                           #
############################################################################################

@testset "Internal Functions" verbose = true begin
    include("./internal/cell_alignment.jl")
    include("./internal/cell_data.jl")
    include("./internal/performance.jl")
    include("./internal/print_state.jl")
end

@testset "Excel Back End Tests" verbose = true begin
    include("./backends/excel/alignment.jl")
    include("./backends/excel/column_headers.jl")
    include("./backends/excel/continuation_cells.jl")
    include("./backends/excel/files_and_sheets.jl")
    include("./backends/excel/fills.jl")
    include("./backends/excel/formats.jl")
    include("./backends/excel/formatters.jl")
    include("./backends/excel/heights_and_widths.jl")
    include("./backends/excel/highlighters.jl")
    include("./backends/excel/styles.jl")
end

@testset "HTML Back End Tests" verbose = true begin
    include("./backends/html/alignment.jl")
    include("./backends/html/cell_titles.jl")
    include("./backends/html/circular_reference.jl")
    include("./backends/html/column_width.jl")
    include("./backends/html/cropping.jl")
    include("./backends/html/decorations.jl")
    include("./backends/html/default.jl")
    include("./backends/html/divs.jl")
    include("./backends/html/footnotes.jl")
    include("./backends/html/full.jl")
    include("./backends/html/highlighters.jl")
    include("./backends/html/issues.jl")
    include("./backends/html/minify.jl")
    include("./backends/html/offset_arrays.jl")
    include("./backends/html/renderers.jl")
    include("./backends/html/special_cells.jl")
    include("./backends/html/stand_alone.jl")
end

@testset "LaTeX Back End Tests" verbose = true begin
    include("./backends/latex/alignment.jl")
    include("./backends/latex/circular_reference.jl")
    include("./backends/latex/cropping.jl")
    include("./backends/latex/decorations.jl")
    include("./backends/latex/default.jl")
    include("./backends/latex/full.jl")
    include("./backends/latex/highlighters.jl")
    include("./backends/latex/horizontal_lines.jl")
    include("./backends/latex/offset_arrays.jl")
    include("./backends/latex/renderers.jl")
    include("./backends/latex/special_cells.jl")
end

@testset "Markdown Back End Tests" verbose = true begin
    include("./backends/markdown/alignment.jl")
    include("./backends/markdown/circular_reference.jl")
    include("./backends/markdown/compact.jl")
    include("./backends/markdown/cropping.jl")
    include("./backends/markdown/decorations.jl")
    include("./backends/markdown/default.jl")
    include("./backends/markdown/footnotes.jl")
    include("./backends/markdown/full.jl")
    include("./backends/markdown/highlighters.jl")
    include("./backends/markdown/offset_arrays.jl")
    include("./backends/markdown/renderers.jl")
    include("./backends/markdown/special_cells.jl")
end

@testset "Text Back End Test" verbose = true begin
    include("./backends/text/alignment.jl")
    include("./backends/text/circular_reference.jl")
    include("./backends/text/column_widths.jl")
    include("./backends/text/cropping.jl")
    include("./backends/text/custom_cells.jl")
    include("./backends/text/decorations.jl")
    include("./backends/text/default.jl")
    include("./backends/text/errors.jl")
    include("./backends/text/footnotes.jl")
    include("./backends/text/full.jl")
    include("./backends/text/highlighters.jl")
    include("./backends/text/horizontal_lines.jl")
    include("./backends/text/issues.jl")
    include("./backends/text/line_breaks.jl")
    include("./backends/text/offset_arrays.jl")
    include("./backends/text/renderers.jl")
    include("./backends/text/special_cells.jl")
end

@testset "Typst Back End Tests" verbose = true begin
    include("./backends/typst/alignment.jl")
    include("./backends/typst/caption.jl")
    include("./backends/typst/circular_reference.jl")
    include("./backends/typst/data_column_widths.jl")
    include("./backends/typst/cropping.jl")
    include("./backends/typst/decorations.jl")
    include("./backends/typst/default.jl")
    include("./backends/typst/full.jl")
    include("./backends/typst/highlighters.jl")
    include("./backends/typst/horizontal_lines.jl")
    include("./backends/typst/minify.jl")
    include("./backends/typst/offset_arrays.jl")
    include("./backends/typst/renderers.jl")
    include("./backends/typst/special_cells.jl")
    include("./ext/pretty_tables_typstry_ext.jl")
end

@testset "Tables.jl" verbose = true begin
    include("./tables.jl")
end

@testset "General Tests" verbose = true begin
    include("./general.jl")
end

@testset "PrettyTable Structure" verbose = true begin
    include("./pretty_table_structure.jl")
end

@testset "Pre-defined Formatters" verbose = true begin
    include("./predefined_formatters.jl")
end

@testset "Errors" verbose = true begin
    include("./errors.jl")
end

## Description #############################################################################
#
# Typst Back End: Tests related to special cells.
#
############################################################################################

@testset "Special Cells" verbose = true begin
    backend = :typst

    @testset "Escaping of Typst Metacharacters" begin
        # Every character here carries a special meaning in Typst markup. Since the cell
        # content is emitted inside a content block (`[...]`), leaving any of them unescaped
        # either breaks the block or changes how the document is typeset.
        matrix = ["]" "[" "*" "_" "\$" "\\" "`" "@" "<" ">" "~" "#"]

        expected = """
#{
  table(
    align: (right, right, right, right, right, right, right, right, right, right, right, right,),
    columns: (auto, auto, auto, auto, auto, auto, auto, auto, auto, auto, auto, auto,),
    stroke: none,
    // == Horizontal Lines =================================================================
    table.hline(y: 0, stroke: 1.5pt,),
    table.hline(y: 1, stroke: 0.8pt,),
    table.hline(y: 2, stroke: 1.5pt,),
    // == Vertical Lines ===================================================================
    table.vline(x: 0, end: 2, stroke: 1.5pt),
    table.vline(x: 1, end: 2, stroke: 0.8pt),
    table.vline(x: 2, end: 2, stroke: 0.8pt),
    table.vline(x: 3, end: 2, stroke: 0.8pt),
    table.vline(x: 4, end: 2, stroke: 0.8pt),
    table.vline(x: 5, end: 2, stroke: 0.8pt),
    table.vline(x: 6, end: 2, stroke: 0.8pt),
    table.vline(x: 7, end: 2, stroke: 0.8pt),
    table.vline(x: 8, end: 2, stroke: 0.8pt),
    table.vline(x: 9, end: 2, stroke: 0.8pt),
    table.vline(x: 10, end: 2, stroke: 0.8pt),
    table.vline(x: 11, end: 2, stroke: 0.8pt),
    table.vline(x: 12, end: 2, stroke: 1.5pt),
    // == Table Header =====================================================================
    table.header(
      // -- Column Labels: Row 1 -----------------------------------------------------------
      [#text(weight: "bold",)[Col. 1]],
      [#text(weight: "bold",)[Col. 2]],
      [#text(weight: "bold",)[Col. 3]],
      [#text(weight: "bold",)[Col. 4]],
      [#text(weight: "bold",)[Col. 5]],
      [#text(weight: "bold",)[Col. 6]],
      [#text(weight: "bold",)[Col. 7]],
      [#text(weight: "bold",)[Col. 8]],
      [#text(weight: "bold",)[Col. 9]],
      [#text(weight: "bold",)[Col. 10]],
      [#text(weight: "bold",)[Col. 11]],
      [#text(weight: "bold",)[Col. 12]],
    ),
    // == Table Body =======================================================================
    // -- Data: Row 1 ----------------------------------------------------------------------
    [\\]],
    [\\[],
    [\\*],
    [\\_],
    [\\\$],
    [\\\\],
    [\\`],
    [\\@],
    [\\<],
    [\\>],
    [\\~],
    [\\#],
  )
}
"""

        result = pretty_table(String, matrix; backend)

        @test result == expected
    end

    @testset "Escaped Metacharacters Inside a Cell" begin
        # An unescaped `]` closes the content block early, whereas an unescaped `[` opens a
        # block that is never closed. Both silently corrupt the whole document.
        result = pretty_table(String, ["a]b" "c[d"]; backend)

        @test occursin("[a\\]b],", result)
        @test occursin("[c\\[d],", result)
    end
end

@testset "Non-Printable Characters" begin
    # Typst has no `\xNN` escape sequence, and its Unicode escape requires braces. Hence,
    # the non-printable characters must be emitted as `\u{...}`.
    result = pretty_table(String, ["a\x01b​c" ;;]; backend = :typst)

    @test occursin("[a\\u{1}b\\u{200b}c],", result)
end

@testset "Style Properties Are Not Markup Escaped" begin
    # The style properties are emitted in Typst code mode. Hence, applying the markup
    # escaping would corrupt values like `rgb("#ff0000")`.
    result = pretty_table(
        String,
        [1 2];
        backend = :typst,
        style = TypstTableStyle(; first_line_column_label = ["fill" => "rgb(\"#ff0000\")"]),
    )

    @test occursin("rgb(\"#ff0000\")", result)
end

@testset "Multiple Footnotes in the Same Cell" begin
    # All the footnote numbers must be inside the same superscript. Otherwise, the
    # separator would be rendered with the normal text size.
    result = pretty_table(
        String,
        [1 2];
        backend = :typst,
        footnotes = [(:data, 1, 1) => "A", (:data, 1, 1) => "B"],
    )

    @test occursin("#super[1,2]", result)
end

## Description #############################################################################
#
# Define the main function for printing tables.
#
############################################################################################

export pretty_table

function pretty_table(@nospecialize(data::Any); kwargs...)
    io = stdout isa Base.TTY ? IOContext(stdout, :limit => true) : stdout
    return pretty_table(io, data; kwargs...)
end

function pretty_table(
    ::Type{String}, @nospecialize(data::Any); color::Bool = false, kwargs...
)
    io = IOContext(IOBuffer(), :color => color, :displaysize => (-1, -1))
    pretty_table(io, data; kwargs...)
    return String(take!(io.io))
end

function pretty_table(::Type{HTML}, @nospecialize(data::Any); kwargs...)
    # If the keywords do not set the back end or the table format, use the HTML back end
    # by default.
    str = if !haskey(kwargs, :backend) && !haskey(kwargs, :table_format)
        pretty_table(String, data; backend = :html, kwargs...)
    else
        pretty_table(String, data; kwargs...)
    end

    return HTML(str)
end

# We declare this function with all the common keywords and after we call an internal
# function where all those keywords are arguments. In this case, we can use `@nospecialize`
# in the first two arguments. The other option would be to wrap the keywords inside a
# `kwargs...`. However, in the latter, we will not have keyword completion in REPL.
function pretty_table(
    io::IO,
    data::Any;
    backend::Symbol = :auto,

    # == Arguments for the IOContext =======================================================

    compact_printing::Bool = true,
    limit_printing::Bool = true,

    # == Arguments for the Printing Specification ==========================================

    show_omitted_cell_summary::Bool = true,
    renderer::Symbol = :print,

    # == Table Sections ====================================================================

    title::String = "",
    subtitle::String = "",
    stubhead_label::String = "",
    row_number_column_label::String = "Row",
    row_labels::Union{Nothing, AbstractVector} = nothing,
    row_group_labels::Union{Nothing, Vector{Pair{Int, String}}} = nothing,
    column_labels::Union{Nothing, AbstractVector} = nothing,
    show_column_labels::Bool = true,
    summary_rows::Union{Nothing, Vector{T} where T <: Any} = nothing,
    summary_row_labels::Union{Nothing, Vector{String}} = nothing,
    footnotes::Union{Nothing, Vector{Pair{FootnoteTuple, String}}} = nothing,
    source_notes::String = "",

    # == Alignments ========================================================================

    alignment::Union{Symbol, Vector{Symbol}} = :r,
    column_label_alignment::Union{Nothing, Symbol, Vector{Symbol}} = nothing,
    continuation_row_alignment::Union{Nothing, Symbol} = nothing,
    footnote_alignment::Symbol = :l,
    row_label_column_alignment::Symbol = :r,
    row_group_label_alignment::Symbol = :l,
    row_number_column_alignment::Symbol = :r,
    source_note_alignment::Symbol = :l,
    subtitle_alignment::Symbol = :c,
    title_alignment::Symbol = :c,
    cell_alignment::Union{
        Nothing, Vector{Pair{NTuple{2, Int}, Symbol}}, Vector{F} where F <: Function
    } = nothing,

    # == Other Configurations ==============================================================

    formatters::Union{Nothing, Vector{T} where T <: Any} = nothing,
    maximum_number_of_columns::Int = -1,
    maximum_number_of_rows::Int = -1,
    merge_column_label_cells::Union{Symbol, Vector{MergeCells}} = :auto,
    new_line_at_end::Bool = true,
    show_first_column_label_only::Bool = false,
    show_row_number_column::Bool = false,
    vertical_crop_mode::Symbol = :bottom,
    kwargs...,
)
    return _pretty_table(
        io,
        data,
        backend,

        # == Arguments for the IOContext ===================================================

        compact_printing,
        limit_printing,

        # == Arguments for the Printing Specification ======================================

        show_omitted_cell_summary,
        renderer,

        # == Table Sections ================================================================

        title,
        subtitle,
        stubhead_label,
        row_number_column_label,
        row_labels,
        row_group_labels,
        column_labels,
        show_column_labels,
        summary_rows,
        summary_row_labels,
        footnotes,
        source_notes,

        # == Alignments ====================================================================

        alignment,
        column_label_alignment,
        continuation_row_alignment,
        footnote_alignment,
        row_label_column_alignment,
        row_group_label_alignment,
        row_number_column_alignment,
        source_note_alignment,
        subtitle_alignment,
        title_alignment,

        # == Other Configurations ==========================================================

        cell_alignment,
        formatters,
        maximum_number_of_columns,
        maximum_number_of_rows,
        merge_column_label_cells,
        new_line_at_end,
        show_first_column_label_only,
        show_row_number_column,
        vertical_crop_mode;

        # == Other Keyword Arguments =======================================================

        kwargs...,
    )
end

# == PrettyTable Structure =================================================================

function pretty_table(pt::PrettyTable; kwargs...)
    io = stdout isa Base.TTY ? IOContext(stdout, :limit => true) : stdout
    return pretty_table(io, pt; kwargs...)
end

function pretty_table(@nospecialize(io::IO), pt::PrettyTable; kwargs...)
    # Get the named tuple with the configurations.
    dictkeys = (collect(keys(pt.configurations))...,)
    dictvals = (collect(values(pt.configurations))...,)
    nt = NamedTuple{dictkeys}(dictvals)

    return pretty_table(io, pt.data; merge(nt, kwargs)...)
end

function pretty_table(::Type{String}, pt::PrettyTable; color::Bool = false, kwargs...)
    # Get the named tuple with the configurations.
    dictkeys = (collect(keys(pt.configurations))...,)
    dictvals = (collect(values(pt.configurations))...,)
    nt = NamedTuple{dictkeys}(dictvals)

    return pretty_table(String, pt.data; color = color, merge(nt, kwargs)...)
end

function pretty_table(::Type{HTML}, pt::PrettyTable; kwargs...)
    # Get the named tuple with the configurations.
    dictkeys = (collect(keys(pt.configurations))...,)
    dictvals = (collect(values(pt.configurations))...,)
    nt = NamedTuple{dictkeys}(dictvals)

    return pretty_table(HTML, pt.data; merge(nt, kwargs)...)
end

function show(io::IO, pt::PrettyTable)
    backend = get(pt.configurations, :backend, :auto)

    if backend == :auto
        # If the backend is `:auto`, we need to resolve it from the `table_format` keyword.
        backend = _resolve_printing_backend(pt.configurations)
    end

    # For the text backend, we need to reserve one display line because the `show` function
    # adds a new line at the end.
    if backend == :text
        return pretty_table(io, pt; new_line_at_end = false, reserved_display_lines = 1)
    else
        return pretty_table(io, pt; new_line_at_end = false)
    end
end

############################################################################################
#                                         Private                                          #
############################################################################################

# This function converts the common keywords to positional arguments. Hence, we can use
# `@nospecialize` at the first two arguments, improving the time to print the first table.
Base.@nospecializeinfer function _pretty_table(
    @nospecialize(io::IO),
    @nospecialize(data::Any),
    backend::Symbol,

    # == Arguments for the IOContext =======================================================

    compact_printing::Bool,
    limit_printing::Bool,

    # == Arguments for the Printing Specification ==========================================

    show_omitted_cell_summary::Bool,
    renderer::Symbol,

    # == Table Sections ====================================================================

    title::String,
    subtitle::String,
    stubhead_label::String,
    row_number_column_label::String,
    row_labels::Union{Nothing, AbstractVector},
    row_group_labels::Union{Nothing, Vector{Pair{Int, String}}},
    column_labels::Union{Nothing, AbstractVector},
    show_column_labels::Bool,
    summary_rows::Union{Nothing, Vector{T} where T <: Any},
    summary_row_labels::Union{Nothing, Vector{String}},
    footnotes::Union{Nothing, Vector{Pair{FootnoteTuple, String}}},
    source_notes::String,

    # == Alignments ========================================================================

    alignment::Union{Symbol, Vector{Symbol}},
    column_label_alignment::Union{Nothing, Symbol, Vector{Symbol}},
    continuation_row_alignment::Union{Nothing, Symbol},
    footnote_alignment::Symbol,
    row_label_column_alignment::Symbol,
    row_group_label_alignment::Symbol,
    row_number_column_alignment::Symbol,
    source_note_alignment::Symbol,
    subtitle_alignment::Symbol,
    title_alignment::Symbol,

    # == Other Configurations ==============================================================

    cell_alignment::Union{
        Nothing, Vector{Pair{NTuple{2, Int}, Symbol}}, Vector{F} where F <: Function
    },
    formatters::Union{Nothing, Vector{T} where T <: Any},
    maximum_number_of_columns::Int,
    maximum_number_of_rows::Int,
    merge_column_label_cells::Union{Nothing, Symbol, Vector{MergeCells}},
    new_line_at_end::Bool,
    show_first_column_label_only::Bool,
    show_row_number_column::Bool,
    vertical_crop_mode::Symbol;
    kwargs...,
)

    # == Table Preprocessing ===============================================================

    # Check for circular dependency.
    ptd = get(io, :__PRETTY_TABLES__DATA__, nothing)

    if !isnothing(ptd)
        context = IOContext(io, :compact => compact_printing, :limit => limit_printing)

        # In this case, `ptd` is a vector with the data printed by PrettyTables.jl. Hence,
        # we need to search if the current one is inside this vector. If true, we have a
        # circular dependency.
        for d in ptd
            if d === data
                print(io, "#= circular reference =#")
                return nothing
            end
        end

        # Otherwise, we must push the current data to the vector. This action is performed
        # just before calling the printing backend so we can remove the data afterward.
    else
        context = IOContext(
            io,
            :__PRETTY_TABLES__DATA__ => Any[data],
            :compact                 => compact_printing,
            :limit                   => limit_printing,
        )
    end

    pdata = _preprocess_data(data)

    # == Check Inputs ======================================================================

    ax = axes(pdata)

    if length(ax) == 1
        num_rows = length(pdata)
        num_columns = num_rows > 0 ? 1 : 0

        first_row_index = first(first(ax))
        first_column_index = 1
    elseif length(ax) == 2
        num_rows, num_columns = size(pdata)

        first_row_index = first(first(ax))
        first_column_index = first(last(ax))
    else
        throw(
            ArgumentError(
                "`pretty_table` does not support data with more than 2 dimensions."
            ),
        )
    end

    # If we reach this point and `column_labels` is nothing, we must guess it.
    if isnothing(column_labels)
        column_labels = if pdata isa Union{ColumnTable, RowTable}
            _guess_column_labels(pdata)
        else
            _guess_column_labels(data)
        end
    end

    # If the element type of column labels is not an `AbstractVector`, we must wrap it into
    # a vector because the user probably only wants one row for the column label.
    if !(eltype(column_labels) <: AbstractVector)
        column_labels = [column_labels]
    end

    # If the user provided the `column_labels` and set `merge_column_label_cells` to
    # `:auto`, we will rebuild those two parameters to take into account the merged columns.
    local _merge_column_label_cells

    if merge_column_label_cells isa Symbol
        if merge_column_label_cells == :auto
            column_labels, _merge_column_label_cells = _process_merge_column_label_specification(
                column_labels, num_columns
            )
        else
            _merge_column_label_cells = nothing
        end
    else
        _merge_column_label_cells = merge_column_label_cells
    end

    # Check the column labels.
    for cl in column_labels
        length(cl) != num_columns && throw(
            ArgumentError(
                "Each vector in `column_labels` must have the same number of elements as the table columns ($num_columns).",
            ),
        )
    end

    if (renderer != :print) && (renderer != :show)
        throw(ArgumentError("The renderer must be `:print` or `:show`."))
    end

    if (alignment isa AbstractVector) && (length(alignment) != num_columns)
        throw(
            ArgumentError(
                "The length of vector `alignment` ($(length(alignment))) must be equal to the number of columns ($num_columns).",
            ),
        )
    end

    if cell_alignment isa Vector{Pair{NTuple{2, Int}, Symbol}}
        # If it is a `Vector{Pair{NTuple{2, Int}, Symbol}}`, it contains a set of `(i, j) =>
        # alignment` with the desired `alignment` for the cell `(i, j)`. Thus, we need to
        # create a wrapper function.
        cell_alignment_vect = copy(cell_alignment)

        cell_alignment = [(_, i, j) -> begin
            for p in cell_alignment_vect
                if first(p) == (i, j)
                    return last(p)
                end
            end

            return nothing
        end]
    end

    if isnothing(column_label_alignment)
        column_label_alignment = alignment
    end

    if !isnothing(summary_rows) && !isnothing(summary_row_labels)
        length(summary_rows) != length(summary_row_labels) && throw(
            ArgumentError(
                "The length of `summary_rows` ($(length(summary_rows))) must be equal to the length of `summary_row_labels` ($(length(summary_row_labels))).",
            ),
        )
    end

    if !isnothing(summary_rows) && isnothing(summary_row_labels)
        summary_row_labels = SummaryLabelIterator(summary_rows)
    end

    if show_first_column_label_only
        column_labels = [column_labels[1]]

        # The merged cell specification can reference the dropped column label rows. Hence,
        # we must keep only the specifications related to the first one.
        if !isnothing(_merge_column_label_cells)
            _merge_column_label_cells = filter(m -> m.i == 1, _merge_column_label_cells)
        end
    end

    # If the difference between the `maximum_number_of_rows` and the actual number of
    # rows is less than or equal to 1, we will not crop the table because we need one
    # additional line to show the continuation marks.
    if (maximum_number_of_rows > 0) && (num_rows == maximum_number_of_rows + 1)
        maximum_number_of_rows = maximum_number_of_rows + 1
    end

    # == Table Data and Printing Specification =============================================

    table_data = TableData(
        pdata,
        title,
        subtitle,
        stubhead_label,
        show_row_number_column,
        row_number_column_label,
        column_labels,
        show_column_labels,
        row_labels,
        row_group_labels,
        summary_rows,
        summary_row_labels,
        _merge_column_label_cells,
        footnotes,
        source_notes,
        title_alignment,
        subtitle_alignment,
        cell_alignment,
        column_label_alignment,
        continuation_row_alignment,
        alignment,
        row_number_column_alignment,
        row_label_column_alignment,
        row_group_label_alignment,
        footnote_alignment,
        source_note_alignment,
        formatters,
        num_rows,
        num_columns,
        first_row_index,
        first_column_index,
        maximum_number_of_columns,
        maximum_number_of_rows,
        vertical_crop_mode,
    )

    _validate_merge_cell_specification(table_data)

    pspec = PrintingSpec(
        context, table_data, renderer, show_omitted_cell_summary, new_line_at_end
    )

    # If backend is `:auto`, obtain the backend from the `table_format` keyword. If it does
    # not exist, use `:text`.
    if backend == :auto
        backend = _resolve_printing_backend(kwargs)
    end

    # When wrapping `stdout` in `IOContext`, sometimes `io.io` is not equal to `stdout`
    # anymore. Hence, we need to check if `io` is `stdout` before calling the backend
    # functions.
    is_stdout = (io === stdout) || ((io isa IOContext) && (io.io === stdout))

    # Register the current data in the circular reference vector while printing, removing
    # it afterward. Hence, only the ancestors of the current table stay in the vector,
    # avoiding false positives when the same object appears in two different cells.
    !isnothing(ptd) && push!(ptd, data)

    try
        # Call the printing backend.
        if backend == :excel
            return _printing_backend(Val(backend), pspec; is_stdout, kwargs...)
        else
            _printing_backend(Val(backend), pspec; is_stdout, kwargs...)
        end
    finally
        !isnothing(ptd) && pop!(ptd)
    end

    return nothing
end

"""
    _printing_backend(::Val{backend}, pspec::PrintingSpec; is_stdout::Bool, kwargs...)

Call the appropriate printing `backend` using the printing specification `pspec`. The
keyword argument `is_stdout` is `true` if the user wants to output the table to the
`stdout`.
"""
function _printing_backend(::Val{:latex}, pspec::PrintingSpec; is_stdout::Bool, kwargs...)
    _latex__print(pspec; kwargs...)
    return nothing
end

function _printing_backend(::Val{:html}, pspec::PrintingSpec; is_stdout::Bool, kwargs...)
    _html__print(pspec; is_stdout, kwargs...)
    return nothing
end

function _printing_backend(::Val{:typst}, pspec::PrintingSpec; is_stdout::Bool, kwargs...)
    _typst__print(pspec; is_stdout, kwargs...)
    return nothing
end

function _printing_backend(::Val{:excel}, pspec::PrintingSpec; is_stdout::Bool, kwargs...)
    return _excel__print(pspec; kwargs...)
end

function _printing_backend(
    ::Val{:markdown}, pspec::PrintingSpec; is_stdout::Bool, kwargs...
)
    _markdown__print(pspec; kwargs...)
    return nothing
end

function _printing_backend(::Val{:text}, pspec::PrintingSpec; is_stdout::Bool, kwargs...)
    _text__print_table(pspec; kwargs...)
    return nothing
end

## == Custom Backend Functions =============================================================

export pretty_table_html_backend
export pretty_table_latex_backend
export pretty_table_markdown_backend
export pretty_table_text_backend
export pretty_table_typst_backend
export pretty_table_excel_backend

function pretty_table_text_backend(args...; kwargs...)
    return pretty_table(args...; backend = :text, kwargs...)
end

function pretty_table_latex_backend(args...; kwargs...)
    return pretty_table(args...; backend = :latex, kwargs...)
end

function pretty_table_markdown_backend(args...; kwargs...)
    return pretty_table(args...; backend = :markdown, kwargs...)
end

function pretty_table_html_backend(args...; kwargs...)
    return pretty_table(args...; backend = :html, kwargs...)
end

function pretty_table_typst_backend(args...; kwargs...)
    return pretty_table(args...; backend = :typst, kwargs...)
end

function pretty_table_excel_backend(args...; kwargs...)
    return pretty_table(args...; backend = :excel, kwargs...)
end

## Description #############################################################################
#
# Functions to retrieve table information.
#
############################################################################################

"""
    _column_label_limits(table_data::TableData, i::Int, j::Int) -> Tuple{Int, Int}

Return the limits of the column label cell at `(i, j)` in `table_data`. If the cell is not
merged, the limits are just `(j, j)`. If the cell is merged, the limits are the start and
end of the merged cell, which is defined by the `merge_column_label_cells` field of
`table_data`.
"""
function _column_label_limits(table_data::TableData, i::Int, j::Int)
    isnothing(table_data.merge_column_label_cells) && return j, j

    # Check if we are in a merged column.
    for mc in table_data.merge_column_label_cells
        if mc.i == i && (mc.j <= j <= mc.j + mc.column_span - 1)
            return mc.j, mc.j + mc.column_span - 1
        end
    end

    # If we are not in a merged column, the limits are just the cell itself.
    return j, j
end

"""
    _current_table_row_section_info(rs::Symbol, action::Symbol, i::Number) -> String

Generate a descriptive string for the current table row section specified by the `rs` and
`action` parameters, along with the row index `i`.
"""
function _current_table_row_section_info(rs::Symbol, action::Symbol, i::Number)
    section = get(_TABLE_ROW_SECTION_NAMES, rs, "Unknown Section")
    section_desc = "Row $i"

    if rs == :table_header
        # NOTE: The `else` branches are required. Without them the chain evaluates to
        # `nothing` for any other action, and the `isempty` below would throw a `MethodError`
        # instead of returning the `String` this function promises.
        section_desc = if action == :title
            "Title"
        elseif action == :subtitle
            "Subtitle"
        else
            ""
        end

    elseif rs == :table_footer
        section_desc = if action == :footnote
            "Footnote $i"
        elseif action == :source_notes
            "Source Notes"
        else
            ""
        end

    elseif rs == :continuation_row
        section_desc = ""
    end

    return isempty(section_desc) ? section : "$section: $section_desc"
end

"""
    _has_footnotes(table_data::TableData) -> Bool

Return whether `table_data` has footnotes.
"""
function _has_footnotes(table_data::TableData)
    return !isnothing(table_data.footnotes)
end

"""
    _has_merged_cells(table_data::TableData, i::Int) -> Bool

Return whether `table_data` has merged cells in line `i`.
"""
function _has_merged_cells(table_data::TableData, i::Int)
    isnothing(table_data.merge_column_label_cells) && return false

    for mc in table_data.merge_column_label_cells
        mc.i == i && return true
    end

    return false
end

"""
    _has_row_group_labels(table_data::TableData)

Return whether `table_data` has row group labels.
"""
function _has_row_group_labels(table_data::TableData)
    return !isnothing(table_data.row_group_labels)
end

"""
    _has_row_labels(table_data::TableData) -> Bool

Return whether `table_data` has row labels.
"""
function _has_row_labels(table_data::TableData)
    return !isnothing(table_data.row_labels) || _has_summary_rows(table_data)
end

"""
    _has_summary_rows(table_data::TableData) -> Bool

Return whether `table_data` has summary rows.
"""
_has_summary_rows(table_data::TableData) = !isnothing(table_data.summary_rows)

"""
    _is_horizontally_cropped(table_data::TableData) -> Bool

Return whether `table_data` is horizontally cropped, meaning that a continuation column must
be printed.
"""
function _is_horizontally_cropped(table_data::TableData)
    return table_data.maximum_number_of_columns > 0 ?
           table_data.num_columns > table_data.maximum_number_of_columns : false
end

"""
    _is_column_label_cell_merged(table_data::TableData, i::Int, j::Int) -> Bool

Return whether the cell at `(i, j)` is a merged column label cell.
"""
function _is_column_label_cell_merged(table_data::TableData, i::Int, j::Int)
    j₀, j₁ = _column_label_limits(table_data, i, j)
    return j₀ != j₁
end

"""
    _is_vertically_cropped(table_data::TableData) -> Bool

Return whether `table_data` is vertically cropped, meaning that a continuation row must be
printed.
"""
function _is_vertically_cropped(table_data::TableData)
    # NOTE: For rows, `maximum_number_of_rows == 0` means "crop to zero rows", whereas a
    # negative value means "no limit". This is the convention `_next` and
    # `_number_of_printed_data_rows` use. Testing for `> 0` here made a table cropped to zero
    # rows be reported as not cropped, so the data columns were sized without accounting for
    # the continuation row.
    return table_data.maximum_number_of_rows >= 0 ?
           table_data.num_rows > table_data.maximum_number_of_rows : false
end

"""
    _number_of_printed_columns(table_data::TableData) -> Int

Return the number of printed columns in `table_data`, which includes the continuation column.
"""
function _number_of_printed_columns(table_data::TableData)
    # NOTE: `maximum_number_of_columns <= 0` means "no limit", exactly like in `_next` and in
    # `_number_of_printed_data_columns`. Testing for `>= 0` here made a `0` be treated as
    # "crop to a single column", so the back ends laid out one column while the iterator fed
    # them all of them.
    data_columns =
        table_data.maximum_number_of_columns > 0 ?
        # If we are cropping the table, we have one additional column for the continuation
        # characters.
        min(table_data.maximum_number_of_columns + 1, table_data.num_columns) :
        table_data.num_columns

    total_columns =
        data_columns +
        table_data.show_row_number_column +
        (!isnothing(table_data.row_labels) || !isnothing(table_data.summary_row_labels))

    return total_columns
end

"""
    _number_of_printed_data_columns(table_data::TableData) -> Int

Return the number of printed data columns.
"""
function _number_of_printed_data_columns(table_data::TableData)
    data_columns =
        table_data.maximum_number_of_columns > 0 ?
        min(table_data.maximum_number_of_columns, table_data.num_columns) :
        table_data.num_columns

    return data_columns
end

"""
    _number_of_printed_data_rows(table_data::TableData) -> Int

Return the number of printed data rows.
"""
function _number_of_printed_data_rows(table_data::TableData)
    data_rows =
        table_data.maximum_number_of_rows >= 0 ?
        min(table_data.maximum_number_of_rows, table_data.num_rows) : table_data.num_rows

    return data_rows
end

"""
    _print_row_group_label(table_data::TableData, i::Int) -> Bool

Return whether we must print a row group label of `table_data` in line `i`.
"""
function _print_row_group_label(table_data::TableData, i::Int)
    !_has_row_group_labels(table_data) && return false

    for rg in table_data.row_group_labels
        first(rg) == i && return true
    end

    return false
end

## Description #############################################################################
#
# Excel Back End: Test use of files and sheets.
#
############################################################################################

@testset "Files and Sheets" verbose = true begin

    # == Creating and Reading Tables =======================================================

    @testset "Creating and Reading Tables" verbose = true begin
        data = [1 2; 3 4]

        f = pretty_table(data; backend = :excel)
        @test f isa XLSX.XLSXFile
        @test f["prettytable"]["A1:B1"] == Any["Col. 1" "Col. 2"]
        @test f["prettytable"]["A2:B3"] == data

        f = pretty_table(data; backend = :excel, filename = "test.xlsx")
        @test f == "test.xlsx"
        @test isfile(f) === true

        xlsx = XLSX.readxlsx("test.xlsx")
        @test xlsx["prettytable"]["A1:B1"] == Any["Col. 1" "Col. 2"]
        @test xlsx["prettytable"]["A2:B3"] == data
    end

    # == File Modes ========================================================================

    @testset "File Modes" verbose = true begin
        data = [1 2; 3 4]

        @test_throws ErrorException pretty_table(
            data; backend = :excel, filename = "test.xlsx", mode = "w"
        )

        @test_throws ArgumentError pretty_table(
            data; backend = :excel, filename = "test.xlsx", mode = "r"
        )

        data2 = [7 8; 9 0]
        f = pretty_table(
            data2; backend = :excel, filename = "test.xlsx", mode = "w", overwrite = true
        )
        @test f == "test.xlsx"

        data3 = [5 6; 7 8]
        f = pretty_table(data3; backend = :excel, filename = "test.xlsx", mode = "rw")
        @test f isa XLSX.XLSXFile
        @test f["prettytable"]["A1:B1"] == Any["Col. 1" "Col. 2"]
        @test f["prettytable"]["A2:B3"] == data3

        writexlsx("test.xlsx", f; overwrite = true)
    end

    # == Anchor Cells ======================================================================

    @testset "Anchor Cells" verbose = true begin
        data = [1 2; 3 4]
        data3 = [5 6; 7 8]

        f = pretty_table(
            data; backend = :excel, filename = "test.xlsx", mode = "rw", anchor_cell = "D1"
        )
        @test f isa XLSX.XLSXFile
        @test f["prettytable"]["A1:B1"] == Any["Col. 1" "Col. 2"]
        @test f["prettytable"]["A2:B3"] == data3
        @test f["prettytable"]["D1:E1"] == Any["Col. 1" "Col. 2"]
        @test f["prettytable"]["D2:E3"] == data
    end

    # == XLSX Worksheets ===================================================================

    @testset "XLSX Worksheets" verbose = true begin
        data = [1 2; 3 4]
        data3 = [5 6; 7 8]

        f = openxlsx("test.xlsx"; mode = "rw")
        newf = pretty_table(
            data; backend = :excel, sheet = XLSX.addsheet!(f, "newsheet"), mode = "rw"
        )
        @test isnothing(newf) === true
        @test XLSX.hassheet(f, "prettytable")
        @test XLSX.hassheet(f, "newsheet")
        @test f["prettytable"]["A1:B1"] == Any["Col. 1" "Col. 2"]
        @test f["prettytable"]["A2:B3"] == data3
        @test f["newsheet"]["A1:B1"] == Any["Col. 1" "Col. 2"]
        @test f["newsheet"]["A2:B3"] == data

        @test_throws ArgumentError pretty_table(
            data;
            backend = :excel,
            filename = "test.xlsx",
            sheet = f["newsheet"],
            mode = "rw",
        )
    end

    # == Cleanup ===========================================================================

    isfile("test.xlsx") && rm("test.xlsx"; force = true)
end

@testset "Tables Without Data Rows" begin
    # The outer border logic used a fallback that computed a row above the first table row,
    # throwing an `XLSXError` for tables without data and summary rows.
    result = pretty_table(XLSX.XLSXFile, Matrix{Float64}(undef, 0, 3))
    @test result[1]["A1"] == "Col. 1"

    result = pretty_table(
        XLSX.XLSXFile, Matrix{Float64}(undef, 0, 3); anchor_cell = "B3"
    )
    @test result[1]["B3"] == "Col. 1"

    result = pretty_table(
        XLSX.XLSXFile, Matrix{Float64}(undef, 0, 3); show_column_labels = false
    )
    @test ismissing(result[1]["A1"])
end

## Description #############################################################################
#
# Private functions for the markdown back end.
#
############################################################################################

# == Alignment =============================================================================

"""
    _markdown__column_alignment_str(column_width::Int, alignment::Symbol) -> String

Compose the markdown `alignment` string given a column with width `column_width`. The
possible values for `alignment` are:

- `:l`: Left alignment.
- `:c`: Center alignment.
- `:r`: Right alignment.
- `:n`: No alignment information will be added to the string.
"""
function _markdown__column_alignment_str(column_width::Int, alignment::Symbol)
    if alignment ∈ (:l, :L)
        return ":" * "-"^(column_width - 1)
    elseif alignment ∈ (:c, :C)
        return ":" * "-"^(column_width - 2) * ":"
    elseif alignment ∈ (:r, :R)
        return "-"^(column_width - 1) * ":"
    else
        return "-"^(column_width)
    end
end

"""
    _markdown__alignment(a::Symbol) -> Symbol

Normalize the alignment symbol `a` to its lowercase form, so that the Markdown back end
accepts `:L`, `:C`, and `:R` exactly like the HTML, LaTeX, and Typst back ends do.
"""
function _markdown__alignment(a::Symbol)
    a === :L && return :l
    a === :C && return :c
    a === :R && return :r
    return a
end

"""
    _markdown__print_aligned(
        buf::IOContext,
        str::String,
        cell_width::Int,
        alignment::Symbol
    ) -> Nothing

Print `str` to the buffer `buf` with `alignment` considering the `cell_width`.
"""
function _markdown__print_aligned(
    buf::IOContext, str::String, cell_width::Int, alignment::Symbol
)
    print(buf, align_string(str, cell_width, _markdown__alignment(alignment); fill = true))
    return nothing
end

"""
    _markdown__print_header_separator(
        buf::IOContext,
        table_data::TableData,
        row_number_column_width::Int,
        row_label_column_width::Int,
        printed_data_column_widths::Vector{Int}
    ) -> Nothing

Print the markdown header separator with the column alignment information.

# Arguments

- `buf::IOContext`: Buffer where the separator will be printed.
- `table_data::TableData`: Table data.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Widths of the printed data columns.
"""
function _markdown__print_header_separator(
    buf::IOContext,
    table_data::TableData,
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
)
    print(buf, "|")

    # == Row Number Column =================================================================

    if table_data.show_row_number_column
        a = _row_number_column_alignment(table_data)
        print(buf, _markdown__column_alignment_str(row_number_column_width + 2, a))
        print(buf, "|")
    end

    # == Row Labels ========================================================================

    if _has_row_labels(table_data)
        a = _row_label_column_alignment(table_data)
        print(buf, _markdown__column_alignment_str(row_label_column_width + 2, a))
        print(buf, "|")
    end

    # == Data ==============================================================================

    for i in eachindex(printed_data_column_widths)
        a = _data_column_alignment(table_data, i)
        print(buf, _markdown__column_alignment_str(printed_data_column_widths[i] + 2, a))
        print(buf, "|")
    end

    # == Continuation Column ===============================================================

    if _is_horizontally_cropped(table_data)
        print(buf, _markdown__column_alignment_str(3, :n))
        print(buf, "|")
    end

    println(buf)

    return nothing
end

# == Rows ==================================================================================

"""
    _markdown__print_row_group_line(
        buf::IOContext,
        row_group_label::String,
        table_data::TableData,
        char::Char,
        row_number_column_width::Int,
        row_label_column_width::Int,
        printed_data_column_widths::Vector{Int}
    ) -> Nothing

Print the row group line to `buf`.

# Arguments

- `buf::IOContext`: Buffer where the separator will be printed.
- `row_group_label::String`: Row group label.
- `table_data::TableData`: Table data.
- `char::Char`: Character used for the separation line.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Widths of the printed data columns.
"""
function _markdown__print_row_group_line(
    buf::IOContext,
    row_group_label::String,
    table_data::TableData,
    char::Char,
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
)

    # Check the initial column.
    cell_width = if table_data.show_row_number_column
        row_number_column_width
    elseif _has_row_labels(table_data)
        row_label_column_width
    else
        first(printed_data_column_widths)
    end

    # == Row Group Label ===================================================================

    print(buf, " ")
    print(buf, rpad(row_group_label, cell_width))
    print(buf, " |")

    # == Fill the Rest of the Cells ========================================================

    if table_data.show_row_number_column
        if _has_row_labels(table_data)
            print(buf, " ")
            print(buf, repeat(char, row_label_column_width))
            print(buf, " |")
        end

        print(buf, " ")
        print(buf, repeat(char, first(printed_data_column_widths)))
        print(buf, " |")

    elseif _has_row_labels(table_data)
        print(buf, " ")
        print(buf, repeat(char, first(printed_data_column_widths)))
        print(buf, " |")
    end

    for i in eachindex(printed_data_column_widths)[2:end]
        print(buf, " ")
        print(buf, repeat(char, printed_data_column_widths[i]))
        print(buf, " |")
    end

    # == Continuation Column ===============================================================

    _is_horizontally_cropped(table_data) && print(buf, " ⋯ |")

    return nothing
end

"""
    _markdown__print_separation_line(
        buf::IOContext,
        table_data::TableData,
        char::Char,
        row_number_column_width::Int,
        row_label_column_width::Int,
        printed_data_column_widths::Vector{Int}
    ) -> Nothing

Print a row separation line to `buf`.

# Arguments

- `buf::IOContext`: Buffer where the separator will be printed.
- `table_data::TableData`: Table data.
- `char::Char`: Character used for the separation line.
- `row_number_column_width::Int`: Row number column width.
- `row_label_column_width::Int`: Row label column width.
- `printed_data_column_widths::Vector{Int}`: Widths of the printed data columns.
"""
function _markdown__print_separation_line(
    buf::IOContext,
    table_data::TableData,
    char::Char,
    row_number_column_width::Int,
    row_label_column_width::Int,
    printed_data_column_widths::Vector{Int},
)
    print(buf, "|")

    # == Row Number Column =================================================================

    if table_data.show_row_number_column
        print(buf, " ")
        print(buf, repeat(char, row_number_column_width))
        print(buf, " |")
    end

    # == Row Label Column ==================================================================

    if _has_row_labels(table_data)
        print(buf, " ")
        print(buf, repeat(char, row_label_column_width))
        print(buf, " |")
    end

    # == Data ==============================================================================

    for w in printed_data_column_widths
        print(buf, " ")
        print(buf, repeat(char, w))
        print(buf, " |")
    end

    # == Continuation Column ===============================================================

    _is_horizontally_cropped(table_data) && print(buf, " ", char, " |")

    println(buf)

    return nothing
end

# == Strings ===============================================================================

# ASCII characters that carry a special meaning inside a Markdown table cell and, hence, must
# be escaped with a backslash. Notice that `[` and `]` are particularly important because the
# back end itself emits `[^N]` footnote references, meaning that unescaped user data can
# collide with the generated markup, whereas `<` and `>` would otherwise be interpreted as
# raw HTML or as an autolink.
#
# `#` and `!` are deliberately **not** escaped. `#` only starts an ATX heading at the
# beginning of a line, which cannot happen inside a cell, and escaping it would corrupt the
# `#= circular reference =#` and `#undef` sentinels this package emits. `!` is only special
# when immediately followed by `[`, which is already escaped.
const _MARKDOWN__ESCAPED_CHARACTERS = ('*', '_', '~', '`', '|', '[', ']', '<', '>')

raw"""
    _markdown__escape_str(
        @nospecialize(io::IO),
        s::AbstractString,
        replace_newline::Bool,
        escape_markdown_chars::Bool
    ) -> Nothing
    _markdown__escape_str(
        s::AbstractString,
        replace_newline::Bool,
        escape_markdown_chars::Bool
    ) -> String

Print the string `s` in `io` escaping the characters for the markdown back end. If `io` is
omitted, the escaped string is returned.

If `replace_newline` is `true`, `\n` is replaced with `<br>`. Otherwise, it is escaped,
leading to `\n`.

If `escape_markdown_chars` is `true`, the characters in `_MARKDOWN__ESCAPED_CHARACTERS`
(`*`, `_`, `~`, `` ` ``, `|`, `[`, `]`, `<`, and `>`) will be escaped, as well as the
backslash itself.
"""
function _markdown__escape_str(
    io::IO, s::AbstractString, replace_newline::Bool, escape_markdown_chars::Bool
)
    a = Iterators.Stateful(s)
    for c in a
        if isascii(c)
            c == '\n'         ? print(io, replace_newline ? "<br>" : "\\n") :
            c == '\\'         ? print(io, escape_markdown_chars ? "\\\\" : "\\") :
            c ∈ _MARKDOWN__ESCAPED_CHARACTERS ?
                (escape_markdown_chars ? print(io, '\\', c) : print(io, c)) :
            '\a' <= c <= '\r' ? print(io, "\\", "abtnvfr"[Int(c) - 6]) :
            isprint(c)        ? print(io, c) :
            print(io, "\\x", string(UInt32(c); base = 16, pad = 2))
        elseif !Base.isoverlong(c) && !Base.ismalformed(c)
            isprint(c)    ? print(io, c) :
            c <= '\x7f'   ? print(io, "\\x", string(UInt32(c); base = 16, pad = 2)) :
            c <= '\uffff' ? print(io, "\\u", string(UInt32(c); base = 16, pad = Base.need_full_hex(peek(a)) ? 4 : 2)) :
            print(io, "\\U", string(UInt32(c); base = 16, pad = Base.need_full_hex(peek(a)) ? 8 : 4))
        else # malformed or overlong
            u = bswap(reinterpret(UInt32, c))
            while true
                print(io, "\\x", string(u % UInt8; base = 16, pad = 2))
                (u >>= 8) == 0 && break
            end
        end
    end
end

function _markdown__escape_str(
    s::AbstractString, replace_newline::Bool, escape_markdown_chars::Bool
)
    return sprint(
        _markdown__escape_str,
        s,
        replace_newline,
        escape_markdown_chars;
        sizehint = lastindex(s),
    )
end

# == Style =================================================================================

"""
    _markdown__apply_style(s::MarkdownStyle, str::String) -> String

Apply the markdown style `s` to `str`.
"""
function _markdown__apply_style(s::MarkdownStyle, str::String)
    isempty(str) && return str
    # NOTE: `code` must be applied innermost because a Markdown code span renders its
    # content verbatim. Otherwise, the `bold`, `italic`, and `strikethrough` markers would
    # be shown literally to the user.
    s.code && (str = "`" * str * "`")
    s.bold && (str = "**" * str * "**")
    s.italic && (str = "*" * str * "*")
    s.strikethrough && (str = "~~" * str * "~~")

    return str
end

"""
    _markdown__style_textwidth(s::MarkdownStyle) -> Int

Return the additional textwidth required to apply the markdown style `s`.
"""
function _markdown__style_textwidth(s::MarkdownStyle)
    Δ = 0
    s.bold && (Δ += 4)
    s.italic && (Δ += 2)
    s.strikethrough && (Δ += 4)
    s.code && (Δ += 2)

    return Δ
end

## Description #############################################################################
#
# Typst back end of PrettyTables.jl
#
############################################################################################

function _typst__print(
    pspec::PrintingSpec;
    annotate::Bool = true,
    caption::Union{Nothing, String, TypstCaption} = nothing,
    data_column_widths::Union{Nothing, String, Vector{String}, Vector{Pair{Int, String}}} = nothing,
    highlighters::Vector{TypstHighlighter} = TypstHighlighter[],
    is_stdout::Bool = false,
    minify::Bool = false,
    style::TypstTableStyle = TypstTableStyle(),
    table_format::TypstTableFormat = TypstTableFormat(),
    wrap_column::Integer = 92,
)
    context    = pspec.context
    table_data = pspec.table_data
    # NOTE: `Val(pspec.renderer)` infers to the abstract `Val` because
    # `pspec.renderer` is a `Symbol`. Branching here keeps the renderer concrete, so the
    # per-cell rendering calls are statically dispatched.
    renderer   = pspec.renderer === :show ? Val(:show) : Val(:print)
    tf         = table_format

    ps     = PrintingTableState()
    buf_io = IOBuffer()
    buf    = IOContext(buf_io, context)

    # Reusable render buffer: one allocation per table instead of three per cell.
    rctx = RenderContext(context)

    buf_hlines = IOBuffer()
    buf_tc     = IOBuffer()

    # Check inputs.
    if data_column_widths isa Vector{String}
        nc = _number_of_printed_data_columns(table_data)
        length(data_column_widths) < nc && throw(
            ArgumentError(
                "The length of `data_column_widths` must be equal to or larger than the number of printed columns ($nc).",
            ),
        )

    elseif data_column_widths isa String
        data_column_widths = Base.Iterators.repeated(
            data_column_widths, table_data.num_columns
        )

    elseif data_column_widths isa Vector{Pair{Int, String}}
        dc = data_column_widths
        data_column_widths = Base.Generator(
            i -> begin
                id = findfirst(==(i), first.(dc))
                isnothing(id) && return "auto"
                return last(dc[id])
            end, 1:(table_data.num_columns)
        )
    end

    # If `minify` is `true`, we do not wrap lines.
    if minify
        wrap_column = -1
    end

    # Process the horizontal lines at data rows.
    if tf.horizontal_lines_at_data_rows isa Symbol
        horizontal_lines_at_data_rows = if tf.horizontal_lines_at_data_rows == :all
            1:(table_data.num_rows)
        else
            1:0
        end
    else
        horizontal_lines_at_data_rows = tf.horizontal_lines_at_data_rows::Vector{Int}
    end

    # Process the vertical lines at data columns.
    if tf.vertical_lines_at_data_columns isa Symbol
        vertical_lines_at_data_columns = if tf.vertical_lines_at_data_columns == :all
            1:(table_data.num_columns)
        else
            1:0
        end
    else
        vertical_lines_at_data_columns = tf.vertical_lines_at_data_columns::Vector{Int}
    end

    # Create dictionaries to store properties to decrease the number of allocations.
    vproperties = Pair{String, String}[]

    # Check if the user wants the omitted cell summary.
    ocs = _omitted_cell_summary(table_data, pspec)
    ocs_printed = false

    # == Variables to Store Information About Indentation ==================================

    il = 0 # ..................................................... Current indentation level
    ns = 2 # .................................... Number of spaces in each indentation level

    # == Table =============================================================================

    _aprintln(buf, "#{", il, ns)
    il += 1

    empty!(vproperties)

    _, table_text_properties = _typst__cell_and_text_properties(style.table)

    if !isempty(table_text_properties)
        prop_str = _typst__property_list(table_text_properties)
        _aprintln(buf, "set text($prop_str)", il, ns)
    end

    # If we have a caption, we need to open a figure environment.
    if !isnothing(caption)
        _aprintln(buf, "figure(", il, ns)
        il += 1
    end

    # Open the table component.
    _aprintln(buf, "table(", il, ns)
    il += 1

    alignment_str = _typst__alignment_configuration(table_data)
    _aprintln(buf, "align: ($alignment_str),", il, ns)

    columns = _typst__get_data_column_widths(table_data, data_column_widths)

    _aprintln(buf, "columns: $columns,", il, ns)
    _aprintln(buf, "stroke: none,", il, ns)

    unused_table_properties = String[]

    for (k, s) in style.table
        if !startswith(k, "text-")
            if k ∉ _TYPST__TABLE_ATTRIBUTES
                push!(unused_table_properties, k)
                continue
            end

            _aprintln(buf, "$k: $s,", il, ns)
        end
    end

    !isempty(unused_table_properties) &&
        @warn ("Unused table properties: " * join(unused_table_properties, ", ", " and "))

    action = :initialize

    # Some internal states to help printing.
    head_opened = false
    body_opened = false

    # This variable stores whether the first column of the current row is being printed. It
    # is used to simplify the logic when `minify` is `true`.
    first_column = false

    # This variable stores where a merged column label begins and ends. Hence, we are able
    # to draw a line after them if the user wants.
    merged_column_labels = Tuple{Int, Int}[]

    # This variable stores the current line in Typst. It is used to print the horizontal
    # lines in the right place.
    current_typst_line = 1

    table_lines = 0

    # This variable stores the indentation level to print the horizontal lines.
    il_table  = il
    hline_pad = " "^max(il_table * ns, 0)

    # This variable is used to check if we are printing the first line of the table. It is
    # used to check if we need to print the horizontal line at the beginning of the table.
    first_table_line = true

    # The highlighters must receive the object the user passed to `pretty_table`, not the
    # internal table wrapper. Notice that this is loop invariant.
    orig_data = _get_data(table_data.data)

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)
        action == :end_printing && break

        # Obtain the next action since some actions depend on it. Notice that only the
        # `:new_row` and `:end_row` branches consume the lookahead, and that it is a full run
        # of the printing state iterator. Hence, we must not pay for it on every cell.
        next_action, next_rs = if (action == :new_row) || (action == :end_row)
            na, nrs, _ = _next(ps, table_data)
            na, nrs
        else
            :initialize, :initialize
        end

        if action == :new_row
            empty!(merged_column_labels)
            first_column = true

            # If we are in the very first row after the title section, we need to check if
            # the user wants a horizontal line before the table.
            if (rs != :table_header) && first_table_line && tf.horizontal_line_at_beginning
                # Using only one argument in `print` to avoid intermediate string
                # allocations.
                @_println(
                    buf_hlines,
                    hline_pad,
                    "table.hline(y: ",
                    current_typst_line - 1,
                    ", stroke: ",
                    tf.borders.top_line,
                    ",),"
                )
                first_table_line = false
            end

            if (ps.i == 1) && (rs ∈ (:table_header, :column_labels)) && !head_opened
                annotate && _aprintln_section_annotation(
                    buf_tc, "// == Table Header", il, ns, wrap_column, '='
                )

                _aprintln(buf_tc, "table.header(", il, ns)
                il += 1
                head_opened = true

            elseif !body_opened && (
                ((ps.i == 1) && (rs ∈ (:data, :summary_row))) || (rs == :row_group_label)
            )
                if head_opened
                    il -= 1
                    _aprintln(buf_tc, "),", il, ns)
                    head_opened = false
                end

                annotate && _aprintln_section_annotation(
                    buf_tc, "// == Table Body", il, ns, wrap_column, '='
                )

                body_opened = true
            end

            annotate && _aprintln_section_annotation(
                buf_tc,
                "// -- " * _current_table_row_section_info(next_rs, next_action, ps.i),
                il,
                ns,
                wrap_column,
                '-',
            )

            empty!(vproperties)

            minify && print(buf_tc, repeat(" ", il * ns))

        elseif action == :diagonal_continuation_cell
            cell_str = _typst__table_cell("⋱"; il, ns, wrap_column)
            _typst__print_cell(buf_tc, cell_str, first_column, il, ns, minify)
            first_column = false

        elseif action == :horizontal_continuation_cell
            cell_str = _typst__table_cell("⋯"; il, ns, wrap_column)
            _typst__print_cell(buf_tc, cell_str, first_column, il, ns, minify)
            first_column = false

        elseif action ∈ _VERTICAL_CONTINUATION_CELL_ACTIONS
            cell_str = _typst__table_cell("⋮"; il, ns, wrap_column)
            _typst__print_cell(buf_tc, cell_str, first_column, il, ns, minify)
            first_column = false

        elseif action == :end_row
            minify && println(buf_tc)

            if rs ∈
                (:column_labels, :data, :row_group_label, :continuation_row, :summary_row)
                table_lines += 1
            end

            # == Handle the Horizontal Lines ===============================================

            hline  = ""
            stroke = ""

            # Print the horizontal line after the column labels.
            if (rs == :table_header) &&
                (next_rs != :table_header) &&
                tf.horizontal_line_at_beginning
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.top_line

                first_table_line = false

            elseif (rs == :column_labels)
                if ps.row_section == :column_labels
                    if tf.horizontal_line_at_merged_column_labels
                        # The specification in `merged_column_labels` refers to the data
                        # columns. Hence, we need to add the offset regarding the previous
                        # columns if they exist.
                        Δc = table_data.show_row_number_column + _has_row_labels(table_data)

                        # NOTE: Each merged cell needs its own line, so they must be written
                        # out inside the loop. Assigning to `hline` here would keep only the
                        # last one, exactly like the LaTeX back end accumulates one `\cline`
                        # per merged cell.
                        for m in merged_column_labels
                            c₀ = Δc + m[1] - 1
                            c₁ = Δc + m[2]

                            @_println(
                                buf_hlines,
                                hline_pad,
                                "table.hline(y: ",
                                current_typst_line,
                                ", start: ",
                                c₀,
                                ", end: ",
                                c₁,
                                ", stroke: ",
                                tf.borders.merged_header_cell_line,
                                ",),"
                            )
                        end
                    end

                elseif tf.horizontal_line_after_column_labels
                    hline  = "y: $(current_typst_line)"
                    stroke = tf.borders.header_line
                end

                # Check if the next line is a row group label and the user requests a
                # line before it.
            elseif (next_rs == :row_group_label) &&
                tf.horizontal_line_before_row_group_label
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.middle_line

                # Check if we must print a horizontal line after the current data row.
            elseif (rs == :data) && (ps.i ∈ horizontal_lines_at_data_rows)
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.middle_line

            elseif (
                (rs ∈ (:data, :continuation_row)) &&
                (next_rs ∈ (:summary_row, :table_footer, :end_printing)) &&
                tf.horizontal_line_after_data_rows
            )
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.middle_line

            elseif (
                (rs ∈ (:data, :continuation_row)) &&
                (next_rs == :summary_row) &&
                tf.horizontal_line_before_summary_rows
            )
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.middle_line

            elseif (rs == :row_group_label) && tf.horizontal_line_after_row_group_label
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.middle_line

                # Check if we must print the horizontal line at the end of the table.
            elseif (rs == :summary_row) &&
                (next_rs != :summary_row) &&
                tf.horizontal_line_after_summary_rows
                hline  = "y: $(current_typst_line)"
                stroke = tf.borders.middle_line
            end

            # If the next section is the end of the table and we need to draw a horizontal
            # line, we should change it to the bottom line.
            if next_rs ∈ (:table_footer, :end_printing) && !isempty(hline)
                stroke = tf.borders.bottom_line
            end

            !isempty(hline) && @_println(
                buf_hlines,
                hline_pad,
                "table.hline(",
                hline,
                ", stroke: ",
                stroke,
                ",),"
            )

            # == Omitted Cell Summary ======================================================

            # We need to print the omitted cell summary as soon as we enter the table
            # footer.
            if (!isempty(ocs) && next_rs ∈ (:table_footer, :end_printing) && !ocs_printed)
                cell_properties, text_properties = _typst__cell_and_text_properties(
                    style.omitted_cell_summary
                )

                # We must copy the vector before pushing because the function above can
                # return a shared empty vector that must not be mutated.
                cell_properties = copy(cell_properties)

                push!(
                    cell_properties,
                    "align"   => _typst__alignment(:r),
                    "colspan" => string(_number_of_printed_columns(table_data)),
                    "inset"   => "(right: 0pt)",
                    "stroke"  => "none",
                )

                cell_content = _typst__text(ocs, text_properties)
                cell_str = _typst__table_cell(
                    cell_content, cell_properties; il, ns, wrap_column
                )

                annotate && _aprintln_section_annotation(
                    buf_tc, "// -- Omitted Cell Summary", il, ns, wrap_column, '-'
                )

                _aprintln(buf_tc, cell_str * ",", il, ns)

                ocs_printed = true
            end

            current_typst_line += 1
        else
            empty!(vproperties)

            cell = _current_cell(action, ps, table_data)

            cell === _IGNORE_CELL && continue

            # Compute the footnote superscripts to append to this cell. Notice that this must
            # be done here, and not once per action, because the result is only ever consumed
            # by a cell.
            footnote = _current_cell_footnotes(table_data, action, ps.i, ps.j)

            append = if !isnothing(footnote) && !isempty(footnote)
                # Notice that all the footnote numbers must be inside the same superscript.
                # Otherwise, the separator would be rendered with the normal text size.
                "#super[" * join(footnote, ",") * "]"
            end

            # If we are in a column label, check if we must merge the cell.
            if (action == :column_label) && (cell isa MergeCells)
                # Check if we have enough data columns to merge the cell.
                num_data_columns = _number_of_printed_data_columns(table_data)

                cs = if (ps.j + cell.column_span - 1) > num_data_columns
                    num_data_columns - ps.j + 1
                else
                    cell.column_span
                end

                push!(merged_column_labels, (ps.j, ps.j + cs - 1))

                push!(vproperties, "colspan" => string(cs))
                rendered_cell = _typst__render_cell(cell.data, rctx, renderer)

                alignment = cell.alignment

                # NOTE: The `:column_label` property branch below never pushes an alignment,
                # since only `:data` cells do. Hence, the alignment the user selected for a
                # merged column label must be pushed here, exactly like the HTML and LaTeX
                # back ends honor it.
                push!(vproperties, "align" => _typst__alignment(alignment))

                append!(
                    vproperties,
                    if ps.i == 1
                        style.first_line_merged_column_label
                    else
                        style.merged_column_label
                    end,
                )

            else
                rendered_cell = _typst__render_cell(cell, rctx, renderer)

                alignment = _current_cell_alignment(action, ps, table_data)
            end

            # If we are in a data cell, we must check for highlighters.
            if action == :data
                if !isempty(highlighters)
                    for h in highlighters
                        if h.f(orig_data, ps.i, ps.j)
                            _typst__merge_properties!(
                                vproperties, h.fd(h, orig_data, ps.i, ps.j)
                            )
                            break
                        end
                    end
                end

                (alignment != _data_column_alignment(table_data, ps.j)) &&
                    push!(vproperties, "align" => _typst__alignment(alignment))
            end

            # Obtain the cell properties.
            if action == :title
                push!(
                    vproperties,
                    "align"   => _typst__alignment(alignment),
                    "colspan" => string(_number_of_printed_columns(table_data)),
                )
                _typst__merge_properties!(vproperties, style.title)

            elseif action == :subtitle
                push!(
                    vproperties,
                    "align"   => _typst__alignment(alignment),
                    "colspan" => string(_number_of_printed_columns(table_data)),
                )
                _typst__merge_properties!(vproperties, style.subtitle)

            elseif action == :row_number_label
                _typst__merge_properties!(vproperties, style.row_number_label)

            elseif action == :row_number
                _typst__merge_properties!(vproperties, style.row_number)

            elseif action == :summary_row_number
                _typst__merge_properties!(vproperties, style.row_number)

            elseif action == :stubhead_label
                _typst__merge_properties!(vproperties, style.stubhead_label)

            elseif action == :row_group_label
                push!(
                    vproperties,
                    "align"   => _typst__alignment(alignment),
                    "colspan" => string(_number_of_printed_columns(table_data)),
                )
                _typst__merge_properties!(vproperties, style.row_group_label)

            elseif action == :row_label
                _typst__merge_properties!(vproperties, style.row_label)

            elseif action == :summary_row_label
                _typst__merge_properties!(vproperties, style.summary_row_label)

            elseif action == :column_label
                if ps.i == 1
                    _typst__merge_properties!(
                        vproperties,
                        if style.first_line_column_label isa Vector{Vector{TypstPair}}
                            style.first_line_column_label[ps.j]
                        else
                            style.first_line_column_label
                        end,
                    )
                else
                    _typst__merge_properties!(
                        vproperties,
                        if style.column_label isa Vector{Vector{TypstPair}}
                            style.column_label[ps.j]
                        else
                            style.column_label
                        end,
                    )
                end

            elseif action == :summary_row_cell
                _typst__merge_properties!(vproperties, style.summary_row_cell)

            elseif action == :footnote
                # The footnote must be a cell that spans the entire printed table.
                push!(
                    vproperties,
                    "align"   => _typst__alignment(alignment),
                    "colspan" => string(_number_of_printed_columns(table_data)),
                    "inset"   => "(left: 0pt)",
                    "stroke"  => "none",
                )
                _typst__merge_properties!(vproperties, style.footnote)

            elseif action == :source_notes
                # The source notes must be a cell that spans the entire printed table.
                push!(
                    vproperties,
                    "align"   => _typst__alignment(alignment),
                    "colspan" => string(_number_of_printed_columns(table_data)),
                    "inset"   => "(left: 0pt)",
                    "stroke"  => "none",
                )
                _typst__merge_properties!(vproperties, style.source_note)
            end

            # Create the table cell.
            cell_properties, text_properties = _typst__cell_and_text_properties(vproperties)

            # NOTE: `action ∈ [:footnote]` would heap-allocate a `Vector{Symbol}` per cell.
            cell_prefix = action == :footnote ? "#super[$(ps.i)]" : ""

            # If the type is `Markdown.MD` or if Typstry.jl is loaded and the cell is a
            # `TypstString`, we do not wrap it in a #text. Treat it as a raw Typst
            # component.
            cell_content = if (cell isa Markdown.MD) || _typst__is_raw_typst_cell(cell)
                rendered_cell
            else
                _typst__text(rendered_cell, text_properties)
            end

            cell_str = _typst__table_cell(
                cell_prefix * cell_content * something(append, ""),
                cell_properties;
                il,
                ns,
                wrap_column,
            )

            _typst__print_cell(buf_tc, cell_str, first_column, il, ns, minify)
            first_column = false
        end
    end

    # Close the section that was left opened.
    if head_opened
        il -= 1
        _aprintln(buf_tc, "),", il, ns)
    end

    # Join the horizontal and vertical lines with the table content.
    annotate && _aprintln_section_annotation(
        buf, "// == Horizontal Lines", il_table, ns, wrap_column, '='
    )

    write(buf, take!(buf_hlines))

    annotate && _aprintln_section_annotation(
        buf, "// == Vertical Lines", il_table, ns, wrap_column, '='
    )

    _typst__vertical_lines!(
        buf, table_data, tf, table_lines, vertical_lines_at_data_columns, il_table, ns
    )

    write(buf, take!(buf_tc))

    il -= 1

    if !isnothing(caption)
        _aprintln(buf, "),", il, ns)

        if caption isa AbstractString
            # The caption is emitted inside a Typst string literal, so an embedded `"` or
            # `\` would break the document.
            _aprintln(
                buf, "caption: \"$(_typst__escape_string_literal(caption))\",", il, ns
            )
            _aprintln(buf, "kind: auto,", il, ns)
        elseif caption isa TypstCaption
            _aprint(buf, _typst__process_caption(caption, il), il, ns)
        end

        il -= 1
    end

    _aprintln(buf, ")", il, ns)
    il -= 1

    _aprintln(buf, "}", il, ns)
    il -= 1

    # == Print the Buffer Into the IO ======================================================

    output_str = String(take!(buf_io))

    # If we are printing to `stdout` and Typstry.jl is loaded, try to render the table using
    # the available displays. If it is not possible, print the plain output.
    if !(is_stdout && _typst__display(output_str))
        print(context, output_str)
    end

    return nothing
end

using LinearAlgebra
using Printf
using PrettyTables
using SHA
using Tables

const SOURCES = [
    ("matrix", "Matrix"),
    ("view", "SubArray/view"),
    ("transpose", "Transpose"),
    ("diagonal", "Diagonal"),
    ("columns", "Tables.jl columns"),
    ("rows", "Tables.jl rows"),
]

const BACKENDS = [:text, :html, :latex, :markdown, :typst]
const COLUMN_LABELS = ["Column 1", "Column 2", "Column 3", "Column 4"]
const RECORD_VERSION = "PTBENCH_V1"
const TARGET_TPFT_NS = 100_000_000.0
const TARGET_REPEATED_NS = 100_000.0

const DASHBOARD_TABLE_FORMAT = TextTableFormat(;
    borders = text_table_borders__unicode_rounded,
    horizontal_line_at_beginning = true,
    horizontal_line_after_column_labels = true,
    horizontal_line_after_data_rows = true,
    vertical_lines_at_data_columns = :all,
)

const DASHBOARD_TABLE_STYLE = TextTableStyle(;
    first_line_column_label = crayon"bold cyan",
    column_label = crayon"fg:cyan",
    row_label = crayon"bold",
    table_border = crayon"fg:dark_gray",
)

"""
    print_help() -> Nothing

Print the public command-line help and benchmark scope.
"""
function print_help()
    println(
        """
Usage: julia --project=. benchmark/user_observed_performance.jl [options]

Measure user-observed PrettyTables performance for 6 table sources and the 5 built-in
rendering backends: text, html, latex, markdown, and typst. Excel is explicitly
excluded.

Options:
  --trials N       Fresh Julia workers per scenario (default: 10).
  --repeats N      Warm renders in each worker (default: 50).
  --backends LIST  Comma-separated built-in backends (default: all five).
  --help           Show this help message.

Backend examples:
  --backends text,html
  --backends typst

Each source/backend/trial runs alone in a fresh process. Runs with 1-3 trials are useful
only for exploratory checks; use the default or more for credible comparisons.

Score v1 is higher-is-better and weights TPFT twice:
  100 * (((100 ms / TPFT)^2 * (100 μs / repeated))^(1/3))
"""
    )
    return nothing
end

"""
    parse_backends(value::String) -> Vector{Symbol}

Parse the comma-separated backend list `value`, normalize its names, and remove duplicates
while preserving their first-occurrence order.
"""
function parse_backends(value::String)
    isempty(strip(value)) && throw(ArgumentError("--backends requires a nonempty list"))
    selected = Symbol[]
    valid = join(String.(BACKENDS), ",")
    for entry in split(value, ',')
        name = lowercase(strip(entry))
        isempty(name) &&
            throw(ArgumentError("--backends contains an empty name; valid values: $valid"))
        backend = Symbol(name)
        backend in BACKENDS ||
            throw(ArgumentError("unknown backend '$name'; valid values: $valid"))
        backend in selected || push!(selected, backend)
    end
    return selected
end

"""
    parse_positive_integer(option::String, value::String) -> Int

Parse `value` as a positive integer for the named command-line `option`.
"""
function parse_positive_integer(option::String, value::String)
    number = tryparse(Int, value)
    if isnothing(number) || number <= 0
        throw(ArgumentError("$option requires a positive integer, got '$value'"))
    end
    return number
end

"""
    parse_parent_arguments(arguments::Vector{String}) -> NamedTuple

Parse and validate the public command-line `arguments`.

# Returns

- `NamedTuple`: Positive trial and repeat counts, ordered backend selection, and help state.
"""
function parse_parent_arguments(arguments::Vector{String})
    trials = 10
    repeats = 50
    backends = copy(BACKENDS)
    index = 1

    while index <= length(arguments)
        argument = arguments[index]
        if argument == "--help"
            return (; trials, repeats, backends, help = true)
        elseif argument == "--trials" || argument == "--repeats"
            index == length(arguments) && throw(ArgumentError("$argument requires a value"))
            value = parse_positive_integer(argument, arguments[index + 1])
            if argument == "--trials"
                trials = value
            else
                repeats = value
            end
            index += 2
        elseif argument == "--backends"
            if index == length(arguments) || startswith(arguments[index + 1], "--")
                throw(ArgumentError("--backends requires a comma-separated list"))
            end
            backends = parse_backends(arguments[index + 1])
            index += 2
        else
            throw(ArgumentError("unknown option '$argument'; use --help for usage"))
        end
    end

    return (; trials, repeats, backends, help = false)
end

"""
    make_source(source_name::String) -> Union{AbstractMatrix, NamedTuple, AbstractVector}

Construct an equivalent four-by-four source selected by the internal `source_name`.
"""
function make_source(source_name::String)
    matrix = [row == column ? row : 0 for row in 1:4, column in 1:4]
    names  = (:c1, :c2, :c3, :c4)

    if source_name == "matrix"
        return matrix
    elseif source_name == "view"
        return view(matrix, :, :)
    elseif source_name == "transpose"
        return transpose(matrix)
    elseif source_name == "diagonal"
        return Diagonal(1:4)
    elseif source_name == "columns"
        return NamedTuple{names}(Tuple(matrix[:, column] for column in axes(matrix, 2)))
    elseif source_name == "rows"
        return [NamedTuple{names}(Tuple(matrix[row, :])) for row in axes(matrix, 1)]
    end

    throw(ArgumentError("unknown worker source '$source_name'"))
end

"""
    new_sink() -> IOContext{IOBuffer}

Create a colorless in-memory sink with a deterministic large display size.
"""
function new_sink()
    return IOContext(IOBuffer(), :color => false, :displaysize => (10_000, 10_000))
end

"""
    median_value(values::AbstractVector{<:Real}) -> Float64

Compute the median of the nonempty real-valued collection `values`.
"""
function median_value(values::AbstractVector{<:Real})
    isempty(values) && throw(ArgumentError("cannot compute the median of no values"))
    ordered = sort!(Float64.(values))
    count   = length(ordered)
    middle  = (count + 1) ÷ 2
    return isodd(count) ? ordered[middle] : (ordered[middle] + ordered[middle + 1]) / 2
end

"""
    geometric_mean(values::AbstractVector{<:Real}) -> Float64

Compute the positive geometric mean of `values` in log space.
"""
function geometric_mean(values::AbstractVector{<:Real})
    isempty(values) && throw(ArgumentError("cannot compute a geometric mean of no values"))
    all(value -> value > 0, values) ||
        throw(ArgumentError("geometric mean values must be positive"))
    return exp(sum(log, values) / length(values))
end

"""
    compile_components(
        value::Union{Real, Tuple{Vararg{Real}}},
    ) -> Tuple{Float64, Float64}

Normalize the scalar or tuple cumulative compilation counter `value` into compile and
recompile times.
"""
function compile_components(value::Union{Real, Tuple})
    if value isa Tuple
        isempty(value) && return 0.0, -1.0
        compile_time   = Float64(value[1])
        recompile_time = length(value) >= 2 ? Float64(value[2]) : -1.0
        return compile_time, recompile_time
    end
    return Float64(value), -1.0
end

"""
    render_worker(source_name::String, backend_name::String, repeats::Int) -> Nothing

Measure the isolated `source_name` and `backend_name` scenario for `repeats` warm renders,
then emit one fixed-field worker record.
"""
function render_worker(source_name::String, backend_name::String, repeats::Int)
    source_name in first.(SOURCES) ||
        throw(ArgumentError("worker source '$source_name' is not allowed"))
    backend = Symbol(backend_name)
    backend in BACKENDS ||
        throw(ArgumentError("worker backend '$backend_name' is not allowed"))

    source = make_source(source_name)
    GC.gc()

    compile_available =
        isdefined(Base, :cumulative_compile_timing) &&
        isdefined(Base, :cumulative_compile_time_ns)
    compile_before = 0.0
    recompile_before = -1.0
    compile_after = 0.0
    recompile_after = -1.0
    first_sink = new_sink()
    first_elapsed_ns = 0

    if compile_available
        Base.cumulative_compile_timing(true)
        compile_before, recompile_before = compile_components(
            Base.cumulative_compile_time_ns()
        )
    end

    try
        start_ns = time_ns()
        pretty_table(
            first_sink,
            source;
            backend = backend,
            column_labels = COLUMN_LABELS,
            limit_printing = false,
        )
        first_elapsed_ns = time_ns() - start_ns
    finally
        if compile_available
            compile_after, recompile_after = compile_components(
                Base.cumulative_compile_time_ns()
            )
            Base.cumulative_compile_timing(false)
        end
    end

    first_output = take!(first_sink.io)
    isempty(first_output) && error("$source_name/$backend_name produced empty first output")
    first_digest = bytes2hex(SHA.sha256(first_output))
    output_bytes = length(first_output)

    repeated_ns = Vector{Float64}(undef, repeats)
    for repetition in 1:repeats
        sink = new_sink()
        GC.gc()
        start_ns = time_ns()
        pretty_table(
            sink,
            source;
            backend = backend,
            column_labels = COLUMN_LABELS,
            limit_printing = false,
        )
        repeated_ns[repetition] = time_ns() - start_ns

        output = take!(sink.io)
        isempty(output) &&
            error("$source_name/$backend_name produced empty repeated output")
        digest = bytes2hex(SHA.sha256(output))
        if length(output) != output_bytes ||
            digest != first_digest ||
            output != first_output
            error("$source_name/$backend_name produced unstable repeated output")
        end
    end

    compile_ns = compile_available ? max(compile_after - compile_before, 0.0) : -1.0
    recompile_ns = if compile_available && recompile_before >= 0 && recompile_after >= 0
        max(recompile_after - recompile_before, 0.0)
    else
        -1.0
    end
    repeated_median_ns = median_value(repeated_ns)

    println(
        RECORD_VERSION,
        '\t',
        source_name,
        '\t',
        backend_name,
        '\t',
        first_elapsed_ns,
        '\t',
        compile_ns,
        '\t',
        recompile_ns,
        '\t',
        repeated_median_ns,
        '\t',
        output_bytes,
        '\t',
        first_digest,
    )
    return nothing
end

"""
    run_trial(
        script::String,
        project::String,
        source::String,
        backend::Symbol,
        repeats::Int,
        trial::Int,
    ) -> NamedTuple

Run one scenario trial in a clean single-threaded Julia subprocess and parse its record.

# Arguments
- `script::String`: Path to the benchmark worker script.
- `project::String`: Path to the explicit Julia project used by the worker.
- `source::String`: Internal source name requested from the worker.
- `backend::Symbol`: Built-in rendering backend requested from the worker.
- `repeats::Int`: Number of warm renders performed by the worker.
- `trial::Int`: One-based trial number used in diagnostics.
"""
function run_trial(
    script::String,
    project::String,
    source::String,
    backend::Symbol,
    repeats::Int,
    trial::Int,
)
    output = IOBuffer()
    errors = IOBuffer()
    julia = Base.julia_cmd()
    backend_name = String(backend)
    command = `$julia --startup-file=no --history-file=no --threads=1 --project=$project`
    command = `$command $script --_worker $source $backend_name $repeats`
    process = run(pipeline(command; stdout = output, stderr = errors); wait = false)
    wait(process)

    standard_output = String(take!(output))
    standard_error  = String(take!(errors))
    if !success(process)
        message = isempty(strip(standard_error)) ? "no error output" : strip(standard_error)
        error(
            "worker failed for $source/$backend_name trial $trial with exit code " *
            "$(process.exitcode):\n$message",
        )
    end
    if !isempty(strip(standard_error))
        println(
            stderr,
            "Worker warning for $source/$backend_name trial $trial:\n",
            strip(standard_error),
        )
    end

    fields = split(chomp(standard_output), '\t')
    length(fields) == 9 || error(
        "worker returned $(length(fields)) fields instead of 9 for " *
        "$source/$backend_name: $(repr(standard_output))",
    )
    fields[1] == RECORD_VERSION ||
        error("worker returned unsupported record version '$(fields[1])'")
    fields[2] == source || error("worker source field did not match request")
    fields[3] == backend_name || error("worker backend field did not match request")
    fields[2] in first.(SOURCES) || error("worker returned a disallowed source")
    Symbol(fields[3]) in BACKENDS || error("worker returned a disallowed backend")
    occursin(r"^[0-9a-f]{64}$", fields[9]) || error("worker returned an invalid digest")

    try
        return (
            tpft_ns = parse(Float64, fields[4]),
            compile_ns = parse(Float64, fields[5]),
            recompile_ns = parse(Float64, fields[6]),
            repeated_ns = parse(Float64, fields[7]),
            output_bytes = parse(Int, fields[8]),
            digest = fields[9],
        )
    catch exception
        error(
            "worker returned invalid numeric fields for $source/$backend_name: " *
            sprint(showerror, exception),
        )
    end
end

"""
    git_profile(project::String) -> NamedTuple

Read the repository revision and worktree state for `project`, with a graceful non-git
fallback.
"""
function git_profile(project::String)
    try
        sha = readchomp(
            pipeline(`git -C $project rev-parse --short HEAD`; stderr = devnull)
        )
        status = readchomp(pipeline(`git -C $project status --porcelain`; stderr = devnull))
        return (; sha, state = isempty(status) ? "clean" : "dirty")
    catch
        return (; sha = "unavailable", state = "unavailable")
    end
end

"""
    cell_score(tpft_ns::Real, repeated_ns::Real) -> Float64

Compute Score v1 from the scenario's `tpft_ns` and `repeated_ns` measurements.
"""
function cell_score(tpft_ns::Real, repeated_ns::Real)
    return 100 * exp(
        (2 * log(TARGET_TPFT_NS / tpft_ns) + log(TARGET_REPEATED_NS / repeated_ns)) / 3
    )
end

"""
    optional_median(values::AbstractVector{<:Real}) -> Float64

Compute the median of `values` after discarding unavailable negative diagnostics.
"""
function optional_median(values::AbstractVector{<:Real})
    available = filter(value -> value >= 0, values)
    return isempty(available) ? -1.0 : median_value(available)
end

"""
    diagnostic_string(value::Real, scale::Real; kwargs...) -> String

Format `value` divided by `scale`, or return an availability marker for a negative value.

# Keywords
- `suffix::String`: Append this unit suffix to an available value.
    (**Default**: `""`)
"""
function diagnostic_string(value::Real, scale::Real; suffix::String = "")
    return value < 0 ? "n/a" : @sprintf("%.3f%s", value / scale, suffix)
end

"""
    output_supports_color(io::IO) -> Bool

Detect whether `io` is an interactive terminal with color support.
"""
function output_supports_color(io::IO)
    return io isa Base.TTY && Base.get_have_color()
end

"""
    dashboard_table_style(io::IO) -> TextTableStyle

Choose the dashboard table styling when `io` supports color, otherwise use plain styling.
"""
function dashboard_table_style(io::IO)
    return output_supports_color(io) ? DASHBOARD_TABLE_STYLE : TextTableStyle()
end

"""
    print_accent(io::IO, text::AbstractString, decoration::Crayon) -> Nothing

Print `text` with `decoration` when `io` supports color, otherwise print plain text.
"""
function print_accent(io::IO, text::AbstractString, decoration::Crayon)
    if output_supports_color(io)
        print(io, decoration, text, crayon"reset")
    else
        print(io, text)
    end
    return nothing
end

"""
    print_dashboard_header(io::IO) -> Nothing

Print the benchmark report masthead.
"""
function print_dashboard_header(io::IO)
    title    = "PRETTYTABLES  /  USER-OBSERVED PERFORMANCE"
    subtitle = "Fresh-process rendering benchmark  ·  Score v1"
    println(io, "╭", repeat("─", 78), "╮")
    print(io, "│ ")
    print_accent(io, title, crayon"bold cyan")
    println(io, repeat(" ", 76 - textwidth(title)), " │")
    println(io, "│ ", subtitle, repeat(" ", 76 - textwidth(subtitle)), " │")
    println(io, "╰", repeat("─", 78), "╯")
    return nothing
end

"""
    print_section(io::IO, title::String, detail::String = "") -> Nothing

Print a clearly separated report section heading with an optional concise `detail`.
"""
function print_section(io::IO, title::String, detail::String = "")
    println(io)
    print_accent(io, "━━ ", crayon"fg:cyan")
    print_accent(io, uppercase(title), crayon"bold cyan")
    isempty(detail) || print(io, "  ", detail)
    println(io)
    return nothing
end

"""
    print_progress(
        io::IO,
        first_worker::Int,
        last_worker::Int,
        total_workers::Int,
        backend::Symbol,
        source_label::String,
    ) -> Nothing

Print one stderr progress line for an isolated scenario batch.
"""
function print_progress(
    io::IO,
    first_worker::Int,
    last_worker::Int,
    total_workers::Int,
    backend::Symbol,
    source_label::String,
)
    range = @sprintf("%3d – %3d / %d", first_worker, last_worker, total_workers)
    print_accent(io, "• [$range] ", crayon"fg:cyan")
    print_accent(io, rpad(String(backend), 9), crayon"bold")
    println(io, " · ", source_label)
    return nothing
end

"""
    print_run_profile(
        git::NamedTuple,
        project::String,
        trials::Int,
        repeats::Int,
        backends::Vector{Symbol},
        scenario_count::Int,
        total_workers::Int,
    ) -> Nothing

Print the compact execution profile panel for the selected `backends`, `scenario_count`,
sampling parameters, worker count, repository `git` state, and `project`.
"""
function print_run_profile(
    git::NamedTuple,
    project::String,
    trials::Int,
    repeats::Int,
    backends::Vector{Symbol},
    scenario_count::Int,
    total_workers::Int,
)
    run_quality = if trials <= 3
        "exploratory; use at least 10 trials to compare"
    else
        "comparison-ready"
    end
    profile_rows = Any[
        "Julia" string(VERSION)
        "Revision" "$(git.sha) ($(git.state))"
        "Machine" Sys.CPU_NAME
        "Execution" "parent: $(Threads.nthreads()) threads · workers: 1 thread"
        "Sampling" "$trials fresh workers / scenario · $repeats warm renders / worker"
        "Scope" "$scenario_count scenarios · $total_workers workers · Excel excluded"
        "Backends" join(String.(backends), " · ")
        "Sink policy" "new IOBuffer/IOContext for every timed render"
        "Score target" "TPFT: 100 ms · repeated: 100 μs"
        "Run quality" run_quality
        "Project" project
    ]
    highlighters = TextHighlighter[TextHighlighter(
        (_, _, column) -> column == 1, crayon"bold"
    ),]
    pretty_table(
        IOContext(stdout, :color => output_supports_color(stdout)),
        profile_rows;
        column_labels = ["Run profile", "Value"],
        alignment = [:l, :l],
        column_label_alignment = :l,
        fit_table_in_display_horizontally = false,
        fit_table_in_display_vertically = false,
        highlighters = highlighters,
        limit_printing = false,
        style = dashboard_table_style(stdout),
        table_format = DASHBOARD_TABLE_FORMAT,
    )
    return nothing
end

"""
    print_result_table(title::String, rows::Matrix, labels::Vector{String}) -> Nothing

Print `rows` under `title` with the column `labels` and without display-width cropping.
"""
function print_result_table(title::String, rows::Matrix, labels::Vector{String})
    print_section(stdout, title)
    score_column = size(rows, 2)
    highlighters = TextHighlighter[
        TextHighlighter((_, _, column) -> column == score_column, crayon"bold yellow"),
        TextHighlighter(
            (data, row, column) -> data[row, column] == "n/a" || data[row, column] == "-",
            crayon"fg:dark_gray",
        ),
        TextHighlighter(
            (data, row, column) -> data[row, column] == "FAILED", crayon"bold red"
        ),
    ]
    alignment = vcat([:l, :l], fill(:r, length(labels) - 2))
    length(labels) == 6 && (alignment = vcat([:l], fill(:r, length(labels) - 1)))
    pretty_table(
        IOContext(stdout, :color => output_supports_color(stdout)),
        rows;
        column_labels = labels,
        alignment = alignment,
        column_label_alignment = :c,
        fit_table_in_display_horizontally = false,
        fit_table_in_display_vertically = false,
        highlighters = highlighters,
        limit_printing = false,
        style = dashboard_table_style(stdout),
        table_format = DASHBOARD_TABLE_FORMAT,
    )
    return nothing
end

"""
    aggregate_group(cells::Vector{<:NamedTuple}) -> NamedTuple

Aggregate the successful scenario `cells` using geometric means and median diagnostics.
"""
function aggregate_group(cells::Vector{<:NamedTuple})
    tpft_ns     = geometric_mean([cell.tpft_ns for cell in cells])
    repeated_ns = geometric_mean([cell.repeated_ns for cell in cells])
    compile_ns  = optional_median([cell.compile_ns for cell in cells])
    shares      = [cell.compile_share for cell in cells if cell.compile_share >= 0]
    share       = isempty(shares) ? -1.0 : median_value(shares)
    score       = geometric_mean([cell.score for cell in cells])
    return (; tpft_ns, repeated_ns, compile_ns, compile_share = share, score)
end

"""
    run_parent(
        trials::Int,
        repeats::Int,
        backends::Vector{Symbol},
    ) -> Nothing

Run the isolated scenarios for `backends` with `trials` workers and `repeats` warm renders,
aggregate their metrics, and print the functional report.
"""
function run_parent(trials::Int, repeats::Int, backends::Vector{Symbol})
    script = abspath(@__FILE__)
    project = dirname(dirname(script))
    git = git_profile(project)
    scenario_count = length(SOURCES) * length(backends)
    total_workers = scenario_count * trials
    backend_names = join(String.(backends), ", ")

    print_dashboard_header(stdout)
    print_section(stdout, "Run profile", "environment and sampling plan")
    print_run_profile(
        git, project, trials, repeats, backends, scenario_count, total_workers
    )
    print_section(
        stderr,
        "Benchmark progress",
        "one update per isolated scenario; worker output stays private",
    )

    cells = NamedTuple[]
    failures = String[]
    worker_index = 0
    for backend in backends
        for (source_name, source_label) in SOURCES
            tpft_values      = Float64[]
            compile_values   = Float64[]
            recompile_values = Float64[]
            repeated_values  = Float64[]
            byte_values      = Float64[]
            share_values     = Float64[]
            scenario_failed  = false

            print_progress(
                stderr,
                worker_index + 1,
                worker_index + trials,
                total_workers,
                backend,
                source_label,
            )
            for trial in 1:trials
                worker_index += 1
                try
                    record = run_trial(
                        script, project, source_name, backend, repeats, trial
                    )
                    push!(tpft_values, record.tpft_ns)
                    push!(compile_values, record.compile_ns)
                    push!(recompile_values, record.recompile_ns)
                    push!(repeated_values, record.repeated_ns)
                    push!(byte_values, record.output_bytes)
                    share =
                        record.compile_ns < 0 ? -1.0 :
                        100 * record.compile_ns / record.tpft_ns
                    push!(share_values, share)
                catch exception
                    scenario_failed = true
                    message =
                        "$backend/$source_label trial $trial: " *
                        sprint(showerror, exception)
                    push!(failures, message)
                    println(stderr, "FAILED: ", message)
                    worker_index += trials - trial
                    break
                end
            end

            scenario_failed && continue
            tpft_ns = median_value(tpft_values)
            compile_ns = optional_median(compile_values)
            recompile_ns = optional_median(recompile_values)
            repeated_ns = median_value(repeated_values)
            output_bytes = median_value(byte_values)
            available_shares = filter(value -> value >= 0, share_values)
            compile_share =
                isempty(available_shares) ? -1.0 : median_value(available_shares)
            score = cell_score(tpft_ns, repeated_ns)
            push!(
                cells,
                (;
                    backend,
                    source = source_label,
                    tpft_ns,
                    compile_ns,
                    recompile_ns,
                    repeated_ns,
                    output_bytes,
                    compile_share,
                    score,
                ),
            )
        end
    end

    scenario_rows = Matrix{Any}(undef, scenario_count, 10)
    scenario_index = 0
    for backend in backends
        for (_, source_label) in SOURCES
            scenario_index += 1
            matches = filter(
                cell -> cell.backend == backend && cell.source == source_label, cells
            )
            if isempty(matches)
                scenario_rows[scenario_index, :] = [
                    String(backend),
                    source_label,
                    "FAILED",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                ]
                continue
            end

            cell = only(matches)
            scenario_rows[scenario_index, :] = [
                String(cell.backend),
                cell.source,
                @sprintf("%.3f", cell.tpft_ns / 1e6),
                diagnostic_string(cell.compile_ns, 1e6),
                diagnostic_string(cell.recompile_ns, 1e6),
                diagnostic_string(cell.compile_share, 1; suffix = "%"),
                @sprintf("%.3f", cell.repeated_ns / 1e3),
                @sprintf("%.1f", cell.tpft_ns / cell.repeated_ns),
                round(Int, cell.output_bytes),
                @sprintf("%.2f", cell.score),
            ]
        end
    end
    print_result_table(
        "Scenario results & compilation",
        scenario_rows,
        [
            "Backend",
            "Source",
            "TPFT ms",
            "Compile ms",
            "Recompile ms",
            "Compile share",
            "Repeated μs",
            "Cold/warm",
            "Output bytes",
            "Score v1",
        ],
    )
    println(
        "  Medians across fresh workers. Compilation is diagnostic within first-print time."
    )

    backend_rows = Matrix{Any}(undef, length(backends), 6)
    for (index, backend) in enumerate(backends)
        group = filter(cell -> cell.backend == backend, cells)
        if length(group) == length(SOURCES)
            aggregate = aggregate_group(group)
            backend_rows[index, :] = [
                String(backend),
                @sprintf("%.3f", aggregate.tpft_ns / 1e6),
                @sprintf("%.3f", aggregate.repeated_ns / 1e3),
                diagnostic_string(aggregate.compile_ns, 1e6),
                diagnostic_string(aggregate.compile_share, 1; suffix = "%"),
                @sprintf("%.2f", aggregate.score),
            ]
        else
            backend_rows[index, :] = [String(backend), "FAILED", "-", "-", "-", "-"]
        end
    end
    print_result_table(
        "Backend summary",
        backend_rows,
        [
            "Backend",
            "TPFT gmean ms",
            "Repeated gmean μs",
            "Compile median ms",
            "Compile share median",
            "Score v1",
        ],
    )

    source_rows = Matrix{Any}(undef, length(SOURCES), 6)
    for (index, (_, source_label)) in enumerate(SOURCES)
        group = filter(cell -> cell.source == source_label, cells)
        if length(group) == length(backends)
            aggregate = aggregate_group(group)
            source_rows[index, :] = [
                source_label,
                @sprintf("%.3f", aggregate.tpft_ns / 1e6),
                @sprintf("%.3f", aggregate.repeated_ns / 1e3),
                diagnostic_string(aggregate.compile_ns, 1e6),
                diagnostic_string(aggregate.compile_share, 1; suffix = "%"),
                @sprintf("%.2f", aggregate.score),
            ]
        else
            source_rows[index, :] = [source_label, "FAILED", "-", "-", "-", "-"]
        end
    end
    print_result_table(
        "Source summary",
        source_rows,
        [
            "Source",
            "TPFT gmean ms",
            "Repeated gmean μs",
            "Compile median ms",
            "Compile share median",
            "Score v1",
        ],
    )

    if isempty(failures) && length(cells) == scenario_count
        global_score = geometric_mean([cell.score for cell in cells])
        print_section(
            stdout,
            "Global Score v1",
            "$scenario_count selected scenario scores · backends: $backend_names",
        )
        print_accent(stdout, "  ", crayon"bold")
        print_accent(stdout, @sprintf("%.2f", global_score), crayon"bold green")
        println("  higher is better")
    else
        print_section(
            stdout, "Global Score v1", "unavailable because one or more scenarios failed"
        )
        print_accent(stdout, "  UNAVAILABLE", crayon"bold red")
        println()
        println("  Failures:")
        foreach(message -> println("  - ", message), failures)
    end
    println(
        "  TPFT has 2:1 weight over repeated time; compilation is already included in TPFT."
    )
    println("  Score v1 is comparable only with the same selected backend set.")
    println(
        "  TPFT excludes Julia startup/package loading; every trial is a fresh process."
    )
    return nothing
end

"""
    main(arguments::Vector{String}) -> Nothing

Dispatch `arguments` to the internal worker or public benchmark mode.
"""
function main(arguments::Vector{String})
    if !isempty(arguments) && arguments[1] == "--_worker"
        length(arguments) == 4 || error("invalid internal worker field count")
        repeats = parse_positive_integer("internal repeats", arguments[4])
        return render_worker(arguments[2], arguments[3], repeats)
    end

    options = parse_parent_arguments(arguments)
    if options.help
        print_help()
    else
        run_parent(options.trials, options.repeats, options.backends)
    end
    return nothing
end

try
    main(ARGS)
catch exception
    println(stderr, "error: ", sprint(showerror, exception))
    exit(1)
end

## Description #############################################################################
#
# Markdown Back End: Test highlighters.
#
############################################################################################

@testset "Highlighters" begin
    matrix = [
        1 2 3
        4 5 6
    ]

    expected = """
| **Col. 1** | **Col. 2** | **Col. 3** |
|-----------:|-----------:|-----------:|
|    ***1*** |        `2` |    ***3*** |
|        `4` |    ***5*** |        `6` |
"""

    md_bold        = MarkdownStyle(; bold = true)
    md_code        = MarkdownStyle(; code = true)
    md_bold_italic = MarkdownStyle(; bold = true, italic = true)

    result = pretty_table(
        String,
        matrix;
        backend = :markdown,
        highlighters = [
            MarkdownHighlighter(
                (data, i, j) -> data[i, j] % 2 == 0, (_, _, _, _) -> md_code
            )
            MarkdownHighlighter((data, i, j) -> data[i, j] % 2 == 0, md_bold)
            MarkdownHighlighter((data, i, j) -> data[i, j] % 2 != 0, md_bold_italic)
        ],
    )

    @test result == expected

    @testset "First Match Wins" begin
        # The applied style must be the one of the **first** matching highlighter.
        h1 = MarkdownHighlighter((d, i, j) -> true, MarkdownStyle(; bold = true))
        h2 = MarkdownHighlighter((d, i, j) -> true, MarkdownStyle(; strikethrough = true))

        result = pretty_table(String, [1]; backend = :markdown, highlighters = [h1, h2])

        @test occursin("**1**", result)
        @test !occursin("~~", result)
    end

    @testset "Highlighter Receives the Original Data" begin
        # The highlighter callbacks must see the object the user passed to `pretty_table`,
        # not the internal table wrapper, so that they are portable across back ends.
        data = (a = [1, 2],)
        seen = []

        h = MarkdownHighlighter(
            (d, i, j) -> (push!(seen, typeof(d)); false),
            MarkdownStyle(; bold = true),
        )

        pretty_table(String, data; backend = :markdown, highlighters = [h])

        @test !isempty(seen)
        @test all(==(typeof(data)), seen)
    end
end

## Description #############################################################################
#
# Text Back End: Test of horizontal lines.
#
############################################################################################

@testset "Horizontal Lines at Merged Column Labels" verbose = true begin
    matrix = [(i, j) for i in 1:4, j in 1:4]
    column_labels = [
        [MultiColumn(2, "Merged #1", :c), "Col. 3", "Col. 4"],
        ["Col. 1", "Col. 2", MultiColumn(2, "Merged #2", :c)],
        ["Col. 1", MultiColumn(3, "Merged #2", :c)],
        ["Col. 1", "Col. 2", "Col. 3", "Col. 4"],
    ]

    expected = """
┌─────────────────┬────────┬────────┐
│    Merged #1    │ Col. 3 │ Col. 4 │
│ ───────┬─────── │        │        │
│ Col. 1 │ Col. 2 │    Merged #2    │
│        │        │ ─────────────── │
│ Col. 1 │        Merged #2         │
│        │ ───────┬────────┬─────── │
│ Col. 1 │ Col. 2 │ Col. 3 │ Col. 4 │
├────────┼────────┼────────┼────────┤
│ (1, 1) │ (1, 2) │ (1, 3) │ (1, 4) │
│ (2, 1) │ (2, 2) │ (2, 3) │ (2, 4) │
│ (3, 1) │ (3, 2) │ (3, 3) │ (3, 4) │
│ (4, 1) │ (4, 2) │ (4, 3) │ (4, 4) │
└────────┴────────┴────────┴────────┘
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = column_labels,
        table_format = TextTableFormat(; horizontal_line_at_merged_column_labels = true),
    )

    @test result == expected

    expected = """
┌───────────────────────────────────┐
│    Merged #1      Col. 3   Col. 4 │
│ ───────────────                   │
│ Col. 1   Col. 2      Merged #2    │
│                   ─────────────── │
│ Col. 1          Merged #2         │
│          ──────────────────────── │
│ Col. 1   Col. 2   Col. 3   Col. 4 │
├────────┬────────┬────────┬────────┤
│ (1, 1) │ (1, 2) │ (1, 3) │ (1, 4) │
│ (2, 1) │ (2, 2) │ (2, 3) │ (2, 4) │
│ (3, 1) │ (3, 2) │ (3, 3) │ (3, 4) │
│ (4, 1) │ (4, 2) │ (4, 3) │ (4, 4) │
└────────┴────────┴────────┴────────┘
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = column_labels,
        table_format = TextTableFormat(;
            horizontal_line_at_merged_column_labels = true,
            suppress_vertical_lines_at_column_labels = true,
        ),
    )

    @test result == expected

    expected = """
┌─────────────────┬────────┬────────┐
│    Merged #1    │ Col. 3 │ Col. 4 │
│ ───────┬─────── │        │        │
│ Col. 1 │ Col. 2 │    Merged #2    │
├────────┼────────┴─────────────────┤
│ Col. 1 │        Merged #2         │
│        │ ───────┬────────┬─────── │
│ Col. 1 │ Col. 2 │ Col. 3 │ Col. 4 │
├────────┼────────┼────────┼────────┤
│ (1, 1) │ (1, 2) │ (1, 3) │ (1, 4) │
│ (2, 1) │ (2, 2) │ (2, 3) │ (2, 4) │
│ (3, 1) │ (3, 2) │ (3, 3) │ (3, 4) │
│ (4, 1) │ (4, 2) │ (4, 3) │ (4, 4) │
└────────┴────────┴────────┴────────┘
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = column_labels,
        table_format = TextTableFormat(;
            horizontal_line_at_merged_column_labels = true,
            horizontal_lines_at_column_labels = [2],
        ),
    )

    @test result == expected

    expected = """
┌───────────────────────────────────┐
│    Merged #1      Col. 3   Col. 4 │
│ ───────────────                   │
│ Col. 1   Col. 2      Merged #2    │
├───────────────────────────────────┤
│ Col. 1          Merged #2         │
│          ──────────────────────── │
│ Col. 1   Col. 2   Col. 3   Col. 4 │
├────────┬────────┬────────┬────────┤
│ (1, 1) │ (1, 2) │ (1, 3) │ (1, 4) │
│ (2, 1) │ (2, 2) │ (2, 3) │ (2, 4) │
│ (3, 1) │ (3, 2) │ (3, 3) │ (3, 4) │
│ (4, 1) │ (4, 2) │ (4, 3) │ (4, 4) │
└────────┴────────┴────────┴────────┘
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = column_labels,
        table_format = TextTableFormat(;
            horizontal_line_at_merged_column_labels  = true,
            horizontal_lines_at_column_labels        = [2],
            suppress_vertical_lines_at_column_labels = true,
        ),
    )

    @test result == expected
end

@testset "Horizontal Lines Do Not Mutate the Table Format" begin
    horizontal_lines = [1, 3]
    table_format = TextTableFormat(; horizontal_lines_at_column_labels = horizontal_lines)

    expected = """
┌───┬───┐
│ A │ B │
├───┼───┤
│ C │ D │
├───┼───┤
│ 1 │ 2 │
└───┴───┘
"""

    result = pretty_table(
        String, [1 2]; column_labels = [["A", "B"], ["C", "D"]], table_format = table_format
    )

    @test result == expected
    @test horizontal_lines == [1, 3]
end

@testset "Line Specifications as a Vector of Indices" verbose = true begin
    # `horizontal_lines_at_data_rows` and `vertical_lines_at_data_columns` accept either a
    # `Symbol` (`:all` / `:none`) or an explicit `Vector{Int}`. The vector branch is what
    # narrows the field type in the back end, and it must select exactly the requested rows
    # and columns.
    matrix = [1 2 3; 4 5 6]

    @testset "Vector of Indices" begin
        expected = """
┌────────┬────────────────┐
│ Col. 1 │ Col. 2  Col. 3 │
├────────┼────────────────┤
│      1 │      2       3 │
├────────┼────────────────┤
│      4 │      5       6 │
└────────┴────────────────┘
"""

        result = pretty_table(
            String,
            matrix;
            table_format = TextTableFormat(;
                horizontal_lines_at_data_rows  = [1],
                vertical_lines_at_data_columns = [1],
            ),
        )

        @test result == expected
    end

    @testset "All Lines" begin
        expected = """
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│      1 │      2 │      3 │
├────────┼────────┼────────┤
│      4 │      5 │      6 │
└────────┴────────┴────────┘
"""

        result = pretty_table(
            String,
            matrix;
            table_format = TextTableFormat(;
                horizontal_lines_at_data_rows  = :all,
                vertical_lines_at_data_columns = :all,
            ),
        )

        @test result == expected
    end
end

@testset "Merged Column Label Line With Leading Columns and Cropping" begin
    # The horizontal line drawn only under the merged column labels must skip the row number
    # and row label columns, and must also span the continuation column when the table is
    # horizontally cropped. Those three fill branches were never executed together.
    matrix = [1 2 3 4; 5 6 7 8]

    expected = """
┌─────┬────┬───────┬───┐
│ Row │    │   X   │ ⋯ │
│     │    │ ──┬── │───┤
│     │    │ a │ b │ ⋯ │
├─────┼────┼───┼───┼───┤
│   1 │ r1 │ 1 │ 2 │ ⋯ │
│   2 │ r2 │ 5 │ 6 │ ⋯ │
└─────┴────┴───┴───┴───┘
       2 columns omitted
"""

    result = pretty_table(
        String,
        matrix;
        column_labels = [
            [MultiColumn(2, "X"), MultiColumn(2, "Y")],
            ["a", "b", "c", "d"],
        ],
        table_format = TextTableFormat(; horizontal_line_at_merged_column_labels = true),
        show_row_number_column = true,
        row_labels = ["r1", "r2"],
        maximum_number_of_columns = 2,
    )

    @test result == expected
end

@testset "Horizontal Lines at All Column Labels" begin
    # `horizontal_lines_at_column_labels = :all` draws a line after every column label row
    # except the last, whose line is governed by
    # `horizontal_line_after_column_labels`. The `:all` branch had no coverage.
    expected = """
┌───┬───┐
│ A │ B │
├───┼───┤
│ a │ b │
├───┼───┤
│ 1 │ 2 │
│ 3 │ 4 │
└───┴───┘
"""

    result = pretty_table(
        String,
        [1 2; 3 4];
        column_labels = [["A", "B"], ["a", "b"]],
        table_format = TextTableFormat(; horizontal_lines_at_column_labels = :all),
    )

    @test result == expected
end

@testset "Horizontal Line at the Last Column Label" begin
    # A line at the last column label row is never drawn because it is governed by
    # `horizontal_line_after_column_labels`. Hence, it must not consume a display line when
    # fitting the table vertically.
    expected = """
┌────────┬────────┐
│ Col. 1 │ Col. 2 │
├────────┼────────┤
│     11 │     12 │
│     21 │     22 │
│     31 │     32 │
│     41 │     42 │
│     51 │     52 │
│     61 │     62 │
│     71 │     72 │
│      ⋮ │      ⋮ │
└────────┴────────┘
    23 rows omitted
"""

    result = pretty_table(
        String,
        [10i + j for i in 1:30, j in 1:2];
        display_size = (15, 80),
        fit_table_in_display_vertically = true,
        table_format = TextTableFormat(; horizontal_lines_at_column_labels = [1]),
    )

    @test result == expected
end

## Description #############################################################################
#
# LaTeX back end for PrettyTables.jl.
#
############################################################################################

function _latex__print(
    pspec::PrintingSpec;
    highlighters::Union{Nothing, Vector{LatexHighlighter}} = nothing,
    style::LatexTableStyle = LatexTableStyle(),
    table_format::LatexTableFormat = LatexTableFormat(),
)
    context    = pspec.context
    table_data = pspec.table_data
    # NOTE: `Val(pspec.renderer)` infers to the abstract `Val` because
    # `pspec.renderer` is a `Symbol`. Branching here keeps the renderer concrete, so the
    # per-cell rendering calls are statically dispatched.
    renderer   = pspec.renderer === :show ? Val(:show) : Val(:print)
    tf         = table_format

    ps     = PrintingTableState()
    buf_io = IOBuffer()
    buf    = IOContext(buf_io, context)

    # Reusable render buffer: one allocation per table instead of three per cell.
    rctx = RenderContext(context)

    # Process the horizontal lines at data rows.
    if tf.horizontal_lines_at_data_rows isa Symbol
        horizontal_lines_at_data_rows = if tf.horizontal_lines_at_data_rows == :all
            1:(table_data.num_rows)
        else
            1:0
        end
    else
        horizontal_lines_at_data_rows = tf.horizontal_lines_at_data_rows::Vector{Int}
    end

    # Process the vertical lines at data columns.
    if tf.vertical_lines_at_data_columns isa Symbol
        vertical_lines_at_data_columns = if tf.vertical_lines_at_data_columns == :all
            1:(table_data.num_columns)
        else
            1:0
        end
    else
        vertical_lines_at_data_columns = tf.vertical_lines_at_data_columns::Vector{Int}
    end

    # Check the style variables.
    if style.first_line_column_label isa Vector{LatexEnvironments}
        length(style.first_line_column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `first_line_column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    if style.column_label isa Vector{LatexEnvironments}
        length(style.column_label) != table_data.num_columns && throw(
            ArgumentError(
                "The length of `column_label` in `style` must be equal to the number of columns ($(table_data.num_columns)).",
            ),
        )
    end

    # == Variables to Store Information About Indentation ==================================

    il = 0 # ..................................................... Current indentation level
    ns = 2 # .................................... Number of spaces in each indentation level

    # == Print LaTeX Header ================================================================

    # Create the table header description for the current table.
    desc = _latex__table_header_description(table_data, tf, vertical_lines_at_data_columns)

    _aprintln(buf, "\\begin{tabular}{$desc}", il, ns)
    il += 1

    # == Table =============================================================================

    # Check if the user wants the omitted cell summary.
    ocs = _omitted_cell_summary(table_data, pspec)
    ocs_printed = false

    action = :initialize

    first_table_line = true
    first_element_in_row = true

    # This variable stores where a merged column label begins and ends. Hence, we are able
    # to draw a line after them if the user wants.
    merged_column_labels = Tuple{Int, Int}[]

    # The highlighters must receive the object the user passed to `pretty_table`, not the
    # internal table wrapper. Notice that this is loop invariant.
    orig_data = _get_data(table_data.data)

    while action != :end_printing
        action, rs, ps = _next(ps, table_data)

        action == :end_printing && break

        if action == :new_row
            empty!(merged_column_labels)
            first_element_in_row = true

            # If we are in the very first row after the title section, we need to check if
            # the user wants a horizontal line before the table.
            if (rs != :table_header) && first_table_line && tf.horizontal_line_at_beginning
                _aprintln(buf, tf.borders.top_line, il, ns)
                first_table_line = false
            end

            # Here, we just need to apply the indentation.
            print(buf, " "^(ns * il))

        elseif action == :end_row
            # Obtain the next row section since some decisions below depend on it. Notice
            # that this must be done here, and not once per action, because the lookahead is
            # a full run of the printing state iterator and only this branch consumes it.
            _, next_rs, _ = _next(ps, table_data)

            println(buf, " \\\\")

            # == Handle the Horizontal Lines ===============================================

            hline_str = ""

            # Print the horizontal line after the column labels.
            if (rs == :table_header) &&
                (next_rs != :table_header) &&
                tf.horizontal_line_at_beginning
                hline_str *= tf.borders.header_line
                first_table_line = false

            elseif (rs == :column_labels)
                if ps.row_section == :column_labels
                    if tf.horizontal_line_at_merged_column_labels
                        # The specification in `merged_column_labels` refers to the data
                        # columns. Hence, we need to add the offset regarding the previous
                        # columns if they exist.
                        Δc = table_data.show_row_number_column + _has_row_labels(table_data)
                        for m in merged_column_labels
                            c₀ = Δc + m[1]
                            c₁ = Δc + m[2]
                            hline_str *= "$(tf.borders.merged_header_cell_line){$c₀-$c₁}"
                        end
                    end
                else
                    if tf.horizontal_line_after_column_labels
                        hline_str *= tf.borders.header_line
                    end
                end

                # Check if the next line is a row group label and the user requests a
                # line before it.
            elseif (next_rs == :row_group_label) &&
                tf.horizontal_line_before_row_group_label
                hline_str *= tf.borders.middle_line

                # Check if we must print a horizontal line after the current data row.
            elseif (rs == :data) && (ps.i ∈ horizontal_lines_at_data_rows)
                hline_str *= tf.borders.middle_line

            elseif (
                (rs ∈ (:data, :continuation_row)) &&
                (next_rs ∈ (:summary_row, :table_footer, :end_printing)) &&
                tf.horizontal_line_after_data_rows
            )
                hline_str *= tf.borders.middle_line

            elseif (
                (rs ∈ (:data, :continuation_row)) &&
                (next_rs == :summary_row) &&
                tf.horizontal_line_before_summary_rows
            )
                hline_str *= tf.borders.middle_line

            elseif (rs == :row_group_label) && tf.horizontal_line_after_row_group_label
                hline_str *= tf.borders.header_line

                # Check if we must print the horizontal line at the end of the table.
            elseif (rs == :summary_row) &&
                (next_rs != :summary_row) &&
                tf.horizontal_line_after_summary_rows
                hline_str *= tf.borders.header_line
            end

            # If the next section is the end of the table and we need to draw a horizontal
            # line, we should change it to the bottom line.
            if next_rs ∈ (:table_footer, :end_printing) && !isempty(hline_str)
                hline_str = tf.borders.bottom_line
            end

            !isempty(hline_str) && _aprintln(buf, hline_str, il, ns)

            # == Omitted Cell Summary ======================================================

            if (!isempty(ocs) && next_rs ∈ (:table_footer, :end_printing) && !ocs_printed)
                cs = _number_of_printed_columns(table_data)
                ocs_styled = _latex__add_environments(ocs, style.omitted_cell_summary)

                # If the table footer will be printed afterward, we must end the current
                # tabular row. Otherwise, the footer cells would be printed in the same row,
                # leading to an invalid LaTeX document.
                has_footer = _has_footnotes(table_data) || !isempty(table_data.source_notes)
                line_end   = (next_rs == :table_footer) && has_footer ? " \\\\" : ""

                _aprintln(buf, "\\multicolumn{$cs}{r@{}}{$ocs_styled}$line_end", il, ns)
                ocs_printed = true
            end

        elseif action == :row_group_label
            cell          = _current_cell(action, ps, table_data)
            alignment     = _latex__alignment_to_str(
                _current_cell_alignment(action, ps, table_data)
            )
            rendered_cell = _latex__render_cell(cell, rctx, renderer)
            cs            = _number_of_printed_columns(table_data)

            # Check for vertical lines.
            vline_before = tf.vertical_line_at_beginning
            vline_after  = if _is_horizontally_cropped(table_data)
                tf.vertical_line_after_continuation_column
            else
                tf.vertical_line_after_data_columns
            end

            border₀ = vline_before ? "|" : ""
            border₁ = vline_after ? "|" : ""

            rgl_styled = _latex__add_environments(rendered_cell, style.row_group_label)
            print(buf, "\\multicolumn{$cs}{$border₀$alignment$border₁}{$rgl_styled}")

        else
            # Check for footnotes.
            footnotes    = _current_cell_footnotes(table_data, action, ps.i, ps.j)
            footnote_str = ""

            if !isnothing(footnotes) && !isempty(footnotes)
                footnote_str = "\$^{"
                for i in eachindex(footnotes)
                    f = footnotes[i]
                    if i != last(eachindex(footnotes))
                        footnote_str *= "$f,"
                    else
                        footnote_str *= "$f}\$"
                    end
                end
            end

            rendered_cell = nothing

            if action == :diagonal_continuation_cell
                rendered_cell = "\$\\ddots\$"

            elseif action == :horizontal_continuation_cell
                rendered_cell = "\$\\cdots\$"

            elseif action ∈ _VERTICAL_CONTINUATION_CELL_ACTIONS
                rendered_cell = "\$\\vdots\$"

            else
                cell = _current_cell(action, ps, table_data)

                cell === _IGNORE_CELL && continue

                # First, we handle merged cells.
                if (action ∈ (:title, :subtitle))
                    alignment = _latex__alignment_to_str(
                        action == :title ? table_data.title_alignment :
                        table_data.subtitle_alignment,
                    )

                    cs = _number_of_printed_columns(table_data)

                    rendered_cell = _latex__render_cell(cell, rctx, renderer)

                    rendered_cell = _latex__add_environments(
                        rendered_cell, action == :title ? style.title : style.subtitle
                    )

                    rendered_cell = rendered_cell * footnote_str
                    rendered_cell = "\\multicolumn{$cs}{@{}$alignment@{}}{$rendered_cell}"

                elseif (action == :column_label) && (cell isa MergeCells)
                    # Check if we have enough data columns to merge the cell.
                    num_data_columns = _number_of_printed_data_columns(table_data)

                    cs = if (ps.j + cell.column_span - 1) > num_data_columns
                        num_data_columns - ps.j + 1
                    else
                        cell.column_span
                    end

                    push!(merged_column_labels, (ps.j, ps.j + cs - 1))

                    alignment = _latex__alignment_to_str(cell.alignment)

                    # We must check if we have a vertical line after the cell merge.
                    vline =
                        if (
                            (ps.j + cs - 1 ∈ vertical_lines_at_data_columns) || (
                                (ps.j + cs - 1 == num_data_columns) &&
                                tf.vertical_line_after_data_columns
                            )
                        )
                            true
                        else
                            false
                        end

                    if vline
                        alignment *= "|"
                    end

                    # The `\multicolumn` command also overrides the vertical line at the
                    # table beginning, which belongs to the descriptor of the first column.
                    # Hence, we must reconstruct it here.
                    if (
                        (ps.j == 1) &&
                        !_has_row_labels(table_data) &&
                        !table_data.show_row_number_column &&
                        tf.vertical_line_at_beginning
                    )
                        alignment = "|" * alignment
                    end

                    rendered_cell = _latex__render_cell(cell.data, rctx, renderer)

                    # Apply the style to the text.
                    envs =
                        ps.i == 1 ? style.first_line_merged_column_label :
                        style.merged_column_label
                    rendered_cell = _latex__add_environments(rendered_cell, envs)
                    rendered_cell = rendered_cell * footnote_str

                    # Merge the cells.
                    rendered_cell = "\\multicolumn{$cs}{@{}$alignment@{}}{$rendered_cell}"

                    # Check if we must merge the cell to render the footnotes or source
                    # notes.
                elseif (action == :footnote)
                    alignment     = _latex__alignment_to_str(table_data.footnote_alignment)
                    cs            = _number_of_printed_columns(table_data)
                    rendered_cell =
                        "\$^{$(ps.i)}\$" * _latex__render_cell(cell, rctx, renderer)
                    rendered_cell = _latex__add_environments(rendered_cell, style.footnote)
                    rendered_cell = rendered_cell * footnote_str
                    rendered_cell = "\\multicolumn{$cs}{@{}$alignment@{}}{$rendered_cell}"

                elseif (action == :source_notes)
                    alignment     = _latex__alignment_to_str(table_data.footnote_alignment)
                    cs            = _number_of_printed_columns(table_data)
                    rendered_cell = _latex__render_cell(cell, rctx, renderer)
                    rendered_cell = _latex__add_environments(rendered_cell, style.source_note)
                    rendered_cell = rendered_cell * footnote_str
                    rendered_cell = "\\multicolumn{$cs}{@{}$alignment@{}}{$rendered_cell}"

                else
                    rendered_cell = _latex__render_cell(cell, rctx, renderer)
                    alignment = _current_cell_alignment(action, ps, table_data)

                    # Apply the style to the cell.
                    envs = nothing

                    # Get the environment of the cell, if any.
                    if action == :row_number_label
                        envs = style.row_number_label

                    elseif action == :row_number
                        envs = style.row_number

                    elseif action == :summary_row_number
                        envs = style.row_number

                    elseif action == :stubhead_label
                        envs = style.stubhead_label

                    elseif action == :row_label
                        envs = style.row_label

                    elseif action == :summary_row_label
                        envs = style.summary_row_label

                    elseif action == :column_label
                        envs = if ps.i == 1
                            if style.first_line_column_label isa Vector{LatexEnvironments}
                                style.first_line_column_label[ps.j]
                            else
                                style.first_line_column_label
                            end
                        else
                            if style.column_label isa Vector{LatexEnvironments}
                                style.column_label[ps.j]
                            else
                                style.column_label
                            end
                        end

                    elseif action == :summary_row_cell
                        envs = style.summary_row_cell

                    # Notice that `:footnote` and `:source_notes` cannot reach this point
                    # because they are fully consumed by the dedicated `\multicolumn`
                    # branches above.
                    else
                        # Here we have a data cell. Hence, let's check if we have a
                        # highlighter to apply.
                        if !isnothing(highlighters)
                            # Apply the highlighters in order, stopping at the first match.
                            for h in highlighters
                                if h.f(orig_data, ps.i, ps.j)
                                    envs = h.fd(h, orig_data, ps.i, ps.j)
                                    break
                                end
                            end
                        end
                    end

                    rendered_cell = _latex__add_environments(rendered_cell, envs)
                    rendered_cell = rendered_cell * footnote_str

                    # Check if we need to override the alignment. Notice that we must
                    # normalize the alignment symbols before comparing them because, e.g.,
                    # `:c` and `:C` lead to the same LaTeX column descriptor.
                    alignment_str = _latex__alignment_to_str(alignment)

                    if (
                        action == :data &&
                        alignment_str != _latex__alignment_to_str(
                            _data_column_alignment(table_data, ps.j)
                        )
                    )
                        # The `\multicolumn` command overrides the column descriptor in the
                        # preamble, including the vertical line after the cell. Hence, we
                        # must reconstruct it here. The vertical line before the cell
                        # belongs to the descriptor of the previous column, except when the
                        # cell is at the very first table column.
                        vline_before =
                            (ps.j == 1) &&
                            !_has_row_labels(table_data) &&
                            !table_data.show_row_number_column &&
                            tf.vertical_line_at_beginning

                        vline_after = (ps.j ∈ vertical_lines_at_data_columns) || (
                            (ps.j == _number_of_printed_data_columns(table_data)) &&
                            tf.vertical_line_after_data_columns
                        )

                        border₀ = vline_before ? "|" : ""
                        border₁ = vline_after ? "|" : ""

                        rendered_cell = "\\multicolumn{1}{$border₀$alignment_str$border₁}{$rendered_cell}"
                    end
                end
            end

            # If `rendered_cell` is `nothing`, we did not process the cell. Hence, we
            # should just skip.
            isnothing(rendered_cell) && continue

            if first_element_in_row
                first_element_in_row = false
            else
                print(buf, " & ")
            end

            print(buf, rendered_cell)
        end
    end

    il -= 1
    _aprintln(buf, "\\end{tabular}", il, ns)

    # == Print the Buffer Into the IO ======================================================

    output_str = String(take!(buf_io))

    if !pspec.new_line_at_end
        output_str = chomp(output_str)
    end

    print(context, output_str)

    return nothing
end

## Description #############################################################################
#
# Typst Back End: Test highlighters.
# 
############################################################################################

@testset "Highlighters" begin
    matrix = [
        1 2 3
        4 5 6
    ]
    backend = :typst

    expected = """
#{
  table(
    align: (right, right, right,),
    columns: (auto, auto, auto,),
    stroke: none,
    // == Horizontal Lines =================================================================
    table.hline(y: 0, stroke: 1.5pt,),
    table.hline(y: 1, stroke: 0.8pt,),
    table.hline(y: 3, stroke: 1.5pt,),
    // == Vertical Lines ===================================================================
    table.vline(x: 0, end: 3, stroke: 1.5pt),
    table.vline(x: 1, end: 3, stroke: 0.8pt),
    table.vline(x: 2, end: 3, stroke: 0.8pt),
    table.vline(x: 3, end: 3, stroke: 1.5pt),
    // == Table Header =====================================================================
    table.header(
      // -- Column Labels: Row 1 -----------------------------------------------------------
      [#text(weight: "bold",)[Col. 1]],
      [#text(weight: "bold",)[Col. 2]],
      [#text(weight: "bold",)[Col. 3]],
    ),
    // == Table Body =======================================================================
    // -- Data: Row 1 ----------------------------------------------------------------------
    [#text(weight: "bold", fill: green,)[1]],
    [#text(fill: red,)[2]],
    [#text(weight: "bold", fill: green,)[3]],
    // -- Data: Row 2 ----------------------------------------------------------------------
    [#text(fill: red,)[4]],
    [#text(weight: "bold", fill: green,)[5]],
    [#text(fill: red,)[6]],
  )
}
"""

    result = pretty_table(
        String,
        matrix;
        backend,
        highlighters = [
            TypstHighlighter((data, i, j) -> data[i, j] % 2 == 0, ["text-fill" => "red"]),
            TypstHighlighter((data, i, j) -> data[i, j] % 2 == 0, ["text-fill" => "blue"]),
            TypstHighlighter(
                (data, i, j) -> data[i, j] % 2 != 0,
                ["text-weight" => "bold", "text-fill" => "green"],
            ),
        ],
    )

    @test result == expected

    result = pretty_table(
        String,
        matrix;
        backend,
        highlighters = [
            TypstHighlighter(
                (data, i, j) -> data[i, j] % 2 == 0, (_, _, _, _) -> ["text-fill" => "red"]
            ),
            TypstHighlighter((data, i, j) -> data[i, j] % 2 == 0, ["text-fill" => "blue"]),
            TypstHighlighter(
                (data, i, j) -> data[i, j] % 2 != 0,
                ["text-weight" => "bold"],
                "text-fill" => "green",
            ),
        ],
    )

    @test result == expected

    @testset "First Match Wins" begin
        # The applied style must be the one of the **first** matching highlighter.
        h1 = TypstHighlighter((d, i, j) -> true, ["text-fill" => "red"])
        h2 = TypstHighlighter((d, i, j) -> true, ["text-fill" => "blue"])

        result = pretty_table(String, [1]; backend = :typst, highlighters = [h1, h2])

        @test occursin("red", result)
        @test !occursin("blue", result)
    end

    @testset "Highlighter Receives the Original Data" begin
        # The highlighter callbacks must see the object the user passed to `pretty_table`,
        # not the internal table wrapper, so that they are portable across back ends.
        data = (a = [1, 2],)
        seen = []

        h = TypstHighlighter(
            (d, i, j) -> (push!(seen, typeof(d)); false),
            ["text-fill" => "red"],
        )

        pretty_table(String, data; backend = :typst, highlighters = [h])

        @test !isempty(seen)
        @test all(==(typeof(data)), seen)
    end
end

## Description #############################################################################
#
# HTML Back End: Test footnotes.
#
############################################################################################

@testset "Footnotes at Summary Row Labels" begin
    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th class = "stubheadLabel" style = "font-weight: bold; text-align: right;"></th>
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;"></td>
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">2</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;"></td>
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">4</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Sum</td>
      <td style = "text-align: right;">4</td>
      <td style = "text-align: right;">6</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Max<sup>1</sup></td>
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">4</td>
    </tr>
  </tbody>
  <tfoot>
    <tr class = "footnote">
      <td colspan = "3" style = "font-size: small; text-align: left;"><sup>1</sup> Footnote in summary row label</td>
    </tr>
  </tfoot>
</table>
"""

    result = pretty_table(
        String,
        [1 2; 3 4];
        backend = :html,
        footnotes = [(:summary_row_label, 2, 0) => "Footnote in summary row label"],
        summary_rows = [(data, i) -> sum(data[:, i]), (data, i) -> maximum(data[:, i])],
        summary_row_labels = ["Sum", "Max"],
    )

    @test result == expected
end

using Documenter
using PrettyTables

#! format: off

makedocs(
    modules = [PrettyTables],
    format = Documenter.HTML(
        prettyurls = !("local" in ARGS),
        canonical = "https://ronisbr.github.io/PrettyTables.jl/stable/",
        size_threshold_warn = 1024 * 1024 * 1024,
        size_threshold = 10 * 1024 * 1024 * 1024,
    ),
    sitename = "Pretty Tables",
    authors = "Ronan Arraes Jardim Chagas",
    warnonly = [:missing_docs, :cross_references],
    pages = [
        "Home"                        => "index.md",
        "Quick Start"                 => "man/quick_start.md",
        "Usage"                       => "man/usage.md",
        "Back Ends"                   => Any[
            "Text"                    => Any[
                "Text Backend"        => "man/text/text_backend.md",
                "Pre-defined Formats" => "man/text/predefined_formats.md",
                "Examples"            => "man/text/text_examples.md",
            ],
            "HTML"                    => Any[
                "HTML Backend"        => "man/html/html_backend.md",
                "Examples"            => "man/html/html_examples.md",
            ],
            "LaTeX"                   => Any[
                "LaTeX Backend"       => "man/latex/latex_backend.md",
                "Examples"            => "man/latex/latex_examples.md",
            ],
            "Markdown"                => Any[
                "Markdown Backend"    => "man/markdown/markdown_backend.md",
                "Examples"            => "man/markdown/markdown_examples.md",
            ],
            "Typst"                   => Any[
               "Typst Backend"       => "man/typst/typst_backend.md",
            ],
            "Excel"                   => Any[
                "Excel Backend"       => "man/excel/excel_backend.md",
                "Examples"            => "man/excel/excel_examples.md",
            ],
        ],
        "Library"                     => "lib/library.md",
    ],
 )

deploydocs(
    repo = "github.com/ronisbr/PrettyTables.jl.git",
    target = "build",
)

#! format: on

## Description #############################################################################
#
# Test errors and exceptions regarding text backend.
#
############################################################################################

struct MyCustomCell <: AbstractCustomTextCell end

@testset "Errors" verbose = true begin
    @testset "CustomCells" begin
        mcc = MyCustomCell()

        @test_throws Exception CustomTextCell.add_suffix!(mcc, "suffix")
        @test_throws Exception CustomTextCell.crop!(mcc, 10)
        @test_throws Exception CustomTextCell.init!(mcc, IOContext(IOBuffer()), Val(:print))
        @test_throws Exception CustomTextCell.init!(mcc, IOContext(IOBUffer()), Val(:show))
        @test_throws Exception CustomTextCell.left_padding!(mcc, 10)
        @test_throws Exception CustomTextCell.right_padding!(mcc, 10)
        @test_throws Exception CustomTextCell.rendered_cell(mcc)
        @test_throws Exception CustomTextCell.printable_cell_text(mcc)
    end
end

## Description #############################################################################
#
# Private functions for the Typst back end.
#
############################################################################################

# == Typstry.jl Integration ================================================================

"""
    _typst__is_raw_typst_cell(cell::Any) -> Bool

Return whether the `cell` content must be treated as a raw Typst component. This function is
overloaded by the Typstry.jl extension for `TypstString` cells.
"""
_typst__is_raw_typst_cell(::Any) = false

"""
    _typst__display(output_str::String) -> Bool

Try to display the rendered table `output_str` using the available displays. This function
returns whether the table was displayed. If Typstry.jl is loaded, the extension renders the
table as an image, provided that the current display supports it.
"""
function _typst__display(output_str::String)
    ext = Base.get_extension(PrettyTables, :PrettyTablesTypstryExt)
    isnothing(ext) && return false
    return ext._typst__display(output_str)::Bool
end

# == Alignment =============================================================================

"""
    _typst__alignment(a::Symbol) -> String

Get the Typst alignment string corresponding to the given alignment symbol `a`. If the
alignment symbol is not recognized, it defaults to "right".
"""
_typst__alignment(a::Symbol) = get(_TYPST__ALIGNMENT_MAP, a, "right")

"""
    _typst__alignment_configuration(td::TableData) -> String

Create the Typst alignment configuration string for the given `td::TableData`.
"""
function _typst__alignment_configuration(td::TableData)
    num_columns = td.num_columns

    alignment_str = IOBuffer(; sizehint = 8num_columns)

    # == Row Number Column =================================================================

    td.show_row_number_column &&
        print(alignment_str, _typst__alignment(_row_number_column_alignment(td)) * ", ")

    # == Row Labels ========================================================================

    _has_row_labels(td) &&
        print(alignment_str, _typst__alignment(_row_label_column_alignment(td)) * ", ")

    # == Data Columns ======================================================================

    nc = _number_of_printed_data_columns(td)

    for i in 1:nc
        print(alignment_str, _typst__alignment(_data_column_alignment(td, i)) * ", ")
    end

    # == Continuation Column ===============================================================

    nc < num_columns && print(alignment_str, _typst__alignment(:c) * ", ")

    return String(take!(alignment_str)) |> rstrip
end

# == Attributes ============================================================================

"""
    _typst__cell_and_text_properties(
        vproperties::Vector{TypstPair}
    ) -> Tuple{Vector{TypstPair}, Vector{TypstPair}}

Split `vproperties` into the properties that must be applied to the Typst `table.cell` and
those that must be applied to the text content.

The first returned vector contains only attributes listed in `_TYPST__CELL_ATTRIBUTES`. The
second returned vector contains only valid text properties prefixed with `text-`, with this
prefix removed.
"""
function _typst__cell_and_text_properties(vproperties::Vector{TypstPair})
    # Most data cells have no properties at all. Hence, we return shared empty vectors to
    # avoid two allocations per cell. Notice that the callers must not mutate the returned
    # vectors.
    isempty(vproperties) && return _TYPST__EMPTY_PROPERTIES, _TYPST__EMPTY_PROPERTIES

    # Separate cell and text attributes in a single pass to reduce allocations.
    cell_properties = TypstPair[]
    text_properties = TypstPair[]
    sizehint!(cell_properties, length(vproperties))
    sizehint!(text_properties, length(vproperties))

    for (k, v) in vproperties
        if k ∈ _TYPST__CELL_ATTRIBUTES
            push!(cell_properties, k => v)
        end

        if startswith(k, "text-")
            text_key = SubString(k, 6)
            text_key ∈ _TYPST__TEXT_ATTRIBUTES &&
                push!(text_properties, String(text_key) => v)
        end
    end

    return cell_properties, text_properties
end

# == Cells =================================================================================

"""
    _typst__print_cell(
        io::IO,
        cell::String,
        first_column::Bool,
        il::Int,
        ns::Int,
        minify::Bool
    )

Print a table cell to the output stream in Typst format.

# Arguments

- `io::IO`: The output stream where the cell will be printed.
- `cell::String`: The content of the cell to be printed.
- `first_column::Bool`: Whether this cell is in the first column.
- `il::Int`: The indentation level for formatting.
- `ns::Int`: The number of spaces for indentation.
- `minify::Bool`: If `true`, prints the cell in minified format.
"""
function _typst__print_cell(
    io::IO, cell::String, first_column::Bool, il::Int, ns::Int, minify::Bool
)
    # Notice that the trailing comma is printed separately to avoid allocating a new string
    # per cell.
    if !minify
        _aprint(io, cell, il, ns)
        println(io, ',')
        return nothing
    end

    first_column || print(io, " ")
    print(io, cell)
    print(io, ',')
    return nothing
end

"""
    _typst__table_cell(
        content::String[, properties::Vector{TypstPair}];
        kwargs...
    ) -> String

Create a Typst table cell with `content` and optional `properties`. If `properties` is not
provided or empty, a basic cell is created with the content. If `properties` are provided, a
`table.cell` component is created with the content and properties.

# Keywords

- `il::Int`: Indentation level for formatting.
    (**Default**: 2)
- `ns::Int`: Number of spaces for indentation.
    (**Default**: 2)
- `wrap_column::Int`: Column width threshold for wrapping content.
    (**Default**: 92)
"""
function _typst__table_cell(
    content::String,
    properties::Vector{TypstPair};
    il::Int = 2,
    ns::Int = 2,
    wrap_column::Int = 92,
)
    isempty(properties) && return _typst__table_cell(content; il, ns, wrap_column)
    return _typst__create_component("table.cell", content, properties; il, ns, wrap_column)
end

function _typst__table_cell(
    content::String; il::Int = 2, ns::Int = 2, wrap_column::Int = 92
)
    cl = length(content)
    id_str = repeat(" ", ns)

    _typst__should_wrap(cl, il, ns, wrap_column) && return "[\n$id_str$content\n]"
    return "[$content]"
end

# == Components ============================================================================

"""
    _typst__create_component(component::String, content::String; kwargs...) -> String

Create a Typst `component` with the `content`.

# Keywords

- `il::Int`: Indentation level for formatting.
    (**Default**: 0)
- `ns::Int`: Number of spaces in each indentation level.
    (**Default**: 2)
- `wrap_column::Int`: Column width threshold for wrapping the content.
    (**Default**: 92)
"""
function _typst__create_component(
    component::String,
    content::String,
    properties::Union{Nothing, Vector{TypstPair}} = nothing;
    il::Int = 0,
    ns::Int = 2,
    wrap_column::Int = 92,
)
    open_tag = _typst__open_component(component, properties)

    line_length = length(open_tag) + length(content) + 1

    !_typst__should_wrap(line_length, il, ns, wrap_column) &&
        return open_tag * content * "]"

    buf = IOBuffer()

    println(buf, open_tag)

    # Notice that we must print at the first indentation level because this text will also
    # be indented when printing to the output buffer.
    _aprintln(buf, content, 1, ns)
    print(buf, "]")

    return String(take!(buf))
end

"""
    _typst__open_component(
        component::String,
        properties::Union{Nothing, Vector{TypstPair}} = nothing
    ) -> String

Create the string that opens the Typst `component` with the given `properties`.
"""
function _typst__open_component(
    component::String, properties::Union{Nothing, Vector{TypstPair}} = nothing
)
    prop_str = isnothing(properties) ? "" : "($(_typst__property_list(properties)))"
    return "$component$prop_str["
end

"""
    _typst__property_list(properties::Vector{TypstPair}) -> String

Create a Typst property list string from the given vector of `properties`.
"""
function _typst__property_list(properties::Vector{TypstPair})
    buf = IOBuffer(; sizehint = length(properties) * 32)
    first_prop = true

    for (k, v) in properties
        !first_prop && print(buf, " ")
        first_prop = false

        print(buf, k)

        if !isempty(v)
            starts_with_digit = isdigit(first(v))
            needs_quote = !starts_with_digit && (k ∈ _TYPST__STRING_ATTRIBUTES)

            # The property values are emitted in Typst code mode. Hence, we must not apply
            # the markup escaping here. If the value is emitted inside a string literal, we
            # only need to escape the backslash and the double quote.
            v_str = needs_quote ? _typst__escape_string_literal(v) : v

            print(buf, ": ")
            needs_quote && print(buf, "\"")
            print(buf, v_str)
            needs_quote && print(buf, "\"")
        end

        print(buf, ",")
    end

    return String(take!(buf))
end

"""
    _typst__process_caption(c::TypstCaption, il::Int) -> String

Convert a `TypstCaption` into a string with the corresponding Typst configuration. The `il`
parameter indicates the indentation level for the generated string.
"""
function _typst__process_caption(c::TypstCaption, il::Int)
    (; caption, kind, supplement, gap, position) = c

    ind = " "^max(il, 0)
    buf = IOBuffer()

    @_println(buf, "caption: figure.caption(")

    !isnothing(position) && @_println(buf, ind, "position: ", position, ",")

    @_println(buf, ind, "[", _typst__escape_str(caption), "]")
    @_println(buf, "),")

    if kind ∉ ("table", "auto", "image")
        @_println(buf, "kind: \"", _typst__escape_string_literal(kind), "\",")
        @_println(
            buf,
            "supplement: [",
            _typst__escape_str(something(supplement, titlecase(kind))),
            "],"
        )
    else
        @_println(buf, "kind: ", kind, ",")
        !isnothing(supplement) &&
            @_println(buf, "supplement: [", _typst__escape_str(supplement), "],")
    end

    gap != "auto" && @_println(buf, "gap: ", gap, ",")

    return String(take!(buf))
end

"""
    _typst__text(content::String, properties::Union{Vector{TypstPair}, Nothing}) -> String

Convert the `content` to Typst format with optional styling `properties`. If `properties`
is empty or `nothing` (default), the function returns the content unchanged.  Otherwise, it
creates a Typst `#text` component with the specified properties.
"""
_typst__text(content::String, ::Nothing) = content

function _typst__text(content::String, properties::Vector{TypstPair})
    (isempty(properties) || isempty(content)) && return _typst__text(content, nothing)
    return _typst__create_component("#text", content, properties; wrap_column = -1)
end

# == Lines =================================================================================

"""
    _typst__vertical_lines!(
        buf::IO,
        td::TableData,
        tf::TypstTableFormat,
        total_inner_table_lines::Int,
        vertical_lines_at_data_columns::AbstractVector{Int},
        il::Int,
        ns::Int
    ) -> Nothing

Print to `buf` the Typst vertical lines configurations considering the table data `td` and
table format `tf`. `total_inner_table_lines` is the total number of rows in the inner table
(excluding title, subtitle, footnote, and source note rows).
`vertical_lines_at_data_columns` contains the indices of data columns that require a
vertical line on their right side. `il` and `ns` are the indentation level and number of
spaces per indentation level, respectively.
"""
function _typst__vertical_lines!(
    buf::IO,
    td::TableData,
    tf::TypstTableFormat,
    total_inner_table_lines::Int,
    vertical_lines_at_data_columns::AbstractVector{Int},
    il::Int,
    ns::Int,
)
    num_columns = td.num_columns
    borders     = tf.borders

    current_typst_column = 0

    # We must skip the title and subtitles since they must not have vertical lines.
    has_title    = !isempty(td.title)
    has_subtitle = !isempty(td.subtitle)

    vs = has_title + has_subtitle
    nr = vs + total_inner_table_lines

    # Pre-compute padding once to avoid repeated allocation in each vline call.
    padding = " "^max(il * ns, 0)

    # Print a vline entry directly to avoid intermediate string and split allocations.
    _vline(x, stroke) = begin
        # Using only one argument in `print` to avoid intermediate string allocations.
        if vs == 0
            @_println(
                buf,
                padding,
                "table.vline(x: ",
                x,
                ", end: ",
                nr,
                ", stroke: ",
                stroke,
                "),"
            )
            return nothing
        end

        @_println(
            buf,
            padding,
            "table.vline(x: ",
            x,
            ", start: ",
            vs,
            ", end: ",
            nr,
            ", stroke: ",
            stroke,
            "),"
        )
        return nothing
    end

    # == Table Beginning ===================================================================

    tf.vertical_line_at_beginning && _vline(current_typst_column, borders.left_line)

    # == Row Number Column =================================================================

    if td.show_row_number_column
        current_typst_column += 1
        tf.vertical_line_after_row_number_column &&
            _vline(current_typst_column, borders.center_line)
    end

    # == Row Labels ========================================================================

    if _has_row_labels(td)
        current_typst_column += 1
        tf.vertical_line_after_row_label_column &&
            _vline(current_typst_column, borders.center_line)
    end

    # == Data Columns ======================================================================

    nc = _number_of_printed_data_columns(td)

    for i in 1:nc
        current_typst_column += 1

        format = borders.center_line
        vline  = i in vertical_lines_at_data_columns

        if ((i == nc) && tf.vertical_line_after_data_columns)
            # If we have the continuation line, we must use the middle line here.
            format = nc < num_columns ? borders.center_line : borders.right_line
            vline = true
        end

        vline && _vline(current_typst_column, format)
    end

    # == Continuation Column ===============================================================

    if nc < num_columns
        current_typst_column += 1
        tf.vertical_line_after_continuation_column &&
            _vline(current_typst_column, borders.right_line)
    end

    return nothing
end

# == Strings ===============================================================================

# ASCII characters that carry a special meaning in Typst markup and, hence, must be escaped
# with a backslash when they occur inside a cell. Notice that the cell content is emitted
# inside a Typst content block (`[...]`), meaning that an unbalanced `[` or `]` silently
# breaks the entire document.
const _TYPST__ESCAPED_CHARACTERS = ('\\', '#', '[', ']', '*', '_', '$', '<', '>', '@', '`', '~')

"""
    _typst__escape_str(io::IO, s::AbstractString) -> Nothing
    _typst__escape_str(s::AbstractString) -> String

Print the string `s` in `io` escaping the characters for the Typst backend. If `io` is
omitted, the escaped string is returned.
"""
function _typst__escape_str(io::IO, s::AbstractString)
    for c in s
        if Base.isascii(c)
            # Notice that Typst has no `\xNN` escape sequence. Hence, the non-printable
            # characters must be emitted using the `\u{...}` escape sequence.
            c ∈ _TYPST__ESCAPED_CHARACTERS ? print(io, '\\', c) :
            isprint(c) ? print(io, c) : print(io, "\\u{", string(UInt32(c); base = 16), "}")

        elseif !Base.isoverlong(c) && !Base.ismalformed(c)
            isprint(c) ? print(io, c) : print(io, "\\u{", string(UInt32(c); base = 16), "}")

        else # malformed or overlong
            # We cannot represent these bytes in a valid Typst document. Hence, we replace
            # each one with the Unicode replacement character.
            u = bswap(reinterpret(UInt32, c))
            while true
                print(io, '\ufffd')
                (u >>= 8) == 0 && break
            end
        end
    end
end

function _typst__escape_str(s::AbstractString)
    return sprint(_typst__escape_str, s; sizehint = 2 * lastindex(s))
end

"""
    _typst__escape_string_literal(s::AbstractString) -> String

Escape `s` so that it can be embedded inside a Typst **string literal** (`"..."`).

Notice that this is a different context from the one `_typst__escape_str` handles. Inside a
string literal only the backslash and the double quote are special, and an unescaped double
quote terminates the literal, breaking the document.
"""
function _typst__escape_string_literal(s::AbstractString)
    buf = IOBuffer(; sizehint = lastindex(s))

    for c in s
        (c == '\\') || (c == '"') ? print(buf, '\\', c) : print(buf, c)
    end

    return String(take!(buf))
end

"""
    _typst__should_wrap(str_length::Int, il::Int, ns::Int, wrap_column::Int) -> Bool

Determine whether a string with length `str_length` should be wrapped in Typst backend based
on length constraints. The current indentation level of the string is determined by `il`,
the number of spaces per indentation level is `ns`, and the maximum column width for
wrapping is `wrap_column`.
"""
function _typst__should_wrap(str_length::Int, il::Int, ns::Int, wrap_column::Int)
    indentation_length = (il - 1) * ns
    return (wrap_column >= 0) && (indentation_length + str_length) > wrap_column
end

# == Styles ================================================================================

"""
    _typst__get_data_column_widths(table_data::TableData[, data_column_widths]) -> String

Generate a Typst column width specification string for a table specified by `table_data`.
`data_column_widths` must be an iterable of width specifications for data columns. Each
element should be a width value compatible with Typst format (e.g., "auto", "1fr", "2cm").
If `data_column_widths` is `nothing` (default), it defaults to "auto" for all columns.
"""
function _typst__get_data_column_widths(table_data::TableData, ::Nothing)
    return _typst__get_data_column_widths(
        table_data, Base.Iterators.repeated("auto", table_data.num_columns)
    )
end

function _typst__get_data_column_widths(table_data::TableData, data_column_widths)
    buf = IOBuffer(; sizehint = 8 * (table_data.num_columns + 3) + 2)

    print(buf, "(")

    # == Row Number Column =================================================================

    table_data.show_row_number_column && print(buf, "auto, ")

    # == Row Labels ========================================================================

    _has_row_labels(table_data) && print(buf, "auto, ")

    # == Data Columns ======================================================================

    num_printed_data_columns = _number_of_printed_data_columns(table_data)

    i = 1
    for width in data_column_widths
        @_print(buf, width, ",")
        i += 1
        i > num_printed_data_columns && break
        print(buf, " ")
    end

    # == Continuation Column ===============================================================

    num_printed_data_columns < table_data.num_columns && print(buf, " auto,")

    print(buf, ")")

    return String(take!(buf))
end

"""
    _typst__merge_properties!(
        bproperties::Vector{TypstPair},
        nproperties::Vector{TypstPair}
    ) -> Vector{TypstPair}

Merge two Typst properties, `bproperties` and `nproperties`, giving priority to
`nproperties` in case of conflicts.
"""
function _typst__merge_properties!(
    bproperties::Vector{TypstPair}, nproperties::Vector{TypstPair}
)
    # NOTE: `first.(nproperties)` would allocate a `Vector{String}` on every merge. Scanning
    # `nproperties` directly avoids it, and the vectors involved are tiny.
    filter!(bproperties) do l
        k = first(l)

        for np in nproperties
            first(np) == k && return false
        end

        return true
    end

    append!(bproperties, nproperties)

    return bproperties
end

## Description #############################################################################
#
# HTML Back End: Test showing all the available fields.
#
############################################################################################

@testset "All Available Fields" verbose = true begin
    matrix = [(i, j) for i in 1:4, j in 1:4]

    @testset "Without Cropping" begin
        expected = """
<table>
  <thead>
    <tr class = "title">
      <td colspan = "6" style = "font-size: x-large; font-weight: bold; text-align: center;">Table Title</td>
    </tr>
    <tr class = "subtitle">
      <td colspan = "6" style = "font-size: large; font-style: italic; text-align: center;">Table Subtitle</td>
    </tr>
    <tr class = "columnLabelRow">
      <th class = "rowNumberLabel" style = "font-weight: bold; text-align: right;">Row</th>
      <th class = "stubheadLabel" style = "font-weight: bold; text-align: right;">Rows</th>
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th colspan = "2" style = "border-bottom: 1px solid black; font-weight: bold; text-align: center;">Merged Column<sup>1</sup></th>
      <th style = "font-weight: bold; text-align: right;">Col. 4</th>
    </tr>
    <tr class = "columnLabelRow">
      <th class = "rowNumberLabel" style = "font-weight: bold; text-align: right;"></th>
      <th class = "stubheadLabel" style = "font-weight: bold; text-align: right;"></th>
      <th style = "text-align: right;">1</th>
      <th style = "text-align: right;">2</th>
      <th style = "text-align: right;">3</th>
      <th style = "text-align: right;">4</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">1</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 1</td>
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td style = "text-align: right;">(1, 4)</td>
    </tr>
    <tr class = "rowGroupLabel">
      <td colspan = "6" style = "font-weight: bold; text-align: left;">Row Group</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">2</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 2</td>
      <td style = "text-align: right;">(2, 1)</td>
      <td style = "text-align: right;">(2, 2)<sup>2</sup></td>
      <td style = "text-align: right;">(2, 3)</td>
      <td style = "text-align: right;">(2, 4)</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">3</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 3</td>
      <td style = "text-align: right;">(3, 1)</td>
      <td style = "text-align: right;">(3, 2)</td>
      <td style = "text-align: right;">(3, 3)</td>
      <td style = "text-align: right;">(3, 4)</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">4</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 4</td>
      <td style = "text-align: right;">(4, 1)</td>
      <td style = "text-align: right;">(4, 2)</td>
      <td style = "text-align: right;">(4, 3)</td>
      <td style = "text-align: right;">(4, 4)</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowNumber" style = "font-weight: bold; text-align: right;"></td>
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Summary 1</td>
      <td style = "text-align: right;">10</td>
      <td style = "text-align: right;">20</td>
      <td style = "text-align: right;">30</td>
      <td style = "text-align: right;">40</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowNumber" style = "font-weight: bold; text-align: right;"></td>
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Summary 2</td>
      <td style = "text-align: right;">20</td>
      <td style = "text-align: right;">40</td>
      <td style = "text-align: right;">60</td>
      <td style = "text-align: right;">80</td>
    </tr>
  </tbody>
  <tfoot>
    <tr class = "footnote">
      <td colspan = "6" style = "font-size: small; text-align: left;"><sup>1</sup> Footnote in column label</td>
    </tr>
    <tr class = "footnote">
      <td colspan = "6" style = "font-size: small; text-align: left;"><sup>2</sup> Footnote in data</td>
    </tr>
    <tr class = "sourceNotes">
      <td colspan = "6" style = "color: gray; font-size: small; font-style: italic; text-align: left;">Source Notes</td>
    </tr>
  </tfoot>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            column_labels = [["Col. $i" for i in 1:4], ["$i" for i in 1:4]],
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
        )

        @test result == expected
    end

    @testset "With Bottom Cropping" begin
        expected = """
<div>
  <div style = "float: right; font-style: italic;">
    <span>2 columns and 2 rows omitted</span>
  </div>
  <div style = "clear: both;"></div>
</div>
<table>
  <thead>
    <tr class = "title">
      <td colspan = "5" style = "font-size: x-large; font-weight: bold; text-align: center;">Table Title</td>
    </tr>
    <tr class = "subtitle">
      <td colspan = "5" style = "font-size: large; font-style: italic; text-align: center;">Table Subtitle</td>
    </tr>
    <tr class = "columnLabelRow">
      <th class = "rowNumberLabel" style = "font-weight: bold; text-align: right;">Row</th>
      <th class = "stubheadLabel" style = "font-weight: bold; text-align: right;">Rows</th>
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th colspan = "1" style = "border-bottom: 1px solid black; font-weight: bold; text-align: center;">Merged Column<sup>1</sup></th>
      <th>&ctdot;</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">1</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 1</td>
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td>&ctdot;</td>
    </tr>
    <tr class = "rowGroupLabel">
      <td colspan = "5" style = "font-weight: bold; text-align: left;">Row Group</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">2</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 2</td>
      <td style = "text-align: right;">(2, 1)</td>
      <td style = "text-align: right;">(2, 2)<sup>2</sup></td>
      <td>&ctdot;</td>
    </tr>
    <tr>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td>&dtdot;</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowNumber" style = "font-weight: bold; text-align: right;"></td>
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Summary 1</td>
      <td style = "text-align: right;">10</td>
      <td style = "text-align: right;">20</td>
      <td>&ctdot;</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowNumber" style = "font-weight: bold; text-align: right;"></td>
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Summary 2</td>
      <td style = "text-align: right;">20</td>
      <td style = "text-align: right;">40</td>
      <td>&ctdot;</td>
    </tr>
  </tbody>
  <tfoot>
    <tr class = "footnote">
      <td colspan = "5" style = "font-size: small; text-align: left;"><sup>1</sup> Footnote in column label</td>
    </tr>
    <tr class = "footnote">
      <td colspan = "5" style = "font-size: small; text-align: left;"><sup>2</sup> Footnote in data</td>
    </tr>
    <tr class = "sourceNotes">
      <td colspan = "5" style = "color: gray; font-size: small; font-style: italic; text-align: left;">Source Notes</td>
    </tr>
  </tfoot>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
        )

        @test result == expected
    end

    @testset "With Middle Cropping" begin
        expected = """
<div>
  <div style = "float: right; font-style: italic;">
    <span>2 columns and 2 rows omitted</span>
  </div>
  <div style = "clear: both;"></div>
</div>
<table>
  <thead>
    <tr class = "title">
      <td colspan = "5" style = "font-size: x-large; font-weight: bold; text-align: center;">Table Title</td>
    </tr>
    <tr class = "subtitle">
      <td colspan = "5" style = "font-size: large; font-style: italic; text-align: center;">Table Subtitle</td>
    </tr>
    <tr class = "columnLabelRow">
      <th class = "rowNumberLabel" style = "font-weight: bold; text-align: right;">Row</th>
      <th class = "stubheadLabel" style = "font-weight: bold; text-align: right;">Rows</th>
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th colspan = "1" style = "border-bottom: 1px solid black; font-weight: bold; text-align: center;">Merged Column<sup>1</sup></th>
      <th>&ctdot;</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">1</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 1</td>
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td>&ctdot;</td>
    </tr>
    <tr>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td>&dtdot;</td>
    </tr>
    <tr class = "dataRow">
      <td class = "rowNumber" style = "font-weight: bold; text-align: right;">4</td>
      <td class = "rowLabel" style = "font-weight: bold; text-align: right;">Row 4</td>
      <td style = "text-align: right;">(4, 1)</td>
      <td style = "text-align: right;">(4, 2)</td>
      <td>&ctdot;</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowNumber" style = "font-weight: bold; text-align: right;"></td>
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Summary 1</td>
      <td style = "text-align: right;">10</td>
      <td style = "text-align: right;">20</td>
      <td>&ctdot;</td>
    </tr>
    <tr class = "summaryRow">
      <td class = "summaryRowNumber" style = "font-weight: bold; text-align: right;"></td>
      <td class = "summaryRowLabel" style = "font-weight: bold; text-align: right;">Summary 2</td>
      <td style = "text-align: right;">20</td>
      <td style = "text-align: right;">40</td>
      <td>&ctdot;</td>
    </tr>
  </tbody>
  <tfoot>
    <tr class = "footnote">
      <td colspan = "5" style = "font-size: small; text-align: left;"><sup>1</sup> Footnote in column label</td>
    </tr>
    <tr class = "footnote">
      <td colspan = "5" style = "font-size: small; text-align: left;"><sup>2</sup> Footnote in data</td>
    </tr>
    <tr class = "sourceNotes">
      <td colspan = "5" style = "color: gray; font-size: small; font-style: italic; text-align: left;">Source Notes</td>
    </tr>
  </tfoot>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            footnotes = [
                (:column_label, 1, 2) => "Footnote in column label",
                (:data, 2, 2) => "Footnote in data",
            ],
            maximum_number_of_columns = 2,
            maximum_number_of_rows = 2,
            merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
            row_group_labels = [2 => "Row Group"],
            row_labels = ["Row $i" for i in 1:5],
            show_row_number_column = true,
            source_notes = "Source Notes",
            stubhead_label = "Rows",
            subtitle = "Table Subtitle",
            summary_rows = [(data, i) -> 10i, (data, i) -> 20i],
            title = "Table Title",
            vertical_crop_mode = :middle,
        )

        @test result == expected
    end
    @testset "Source Notes Without Footnotes" begin
        # When the table has source notes but no footnotes, the source note rows must still
        # be tagged with the `sourceNotes` class. Otherwise, the default CSS rule
        # `tr.sourceNotes td` would never fire.
        result = pretty_table(String, [1 2]; backend = :html, source_notes = "src")

        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">2</td>
    </tr>
  </tbody>
  <tfoot>
    <tr class = "sourceNotes">
      <td colspan = "2" style = "color: gray; font-size: small; font-style: italic; text-align: left;">src</td>
    </tr>
  </tfoot>
</table>
"""

        @test result == expected
    end

    @testset "Table Footer Is Closed With </tfoot>" begin
        # The `<tfoot>` section must be closed with `</tfoot>`, and `</tbody>` must be
        # emitted exactly once.
        result = pretty_table(
            String,
            [1 2];
            backend = :html,
            footnotes = [(:column_label, 1, 1) => "note A"],
        )

        @test occursin("</tfoot>", result)
        @test count("</tbody>", result) == 1
        @test count("</tfoot>", result) == 1
    end
end

## Description #############################################################################
#
# Functions to render the table cells in markdown back end.
#
############################################################################################

# NOTE: The functions to render the cell must receive the current `RenderContext` because
# its `IOContext` carries the information required to check for circular dependency. We
# store the objects being printed inside the key `__PRETTY_TABLES__DATA__` in the IO
# context. Hence, we must pass it forward when rendering the cells.

"""
    _markdown__cell_to_str(
        cell::Any,
        context::RenderContext,
        renderer::Union{Val{:print}, Val{:show}}
    ) -> String

Convert the `cell` to a string using a specific `context` and `renderer`.
"""
function _markdown__cell_to_str(cell::Any, context::RenderContext, ::Val{:print})
    return _sprint_with_context(print, context, cell)
end

function _markdown__cell_to_str(cell::Any, context::RenderContext, ::Val{:show})
    return _sprint_with_context(show, context, cell)
end

function _markdown__cell_to_str(cell::AbstractString, context::RenderContext, ::Val{:print})
    # Notice that we must not use `string` here because it is the identity for any
    # `AbstractString`, whereas the callers require a `String`.
    return String(cell)
end

function _markdown__cell_to_str(cell::AbstractString, context::RenderContext, ::Val{:show})
    return string(cell)
end

_markdown__cell_to_str(::UndefinedCell, ::RenderContext, ::Val{:print}) = "#undef"
_markdown__cell_to_str(::UndefinedCell, ::RenderContext, ::Val{:show}) = "#undef"

function _markdown__cell_to_str(cell::MergeCells, context::RenderContext, ::Val{:print})
    return _markdown__cell_to_str(cell.data, context, Val(:print))
end

function _markdown__cell_to_str(cell::MergeCells, context::RenderContext, ::Val{:show})
    return _markdown__cell_to_str(cell.data, context, Val(:show))
end

"""
    _markdown__render_cell(
        cell::Any,
        context::RenderContext,
        renderer::Union{Val{:print}, Val{:show}};
        kwargs...
    ) -> String

Render the `cell` in markdown back end using a specific `context` and `renderer`.

# Keywords

- `allow_markdown_in_cells::Bool`: If `true`, we will not escape markdown sequences in the rendered
    string.
    (**Default**: `false`)
- `line_breaks::Bool`: If `true`, we will replace `\\n` with `<br>`.
    (**Default**: `false`)
"""
function _markdown__render_cell(
    cell::Any,
    context::RenderContext,
    renderer::Union{Val{:print}, Val{:show}};
    allow_markdown_in_cells::Bool = false,
    line_breaks::Bool = false,
)
    cell_str = _markdown__cell_to_str(cell, context, renderer)

    # Check if we need to replace `\n` with `<br>`.
    replace_newline = line_breaks

    # If the user wants markdown code inside cell, we must not escape the markdown characters.
    return _markdown__escape_str(cell_str, replace_newline, !allow_markdown_in_cells)
end

# For Markdown cells, we just output the string.
function _markdown__render_cell(
    cell::Markdown.MD,
    context::RenderContext,
    renderer::Union{Val{:print}, Val{:show}};
    allow_markdown_in_cells::Bool = false,
    line_breaks::Bool = false,
)
    return replace(sprint(show, MIME("text/markdown"), cell), "\n" => "")
end

## Description #############################################################################
#
# Typst Back End: Tests related to the horizontal and vertical line specifications.
#
############################################################################################

@testset "Line Specifications" verbose = true begin
    # `horizontal_lines_at_data_rows` and `vertical_lines_at_data_columns` accept either a
    # `Symbol` (`:all` / `:none`) or an explicit `Vector{Int}`. The vector branch is what
    # narrows the field type in the back end, and it must select exactly the requested rows
    # and columns.
    matrix = [1 2 3; 4 5 6]

    @testset "Vector of Indices" begin
        result = pretty_table(
            String,
            matrix;
            backend = :typst,
            table_format = TypstTableFormat(;
                horizontal_lines_at_data_rows  = [1],
                vertical_lines_at_data_columns = [1],
            ),
        )

        # Only the line after the first data row is drawn with the middle stroke.
        @test occursin("table.hline(y: 2, stroke: 0.5pt,),", result)

        # Only the vertical line after the first data column is drawn, so there is no line
        # at `x: 2`.
        @test occursin("table.vline(x: 1, end: 3, stroke: 0.8pt),", result)
        @test !occursin("table.vline(x: 2,", result)
    end

    @testset "All Lines" begin
        result = pretty_table(
            String,
            matrix;
            backend = :typst,
            table_format = TypstTableFormat(;
                horizontal_lines_at_data_rows  = :all,
                vertical_lines_at_data_columns = :all,
            ),
        )

        @test occursin("table.hline(y: 2, stroke: 0.5pt,),", result)

        # Now every interior vertical line must be present.
        @test occursin("table.vline(x: 1, end: 3, stroke: 0.8pt),", result)
        @test occursin("table.vline(x: 2, end: 3, stroke: 0.8pt),", result)
    end
end

@testset "Line Before a Row Group Label" begin
    # `horizontal_line_before_row_group_label` had no coverage in this back end.
    result = pretty_table(
        String,
        [1 2 3; 4 5 6];
        backend = :typst,
        row_group_labels = [2 => "G"],
        table_format = TypstTableFormat(;
            horizontal_line_before_row_group_label = true
        ),
    )

    # One line before the row group label, and one after it.
    @test occursin("table.hline(y: 2, stroke: 0.5pt,),", result)
    @test occursin("table.hline(y: 3, stroke: 0.5pt,),", result)
end

## Description #############################################################################
#
# Text Back End: Pre-defined table formats.
#
############################################################################################

############################################################################################
#                                      Table Borders                                       #
############################################################################################

export text_table_borders__ascii_dots
export text_table_borders__ascii_rounded
export text_table_borders__borderless
export text_table_borders__compact
export text_table_borders__matrix
export text_table_borders__mysql
export text_table_borders__simple
export text_table_borders__unicode_rounded

const text_table_borders__ascii_dots = TextTableBorders(;
    up_right_corner     = '.',
    up_left_corner      = '.',
    bottom_left_corner  = ':',
    bottom_right_corner = ':',
    up_intersection     = '.',
    left_intersection   = ':',
    right_intersection  = ':',
    middle_intersection = ':',
    bottom_intersection = ':',
    column              = ':',
    row                 = '.',
)

const text_table_borders__ascii_rounded = TextTableBorders(;
    up_right_corner     = '.',
    up_left_corner      = '.',
    bottom_left_corner  = '\'',
    bottom_right_corner = '\'',
    up_intersection     = '.',
    left_intersection   = ':',
    right_intersection  = ':',
    middle_intersection = '+',
    bottom_intersection = '\'',
    column              = '|',
    row                 = '-',
)

const text_table_borders__borderless = TextTableBorders(;
    up_right_corner     = ' ',
    up_left_corner      = ' ',
    bottom_left_corner  = ' ',
    bottom_right_corner = ' ',
    up_intersection     = ' ',
    left_intersection   = ' ',
    right_intersection  = ' ',
    middle_intersection = ' ',
    bottom_intersection = ' ',
    column              = ' ',
    row                 = ' ',
)

const text_table_borders__compact = TextTableBorders(;
    up_right_corner     = ' ',
    up_left_corner      = ' ',
    bottom_left_corner  = ' ',
    bottom_right_corner = ' ',
    up_intersection     = ' ',
    left_intersection   = ' ',
    right_intersection  = ' ',
    middle_intersection = ' ',
    bottom_intersection = ' ',
    column              = ' ',
    row                 = '-',
)

const text_table_borders__matrix = TextTableBorders(;
    left_intersection   = '│',
    right_intersection  = '│',
    middle_intersection = '│',
    row                 = ' ',
)

const text_table_borders__mysql = TextTableBorders(;
    up_right_corner     = '+',
    up_left_corner      = '+',
    bottom_left_corner  = '+',
    bottom_right_corner = '+',
    up_intersection     = '+',
    left_intersection   = '+',
    right_intersection  = '+',
    middle_intersection = '+',
    bottom_intersection = '+',
    column              = '|',
    row                 = '-',
)

const text_table_borders__simple = TextTableBorders(;
    up_right_corner     = '=',
    up_left_corner      = '=',
    bottom_left_corner  = '=',
    bottom_right_corner = '=',
    up_intersection     = ' ',
    left_intersection   = '=',
    right_intersection  = '=',
    middle_intersection = ' ',
    bottom_intersection = ' ',
    column              = ' ',
    row                 = '=',
)

const text_table_borders__unicode_rounded = TextTableBorders(;
    up_right_corner     = '╮',
    up_left_corner      = '╭',
    bottom_left_corner  = '╰',
    bottom_right_corner = '╯',
    up_intersection     = '┬',
    left_intersection   = '├',
    right_intersection  = '┤',
    middle_intersection = '┼',
    bottom_intersection = '┴',
    column              = '│',
    row                 = '─',
)

############################################################################################
#                                      Table Formats                                       #
############################################################################################

export text_table_format__matrix

const text_table_format__matrix = TextTableFormat(;
    borders                                  = text_table_borders__matrix,
    horizontal_line_after_column_labels      = true,
    horizontal_line_after_data_rows          = true,
    horizontal_line_after_row_group_label    = false,
    horizontal_line_after_summary_rows       = true,
    horizontal_line_at_beginning             = true,
    horizontal_line_before_row_group_label   = false,
    horizontal_lines_at_data_rows            = :none,
    suppress_vertical_lines_at_column_labels = true,
    vertical_line_after_continuation_column  = true,
    vertical_lines_at_data_columns           = :none,
    vertical_line_after_data_columns         = true,
    vertical_line_after_row_label_column     = true,
    vertical_line_after_row_number_column    = true,
    vertical_line_at_beginning               = true,
)

## Description #############################################################################
#
# HTML Back End: Test circular reference.
#
############################################################################################

@testset "Circular Reference" begin
    cr = CircularRef([1, 2, 3], [4, 5, 6], [7, 8, 9], [10, 11, 12])

    cr.A1[2]   = cr
    cr.A4[end] = cr

    expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">A1</th>
      <th style = "font-weight: bold; text-align: right;">A2</th>
      <th style = "font-weight: bold; text-align: right;">A3</th>
      <th style = "font-weight: bold; text-align: right;">A4</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">4</td>
      <td style = "text-align: right;">7</td>
      <td style = "text-align: right;">10</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">#= circular reference =#</td>
      <td style = "text-align: right;">5</td>
      <td style = "text-align: right;">8</td>
      <td style = "text-align: right;">11</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">3</td>
      <td style = "text-align: right;">6</td>
      <td style = "text-align: right;">9</td>
      <td style = "text-align: right;">#= circular reference =#</td>
    </tr>
  </tbody>
</table>
"""

    result = sprint(show, MIME("text/html"), cr)

    @test result == expected
end

## Description #############################################################################
#
# HTML Back End: Test to print stand alone tables.
#
############################################################################################

@testset "Stand Alone Tables" begin
    matrix = [1 2]

    expected = """
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<style>
  table, td, th {
    border-collapse: collapse;
    font-family: sans-serif;
  }

  td, th {
    padding-bottom: 6px !important;
    padding-left: 8px !important;
    padding-right: 8px !important;
    padding-top: 6px !important;
  }

  tr.title td {
    padding-bottom: 2px !important;
  }

  tr.footnote td {
    padding-bottom: 2px !important;
  }

  tr.sourceNotes td {
    padding-bottom: 2px !important;
  }

  table > *:first-child > tr:first-child {
    border-top: 2px solid black;
  }

  table > *:last-child > tr:last-child {
    border-bottom: 2px solid black;
  }

  thead > tr:nth-child(1 of .columnLabelRow) {
    border-top: 1px solid black;
  }

  thead tr:last-child {
    border-bottom: 1px solid black;
  }

  tbody tr:last-child {
    border-bottom: 1px solid black;
  }

  tbody > tr:nth-child(1 of .summaryRow) {
    border-top: 1px solid black;
  }

  tbody > tr:nth-last-child(1 of .summaryRow) {
    border-bottom: 1px solid black;
  }

  tfoot tr:nth-last-child(1 of .footnote) {
    border-bottom: 1px solid black;
  }
</style>
</head>
<body>
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">1</td>
      <td style = "text-align: right;">2</td>
    </tr>
  </tbody>
</table>
</body>
</html>
"""

    result = pretty_table(String, matrix; backend = :html, stand_alone = true)

    @test result == expected
end

@testset "Stand Alone Tables With Table Div" begin
    # The div that wraps the table must be closed before the end of the document.
    result = pretty_table(
        String,
        [1 2];
        backend = :html,
        stand_alone = true,
        wrap_table_in_div = true,
    )

    @test occursin("</div>\n</body>\n</html>", result)
    @test !occursin("</html>\n</div>", result)
end

## Description #############################################################################
#
# LaTeX Back End: Tests related to the horizontal and vertical line specifications.
#
############################################################################################

@testset "Line Specifications" verbose = true begin
    # `horizontal_lines_at_data_rows` and `vertical_lines_at_data_columns` accept either a
    # `Symbol` (`:all` / `:none`) or an explicit `Vector{Int}`. The vector branch is what
    # narrows the field type in the back end, and it must select exactly the requested rows
    # and columns.
    matrix = [1 2 3; 4 5 6]

    @testset "Vector of Indices" begin
        expected = """
\\begin{tabular}{|r|rr|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1 & 2 & 3 \\\\
  \\hline
  4 & 5 & 6 \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            table_format = LatexTableFormat(;
                horizontal_lines_at_data_rows  = [1],
                vertical_lines_at_data_columns = [1],
            ),
        )

        @test result == expected
    end

    @testset "All Lines" begin
        expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1 & 2 & 3 \\\\
  \\hline
  4 & 5 & 6 \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex,
            table_format = LatexTableFormat(;
                horizontal_lines_at_data_rows  = :all,
                vertical_lines_at_data_columns = :all,
            ),
        )

        @test result == expected
    end
end

@testset "Line Before a Row Group Label" begin
    # `horizontal_line_before_row_group_label` had no coverage in this back end.
    expected = """
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1 & 2 & 3 \\\\
  \\hline
  \\multicolumn{3}{|l|}{\\textbf{G}} \\\\
  \\hline
  4 & 5 & 6 \\\\
  \\hline
\\end{tabular}
"""

    result = pretty_table(
        String,
        [1 2 3; 4 5 6];
        backend = :latex,
        row_group_labels = [2 => "G"],
        table_format = LatexTableFormat(;
            horizontal_line_before_row_group_label = true
        ),
    )

    @test result == expected
end
@testset "Merged Column Label Truncated by the Column Limit" begin
    # When a merged column label spans more columns than are actually printed, its span must
    # be clamped to the remaining columns.
    result = pretty_table(
        String,
        [1 2 3 4; 5 6 7 8];
        backend = :latex,
        column_labels = [[MultiColumn(4, "Wide")], ["a", "b", "c", "d"]],
        maximum_number_of_columns = 2,
    )

    @test occursin("\\multicolumn{2}{", result)
    @test !occursin("\\multicolumn{4}{", result)
end

## Description #############################################################################
#
# Documentation for the function `pretty_table`.
#
############################################################################################

"""
    pretty_table(table; kwargs...) -> Nothing

Print the `table` to the `stdout`.

    pretty_table(io::IO, table; kwargs...) -> Nothing
    pretty_table(String, table; kwargs...) -> String
    pretty_table(HTML,   table; kwargs...) -> HTML

Print the `table` to the output specified by the first argument.

If the first argument is of type `IO`, the function prints the table to it. If it is
`String`, a `String` with the printed table will be returned by the function. If `HTML` is
passed as the first argument, the function will return an `HTML` object with the table.

When printing, the function verifies if `table` complies with **Tables.jl** API. If it is
compliant, this interface will be used to print the table. If it is not compliant, only the
following types are supported:

1. `AbstractVector`: any vector can be printed.
2. `AbstractMatrix`: any matrix can be printed.

`pretty_table` currently supports printing tables for six backends: text, markdown, html,
latex, typst, and excel. The desired backend can be set using the `backend` keyword
argument.

For more information, see the **Extended Help** section.

# Extended Help

## Table Sections

**PrettyTables.jl** considers the following table sections when printing a table:

```
                                      TITLE
                                     Subtitle
┌────────────┬───────────────────┬──────────────┬──────────────┬───┬──────────────┐
│ Row Number │    Stubhead Label │ Column Label │ Column Label │ ⋯ │ Column Label │
│            │                   │ Column Label │ Column Label │ ⋯ │ Column Label │
│            │                   │       ⋮      │       ⋮      │ ⋯ │       ⋮      │
│            │                   │ Column Label │ Column Label │ ⋯ │ Column Label │
├────────────┼───────────────────┼──────────────┼──────────────┼───┼──────────────┤
│          1 │         Row Label │         Data │         Data │ ⋯ │         Data │
│          2 │         Row Label │         Data │         Data │ ⋯ │         Data │
├────────────┴───────────────────┴──────────────┴──────────────┴───┴──────────────┤
│ Row Group Label                                                                 │
├────────────┬───────────────────┬──────────────┬──────────────┬───┬──────────────┤
│          3 │         Row Label │         Data │         Data │ ⋯ │         Data │
│          4 │         Row Label │         Data │         Data │ ⋯ │         Data │
├────────────┴───────────────────┴──────────────┴──────────────┴───┴──────────────┤
│ Row Group Label                                                                 │
├────────────┬───────────────────┬──────────────┬──────────────┬───┬──────────────┤
│          5 │         Row Label │         Data │         Data │ ⋯ │         Data │
│          6 │         Row Label │         Data │         Data │ ⋯ │         Data │
│      ⋮     │          ⋮        │       ⋮      │       ⋮      │ ⋱ │       ⋮      │
│        100 │         Row Label │         Data │         Data │ ⋯ │         Data │
├────────────┼───────────────────┼──────────────┼──────────────┼───┼──────────────┤
│            │ Summary Row Label │ Summary Cell │ Summary Cell │ ⋯ │ Summary Cell │
│            │ Summary Row Label │ Summary Cell │ Summary Cell │ ⋯ │ Summary Cell │
│      ⋮     │          ⋮        │       ⋮      │       ⋮      │ ⋯ │       ⋮      │
│            │ Summary Row Label │ Summary Cell │ Summary Cell │ ⋯ │ Summary Cell │
└────────────┴───────────────────┴──────────────┴──────────────┴───┴──────────────┘
Footnotes
Source notes
```

All those sections can be configured using keyword arguments as described below.

## Quick Start

The following command prints the table in `matrix` using the text backend with all the
available sections:

```julia-repl
julia> matrix = [(i, j) for i in 1:3, j in 1:3];

julia> result = pretty_table(
    matrix;
    column_labels            = [["Col. \$i" for i in 1:3], ["\$i" for i in 1:3]],
    footnotes                = [(:column_label, 1, 2) => "Footnote in column label", (:data, 2, 2) => "Footnote in data"],
    merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
    row_group_labels         = [2                     => "Row Group"],
    row_labels               = ["Row \$i" for i in 1:5],
    show_row_number_column   = true,
    source_notes             = "Source Notes",
    stubhead_label           = "Rows",
    subtitle                 = "Table Subtitle",
    summary_rows             = [(data, i) -> 10i, (data, i) -> 20i],
    title                    = "Table Title",
)
                  Table Title
                Table Subtitle
┌─────┬───────────┬────────┬──────────────────┐
│ Row │      Rows │ Col. 1 │  Merged Column¹  │
│     │           │      1 │       2 │      3 │
├─────┼───────────┼────────┼─────────┼────────┤
│   1 │     Row 1 │ (1, 1) │  (1, 2) │ (1, 3) │
├─────┴───────────┴────────┴─────────┴────────┤
│ Row Group                                   │
├─────┬───────────┬────────┬─────────┬────────┤
│   2 │     Row 2 │ (2, 1) │ (2, 2)² │ (2, 3) │
│   3 │     Row 3 │ (3, 1) │  (3, 2) │ (3, 3) │
├─────┼───────────┼────────┼─────────┼────────┤
│     │ Summary 1 │     10 │      20 │     30 │
│     │ Summary 2 │     20 │      40 │     60 │
└─────┴───────────┴────────┴─────────┴────────┘
¹: Footnote in column label
²: Footnote in data
Source Notes
```

## General Keywords

The following keywords are related to table configuration and are available in all backends:

- `backend::Symbol`: Backend used to print the table. The available options are `:text`,
    `:markdown`, `:html`, `:latex`, `:typst`, and `:excel`. If it is `:auto`, the backend is
    obtained from the type of the keyword `table_format`, falling back to `:text` if the
    latter is not present.
    (**Default**: `:auto`)

### IOContext Arguments

- `compact_printing::Bool`: If `true`, the table will be printed in a compact format, *i.e*,
    we will pass the context option `:compact => true` when rendering the values.
    (**Default**: `true`)
- `limit_printing::Bool`: If `true`, the table will be printed in a limited format, *i.e*,
    we will pass the context option `:limit => true` when rendering the values.
    (**Default**: `true`)

### Printing Specification Arguments

- `show_omitted_cell_summary::Bool`: If `true`, a summary of the omitted cells will be
    printed at the end of the table.
    (**Default**: `true`)
- `renderer::Symbol`: The renderer used to print the table. The available options are
    `:print` and `:show`.
    (**Default**: `:print`)

### Table Sections Arguments

- `title::String`: Title of the table. If it is empty, the title will be omitted.
    (**Default**: "")
- `subtitle::String`: Subtitle of the table. If it is empty, the subtitle will be omitted.
    (**Default**: "")
- `stubhead_label::String`: Label of the stubhead column.
    (**Default**: "")
- `row_number_column_label::String`: Label of the row number column.
    (**Default**: "Row")
- `row_labels::Union{Nothing, AbstractVector}`: Row labels. If it is `nothing`, the column
    with row labels is omitted.
    (**Default**: `nothing`)
- `row_group_labels::Union{Nothing, Vector{Pair{Int, String}}}`: Row group labels. If it is
    `nothing`, no row group label is printed. For more information on how to specify the row
    group labels, see the section **Row Group Labels**.
    (**Default**: `nothing`)
- `column_labels::Union{Nothing, AbstractVector}`: Column labels. If it is `nothing`, the
    function uses a default value for the column labels. For more information on how to
    specify the column labels, see the section **Column Labels**.
    (**Default**: `nothing`)
- `show_column_labels::Bool`: If `true`, the column labels will be printed.
    (**Default**: `true`)
- `summary_rows::Union{Nothing, Vector{Function}}`: Summary rows. If it is `nothing`, no
    summary rows are printed. For more information on how to specify the summary rows, see
    the section **Summary Rows**.
    (**Default**: `nothing`)
- `summary_row_labels::Union{Nothing, Vector{String}}`: Labels of the summary rows. If it is
    `nothing`, the function uses a default value for the summary row labels.
    (**Default**: `nothing`)
- `footnotes::Union{Nothing, Vector{Pair{FootnoteTuple, String}}}`: Footnotes. If it is
    `nothing`, no footnotes are printed. For more information on how to specify the
    footnotes, see the section **Footnotes**.
    (**Default**: `nothing`)
- `source_notes::String`: Source notes. If it is empty, the source notes will be omitted.
    (**Default**: "")

### Alignment Arguments

The following keyword arguments define the alignment of the table sections. The alignment
can be specified using a symbol: `:l` for left, `:c` for center, or `:r` for right.

- `alignment::Union{Symbol, Vector{Symbol}}`: Alignment of the table data. It can be a
    `Symbol`, which will be used for all columns, or a vector of `Symbol`s, one for each
    column.
    (**Default**: `:r`)
- `column_label_alignment::Union{Nothing, Symbol, Vector{Symbol}}`: Alignment of the column
    labels. It can be a `Symbol`, which will be used for all columns, a vector of `Symbol`s,
    one for each column, or `nothing`, which will use the value of `alignment`.
    (**Default**: `nothing`)
- `continuation_row_alignment::Union{Nothing, Symbol}`: Alignment of the columns in the
    continuation row. If it is `nothing`, we use the value of `alignment`.
    (**Default**: `nothing`)
- `footnote_alignment::Symbol`: Alignment of the footnotes.
    (**Default**: `:l`)
- `row_label_column_alignment::Symbol`: Alignment of the row labels.
    (**Default**: `:r`)
- `row_group_label_alignment::Symbol`: Alignment of the row group labels.
    (**Default**: `:l`)
- `row_number_column_alignment::Symbol`: Alignment of the row number column.
    (**Default**: `:r`)
- `source_note_alignment::Symbol`: Alignment of the source notes.
    (**Default**: `:l`)
- `subtitle_alignment::Symbol`: Alignment of the subtitle.
    (**Default**: `:c`)
- `title_alignment::Symbol`: Alignment of the title.
    (**Default**: `:c`)
- `cell_alignment::Union{Nothing, Vector{<:Function},
    Vector{Pair{NTuple{2, Int}, Symbol}}}`: Either `nothing`, a vector of functions, or a
    vector of coordinate/alignment pairs. Each function must have the signature
    `f(data, i, j)` and return a valid alignment symbol or `nothing` for the cell `(i, j)`.
    Returning `nothing` leaves the cell alignment unchanged. Each pair must have the form
    `(i::Int, j::Int) => a::Symbol` and sets the alignment of cell `(i, j)` to `a`.
    (**Default** = `nothing`)

!!! warning

    Some backends do not support all the alignment options. For example, it is impossible
    to define cell-specific alignment in the markdown backend.

### Other Arguments

- `formatters::Union{Nothing, Vector{Function}}`: Formatters used to modify the rendered
    output of the cells. For more information, see the section **Formatters**.
    (**Default**: `nothing`)
- `maximum_number_of_columns::Int`: Maximum number of columns to be printed. If the table
    has more columns than this value, the table will be truncated. If it is negative, all
    columns will be printed.
    (**Default**: `-1`)
- `maximum_number_of_rows::Int`: Maximum number of rows to be printed. If the table has more
    rows than this value, the table will be truncated. If it is negative, all rows will be
    printed.
    (**Default**: `-1`)
- `merge_column_label_cells::Union{Symbol, Vector{MergeCells}}`: Merged cells in the column
    labels. For more information, see the section **Column Labels**.
    (**Default**: `:auto`)
- `new_line_at_end::Bool`: If `true`, a new line will be printed at the end of the table.
    (**Default**: `true`)
- `show_first_column_label_only::Bool`: If `true`, only the first row of the column labels
    will be printed.
    (**Default**: `false`)
- `vertical_crop_mode::Symbol`: Vertical crop mode. This option defines how the table will
    be vertically cropped if it has more rows than the number specified in
    `maximum_number_of_rows`. The available options are `:bottom`, when the data will be
    cropped at the bottom of the table, or `:middle`, when the data will be cropped at the
    middle of the table.
    (**Default**: `:bottom`)

## Backend-Specific Keywords

The keywords and information specific to each backend can be seen in the docstrings of the
following methods:

- **Text backend**: `pretty_table_text_backend`.
- **Markdown backend**: `pretty_table_markdown_backend`.
- **HTML backend**: `pretty_table_html_backend`.
- **LaTeX backend**: `pretty_table_latex_backend`.
- **Typst backend**: `pretty_table_typst_backend`.
- **Excel backend**: `pretty_table_excel_backend`.

!!! warning

    Those methods **must not** be called directly. They are only defined to split the
    documentation, providing a better organization.

## Specification of Table Sections

Here, we show how to specify the table sections using the keyword arguments.

### Column Labels

The specification of column labels must be a vector of elements. Each element in this vector
must be another vector with a row of column labels. Notice that each vector must have the
same size as the number of table columns.

For example, in a table with three columns, we can specify two rows of column labels by
passing:

```julia
column_labels = [
    ["Column #1",    "Column #2",    "Column #3"],
    ["Subcolumn #1", "Subcolumn #2", "Subcolumn #3"]
]
```

!!! info

    If the user wants only one row in the column labels, they can pass only a vector with
    the elements. The algorithm will encapsulate it inside another vector to match the API.

Adjacent column labels can be merged using the keyword `merge_column_label_cells`. It must
contain a vector of `MergeCells` objects. Each object defines a new merged cell. The
`MergeCells` object has the following fields:

- `i::Int`: Row index of the merged cell.
- `j::Int`: Column index of the merged cell.
- `column_span::Int`: Number of columns spanned by the merged cell.
- `data::Any`: Data of the merged cell.
- `alignment::Symbol`: Alignment of the merged cell. The available options are `:l` for
    left, `:c` for center, and `:r` for right.
    (**Default**: `:c`)

Hence, in our example, if we want to merge the columns 2 and 3 of the first column label
row, we must pass:

```julia
merge_column_label_cells = [
    MergeCells(1, 2, 2, "Merged Column", :c)
]
```

We can pass the helpers `MultiColumn` and `EmptyCells` to `column_labels` to create merged
columns more easily. In this case, `MultiColumn` specify a set of columns that will be
merged, and `EmptyCells` specify a set of empty columns. However, notice that in this case
we must set `merge_column_label_cells` to `:auto`, which is the default.

`MultiColumn` has the following fields:

- `column_span::Int`: Number of columns spanned by the merged cell.
- `data::Any`: Data of the merged cell.
- `alignment::Symbol`: Alignment of the merged cell. The available options are `:l` for
    left, `:c` for center, and `:r` for right.
    (**Default**: `:c`)

`EmptyCells` has the following field:

- `number_of_cells::Int`: Number of columns that will be filled with empty cells.

For example, we can create the following column labels:

```
┌───────────────────────────────────┬─────────────────┐
│              Group #1             │     Group #2    │
├─────────────────┬─────────────────┼────────┬────────┤
│    Group #1.1   │    Group #1.2   │        │        │
├────────┬────────┼────────┬────────┼────────┼────────┤
│ Test 1 │ Test 2 │ Test 3 │ Test 4 │ Test 5 │ Test 6 │
└────────┴────────┴────────┴────────┴────────┴────────┘
```

by passing these arguments:

```julia
column_labels = [
    [MultiColumn(4, "Group #1"), MultiColumn(2, "Group #2")],
    [MultiColumn(2, "Group #1.1"), MultiColumn(2, "Group #1.2"), EmptyCells(2)],
    ["Test 1", "Test 2", "Test 3", "Test 4", "Test 5", "Test 6"]
]

merge_column_label_cells = :auto
```

### Row Group Labels

The row group labels are specified by a `Vector{Pair{Int, String}}`. Each element defines a
new row group label. The first element of the `Pair` is the row index of the row group and
the second is the label. For example, `[3 => "Row Group #1"]` defines that before
row 3, we have the row group label named "Row Group #1".

### Summary Rows

The summary rows can be specified by a vector of `Function`s. Each element defines a summary
row and the function must have one of the following signatures:

```
f(col)

f(data, j)
```

where `col` is the current column, `data` is the table data, and `j` is the column index. In
the first case, it must return the summary cell value for the referenced column. In the
second case, it must return the summary cell value for the `j`th column. The algorithm will
check if there is an applicable method for the first signature and use it if it exists.
Otherwise, it will use the second signature. This verification is performed using the method
`applicable` and `col` is obtained by `@view data[:, j]`.

If we want, for example, to create two summary rows, one with the sum of the column values
and other with their mean, we can define:

```julia
summary_rows = [
    (data, j) -> sum(data[:, j]),
    (data, j) -> sum(data[:, j]) / length(data[:, j])
]
```

We can also use the first signature to simplify the code:

```julia
using Statistics
summary_rows = [sum, mean]
```

!!! note

    If both signatures are available, the algorithm will prioritize the first one. To force
    the usage of the second, we can create an anonymous functions as follows: `(data, i) ->
    f(data, i)`. This ensures that only the second method is available.

### Footnotes

The footnotes are specified by a vector of `Pair{FootnoteTuple, String}`. Each element
defines a new footnote. The `FootnoteTuple` is a `Tuple` with the following elements:

- `section::Symbol`: Section to which the footnote must be applied. The available options
    are `:column_label`, `:data`, `:row_label`, `:summary_row_label`, and
    `:summary_row_cell`.
- `i::Int`: Row index of the footnote considering the desired section.
- `j::Int`: Column index of the footnote considering the desired section.

The second element of the `Pair` is the footnote text.

Hence, if we want to apply a foot note to a column label, a data cell, and a summary cell,
we can define:

```julia
footnotes = [
    (:column_label, 1, 2) => "Footnote in column label",
    (:data, 2, 2) => "Footnote in data",
    (:summary_row_cell, 1, 2) => "Footnote in summary cell"
]
```

## Formatters

The keyword `formatters` can be used to pass functions to format the values in the columns.
It must be a `Vector{Function}` in which each function has the following signature:

    f(v, i, j)

where `v` is the value in the cell, `i` is the row number, and `j` is the column number.
It must return the formatted value of the cell `(i, j)` that has the value `v`. Notice
that the returned value will be converted to string after using the function `sprint`.

This keyword can also be `nothing`, meaning that no formatter will be used.

For example, if we want to multiply all values in odd rows of the column 2 by π, the
formatter should look like:

```julia
formatters = [(v, i, j) -> (j == 2 && isodd(i)) ? v * π : v]
```

If multiple formatters are available, they will be applied in the same order as they are
located in the vector. Thus, for the following `formatters`:

```julia
formatters = [f1, f2, f3]
```

each element `v` in the table (`i`th row and `j`th column) will be formatted by:

```julia
v = f1(v, i, j)
v = f2(v, i, j)
v = f3(v, i, j)
```

Thus, the user must ensure that the type of `v` between the calls is compatible.

PrettyTables.jl provides some predefined formatters for common tasks. For more information,
see [`fmt__printf`](@ref), [`fmt__round`](@ref), and [`fmt__latex_sn`](@ref).
"""
pretty_table

## Description #############################################################################
#
# Definition of types and structures for the tests.
#
############################################################################################

# == Circular Reference ====================================================================

struct CircularRef
    A1::Vector{Any}
    A2::Vector{Any}
    A3::Vector{Any}
    A4::Vector{Any}
end

Tables.istable(x::CircularRef) = true
Tables.columnaccess(::CircularRef) = true
Tables.columnnames(x::CircularRef) = [:A1, :A2, :A3, :A4]
Tables.columns(x::CircularRef) = x

function Base.show(io::IO, cf::CircularRef)
    context = IOContext(io, :color => false)
    pretty_table(context, cf; renderer = :show)
    return nothing
end

function Base.show(io::IO, ::MIME"text/plain", cf::CircularRef)
    context = IOContext(io, :color => false)
    pretty_table(context, cf; renderer = :show)
    return nothing
end

function Base.show(io::IO, ::MIME"text/html", cf::CircularRef)
    pretty_table(io, cf; backend = :html, renderer = :show)
    return nothing
end

function Base.show(io::IO, ::MIME"text/latex", cf::CircularRef)
    pretty_table(io, cf; backend = :latex, renderer = :show)
    return nothing
end

function Base.show(io::IO, ::MIME"text/markdown", cf::CircularRef)
    pretty_table(io, cf; backend = :markdown, renderer = :show)
    return nothing
end

function Base.show(io::IO, ::MIME"text/typst", cf::CircularRef)
    pretty_table(io, cf; backend = :typst, renderer = :show)
    return nothing
end

## Description #############################################################################
#
# Miscellaneous functions and macros.
#
############################################################################################

"""
    _sprint_with_context(f::Function, context::IOContext, args...) -> String

Call `f(io, args...)`, where `io` inherits the IO properties of `context`, and return
everything that was written as a `String`.

This function must be used instead of `sprint(f, args...; context)` in the cell rendering
code. `sprint` builds its temporary `IOContext` around the *caller's* IO, so the resulting
type changes with the object the user is printing to. Since the cell renderers deliberately
declare `@nospecialize(context::IOContext)`, that made every new output IO type trigger a
fresh inference and code generation of the whole rendering call, which showed up directly as
time-to-first-print. Wrapping a plain `IOBuffer` instead pins the type to
`IOContext{IOBuffer}` for every caller.
"""
function _sprint_with_context(f::F, @nospecialize(context::IOContext), args...) where {F}
    buf = IOBuffer()
    f(IOContext(buf, context), args...)
    return String(take!(buf))
end

"""
    @_print(io, args...)

Print `args` to `io`. Each argument in `args` is printed sequentially using `print`.

This macro expands each argument into a separate `print` call, avoiding the overhead of
string interpolation or concatenation, which reduces allocations.
"""
macro _print(io, args...)
    return esc(
        quote
            $([:(print($io, $arg)) for arg in args]...)
        end,
    )
end

"""
    @_println(io, args...)

Print `args` to `io` followed by a newline. Each argument in `args` is printed sequentially
using `print`, and a final `println` is issued to terminate the line.

This macro expands each argument into a separate `print` call, avoiding the overhead of
string interpolation or concatenation, which reduces allocations.
"""
macro _println(io, args...)
    return esc(
        quote
            $([:(print($io, $arg)) for arg in args]...)
            println($io)
        end,
    )
end

"""
    _aprint(buf::IO, str::String, indentation_level::Int = 0, indentation_spaces::Int = 2; kwargs...) -> Nothing

Print `str` in the buffer `buf` aligned to the `indentation_level`. Each indentation level
contains a number of spaces given by `indentation_spaces`.

# Keywords

- `minify::Bool`: If `true`, the output will be minified, meaning that it will be printed
    without indentation spaces or line breaks.
    (**Default**: `false`)
"""
function _aprint(
    buf::IO,
    str::String,
    indentation_level::Int = 0,
    indentation_spaces::Int = 2;
    minify::Bool = false,
)
    if minify
        for t in eachsplit(str, '\n')
            !isempty(t) && print(buf, strip(t))
        end

        return nothing
    end

    padding = " "^max(indentation_level * indentation_spaces, 0)
    first_token = true

    for t in eachsplit(str, '\n')
        # Print newline before each token except the first, preserving internal
        # line breaks (including empty lines).
        !first_token && println(buf)
        first_token = false

        # If the token is empty, we do nothing to avoid unnecessary white spaces.
        !isempty(t) && @_print(buf, padding, t)
    end

    return nothing
end

"""
    _aprintln(buf::IO, str::String, indentation_level::Int = 0, indentation_spaces::Int = 2; kwargs...) -> Nothing

Print `str` in the buffer `buf` aligned to the `indentation_level` and adding a line break
at the end. Each indentation level contains a number of spaces given by
`indentation_spaces`.

# Keywords

- `minify::Bool`: If `true`, the output will be minified, meaning that it will be printed
    without indentation spaces or line breaks.
    (**Default**: `false`)
"""
function _aprintln(
    buf::IO,
    str::String,
    indentation_level::Int = 0,
    indentation_spaces::Int = 2;
    minify::Bool = false,
)
    _aprint(buf, str, indentation_level, indentation_spaces; minify)
    !minify && println(buf)
    return nothing
end

"""
    _aprint_section_annotation(buf::IO, str::String, indentation_level::Int = 0, indentation_spaces::Int = 2, column_width::Int = 92, fill_char::Char = '=') -> Nothing

Print a section annotation line to `buf`. The annotation consists of `str` padded to
`indentation_level` and followed by `fill_char` characters up to `column_width`. If
`column_width` is negative, it defaults to 92. No newline is appended.
"""
function _aprint_section_annotation(
    buf::IO,
    str::String,
    indentation_level::Int = 0,
    indentation_spaces::Int = 2,
    column_width::Int = 92,
    fill_char::Char = '=',
)
    column_width < 0 && (column_width = 92)

    padding_length = max(indentation_level * indentation_spaces, 0)
    padding        = " "^padding_length
    line_width     = padding_length + textwidth(str) + 1
    fill_length    = max(column_width - line_width, 0)

    @_print(buf, padding, str, " ", fill_char^fill_length)

    return nothing
end

"""
    _aprintln_section_annotation(buf::IO, str::String, indentation_level::Int = 0, indentation_spaces::Int = 2, column_width::Int = 92, fill_char::Char = '=') -> Nothing

Same as `_aprint_section_annotation`, but appends a newline after the annotation.
"""
function _aprintln_section_annotation(
    buf::IO,
    str::String,
    indentation_level::Int = 0,
    indentation_spaces::Int = 2,
    column_width::Int = 92,
    fill_char::Char = '=',
)
    _aprint_section_annotation(
        buf, str, indentation_level, indentation_spaces, column_width, fill_char
    )
    println(buf)

    return nothing
end

"""
    _align_column_with_regex!(column::AbstractVector{String}, alignment_anchor_regex::Vector{Regex}, alignment_anchor_fallback::Symbol) -> Int
    _align_column_with_regex!(column::AbstractVector{Vector{String}}, alignment_anchor_regex::Vector{Regex}, alignment_anchor_fallback::Symbol) -> Int

Align the lines in the `column` at the first match obtained by the regex vector
`alignment_anchor_regex`, falling back to `alignment_anchor_fallback` if a match is not
found for a specific line.

This function returns the largest cell width.

!!! note

    In the second signature, each element in `column` must be a vector of `String`s, where
    each string is a line.
"""
function _align_column_with_regex!(
    column::AbstractVector{String},
    alignment_anchor_regex::Vector{Regex},
    alignment_anchor_fallback::Symbol,
)
    # Variable to store in which column we must align the match.
    alignment_column = 0

    # Cache the column of the first regex match at each row. Hence, we avoid running the
    # regexes again in the second pass. `-1` means that no match was found.
    match_columns = similar(column, Int)

    # We need to pass through the entire column searching for matches to compute in which
    # column we need to align them.
    for i in eachindex(column)
        row = column[i]
        m = nothing

        for r in alignment_anchor_regex
            m_r = findfirst(r, row)
            isnothing(m_r) && continue
            m = m_r
            break
        end

        if !isnothing(m)
            alignment_column_i = textwidth(@views row[1:first(m)])
            match_columns[i] = alignment_column_i
        else
            match_columns[i] = -1

            # If a match is not found, the alignment column depends on the user
            # selection.

            if alignment_anchor_fallback == :c
                row_len = textwidth(row)
                alignment_column_i = cld(row_len, 2)

            elseif alignment_anchor_fallback == :r
                row_len = textwidth(row)
                alignment_column_i = row_len + 1

            else
                alignment_column_i = 0
            end
        end

        alignment_column = max(alignment_column, alignment_column_i)
    end

    # Variable to store the largest cell width after the alignment.
    largest_cell_width = 0

    # Now, we need to pass again applying the alignments.
    for i in eachindex(column)
        row = column[i]

        match_column_k = match_columns[i]

        if match_column_k >= 0
            pad = alignment_column - match_column_k
        else
            # If a match is not found, the alignment column depends on the user selection.
            if alignment_anchor_fallback == :c
                row_len = textwidth(row)
                pad = alignment_column - cld(row_len, 2)

            elseif alignment_anchor_fallback == :r
                row_len = textwidth(row)
                pad = alignment_column - row_len - 1

            else
                pad = alignment_column
            end
        end

        # `pad` must be positive.
        pad = max(pad, 0)

        # Apply the alignment to the row.
        row = " "^pad * row
        row_len = textwidth(row)

        largest_cell_width = max(largest_cell_width, row_len)
        column[i] = row
    end

    # The third pass aligns the elements correctly. This is performed by adding spaces to
    # the right so that all the cells have the same width.
    for i in eachindex(column)
        row = column[i]
        pad = largest_cell_width - textwidth(row)
        pad = max(pad, 0)

        column[i] = row * " "^pad
    end

    return largest_cell_width
end

function _align_column_with_regex!(
    column::AbstractVector{Vector{T}},
    alignment_anchor_regex::Vector{Regex},
    alignment_anchor_fallback::Symbol,
) where {T <: AbstractString}
    # Variable to store in which column we must align the match.
    alignment_column = 0

    # Cache the column of the first regex match at each line. Hence, we avoid running the
    # regexes again in the second pass. `-1` means that no match was found.
    match_columns = [similar(row, Int) for row in column]

    # We need to pass through the entire column searching for matches to compute in which
    # column we need to align them.
    for i in eachindex(column)
        row = column[i]

        for l in eachindex(row)
            line = row[l]
            m = nothing

            for r in alignment_anchor_regex
                m_r = findfirst(r, line)
                isnothing(m_r) && continue
                m = m_r
                break
            end

            if !isnothing(m)
                alignment_column_i = textwidth(@views line[1:first(m)])
                match_columns[i][l] = alignment_column_i
            else
                match_columns[i][l] = -1

                # If a match is not found, the alignment column depends on the user
                # selection.

                if alignment_anchor_fallback == :c
                    line_len = textwidth(line)
                    alignment_column_i = cld(line_len, 2)

                elseif alignment_anchor_fallback == :r
                    line_len = textwidth(line)
                    alignment_column_i = line_len + 1

                else
                    alignment_column_i = 0
                end
            end

            alignment_column = max(alignment_column, alignment_column_i)
        end
    end

    # Variable to store the largest cell width after the alignment.
    largest_cell_width = 0

    # Now, we need to pass again applying the alignments.
    for i in eachindex(column)
        row = column[i]

        for l in eachindex(row)
            line = row[l]

            match_column_k = match_columns[i][l]

            if match_column_k >= 0
                pad = alignment_column - match_column_k
            else
                # If a match is not found, the alignment column depends on the user
                # selection.

                if alignment_anchor_fallback == :c
                    line_len = textwidth(line)
                    pad = alignment_column - cld(line_len, 2)

                elseif alignment_anchor_fallback == :r
                    line_len = textwidth(line)
                    pad = alignment_column - line_len - 1

                else
                    pad = alignment_column
                end
            end

            # `pad` must be positive.
            pad = max(pad, 0)

            # Apply the alignment to the line.
            row[l] = " "^pad * line
            line_len = textwidth(row[l])

            largest_cell_width = max(largest_cell_width, line_len)
        end
    end

    # The third pass aligns the elements correctly. This is performed by adding spaces to
    # the right so that all the cells have the same width.
    for i in eachindex(column)
        row = column[i]

        for l in eachindex(row)
            line   = row[l]
            pad    = largest_cell_width - textwidth(line)
            pad    = max(pad, 0)
            row[l] = line * " "^pad
        end
    end

    return largest_cell_width
end

"""
    _align_multline_column_with_regex!(column::AbstractVector{String}, alignment_anchor_regex::Vector{Regex}, alignment_anchor_fallback::Symbol,) -> Int

Similar to `_align_column_with_regex!`, but each row will be split into multiple lines at
`\n` before applying the alignment.
"""
function _align_multline_column_with_regex!(
    column::AbstractVector{String},
    alignment_anchor_regex::Vector{Regex},
    alignment_anchor_fallback::Symbol,
)
    # In this case, we split each row creating a vector of `Vector{String}`, where each
    # element is a line. Then, we perform the alignment and re-join the lines.
    v = split.(column, '\n')
    largest_cell_width = _align_column_with_regex!(
        v, alignment_anchor_regex, alignment_anchor_fallback
    )

    for i in 1:length(column)
        column[i - 1 + begin] = join(v[i - 1 + begin], '\n')
    end

    return largest_cell_width
end

"""
    _auto_wrap(str::AbstractString, field_width::Int) -> String

Autowrap the string `str` given a `field_width`.
"""
function _auto_wrap(str::AbstractString, field_width::Int)
    # Check for errors.
    (field_width <= 0) && throw(ArgumentError("`field_width` must be greater than 0."))

    # Buffers.
    buf      = IOBuffer(; sizehint = length(str)) # .......... Buffer to store the entire text
    line_buf = IOBuffer(; sizehint = length(str)) # ......... Buffer to store the current line

    # Auxiliary variables.
    state          = :text # .................................................. String state
    c_id           = 0     # ................................... ID of the current character
    line_width     = 0     # .................................... Total line printable width
    last_space     = 0     # ................................ ID of the last space character
    lw_after_space = 0     # ..................... Line width after the last space character

    for c in str
        state = StringManipulation._next_string_state(c, state)
        ctw = textwidth(c)

        if state != :text
            write(line_buf, c)
            c_id += ncodeunits(c)
            continue
        end

        line_overflow = line_width + ctw > field_width

        @views if (c == '\n') || (line_overflow && ((last_space == 0) || (c == ' ')))
            # If the character is a line break, if we have a line overflow and we do not have
            # any space in this line, or if we have a line overflow and this character is a
            # space, we only flush the current line buffer to the output buffer.
            write(buf, take!(line_buf))
            write(buf, '\n')

            c_id       = 0
            line_width = 0
            last_space = 0

            (c ∈ (' ', '\n')) && continue

        elseif line_overflow
            line = take!(line_buf)

            # If we have a last space in this line, break the line at that position, and
            # move the rest to another line.
            l₀ = line[1:(last_space - 1)]
            l₁ = line[(last_space + 1):end]

            write(buf, l₀)
            write(buf, '\n')
            write(line_buf, l₁)

            c_id       = length(l₁)
            line_width = lw_after_space
            last_space = 0
        end

        write(line_buf, c)
        c_id += ncodeunits(c)

        line_width     += textwidth(c)
        lw_after_space += ctw

        if c == ' '
            last_space     = c_id
            lw_after_space = 0
        end
    end

    # Flush the rest of the line.
    write(buf, take!(line_buf))

    return String(take!(buf))
end

"""
    _compact_type_str(T) -> String

Return a string with a compact representation of type `T`.
"""
_compact_type_str(T) = string(T)

function _compact_type_str(T::Union)
    str = T >: Missing ? string(nonmissingtype(T)) * "?" : string(T)
    return replace(str, "Union" => "U")
end

"""
    _maximum_textwidth_per_line(str::AbstractString) -> Int

Compute the maximum textwidth per line of the string `str`.
"""
function _maximum_textwidth_per_line(str::AbstractString)
    return maximum(printable_textwidth_per_line(str))
end

"""
    _omitted_cell_summary(table_data::TableData, pspec::PrintingSpec) -> String

Return the omitted cell summary related to the `table_data` and printing specification
`pspec`.
"""
function _omitted_cell_summary(table_data::TableData, pspec::PrintingSpec)
    pspec.show_omitted_cell_summary || return ""

    num_rows    = table_data.num_rows
    num_columns = table_data.num_columns
    max_rows    = table_data.maximum_number_of_rows
    max_columns = table_data.maximum_number_of_columns

    # Compute the number of omitted rows and columns. Notice that the conventions differ:
    # `maximum_number_of_rows == 0` crops the table to zero rows, whereas
    # `maximum_number_of_columns == 0` means no column cropping.
    num_omitted_columns = (max_columns > 0) ? num_columns - max_columns : 0
    num_omitted_rows    = (max_rows >= 0) ? num_rows - max_rows : 0

    return _omitted_cell_summary(num_omitted_rows, num_omitted_columns)
end

"""
    _omitted_cell_summary(num_omitted_rows::Int, num_omitted_columns::Int) -> String

Return the omitted cell summary string when there are `num_omitted_rows` omitted data rows
and `num_omitted_columns` omitted data columns.
"""
function _omitted_cell_summary(num_omitted_rows::Int, num_omitted_columns::Int)
    has_omitted_columns = num_omitted_columns > 0
    has_omitted_rows    = num_omitted_rows > 0

    (has_omitted_columns || has_omitted_rows) || return ""

    buf = IOBuffer()

    if has_omitted_columns
        print(buf, num_omitted_columns)
        print(buf, num_omitted_columns == 1 ? " column" : " columns")
    end

    (has_omitted_columns && has_omitted_rows) && print(buf, " and ")

    if has_omitted_rows
        print(buf, num_omitted_rows)
        print(buf, num_omitted_rows == 1 ? " row" : " rows")
    end

    print(buf, " omitted")

    return String(take!(buf))
end

"""
    _resolve_printing_backend(configurations) -> Symbol

Return the printing backend to be used based on the `configurations` provided. Notice that
this function must only be used when the user did not specify the backend directly using the
`backend` keyword.
"""
function _resolve_printing_backend(configurations)
    table_format = get(configurations, :table_format, nothing)
    backend = :text

    if table_format isa ExcelTableFormat
        backend = :excel
    elseif table_format isa HtmlTableFormat
        backend = :html
    elseif table_format isa LatexTableFormat
        backend = :latex
    elseif table_format isa MarkdownTableFormat
        backend = :markdown
    elseif table_format isa TypstTableFormat
        backend = :typst
    end

    return backend
end

## Description #############################################################################
#
# Define types for PrettyTables.jl
#
############################################################################################

export EmptyCells, MultiColumn, MergeCells, PrettyTable

# Tuple that defines a footnote.
const FootnoteTuple = Tuple{Symbol, Int, Int}

"""
    struct EmptyCells

Specification for adding a set of empty cells at the column label rows.

# Fields

- `number_of_cells::Int`: Number of cells to add (must be greater than 0).
"""
struct EmptyCells
    number_of_cells::Int

    function EmptyCells(number_of_cells::Int)
        number_of_cells < 1 && throw(
            ArgumentError("The `number_of_cells` of `EmptyCells` must be greater than 0."),
        )

        return new(number_of_cells)
    end
end

"""
    struct MultiColumn

Specification for merging columns at the column label rows.

# Fields

- `column_span::Int`: Number of columns to merge (must be greater than 1).
- `data::Any`: Merged cell data.
- `alignment::Symbol`: Merge cell alignment.
"""
struct MultiColumn
    column_span::Int
    data::Any
    alignment::Symbol

    function MultiColumn(column_span::Int, data::Any)
        column_span < 2 && throw(
            ArgumentError("The `column_span` of `MultiColumn` must be greater than 1.")
        )
        return new(column_span, data, :c)
    end

    function MultiColumn(column_span::Int, data::Any, alignment::Symbol)
        column_span < 2 && throw(
            ArgumentError("The `column_span` of `MultiColumn` must be greater than 1.")
        )
        return new(column_span, data, alignment)
    end
end

@kwdef struct MergeCells
    i::Int
    j::Int
    column_span::Int
    data::Any
    alignment::Symbol = :c

    function MergeCells(i::Int, j::Int, column_span::Int, data::Any)
        return new(i, j, column_span, data, :c)
    end

    function MergeCells(i::Int, j::Int, column_span::Int, data::Any, alignment::Symbol)
        return new(i, j, column_span, data, alignment)
    end
end

struct __IGNORE_CELL__ end
const _IGNORE_CELL = __IGNORE_CELL__()

struct UndefinedCell end
const _UNDEFINED_CELL = UndefinedCell()

"""
    struct RenderContext

Reusable rendering buffer. One instance is created per backend print call, meaning that the
per-cell rendering pays for a single `String` allocation instead of a fresh `IOBuffer` plus
`IOContext` per cell. The wrapped `IOContext` layers over the caller context so that
`:__PRETTY_TABLES__DATA__`, `:compact`, and `:limit` still flow through.
"""
struct RenderContext
    buf::IOBuffer
    ctx::IOContext{IOBuffer}
end

function RenderContext(@nospecialize(context::IOContext))
    buf = IOBuffer()
    return RenderContext(buf, IOContext(buf, context))
end

@kwdef mutable struct TableData
    data::Any

    # ==  Table Header =====================================================================

    title::String = ""
    subtitle::String = ""

    # == Labels ============================================================================

    # -- Columns ---------------------------------------------------------------------------

    stubhead_label::String = ""
    show_row_number_column::Bool = false
    row_number_column_label::String = ""
    column_labels::Vector{Vector{Any}}
    show_column_labels::Bool = true

    # -- Rows ------------------------------------------------------------------------------

    row_labels::Union{Nothing, AbstractVector} = nothing
    row_group_labels::Union{Nothing, Vector{Pair{Int, String}}} = nothing
    summary_rows::Union{Nothing, Vector{Any}} = nothing
    # NOTE: The abstract vector is required to store the lazy `SummaryLabelIterator`
    # without materializing it into a `Vector{String}` at construction time.
    summary_row_labels::Union{Nothing, AbstractVector{String}} = nothing

    # -- Cell Merging ----------------------------------------------------------------------

    merge_column_label_cells::Union{Nothing, Vector{MergeCells}} = nothing

    # == Table Footer ======================================================================

    footnotes::Union{Nothing, Vector{Pair{FootnoteTuple, String}}} = nothing
    source_notes::String = ""

    # == Alignments ========================================================================

    title_alignment::Symbol = :c
    subtitle_alignment::Symbol = :c
    cell_alignment::Union{Nothing, Vector{Any}} = nothing
    column_label_alignment::Union{Symbol, Vector{Symbol}} = :r
    continuation_row_alignment::Union{Nothing, Symbol} = nothing
    data_alignment::Union{Symbol, Vector{Symbol}} = :r
    row_number_column_alignment::Symbol = :r
    row_label_column_alignment::Symbol = :r
    row_group_label_alignment::Symbol = :l
    footnote_alignment::Symbol = :l
    source_note_alignment::Symbol = :l

    # == Formatters ========================================================================

    formatters::Union{Nothing, Vector{Any}} = nothing

    # == Auxiliary Variables ===============================================================

    # Since `data` can be any object, `size` is type unstable. Hence, we store this
    # information here to improve the performance.
    num_rows::Int
    num_columns::Int

    # We need to store the first index in both direction to reduce the number of
    # allocations. Notice that `data` is stored using `Any`, meaning that using functions
    # like `axes`, `firstindex`, and `begin` inside `getindex` will allocate.
    first_row_index::Int
    first_column_index::Int

    # Maximum number of rows and columns we must print.
    maximum_number_of_columns::Int = -1
    maximum_number_of_rows::Int = -1

    # How we should vertically crop the table.
    vertical_crop_mode::Symbol = :bottom
end

# == Tables.jl API =========================================================================

"""
    struct ColumnTable

This structure helps to access elements that comply with the column access specification of
Tables.jl.
"""
struct ColumnTable{D, T}
    data::D                      # .......................................... Original table
    table::T                     # .................. Table converted using `Tables.columns`
    column_names::Vector{Symbol} # ............................................ Column names
    size::Tuple{Int, Int}        # ....................................... Size of the table
end

# Since the structure is parametric, the automatically generated constructor requires
# `column_names` to be a `Vector{Symbol}` already. However, `Tables.columnnames` is allowed
# to return any container of symbols. Hence, we must convert it here.
function ColumnTable(
    data::D, table::T, column_names::AbstractVector{Symbol}, size::Tuple{Int, Int}
) where {D, T}
    return ColumnTable{D, T}(data, table, convert(Vector{Symbol}, column_names), size)
end

"""
    mutable struct RowTableAccessState

Mutable, constant-space state used to acquire rows from a `RowTable`.

# Fields

- `subset_supported::Bool`: Whether `Tables.subset` can be used with this table at all. It
    starts as `true` and is latched to `false` at the first failure.
    (**Default**: `true`)
- `requested_row::Int`: Row index associated with the cached subset acquisition.
    (**Default**: `0`)
- `subset_attempted::Bool`: Whether subset acquisition was attempted for `requested_row`.
    (**Default**: `false`)
- `subset_succeeded::Bool`: Whether subset acquisition succeeded for `requested_row`.
    (**Default**: `false`)
- `subset_row::Any`: Row returned by the cached subset acquisition.
    (**Default**: `nothing`)
- `iterator_row_index::Int`: Index of the row currently held by the iterator cursor.
    (**Default**: `0`)
- `iterator_row::Any`: Row currently held by the iterator cursor.
    (**Default**: `nothing`)
- `iterator_state::Any`: Opaque state required to continue the row iterator.
    (**Default**: `nothing`)
- `iterator_started::Bool`: Whether iterator traversal has started.
    (**Default**: `false`)
"""
mutable struct RowTableAccessState
    # NOTE: `subset_supported` must be latched, not reset per row. The subset cache is
    # row-local, so a table that does not implement `Tables.subset` used to pay for a thrown
    # and caught exception once per row, forever.
    subset_supported::Bool
    subset_getcolumn_supported::Bool
    requested_row::Int
    subset_attempted::Bool
    subset_succeeded::Bool
    subset_row::Any
    iterator_row_index::Int
    iterator_row::Any
    iterator_state::Any
    iterator_started::Bool

    function RowTableAccessState()
        return new(true, true, 0, false, false, nothing, 0, nothing, nothing, false)
    end
end

"""
    struct RowTable

This structure helps to access elements that comply with the row access specification of
Tables.jl.
"""
struct RowTable{D, T}
    data::D                           # ..................................... Original table
    table::T                          # ................ Table converted using `Tables.rows`
    column_names::Vector{Symbol}      # ....................................... Column names
    size::Tuple{Int, Int}             # .................................. Size of the table
    access_state::RowTableAccessState # ........................... Mutable row access state
end

# See the note in the `ColumnTable` constructor.
function RowTable(
    data::D,
    table::T,
    column_names::AbstractVector{Symbol},
    size::Tuple{Int, Int},
    access_state::RowTableAccessState,
) where {D, T}
    return RowTable{D, T}(
        data, table, convert(Vector{Symbol}, column_names), size, access_state
    )
end

# == Print Table State =====================================================================

const _INITIALIZE          = 0
const _TITLE               = 1
const _SUBTITLE            = 2
const _NEW_ROW             = 3
const _ROW_GROUP           = 4
const _ROW_NUMBER_COLUMN   = 5
const _ROW_LABEL_COLUMN    = 6
const _DATA                = 7
const _CONTINUATION_COLUMN = 8
const _END_ROW             = 9
const _FOOTNOTES           = 10
const _SOURCENOTES         = 11
const _END_PRINTING        = 12
const _END_ROW_AFTER_GROUP = 13
const _NEW_ROW_AFTER_GROUP = 14

const _VERTICAL_CONTINUATION_CELL_ACTIONS = (
    :vertical_continuation_cell,
    :row_number_vertical_continuation_cell,
    :row_label_vertical_continuation_cell,
)

const _TABLE_ROW_SECTION_NAMES = Dict(
    :table_header     => "Table Header",
    :column_labels    => "Column Labels",
    :data             => "Data",
    :continuation_row => "Continuation Row",
    :row_group_label  => "Row Group Label",
    :summary_row      => "Summary Row",
    :table_footer     => "Table Footer",
)

"""
    struct PrintingTableState

This structure stores the current state of the printing process.

# Fields

- `state::Int`: The current state of the printing process.
- `i::Int`: The current row index.
- `j::Int`: The current column index.
- `row_section::Symbol`: The current or the next row section.

!!! warning

    The field `row_section` is used to determine the next state of the printing process. It
    must not be used to verify the current or the next row section as the meaning can change
    depending on the current state. Instead, always use the function `_next` to obtain the
    next row section.
"""
struct PrintingTableState
    state::Int
    i::Int
    j::Int
    row_section::Symbol

    function PrintingTableState(state::Int, i::Int, j::Int, row_section::Symbol)
        return new(state, i, j, row_section)
    end

    function PrintingTableState()
        return new(_INITIALIZE, 0, 0, :table_header)
    end
end

# == Printing Specification ================================================================

@kwdef struct PrintingSpec
    context::IOContext
    table_data::TableData
    renderer::Symbol
    show_omitted_cell_summary::Bool
    new_line_at_end::Bool
end

# == Auxiliary =============================================================================

# Type to lazily construct the summary row / column label if the user does not pass this
# information.
struct SummaryLabelIterator <: AbstractVector{String}
    summary_rows::Vector{Any}
end

Base.size(s::SummaryLabelIterator) = (length(s.summary_rows),)
function Base.getindex(s::SummaryLabelIterator, i::Int)
    f_str = string(s.summary_rows[i])
    startswith(f_str, '#') && return "Summary $i"
    return f_str
end

# == PrettyTable ===========================================================================

"""
    mutable struct PrettyTable

This structure stores the data and configuration options required to print a table. The
table to be displayed is specified by the `data` field, while any additional configuration
options, corresponding to the keyword arguments accepted by the `pretty_table` function, can
be set as fields with matching names.

Users can overload the `show` function to customize how the table is printed for different
MIME types. PrettyTables.jl provides a default `show` method for printing tables to
`stdout`.

## Fields

- `data::Any`: The table to be displayed.
- `configurations::Dict{Symbol, Any}`: A dictionary containing configuration options for
    the table. The keys are symbols corresponding to the keyword arguments accepted by the
    `pretty_table` function, and the values are the corresponding settings. It is not
    recommended to add configurations here directly. Use the native Julia syntax to set
    fields in the `PrettyTable` object instead.

# Extended Help

## Examples

```julia-repl
julia> pt = PrettyTable(ones(3, 3))
┌────────┬────────┬────────┐
│ Col. 1 │ Col. 2 │ Col. 3 │
├────────┼────────┼────────┤
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
│    1.0 │    1.0 │    1.0 │
└────────┴────────┴────────┘

julia> pt.table_format = TextTableFormat(; @text__no_vertical_lines)
TextTableFormat(TextTableBorders('┐', '┌', '└', '┘', '┬', '├', '┤', '┼', '┴', '│', '─'), true, :none, true, :none, true, true, true, true, true, false, false, false, :none, false, false, true, 0)

julia> pt
────────────────────────
 Col. 1  Col. 2  Col. 3
────────────────────────
    1.0     1.0     1.0
    1.0     1.0     1.0
    1.0     1.0     1.0
────────────────────────

julia> pt.data = 2 .* ones(3, 3)
3×3 Matrix{Float64}:
 2.0  2.0  2.0
 2.0  2.0  2.0
 2.0  2.0  2.0

julia> pt
────────────────────────
 Col. 1  Col. 2  Col. 3
────────────────────────
    2.0     2.0     2.0
    2.0     2.0     2.0
    2.0     2.0     2.0
────────────────────────
```
"""
mutable struct PrettyTable
    data::Any
    configurations::Dict{Symbol, Any}

    function PrettyTable(data::Any; kwargs...)
        return new(data, Dict{Symbol, Any}(kwargs...))
    end
end

function Base.getproperty(pt::PrettyTable, field::Symbol)
    field in fieldnames(PrettyTable) && return getfield(pt, field)
    return get(getfield(pt, :configurations), field, nothing)
end

function Base.setproperty!(pt::PrettyTable, field::Symbol, value::Any)
    field in fieldnames(PrettyTable) && return setfield!(pt, field, value)
    return getfield(pt, :configurations)[field] = value
end

## Description #############################################################################
#
# Documentation for the text backend.
#
############################################################################################

"""
# PrettyTables.jl Text Backend

The text backend can be selected by passing the keyword `backend = :text` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output.

# Keywords

- `alignment_anchor_fallback::Symbol`: This keyword controls the line alignment when using
    the regex alignment anchors if a match is not found. If it is `:l`, the left of the line
    will be aligned with the anchor. If it is `:c`, the line center will be aligned with the
    anchor. Otherwise, the end of the line will be aligned with the anchor.
    (**Default** = `:l`)
- `alignment_anchor_regex::Union{Vector{Regex}, Vector{Pair{Int, Vector{Regex}}}}`: This
    keyword can be used to provide regexes to align the data values in the table columns. If
    it is `Vector{Regex}`, the regexes will be used to align all the columns. If it is
    `Vector{Pair{Int, Vector{Regex}}}`, the `Int` element specifies the column to which the
    regexes in `Vector{Regex}` will be applied. The regex match is searched in the same
    order as the regexes appear on the vector. The regex matching is applied after the cell
    conversion to string, which includes the formatters. If no match is found for a specific
    line, the alignment of this line depends on the option `alignment_anchor_fallback`.
    Example: `[2 => [r"\\."]]` aligns the decimal point of the cells in the second column.
    (**Default** = `Regex[]`)
- `apply_alignment_regex_to_summary_rows::Bool`: If `true`, the alignment regexes in
    `alignment_anchor_regex` will also be applied to the summary rows.
    (**Default** = `false`)
- `auto_wrap::Bool`: If `true`, the text will be wrapped on spaces to fit the column. Note
    that this function requires `line_breaks = true` and the column must have a fixed size
    (see `fixed_data_column_widths`).
    (**Default** = `false`)
- `column_label_width_based_on_first_line_only::Bool`: If `true`, the column label width is
    based on the first line of the column. Hence, if the other column labels have text
    width larger than the computed column width, they will be cropped to fit.
    (**Default** = `false`)
- `display_size::Tuple{Int, Int}`: A tuple of two integers that defines the display size
    (num. of rows, num. of columns) that is available to print the table. It is used to crop
    the data depending on the value of the keyword `crop`. Notice that if a dimension is not
    positive, it will be treated as unlimited.
    (**Default** = `displaysize(io)`)
- `equal_data_column_widths::Bool`: If `true`, the data columns will have the same width.
    (**Default** = `false`)
- `fit_table_in_display_horizontally::Bool`: If `true`, the table will be cropped to fit
    the display horizontally.
    (**Default** = `true`)
- `fit_table_in_display_vertically::Bool`: If `true`, the table will be cropped to fit the
    display vertically.
    (**Default** = `true`)
- `fixed_data_column_widths::Union{Int, Vector{Int}}`: If it is a `Vector{Int}`, this vector
    specifies the width of each column. If it is a `Int`, this number will be used as the
    width of all columns. If the width is equal to or lower than 0, it will be automatically
    computed to fit the largest cell in the column.
    (**Default** = 0)
- `highlighters::Vector{TextHighlighter}`: Highlighters to apply to the table. For more
    information, see the section **Text Highlighters** in the **Extended Help**.
- `line_breaks::Bool`: If `true`, a new line character will break the line inside the cells.
    (**Default** = `false`)
- `maximum_data_column_widths::Union{Int, Vector{Int}}`: If it is a `Vector{Int}`, this
    vector specifies the maximum width of each column. If it is an `Int`, this number will
    be used as the maximum width of all columns. If the maximum width is equal to or lower
    than 0, it will be ignored. Notice that the parameter `fixed_data_column_widths` has
    precedence over this one.
    (**Default** = 0)
- `minimum_data_column_widths::Union{Int, Vector{Int}}`: If it is a `Vector{Int}`, this
    vector specifies the minimum width of each column. If it is an `Int`, this number will
    be used as the minimum width of all columns. If the minimum width is equal to or lower
    than 0, it will be ignored. Notice that the parameter `fixed_data_column_widths` has
    precedence over this one.
    (**Default** = 0)
- `overwrite_display::Bool`: If `true`, the same number of lines in the printed table will
    be deleted from the output `io`. This can be used to update the table in the display
    continuously.
    (**Default** = `false`)
- `reserved_display_lines::Int`: Number of lines to be left at the beginning of the printing
    when vertically cropping the output.
    (**Default** = 0)
- `shrinkable_column_minimum_width::Int`: If it is a positive integer (> 0), this is the
    minimum width of the shrinkable column (see `shrinkable_data_column`).
    (**Default** = 0)
- `shrinkable_data_column::Int`: If it is a positive integer, this column will be
    shrinkable. This means that if the table does not fit in the display, this column will
    be shrunk to fit the table in the display. If it is `0` or negative, no column will be
    shrinkable.
    (**Default** = 0)
- `style::TextTableStyle`: Style of the table. For more information, see the section
    **Text Table Style** in the **Extended Help**.
- `table_format::TextTableFormat`: Text table format used to render the table. For more
    information, see the section **Text Table Format** in the **Extended Help**.

# Extended Help

## Text highlighters

A set of highlighters can be passed as a `Vector{TextHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`TextHighlighter`](@ref). It
contains three fields:

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `fd(h, data, i, j)` in which `h` is the
    highlighter. This function must return the `Crayon` to be applied to the cell that must
    be highlighted.
- `_decoration::Crayon`: The `Crayon` to be applied to the highlighted cell if the default
    `fd` is used.

The function `f` has the following signature:

```julia
f(data, i, j)
```

in which `data` is a reference to the data that is being printed, and `i` and `j` are the
element coordinates that are being tested. If this function returns `true`, the cell
`(i, j)` will be highlighted.

If the function `f` returns true, the function `fd(h, data, i, j)` will be called and must
return a `Crayon` that will be applied to the cell.

A highlighter can be constructed using three helpers:

```julia
TextHighlighter(f::Function; kwargs...)
```

where it will construct a `Crayon` using the keywords in `kwargs` and apply it to the
highlighted cell,

```julia
TextHighlighter(f::Function, crayon::Crayon)
```

where it will apply the `crayon` to the highlighted cell, and

```julia
TextHighlighter(f::Function, fd::Function)
```

where it will apply the `Crayon` returned by the function `fd` to the highlighted cell.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the tuple `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells with value greater than 5 in red, and
all the cells with value less than 5 in blue, we can define:

```julia
hl_gt5 = TextHighlighter(
    (data, i, j) -> data[i, j] > 5,
    crayon"red"
)

hl_lt5 = TextHighlighter(
    (data, i, j) -> data[i, j] < 5,
    crayon"blue"
)

highlighters = [hl_gt5, hl_lt5]
```

## Text Table Format

The text table format is defined using an object of type [`TextTableFormat`](@ref) that
contains the following fields:

- `borders::TextTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_lines_at_column_labels::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each column label row index listed in this vector. If the symbol `:all` is
    passed, a horizontal line will be drawn after every column label. If the symbol `:none`
    is passed, no horizontal lines will be drawn.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn at the merged column labels. Notice that the horizontal line drawn using the
    option `horizontal_lines_at_column_labels` has precedence over this one.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data row. If the symbol `:none` is passed,
    no horizontal lines will be drawn.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data column. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.
- `suppress_vertical_lines_at_column_labels::Bool`: If `true`, the vertical lines inside
    the column label rows will be suppressed.
- `ellipsis_line_skip::Integer`: Number of lines to skip when printing an ellipsis.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@text__all_horizontal_lines`](@ref).
- [`@text__all_vertical_lines`](@ref).
- [`@text__no_horizontal_lines`](@ref).
- [`@text__no_vertical_lines`](@ref).

## Text Table Style

The text table style is defined using an object of type [`TextTableStyle`](@ref) that
contains the following fields:

- `title::Crayon`: Crayon with the style for the title.
- `subtitle::Crayon`: Crayon with the style for the subtitle.
- `row_number_label::Crayon`: Crayon with the style for the row number label.
- `row_number::Crayon`: Crayon with the style for the row numbers.
- `stubhead_label::Crayon`:  Crayon with the style for the stubhead label.
- `row_label::Crayon`: Crayon with the style for the row labels.
- `row_group_label::Crayon`: Crayon with the style for the row group label.
- `first_line_column_label::Union{Crayon, Vector{Crayon}}`: Crayon or crayons with the style
    for the first column label lines. If a vector of crayons is passed, it must have the
    same length as the number of columns in the table.
- `column_label::Union{Crayon, Vector{Crayon}}`: Crayon or crayons with the style for the
    rest of the column labels. If a vector of crayons is passed, it must have the same
    length as the number of columns in the table.
- `first_line_merged_column_label::Crayon`: Crayon with the style for the merged cells at
    the first column label line.
- `merged_column_label::Crayon`: Crayon with the style for the merged cells at the rest of
    the column labels.
- `summary_row_cell::Crayon`: Crayon with the style for the summary row cell.
- `summary_row_label::Crayon`: Crayon with the style for the summary row label.
- `footnote::Crayon`: Crayon with the style for the footnotes.
- `source_note::Crayon`: Crayon with the style for the source notes.
- `omitted_cell_summary::Crayon`: Crayon with the style for the omitted cell summary.
- `table_border::Crayon`: Crayon with the style for the table border.

Each field is a `Crayon` describing the style for the corresponding element in the table.

For example, if we want that the stubhead label is bold and red, we must define:

```julia
style = TextTableStyle(
    stubhead_label = crayon"bold red"
)
```
"""
pretty_table_text_backend

## Description #############################################################################
#
# Tests related to the internal functions that guard user-observed performance.
#
############################################################################################

@testset "Horizontal Line Counting" verbose = true begin
    # `_text__count_horizontal_lines` replaced a scan over every row of the source table.
    # Hence, it must reproduce that scan exactly while being independent of `last_row`.
    naive(hlines, last_row) = count(i -> i ∈ hlines, 1:last_row)

    @testset "Ranges" begin
        for hlines in (1:0, 1:1, 1:5, 3:7, 1:1000), last_row in (0, 1, 4, 10)
            @test PrettyTables._text__count_horizontal_lines(hlines, last_row) ==
                naive(hlines, last_row)
        end
    end

    @testset "Vectors" begin
        for hlines in (Int[], [1], [2, 4], [1, 2, 3], [5, 1, 9], [-3, 0, 2]),
            last_row in (0, 1, 4, 10)

            @test PrettyTables._text__count_horizontal_lines(hlines, last_row) ==
                naive(hlines, last_row)
        end
    end

    @testset "Duplicated Entries Are Counted Once" begin
        @test PrettyTables._text__count_horizontal_lines([2, 2, 2], 5) == 1
        @test PrettyTables._text__count_horizontal_lines([1, 2, 2, 3], 5) == 3
    end
end

@testset "Printing a Cropped Table Is Independent of the Number of Rows" begin
    # `_text__number_of_required_lines` used to walk every row of the source table, twice,
    # with no early exit. Hence, `pretty_table(1:10^7)` took tens of milliseconds even though
    # only a screenful is ever shown.
    #
    # This is asserted through the allocation count, which is deterministic, instead of
    # through the elapsed time.
    function allocations_for(n)
        io = IOContext(IOBuffer(), :displaysize => (25, 80), :color => false, :limit => true)

        # Warm up so that compilation is not measured.
        pretty_table(io, 1:n)
        take!(io.io)

        a = @allocated pretty_table(io, 1:n)
        take!(io.io)

        return a
    end

    small = allocations_for(10^3)
    large = allocations_for(10^7)

    @test small == large
end

## Description #############################################################################
#
# LaTeX Back End: Tests related to special cells.
#
############################################################################################

#! format: off

@testset "Special Cells" verbose = true begin
    @testset "LatexCell" begin
        matrix = [
            latex_cell"\textbf{Test}",
            latex_cell"\(a^2 + b^2\)",
            latex_cell"\textit{Test}"
        ]

        expected = """
\\begin{tabular}{|r|}
  \\hline
  \\textbf{Col. 1} \\\\
  \\hline
  \\textbf{Test} \\\\
  \\(a^2 + b^2\\) \\\\
  \\textit{Test} \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex
        )

        @test result == expected
    end

    @testset "LaTeXString" begin
        matrix = [L"a^2 + b^2", L"\mathbf{v}_b", L"\mathbf{I}_{3 \times 3}"]

        expected = """
\\begin{tabular}{|r|}
  \\hline
  \\textbf{Col. 1} \\\\
  \\hline
  \$a^2 + b^2\$ \\\\
  \$\\mathbf{v}_b\$ \\\\
  \$\\mathbf{I}_{3 \\times 3}\$ \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex
        )

        @test result == expected
    end

    @testset "Markdown" begin
        matrix = [
            md"**Bold Text**",
            md"*Italic Text*",
            md"`Code Snippet`"
        ]

        expected = """
\\begin{tabular}{|r|}
  \\hline
  \\textbf{Col. 1} \\\\
  \\hline
  \\textbf{Bold Text} \\\\
  \\emph{Italic Text} \\\\
  \\texttt{Code Snippet} \\\\
  \\hline
\\end{tabular}
"""

        result = pretty_table(
            String,
            matrix;
            backend = :latex
        )

        @test result == expected
    end

    @testset "Escaping of LaTeX Metacharacters" begin
        # `^` must be escaped as `\textasciicircum{}`. Notice that `\^` is the circumflex
        # *accent* command, which takes the next character as its argument. Hence, `a\^b`
        # would typeset `b` with a circumflex instead of showing a literal caret.
        matrix = ["a^b" "c%d" "e&f" "g_h" "i#j" "k{l}" "m~n" "o\\p" "q\$r"]

        result = pretty_table(String, matrix; backend = :latex)

        @test occursin("a\\textasciicircum{}b", result)
        @test occursin("c\\%d", result)
        @test occursin("e\\&f", result)
        @test occursin("g\\_h", result)
        @test occursin("i\\#j", result)
        @test occursin("k\\{l\\}", result)
        @test occursin("m\\textasciitilde{}n", result)
        @test occursin("o\\textbackslash{}p", result)
        @test occursin("q\\\$r", result)
    end
end

#! format: on

## Description #############################################################################
#
# Types and structures for the HTML back end.
#
############################################################################################

export HtmlHighlighter, HtmlTableFormat, HtmlTableStyle

# Pair that defines HTML properties.
const HtmlPair = Pair{String, String}

############################################################################################
#                                       Highlighters                                       #
############################################################################################

"""
    struct HtmlHighlighter

Define the default highlighter of a table when using the HTML back end.

# Fields

- `f::Function`: Function with the signature `f(data, i, j)` which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
    highlighter. This function must return a `Vector{Pair{String, String}}` with properties
    compatible with the `style` field that will be applied to the highlighted cell.
- `_decoration::Vector{HtmlPair}`: The decoration to be applied to the highlighted cell
    if the default `fd` is used.

# Remarks

This structure can be constructed using the following helpers:

    HtmlHighlighter(f::Function, decoration::HtmlPair)

    HtmlHighlighter(f::Function, decoration::Vector{HtmlPair})

    HtmlHighlighter(f::Function, fd::Function)

The first two apply a fixed decoration to the highlighted cell, whereas the third lets the
user select the desired decoration by specifying the function `fd`.
"""
struct HtmlHighlighter
    f::Function
    fd::Function

    # == Private Fields ====================================================================

    _decoration::Vector{HtmlPair}

    # == Constructors ======================================================================

    function HtmlHighlighter(f::Function, fd::Function)
        return new(f, fd, HtmlPair[])
    end

    function HtmlHighlighter(f::Function, decoration::HtmlPair)
        return new(f, _html__default_highlighter_fd, [decoration])
    end

    function HtmlHighlighter(f::Function, decoration::Vector{HtmlPair})
        return new(f, _html__default_highlighter_fd, decoration)
    end

    function HtmlHighlighter(f::Function, decoration::Vector{HtmlPair}, args::HtmlPair...)
        return new(f, _html__default_highlighter_fd, [decoration..., args...])
    end
end

_html__default_highlighter_fd(h::HtmlHighlighter, ::Any, ::Int, ::Int) = h._decoration

############################################################################################
#                                       Table Format                                       #
############################################################################################

# Create some default decorations to reduce allocations.
const _HTML__NO_DECORATION = HtmlPair[]
const _HTML__BOLD = ["font-weight" => "bold"]
const _HTML__ITALIC = ["font-style" => "italic"]
const _HTML__XLARGE_BOLD = ["font-size" => "x-large", "font-weight" => "bold"]
const _HTML__LARGE_ITALIC = ["font-size" => "large", "font-style" => "italic"]
const _HTML__SMALL = ["font-size" => "small"]
const _HTML__SMALL_ITALIC = ["font-size" => "small", "font-style" => "italic"]
const _HTML__SMALL_ITALIC_GRAY = [
    "color" => "gray", "font-size" => "small", "font-style" => "italic"
]
const _HTML__MERGED_CELL = ["border-bottom" => "1px solid black"]

"""
    HtmlTableFormat

Format that will be used to print the HTML table. All parameters are strings compatible with
the corresponding HTML property.

# Fields

- `css::String`: CSS to be injected at the end of the `<style>` section.
- `table_width::String`: Table width.

Notice that this format is only applied if `stand_alone = true`.
"""
@kwdef struct HtmlTableFormat
    css::String = """
    table, td, th {
      border-collapse: collapse;
      font-family: sans-serif;
    }

    td, th {
      padding-bottom: 6px !important;
      padding-left: 8px !important;
      padding-right: 8px !important;
      padding-top: 6px !important;
    }

    tr.title td {
      padding-bottom: 2px !important;
    }

    tr.footnote td {
      padding-bottom: 2px !important;
    }

    tr.sourceNotes td {
      padding-bottom: 2px !important;
    }

    table > *:first-child > tr:first-child {
      border-top: 2px solid black;
    }

    table > *:last-child > tr:last-child {
      border-bottom: 2px solid black;
    }

    thead > tr:nth-child(1 of .columnLabelRow) {
      border-top: 1px solid black;
    }

    thead tr:last-child {
      border-bottom: 1px solid black;
    }

    tbody tr:last-child {
      border-bottom: 1px solid black;
    }

    tbody > tr:nth-child(1 of .summaryRow) {
      border-top: 1px solid black;
    }

    tbody > tr:nth-last-child(1 of .summaryRow) {
      border-bottom: 1px solid black;
    }

    tfoot tr:nth-last-child(1 of .footnote) {
      border-bottom: 1px solid black;
    }"""

    table_width::String = ""
end

"""
    struct HtmlTableStyle

Define the style of the tables printed with the HTML back end.

# Fields

- `top_left_string::Vector{HtmlPair}`: Style for the top left string.
- `top_right_string::Vector{HtmlPair}`: Style for the top right string.
- `table::Vector{HtmlPair}`: Style for the table.
- `title::Vector{HtmlPair}`: Style for the title.
- `subtitle::Vector{HtmlPair}`: Style for the subtitle.
- `row_number_label::Vector{HtmlPair}`: Style for the row number label.
- `row_number::Vector{HtmlPair}`: Style for the row number.
- `stubhead_label::Vector{HtmlPair}`: Style for the stubhead label.
- `row_label::Vector{HtmlPair}`: Style for the row label.
- `row_group_label::Vector{HtmlPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}}`: Style for
    the first line of the column labels. If a vector of `Vector{HtmlPair}` is provided,
    each column label in the first line will use the corresponding style.
- `column_label::Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}}`: Style for the rest of
    the column labels. If a vector of `Vector{HtmlPair}` is provided, each column label
    will use the corresponding style.
- `first_line_merged_column_label::Vector{HtmlPair}`: Style for the merged cells at the
    first column label line.
- `merged_column_label::Vector{HtmlPair}`: Style for the merged cells at the rest of the
    column labels.
- `summary_row_cell::Vector{HtmlPair}`: Style for the summary row cell.
- `summary_row_label::Vector{HtmlPair}`: Style for the summary row label.
- `footnote::Vector{HtmlPair}`: Style for the footnote.
- `source_note::Vector{HtmlPair}`: Style for the source notes.
"""
@kwdef struct HtmlTableStyle{
    TFCL <: Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}},
    TCL <: Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}},
}
    top_left_string::Vector{HtmlPair}                = _HTML__NO_DECORATION
    top_right_string::Vector{HtmlPair}               = _HTML__ITALIC
    table::Vector{HtmlPair}                          = _HTML__NO_DECORATION
    title::Vector{HtmlPair}                          = _HTML__XLARGE_BOLD
    subtitle::Vector{HtmlPair}                       = _HTML__LARGE_ITALIC
    row_number_label::Vector{HtmlPair}               = _HTML__BOLD
    row_number::Vector{HtmlPair}                     = _HTML__BOLD
    stubhead_label::Vector{HtmlPair}                 = _HTML__BOLD
    row_label::Vector{HtmlPair}                      = _HTML__BOLD
    row_group_label::Vector{HtmlPair}                = _HTML__BOLD
    first_line_column_label::TFCL                    = _HTML__BOLD
    column_label::TCL                                = _HTML__NO_DECORATION
    first_line_merged_column_label::Vector{HtmlPair} = _HTML__MERGED_CELL
    merged_column_label::Vector{HtmlPair}            = _HTML__MERGED_CELL
    summary_row_cell::Vector{HtmlPair}               = _HTML__NO_DECORATION
    summary_row_label::Vector{HtmlPair}              = _HTML__BOLD
    footnote::Vector{HtmlPair}                       = _HTML__SMALL
    source_note::Vector{HtmlPair}                    = _HTML__SMALL_ITALIC_GRAY
end

############################################################################################
#
# Functions to compute the printed column widths.
#
############################################################################################

"""
    _text__fix_data_column_widths!(
        printed_data_column_widths::Vector{Int},
        table_data::TableData,
        column_labels::Union{Nothing, Matrix{String}},
        table_str::Matrix{String},
        summary_rows::Union{Nothing, Matrix{String}},
        fixed_data_column_widths::AbstractVector{Int},
        vertical_lines_at_data_columns::AbstractVector{Int},
        auto_wrap::Bool,
        line_breaks::Bool
    ) -> Nothing

Fix the data column widths given the user specification. This function also crops the cells
at the data columns to fit the fixed width.

# Arguments

- `printed_data_column_widths::Vector{Int}`: Printed data column widths.
- `table_data::TableData`: Table data.
- `column_labels::Union{Nothing, Matrix{String}}`: Column labels.
- `table_str::Matrix{String}`: Rendered data cells.
- `summary_rows::Union{Nothing, Matrix{String}}`: Summary rows.
- `fixed_data_column_widths::AbstractVector{Int}`: Fixed data column widths.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell. It is required to compute the available width of
    merged column labels.
- `auto_wrap::Bool`: If `true`, the strings will be auto wrapped at each column with a fixed
    width.
- `line_breaks::Bool`: If `true`, the cells will be split into multiple lines if needed.
"""
function _text__fix_data_column_widths!(
    printed_data_column_widths::Vector{Int},
    table_data::TableData,
    column_labels::Union{Nothing, Matrix{String}},
    table_str::Matrix{String},
    summary_rows::Union{Nothing, Matrix{String}},
    fixed_data_column_widths::AbstractVector{Int},
    vertical_lines_at_data_columns::AbstractVector{Int},
    auto_wrap::Bool,
    line_breaks::Bool,
)
    for j in eachindex(printed_data_column_widths)
        fcw = fixed_data_column_widths[j - 1 + begin]
        (fcw <= 0) && continue
        printed_data_column_widths[j] = fcw

        if auto_wrap
            for i in axes(table_str, 1)
                table_str[i, j] = _auto_wrap(table_str[i, j], printed_data_column_widths[j])
            end
        end
    end

    for table in (table_str, summary_rows)
        isnothing(table) && continue

        for j in axes(table, 2)
            cw = printed_data_column_widths[j]

            for i in axes(table, 1)
                table[i, j] = _text__crop_cell_to_width(table[i, j], cw, line_breaks)
            end
        end
    end

    isnothing(column_labels) && return nothing

    num_printed_data_columns = size(column_labels, 2)

    for j in axes(column_labels, 2)
        for i in axes(column_labels, 1)
            # A merged column label spans multiple columns. Hence, its available width must
            # be computed from all the spanned columns. Notice that we only need to crop the
            # cell where the merged label is stored, which is the first one.
            j₀, j₁ = _column_label_limits(table_data, i, j)

            j != j₀ && continue

            j₁ = min(j₁, num_printed_data_columns)

            cw = 0

            for k in j₀:j₁
                cw += printed_data_column_widths[k]

                # We must also take into account the margins and vertical lines between the
                # merged columns.
                if k != j₁
                    cw += 2 + (k ∈ vertical_lines_at_data_columns)
                end
            end

            column_labels[i, j] = _text__crop_cell_to_width(column_labels[i, j], cw, line_breaks)
        end
    end

    return nothing
end

"""
    _text__crop_cell_to_width(str::String, cw::Int, line_breaks::Bool) -> String

Crop each line of the cell `str` to fit the width `cw`, adding a continuation character at
the end of the cropped lines. If `line_breaks` is `false`, `str` is treated as a single
line.
"""
function _text__crop_cell_to_width(str::String, cw::Int, line_breaks::Bool)
    if !line_breaks
        tw = printable_textwidth(str)
        tw <= cw && return str

        str = first(right_crop(str, tw - cw + 1))
        return str * "…"
    end

    tokens = split(str, '\n')

    for l in eachindex(tokens)
        line = tokens[l]
        tw   = printable_textwidth(line)
        tw <= cw && continue

        line = first(right_crop(line, tw - cw + 1))
        line *= "…"
        tokens[l] = line
    end

    return join(tokens, '\n')
end

"""
    _text__fit_cell_in_maximum_cell_width(
        cell_str::String,
        maximum_cell_width::Int,
        line_breaks::Bool
    ) -> String

Fit the cell with text `cell_str` in a field with a maximum width `maximum_cell_width`. If
`line_breaks` is `true`, the cell will be split into multiple lines before fitting it.
"""
function _text__fit_cell_in_maximum_cell_width(
    cell_str::String, maximum_cell_width::Int, line_breaks::Bool
)
    maximum_cell_width < 1 && return cell_str

    if !line_breaks
        tw = printable_textwidth(cell_str)
        tw <= maximum_cell_width && return cell_str

        cell_str, _ = right_crop(cell_str, tw - maximum_cell_width + 1)
        cell_str *= "…"
    else
        tokens = split(cell_str, '\n')
        fitted_tokens = Vector{String}(undef, length(tokens))

        for k in eachindex(tokens)
            t  = tokens[k]
            tw = printable_textwidth(t)

            if tw > maximum_cell_width
                t = first(right_crop(t, tw - maximum_cell_width + 1))
                t *= "…"
            end

            fitted_tokens[k] = t
        end

        cell_str = join(fitted_tokens, '\n')
    end

    return cell_str
end

"""
    _text__printed_column_widths(
        table_data,
        row_labels,
        column_labels,
        summary_rows,
        summary_row_labels,
        table_str,
        vertical_lines_at_data_columns,
        column_label_width_based_on_first_line_only,
        line_breaks,
        minimum_data_column_widths
    )

Compute the printed column widths.

# Arguments

- `table_data::TableData`: Table data.
- `row_labels::Union{Nothing, Vector{String}}`: Rendered row labels.
- `column_labels::Union{Nothing, Matrix{String}}`: Rendered column labels.
- `summary_rows::Union{Nothing, Matrix{String}}`: Rendered summary rows.
- `summary_row_labels::Union{Nothing, Vector{String}}`: Rendered summary row labels.
- `table_str::Matrix{String}`: Rendered data cells.
- `vertical_lines_at_data_columns::AbstractVector{Int}`: List of columns where a vertical
    line must be drawn after the cell.
- `column_label_width_based_on_first_line_only::Bool`: If `true`, the column label width
    will be computed based on the first line only.
- `line_breaks::Bool`: If `true`, the cells will be split into multiple lines if needed.
    Hence, the textwidth of each line is used to compute the column width.
- `minimum_data_column_widths::AbstractVector{Int}`: Minimum data column widths.

# Returns

- `Int`: Row number column width.
- `Int`: Row label column width.
- `Vector{Int}`: Printed data column widths.
"""
function _text__printed_column_widths(
    table_data::TableData,
    row_labels::Union{Nothing, Vector{String}},
    column_labels::Union{Nothing, Matrix{String}},
    summary_rows::Union{Nothing, Matrix{String}},
    summary_row_labels::Union{Nothing, Vector{String}},
    table_str::Matrix{String},
    vertical_lines_at_data_columns::AbstractVector{Int},
    column_label_width_based_on_first_line_only::Bool,
    line_breaks::Bool,
    minimum_data_column_widths::AbstractVector{Int},
)
    num_printed_data_rows, num_printed_data_columns = size(table_str)

    row_number_column_width    = 0
    row_label_column_width     = 0
    printed_data_column_widths = zeros(Int, num_printed_data_columns)

    if table_data.show_row_number_column
        m =
            (
                _is_vertically_cropped(table_data) &&
                (table_data.vertical_crop_mode == :bottom)
            ) ? table_data.maximum_number_of_rows : table_data.num_rows

        # The printed row numbers run from `first_row_index` to `first_row_index + m - 1`,
        # which can be negative when the data has a non 1-based row axis. Notice that
        # `ndigits` must be used instead of `floor(Int, log10(x) + 1)` because the latter is
        # float-fragile, returning 19 instead of 18 for `m = 999_999_999_999_999_999`.
        f = table_data.first_row_index
        l = f + max(m, 1) - 1

        row_number_column_width = max(
            printable_textwidth(table_data.row_number_column_label),
            ndigits(f) + (f < 0),
            ndigits(l) + (l < 0),
        )
    end

    if !isnothing(row_labels)
        row_label_column_width = max(
            printable_textwidth(table_data.stubhead_label),
            num_printed_data_rows > 0 ? maximum(printable_textwidth, row_labels) : 0,
            if !isnothing(summary_row_labels)
                maximum(printable_textwidth, summary_row_labels)
            else
                0
            end,
        )
    end

    @views for j in last(axes(table_str))
        m = 0

        if !isnothing(column_labels)
            for i in first(axes(column_labels))
                !table_data.show_column_labels && break

                # If the user wants to crop the additional column labels, we must consider
                # only the first one here when computing the column width.
                (column_label_width_based_on_first_line_only && (i > 1)) && break

                # At first, we must neglect all the column label merged cells. Its width
                # will be taken into account at a later stage.
                _is_column_label_cell_merged(table_data, i, j) && continue

                m = max(m, printable_textwidth(column_labels[i, j]))
            end
        end

        if num_printed_data_rows > 0
            if !line_breaks
                m = max(maximum(printable_textwidth, table_str[:, j]), m)
            else
                for cell in table_str[:, j]
                    m = max(m, _maximum_textwidth_per_line(cell))
                end
            end
        end

        if _has_summary_rows(table_data)
            m = max(maximum(printable_textwidth, summary_rows[:, j]), m)
        end

        # When the table is vertically cropped, a continuation row showing `⋮` is printed in
        # every data column. Hence, the column must be wide enough to show it. Notice that
        # this only matters when nothing else contributed to the width, which happens when
        # the column labels are hidden and no data row is printed.
        _is_vertically_cropped(table_data) && (m = max(m, 1))

        mdw = minimum_data_column_widths[j - 1 + begin]

        if mdw > 0
            m = max(m, mdw)
        end

        printed_data_column_widths[j] = m
    end

    # Resize the columns based on the merged cells. Notice that we must skip this step if
    # the column labels are not rendered since we have no reference to compute the merged
    # cell width.
    if !isnothing(table_data.merge_column_label_cells) && !isnothing(column_labels)
        @views for mc in table_data.merge_column_label_cells
            mc.j > num_printed_data_columns && continue

            j₀ = mc.j
            j₁ = min(mc.j + mc.column_span - 1, num_printed_data_columns)

            total_width = 0

            for j in j₀:j₁
                total_width += printed_data_column_widths[j]

                if j != j₁
                    total_width += 2 + (j ∈ vertical_lines_at_data_columns)
                end
            end

            mctw = printable_textwidth(column_labels[mc.i, mc.j])

            if mctw > total_width
                Δ = div(mctw - total_width, j₁ - j₀ + 1, RoundUp)
                printed_data_column_widths[j₀:j₁] .+= Δ
            end
        end
    end

    return row_number_column_width, row_label_column_width, printed_data_column_widths
end

module PrettyTables

using Markdown
using Printf
using Reexport
using StringManipulation
using Tables

# We add REPL.jl as dependency only to decrease the enormous precompilation time observed
# after Julia 1.11. For more information, check:
#
#   https://github.com/JuliaLang/julia/issues/56080
#
using REPL

@reexport using Crayons

import Base: @kwdef, axes, getindex, show
import LaTeXStrings: LaTeXString

# The performance of PrettyTables.jl does not increase by a lot of optimizations that is
# performed by the compiler. Hence, we disable them to improve compile time.
if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@optlevel"))
    @eval Base.Experimental.@optlevel 1
end

############################################################################################
#                                          Types                                           #
############################################################################################

include("./types.jl")

############################################################################################
#                                         Includes                                         #
############################################################################################

include("./documentation.jl")
include("./main.jl")
include("./misc.jl")
include("./predefined_formatters.jl")
include("./private.jl")
include("./tables.jl")

include("./backends/latex/types.jl")
include("./backends/latex/documentation.jl")
include("./backends/latex/helpers.jl")
include("./backends/latex/latex_backend.jl")
include("./backends/latex/predefined_formats.jl")
include("./backends/latex/private.jl")
include("./backends/latex/render_cell.jl")

include("./backends/html/types.jl")
include("./backends/html/documentation.jl")
include("./backends/html/html_backend.jl")
include("./backends/html/private.jl")
include("./backends/html/render_cell.jl")

include("./backends/markdown/types.jl")
include("./backends/markdown/documentation.jl")
include("./backends/markdown/markdown_backend.jl")
include("./backends/markdown/private.jl")
include("./backends/markdown/render_cell.jl")

include("./backends/text/types.jl")
include("./backends/text/documentation.jl")
include("./backends/text/column_widths.jl")
include("./backends/text/display.jl")
include("./backends/text/helpers.jl")
include("./backends/text/predefined_formats.jl")
include("./backends/text/private.jl")
include("./backends/text/render_cell.jl")
include("./backends/text/render_table.jl")
include("./backends/text/text_backend.jl")

include("./backends/excel/types.jl")
include("./backends/excel/documentation.jl")
include("./backends/excel/helpers.jl")
include("./backends/excel/excel_backend.jl")

include("./backends/typst/types.jl")
include("./backends/typst/documentation.jl")
include("./backends/typst/helpers.jl")
include("./backends/typst/typst_backend.jl")
include("./backends/typst/private.jl")
include("./backends/typst/render_cell.jl")

include("./printing_state/alignment.jl")
include("./printing_state/data.jl")
include("./printing_state/information.jl")
include("./printing_state/iterator.jl")

############################################################################################
#                                      Precompilation                                      #
############################################################################################

include("./precompile.jl")

end # module

## Description #############################################################################
#
# Tests of Tables.jl API.
#
############################################################################################

@testset "Tables.jl Compatibility" begin
    # A NamedTuple is compliant with Tables.jl API.
    table = (x = Int64(1):Int64(3), y = 'a':'c', z = ["String 1"; "String 2"; "String 3"])

    # Thus, the following 5 calls must provide the same results.
    result_1 = pretty_table(String, table)
    result_2 = pretty_table(String, Tables.rowtable(table))
    result_3 = pretty_table(String, Tables.columntable(table))
    result_4 = pretty_table(String, Tables.columns(table))
    result_5 = pretty_table(String, Tables.rows(table))

    expected = """
┌───────┬──────┬──────────┐
│     x │    y │        z │
│ Int64 │ Char │   String │
├───────┼──────┼──────────┤
│     1 │    a │ String 1 │
│     2 │    b │ String 2 │
│     3 │    c │ String 3 │
└───────┴──────┴──────────┘
"""

    @test result_1 == result_2 == result_3 == result_4 == result_5 == expected

    # If the column labels is passed, it must replace the Tables.jl schema.
    result = pretty_table(
        String, table; column_labels = ["My col. 1", "My col. 2", "My col. 3"]
    )

    expected = """
┌───────────┬───────────┬───────────┐
│ My col. 1 │ My col. 2 │ My col. 3 │
├───────────┼───────────┼───────────┤
│         1 │         a │  String 1 │
│         2 │         b │  String 2 │
│         3 │         c │  String 3 │
└───────────┴───────────┴───────────┘
"""

    @test result == expected
end

@testset "RowTable acquisition state" begin
    mutable struct InstrumentedRowSource
        rows::Vector{NamedTuple{(:a, :b), Tuple{Int, Int}}}
        iterator_calls::Int
        subset_calls::Dict{Int, Int}
        subset_works::Bool
    end

    Tables.istable(::Type{InstrumentedRowSource}) = true
    Tables.rowaccess(::Type{InstrumentedRowSource}) = true
    Tables.rows(source::InstrumentedRowSource) = source
    Tables.schema(::InstrumentedRowSource) = Tables.Schema((:a, :b), (Int, Int))
    Base.length(source::InstrumentedRowSource) = length(source.rows)

    function Base.iterate(source::InstrumentedRowSource)
        isempty(source.rows) && return nothing
        source.iterator_calls += 1
        return source.rows[1], (:opaque_iterator_state, 2)
    end

    function Base.iterate(source::InstrumentedRowSource, state::Tuple{Symbol, Int})
        i = state[2]
        i > length(source.rows) && return nothing
        source.iterator_calls += 1
        return source.rows[i], (:opaque_iterator_state, i + 1)
    end

    function Tables.subset(source::InstrumentedRowSource, i::Int; viewhint = nothing)
        source.subset_calls[i] = get(source.subset_calls, i, 0) + 1
        source.subset_works || throw(ArgumentError("subset disabled"))
        return source.rows[i]
    end

    make_source(; subset_works = false) = InstrumentedRowSource(
        [(a = i, b = 10i) for i in 1:6], 0, Dict{Int, Int}(), subset_works
    )

    source = make_source()
    rtable = PrettyTables.RowTable(source)
    source.iterator_calls = 0
    @test [rtable[i, 1] for i in 1:6] == collect(1:6)
    @test source.iterator_calls == 6
    @test all(==(1), values(source.subset_calls))

    for i in (Int32(2), UInt(2))
        source = make_source()
        rtable = PrettyTables.RowTable(source)
        source.iterator_calls = 0
        @test (rtable[i, 1], rtable[i, 2]) == (2, 20)
        @test source.iterator_calls == 2
    end

    source = make_source()
    rtable = PrettyTables.RowTable(source)
    source.iterator_calls = 0
    @test (rtable[3, 1], rtable[3, 2]) == (3, 30)
    @test source.iterator_calls == 3
    @test get(source.subset_calls, 3, 0) == 1
    @test rtable[1, 1] == 1
    @test source.iterator_calls == 4
    @test rtable[2, 2] == 20
    @test source.iterator_calls == 5

    out_of_range_failed = try
        rtable[10, 1]
        false
    catch
        true
    end
    @test out_of_range_failed
    @test rtable[2, 1] == 2

    source = make_source(; subset_works = true)
    rtable = PrettyTables.RowTable(source)
    source.iterator_calls = 0
    @test [(rtable[i, 1], rtable[i, 2]) for i in 1:6] == [(i, 10i) for i in 1:6]
    @test source.iterator_calls == 0
    @test source.subset_calls == Dict(i => 1 for i in 1:6)
    @test PrettyTables._get_data(rtable) === source
end

@testset "Tables.jl without Schema" begin
    expected = """
┌───┬───────┬─────┬───┐
│ a │     b │   c │ d │
├───┼───────┼─────┼───┤
│ 1 │ false │ 1.0 │ 1 │
│ 2 │  true │ 2.0 │ 2 │
│ 3 │ false │ 3.0 │ 3 │
│ 4 │  true │ 4.0 │ 4 │
│ 5 │ false │ 5.0 │ 5 │
│ 6 │  true │ 6.0 │ 6 │
└───┴───────┴─────┴───┘
"""

    # == Column Table ======================================================================

    struct MyColumnTable{T <: AbstractMatrix}
        names::Vector{Symbol}
        lookup::Dict{Symbol, Int}
        matrix::T
    end

    Tables.istable(::Type{<:MyColumnTable}) = true
    names(m::MyColumnTable) = getfield(m, :names)
    mat(m::MyColumnTable) = getfield(m, :matrix)
    lookup(m::MyColumnTable) = getfield(m, :lookup)

    Tables.columnaccess(::Type{<:MyColumnTable}) = true
    Tables.columns(m::MyColumnTable) = m
    Tables.getcolumn(m::MyColumnTable, ::Type{T}, col::Int, nm::Symbol) where {T} =
        mat(m)[:, col]
    Tables.getcolumn(m::MyColumnTable, nm::Symbol) = mat(m)[:, lookup(m)[nm]]
    Tables.getcolumn(m::MyColumnTable, i::Int) = mat(m)[:, i]
    Tables.columnnames(m::MyColumnTable) = names(m)

    data = Any[
        1    false      1.0     0x01
        2     true      2.0     0x02
        3    false      3.0     0x03
        4     true      4.0     0x04
        5    false      5.0     0x05
        6     true      6.0     0x06
    ]

    table = MyColumnTable([:a, :b, :c, :d], Dict(:a => 1, :b => 2, :c => 3, :d => 4), data)

    result = pretty_table(String, table)

    @test Tables.schema(table) === nothing
    @test result == expected

    # == Row Table =========================================================================

    struct MyRowTable{T <: AbstractMatrix}
        names::Vector{Symbol}
        lookup::Dict{Symbol, Int}
        matrix::T
    end

    struct MyMatrixRow{T} <: Tables.AbstractRow
        row::Int
        source::MyRowTable{T}
    end

    Tables.istable(::Type{<:MyRowTable}) = true
    names(m::MyRowTable) = getfield(m, :names)
    mat(m::MyRowTable) = getfield(m, :matrix)
    lookup(m::MyRowTable) = getfield(m, :lookup)

    Tables.rowaccess(::Type{<:MyRowTable}) = true
    Tables.rows(m::MyRowTable) = m
    Base.eltype(m::MyRowTable{T}) where {T} = MyMatrixRow{T}
    Base.length(m::MyRowTable) = size(mat(m), 1)
    Base.iterate(m::MyRowTable, st = 1) =
        st > length(m) ? nothing : (MyMatrixRow(st, m), st + 1)

    Tables.getcolumn(m::MyMatrixRow, ::Type, col::Int, nm::Symbol) =
        getfield(getfield(m, :source), :matrix)[getfield(m, :row), col]

    Tables.getcolumn(m::MyMatrixRow, i::Int) =
        getfield(getfield(m, :source), :matrix)[getfield(m, :row), i]

    Tables.getcolumn(m::MyMatrixRow, nm::Symbol) = getfield(getfield(m, :source), :matrix)[
        getfield(m, :row), getfield(getfield(m, :source), :lookup)[nm]
    ]

    Tables.columnnames(m::MyMatrixRow) = names(getfield(m, :source))

    table = MyRowTable([:a, :b, :c, :d], Dict(:a => 1, :b => 2, :c => 3, :d => 4), data)

    # This test does not have a valid `Tables.subet` implementation.
    result = pretty_table(String, table)
    @test Tables.schema(table) === nothing
    @test result == expected

    # Now, let's define a Tables.subset.
    Tables.subset(m::MyMatrixRow, inds; viewhint = nothing) = data[inds]

    result = pretty_table(String, table)
    @test result == expected
end

@testset "Tables.jl with Custom Column Name Vector" begin
    struct TestVec{T} <: AbstractArray{T, 1}
        data::Array{T, 1}
    end

    struct MinimalTable
        data::Matrix
        colnames::TestVec
    end

    Base.IndexStyle(::Type{A}) where {A <: TestVec} = Base.IndexCartesian()
    Base.size(A::TestVec) = size(getfield(A, :data))
    Base.getindex(A::TestVec, index::Int) = getindex(getfield(A, :data), index)
    Base.collect(::Type{T}, itr::TestVec) where {T} =
        TestVec(collect(T, getfield(itr, :data)))

    Tables.istable(x::MinimalTable) = true
    Tables.columnaccess(::MinimalTable) = true
    Tables.columnnames(x::MinimalTable) = getfield(x, :colnames)
    Tables.columns(x::MinimalTable) = x
    Base.getindex(x::MinimalTable, i1, i2) = getindex(getfield(x, :data), i1, i2)
    Base.getproperty(x::MinimalTable, s::Symbol) =
        getindex(x, :, findfirst(==(s), Tables.columnnames(x)))
    Base.convert(::Type{<:TestVec}, x::Array) = TestVec(x)

    data     = [10.0^(i + j) for i in 1:10, j in 1:5]
    mintable = MinimalTable(data, [:C1, :C2, :C3, :C4, :C5])

    str_data = pretty_table(String, data; column_labels = ["C1", "C2", "C3", "C4", "C5"])

    str_mintable = pretty_table(String, mintable)

    @test str_data == str_mintable
end

@testset "Tables.jl with Undefined Elements" begin
    expected = """
┌────────┬────────┬────────┐
│      A │      B │      C │
├────────┼────────┼────────┤
│      1 │ #undef │ #undef │
│ #undef │      1 │ #undef │
│ #undef │ #undef │    1.0 │
└────────┴────────┴────────┘
"""

    # == Column Tables =====================================================================

    struct MinimalColumnTable{T}
        columns::Vector{Vector{T}}
        colnames::Vector{Symbol}
    end

    Tables.istable(x::MinimalColumnTable) = true
    Tables.columnaccess(::MinimalColumnTable) = true
    Tables.columnnames(m::MinimalColumnTable) = getfield(m, :colnames)
    Tables.columns(m::MinimalColumnTable) = m
    Tables.getcolumn(m::MinimalColumnTable, i::Int) = m.columns[i]
    Tables.getcolumn(m::MinimalColumnTable, nm::Symbol) =
        getindex(m.columns, findfirst(==(nm), m.colnames))

    table = MinimalColumnTable([Vector{Any}(undef, 3) for _ in 1:3], [:A, :B, :C])

    table.columns[1][1] = UInt64(1)
    table.columns[2][2] = Int64(1)
    table.columns[3][3] = 1.0

    result = pretty_table(String, table)
    @test result == expected

    # == Row Tables ========================================================================

    struct MinimalRow{T}
        data::Vector{T}
        colnames::Vector{Symbol}
    end

    struct MinimalRowTable{T}
        rows::Vector{MinimalRow{T}}

        function MinimalRowTable(
            data::Vector{Vector{T}}, colnames::Vector{Symbol}
        ) where {T}
            return new{T}([MinimalRow{T}(data[i], colnames) for i in 1:length(data)],)
        end
    end

    Tables.istable(x::MinimalRowTable) = true
    Tables.rowaccess(::MinimalRowTable) = true
    Tables.rows(m::MinimalRowTable) = m.rows

    Tables.columnnames(m::MinimalRow) = getfield(m, :colnames)
    Tables.getcolumn(m::MinimalRow, i::Int) = m.data[i]
    Tables.getcolumn(m::MinimalRow, nm::Symbol) =
        getindex(m.data, findfirst(==(nm), m.colnames))

    table = MinimalRowTable([Vector{Any}(undef, 3) for _ in 1:3], [:A, :B, :C])

    table.rows[1].data[1] = UInt64(1)
    table.rows[2].data[2] = Int64(1)
    table.rows[3].data[3] = 1.0

    # This test happens without `Tables.subset` application.
    result = pretty_table(String, table)
    @test result == expected

    # Define the `Tables.subset` API and test again.
    Tables.subset(m::MinimalRowTable, i::Int; viewhint = nothing) = m.rows[i]

    result = pretty_table(String, table)
    @test result == expected
end

@testset "Summary Rows Over Tables.jl Sources" verbose = true begin
    # `summary_rows` asks the wrapper for a whole column with `data[:, j]`. Since both
    # `ColumnTable` and `RowTable` used to forward that query straight to the user's object,
    # every Tables.jl input threw a `MethodError` before the summary could be computed.
    expected = """
┌──┬───────┬───────┐
│  │     a │     b │
│  │ Int64 │ Int64 │
├──┼───────┼───────┤
│  │     1 │     4 │
│  │     2 │     5 │
│  │     3 │     6 │
├──┼───────┼───────┤
│  │     6 │    15 │
└──┴───────┴───────┘
"""

    @testset "NamedTuple" begin
        result = pretty_table(
            String,
            (a = [1, 2, 3], b = [4, 5, 6]);
            summary_rows = [sum],
            summary_row_labels = [""],
            show_row_number_column = false,
        )

        @test result == expected
    end

    @testset "Column Access" begin
        result = pretty_table(
            String,
            Tables.columntable((a = [1, 2, 3], b = [4, 5, 6]));
            summary_rows = [sum],
            summary_row_labels = [""],
            show_row_number_column = false,
        )

        @test result == expected
    end

    @testset "Row Access" begin
        rows = [(a = 1, b = 4), (a = 2, b = 5), (a = 3, b = 6)]

        result = pretty_table(
            String,
            Tables.rowtable(rows);
            summary_rows = [sum],
            summary_row_labels = [""],
            show_row_number_column = false,
        )

        @test result == expected
    end
end

@testset "Tables.jl Wrapper Edge Cases" verbose = true begin
    @testset "Column Table With Tuple Columns" begin
        # `isassigned` short-circuits to `true` when the column is a `Tuple`, since a tuple
        # cannot hold an undefined element. Every existing column table test uses `Vector`
        # columns, so that branch was never taken.
        struct TupleColumnTable
            columns::NamedTuple
        end

        Tables.istable(::Type{TupleColumnTable}) = true
        Tables.columnaccess(::Type{TupleColumnTable}) = true
        Tables.columns(t::TupleColumnTable) = t
        Tables.columnnames(t::TupleColumnTable) = keys(getfield(t, :columns))
        Tables.getcolumn(t::TupleColumnTable, nm::Symbol) = getfield(t, :columns)[nm]
        Tables.getcolumn(t::TupleColumnTable, i::Int) = getfield(t, :columns)[i]
        Tables.rowcount(t::TupleColumnTable) = length(first(getfield(t, :columns)))

        expected = """
┌───┬───┐
│ a │ b │
├───┼───┤
│ 1 │ 4 │
│ 2 │ 5 │
│ 3 │ 6 │
└───┴───┘
"""

        table = TupleColumnTable((a = (1, 2, 3), b = (4, 5, 6)))

        @test pretty_table(String, table) == expected
    end

    @testset "Row Table Without Rows" verbose = true begin
        # `RowTable` obtains the column names from the first row. When the table has no rows
        # at all, it must fall back to the schema, and to an empty set of columns when there
        # is no schema either. Neither fallback was covered.

        @testset "With a Schema" begin
            struct EmptyRowsWithSchema end

            Tables.istable(::Type{EmptyRowsWithSchema}) = true
            Tables.rowaccess(::Type{EmptyRowsWithSchema}) = true
            Tables.rows(s::EmptyRowsWithSchema) = s
            Tables.schema(::EmptyRowsWithSchema) = Tables.Schema((:a, :b), (Int, Int))
            Base.length(::EmptyRowsWithSchema) = 0
            Base.iterate(::EmptyRowsWithSchema, state = 1) = nothing

            expected = """
┌───────┬───────┐
│     a │     b │
│ Int64 │ Int64 │
└───────┴───────┘
"""

            @test pretty_table(String, EmptyRowsWithSchema()) == expected
        end

        @testset "Without a Schema" begin
            struct EmptyRowsNoSchema end

            Tables.istable(::Type{EmptyRowsNoSchema}) = true
            Tables.rowaccess(::Type{EmptyRowsNoSchema}) = true
            Tables.rows(s::EmptyRowsNoSchema) = s
            Tables.schema(::EmptyRowsNoSchema) = nothing
            Base.length(::EmptyRowsNoSchema) = 0
            Base.iterate(::EmptyRowsNoSchema, state = 1) = nothing

            # Without rows and without a schema there is nothing to name, so the table has
            # no columns and prints nothing.
            @test pretty_table(String, EmptyRowsNoSchema()) == ""
        end
    end
end

## Description #############################################################################
#
# Helpers for designing tables in the LaTeX backend.
#
############################################################################################

export @latex__all_horizontal_lines, @latex__all_vertical_lines
export @latex__no_horizontal_lines, @latex__no_vertical_lines

"""
    @latex__all_horizontal_lines() -> Keywords for `LatexTableFormat`

Return the keyword arguments to be passed to [`LatexTableFormat`](@ref) to show all
horizontal lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a LaTeX table format with all horizontal lines:

```julia
tf = LatexTableFormat(; @latex__all_horizontal_lines())
```

Any option can be overridden by merging the keyword arguments. For example, the following
code shows all the horizontal lines but the first one:

```julia
tf = LatexTableFormat(; @latex__all_horizontal_lines, horizontal_line_at_beginning = false)
```

# Extended Help

## Example

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = LatexTableFormat(; @latex__all_horizontal_lines))
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}

julia> pretty_table(
           A;
           table_format = LatexTableFormat(;
               @latex__all_horizontal_lines,
               horizontal_line_after_column_labels = false
           )
       )
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  1.0 & 1.0 & 1.0 \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}
```
"""
macro latex__all_horizontal_lines()
    return :(
        (
            horizontal_line_at_beginning            = true,
            horizontal_line_at_merged_column_labels = true,
            horizontal_line_after_column_labels     = true,
            horizontal_lines_at_data_rows           = :all,
            horizontal_line_before_row_group_label  = true,
            horizontal_line_after_row_group_label   = true,
            horizontal_line_after_data_rows         = true,
            horizontal_line_before_summary_rows     = true,
            horizontal_line_after_summary_rows      = true,
        )...
    )
end

"""
    @latex__all_vertical_lines() -> Keywords for `LatexTableFormat`

Return the keyword arguments to be passed to [`LatexTableFormat`](@ref) to show all vertical
lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a LaTeX table format with all vertical lines:

```julia
tf = LatexTableFormat(; @latex__all_vertical_lines)
```

Any option can be overridden by merging the keyword arguments. For example, the following
code shows all the vertical lines but the first one:

```julia
tf = LatexTableFormat(; @latex__all_vertical_lines, vertical_line_at_beginning = false)
```

# Extended Help

## Examples

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = LatexTableFormat(; @latex__all_vertical_lines))
\\begin{tabular}{|r|r|r|}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}

julia> pretty_table(
           A;
           show_row_number_column = true,
           table_format = LatexTableFormat(;
               @latex__all_vertical_lines,
               vertical_line_after_row_number_column = false
           )
       )
\\begin{tabular}{|rr|r|r|}
  \\hline
  \\textbf{Row} & \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1 & 1.0 & 1.0 & 1.0 \\\\
  2 & 1.0 & 1.0 & 1.0 \\\\
  3 & 1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}
```
"""
macro latex__all_vertical_lines()
    return :(
        (
            vertical_line_after_continuation_column = true,
            vertical_lines_at_data_columns          = :all,
            vertical_line_after_data_columns        = true,
            vertical_line_after_row_label_column    = true,
            vertical_line_after_row_number_column   = true,
            vertical_line_at_beginning              = true,
        )...
    )
end

"""
    @latex__no_horizontal_lines() -> Keywords for `LatexTableFormat`

Return the keyword arguments to be passed to [`LatexTableFormat`](@ref) to suppress all
horizontal lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a LaTeX table format without horizontal lines:

```julia
tf = LatexTableFormat(; @latex__no_horizontal_lines)
```

Any option can be overridden by merging the keyword arguments. For example, the following
code draws only the horizontal line at the beginning of the table:

```julia
tf = LatexTableFormat(; @latex__no_horizontal_lines, horizontal_line_at_beginning = true)
```

# Extended Help

## Example

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = LatexTableFormat(; @latex__no_horizontal_lines))
\\begin{tabular}{|r|r|r|}
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
\\end{tabular}

julia> pretty_table(
           A;
           table_format = LatexTableFormat(;
               @latex__no_horizontal_lines,
               horizontal_line_after_column_labels = true
           )
       )
\\begin{tabular}{|r|r|r|}
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
\\end{tabular}
```
"""
macro latex__no_horizontal_lines()
    return :(
        (
            horizontal_line_at_beginning            = false,
            horizontal_line_at_merged_column_labels = false,
            horizontal_line_after_column_labels     = false,
            horizontal_lines_at_data_rows           = :none,
            horizontal_line_before_row_group_label  = false,
            horizontal_line_after_row_group_label   = false,
            horizontal_line_after_data_rows         = false,
            horizontal_line_before_summary_rows     = false,
            horizontal_line_after_summary_rows      = false,
        )...
    )
end

"""
    @latex__no_vertical_lines() -> Keywords for `LatexTableFormat`

Return the keyword arguments to be passed to [`LatexTableFormat`](@ref) to suppress all
vertical lines.

We can use the output of this function when creating the text table format object. For
example, the following code creates a LaTeX table format without vertical lines:

```julia
tf = LatexTableFormat(; @latex__no_vertical_lines)
```

Any option can be overridden by merging the keyword arguments. For example, the following
code draws only the vertical line at the beginning of the table:

```julia
tf = LatexTableFormat(; @latex__no_vertical_lines, vertical_line_at_beginning = true)
```

# Extended Help

## Examples

```julia-repl
julia> A = ones(3, 3);

julia> pretty_table(A; table_format = LatexTableFormat(; @latex__no_vertical_lines))
\\begin{tabular}{rrr}
  \\hline
  \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}

julia> pretty_table(
           A;
           show_row_number_column = true,
           table_format = LatexTableFormat(;
               @latex__no_vertical_lines,
               vertical_line_after_row_number_column = true
           )
       )
\\begin{tabular}{r|rrr}
  \\hline
  \\textbf{Row} & \\textbf{Col. 1} & \\textbf{Col. 2} & \\textbf{Col. 3} \\\\
  \\hline
  1 & 1.0 & 1.0 & 1.0 \\\\
  2 & 1.0 & 1.0 & 1.0 \\\\
  3 & 1.0 & 1.0 & 1.0 \\\\
  \\hline
\\end{tabular}
```
"""
macro latex__no_vertical_lines()
    return :(
        (
            vertical_line_after_continuation_column = false,
            vertical_lines_at_data_columns          = :none,
            vertical_line_after_data_columns        = false,
            vertical_line_after_row_label_column    = false,
            vertical_line_after_row_number_column   = false,
            vertical_line_at_beginning              = false,
        )...
    )
end

## Description #############################################################################
#
# Precompilation for the Excel back end.
#
# The Excel back end lives in this extension. Hence, it is not covered by the workload in
# `src/precompile.jl`, meaning that without this file the first Excel export would be fully
# cold.
#
############################################################################################

import PrecompileTools

PrecompileTools.@setup_workload begin
    matrix = ones(10, 10)

    # A named tuple is compliant with Tables.jl.
    table = (a = 1:1:10, b = ["S" for i in 1:10], c = ['C' for i in 1:10])

    PrecompileTools.@compile_workload begin
        # Passing `filename = nothing` keeps the workbook in memory, so the workload does not
        # touch the file system.
        pretty_table(matrix; backend = :excel, filename = nothing)

        pretty_table(
            matrix;
            backend = :excel,
            filename = nothing,
            highlighters = [
                ExcelHighlighter((data, i, j) -> i == 1, ["bold" => "true"]),
            ],
        )

        pretty_table(table; backend = :excel, filename = nothing)
    end
end

## Description #############################################################################
#
# HTML Back End: Tests related to table cropping.
#
############################################################################################

@testset "Table Cropping" verbose = true begin
    matrix = [(i, j) for i in 1:100, j in 1:100]

    @testset "Bottom Cropping" begin
        expected = """
<div>
  <div style = "float: right; font-style: italic;">
    <span>97 columns and 98 rows omitted</span>
  </div>
  <div style = "clear: both;"></div>
</div>
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th>&ctdot;</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td>&ctdot;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">(2, 1)</td>
      <td style = "text-align: right;">(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td>&ctdot;</td>
    </tr>
    <tr>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td>&dtdot;</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
        )

        @test result == expected
    end

    @testset "Middle Cropping" begin
        expected = """
<div>
  <div style = "float: right; font-style: italic;">
    <span>97 columns and 98 rows omitted</span>
  </div>
  <div style = "clear: both;"></div>
</div>
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th>&ctdot;</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td>&ctdot;</td>
    </tr>
    <tr>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td>&dtdot;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">(100, 1)</td>
      <td style = "text-align: right;">(100, 2)</td>
      <td style = "text-align: right;">(100, 3)</td>
      <td>&ctdot;</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
            vertical_crop_mode = :middle,
        )

        @test result == expected
    end

    @testset "Omitted Cell Summary" begin
        expected = """
<table>
  <thead>
    <tr class = "columnLabelRow">
      <th style = "font-weight: bold; text-align: right;">Col. 1</th>
      <th style = "font-weight: bold; text-align: right;">Col. 2</th>
      <th style = "font-weight: bold; text-align: right;">Col. 3</th>
      <th>&ctdot;</th>
    </tr>
  </thead>
  <tbody>
    <tr class = "dataRow">
      <td style = "text-align: right;">(1, 1)</td>
      <td style = "text-align: right;">(1, 2)</td>
      <td style = "text-align: right;">(1, 3)</td>
      <td>&ctdot;</td>
    </tr>
    <tr class = "dataRow">
      <td style = "text-align: right;">(2, 1)</td>
      <td style = "text-align: right;">(2, 2)</td>
      <td style = "text-align: right;">(2, 3)</td>
      <td>&ctdot;</td>
    </tr>
    <tr>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td style = "text-align: right;">&vellip;</td>
      <td>&dtdot;</td>
    </tr>
  </tbody>
</table>
"""

        result = pretty_table(
            String,
            matrix;
            backend = :html,
            maximum_number_of_rows = 2,
            maximum_number_of_columns = 3,
            show_omitted_cell_summary = false,
        )

        @test result == expected
    end
end

## Description #############################################################################
#
# Functions to compute the cell alignment of the current state.
#
############################################################################################

"""
    _current_cell_alignment(action::Symbol, state::PrintingTableState, table_data::TableData) -> Symbol

Return the alignment of the current cell specified by the `action` and the current printing
table `state` of `table_data`.
"""
function _current_cell_alignment(
    action::Symbol, state::PrintingTableState, table_data::TableData
)
    if (action == :title)
        return table_data.title_alignment

    elseif (action == :subtitle)
        return table_data.subtitle_alignment

    elseif (action == :row_number_label) || (action == :row_number)
        return table_data.row_number_column_alignment

    elseif action == :summary_row_number
        return table_data.row_number_column_alignment

    elseif (action == :stubhead_label) ||
        (action == :row_label) ||
        (action == :summary_row_label)
        return table_data.row_label_column_alignment

    elseif action == :column_label
        a = table_data.column_label_alignment
        if a isa Symbol
            return a
        else
            return a[state.j]
        end

    elseif action == :row_group_label
        return table_data.row_group_label_alignment

    elseif (action == :data) || (action == :summary_row_cell)
        # First, we check if we have a special cell alignment.
        if (action == :data) && !isnothing(table_data.cell_alignment)
            for f in table_data.cell_alignment
                fa = f(_get_data(table_data.data), state.i, state.j)::Union{Nothing, Symbol}
                !isnothing(fa) && return fa
            end
        end

        a = table_data.data_alignment
        if a isa Symbol
            return a
        else
            return a[state.j]
        end

    elseif action ∈ _VERTICAL_CONTINUATION_CELL_ACTIONS
        # Check if the continuation cell has a custom alignment. Otherwise, use the current
        # column alignment.
        #
        # NOTE: If we do not add `Symbol(...)` here, this function return type becomes
        # `Union{Nothing, Symbol}` instead of `Symbol`.
        !isnothing(table_data.continuation_row_alignment) &&
            return Symbol(table_data.continuation_row_alignment)

        new_action = if action == :row_number_vertical_continuation_cell
            :row_number
        elseif action == :row_label_vertical_continuation_cell
            :row_label
        else
            :data
        end

        return _current_cell_alignment(new_action, state, table_data)

    elseif action == :footnote
        return table_data.footnote_alignment

    elseif action == :source_notes
        return table_data.source_note_alignment

    elseif action == :empty_cell
        return :r

    else
        throw(ArgumentError("Invalid action found: `$action`!"))
    end
end

"""
    _data_column_alignment(table_data::TableData, i::Int) -> Symbol

Return the alignment of the `i`th column.
"""
function _data_column_alignment(table_data::TableData, i::Int)
    a = table_data.data_alignment
    return a isa Symbol ? a : a[i]
end

"""
    _row_number_column_alignment(table_data::TableData) -> Symbol

Return the row number column alignment.
"""
function _row_number_column_alignment(table_data::TableData)
    return table_data.row_number_column_alignment
end

"""
    _row_label_column_alignment(table_data::TableData) -> Symbol

Return the row label column alignment.
"""
function _row_label_column_alignment(table_data::TableData)
    return table_data.row_label_column_alignment
end

## Description #############################################################################
#
# Functions to render the table cells in the HTML back end.
#
############################################################################################

# NOTE: The functions to render the cell must receive the current `IOContext` because we
# need to check for circular dependency. We store the information about the objects being
# printed inside the key `__PRETTY_TABLES__DATA__` in the IO context. Hence, we must pass it
# forward when rendering the cells.

"""
    _html__cell_to_str(cell::Any, context::IOContext, renderer::Union{Val{:print}, Val{:show}}) -> String

Convert the `cell` to a string using a specific `context` and `renderer`.
"""
function _html__cell_to_str(cell::Any, context::IOContext, ::Val{:print})
    return _sprint_with_context(print, context, cell)
end

function _html__cell_to_str(cell::Any, context::IOContext, ::Val{:show})
    if showable(MIME("text/html"), cell)
        cell_str = _sprint_with_context(show, context, MIME("text/html"), cell)
    else
        cell_str = _sprint_with_context(show, context, cell)
    end

    return cell_str
end

function _html__cell_to_str(cell::AbstractString, context::IOContext, ::Val{:show})
    if showable(MIME("text/html"), cell)
        # This code handles, for example, StyledStrings.jl objects.
        cell_str = _sprint_with_context(show, context, MIME("text/html"), cell)
    else
        cell_str = string(cell)
    end

    return cell_str
end

_html__cell_to_str(cell::HTML, context::IOContext, ::Val{:print}) = cell.content
_html__cell_to_str(cell::HTML, context::IOContext, ::Val{:show}) = cell.content

_html__cell_to_str(cell::UndefinedCell, context::IOContext, ::Val{:print}) = "#undef"
_html__cell_to_str(cell::UndefinedCell, context::IOContext, ::Val{:show}) = "#undef"

"""
    _html__render_cell(cell::Any, context::IOContext, renderer::Union{Val{:print}, Val{:show}}; kwargs...) -> String

Render the `cell` in HTML back end using a specific `context` and `renderer`.

# Keywords

- `allow_html_in_cells::Bool`: If `true`, we will not escape HTML sequences in the rendered
    string.
    (**Default**: `false`)
- `line_breaks::Bool`: If `true`, we will replace `\\n` with `<br>`.
    (**Default**: `false`)
"""
function _html__render_cell(
    cell::Any,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    allow_html_in_cells::Bool = false,
    line_breaks::Bool = false,
)
    cell_str = _html__cell_to_str(cell, context, renderer)

    # Check if we need to replace `\n` with `<br>`.
    replace_newline = line_breaks

    # If the user wants HTML code inside cell, we must not escape the HTML characters.
    return _html__escape_str(cell_str, replace_newline, !allow_html_in_cells)
end

function _html__render_cell(
    cell::AbstractString,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    allow_html_in_cells::Bool = false,
    line_breaks::Bool = false,
)
    cell_str = _html__cell_to_str(cell, context, renderer)

    # Check if we need to replace `\n` with `<br>`.
    replace_newline = line_breaks

    # If the string is showable as HTML, we assume it contains HTML code and we do not
    # escape it.
    if showable(MIME("text/html"), cell)
        allow_html_in_cells = true
    end

    # If the user wants HTML code inside cell, we must not escape the HTML characters.
    return _html__escape_str(cell_str, replace_newline, !allow_html_in_cells)
end

function _html__render_cell(
    cell::HTML,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    allow_html_in_cells::Bool = false,
    line_breaks::Bool = false,
)
    return _html__cell_to_str(cell, context, renderer)
end

# For Markdown cells, we must render always using `show` to obtain the correct decoration.
function _html__render_cell(
    cell::Markdown.MD,
    context::IOContext,
    renderer::Union{Val{:print}, Val{:show}};
    allow_html_in_cells::Bool = false,
    line_breaks::Bool = false,
)
    return replace(sprint(show, MIME("text/html"), cell), "\n" => "")
end

## Description #############################################################################
#
# Excel backend for PrettyTables.jl
#
############################################################################################

"""
    _excel__print(pspec::PrintingSpec; kwargs...) -> Union{Nothing, String, XLSX.XLSXFile}

Write the table described by `pspec` to an Excel workbook. All other keyword arguments are
passed through to `_excel__write_table!`.

# Keywords

- `filename::Union{Nothing, String}`: Path of the Excel file to write. When `nothing`, no
    file is created and an in-memory `XLSX.XLSXFile` is returned instead. When a string,
    behaviour depends on `mode`.
    (**Default**: `nothing`)
- `sheet::Union{String, XLSX.Worksheet}`: When a `String`, the name of the worksheet tab.
    If no sheet with that name exists it will be created. When an `XLSX.Worksheet`, that
    worksheet is updated in place and `nothing` is returned.
    (**Default**: `"prettytable"`)
- `mode::String`: `"w"` to create a new file or `"rw"` (or its alias `"wr"`) to open and
    update an existing one.
    (**Default**: `"w"`)
- `overwrite::Bool`: Allow overwriting an existing file when `mode = "w"`.
    (**Default**: `false`)
- `anchor_cell::String`: Top-left cell of the table in A1 notation, allowing placement
    anywhere on the sheet.
    (**Default**: `"A1"`)

# Returns

- `nothing` when `sheet` is an `XLSX.Worksheet` (the worksheet is updated in place).
- `XLSX.XLSXFile` when `filename` is `nothing` and `sheet` is a `String`.
- `String` (the filename) when `filename` is a `String` and `mode = "w"`.
- `XLSX.XLSXFile` when `filename` is a `String` and `mode = "rw"`.

!!! note

    Save a returned `XLSX.XLSXFile` using `XLSX.writexlsx` or `XLSX.savexlsx`.
"""
function _excel__print(args...; kwargs...)
    error("""
          Excel backend requires the XLSX.jl package.

          Please install and load it with:

              using Pkg
              Pkg.add("XLSX")
              using XLSX

          Then retry your pretty_table call with backend = :excel.
          """)

    return nothing
end

# HTML Backend

The HTML backend can be selected by passing the keyword `backend = :html` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output.

## Keywords

- `allow_html_in_cells::Bool`: If `true`, the content of the cells can contain HTML code.
  This can be useful to render tables with more complex content, but it can also be a
  security risk if the content is not sanitized.
  (**Default**: `false`)
- `column_label_titles::Union{Nothing, AbstractVector}`: Titles for the column labels. If
  `nothing`, no titles are added. If a vector is passed, it must have the same length as the
  number of column label rows. Each element in the vector can be `nothing` (no title for
  that row) or an element with the title for that row. Notice that this element will be
  converted to string using the function `string`.
  (**Default**: `nothing`)
- `highlighters::Vector{HtmlHighlighter}`: Highlighters to apply to the table. For more
  information, see the section [HTML Highlighters](@ref).
- `line_breaks::Bool`: If `true`, line breaks in the content of the cells (`\\n`) are
  replaced by the HTML tag `<br>`.
  (**Default**: `false`)
- `maximum_column_width::String`: CSS width string for the maximum column width.
  (**Default**: "")
- `minify::Bool`: If `true`, the output HTML code is minified.
  (**Default**: `false`)
- `stand_alone::Bool`: If `true`, the output HTML code is a complete HTML document.
  (**Default**: `false`)
- `style::HtmlTableStyle`: Style of the table. For more information, see the section
  [HTML Table Style](@ref).
- `table_class::String`: Class for the table.
  (**Default**: "")
- `table_div_class::String`: Class for the div containing the table. It is only used if
  `wrap_table_in_div` is `true`.
  (**Default**: "")
- `table_format::HtmlTableFormat`: HTML table format used to render the table. For more
  information, see the section [HTML Table Format](@ref).
- `top_left_string::String`: String to put in the top left corner div.
  (**Default**: "")
- `top_right_string::String`: String to put in the top right corner div. Notice that this
  information is replaced if we are printing the omitted cell summary.
  (**Default**: "")
- `wrap_table_in_div::Bool`: If `true`, the table is wrapped in a div.
  (**Default**: `false`)

## HTML Highlighters

A set of highlighters can be passed as a `Vector{HtmlHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`HtmlHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)` in which should return `true`
  if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
  highlighter. This function must return a `Vector{Pair{String, String}}` with properties
  compatible with the `style` field that will be applied to the highlighted cell.

A HTML highlighter can be constructed using three helpers:

```julia
HtmlHighlighter(f::Function, decoration::Vector{Pair{String, String}})

HtmlHighlighter(f::Function, decorations::NTuple{N, Pair{String, String})

HtmlHighlighter(f::Function, fd::Function)
```

The first will apply a fixed decoration to the highlighted cell specified in `decoration`,
whereas the second lets the user select the desired decoration by specifying the function
`fd`.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells with values greater than 5 in red, and all
the cells with values less than 5 in blue, we can define:

```julia
hl_gt5 = HtmlHighlighter(
    (data, i, j) -> data[i, j] > 5,
    ["color" => "red"]
)

hl_lt5 = HtmlHighlighter(
    (data, i, j) -> data[i, j] < 5,
    ["color" => "blue"]
)

highlighters = [hl_gt5, hl_lt5]
```

## HTML Table Format

The HTML table format is defined using an object of type [`HtmlTableFormat`](@ref) that
contains the following fields:

- `css::String`: CSS to be injected at the end of the `<style>` section.
- `table_width::String`: Table width.

Notice that this format is only applied if `stand_alone = true`.

## HTML Table Style

The HTML table style is defined using an object of type [`HtmlTableStyle`](@ref) that
contains the following fields:

- `top_left_string::Vector{HtmlPair}`: Style for the top left string.
- `top_right_string::Vector{HtmlPair}`: Style for the top right string.
- `table::Vector{HtmlPair}`: Style for the table.
- `title::Vector{HtmlPair}`: Style for the title.
- `subtitle::Vector{HtmlPair}`: Style for the subtitle.
- `row_number_label::Vector{HtmlPair}`: Style for the row number label.
- `row_number::Vector{HtmlPair}`: Style for the row number.
- `stubhead_label::Vector{HtmlPair}`: Style for the stubhead label.
- `row_label::Vector{HtmlPair}`: Style for the row label.
- `row_group_label::Vector{HtmlPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}}`: Style for
  the first line of the column labels. If a vector of `Vector{HtmlPair}}` is provided, each
  column label in the first line will use the corresponding style.
- `column_label::Union{Vector{HtmlPair}, Vector{Vector{HtmlPair}}}`: Style for the rest of
  the column labels. If a vector of `Vector{HtmlPair}}` is provided, each column label will
  use the corresponding style.
- `first_line_merged_column_label::Vector{HtmlPair}`: Style for the merged cells at the
  first column label line.
- `merged_column_label::Vector{HtmlPair}`: Style for the merged cells at the rest of the
  column labels.
- `summary_row_cell::Vector{HtmlPair}`: Style for the summary row cell.
- `summary_row_label::Vector{HtmlPair}`: Style for the summary row label.
- `footnote::Vector{HtmlPair}`: Style for the footnote.
- `source_notes::Vector{HtmlPair}`: Style for the source notes.
- `first_line_of_column_labels::Vector{HtmlPair}`: Style for the first line of the column
  labels.

Each field is a vector of [`HtmlPair`](@ref), *i.e.* `Pair{String, String}`, describing
properties and values compatible with the HTML style attribute.

For example, if we want the stubhead label to be bold and red, we must define:
```julia
style = HtmlTableStyle(
    stubhead_label = ["font-weight" => "bold", "color" => "red"]
)
```

# Excel Backend Examples

Here we show some examples produced by the Excel backend.

## Excel Formatter

Native Excel formatting can straightforwardly be used to format the display format of table
data without affecting the underlying values.

```julia
data = [10.0^(-i + j) for i in 1:6, j in 1:6];

f1 = ExcelFormatter((data, i, j) -> j==1, ["format" => "#,##0.0????_0"]);
f2 = ExcelFormatter((data, i, j) -> j==2, ["format" => "#,##0.0???_0"]);
f3 = ExcelFormatter((data, i, j) -> j==3, ["format" => "#,##0.0??_0"]);
f4 = ExcelFormatter((data, i, j) -> j==4, ["format" => "#,##0.0?_0"]);
f5 = ExcelFormatter((data, i, j) -> j==5, ["format" => "#,##0.0_0"]);
f6 = ExcelFormatter((data, i, j) -> j==6, ["format" => "#,##0_0"]);

f = pretty_table(
    data;
    anchor_cell = "B2",
    backend = :excel,
    data_column_widths = 10.5,
    excel_formatters = [f1, f2, f3, f4, f5, f6],
)

writexlsx("output.xlsx", f; overwrite = true);
```

![image|320x500](../excel/excel_images/excel_example_formatter_01.png)

```julia
data = [f(a) for a = 0:30:90, f in (sind, cosd, tand)];

f = pretty_table(
    data;
    anchor_cell = "B2",
    backend = :excel,
    excel_formatters = [ExcelFormatter((v, i, j) -> true, ["format" => "0.000_);;@_)"])],
)

writexlsx("output.xlsx", f; overwrite = true);
```

![image|320x500](../excel/excel_images/excel_example_formatter_02.png)

The calculated values of the trigonometric functions are written natively to Excel at full
precision but the `ExcelFormatter` sets the Excel display format to only show three decimal
places in the table.

When an Excel formatter is used, the printed width of cell data is determined by Excel based
on the format specified. It cannot be known by PrettyTables.jl. For this reason, most cell
data values are not considered by the automatic determination of column widths, which
therefore relies on the column headers only. However, if cells contain text (or are
otherwise represnted as `Strings`), these are included in column width determination (text
is less likely to be significantly impacted by Excel formatting - although this is not
impossible).

If automatic determination of column widths is unsatisfactory, consider setting minimum
and/or maximum width limits or fixing column widths entirely.

To illustrate the extent to which formatting affects width even of the same data, consider:

```julia
dt = Dates.DateTime("1986-06-19T18:35:00");

matrix = [
    dt dt dt dt
    dt dt dt dt
];

f = pretty_table(
    XLSX.XLSXFile,
    matrix;
    anchor_cell = "B2",
    data_column_widths = [12.0, 16.0, 8.0, 20.0],
    excel_formatters = [
        ExcelFormatter((v, i, j) -> (j == 1), ["format" => "ShortDate"])
        ExcelFormatter((v, i, j) -> (j == 2), ["format" => "d mmmm yyyy"])
        ExcelFormatter((v, i, j) -> (j == 3), ["format" => "hh:mm"])
        ExcelFormatter((v, i, j) -> (j == 4), ["format" => "yyyy-mm-dd\"T\"hh:mm:ss"])
    ],
)

XLSX.writexlsx("output.xlsx", f; overwrite = true);
```

![image|320x500](../excel/excel_images/excel_example_datetime.png)

## Predefined Formatters

Predefined formatters are intended for text output. They can be used straightforwardly with
the `:excel` backend but convert cell data to formatted strings rather than passing the
native values.

For example, using the same trigonometry data table as above:

```julia
data = [f(a) for a = 0:30:90, f in (sind, cosd, tand)];

f = pretty_table(
    data;
    anchor_cell = "B2",
    backend = :excel,
    formatters = [fmt__printf("%5.3f")],
    filename = "output.xlsx",
    overwrite = true
)
```

![image|320x500](../excel/excel_images/excel_example_predefined_formatters.png)

Excel generates a warning that numbers are represented as text. Clicking in such a cell and
hitting enter causes Excel to convert the string to a number again, but the formatting is
lost (eg, `1.000` => `1`). Moreover, by converting to a string, the precision has been
truncated to the length of the string. While not important for presentation purposes, if the
table is used in Excel as input for further calculation, some information will have been
lost.

Numbers passed via a predefined formatter are converted to a string representation and so
will always be included in the column width determination.

An Excel formatter and a predefined formatter can readily be applied to the same cell, if
useful. For example, the addition of

```julia
excel_formatters = [ExcelFormatter((v, i, j) -> true, ["format" => "@_0"])],
```

in the above `pretty_table` specification would provide a right cell margin the width of one
'`0`' character to the data in each cell, similar to the one included in the first example.

## Excel Highlighters

```julia
t = 0:1:20;

data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

column_labels = [
    ["Time", "Acceleration", "Velocity", "Distance"],
    [ "[s]",     "[m / s²]",  "[m / s]",      "[m]"]
];

hl_p = ExcelHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    ["color" => "navy", "bold" => "true"]
);

hl_v = ExcelHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    ["color" => "maroon", "bold" => "true"]
);

 hl_10 = ExcelHighlighter(
     (data, i, j) -> (i == 10),
     [
         "color" => "white",
         "bold" => "true",
         "cell_fill_fgColor" => "darkgray",
         "cell_fill_pattern" => "solid",
     ]
 );

style = ExcelTableStyle(first_line_column_label = ["color" => "orange", "bold" => "true"]);

f = pretty_table(
    data;
    anchor_cell = "B2",
    backend = :excel,
    column_labels = column_labels,
    excel_formatters = [ExcelFormatter((v, i, j) -> true, ["format" => "#,##0.0"])],
    highlighters = [hl_10, hl_p, hl_v],
    style = style,
)

XLSX.writexlsx("output.xlsx", f; overwrite=true);
```

![image|320x500](../excel/excel_images/excel_example_highlighter.png)

## Excel Table Style

```julia
data = [
    10.0 6.5
     3.0 3.0
     0.1 1.0
];

row_labels = [
   "Atmospheric drag"
   "Gravity gradient"
   "Solar radiation pressure"
]
column_labels = [
    [MultiColumn(2, "Value", :c)],
    [
        "Torque [10⁻⁶ Nm]",
        "Angular Momentum [10⁻³ Nms]"
    ]
]

pretty_table(
    data;
    anchor_cell = "B2",
    backend = :excel,
    column_labels,
    excel_formatters = [ExcelFormatter((v, i, j) -> true, ["format" => "Number"])],
    filename = "output.xlsx",
    merge_column_label_cells = :auto,
    overwrite = true,
    row_labels,
    stubhead_label = "Effect",
    style = ExcelTableStyle(;
        first_line_merged_column_label = ["color" => "navy", "bold" => "true"],
        column_label                   = ["color" => "grey"],
        stubhead_label                 = ["color" => "navy", "bold" => "true"],
        summary_row_label              = ["color" => "orange", "bold" => "true"]
    ),
    summary_row_labels = ["Total"],
    summary_rows = [(data, i) -> sum(data[:, i])],
)
```

![image|320x500](../excel/excel_images/excel_example_table_style.png)

## Excel borders and fill

```julia
matrix = [
    "Data" "Data" "Data"
    "Data" "Data" "Data"
    "Data" "Data" "Data"
    "Data" "Data" "Data"
    "Data" "Data" "Data"
    "Data" "Data" "Data"
]

f = pretty_table(
    XLSX.XLSXFile,
    matrix;
    anchor_cell = "B2",
    alignment = :c,
    column_labels = [
        ["Column Label", "Column Label", "Column Label"],
        ["Column Label", MultiColumn(2, "Merged Column Label")],
        [MultiColumn(2, "Merged Column Label"), "Column Label"],
    ],
    footnotes = [(:title, 1, 1) => "Footnotes"],
    merge_column_label_cells = :auto,
    row_group_labels = [3 => "Row Group Label", 5 => "Row Group Label"],
    row_label_column_alignment = :c,
    row_labels = fill("Row Label", 6),
    row_number_column_alignment = :c,
    row_number_column_label = "Row Number",
    show_row_number_column = true,
    source_notes = "Source Notes",
    style = ExcelTableStyle(;
        title = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "black"
        ],
        subtitle = [
          "color" => "white",
          "italic" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "grey50"
        ],
        row_number_label = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "seagreen"
        ],
        row_number = [
          "color" => "white",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "steelblue4"
        ],
        stubhead_label = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "seagreen"
        ],
        row_label = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "steelblue4"
        ],
        first_line_column_label = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "seagreen"
        ],
        column_label = [
          "color" => "white",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "seagreen"
        ],
        first_line_merged_column_label = [
          "color" => "white",
          "bold" => "true"
        ],
        merged_column_label = [
          "color" => "white",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "seagreen"
        ],
        row_group_label = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "goldenrod1"
        ],
        data_cell = [
          "color" => "white",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "steelblue4"
        ],
        summary_row_label = [
          "color" => "white",
          "bold" => "true",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "violetred3"
        ],
        summary_row_cell = [
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "violetred3",
          "color" => "white"
        ],
        footnote = [
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "grey80"
        ],
        source_note = [
          "color" => "black",
          "cell_fill_pattern" => "solid",
          "cell_fill_fgColor" => "grey80"
        ],
    ),
    stubhead_label  = "Stubhead Label",
    subtitle = "Subtitle",
    summary_row_labels = ["Row Summary Label", "Row Summary Label"],
    summary_rows = [(data, i) -> "Summary Cell", (data, i) -> "Summary Cell"],
    table_format = ExcelTableFormat(;
        @excel__all_horizontal_lines,
        @excel__all_vertical_lines,
        horizontal_line_at_beginning     = false,
        vertical_line_at_beginning       = false,
        vertical_line_after_data_columns = false,
        borders = ExcelTableBorders(
            header_line             = ["style" => "thick", "color" => "white"],
            merged_header_cell_line = ["style" => "thin",  "color" => "white"],
            middle_line             = ["style" => "thin",  "color" => "white"],
            bottom_line             = ["style" => "thick", "color" => "white"],
            center_line             = ["style" => "thin",  "color" => "white"],
        ),
    ),
    title = "Title",
)

XLSX.writexlsx("output.xlsx", f; overwrite = true)
```

![image|320x500](../excel/excel_images/excel_example_table_fill.png)


## Putting it all together

```julia
# == Creating the Table ====================================================================

v1_t = 0:5:20;

v1_a = ones(length(v1_t)) * 1.0;

v1_v = @. 0 + v1_a * v1_t;

v1_d = @. 0 + v1_a * v1_t^2 / 2;

v2_t = 0:5:20;

v2_a = ones(length(v2_t)) * 0.75;

v2_v = @. 0 + v2_a * v2_t;

v2_d = @. 0 + v2_a * v2_t^2 / 2;

table = [
  v1_t v1_a v1_v v1_d
  v2_t v2_a v2_v v2_d
];

# == Configuring the Table =================================================================

title = "Table 1. Data obtained from the test procedure.";

subtitle = "Comparison between two vehicles";

column_labels = [
    [EmptyCells(2), MultiColumn(2, "Estimated Data")],
    ["Time (s)", "Acceleration", "Velocity", "Position"],
];

units = [
  styled"{(foreground=gray):[s]}",
  styled"{(foreground=gray):[m / s²]}",
  styled"{(foreground=gray):[m / s]}",
  styled"{(foreground=gray):[m]}",
];

push!(column_labels, units);

merge_column_label_cells = :auto;

column_label_alignment = :c;

show_row_number_column = true;
row_number_column_label = "Row Number";

stubhead_label="Stubhead Label";

row_labels = [
    "Multi-line\nrow label a",
    "Row b",
    "Row c",
    "Row d",
    "Row e",
    "Row f",
    "Row g",
    "Row h",
    "Row i",
    "Row j"
]

row_group_labels = [
    1 => "Vehicle #1\nand some continuation",
    6 => "Vehicle #2"
]

cell_alignment = [(data, i, j) -> :r]

summary_rows = [
    (data, j) -> maximum(@views data[ 1:5, j]),
    (data, j) -> maximum(@views data[6:10, j]),
]

summary_row_labels = [
    "Max. for very long Vehicle #1",
    "Max. for Vehicle #2",
]

footnotes = [
    (:subtitle, 1, 1) => "Vehicle 1: Ford Escort, Vehicle 2: VW Golf"
    (:column_label, 1, 3) => "Estimated data based on the acceleration measurement."
]

source_notes = "Source: Test procedure conducted on 2024-01-15.\nNote: Data is for demonstration purposes only."

excel_formatters = [
    ExcelFormatter((v, i, j) -> (j==1), ["format" => "#,##0_0_0"])
    ExcelFormatter((v, i, j) -> (j==2), ["format" => "#,##0.??_0_0"])
    ExcelFormatter((v, i, j) -> (j==3), ["format" => "#,##0.???"])
    ExcelFormatter((v, i, j) -> (j==4), ["format" => "0_0_0_0"])
]

highlighters = [
    ExcelHighlighter(
        (data, i, j) -> (j == 3) && (data[i, j] > 10),
        [
            "color" => "maroon",
            "bold" => "true",
            "cell_fill_pattern" => "solid",
            "cell_fill_fgColor" => "grey90"
        ],
    ),
    ExcelHighlighter(
        (data, i, j) -> (data[i, j] ≈ 0.0),
        ["color" => "green", "bold" => "true"],
    ),
    ExcelHighlighter(
        (data, i, j) -> (j == 4) && (data[i, j] > 10),
        [ "color" => "navy", "bold" => "true"]
    )
]

table_format = ExcelTableFormat(
    borders = ExcelTableBorders(
        top_line    = ["style" => "thick"],
        bottom_line = ["style" => "thick"],
        left_line   = ["style" => "thick"],
        right_line  = ["style" => "thick"],
    ),
)

style = ExcelTableStyle(
    column_label                   = ["bold" => "true"],
    summary_row_label              = ["size" => "8"],
    first_line_merged_column_label = ["bold" => "true", "color" => "orange"],
    footnote                       = ["italic" => "true", "color" => "gray"],
    row_group_label                = ["bold" => "true", "color" => "purple"],
    subtitle                       = ["italic" => "true"],
    title                          = ["bold" => "true", "color" => "navy", "size" => "18"],
)

# == Printing the Table ====================================================================

pretty_table(
    table;
    anchor_cell = "B2",
    backend = :excel,
    cell_alignment,
    column_label_alignment,
    column_labels,
    excel_formatters,
    filename = "output.xlsx",
    footnotes,
    highlighters,
    merge_column_label_cells,
    overwrite = true,
    row_group_labels,
    row_labels,
    row_number_column_label,
    show_row_number_column,
    source_notes,
    stubhead_label,
    style,
    subtitle,
    summary_row_labels,
    summary_rows,
    table_format,
    title,
)
```

![image|320x500](../excel/excel_images/excel_example_all_together.png)

# LaTeX Backend Examples

```@meta
CurrentModule = PrettyTables
```

```@setup latex_examples
using PrettyTables

function create_latex_example(table, filename)
    mkdir("tmp")
    cd("tmp")

    write(
      "table.tex",
      """
      \\documentclass[a4paper, 12pt]{article}
      \\pagestyle{empty}
      \\usepackage{color}
      \\usepackage{booktabs}
      \\usepackage{xcolor}
      \\begin{document}
      $table
      \\end{document}
      """
    )

    run(`lualatex table.tex`)
    run(`lualatex table.tex`)
    run(`convert -density 600 table.pdf -flatten -trim $filename`)
    run(`mv $filename ..`)
    cd("..")
    rm("tmp"; recursive = true)
end
```

Here, we can see some examples of LaTeX tables generated by PrettyTables.jl. Notice that the
output has been rendered to PDF using LuaTeX and converted to PNG using ImageMagick.

---

```julia-repl
julia> data = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]

julia> pretty_table(data; backend = :latex)
```

```@setup latex_examples
data = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]

table = pretty_table(
    String,
    data,
    backend = :latex
)

create_latex_example(table, "latex_example_01.png")
```

```@raw html
<img src="../latex_example_01.png" alt="LaTeX Example 01" width="60%">
```

---

This example uses the predefined format for the LaTeX backend
`latex_table_format__booktabs`.

```julia-repl
julia> data = [
    10.0 6.5
     3.0 3.0
     0.1 1.0
]

julia> row_labels = [
    "Atmospheric drag"
    "Gravity gradient"
    "Solar radiation pressure"
]

julia> column_labels = [
    [MultiColumn(2, "Value", :c)],
    [
        latex_cell"\textbf{Torque} [10$^{-5}$ Nm]",
        latex_cell"\textbf{Angular Momentum} [10$^{-3}$ Nms]"
    ]
],

julia> pretty_table(
    data;
    backend = :latex,
    column_labels,
    merge_column_label_cells = :auto,
    row_labels,
    stubhead_label = "Effect",
    style = LatexTableStyle(column_label = String[]),
    summary_row_labels = ["Total"],
    summary_rows = [(data, i) -> sum(data[:, i])],
    table_format = latex_table_format__booktabs
)
```

```@setup latex_examples
data = [
    10.0 6.5
     3.0 3.0
     0.1 1.0
]

row_labels = [
    "Atmospheric drag"
    "Gravity gradient"
    "Solar radiation pressure"
]

column_labels = [
    [MultiColumn(2, "Value", :c)],
    [
        latex_cell"\textbf{Torque} [10$^{-5}$ Nm]",
        latex_cell"\textbf{Angular Momentum} [10$^{-3}$ Nms]"
    ]
]

table = pretty_table(
    String,
    data;
    backend                  = :latex,
    column_labels,
    merge_column_label_cells = :auto,
    row_labels,
    stubhead_label           = "Effect",
    style                    = LatexTableStyle(column_label = String[]),
    summary_row_labels       = ["Total"],
    summary_rows             = [(data, i) -> sum(data[:, i])],
    table_format             = latex_table_format__booktabs
)

create_latex_example(table, "latex_example_02.png")
```

![LaTeX Example 02](./latex_example_02.png)

---

```julia-repl
julia> t = 0:1:20

julia> data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

julia> column_labels = [
    [            "Time",           "Acceleration", "Velocity", "Distance"],
    [ latex_cell"{[s]}",  latex_cell"[m / s$^2$]",  "[m / s]",      "[m]"]
]

julia> hl_p = LatexHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    ["textcolor{blue!60}"]
)

julia> hl_v = LatexHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    ["textcolor{red!60}"]
)

julia> pretty_table(
    data;
    backend       = :latex,
    column_labels = column_labels,
    highlighters  = [hl_p, hl_v],
    style         = LatexTableStyle(column_label = String[]),
    table_format  = latex_table_format__booktabs
)
```

```@setup latex_examples
t = 0:1:20

data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

column_labels = [
    [            "Time",           "Acceleration", "Velocity", "Distance"],
    [ latex_cell"{[s]}",  latex_cell"[m / s$^2$]",  "[m / s]",      "[m]"]
]

hl_p = LatexHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    ["textcolor{blue!60}"]
);

hl_v = LatexHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    ["textcolor{red!60}"]
);

table = pretty_table(
    String,
    data;
    backend       = :latex,
    column_labels = column_labels,
    highlighters  = [hl_p, hl_v],
    style         = LatexTableStyle(column_label = String[]),
    table_format  = latex_table_format__booktabs
)

create_latex_example(table, "latex_example_03.png")
```

```@raw html
<img src="../latex_example_03.png" alt="LaTeX Example 01" width="70%">
```

# Quick Start

```@meta
CurrentModule = PrettyTables
```

```@setup quick_start
using PrettyTables
```

The following command prints the table in `matrix` using the text backend with all the
available sections:

```julia-repl
julia> matrix = [(i, j) for i in 1:3, j in 1:3];

julia> pretty_table(
    matrix;
    column_labels            = [["Col. $i" for i in 1:3], ["$i" for i in 1:3]],
    footnotes                = [(:column_label, 1, 2) => "Footnote in column label", (:data, 2, 2) => "Footnote in data"],
    merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
    row_group_labels         = [2 => "Row Group"],
    row_labels               = ["Row $i" for i in 1:5],
    show_row_number_column   = true,
    source_notes             = "Source Notes",
    stubhead_label           = "Rows",
    subtitle                 = "Table Subtitle",
    summary_rows             = [(data, i) -> 10i, (data, i) -> 20i],
    title                    = "Table Title",
)
```

```@setup quick_start
matrix = [(i, j) for i in 1:3, j in 1:3];

str = pretty_table(
    String,
    matrix;
    color                    = true,
    column_labels            = [["Col. $i" for i in 1:3], ["$i" for i in 1:3]],
    footnotes                = [(:column_label, 1, 2) => "Footnote in column label", (:data, 2, 2) => "Footnote in data"],
    merge_column_label_cells = [MergeCells(1, 2, 2, "Merged Column", :c)],
    row_group_labels         = [2 => "Row Group"],
    row_labels               = ["Row $i" for i in 1:5],
    show_row_number_column   = true,
    source_notes             = "Source Notes",
    stubhead_label           = "Rows",
    subtitle                 = "Table Subtitle",
    summary_rows             = [(data, i) -> 10i, (data, i) -> 20i],
    title                    = "Table Title",
)

write("tmp", str)

run(`ansitoimg --width 60 --title "PrettyTables.jl (generated by AnsiToImg)" tmp quick_start.svg`)

run(`rm tmp`)
```

![Quick start](./quick_start.svg)

# HTML Backend Examples

```@meta
CurrentModule = PrettyTables
```

```@setup html_examples
using PrettyTables

function pt_to_html(args...; kwargs...)
    str = pretty_table(String, args...; kwargs...)
    return Base.HTML(str)
end
```

Here, we can see some examples of text tables generated by PrettyTables.jl. The `A` object,
when referenced, is defined as:

```julia-repl
julia> A = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]
```

```@setup html_examples
A = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]
```

---

```julia-repl
julia> pretty_table(A; backend = :html)
```

```@example html_examples
pt_to_html(         # hide
    A;              # hide
    backend = :html # hide
)                   # hide
```

---

```julia-repl
julia> pretty_table(
    A;
    backend = :html,
    style = HtmlTableStyle(;
        first_line_column_label = ["color" => "BurlyWood", "font-weight" => "bold"]
    )
)
```

```@example html_examples
pt_to_html(                                                                         # hide
    A;                                                                              # hide
    backend = :html,                                                                # hide
    style = HtmlTableStyle(;                                                        # hide
        first_line_column_label = ["color" => "BurlyWood", "font-weight" => "bold"] # hide
    )                                                                               # hide
)                                                                                   # hide
```

---

```julia-repl
julia> data = [
    10.0 6.5
     3.0 3.0
     0.1 1.0
]

julia> row_labels = [
    "Atmospheric drag"
    "Gravity gradient"
    "Solar radiation pressure"
]

julia> column_labels = [
    [MultiColumn(2, "Value", :c)],
    [
        "Torque [10⁻⁶ Nm]",
        "Angular Momentum [10⁻³ Nms]"
    ]
]

julia> pretty_table(
    data;
    backend = :html,
    column_labels,
    merge_column_label_cells = :auto,
    row_labels,
    stubhead_label = "Effect",
    style = HtmlTableStyle(;
        first_line_merged_column_label = ["color" => "BurlyWood", "font-weight" => "bold"],
        column_label                   = ["color" => "DarkGrey"],
        stubhead_label                 = ["color" => "BurlyWood", "font-weight" => "bold"],
        summary_row_label              = ["color" => "red",       "font-weight" => "bold"]
    ),
    summary_row_labels = ["Total"],
    summary_rows = [(data, i) -> sum(data[:, i])],
)
```

```@example html_examples
data = [                                                                                    # hide
    10.0 6.5                                                                                # hide
     3.0 3.0                                                                                # hide
     0.1 1.0                                                                                # hide
]                                                                                           # hide
                                                                                            # hide
row_labels = [                                                                              # hide
    "Atmospheric drag"                                                                      # hide
    "Gravity gradient"                                                                      # hide
    "Solar radiation pressure"                                                              # hide
]                                                                                           # hide
                                                                                            # hide
column_labels = [                                                                           # hide
    [MultiColumn(2, "Value", :c)],                                                          # hide
    [                                                                                       # hide
        "Torque [10⁻⁶ Nm]",                                                                 # hide
        "Angular Momentum [10⁻³ Nms]"                                                       # hide
    ]                                                                                       # hide
]                                                                                           # hide
                                                                                            # hide
pt_to_html(                                                                                 # hide
    data;                                                                                   # hide
    backend = :html,                                                                        # hide
    column_labels,                                                                          # hide
    merge_column_label_cells = :auto,                                                       # hide
    row_labels,                                                                             # hide
    stubhead_label = "Effect",                                                              # hide
    style = HtmlTableStyle(;                                                                # hide
        first_line_merged_column_label = ["color" => "BurlyWood", "font-weight" => "bold"], # hide
        column_label                   = ["color" => "DarkGrey"],                           # hide
        stubhead_label                 = ["color" => "BurlyWood", "font-weight" => "bold"], # hide
        summary_row_label              = ["color" => "red",       "font-weight" => "bold"]  # hide
    ),                                                                                      # hide
    summary_row_labels = ["Total"],                                                         # hide
    summary_rows = [(data, i) -> sum(data[:, i])],                                          # hide
)                                                                                           # hide
```

---

```julia-repl
julia> t = 0:1:20

julia> data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

julia> column_labels = [
    ["Time", "Acceleration", "Velocity", "Distance"],
    [ "[s]",     "[m / s²]",  "[m / s]",      "[m]"]
]

julia> hl_p = HtmlHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    ["color" => "blue"]
)

julia> hl_v = TextHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    ["color" => "red"]
)

julia> pretty_table(
    data;
    backend = :html,
    column_labels = column_labels,
    highlighters  = [hl_p, hl_v],
    style = HtmlTableStyle(;
        first_line_column_label = ["color" => "BurlyWood", "font-weight" => "bold"],
        column_label            = ["color" => "DarkGrey"],
    )
)
```

```@example html_examples
t = 0:1:20                                                                           # hide
                                                                                     # hide
data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);                                      # hide
                                                                                     # hide
column_labels = [                                                                    # hide
    ["Time", "Acceleration", "Velocity", "Distance"],                                # hide
    [ "[s]",     "[m / s²]",  "[m / s]",      "[m]"]                                 # hide
]                                                                                    # hide
                                                                                     # hide
hl_p = HtmlHighlighter(                                                              # hide
    (data, i, j) -> (j == 4) && (data[i, j] > 9),                                    # hide
    ["color" => "blue"]                                                              # hide
)                                                                                    # hide
                                                                                     # hide
hl_v = HtmlHighlighter(                                                              # hide
    (data, i, j) -> (j == 3) && (data[i, j] > 9),                                    # hide
    ["color" => "red"]                                                               # hide
)                                                                                    # hide
                                                                                     # hide
pt_to_html(                                                                          # hide
    data;                                                                            # hide
    backend = :html,                                                                 # hide
    column_labels = column_labels,                                                   # hide
    highlighters  = [hl_p, hl_v],                                                    # hide
    style = HtmlTableStyle(;                                                         # hide
        first_line_column_label = ["color" => "BurlyWood", "font-weight" => "bold"], # hide
        column_label            = ["color" => "DarkGrey"],                           # hide
    )                                                                                # hide
)                                                                                    # hide
```

# Repository Instructions

## Package Structure

- Treat `src/PrettyTables.jl` as the module entrypoint. Preserve its include order: load core types and implementation first, keep each backend grouped, load printing-state files after the backends, and include `src/precompile.jl` last.
- Keep backend implementations under `src/backends/{text,html,latex,markdown,typst,excel}` and put focused backend regressions in the corresponding `test/backends/...` directory.
- Keep extension code under `ext/`. `PrettyTablesExcelExt` activates with XLSX and `PrettyTablesTypstryExt` activates with Typstry; both trigger packages belong to the root test target.
- Use the root `Project.toml` for package and test dependencies. Support Julia 1.10 or newer according to `[compat]`; tests use the root `[extras]` and `[targets]`, and there is no `test/Project.toml`.
- Build documentation from `docs/`, which has its own `Project.toml` and `make.jl`.

## Commands

- Allow generous timeouts for first runs because package precompilation can be substantial.
- Instantiate the root environment with `julia --project=. -e 'using Pkg; Pkg.instantiate()'`.
- Run the complete suite with `julia --project=. -e 'using Pkg; Pkg.test()'`. Use this by default because `test/runtests.jl` unconditionally loads shared test types and all internal, backend, extension, integration, general, and error test groups.
- Do not assume a test-name selector exists. For a focused file, install TestEnv in the default/shared tool environment first with `julia -e 'using Pkg; Pkg.add("TestEnv")'`, then activate the test environment and mirror the `runtests.jl` setup, for example: `julia --project=. -e 'using TestEnv; TestEnv.activate(); using Test, PrettyTables, Crayons, LaTeXStrings, Markdown, OffsetArrays, StyledStrings, Tables, XLSX, Dates; Crayons.force_color(true); include("test/types.jl"); include("test/backends/text/alignment.jl")'`. Prefer `Pkg.test()` when the selected file needs additional suite state.
- Bootstrap docs from the repository root with `julia --project=docs -e 'using Pkg; Pkg.develop(PackageSpec(path=pwd())); Pkg.instantiate()'`, then build locally with `julia --project=docs docs/make.jl local`.
- Format with `julia -e 'using JuliaFormatter; format(".")'`. Install JuliaFormatter in the active/default tool environment first; it is not a package dependency, so do not run this command with `--project=.`.
- Expect CI to run the build action before tests. The main workflow covers Julia 1.10 and latest stable on Ubuntu x64, macOS arm64, and Windows x64; the nightly workflow runs the same supported platform/architecture combinations on Julia nightly.

## Code Style

- Apply the BlueStyle configuration in `.JuliaFormatter.toml` and preserve its explicit alignment and rewrite settings.
- Write test groups as `@testset "..." verbose = true begin` when adding groups to `test/runtests.jl`; use focused nested testsets within backend files as appropriate.
- Preserve exact backend output, including whitespace, delimiters, escaping, and ANSI sequences. Keep `Crayons.force_color(true)` in test setup so ANSI expectations remain deterministic in CI and non-TTY sessions.
- Review `src/precompile.jl` when changing common public rendering paths. Keep its representative `pretty_table` workloads current and preserve its redirected-output handling and stdout restoration.
- Follow `COMMITS.md` when creating commits: keep commits incremental and functional, use an imperative summary under 50 characters without a trailing period, and separate any punctuated body with a blank line.

## Behavioral Constraints

- Accept only one- or two-dimensional data; reject data with more than two dimensions.
- Require an `alignment` vector to contain exactly one entry per data column.
- Require `summary_rows` and explicitly supplied `summary_row_labels` to have equal lengths.
- Render recursive table data as the exact sentinel `#= circular reference =#`; do not recurse indefinitely or change the sentinel casually.
- Add focused regression coverage in the matching backend test directory whenever output behavior changes, and compare exact rendered output where existing tests do so.

## Not Configured

- Do not invent a linter or formatting gate. The GitHub Actions workflows have no formatting job, even though JuliaFormatter settings are present locally.
- Do not expect pre-commit hooks; no pre-commit configuration is committed.
- Do not run `Pkg.build()` as a repository task; there is no `deps/build.jl`.

# PrettyTables.jl

```@meta
CurrentModule = PrettyTables
```

```@setup index
using PrettyTables
```

This package has the purpose to print data in matrices using different backends. It was
orizinally inspired in the functionality provided by
[ASCII Tables](https://ozh.github.io/ascii-tables/).

**PrettyTables.jl** allows to print the data together with some table sections. They can be
modified by the user to obtain the desired output. The sections currently available are:

![Table Design](./assets/table_design.png)

This design is heavily inspired by the R's package [gt](https://github.com/rstudio/gt/) but
the API is highly different due to the differences between the R and Julia languages.

```@repl index
using PrettyTables

t = 0:1:20

data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

column_labels = [
    ["Time", "Acceleration", "Velocity", "Distance"],
    [ "[s]",     "[m / s²]",  "[m / s]",      "[m]"]
]

hl_p = TextHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    crayon"blue bold"
);

hl_v = TextHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    crayon"red bold"
);

hl_10 = TextHighlighter(
    (data, i, j) -> (i == 10),
    crayon"fg:white bold bg:dark_gray"
);

style = TextTableStyle(first_line_column_label = crayon"yellow bold");

table_format = TextTableFormat(borders = text_table_borders__unicode_rounded);
```

```julia-repl
julia> pretty_table(
    data;
    column_labels = column_labels,
    style         = style,
    highlighters  = [hl_10, hl_p, hl_v],
    table_format  = table_format_format  = TextTableFormat(borders = text_table_borders__unicode_rounded)
)
```

```@setup index
str = pretty_table(
    String,
    data;
    color         = true,
    column_labels = column_labels,
    style         = style,
    highlighters  = [hl_10, hl_p, hl_v],
    table_format  = table_format
)

write("tmp", str)

run(`ansitoimg --width 60 --title "PrettyTables.jl (generated by AnsiToImg)" tmp welcome_figure.svg`)

run(`rm tmp`)
```

![Welcome figure](./welcome_figure.svg)

## Installation

```julia-repl
julia> using Pkg
julia> Pkg.add("PrettyTables")
```

# Text Backend Examples

```@meta
CurrentModule = PrettyTables
```

```@setup text_examples
using PrettyTables

function create_text_example(str::String, filename::String, width::Int = 92)
  write("tmp", str)
  run(`ansitoimg --width $width --title "PrettyTables.jl (generated by AnsiToImg)" tmp $filename`)
  run(`rm tmp`)
  return nothing
end
```

Here, we can see some examples of text tables generated by PrettyTables.jl. The `A` object,
when referenced, is defined as:

```julia-repl
julia> A = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]
```

```@setup text_examples
A = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]
```

---

```julia-repl
julia> pretty_table(A)
```

```@setup text_examples
table = pretty_table(
    String,
    A;
    color = true
)

create_text_example(table, "text_example_01.svg")
```

```@raw html
<img src="../text_example_01.svg" alt="Text Example 01">
```

---

```julia-repl
julia> pretty_table(A; style = TextTableStyle(; table_border = crayon"yellow"))
```

```@setup text_examples
table = pretty_table(
  String,
  A;
  color = true,
  style = TextTableStyle(; table_border = crayon"yellow")
)

create_text_example(table, "text_example_02.svg")
```

```@raw html
<img src="../text_example_02.svg" alt="Text Example 02">
```

---

```julia-repl
julia> data = [
    10.0 6.5
     3.0 3.0
     0.1 1.0
]

julia> row_labels = [
    "Atmospheric drag"
    "Gravity gradient"
    "Solar radiation pressure"
]

julia> column_labels = [
    [MultiColumn(2, "Value", :c)],
    [
        "Torque [10⁻⁶ Nm]",
        "Angular Momentum [10⁻³ Nms]"
    ]
]

julia> pretty_table(
    data;
    column_labels,
    merge_column_label_cells = :auto,
    row_labels,
    stubhead_label = "Effect",
    style = TextTableStyle(;
        first_line_merged_column_label = crayon"bold yellow",
        stubhead_label = crayon"bold yellow",
        summary_row_label = crayon"bold cyan"
    ),
    summary_row_labels = ["Total"],
    summary_rows = [(data, i) -> sum(data[:, i])],
    table_format = TextTableFormat(;
        @text__no_vertical_lines,
        horizontal_lines_at_column_labels = [1],
        vertical_line_after_row_label_column = true
    ),
)
```

```@setup text_examples
data = [
    10.0 6.5
     3.0 3.0
     0.1 1.0
]

row_labels = [
    "Atmospheric drag"
    "Gravity gradient"
    "Solar radiation pressure"
]

column_labels = [
    [MultiColumn(2, "Value", :c)],
    [
        "Torque [10⁻⁶ Nm]",
        "Angular Momentum [10⁻³ Nms]"
    ]
]

table = pretty_table(
    String,
    data;
    color = true,
    column_labels,
    merge_column_label_cells = :auto,
    row_labels,
    stubhead_label = "Effect",
    style = TextTableStyle(;
        first_line_merged_column_label = crayon"bold yellow",
        stubhead_label = crayon"bold yellow",
        summary_row_label = crayon"bold cyan"
    ),
    summary_row_labels = ["Total"],
    summary_rows = [(data, i) -> sum(data[:, i])],
    table_format = TextTableFormat(;
        @text__no_vertical_lines,
        horizontal_lines_at_column_labels = [1],
        vertical_line_after_row_label_column = true
    ),
)
create_text_example(table, "text_example_03.svg")
```

```@raw html
<img src="../text_example_03.svg" alt="Text Example 03">
```

---

```julia-repl
julia> t = 0:1:20

julia> data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

julia> column_labels = [
    ["Time", "Acceleration", "Velocity", "Distance"],
    [ "[s]",     "[m / s²]",  "[m / s]",      "[m]"]
]

julia> hl_p = TextHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    crayon"bold blue"
)

julia> hl_v = TextHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    crayon"bold red"
)

julia> pretty_table(
    data;
    column_labels = column_labels,
    highlighters  = [hl_p, hl_v],
    style = TextTableStyle(;
        first_line_column_label = crayon"bold yellow",
    )
)
```

```@setup text_examples
t = 0:1:20

data = hcat(t, ones(length(t) ), t, 0.5.*t.^2);

column_labels = [
    ["Time", "Acceleration", "Velocity", "Distance"],
    [ "[s]",     "[m / s²]",  "[m / s]",      "[m]"]
]

hl_p = TextHighlighter(
    (data, i, j) -> (j == 4) && (data[i, j] > 9),
    crayon"bold blue"
)

hl_v = TextHighlighter(
    (data, i, j) -> (j == 3) && (data[i, j] > 9),
    crayon"bold red"
)

table = pretty_table(
    String,
    data;
    color = true,
    column_labels = column_labels,
    highlighters  = [hl_p, hl_v],
    style = TextTableStyle(;
        first_line_column_label = crayon"bold yellow",
    )
)

create_text_example(table, "text_example_04.svg")
```

```@raw html
<img src="../text_example_04.svg" alt="Text Example 04">
```

# Markdown Backend

The markdown backend can be selected by passing the keyword `backend = :markdown` to the
function [`pretty_table`](@ref). In this case, we have the following additional keywords to
configure the output.

## Keywords

- `allow_markdown_in_cells::Bool`: If `true`, the content of the cells can contain markdown
  code.
  (**Default**: `false`)
- `highlighters::Vector{MarkdownHighlighter}`: Highlighters to apply to the table. For more
  information, see the section [Markdown Highlighters](@ref).
- `line_breaks::Bool`: If `true`, line breaks in the content of the cells (`\\n`) are
  replaced by `<br>`.
  (**Default**: `false`)
- `style::MarkdownTableStyle`: Style of the table. For more information, see the section
  [Markdown Table Style](@ref).
- `table_format::MarkdownTableFormat`: Markdown table format used to render the table. For
  more information, see the section [Markdown Table Format](@ref).

## Markdown Highlighters

A set of highlighters can be passed as a `Vector{MarkdownHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`MarkdownHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)` in which should return `true`
  if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `fd(h, data, i, j)` in which `h` is the
  highlighter. This function must return the [`MarkdownStyle`](@ref) to be applied to the
  cell that must be highlighted.

The function `f` has the following signature:

```julia
  f(data, i, j)
```

in which `data` is a reference to the data that is being printed, and `i` and `j` are the
element coordinates that are being tested. If this function returns `true`, the highlight
style will be applied to the `(i, j)` element. Otherwise, the default style will be used.

If the function `f` returns true, the function `fd(h, data, i, j)` will be called and must
return an element of type [`MarkdownStyle`](@ref) that contains the decoration to be
applied to the cell.

A markdown highlighter can be constructed using two helpers:

```julia
MarkdownHighlighter(f::Function, decoration::MarkdownStyle)

MarkdownHighlighter(f::Function, fd::Function)
```

The first will apply a fixed decoration to the highlighted cell specified in `decoration`
whereas the second let the user select the desired decoration by specifying the function
`fd`.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

## Markdown Table Format

The markdown table format is defined using an object of type [`MarkdownTableFormat`](@ref)
that contains the following fields:

- `title_heading_level::Int`: Title heading level.
- `subtitle_heading_level::Int`: Subtitle heading level.
- `horizontal_line_char::Char`: Character used to draw the horizontal line.
- `line_before_summary_rows::Bool`: Whether to draw a line before the summary rows.
- `compact_table::Bool`: If `true`, the table is printed in a compact format without extra
  spaces between columns.

## Markdown Table Style

The markdown table style is defined using an object of type [`MarkdownTableStyle`](@ref)
that contains the following fields:

- `row_number_label::MarkdownStyle`: Style for the row number label.
- `row_number::MarkdownStyle`: Style for the row number.
- `stubhead_label::MarkdownStyle`: Style for the stubhead label.
- `row_label::MarkdownStyle`: Style for the row label.
- `row_group_label::MarkdownStyle`: Style for the row group label.
- `first_line_column_label::Union{MarkdownStyle, Vector{MarkdownStyle}}`: Style for the
  first line of the column label. If a vector of `MarkdownStyle` is provided, each column
  label in the first line will use the corresponding style.
- `column_label::Union{MarkdownStyle, Vector{MarkdownStyle}}`: Style for the column label.
  If a vector of `MarkdownStyle` is provided, each column label will use the corresponding
  style.
- `summary_row_label::MarkdownStyle`: Style for the summary row label.
- `summary_row_cell::MarkdownStyle`: Style for the summary row cell.
- `footnote::MarkdownStyle`: Style for the footnote.
- `source_note::MarkdownStyle`: Style for the source note.
- `omitted_cell_summary::MarkdownStyle`: Style for the omitted cell summary.

Each field is an instance of the structure [`MarkdownStyle`](@ref) describing the style to
be applied to the corresponding element.

For example, if we want that the stubhead label is bold and italic, we must define:

```julia
style = MarkdownTableStyle(
    stubhead_label = MarkdownStyle(bold = true, italic = true)
)
```

# Usage

```@meta
CurrentModule = PrettyTables
```

```@setup usage
using PrettyTables

function create_latex_example(table, filename)
    mkdir("tmp")
    cd("tmp")

    write(
      "table.tex",
      """
      \\documentclass[a4paper, 12pt]{article}
      \\pagestyle{empty}
      \\usepackage{color}
      \\usepackage{booktabs}
      \\usepackage{xcolor}
      \\begin{document}
      $table
      \\end{document}
      """
    )

    run(`lualatex table.tex`)
    run(`lualatex table.tex`)
    run(`convert -density 600 table.pdf -flatten -trim $filename`)
    run(`mv $filename ..`)
    cd("..")
    rm("tmp"; recursive = true)
end
```

## Table Sections

**PrettyTables.jl** considers the following table sections when printing a table:

```text
                                      TITLE
                                     Subtitle
┌────────────┬───────────────────┬──────────────┬──────────────┬───┬──────────────┐
│ Row Number │    Stubhead Label │ Column Label │ Column Label │ ⋯ │ Column Label │
│            │                   │ Column Label │ Column Label │ ⋯ │ Column Label │
│            │                   │       ⋮      │       ⋮      │ ⋯ │       ⋮      │
│            │                   │ Column Label │ Column Label │ ⋯ │ Column Label │
├────────────┼───────────────────┼──────────────┼──────────────┼───┼──────────────┤
│          1 │         Row Label │         Data │         Data │ ⋯ │         Data │
│          2 │         Row Label │         Data │         Data │ ⋯ │         Data │
├────────────┴───────────────────┴──────────────┴──────────────┴───┴──────────────┤
│ Row Group Label                                                                 │
├────────────┬───────────────────┬──────────────┬──────────────┬───┬──────────────┤
│          3 │         Row Label │         Data │         Data │ ⋯ │         Data │
│          4 │         Row Label │         Data │         Data │ ⋯ │         Data │
├────────────┴───────────────────┴──────────────┴──────────────┴───┴──────────────┤
│ Row Group Label                                                                 │
├────────────┬───────────────────┬──────────────┬──────────────┬───┬──────────────┤
│          5 │         Row Label │         Data │         Data │ ⋯ │         Data │
│          6 │         Row Label │         Data │         Data │ ⋯ │         Data │
│      ⋮     │          ⋮        │       ⋮      │       ⋮      │ ⋱ │       ⋮      │
│        100 │         Row Label │         Data │         Data │ ⋯ │         Data │
├────────────┼───────────────────┼──────────────┼──────────────┼───┼──────────────┤
│            │ Summary Row Label │ Summary Cell │ Summary Cell │ ⋯ │ Summary Cell │
│            │ Summary Row Label │ Summary Cell │ Summary Cell │ ⋯ │ Summary Cell │
│      ⋮     │          ⋮        │       ⋮      │       ⋮      │ ⋯ │       ⋮      │
│            │ Summary Row Label │ Summary Cell │ Summary Cell │ ⋯ │ Summary Cell │
└────────────┴───────────────────┴──────────────┴──────────────┴───┴──────────────┘
Footnotes
Source notes
```

All those sections can be configured using keyword arguments as described below.

## General Keywords

The following keywords are related to table configuration and are available in all backends:

- `backend::Symbol`: Backend used to print the table. The available options are `:text`,
  `:markdown`, `:html`, and `:latex`.
  (**Default**: `:text`)

### IOContext Arguments

- `compact_printing::Bool`: If `true`, the table will be printed in a compact format, *i.e*,
  we will pass the context option `:compact => true` when rendering the values.
  (**Default**: `true`)
- `limit_printing::Bool`: If `true`, the table will be printed in a limited format, *i.e*,
  we will pass the context option `:limit => true` when rendering the values.
  (**Default**: `true`)

### Printing Specification Arguments

- `show_omitted_cell_summary::Bool`: If `true`, a summary of the omitted cells will be
  printed at the end of the table.
  (**Default**: `true`)
- `renderer::Symbol`: The renderer used to print the table. The available options are
  `:print` and `:show`.
  (**Default**: `:print`)

### Table Sections Arguments

- `title::String`: Title of the table. If it is empty, the title will be omitted.
  (**Default**: "")
- `subtitle::String`: Subtitle of the table. If it is empty, the subtitle will be omitted.
  (**Default**: "")
- `stubhead_label::String`: Label of the stubhead column.
  (**Default**: "")
- `row_number_column_label::String`: Label of the row number column.
  (**Default**: "Row")
- `row_labels::Union{Nothing, AbstractVector}`: Row labels. If it is `nothing`, the column
  with row labels is omitted.
  (**Default**: `nothing`)
- `row_group_labels::Union{Nothing, Vector{Pair{Int, String}}}`: Row group labels. If it is
  `nothing`, no row group label is printed. For more information on how to specify the row
  group labels, see the section **Row Group Labels**.
  (**Default**: `nothing`)
- `column_labels::Union{Nothing, AbstractVector}`: Column labels. If it is `nothing`, the
  function uses a default value for the column labels. For more information on how to
  specify the column labels, see the section **Column Labels**.
  (**Default**: `nothing`)
- `show_column_labels::Bool`: If `true`, the column labels will be printed.
  (**Default**: `true`)
- `summary_rows::Union{Nothing, Vector{Function}}`: Summary rows. If it is `nothing`, no
  summary rows are printed. For more information on how to specify the summary rows, see the
  section [Summary Rows](@ref).
  (**Default**: `nothing`)
- `summary_row_labels::Union{Nothing, Vector{String}}`: Labels of the summary rows. If it is
  `nothing`, the function uses a default value for the summary row labels.
  (**Default**: `nothing`)
- `footnotes::Union{Nothing, Vector{Pair{FootnoteTuple, String}}}`: Footnotes. If it is
  `nothing`, no footnotes are printed. For more information on how to specify the footnotes,
  see the section [Footnotes](@ref).
  (**Default**: `nothing`)
- `source_notes::String`: Source notes. If it is empty, the source notes will be omitted.
  (**Default**: "")

### Alignment Arguments

The following keyword arguments define the alignment of the table sections. The alignment
can be specified using a symbol: `:l` for left, `:c` for center, or `:r` for right.

- `alignment::Union{Symbol, Vector{Symbol}}`: Alignment of the table data. It can be a
  `Symbol`, which will be used for all columns, or a vector of `Symbol`s, one for each
  column.
  (**Default**: `:r`)
- `column_label_alignment::Union{Nothing, Symbol, Vector{Symbol}}`: Alignment of the column
  labels. It can be a `Symbol`, which will be used for all columns, a vector of `Symbol`s,
  one for each column, or `nothing`, which will use the value of `alignment`.
  (**Default**: `nothing`)
- `continuation_row_alignment::Union{Nothing, Symbol}`: Alignment of the columns in the
  continuation row. If it is `nothing`, we use the value of `alignment`.
  (**Default**: `nothing`)
- `footnote_alignment::Symbol`: Alignment of the footnotes.
  (**Default**: `:l`)
- `row_label_column_alignment::Symbol`: Alignment of the row labels.
  (**Default**: `:r`)
- `row_group_label_alignment::Symbol`: Alignment of the row group labels.
  (**Default**: `:l`)
- `row_number_column_alignment::Symbol`: Alignment of the row number column.
  (**Default**: `:r`)
- `source_note_alignment::Symbol`: Alignment of the source notes.
  (**Default**: `:l`)
- `subtitle_alignment::Symbol`: Alignment of the subtitle.
  (**Default**: `:c`)
- `title_alignment::Symbol`: Alignment of the title.
  (**Default**: `:c`)
- `cell_alignment::Union{Nothing, Vector{Pair{NTuple{2, Int}, Symbol}, Vector{Function}}`: A
  vector of functions with the signature `f(data, i, j)` that overrides the alignment of the
  cell `(i, j)` to the value returned by `f`. The function must return a valid alignment
  symbol or `nothing`. In the latter, the cell alignment will not be modified. If the
  function returns an invalid data, it will be discarded. For convenience, it can also be a
  vector of `Pair{NTuple{2, Int}, Symbol}`, *i.e.* `(i::Int, j::Int) => a::Symbol`, that
  overrides the alignment of the cell `(i, j)` to `a`.
  (**Default** = `nothing`)

!!! warning

    Some backends do not support all the alignment options. For example, it is impossible
    to define cell-specific alignment in the markdown backend.

### Other Arguments

- `formatters::Union{Nothing, Vector{Function}}`: Formatters used to modify the rendered
  output of the cells. For more information, see the section [Formatters](@ref).
  (**Default**: `nothing`)
- `maximum_number_of_columns::Int`: Maximum number of columns to be printed. If the table
  has more columns than this value, the table will be truncated. If it is negative, all
  columns will be printed.
  (**Default**: `-1`)
- `maximum_number_of_rows::Int`: Maximum number of rows to be printed. If the table has more
  rows than this value, the table will be truncated. If it is negative, all rows will be
  printed.
  (**Default**: `-1`)
- `merge_column_label_cells::Union{Symbol, Vector{MergeCells}}`: Merged cells in the column
  labels. For more information, see the section [Column Labels](@ref).
  (**Default**: `:auto`)
- `new_line_at_end::Bool`: If `true`, a new line will be added at the end of the table.
- `show_first_column_label_only::Bool`: If `true`, only the first row of the column labels
  will be printed.
  (**Default**: `false`)
- `vertical_crop_mode::Symbol`: Vertical crop mode. This option defines how the table will
  be vertically cropped if it has more rows than the number specified in
  `maximum_number_of_rows`. The available options are `:bottom`, when the data will be
  cropped at the bottom of the table, or `:middle`, when the data will be cropped at the
  middle of the table.
  (**Default**: `:bottom`)

## Backend-Specific Keywords

Please, see the backend sections for the keywords specific to each one.

## Specification of Table Sections

Here, we show how to specify the table sections using the keyword arguments.

### Column Labels

The specification of column labels must be a vector of elements. Each element in this vector
must be another vector with a row of column labels. Notice that each vector must have the
same size as the number of table columns.

For example, in a table with three columns, we can specify two rows of column labels by
passing:

```julia
column_labels = [
    ["Column #1",    "Column #2",    "Column #3"],
    ["Subcolumn #1", "Subcolumn #2", "Subcolumn #3"]
]
```

!!! info

    If the user wants only one row in the column labels, they can pass only a vector with
    the elements. The algorithm will encapsulate it inside another vector to match the API.

Adjacent column labels can be merged using the keyword `merge_column_label_cells`. It must
contain a vector of `MergeCells` objects. Each object defines a new merged cell. The
`MergeCells` object has the following fields:

- `row::Int`: Row index of the merged cell.
- `column::Int`: Column index of the merged cell.
- `column_span::Int`: Number of columns spanned by the merged cell.
- `data::String`: Data of the merged cell.
- `alignment::Symbol`: Alignment of the merged cell. The available options are `:l` for
  left, `:c` for center, and `:r` for right.
  (**Default**: `:c`)

Hence, in our example, if we want to merge the columns 2 and 3 of the first column label
row, we must pass:

```julia
merge_column_label_cells = [
    MergeCells(1, 2, 2, "Merged Column", :c)
]
```

We can pass the helpers `MultiColumn` and `EmptyCells` to `column_labels` to create merged
columns more easily. In this case, `MultiColumn` specify a set of columns that will be
merged, and `EmptyCells` specify a set of empty columns. However, notice that in this case
we must set `merge_column_label_cells` to `:auto`.

`MultiColumn` has the following fields:

- `column_span::Int`: Number of columns spanned by the merged cell.
- `data::String`: Data of the merged cell.

`EmptyCells` has the following field:

- `number_of_cells::Int`: Number of columns that will be filled with empty cells.

For example, we can create the following column labels:

```
┌───────────────────────────────────┬─────────────────┐
│              Group #1             │     Group #2    │
├─────────────────┬─────────────────┼────────┬────────┤
│    Group #1.1   │    Group #1.2   │        │        │
├────────┬────────┼────────┬────────┼────────┼────────┤
│ Test 1 │ Test 2 │ Test 3 │ Test 4 │ Test 5 │ Test 6 │
└────────┴────────┴────────┴────────┴────────┴────────┘
```

by passing these arguments:

```julia
column_labels = [
    [MultiColumn(4, "Group #1"), MultiColumn(2, "Group #2")],
    [MultiColumn(2, "Group #1.1"), MultiColumn(2, "Group #1.2"), EmptyCells(2)],
    ["Test 1", "Test 2", "Test 3", "Test 4", "Test 5", "Test 6"]
]

merge_column_label_cells = :auto
```

### Row Group Labels

The row group labels are specified by a `Vector{Pair{Int, String}}`. Each element defines a
new row group label. The first element of the `Pair` is the row index of the row group and
the second is the label. For example, `[3 => "Row Group #1"]` defines that before
row 3, we have the row group label named "Row Group #1".

### Summary Rows

The summary rows can be specified by a vector of `Function`s. Each element defines a summary
row and the function must have one the following signature:

```
f(col)

f(data, j)
```

where `col` is the current column, `data` is the table data, and `j` is the column index. In
the first case, it must return the summary cell value for the referenced column. In the
second case, it must return the summary cell value for the `j`th column. The algorithm will
check if there is an applicable method for the first signature and use it if it exists.
Otherwise, it will use the second signature. This verification is performed using the method
`applicable` and `col` is obtained by `@view data[:, j]`.

If we want, for example, to create two summary rows, one with the sum of the column values
and other with their mean, we can define:

```julia
summary_rows = [
    (data, j) -> sum(data[:, j]),
    (data, j) -> sum(data[:, j]) / length(data[:, j])
]
```

We can also use the first signature to simplify the code:

```julia
using Statistics
summary_rows = [sum, mean]
```

!!! note

    If both signatures are available, the algorithm will prioritize the first one. To force
    the usage of the second, we can create an anonymous functions as follows: `(data, i) ->
    f(data, i)`. This ensures that only the second method is available.

### Footnotes

The footnotes are specified by a vector of `Pair{FootnoteTuple, String}`. Each element
defines a new footnote. The `FootnoteTuple` is a `Tuple` with the following elements:

- `section::Symbol`: Section to which the footnote must be applied. The available options
  are `:column_label`, `:data`, `:row_label`, `:summary_row_label`, and `:summary_row_cell`.
- `i::Int`: Row index of the footnote considering the desired section.
- `j::Int`: Column index of the footnote considering the desired section.

The second element of the `Pair` is the footnote text.

Hence, if we want to apply a foot note to a column label, a data cell, and a summary cell,
we can define:

```julia
footnotes = [
    (:column_label, 1, 2) => "Footnote in column label",
    (:data, 2, 2) => "Footnote in data",
    (:summary_row_cell, 1, 2) => "Footnote in summary cell"
]
```

## Formatters

The keyword `formatters` can be used to pass functions to format the values in the columns.
It must be a `Vector{Function}` in which each function has the following signature:

```julia
f(v, i, j)
```

where `v` is the value in the cell, `i` is the row number, and `j` is the column number.
It must return the formatted value of the cell `(i, j)` that has the value `v`. Notice
that the returned value will be converted to string after using the function `sprint`.

This keyword can also be `nothing`, meaning that no formatter will be used.

For example, if we want to multiply all values in odd rows of the column 2 by π, the
formatter should look like:

```julia
formatters = [(v, i, j) -> (j == 2 && isodd(i)) ? v * π : v]
```

If multiple formatters are available, they will be applied in the same order as they are
located in the vector. Thus, for the following `formatters`:

```julia
formatters = [f1, f2, f3]
```

each element `v` in the table (`i`th row and `j`th column) will be formatted by:

```julia
v = f1(v, i, j)
v = f2(v, i, j)
v = f3(v, i, j)
```

Thus, the user must ensure that the type of `v` between the calls is compatible.

PrettyTables.jl provides some predefined formatters for common tasks as described in the
next section.

### Predefined Formatters

```julia
fmt__printf(fmt_str::String[, columns::AbstractVector{Int}]) -> Function
```

Apply the format `fmt_str` (see the `Printf` standard library) to the elements in the
columns specified in the vector `columns`. If `columns` is not specified, the format will be
applied to the entire table.

!!! info

    This formatter will be applied only to the cells that are of type `Number`.

```@repl usage
data = [f(a) for a = 0:30:90, f in (sind, cosd, tand)]

pretty_table(data; formatters = [fmt__printf("%5.3f")])

pretty_table(data; formatters = [fmt__printf("%5.3f", [1, 3])])
```

---

```julia
fmt__round(digits::Int[, columns::AbstractVector{Int}]) -> Function
```

Round the elements in the columns specified in the vector `columns` to the number of
`digits`. If `columns` is not specified, the rounding will be applied to the entire table.

```@repl usage
data = [f(a) for a = 0:30:90, f in (sind, cosd, tand)]

pretty_table(data; formatters = [fmt__round(1)])

pretty_table(data; formatters = [fmt__round(1, [1, 3])])
```

---

```julia
fmt__latex_sn(m_digits::Int[, columns::AbstractVector{Int}]) -> Function
```

Format the numbers of the elements in the `columns` to a scientific notation using LaTeX.
If `columns` is not present, the formatting will be applied to the entire table.

The number is first printed using `Printf` functions with the `g` modifier and then
converted to the LaTeX format. The number of digits in the mantissa can be selected by the
argument `m_digits`.

The formatted number will be wrapped in the object `LatexCell`. Hence, this formatter only
makes sense if the selected backend is `:latex`.

!!! info

    This formatter will be applied only to the cells that are of type `Number`.

```julia-repl
julia> data = [10.0^(-i + j) for i in 1:6, j in 1:6]
6×6 Matrix{Float64}:
 1.0     10.0     100.0    1000.0   10000.0  100000.0
 0.1      1.0      10.0     100.0    1000.0   10000.0
 0.01     0.1       1.0      10.0     100.0    1000.0
 0.001    0.01      0.1       1.0      10.0     100.0
 0.0001   0.001     0.01      0.1       1.0      10.0
 1.0e-5   0.0001    0.001     0.01      0.1       1.0

julia> pretty_table(data; formatters = [fmt__latex_sn(1)], backend = :latex)
```

```@setup usage
data = [ 10.0^(-i + j) for i in 1:6, j in 1:6]

table = pretty_table(String, data; formatters = [fmt__latex_sn(1)], backend = :latex)

create_latex_example(table, "fmt__latex_sn.png")
```

![fmt__latex_sn](./fmt__latex_sn.png)

## PrettyTable Object

The structure `PrettyTable` stores the data and configuration options required to print a
table. The table to be displayed is specified by the `data` field, while any additional
configuration options, corresponding to the keyword arguments accepted by the `pretty_table`
function, can be set as fields with matching names.

Users can overload the `show` function to customize how the table is printed for different
MIME types. PrettyTables.jl provides a default `show` method for printing tables to
`stdout`.

```@repl usage
matrix = [(i, j) for i in 1:4, j in 1:4]

pt = PrettyTable(matrix)

pt.table_format = TextTableFormat(; @text__no_vertical_lines)

pt

pt.formatters = [(v, i, j) -> "$(v[1]) <=> $(v[2])"]

pt

pt.formatters = nothing

pt
```

# Commits

This file describe rules that must be applied to commit code to
**PrettyTables**.

Notice that this document is **under construction**.

## Best practices

The following list of best practices should be considered when creating commits
for this project:

1. The commits should be incremental. Try to avoid very big changes within just
   one commit.
2. The overall state of the software must be as functional as possible between
   two commits. Try to avoid commits that break the entire software if another
   commit is not applied.

## Commit message

The commit message must have the following structure:

```text
<EMOJI> Short summary of changes
                         -- BLANK LINE -- 
More detailed explanatory text, if necessary.  Wrap it to 67
characters.  In some contexts, the first line is treated as the
subject of an email and the rest of the text as the body.  The
blank line separating the summary from the body is critical (unless
you omit the body entirely); tools like rebase can get confused if
you run the two together.

Further paragraphs come after blank lines.

  - Bullet points are okay, too.

  - Typically a hyphen or asterisk is used for the bullet, preceded
    by a single space, with blank lines in between, but conventions
    vary here.
```

**Source**: Adapted from http://git-scm.com/book/ch5-2.html

Notice that:

1. The short summary **must** be less than **50 characters**. The emojis, if
   present, count as 1 character each.
2. **Don't** end the summary with a period.
3. If the summary indicates an action, then if **must** be written in imperative
   form. Hence, write "Fix ...", "Change ...", and "Add ...", instead of "Fixed
   ...", "Changed ...", or "Added ...".
4. It is preferred that only one emoji is used per commit.
5. All the phrases in the explanatory text **must** be punctuated.
6. If there is an explanatory text, a blank line **must** exist between the
   short summary of changes and the explanatory text.
7. The is no limit for the detailed explanatory text, but it must be wrap to 72
   characters.

## Commit emojis

Emojis can be used to improve the understanding about the commit. It can be used
at the beginning of the commit message to indicate what kind of modification the
commit does. The following table describe some situations:

| Commit Type            | Emoji                                                          |
|------------------------|----------------------------------------------------------------|
| Initial Commit         | :tada: `:tada:`                                                |
| Version Tag            | :bookmark: `:bookmark:`                                        |
| New Feature            | :sparkles: `:sparkles:`                                        |
| Bugfix                 | :bug: `:bug:`                                                  |
| Refactoring            | :package: `:package:`                                          |
| Documentation          | :books: `:books:`                                              |
| Internationalization   | :globe_with_meridians: `:globe_with_meridians:`                |
| Performance            | :racehorse: `:racehorse:`                                      |
| Cosmetic               | :lipstick: `:lipstick:`                                        |
| General improvements   | :wrench: `:wrench:`                                            |
| Tests                  | :rotating_light: `:rotating_light:`                            |
| Deprecation            | :poop: `:poop:`                                                |
| Work In Progress (WIP) | :construction: `:construction:`                                |
| Warning                | :warning: `:warning:`                                          |
| Other                  | [See here](https://www.webpagefx.com/tools/emoji-cheat-sheet/) |

**Note**: If the commit contains an important warning, such as a breaking change, then the
emoji :warning: `:warning:` must be added to the commit title. In this case, two emojis
can be used.

# LaTeX Backend

The LaTeX backend can be selected by passing the keyword `backend = :latex` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output.

## Keywords

- `highlighters::Vector{LatexHighlighter}`: Highlighters to apply to the table. For more
    information, see the section [LaTeX Highlighters]@(ref).
- `style::LatexTableStyle`: Style of the table. For more information, see the section
    [LaTeX Table Style](@ref).
- `table_format::LatexTableFormat`: LaTeX table format used to render the table. For more
    information, see the section [LaTeX Table Format](@ref).

## LaTeX Highlighters

A set of highlighters can be passed as a `Vector{LatexHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`LatexHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)` in which should return `true`
    if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
    highlighter. This function must return a `Vector{String}` with the LaTeX environments to
    be applied to the cell.

A LaTeX highlighter can be constructed using two helpers:

```julia
LatexHighlighter(f::Function, envs::Vector{String})
```

where it will apply recursively all the LaTeX environments in `envs` to the highlighted
text, and

```julia
LatexHighlighter(f::Function, fd::Function)
```

where the user select the desired decoration by specifying the function `fd`.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to make the cells with value greater than 5 bold, and all the
cells with value less than 5 small, we can define:

```julia
hl_gt5 = LatexHighlighter(
    (data, i, j) -> data[i, j] > 5,
    ["textbf"]
)

hl_lt5 = LatexHighlighter(
    (data, i, j) -> data[i, j] < 5,
    ["small"]
)

highlighters = [hl_gt5, hl_lt5]
```

## LaTeX Table Format

The LaTeX table format is defined using an object of type [`LatexTableFormat`](@ref) that
contains the following fields:

- `borders::LatexTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn on bottom of the merged column labels using `\\cline`.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data column. If the symbol `:none` is passed,
    no horizontal lines will be drawn after the data rows.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data column. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@latex__all_horizontal_lines`](@ref).
- [`@latex__all_vertical_lines`](@ref).
- [`@latex__no_horizontal_lines`](@ref).
- [`@latex__no_vertical_lines`](@ref).

## LaTeX Table Style

The LaTeX table style is defined using an object of type [`LatexTableStyle`](@ref) that
contains the following fields:

- `title::LatexEnvironments`: Latex environments with the style for the title.
- `subtitle::LatexEnvironments`: Latex environments with the style for the subtitle.
- `row_number_label::LatexEnvironments`: Latex environments with the style for the row
    number label.
- `row_number::LatexEnvironments`: Latex environments with the style for the row numbers.
- `stubhead_label::LatexEnvironments`:  Latex environments with the style for the stubhead
    label.
- `row_label::LatexEnvironments`: Latex environments with the style for the row labels.
- `row_group_label::LatexEnvironments`: Latex environments with the style for the row group
    label.
- `first_line_column_label::Union{LatexEnvironments, Vector{LatexEnvironments}}`: Latex
    environments with the style for the first line of the column labels. If a vector of
    `LatexEnvironments` is provided, each column label in the first line will use the
    corresponding style.
- `column_label::Union{LatexEnvironments, Vector{LatexEnvironments}}`: Latex environments
    with the style for the rest of the column labels. If a vector of `LatexEnvironments` is
    provided, each column label will use the corresponding style.
- `first_line_merged_column_label::LatexEnvironments`: Latex environments with the style for
    the merged cells at the first column label line.
- `merged_column_label::LatexEnvironments`: Latex environments with the style for the merged
    cells at the rest of the column labels.
- `summary_row_cell::LatexEnvironments`: Latex environments with the style for the summary
    row cell.
- `summary_row_label::LatexEnvironments`: Latex environments with the style for the summary
    row label.
- `footnote::LatexEnvironments`: Latex environments with the style for the footnotes.
- `source_note::LatexEnvironments`: Latex environments with the style for the source notes.
- `omitted_cell_summary::LatexEnvironments`: Latex environments with the style for the
    omitted cell summary.

Each field is a `LatexEnvironments` object, which is a vector of strings with the LaTeX
environments to be applied to the corresponding element.

For example, if we want to make the stubhead label bold and red, we must define:

```julia
style = LatexTableStyle(
    stubhead_label = ["textbf", "color{red}"]
)
```

# Excel Backend

The Excel backend can be selected by passing the keyword `backend = :excel` to the function
[`pretty_table`](@ref). This will allow you to create a pretty table in a newly created
Excel file or to add a pretty table to a new or existing sheet in an existing Excel file.

The Excel backend return depends on the following combination of keywords:

- `nothing` when `sheet` is an `XLSX.Worksheet` (the worksheet is updated in place).
- `XLSX.XLSXFile` when `filename` is `nothing` and `sheet` is a `String`.
- `String` (the filename) when `filename` is a `String` and `mode = "w"`.
- `XLSX.XLSXFile` when `filename` is a `String` and `mode = "rw"`.

!!! note

    This backend uses the functions of [XLSX.jl](https://github.com/felipenoris/XLSX.jl),
    particularly the functions `setFont`, `setFill`, `setBorder` and `setFormat`. For more
    information, refer to the documentation of this package.

## Keywords

- `anchor_cell::String`: Top-left cell of the table in A1 notation (e.g. `"B3"`).
    (**Default**: `"A1"`)
- `data_column_widths::Union{Float64, Vector{Float64}}`: Explicit width for each data column
    in Excel units, overriding auto-calculated widths. A scalar applies to all columns; a
    vector sets per-column widths. When set (> 0), `minimum_data_column_widths` and
    `maximum_data_column_widths` are ignored for that column.
    (**Default**: `0.0`)
- `excel_formatters::Vector{ExcelFormatter}`: Number-format rules applied to data and
    summary cells.
    (**Default**: `ExcelFormatter[]`)
- `filename::Union{Nothing, String}`: Path of the Excel file to write. When `nothing`, no
    file is created and an in-memory `XLSX.XLSXFile` is returned instead. When a string,
    behavior depends on `mode`.
    (**Default**: `nothing`)
- `highlighters::Vector{ExcelHighlighter}`: Highlighters to apply to the table. For more
    information, see the section [Excel Highlighters](@ref).
- `maximum_data_column_widths::Union{Float64, Vector{Float64}}`: Maximum width for each
    data column in Excel units. A scalar applies to all columns; a vector sets per-column
    maximums.
    (**Default**: `0.0`)
- `minimum_data_column_widths::Union{Float64, Vector{Float64}}`: Minimum width for each
    data column in Excel units. A scalar applies to all columns; a vector sets per-column
    minimums.
    (**Default**: `0.0`)
- `mode::String`: `"w"` to create a new file or `"rw"` to open and update an existing one.
    (**Default**: `"w"`)
- `overwrite::Bool`: Allow overwriting an existing file when `mode = "w"`.
    (**Default**: `false`)
- `sheet::Union{String, XLSX.Worksheet}`: When a `String`, the name of the worksheet tab.
    If no sheet with that name exists it will be created. When an `XLSX.Worksheet`, that
    worksheet is updated in place and `nothing` is returned.
    (**Default**: `"prettytable"`)
- `style::TextTableStyle`: Style of the table. For more information, see the section
    [Excel Table Style](@ref).
- `table_format::ExcelTableFormat`: Excel table format used to render the table. For more
    information, see the section [Excel Table Format](@ref).

## Excel Highlighters

A set of highlighters can be passed as a `Vector{ExcelHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`ExcelHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)`, which should return `true`
  if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
  highlighter. This function must return a `Vector{ExcelPair}` with the styling attributes
  to apply to the highlighted cell.

An Excel highlighter can be constructed using the following helpers:

```julia
ExcelHighlighter(f::Function, decoration::ExcelPair)
ExcelHighlighter(f::Function, decoration::Vector{ExcelPair})
ExcelHighlighter(f::Function, fd::Function)
```

The decoration uses the same `Vector{ExcelPair}` format as `ExcelTableStyle` fields.
Font attributes are specified directly; fill attributes use the `"cell_fill_"` key prefix
(stripped before calling `XLSX.setFill`). Border attributes are not supported.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells in the third data column with a value greater
than 10 in red with a grey fill, and those in the fourth column in blue:

```julia
highlighters = [
    ExcelHighlighter((data, i, j) -> (j == 3) && (data[i, j] > 10), [
        "color" => "red", "bold" => "true",
        "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "grey90",
    ]),
    ExcelHighlighter((data, i, j) -> (j == 4) && (data[i, j] > 10),
        ["color" => "blue", "bold" => "true"],
    ),
]
```

## Excel Formatters

It is possible to apply a set of native Excel formats by passing a `Vector{ExcelFormatter}`
to the `excel_formatters` keyword. Each Excel formatter is an instance of the structure
[`ExcelFormatter`](@ref).

The first formatter (in the order they are specified) that satisfies the specified condition
in the given table cell is applied, and the remainder of the formatters in the list are
skipped. If none matches, no `ExcelFormatter` is applied.

By default, an `ExcelFormatter` matches the **data cells** and the value of `i` passed to
its function is the data row index. An `ExcelFormatter` can be applied in the summary row,
too, by setting the keyword `region = :summary_row`. In this case, the value of `i` relates
to the summary row index (`1` for the first summary row, `2` for the second, and so on),
rather than the data table row. The value of `j` has the same meaning/values (column
specifier) as in the data table itself.

Excel formatters may be applied in addition to the standard formatters. The standard
formatters control the literal values written to Excel while the Excel formatters control
how Excel displays the literal cell values.

For example, to apply Excel-native formatting to different columns of a table:

```julia
excel_formatters = [
    ExcelFormatter((v, i, j) -> (j==1), ["format" => "#,##0_0_0"])
    ExcelFormatter((v, i, j) -> (j==2), ["format" => "#,##0.??_0_0"])
    ExcelFormatter((v, i, j) -> (j==3), ["format" => "#,##0.???"])
    ExcelFormatter((v, i, j) -> (j==4), ["format" => "0_0_0_0"])
]
```

Excel formatters apply native Excel formatting to native Excel values. However,
`PrettyTables.jl` can handle Julia types that can't be represented natively in Excel. If
these are passed natively, then XLSX.jl will fail. To circumvent this, a predefined
formatter has been provided which converts any unhandled types to strings (using
`string()`). For more information, see [`fmt__excel_stringify`](@ref).

## Excel Table Format

The Excel table format is defined using an object of type [`ExcelTableFormat`](@ref) that
contains the following fields:

- `borders::ExcelTableBorders`: Border style configuration (see below).
- `horizontal_line_at_beginning::Bool`: Draw a horizontal line at the first table row after
    the title/subtitle section (i.e., the top of the column labels or the first data row).
    Title and subtitle rows are never bordered.
- `horizontal_line_after_column_labels::Bool`: Draw a line under the column header section.
- `horizontal_line_between_column_labels::Bool`: Draw a line between column header rows.
- `horizontal_line_at_merged_column_labels::Bool`: Draw a line under merged column headers.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: Draw underlines after data
    rows. `:all` draws after every row, `:none` draws none, a `Vector{Int}` draws only after
    the specified row indices (e.g., `[1, 3]` draws after rows 1 and 3).
- `horizontal_line_after_data_rows::Bool`: Draw a line under the data table section.
- `horizontal_line_before_row_group_label::Bool`: Draw a line above each row group divider.
- `horizontal_line_after_row_group_label::Bool`: Draw a line below each row group divider.
- `horizontal_line_before_summary_rows::Bool`: Draw a line between consecutive summary rows.
- `horizontal_line_after_summary_rows::Bool`: Draw a line under the last summary row.
- `vertical_line_at_beginning::Bool`: Draw a vertical line on the left side of the content
    area (excludes title/subtitle and footnotes).
- `vertical_line_after_row_number_column::Bool`: Draw a vertical line after the row number
    column.
- `vertical_line_after_row_label_column::Bool`: Draw a vertical line after the row label
    column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: Draw dividers between data
    columns. `:all` draws after every column, `:none` draws none, a `Vector{Int}` draws only
    after the specified column indices (e.g., `[1, 3]` draws after columns 1 and 3).
- `vertical_line_after_data_columns::Bool`: Draw a vertical line on the right side of the
    content area (excludes title/subtitle and footnotes).

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@excel__all_horizontal_lines`](@ref).
- [`@excel__all_vertical_lines`](@ref).
- [`@excel__no_horizontal_lines`](@ref).
- [`@excel__no_vertical_lines`](@ref).

Border styles are specified using an [`ExcelTableBorders`](@ref) object with these fields:

**Horizontal lines:**

- `top_line`: Top of the outside border.
    (**Default**: thick black).
- `header_line`: Line drawn under the column label section.
    (**Default**: medium black).
- `merged_header_cell_line`: Line below merged header cells
    (**Default**: thin black).
- `middle_line`: All other internal horizontal lines — data row underlines, lines around
    row groups, lines around summary rows, between-header lines — and vertical lines
    between data columns.
    (**Default**: thin black).
- `bottom_line`: Bottom of the outside border
    (**Default**: thick black).

**Vertical lines:**

- `left_line`: Left of the outside border.
    (**Default**: thick black).
- `center_line`: Structural vertical lines — after row numbers and after row labels.
    (**Default**: thin black).
- `right_line`: Right of the outside border.
    (**Default**: thick black).

### Examples

Apply a preset:

```julia
table_format = ExcelTableFormat(; @excel__no_vertical_lines)
```

Apply a preset and override one of its fields. Notice that the keyword must come **after**
the macro, since the last binding wins:

```julia
table_format = ExcelTableFormat(;
    @excel__no_vertical_lines,
    vertical_line_at_beginning = true,
)
```

Draw section-separator lines in red:

```julia
table_format = ExcelTableFormat(;
    borders = ExcelTableBorders(; header_line = ["style" => "thin", "color" => "red"]),
)
```

To combine a preset with customized border styles:

```julia
table_format = ExcelTableFormat(;
    @excel__no_vertical_lines,
    borders = ExcelTableBorders(;
        header_line = ["style" => "thick", "color" => "red"],
        middle_line = ["style" => "thick", "color" => "red"],
    ),
)
```

When more than one preset is applied, they take effect in order, with the later ones taking
precedence. Any keyword argument provided after them takes precedence over all of them.

## Excel Table Style

The Excel table style is defined using an object of type [`ExcelTableStyle`](@ref) that
contains the following fields:

- `title::Vector{ExcelPair}`: Style for the title.
- `subtitle::Vector{ExcelPair}`: Style for the subtitle.
- `row_number_label::Vector{ExcelPair}`: Style for the row number label.
- `row_number::Vector{ExcelPair}`: Style for the row number.
- `stubhead_label::Vector{ExcelPair}`: Style for the stubhead label.
- `row_label::Vector{ExcelPair}`: Style for the row label.
- `row_group_label::Vector{ExcelPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}}`: Style for
    the first line of the column labels. If a vector of `Vector{ExcelPair}}` is provided,
    each column label in the first line will use the corresponding style.
- `column_label::Union{Vector{ExcelPair}, Vector{Vector{ExcelPair}}}`: Style for the rest of
    the column labels. If a vector of `Vector{ExcelPair}}` is provided, each column label
    will use the corresponding style.
- `first_line_merged_column_label::Vector{ExcelPair}`: Style for the merged cells at the
    first column label line.
- `merged_column_label::Vector{ExcelPair}`: Style for the merged cells at the rest of the
    column labels.
- `data_cell::Vector{ExcelPair}`: Style for the table cells. If a vector of
    `Vector{ExcelPair}}` is provided, each column in the data table will use the
    corresponding style.
- `summary_row_label::Vector{ExcelPair}`: Style for the summary row label.
- `summary_row_cell::Vector{ExcelPair}`: Style for the summary row cell. If a vector of
    `Vector{ExcelPair}}` is provided, each column in the summary row will use the
    corresponding style.
- `footnote::Vector{ExcelPair}`: Style for the footnotes.
- `source_note::Vector{ExcelPair}`: Style for the source notes.

Each field corresponds to a table element and should be a vector of `ExcelPair`,
*i.e.* `Pair{String, String}`, describing properties and values compatible with the
`XLSX.setFont` function.

Fill (background color) attributes for a cell can also be included in the same field by
prefixing their keys with `"cell_fill_"`. Any pair whose key starts with `"cell_fill_"` is
routed to `XLSX.setFill` (with the prefix stripped) instead of `XLSX.setFont`. Font and
fill pairs may be mixed freely within a single field.

It is only necessary to define those fields for which the default style needs to be
overwritten. For example:

```julia
style = ExcelTableStyle(
    column_label                   = [["bold" => "true"], ["color" => "red"]], # assuming two columns
    summary_row_label              = ["size" => "8"],
    first_line_merged_column_label = ["bold" => "true", "color" => "orange"],
    footnote                       = ["italic" => "true", "color" => "cyan"],
    row_group_label                = ["bold" => "true", "color" => "magenta"],
    subtitle                       = ["italic" => "true"],
    title                          = ["bold" => "true", "cell_fill_pattern" => "solid", "cell_fill_fgColor" => "black"],
)
```

# Pre-defined Formats

```@meta
CurrentModule = PrettyTables
```

```@setup text_backend_predefined_formats
using PrettyTables
```

The text backend has some predefined borders and formats to print tables.

```@setup text_backend_predefined_formats
data = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
];
```

## Borders

We can change the printed table borders using the parameter `borders` in the structure
[`TextTableFormat`](@ref) passed to the keyword `table_format`.

`text_table_borders__ascii_dots`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__ascii_dots)
)
```

`text_table_borders__ascii_rounded`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__ascii_rounded)
)
```

`text_table_borders__borderless`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__borderless)
)
```

`text_table_borders__compact`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__compact)
)
```

`text_table_borders__matrix`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__matrix)
)
```

`text_table_borders__mysql`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__mysql)
)
```

`text_table_borders__simple`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__simple)
)
```

`text_table_borders__unicode_rounded`

```@repl text_backend_predefined_formats
pretty_table(
  data;
  backend = :text,
  table_format = TextTableFormat(borders = text_table_borders__unicode_rounded)
)
```

## Formats

The text backend also defines some pre-defined formats to print tables that can be used
through the keyword `table_format` in [`pretty_table`](@ref).

`text_table_format__matrix`

```@repl text_backend_predefined_formats
pretty_table(
  ones(3, 3);
  backend = :text,
  show_column_labels = false,
  table_format = text_table_format__matrix
)
```

# Markdown Backend Examples

```@meta
CurrentModule = PrettyTables
```

```@setup markdown_examples
using PrettyTables, Markdown
```

This page contains examples of markdown tables generated by PrettyTables.jl. 

The `A` object, when referenced, is defined as:

```julia-repl
julia> A = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]
```

```@setup markdown_examples
A = Any[
    1    false      1.0     0x01
    2     true      2.0     0x02
    3    false      3.0     0x03
    4     true      4.0     0x04
    5    false      5.0     0x05
    6     true      6.0     0x06
]
```

## Basic Table

First, we create a basic markdown table using the [`pretty_table`](@ref) function with 
the `backend` keyword set to `:markdown`.

```@example markdown_examples
table = pretty_table(String, A; backend = :markdown)
Markdown.parse(table) # hide
```

We can add custom column labels by passing a vector of strings to the `column_labels` 
keyword.

```@example markdown_examples
table = pretty_table(
    String,
    A;
    backend = :markdown,
    column_labels = ["ID", "Flag", "Value", "Hex"]
)
Markdown.parse(table) # hide
```

## Column Label Style

The style of the column labels can be customized by passing a [`MarkdownTableStyle`](@ref)  
to the `style` keyword. In the first example, we set the `first_line_column_label` field 
of the style to a [`MarkdownStyle`](@ref) with the `bold` field set to `true` to obtain 
bold column labels.

!!! details "**bold** Column Labels"
    ```@example markdown_examples
    table = pretty_table(
        String,
        A;
        backend = :markdown,
        style = MarkdownTableStyle(first_line_column_label = MarkdownStyle(bold = true))
    )

    print(table) # hide
    ```

```@example markdown_examples
Markdown.parse(table) # hide
```

In the second example we use italic column labels:

!!! details "*italic* Column Labels"
    ```@example markdown_examples
    table = pretty_table(
        String,
        A;
        backend = :markdown,
        style = MarkdownTableStyle(first_line_column_label = MarkdownStyle(italic = true))
    )

    print(table) # hide
    ```

```@example markdown_examples
Markdown.parse(table) # hide
```

## Custom Alignment

The alignment of each column can be specified by passing a vector of symbols to the 
`alignment` keyword. The supported alignment values are:

- `:l`: Left alignment
- `:c`: Center alignment
- `:r`: Right alignment

The default alignment is left alignment (`:l`).

!!! details "Example code"
    ```@example markdown_examples
    table = pretty_table(
        String,
        A;
        backend = :markdown,
        column_labels = ["Left", "Center", "Right", "Default"],
        alignment = [:l, :c, :r, :l]
    )

    print(table) # hide
    ```

```@example markdown_examples
Markdown.parse(table) # hide
```

## Row and Column Labels

Additional row and column labels can be added to the table by passing the `row_labels` 
and `column_labels` keywords to the `pretty_table` function. The `stubhead_label` keyword 
can be used to specify the label of the stubhead (corner cell).

!!! details "Example code"
    ```@example markdown_examples
    data = [
        10.0 6.5
        3.0 3.0
        0.1 1.0
    ]

    row_labels = [
        "Atmospheric drag"
        "Gravity gradient"
        "Solar radiation pressure"
    ]

    column_labels = [
        "Torque [10⁻⁶ Nm]",
        "Angular Momentum [10⁻³ Nms]"
    ]

    table = pretty_table(
        String,
        data;
        backend = :markdown,
        column_labels,
        row_labels,
        stubhead_label = "Effect",
        summary_row_labels = ["Total"],
        summary_rows = [(data, i) -> sum(data[:, i])],
    )

    print(table) # hide
    ```

```@example markdown_examples
Markdown.parse(table) # hide
```

## Markdown Highlighters

A markdown highlighter is defined using an object of type [`MarkdownHighlighter`](@ref).
Two types of highlighters are supported: *italic* and **bold**.

!!! details "Example code"
    ```@example markdown_examples
    t = 0:1:20

    data = hcat(t, ones(length(t)), t, 0.5.*t.^2)

    column_labels = [
        ["Time", "Acceleration", "Velocity", "Distance"],
        ["[s]", "[m / s²]", "[m / s]", "[m]"]
    ]

    hl_p = MarkdownHighlighter(
        (data, i, j) -> (j == 4) && (data[i, j] > 9),
        MarkdownStyle(italic = true)
    )

    hl_v = MarkdownHighlighter(
        (data, i, j) -> (j == 3) && (data[i, j] > 9),
        MarkdownStyle(bold = true)
    )

    table = pretty_table(
        String,
        data;
        backend = :markdown,
        column_labels = column_labels,
        highlighters = [hl_p, hl_v],
    )
    
    print(table) # hide
    ```

```@example markdown_examples
Markdown.parse(table) # hide
```

# Text Backend

The text backend can be selected by passing the keyword `backend = :text` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output.

## Keywords

- `alignment_anchor_fallback::Symbol`: This keyword controls the line alignment when using
  the regex alignment anchors if a match is not found. If it is `:l`, the left of the line
  will be aligned with the anchor. If it is `:c`, the line center will be aligned with the
    anchor. Otherwise, the end of the line will be aligned with the anchor.
  (**Default** = `:l`)
- `alignment_anchor_regex::Union{Vector{Regex}, Vector{Pair{Int, Vector{Regex}}}}`: This
  This keyword can be used to provide regexes to align the data values in the table columns. If
  it is `Vector{Regex}`, the regexes will be used to align all the columns. If it is
  `Vector{Pair{Int, Vector{Regex}}}`, the `Int` element specifies the column to which the
  regexes in `Vector{Regex}` will be applied. The regex match is searched in the same order
  as the regexes appear on the vector. The regex matching is applied after the cell
  conversion to string, which includes the formatters. If no match is found for a specific
  line, the alignment of this line depends on the options `alignment_anchor_fallback`.
  Example: `[2 => [r"\\."]]` aligns the decimal point of the cells in the second column.
  (**Default** = `Regex[]`)
- `apply_alignment_regex_to_summary_rows::Bool`: If `true`, the alignment regexes in
    `alignment_anchor_regex` will also be applied to the summary rows.
    (**Default** = `false`)
- `auto_wrap::Bool`: If `true`, the text will be wrapped on spaces to fit the column. Notice
  that this option automatically enables `line_breaks` and the column must have a fixed
  size (see `fixed_data_column_widths`).
  (**Default** = `false`)
- `column_label_width_based_on_first_line_only::Bool`: If `true`, the column label width is
  based on the first line of the column. Hence, if the other column labels have a text width
  larger than the computed column width, they will be cropped to fit.
  (**Default** = `false`)
- `display_size::Tuple{Int, Int}`: A tuple of two integers that defines the display size
  (num. of rows, num. of columns) that is available to print the table. It is used to crop
  the data depending on the values of the keywords `fit_table_in_display_horizontally` and
  `fit_table_in_display_vertically`. Notice that if a dimension is not positive, it will be
  treated as unlimited.
  (**Default** = `displaysize(io)`)
- `equal_data_column_widths::Bool`: If `true`, the data columns will have the same width.
  (**Default** = `false`)
- `fit_table_in_display_horizontally::Bool`: If `true`, the table will be cropped to fit
  the display horizontally.
  (**Default** = `true`)
- `fit_table_in_display_vertically::Bool`: If `true`, the table will be cropped to fit the
  display vertically.
  (**Default** = `true`)
- `fixed_data_column_widths::Union{Int, Vector{Int}}`: If it is a `Vector{Int}`, this vector
  specifies the width of each column. If it is a `Int`, this number will be used as the
  width of all columns. If the width is equal or lower than 0, it will be automatically
  computed to fit the large cell in the column.
  (**Default** = 0)
- `highlighters::Vector{TextHighlighter}`: Highlighters to apply to the table. For more
  information, see the section [Text Highlighters](@ref).
- `line_breaks::Bool`: If `true`, a new line character will break the line inside the cells.
  (**Default** = `false`)
- `maximum_data_column_widths::Union{Int, Vector{Int}}`: If it is a `Vector{Int}`, this
  vector specifies the maximum width of each column. If it is a `Int`, this number will be
  used as the maximum width of all columns. If the maximum width is equal or lower than 0,
  it will be ignored. Notice that the parameter `fixed_data_column_widths` has precedence
  over this one.
  (**Default** = 0)
- `minimum_data_column_widths::Union{Int, Vector{Int}}`: If it is a `Vector{Int}`, this
  vector specifies the minimum width of each column. If it is an `Int`, this number will
  be used as the minimum width of all columns. If the minimum width is equal or lower than
  0, it will be ignored. Notice that the parameter `fixed_data_column_widths` has
  precedence over this one.
  (**Default** = 0)
- `overwrite_display::Bool`: If `true`, the same number of lines in the printed table will
  be deleted from the output `io`. This can be used to update the table in the display
  continuously.
  (**Default** = `false`)
- `reserved_display_lines::Int`: Number of lines to be left at the beginning of the printing
  when vertically cropping the output.
  (**Default** = 0)
- `shrinkable_column_minimum_width::Int`: If it is a positive integer (> 0), this is the
  minimum width of the shrinkable column (see `shrinkable_data_column`).
  (**Default** = 0)
- `shrinkable_data_column::Int`: If it is a positive integer, this column will be
  shrinkable. This means that if the table does not fit in the display, this column will be
  shrunk to fit the table in the display. If it is `0` or negative, no column will be
  shrinkable.
  (**Default** = 0)
- `style::TextTableStyle`: Style of the table. For more information, see the section
  [Text Table Style](@ref).
- `table_format::TextTableFormat`: Text table format used to render the table. For more
    information, see the section [Text Table Format](@ref).

## Text Highlighters

A set of highlighters can be passed as a `Vector{TextHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`TextHighlighter`](@ref). It
contains three fields:

- `f::Function`: Function with the signature `f(data, i, j)` in which should return `true`
  if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)` in which `h` is the
  highlighter. This function must return the `Crayon` to be applied to the cell that must be
  highlighted.
- `crayon::Crayon`: The `Crayon` to be applied to the highlighted cell if the default `fd`
  is used.

The function `f` has the following signature:

```julia
f(data, i, j)
```

in which `data` is a reference to the data that is being printed, and `i` and `j` are the
element coordinates that are being tested. If this function returns `true`, the cell
`(i, j)` will be highlighted.

If the function `f` returns true, the function `fd(h, data, i, j)` will be called and must
return a `Crayon` that will be applied to the cell.

A highlighter can be constructed using three helpers:

```julia
Highlighter(f::Function; kwargs...)
```

where it will construct a `Crayon` using the keywords in `kwargs` and apply it to the
highlighted cell,

```julia
Highlighter(f::Function, crayon::Crayon)
```

where it will apply the `crayon` to the highlighted cell, and

```julia
Highlighter(f::Function, fd::Function)
```

where it will apply the `Crayon` returned by the function `fd` to the highlighted cell.

!!! note

    If multiple highlighters are valid for the element `(i, j)`, the applied style will be
    equal to the first match considering the order in the vector `highlighters`.

!!! note

    If the highlighters are used together with [Formatters](@ref), the change in the format
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

  For example, if we want to highlight the cells with value greater than 5 in red, and all the
cells with value less than 5 in blue, we can define:

```julia
hl_gt5 = TextHighlighter(
    (data, i, j) -> data[i, j] > 5,
    crayon"red"
)

hl_lt5 = TextHighlighter(
    (data, i, j) -> data[i, j] < 5,
    crayon"blue"
)

highlighters = [hl_gt5, hl_lt5]
```

## Text Table Format

The text table format is defined using an object of type [`TextTableFormat`](@ref) that
contains the following fields:

- `borders::TextTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
  beginning of the table.
- `horizontal_lines_at_column_labels::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each column label row index listed in this vector. If the symbol `:all` is
    passed, a horizontal line will be drawn after every column label. If the symbol `:none`
    is passed, no horizontal lines will be drawn.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn at the merged column labels. Notice that the horizontal line drawn using the
    option `horizontal_lines_at_column_labels` has precedence over this one.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
  after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
  drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
  horizontal line will be drawn after every data column. If the symbol `:none` is passed, no
  horizontal lines will be drawn.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
  drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be drawn
  after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn after
  the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there are no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
  after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
  beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
  after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
  after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
  drawn after each data column index listed in this vector. If the symbol `:all` is passed,
  a vertical line will be drawn after every data column. If the symbol `:none` is passed, no
  vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
  the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be drawn
  after the continuation column.
- `ellipsis_line_skip::Integer`: Number of lines to skip when printing an ellipsis.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@text__all_horizontal_lines`](@ref).
- [`@text__all_vertical_lines`](@ref).
- [`@text__no_horizontal_lines`](@ref).
- [`@text__no_vertical_lines`](@ref).

## Text Table Style

The text table style is defined using an object of type [`TextTableStyle`](@ref) that
contains the following fields:

- `title::Crayon`: Crayon with the style for the title.
- `subtitle::Crayon`: Crayon with the style for the subtitle.
- `row_number_label::Crayon`: Crayon with the style for the row number label.
- `row_number::Crayon`: Crayon with the style for the row numbers.
- `stubhead_label::Crayon`: Crayon with the style for the stubhead label.
- `row_label::Crayon`: Crayon with the style for the row labels.
- `row_group_label::Crayon`: Crayon with the style for the row group label.
- `first_line_column_label::Union{Crayon, Vector{Crayon}}`: Crayon or crayons with the style
    for the first column label lines. If a vector of crayons is passed, it must have the
    same length as the number columns in the table.
- `column_label::Union{Crayon, Vector{Crayon}}`: Crayon or crayons with the style for the
    rest of the column labels. If a vector of crayons is passed, it must have the same
    length as the number of columns in the table.
- `first_line_merged_column_label::Crayon`: Crayon with the style for the merged cells at
  the first column label line.
- `merged_column_label::Crayon`: Crayon with the style for the merged cells at the rest of
  the column labels.
- `summary_row_cell::Crayon`: Crayon with the style for the summary row cell.
- `summary_row_label::Crayon`: Crayon with the style for the summary row label.
- `footnote::Crayon`: Crayon with the style for the footnotes.
- `source_note::Crayon`: Crayon with the style for the source notes.
- `omitted_cell_summary::Crayon`: Crayon with the style for the omitted cell summary.
- `table_border::Crayon`: Crayon with the style for the table border.

Each field is a `Crayon` describing the style for the corresponding element in the table.

For example, if we want the stubhead label to be bold and red, we must define:

```julia
style = TextTableStyle(
    stubhead_label = crayon"bold red"
)
```

# Typst Backend

The Typst backend can be selected by passing the keyword `backend = :typst` to the function
[`pretty_table`](@ref). In this case, we have the following additional keywords to configure
the output:

## Keywords

- `annotate::Bool`: Boolean indicating whether Typst code should be annotated.
- `caption::Union{Nothing, String, TypstCaption}`: Table caption to be used by the
  Typst `#figure` function. The user can provide additional configuration to the caption
  by using the `TypstCaption` structure.
- `data_column_widths::Union{Nothing, String, Vector{String}, Vector{Pair{Int, String}}}`:
  Column widths for the data columns. The information must be a valid length information
  in Typst, such as "10fr" or "30pt". If a single string is provided, it will be repeated
  for all columns. If a vector of strings is provided, its length must be equal to or
  larger than the number of printed columns. Alternatively, a vector of pairs can be
  provided, where the first element of the pair is the column index and the second element
  is the width for that column. In this case, columns that are not specified will have
  width `auto`.
  (**Default** = `nothing`)
- `highlighters::Vector{TypstHighlighter}`: Highlighters to apply to the table. For more
  information, see the section [Typst Highlighters]@(ref).
  (**Default** = `TypstHighlighter[]`)
- `minify::Bool`: If `true`, the generated Typst code will be minified by ignoring
  `wrap_column` and printing the table columns in the same line.
  (**Default** = `false`)
- `style::TypstTableStyle`: Style of the table. For more information, see the section
  [Typst Table Style](@ref).
  (**Default** = `TypstTableStyle()`)
- `table_format::TypstTableFormat`: Typst table format used to render the table. For more
    information, see the section [Typst Table Format](@ref).
- `wrap_column::Integer`: Indicates the column where the output will be wrapped.
  (**Default** = `92`)

!!! note

    The content in the cells is always escaped. If you want to use a raw Typst component as
    cell, load the package Typstry.jl and pass the cell content as a `TypstString`. In this
    case, the content will not be escaped and will be treated as a raw Typst component.

## Typst Highlighters

A set of highlighters can be passed as a `Vector{TypstHighlighter}` to the `highlighters`
keyword. Each highlighter is an instance of the structure [`TypstHighlighter`](@ref). It
contains the following two public fields:

- `f::Function`: Function with the signature `f(data, i, j)`, which should return `true`
  if the element `(i, j)` in `data` must be highlighted, or `false` otherwise.
- `fd::Function`: Function with the signature `f(h, data, i, j)`, where `h` is the
  highlighter. This function must return a `Vector{Pair{String, String}}` with properties
  compatible with the `style` field that will be applied to the highlighted cell.

A Typst highlighter can be constructed using three helpers:

```julia
TypstHighlighter(f::Function, decoration::Vector{Pair{String, String}})

TypstHighlighter(f::Function, decorations::NTuple{N, Pair{String, String}})

TypstHighlighter(f::Function, fd::Function)
```

The first applies a fixed decoration to the highlighted cell specified in `decoration`, the
second allows specifying decorations as a `Tuple`, and the third lets the user select the
desired decoration by specifying the function `fd`.

!!! note

    If multiple highlighters are valid for element `(i, j)`, the applied style is the first
    match according to the order in the vector `highlighters`.

!!! note

    If highlighters are used together with [Formatters](@ref), formatting changes
    **will not** affect the parameter `data` passed to the highlighter function `f`. It will
    always receive the original, unformatted value.

For example, if we want to highlight the cells with values greater than 5 in red, and all
the cells with values less than 5 in blue, we can define:

```julia
hl_gt5 = TypstHighlighter(
    (data, i, j) -> data[i, j] > 5,
    ["text-fill" => "red"]
)

hl_lt5 = TypstHighlighter(
    (data, i, j) -> data[i, j] < 5,
    ["text-fill" => "blue"]
)

highlighters = [hl_gt5, hl_lt5]
```

Each cell with properties is rendered with one call to `#text` inside a `table.cell`
function, as shown below:

```typst
table.cell()[#text()[Cell Content]]
```

!!! note

    Since `table.cell` and `#text()` share some attribute names, attributes used by the
    `#text` function must be defined with the `text-` prefix. For example, to create a table
    style (or highlighter) that sets a blue background and white font color:

    ```julia
    ["fill" => "blue", "text-fill" => "white"]
    ```

## Typst Table Format

The Typst table format is defined using an object of type [`TypstTableFormat`](@ref) that
contains the following fields:

- `borders::TypstTableBorders`: Format of the borders.
- `horizontal_line_at_beginning::Bool`: If `true`, a horizontal line will be drawn at the
    beginning of the table.
- `horizontal_line_at_merged_column_labels::Bool`: If `true`, a horizontal line will be
    drawn on bottom of the merged column labels using `\\cline`.
- `horizontal_line_after_column_labels::Bool`: If `true`, a horizontal line will be drawn
    after the column labels.
- `horizontal_lines_at_data_rows::Union{Symbol, Vector{Int}}`: A horizontal line will be
    drawn after each data row index listed in this vector. If the symbol `:all` is passed, a
    horizontal line will be drawn after every data column. If the symbol `:none` is passed,
    no horizontal lines will be drawn after the data rows.
- `horizontal_line_before_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn before the row group label.
- `horizontal_line_after_row_group_label::Bool`: If `true`, a horizontal line will be
    drawn after the row group label.
- `horizontal_line_after_data_rows::Bool`: If `true`, a horizontal line will be drawn
    after the data rows.
- `horizontal_line_before_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    before the summary rows. Notice that this line is the same as the one drawn if
    `horizontal_line_after_data_rows` is `true`. However, in this case, the line is omitted
    if there is no summary rows.
- `horizontal_line_after_summary_rows::Bool`: If `true`, a horizontal line will be drawn
    after the summary rows.
- `vertical_line_at_beginning::Bool`: If `true`, a vertical line will be drawn at the
    beginning of the table.
- `vertical_line_after_row_number_column::Bool`: If `true`, a vertical line will be drawn
    after the row number column.
- `vertical_line_after_row_label_column::Bool`: If `true`, a vertical line will be drawn
    after the row label column.
- `vertical_lines_at_data_columns::Union{Symbol, Vector{Int}}`: A vertical line will be
    drawn after each data column index listed in this vector. If the symbol `:all` is
    passed, a vertical line will be drawn after every data column. If the symbol `:none` is
    passed, no vertical lines will be drawn after the data columns.
- `vertical_line_after_data_columns::Bool`: If `true`, a vertical line will be drawn after
    the data columns.
- `vertical_line_after_continuation_column::Bool`: If `true`, a vertical line will be
    drawn after the continuation column.

We provide a few helpers to configure the table format. For more information, see the
documentation of the following macros:

- [`@typst__all_horizontal_lines`](@ref).
- [`@typst__all_vertical_lines`](@ref).
- [`@typst__no_horizontal_lines`](@ref).
- [`@typst__no_vertical_lines`](@ref).

## Typst Table Style

The Typst table style is defined using an object of type [`TypstTableStyle`](@ref) that
contains the following fields:

- `table::Vector{TypstPair}`: Style for the table.
- `title::Vector{TypstPair}`: Style for the title.
- `subtitle::Vector{TypstPair}`: Style for the subtitle.
- `row_number_label::Vector{TypstPair}`: Style for the row number label.
- `row_number::Vector{TypstPair}`: Style for the row number.
- `stubhead_label::Vector{TypstPair}`: Style for the stubhead label.
- `row_label::Vector{TypstPair}`: Style for the row label.
- `row_group_label::Vector{TypstPair}`: Style for the row group label.
- `first_line_column_label::Union{Vector{TypstPair}, Vector{Vector{TypstPair}}}`: Style for
  the first line of the column labels. If a vector of `Vector{TypstPair}` is provided, each
  column label in the first line will use the corresponding style.
- `column_label::Union{Vector{TypstPair}, Vector{Vector{TypstPair}}}`: Style for the rest of
  the column labels. If a vector of `Vector{TypstPair}` is provided, each column label will
  use the corresponding style.
- `first_line_merged_column_label::Vector{TypstPair}`: Style for the merged cells at the
  first column label line.
- `merged_column_label::Vector{TypstPair}`: Style for the merged cells at the rest of the
  column labels.
- `summary_row_cell::Vector{TypstPair}`: Style for the summary row cell.
- `summary_row_label::Vector{TypstPair}`: Style for the summary row label.
- `footnote::Vector{TypstPair}`: Style for the footnote.
- `source_notes::Vector{TypstPair}`: Style for the source notes.

Each field is a vector of [`TypstPair`](@ref), *i.e.* `Pair{String, String}`, describing
properties and values compatible with the Typst style attribute.

For example, if we want the stubhead label to be bold and red, we must define:

```julia
style = TypstTableStyle(
    stubhead_label = ["text-weight" => "bold", "fill" => "red", "text-fill" => "white"]
)
```

The user can pass any property compatible with the Typst style attribute. If the prefix
`text-` is used, the property will be applied to the text of the cell. Otherwise, it will be
applied to the cell itself.
